/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/base/common/labels","fs","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function($){for(var e=[],m=0,A=$.length;m<A;m++)e[m]=Q[$[m]];return e};define(Q[103],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(A,R){if(!A)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=m}),define(Q[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(P){return(n,v,y)=>{let i=null,I=null;if(typeof y.value=="function"?(i="value",I=y.value):typeof y.get=="function"&&(i="get",I=y.get),!I)throw new Error("not supported");y[i]=P(I,v)}}e.createDecorator=m;function A(P,n,v){let y=null,i=null;if(typeof v.value=="function"?(y="value",i=v.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(y="get",i=v.get),!i)throw new Error("not supported");const I=`$memoize$${n}`;v[y]=function(...M){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,M)}),this[I]}}e.memoize=A;function R(P,n,v){return m((y,i)=>{const I=`$debounce$${i}`,M=`$debounce$result$${i}`;return function(...w){this[M]||(this[M]=v?v():void 0),clearTimeout(this[I]),n&&(this[M]=n(this[M],...w),w=[this[M]]),this[I]=setTimeout(()=>{y.apply(this,w),this[M]=v?v():void 0},P)}})}e.debounce=R;function b(P,n,v){return m((y,i)=>{const I=`$throttle$timer$${i}`,M=`$throttle$result$${i}`,w=`$throttle$lastRun$${i}`,f=`$throttle$pending$${i}`;return function(...g){if(this[M]||(this[M]=v?v():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),n&&(this[M]=n(this[M],...g)),this[f])return;const D=this[w]+P;D<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[M]]),this[M]=v?v():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),y.apply(this,[this[M]]),this[M]=v?v():void 0},D-Date.now()))}})}e.throttle=b}),define(Q[22],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function A(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=A;function R(l){v(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function b(l){v(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=b;function P(l){if(l instanceof Error){let{name:t,message:r}=l;const s=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:s}}return l}e.transformErrorForSerialization=P;const n="Canceled";function v(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=v;class y extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=y;function i(){const l=new Error(n);return l.name=l.message,l}e.canceled=i;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function M(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=M;function w(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function f(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function u(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function a(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(Q[36],Z([0,1,22]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(N,F=0){return N[N.length-(1+F)]}e.tail=A;function R(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=R;function b(N,F,T=(O,k)=>O===k){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let O=0,k=N.length;O<k;O++)if(!T(N[O],F[O]))return!1;return!0}e.equals=b;function P(N,F,T){let O=0,k=N.length-1;for(;O<=k;){const W=(O+k)/2|0,C=T(N[W],F);if(C<0)O=W+1;else if(C>0)k=W-1;else return W}return-(O+1)}e.binarySearch=P;function n(N,F){let T=0,O=N.length;if(O===0)return 0;for(;T<O;){const k=Math.floor((T+O)/2);F(N[k])?O=k:T=k+1}return T}e.findFirstInSorted=n;function v(N,F,T){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let O=F[Math.floor(F.length*Math.random())],k=[],W=[],C=[];for(let V of F){const K=T(V,O);K<0?k.push(V):K>0?W.push(V):C.push(V)}return N<k.length?v(N,k,T):N<k.length+C.length?C[0]:v(N-(k.length+C.length),W,T)}e.quickSelect=v;function y(N,F){const T=[];let O;for(const k of N.slice(0).sort(F))!O||F(O[0],k)!==0?(O=[k],T.push(O)):O.push(k);return T}e.groupBy=y;function i(N,F,T){const O=[];function k(V,K,q){if(K===0&&q.length===0)return;const x=O[O.length-1];x&&x.start+x.deleteCount===V?(x.deleteCount+=K,x.toInsert.push(...q)):O.push({start:V,deleteCount:K,toInsert:q})}let W=0,C=0;for(;;){if(W===N.length){k(W,0,F.slice(C));break}if(C===F.length){k(W,N.length-W,[]);break}const V=N[W],K=F[C],q=T(V,K);q===0?(W+=1,C+=1):q<0?(k(W,1,[]),W+=1):q>0&&(k(W,0,[K]),C+=1)}return O}e.sortedDiff=i;function I(N,F,T){const O=i(N,F,T),k=[],W=[];for(const C of O)k.push(...N.slice(C.start,C.start+C.deleteCount)),W.push(...C.toInsert);return{removed:k,added:W}}e.delta=I;function M(N,F,T){if(T===0)return[];const O=N.slice(0,T).sort(F);return f(N,F,O,T,N.length),O}e.top=M;function w(N,F,T,O,k){return T===0?Promise.resolve([]):new Promise((W,C)=>{(async()=>{const V=N.length,K=N.slice(0,T).sort(F);for(let q=T,x=Math.min(T+O,V);q<V;q=x,x=Math.min(x+O,V)){if(q>T&&await new Promise(ne=>setTimeout(ne)),k&&k.isCancellationRequested)throw m.canceled();f(N,F,K,q,x)}return K})().then(W,C)})}e.topAsync=w;function f(N,F,T,O,k){for(const W=T.length;O<k;O++){const C=N[O];if(F(C,T[W-1])<0){T.pop();const V=n(T,K=>F(C,K)<0);T.splice(V,0,C)}}}function g(N){return N.filter(F=>!!F)}e.coalesce=g;function D(N){let F=0;for(let T=0;T<N.length;T++)N[T]&&(N[F]=N[T],F+=1);N.length=F}e.coalesceInPlace=D;function E(N,F,T){N.splice(T,0,N.splice(F,1)[0])}e.move=E;function c(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=c;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function a(N,F){if(!F)return N.filter((O,k)=>N.indexOf(O)===k);const T=Object.create(null);return N.filter(O=>{const k=F(O);return T[k]?!1:(T[k]=!0,!0)})}e.distinct=a;function l(N){const F=new Set;return N.filter(T=>F.has(T)?!1:(F.add(T),!0))}e.distinctES6=l;function t(N){const F=Object.create(null);return T=>{const O=N(T);return F[O]?!1:(F[O]=!0,!0)}}e.uniqueFilter=t;function r(N,F){for(let T=N.length-1;T>=0;T--){const O=N[T];if(F(O))return T}return-1}e.lastIndex=r;function s(N,F){return N.length>0?N[0]:F}e.firstOrDefault=s;function o(N,F,T=(O,k)=>O===k){let O=0;for(let k=0,W=Math.min(N.length,F.length);k<W&&T(N[k],F[k]);k++)O++;return O}e.commonPrefixLength=o;function h(N){return[].concat(...N)}e.flatten=h;function p(N,F){let T=typeof F=="number"?N:0;typeof F=="number"?T=N:(T=0,F=N);const O=[];if(T<=F)for(let k=T;k<F;k++)O.push(k);else for(let k=T;k>F;k--)O.push(k);return O}e.range=p;function d(N,F,T){return N.reduce((O,k)=>(O[F(k)]=T?T(k):k,O),Object.create(null))}e.index=d;function S(N,F){return N.push(F),()=>L(N,F)}e.insert=S;function L(N,F){const T=N.indexOf(F);if(T>-1)return N.splice(T,1),F}e.remove=L;function _(N,F,T){const O=N.slice(0,F),k=N.slice(F);return O.concat(T,k)}e.arrayInsert=_;function H(N,F){let T;if(typeof F=="number"){let O=F;T=()=>{const k=Math.sin(O++)*179426549;return k-Math.floor(k)}}else T=Math.random;for(let O=N.length-1;O>0;O-=1){const k=Math.floor(T()*(O+1)),W=N[O];N[O]=N[k],N[k]=W}}e.shuffle=H;function X(N,F){const T=N.indexOf(F);T>-1&&(N.splice(T,1),N.unshift(F))}e.pushToStart=X;function ee(N,F){const T=N.indexOf(F);T>-1&&(N.splice(T,1),N.push(F))}e.pushToEnd=ee;function B(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=B;function J(N){return Array.isArray(N)?N:[N]}e.asArray=J;function Y(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=Y;function U(N,F){for(const T of N){const O=F(T);if(O!==void 0)return O}}e.mapFind=U;function z(N,F){let T=Number.MAX_SAFE_INTEGER,O=0;return N.forEach((k,W)=>{const C=F(k);C<T&&(T=C,O=W)}),O}e.minIndex=z;function G(N,F){let T=Number.MIN_SAFE_INTEGER,O=0;return N.forEach((k,W)=>{const C=F(k);C>T&&(T=C,O=W)}),O}e.maxIndex=G}),define(Q[43],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(A){const R=this;let b=!1,P;return function(){return b||(b=!0,P=A.apply(R,arguments)),P}}e.once=m}),define(Q[63],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(A){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}A.is=R;const b=Object.freeze([]);function P(){return b}A.empty=P;function*n(l){yield l}A.single=n;function v(l){return l||b}A.from=v;function y(l){return!l||l[Symbol.iterator]().next().done===!0}A.isEmpty=y;function i(l){return l[Symbol.iterator]().next().value}A.first=i;function I(l,t){for(const r of l)if(t(r))return!0;return!1}A.some=I;function M(l,t){for(const r of l)if(t(r))return r}A.find=M;function*w(l,t){for(const r of l)t(r)&&(yield r)}A.filter=w;function*f(l,t){let r=0;for(const s of l)yield t(s,r++)}A.map=f;function*g(...l){for(const t of l)for(const r of t)yield r}A.concat=g;function*D(l){for(const t of l)for(const r of t)yield r}A.concatNested=D;function E(l,t,r){let s=r;for(const o of l)s=t(s,o);return s}A.reduce=E;function*c(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}A.slice=c;function u(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const s=l[Symbol.iterator]();for(let o=0;o<t;o++){const h=s.next();if(h.done)return[r,A.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return s}}]}A.consume=u;function a(l,t,r=(s,o)=>s===o){const s=l[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const h=s.next(),p=o.next();if(h.done!==p.done)return!1;if(h.done)return!0;if(!r(h.value,p.value))return!1}}A.equals=a})(m=e.Iterable||(e.Iterable={}))}),define(Q[40],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function P(t,r=!1){let s=0,o=t.length,h="",p=0,d=16,S=0;function L(Y){let U=0,z=0;for(;U<Y;){const G=t.charCodeAt(s);if(G>=48&&G<=57)z=z*16+G-48;else if(G>=65&&G<=70)z=z*16+G-65+10;else if(G>=97&&G<=102)z=z*16+G-97+10;else break;s++,U++}return U<Y&&(z=-1),z}function _(Y){s=Y,h="",p=0,d=16,S=0}function H(){const Y=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return S=3,t.substring(Y,s);let U=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;U=s}else S=3;return t.substring(Y,U)}function X(){let Y="",U=s;for(;;){if(s>=o){Y+=t.substring(U,s),S=2;break}const z=t.charCodeAt(s);if(z===34){Y+=t.substring(U,s),s++;break}if(z===92){if(Y+=t.substring(U,s),s++,s>=o){S=2;break}switch(t.charCodeAt(s++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const N=L(4);N>=0?Y+=String.fromCharCode(N):S=4;break;default:S=5}U=s;continue}if(z>=0&&z<=31)if(v(z)){Y+=t.substring(U,s),S=2;break}else S=6;s++}return Y}function ee(){if(h="",S=0,p=s,s>=o)return p=o,d=17;let Y=t.charCodeAt(s);if(n(Y)){do s++,h+=String.fromCharCode(Y),Y=t.charCodeAt(s);while(n(Y));return d=15}if(v(Y))return s++,h+=String.fromCharCode(Y),Y===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),d=14;switch(Y){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,h=X(),d=10;case 47:const U=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!v(t.charCodeAt(s));)s++;return h=t.substring(U,s),d=12}if(t.charCodeAt(s+1)===42){s+=2;const z=o-1;let G=!1;for(;s<z;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,G=!0;break}s++}return G||(s++,S=1),h=t.substring(U,s),d=13}return h+=String.fromCharCode(Y),s++,d=16;case 45:if(h+=String.fromCharCode(Y),s++,s===o||!y(t.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=H(),d=11;default:for(;s<o&&B(Y);)s++,Y=t.charCodeAt(s);if(p!==s){switch(h=t.substring(p,s),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(Y),s++,d=16}}function B(Y){if(n(Y)||v(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let Y;do Y=ee();while(Y>=12&&Y<=15);return Y}return{setPosition:_,getPosition:()=>s,scan:r?J:ee,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>p,getTokenLength:()=>s-p,getTokenError:()=>S}}e.createScanner=P;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const s=[],o=new Object;let h;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function S(L,_,H,X){p.value=L,p.offset=_,p.length=H,p.type=X,p.colonOffset=void 0,h=p}try{u(t,{onObjectBegin:(L,_)=>{if(r<=L)throw o;h=void 0,d=r>L,s.push("")},onObjectProperty:(L,_,H)=>{if(r<_||(S(L,_,H,"property"),s[s.length-1]=L,r<=_+H))throw o},onObjectEnd:(L,_)=>{if(r<=L)throw o;h=void 0,s.pop()},onArrayBegin:(L,_)=>{if(r<=L)throw o;h=void 0,s.push(0)},onArrayEnd:(L,_)=>{if(r<=L)throw o;h=void 0,s.pop()},onLiteralValue:(L,_,H)=>{if(r<_||(S(L,_,H,l(L)),r<=_+H))throw o},onSeparator:(L,_,H)=>{if(r<=_)throw o;if(L===":"&&h&&h.type==="property")h.colonOffset=_,d=!1,h=void 0;else if(L===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(d=!0,s[s.length-1]=""),h=void 0}}})}catch(L){if(L!==o)throw L}return{path:s,previousNode:h,isAtPropertyKey:d,matches:L=>{let _=0;for(let H=0;_<L.length&&H<s.length;H++)if(L[_]===s[H]||L[_]==="*")_++;else if(L[_]!=="**")return!1;return _===L.length}}}e.getLocation=I;function M(t,r=[],s=b.DEFAULT){let o=null,h=[];const p=[];function d(L){Array.isArray(h)?h.push(L):o!==null&&(h[o]=L)}return u(t,{onObjectBegin:()=>{const L={};d(L),p.push(h),h=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{h=p.pop()},onArrayBegin:()=>{const L=[];d(L),p.push(h),h=L,o=null},onArrayEnd:()=>{h=p.pop()},onLiteralValue:d,onError:(L,_,H)=>{r.push({error:L,offset:_,length:H})}},s),h[0]}e.parse=M;function w(t,r=[],s=b.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(L){o.type==="property"&&(o.length=L-o.offset,o=o.parent)}function p(L){return o.children.push(L),L}u(t,{onObjectBegin:L=>{o=p({type:"object",offset:L,length:-1,parent:o,children:[]})},onObjectProperty:(L,_,H)=>{o=p({type:"property",offset:_,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:L,offset:_,length:H,parent:o})},onObjectEnd:(L,_)=>{o.length=L+_-o.offset,o=o.parent,h(L+_)},onArrayBegin:(L,_)=>{o=p({type:"array",offset:L,length:-1,parent:o,children:[]})},onArrayEnd:(L,_)=>{o.length=L+_-o.offset,o=o.parent,h(L+_)},onLiteralValue:(L,_,H)=>{p({type:l(L),offset:_,length:H,parent:o,value:L}),h(_+H)},onSeparator:(L,_,H)=>{o.type==="property"&&(L===":"?o.colonOffset=_:L===","&&h(_))},onError:(L,_,H)=>{r.push({error:L,offset:_,length:H})}},s);const S=o.children[0];return S&&delete S.parent,S}e.parseTree=w;function f(t,r){if(!t)return;let s=t;for(let o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const p of s.children)if(Array.isArray(p.children)&&p.children[0].value===o){s=p.children[1],h=!0;break}if(!h)return}else{const h=o;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}e.findNodeAtLocation=f;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=g;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(r[s.children[0].value]=D(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function E(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=E;function c(t,r,s=!1){if(E(t,r,s)){const o=t.children;if(Array.isArray(o))for(let h=0;h<o.length&&o[h].offset<=r;h++){const p=c(o[h],r,s);if(p)return p}return t}}e.findNodeAtOffset=c;function u(t,r,s=b.DEFAULT){const o=P(t,!1);function h(C){return C?()=>C(o.getTokenOffset(),o.getTokenLength()):()=>!0}function p(C){return C?V=>C(V,o.getTokenOffset(),o.getTokenLength()):()=>!0}const d=h(r.onObjectBegin),S=p(r.onObjectProperty),L=h(r.onObjectEnd),_=h(r.onArrayBegin),H=h(r.onArrayEnd),X=p(r.onLiteralValue),ee=p(r.onSeparator),B=h(r.onComment),J=p(r.onError),Y=s&&s.disallowComments,U=s&&s.allowTrailingComma;function z(){for(;;){const C=o.scan();switch(o.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:Y||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(C){case 12:case 13:Y?G(10):B();break;case 16:G(1);break;case 15:case 14:break;default:return C}}}function G(C,V=[],K=[]){if(J(C),V.length+K.length>0){let q=o.getToken();for(;q!==17;){if(V.indexOf(q)!==-1){z();break}else if(K.indexOf(q)!==-1)break;q=z()}}}function N(C){const V=o.getTokenValue();return C?X(V):S(V),z(),!0}function F(){switch(o.getToken()){case 11:let C=0;try{C=JSON.parse(o.getTokenValue()),typeof C!="number"&&(G(2),C=0)}catch(V){G(2)}X(C);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return z(),!0}function T(){return o.getToken()!==10?(G(3,[],[2,5]),!1):(N(!1),o.getToken()===6?(ee(":"),z(),W()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function O(){d(),z();let C=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(C||G(4,[],[]),ee(","),z(),o.getToken()===2&&U)break}else C&&G(6,[],[]);T()||G(4,[],[2,5]),C=!0}return L(),o.getToken()!==2?G(7,[2],[]):z(),!0}function k(){_(),z();let C=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(C||G(4,[],[]),ee(","),z(),o.getToken()===4&&U)break}else C&&G(6,[],[]);W()||G(4,[],[4,5]),C=!0}return H(),o.getToken()!==4?G(8,[4],[]):z(),!0}function W(){switch(o.getToken()){case 3:return k();case 1:return O();case 10:return N(!0);default:return F()}}return z(),o.getToken()===17?s.allowEmptyContent?!0:(G(4,[],[]),!1):W()?(o.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=u;function a(t,r){let s=P(t),o=[],h,p=0,d;do switch(d=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:p!==d&&o.push(t.substring(p,d)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),p=s.getPosition();break}while(h!==17);return o.join("")}e.stripComments=a;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Q[104],Z([0,1,40]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(v,y,i){let I,M,w,f,g;if(y){for(f=y.offset,g=f+y.length,w=f;w>0&&!n(v,w-1);)w--;let p=g;for(;p<v.length&&!n(v,p);)p++;M=v.substring(w,p),I=b(M,i)}else M=v,I=0,w=0,f=0,g=v.length;const D=P(i,v);let E=!1,c=0,u;i.insertSpaces?u=R(" ",i.tabSize||4):u="	";const a=m.createScanner(M,!1);let l=!1;function t(){return D+R(u,I+c)}function r(){let p=a.scan();for(E=!1;p===15||p===14;)E=E||p===14,p=a.scan();return l=p===16||a.getTokenError()!==0,p}const s=[];function o(p,d,S){!l&&d<g&&S>f&&v.substring(d,S)!==p&&s.push({offset:d,length:S-d,content:p})}let h=r();if(h!==17){const p=a.getTokenOffset()+w,d=R(u,I);o(d,w,p)}for(;h!==17;){let p=a.getTokenOffset()+a.getTokenLength()+w,d=r(),S="";for(;!E&&(d===12||d===13);){const _=a.getTokenOffset()+w;o(" ",p,_),p=a.getTokenOffset()+a.getTokenLength()+w,S=d===12?t():"",d=r()}if(d===2)h!==1&&(c--,S=t());else if(d===4)h!==3&&(c--,S=t());else{switch(h){case 3:case 1:c++,S=t();break;case 5:case 12:S=t();break;case 13:E?S=t():S=" ";break;case 6:S=" ";break;case 10:if(d===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?S=" ":d!==5&&d!==17&&(l=!0);break;case 16:l=!0;break}E&&(d===12||d===13)&&(S=t())}const L=a.getTokenOffset()+w;o(S,p,L),h=d}return s}e.format=A;function R(v,y){let i="";for(let I=0;I<y;I++)i+=v;return i}function b(v,y){let i=0,I=0;const M=y.tabSize||4;for(;i<v.length;){const w=v.charAt(i);if(w===" ")I++;else if(w==="	")I+=M;else break;i++}return Math.floor(I/M)}function P(v,y){for(let i=0;i<y.length;i++){const I=y.charAt(i);if(I==="\r")return i+1<y.length&&y.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=P;function n(v,y){return`\r
`.indexOf(v.charAt(y))!==-1}e.isEOL=n}),define(Q[78],Z([0,1,40,104]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(y,i,I){return b(y,i,void 0,I)}e.removeProperty=R;function b(y,i,I,M,w){const f=i.slice(),g=[],D=m.parseTree(y,g);let E,c;for(;f.length>0&&(c=f.pop(),E=m.findNodeAtLocation(D,f),E===void 0&&I!==void 0);)typeof c=="string"?I={[c]:I}:I=[I];if(E)if(E.type==="object"&&typeof c=="string"&&Array.isArray(E.children)){const u=m.findNodeAtLocation(E,[c]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const a=E.children.indexOf(u.parent);let l,t=u.parent.offset+u.parent.length;if(a>0){const r=E.children[a-1];l=r.offset+r.length}else l=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return P(y,{offset:l,length:t-l,content:""},M)}else return P(y,{offset:u.offset,length:u.length,content:JSON.stringify(I)},M);else{if(I===void 0)return[];const a=`${JSON.stringify(c)}: ${JSON.stringify(I)}`,l=w?w(E.children.map(r=>r.children[0].value)):E.children.length;let t;if(l>0){const r=E.children[l-1];t={offset:r.offset+r.length,length:0,content:","+a}}else E.children.length===0?t={offset:E.offset+1,length:0,content:a}:t={offset:E.offset+1,length:0,content:a+","};return P(y,t,M)}}else if(E.type==="array"&&typeof c=="number"&&Array.isArray(E.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let a;if(E.children.length===0||c===0)a={offset:E.offset+1,length:0,content:E.children.length===0?u:u+","};else{const l=c===-1||c>E.children.length?E.children.length:c,t=E.children[l-1];a={offset:t.offset+t.length,length:0,content:","+u}}return P(y,a,M)}else{const u=c,a=E.children[u];let l;if(E.children.length===1)l={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===u){const t=E.children[u-1],r=t.offset+t.length,s=E.offset+E.length;l={offset:r,length:s-2-r,content:""}}else l={offset:a.offset,length:E.children[u+1].offset-a.offset,content:""};return P(y,l,M)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${E.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return P(y,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},M)}}e.setProperty=b;function P(y,i,I){let M=n(y,i),w=i.offset,f=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;w>0&&!A.isEOL(M,w-1);)w--;for(;f<M.length&&!A.isEOL(M,f);)f++}const g=A.format(M,{offset:w,length:f-w},I);for(let E=g.length-1;E>=0;E--){const c=g[E];M=n(M,c),w=Math.min(w,c.offset),f=Math.max(f,c.offset+c.length),f+=c.content.length-c.length}const D=y.length-(M.length-f)-w;return[{offset:w,length:D,content:M.substring(w,f)}]}e.withFormatting=P;function n(y,i){return y.substring(0,i.offset)+i.content+y.substring(i.offset+i.length)}e.applyEdit=n;function v(y,i){let I=i.slice(0).sort((w,f)=>{const g=w.offset-f.offset;return g===0?w.length-f.length:g}),M=y.length;for(let w=I.length-1;w>=0;w--){let f=I[w];if(f.offset+f.length<=M)y=n(y,f);else throw new Error("Overlapping edit");M=f.offset}return y}e.applyEdits=v}),define(Q[57],Z([0,1,22]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,a){this._keyCodeToStr[u]=a,this._strToKeyCode[a.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const b=new R,P=new R,n=new R;(function(){function c(u,a,l=a,t=l){b.define(u,a),P.define(u,l),n.define(u,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var v;(function(c){function u(s){return b.keyCodeToStr(s)}c.toString=u;function a(s){return b.strToKeyCode(s)}c.fromString=a;function l(s){return P.keyCodeToStr(s)}c.toUserSettingsUS=l;function t(s){return n.keyCodeToStr(s)}c.toUserSettingsGeneral=t;function r(s){return P.strToKeyCode(s)||n.strToKeyCode(s)}c.fromUserSettings=r})(v=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(y||(y={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function I(c,u){const a=(u&65535)<<16>>>0;return(c|a)>>>0}e.KeyChord=I;function M(c,u){if(c===0)return null;const a=(c&65535)>>>0,l=(c&4294901760)>>>16;return l!==0?new g([w(a,u),w(l,u)]):new g([w(a,u)])}e.createKeybinding=M;function w(c,u){const a=!!(c&2048),l=!!(c&256),t=u===2?l:a,r=!!(c&1024),s=!!(c&512),o=u===2?a:l,h=c&255;return new f(t,r,s,o,h)}e.createSimpleKeybinding=w;class f{constructor(u,a,l,t,r){this.ctrlKey=u,this.shiftKey=a,this.altKey=l,this.metaKey=t,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",l=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${a}${l}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=f;class g{constructor(u){if(u.length===0)throw m.illegalArgument("parts");this.parts=u}getHashCode(){let u="";for(let a=0,l=this.parts.length;a<l;a++)a!==0&&(u+=";"),u+=this.parts[a].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(u.parts[a]))return!1;return!0}}e.ChordKeybinding=g;class D{constructor(u,a,l,t,r,s){this.ctrlKey=u,this.shiftKey=a,this.altKey=l,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class E{}e.ResolvedKeybinding=E}),define(Q[2],Z([0,1,43,63]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let b=null;function P(a){b=a}if(e.setDisposableTracker=P,R){const a="__is_disposable_tracked__";b=new class{trackDisposable(l){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[a]||console.log(t)},3e3)}markTracked(l){if(l&&l!==g.None)try{l[a]=!0}catch(t){}}}}function n(a){!b||b.markTracked(a)}function v(a){return b&&b.trackDisposable(a),a}e.trackDisposable=v;class y extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=y;function i(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=i;function I(a){if(A.Iterable.is(a)){let l=[];for(const t of a)if(t){n(t);try{t.dispose()}catch(r){l.push(r)}}if(l.length===1)throw l[0];if(l.length>1)throw new y(l);return Array.isArray(a)?[]:a}else if(a)return n(a),a.dispose(),a}e.dispose=I;function M(...a){return a.forEach(n),w(()=>I(a))}e.combinedDisposable=M;function w(a){const l=v({dispose:()=>{n(l),a()}});return l}e.toDisposable=w;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new f,v(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var t;this._isDisposed||l===this._value||((t=this._value)===null||t===void 0||t.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,n(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=D;class E{constructor(){this.references=new Map}acquire(l,...t){let r=this.references.get(l);r||(r={counter:0,object:this.createReferencedObject(l,...t)},this.references.set(l,r));const{object:s}=r,o=m.once(()=>{--r.counter==0&&(this.destroyReferencedObject(l,r.object),this.references.delete(l))});return r.counter++,{object:s,dispose:o}}}e.ReferenceCollection=E;class c{constructor(l){this.referenceCollection=l}async acquire(l,...t){const r=this.referenceCollection.acquire(l,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(s){throw r.dispose(),s}}}e.AsyncReferenceCollection=c;class u{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=u}),define(Q[79],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(b){this.element=b,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class A{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let b=this._first;for(;b!==m.Undefined;){const P=b.next;b.prev=m.Undefined,b.next=m.Undefined,b=P}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,P){const n=new m(b);if(this._first===m.Undefined)this._first=n,this._last=n;else if(P){const y=this._last;this._last=n,n.prev=y,y.next=n}else{const y=this._first;this._first=n,n.next=y,y.prev=n}this._size+=1;let v=!1;return()=>{v||(v=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==m.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==m.Undefined&&b.next!==m.Undefined){const P=b.prev;P.next=b.next,b.next.prev=P}else b.prev===m.Undefined&&b.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):b.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):b.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==m.Undefined;)yield b.element,b=b.next}}e.LinkedList=A}),function(){function $(R){const b=[];typeof R=="number"&&b.push("code/timeOrigin",R);function P(v){b.push(v,Date.now())}function n(){const v=[];for(let y=0;y<b.length;y+=2)v.push({name:b[y],startTime:b[y+1]});return v}return{mark:P,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const P of performance.getEntriesByType("mark"))b.push({name:P.name,startTime:Math.round(R+P.startTime)});return b}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=m(A))}(),define(Q[3],Z([0,1]),function($,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let R=!1,b=!1,P=!1,n=!1,v=!1,y=!1,i=!1,I,M=A,w,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const D=typeof((m=g==null?void 0:g.versions)===null||m===void 0?void 0:m.electron)=="string"&&g.type==="renderer";if(e.isElectronSandboxed=D&&(g==null?void 0:g.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=g==null?void 0:g.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)f=navigator.userAgent,R=f.indexOf("Windows")>=0,b=f.indexOf("Macintosh")>=0,i=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=f.indexOf("Linux")>=0,y=!0,I=navigator.language,M=I;else if(typeof g=="object"){R=g.platform==="win32",b=g.platform==="darwin",P=g.platform==="linux",n=P&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,I=A,M=A;const o=g.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),p=h.availableLanguages["*"];I=h.locale,M=p||A,w=h._translationsConfigFile}catch(h){}v=!0}else console.error("Unable to resolve platform.");var E;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function c(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;b?u=1:R?u=3:P&&(u=2),e.isWindows=R,e.isMacintosh=b,e.isLinux=P,e.isLinuxSnap=n,e.isNative=v,e.isWeb=y,e.isIOS=i,e.platform=u,e.userAgent=f,e.language=M;var a;(function(o){function h(){return e.language}o.value=h;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=p;function d(){return e.language==="en"}o.isDefault=d})(a=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=w,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let p=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let L=0,_=p.length;L<_;L++){const H=p[L];if(H.id===S.data.vscodeSetImmediateId){p.splice(L,1),H.callback();return}}});let d=0;return S=>{const L=++d;p.push({id:L,callback:S}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof(g==null?void 0:g.nextTick)=="function")return g.nextTick.bind(g);const h=Promise.resolve();return p=>h.then(p)}();var l;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||i?2:R?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Q[33],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const R=m.globals.vscode.process;A={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(b){return m.setImmediate(b)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:A={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(R){return m.setImmediate(R)},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(Q[8],Z([0,1,33]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,R=97,b=90,P=122,n=46,v=47,y=92,i=58,I=63;class M extends Error{constructor(a,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const s=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${s} ${r} of type ${l}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function w(u,a){if(typeof u!="string")throw new M(a,"string",u)}function f(u){return u===v||u===y}function g(u){return u===v}function D(u){return u>=A&&u<=b||u>=R&&u<=P}function E(u,a,l,t){let r="",s=0,o=-1,h=0,p=0;for(let d=0;d<=u.length;++d){if(d<u.length)p=u.charCodeAt(d);else{if(t(p))break;p=v}if(t(p)){if(!(o===d-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const S=r.lastIndexOf(l);S===-1?(r="",s=0):(r=r.slice(0,S),s=r.length-1-r.lastIndexOf(l)),o=d,h=0;continue}else if(r.length!==0){r="",s=0,o=d,h=0;continue}}a&&(r+=r.length>0?`${l}..`:"..",s=2)}else r.length>0?r+=`${l}${u.slice(o+1,d)}`:r=u.slice(o+1,d),s=d-o-1;o=d,h=0}else p===n&&h!==-1?++h:h=-1}return r}function c(u,a){if(a===null||typeof a!="object")throw new M("pathObject","Object",a);const l=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${t}`:`${l}${u}${t}`:t}e.win32={resolve(...u){let a="",l="",t=!1;for(let r=u.length-1;r>=-1;r--){let s;if(r>=0){if(s=u[r],w(s,"path"),s.length===0)continue}else a.length===0?s=m.cwd():(s=m.env[`=${a}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${a}\\`));const o=s.length;let h=0,p="",d=!1;const S=s.charCodeAt(0);if(o===1)f(S)&&(h=1,d=!0);else if(f(S))if(d=!0,f(s.charCodeAt(1))){let L=2,_=L;for(;L<o&&!f(s.charCodeAt(L));)L++;if(L<o&&L!==_){const H=s.slice(_,L);for(_=L;L<o&&f(s.charCodeAt(L));)L++;if(L<o&&L!==_){for(_=L;L<o&&!f(s.charCodeAt(L));)L++;(L===o||L!==_)&&(p=`\\\\${H}\\${s.slice(_,L)}`,h=L)}}}else h=1;else D(S)&&s.charCodeAt(1)===i&&(p=s.slice(0,2),h=2,o>2&&f(s.charCodeAt(2))&&(d=!0,h=3));if(p.length>0)if(a.length>0){if(p.toLowerCase()!==a.toLowerCase())continue}else a=p;if(t){if(a.length>0)break}else if(l=`${s.slice(h)}\\${l}`,t=d,d&&a.length>0)break}return l=E(l,!t,"\\",f),t?`${a}\\${l}`:`${a}${l}`||"."},normalize(u){w(u,"path");const a=u.length;if(a===0)return".";let l=0,t,r=!1;const s=u.charCodeAt(0);if(a===1)return g(s)?"\\":u;if(f(s))if(r=!0,f(u.charCodeAt(1))){let h=2,p=h;for(;h<a&&!f(u.charCodeAt(h));)h++;if(h<a&&h!==p){const d=u.slice(p,h);for(p=h;h<a&&f(u.charCodeAt(h));)h++;if(h<a&&h!==p){for(p=h;h<a&&!f(u.charCodeAt(h));)h++;if(h===a)return`\\\\${d}\\${u.slice(p)}\\`;h!==p&&(t=`\\\\${d}\\${u.slice(p,h)}`,l=h)}}}else l=1;else D(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),l=2,a>2&&f(u.charCodeAt(2))&&(r=!0,l=3));let o=l<a?E(u.slice(l),!r,"\\",f):"";return o.length===0&&!r&&(o="."),o.length>0&&f(u.charCodeAt(a-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(u){w(u,"path");const a=u.length;if(a===0)return!1;const l=u.charCodeAt(0);return f(l)||a>2&&D(l)&&u.charCodeAt(1)===i&&f(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let a,l;for(let s=0;s<u.length;++s){const o=u[s];w(o,"path"),o.length>0&&(a===void 0?a=l=o:a+=`\\${o}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&f(l.charCodeAt(0))){++r;const s=l.length;s>1&&f(l.charCodeAt(1))&&(++r,s>2&&(f(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&f(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(u,a){if(w(u,"from"),w(a,"to"),u===a)return"";const l=e.win32.resolve(u),t=e.win32.resolve(a);if(l===t||(u=l.toLowerCase(),a=t.toLowerCase(),u===a))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===y;)r++;let s=u.length;for(;s-1>r&&u.charCodeAt(s-1)===y;)s--;const o=s-r;let h=0;for(;h<a.length&&a.charCodeAt(h)===y;)h++;let p=a.length;for(;p-1>h&&a.charCodeAt(p-1)===y;)p--;const d=p-h,S=o<d?o:d;let L=-1,_=0;for(;_<S;_++){const X=u.charCodeAt(r+_);if(X!==a.charCodeAt(h+_))break;X===y&&(L=_)}if(_!==S){if(L===-1)return t}else{if(d>S){if(a.charCodeAt(h+_)===y)return t.slice(h+_+1);if(_===2)return t.slice(h+_)}o>S&&(u.charCodeAt(r+_)===y?L=_:_===2&&(L=3)),L===-1&&(L=0)}let H="";for(_=r+L+1;_<=s;++_)(_===s||u.charCodeAt(_)===y)&&(H+=H.length===0?"..":"\\..");return h+=L,H.length>0?`${H}${t.slice(h,p)}`:(t.charCodeAt(h)===y&&++h,t.slice(h,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const a=e.win32.resolve(u);if(a.length<=2)return u;if(a.charCodeAt(0)===y){if(a.charCodeAt(1)===y){const l=a.charCodeAt(2);if(l!==I&&l!==n)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(D(a.charCodeAt(0))&&a.charCodeAt(1)===i&&a.charCodeAt(2)===y)return`\\\\?\\${a}`;return u},dirname(u){w(u,"path");const a=u.length;if(a===0)return".";let l=-1,t=0;const r=u.charCodeAt(0);if(a===1)return f(r)?u:".";if(f(r)){if(l=t=1,f(u.charCodeAt(1))){let h=2,p=h;for(;h<a&&!f(u.charCodeAt(h));)h++;if(h<a&&h!==p){for(p=h;h<a&&f(u.charCodeAt(h));)h++;if(h<a&&h!==p){for(p=h;h<a&&!f(u.charCodeAt(h));)h++;if(h===a)return u;h!==p&&(l=t=h+1)}}}}else D(r)&&u.charCodeAt(1)===i&&(l=a>2&&f(u.charCodeAt(2))?3:2,t=l);let s=-1,o=!0;for(let h=a-1;h>=t;--h)if(f(u.charCodeAt(h))){if(!o){s=h;break}}else o=!1;if(s===-1){if(l===-1)return".";s=l}return u.slice(0,s)},basename(u,a){a!==void 0&&w(a,"ext"),w(u,"path");let l=0,t=-1,r=!0,s;if(u.length>=2&&D(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(l=2),a!==void 0&&a.length>0&&a.length<=u.length){if(a===u)return"";let o=a.length-1,h=-1;for(s=u.length-1;s>=l;--s){const p=u.charCodeAt(s);if(f(p)){if(!r){l=s+1;break}}else h===-1&&(r=!1,h=s+1),o>=0&&(p===a.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=h))}return l===t?t=h:t===-1&&(t=u.length),u.slice(l,t)}for(s=u.length-1;s>=l;--s)if(f(u.charCodeAt(s))){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(l,t)},extname(u){w(u,"path");let a=0,l=-1,t=0,r=-1,s=!0,o=0;u.length>=2&&u.charCodeAt(1)===i&&D(u.charCodeAt(0))&&(a=t=2);for(let h=u.length-1;h>=a;--h){const p=u.charCodeAt(h);if(f(p)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),p===n?l===-1?l=h:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||r===-1||o===0||o===1&&l===r-1&&l===t+1?"":u.slice(l,r)},format:c.bind(null,"\\"),parse(u){w(u,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return a;const l=u.length;let t=0,r=u.charCodeAt(0);if(l===1)return f(r)?(a.root=a.dir=u,a):(a.base=a.name=u,a);if(f(r)){if(t=1,f(u.charCodeAt(1))){let L=2,_=L;for(;L<l&&!f(u.charCodeAt(L));)L++;if(L<l&&L!==_){for(_=L;L<l&&f(u.charCodeAt(L));)L++;if(L<l&&L!==_){for(_=L;L<l&&!f(u.charCodeAt(L));)L++;L===l?t=L:L!==_&&(t=L+1)}}}}else if(D(r)&&u.charCodeAt(1)===i){if(l<=2)return a.root=a.dir=u,a;if(t=2,f(u.charCodeAt(2))){if(l===3)return a.root=a.dir=u,a;t=3}}t>0&&(a.root=u.slice(0,t));let s=-1,o=t,h=-1,p=!0,d=u.length-1,S=0;for(;d>=t;--d){if(r=u.charCodeAt(d),f(r)){if(!p){o=d+1;break}continue}h===-1&&(p=!1,h=d+1),r===n?s===-1?s=d:S!==1&&(S=1):s!==-1&&(S=-1)}return h!==-1&&(s===-1||S===0||S===1&&s===h-1&&s===o+1?a.base=a.name=u.slice(o,h):(a.name=u.slice(o,s),a.base=u.slice(o,h),a.ext=u.slice(s,h))),o>0&&o!==t?a.dir=u.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let a="",l=!1;for(let t=u.length-1;t>=-1&&!l;t--){const r=t>=0?u[t]:m.cwd();w(r,"path"),r.length!==0&&(a=`${r}/${a}`,l=r.charCodeAt(0)===v)}return a=E(a,!l,"/",g),l?`/${a}`:a.length>0?a:"."},normalize(u){if(w(u,"path"),u.length===0)return".";const a=u.charCodeAt(0)===v,l=u.charCodeAt(u.length-1)===v;return u=E(u,!a,"/",g),u.length===0?a?"/":l?"./":".":(l&&(u+="/"),a?`/${u}`:u)},isAbsolute(u){return w(u,"path"),u.length>0&&u.charCodeAt(0)===v},join(...u){if(u.length===0)return".";let a;for(let l=0;l<u.length;++l){const t=u[l];w(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(u,a){if(w(u,"from"),w(a,"to"),u===a||(u=e.posix.resolve(u),a=e.posix.resolve(a),u===a))return"";const l=1,t=u.length,r=t-l,s=1,o=a.length-s,h=r<o?r:o;let p=-1,d=0;for(;d<h;d++){const L=u.charCodeAt(l+d);if(L!==a.charCodeAt(s+d))break;L===v&&(p=d)}if(d===h)if(o>h){if(a.charCodeAt(s+d)===v)return a.slice(s+d+1);if(d===0)return a.slice(s+d)}else r>h&&(u.charCodeAt(l+d)===v?p=d:d===0&&(p=0));let S="";for(d=l+p+1;d<=t;++d)(d===t||u.charCodeAt(d)===v)&&(S+=S.length===0?"..":"/..");return`${S}${a.slice(s+p)}`},toNamespacedPath(u){return u},dirname(u){if(w(u,"path"),u.length===0)return".";const a=u.charCodeAt(0)===v;let l=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===v){if(!t){l=r;break}}else t=!1;return l===-1?a?"/":".":a&&l===1?"//":u.slice(0,l)},basename(u,a){a!==void 0&&w(a,"ext"),w(u,"path");let l=0,t=-1,r=!0,s;if(a!==void 0&&a.length>0&&a.length<=u.length){if(a===u)return"";let o=a.length-1,h=-1;for(s=u.length-1;s>=0;--s){const p=u.charCodeAt(s);if(p===v){if(!r){l=s+1;break}}else h===-1&&(r=!1,h=s+1),o>=0&&(p===a.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=h))}return l===t?t=h:t===-1&&(t=u.length),u.slice(l,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===v){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(l,t)},extname(u){w(u,"path");let a=-1,l=0,t=-1,r=!0,s=0;for(let o=u.length-1;o>=0;--o){const h=u.charCodeAt(o);if(h===v){if(!r){l=o+1;break}continue}t===-1&&(r=!1,t=o+1),h===n?a===-1?a=o:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||t===-1||s===0||s===1&&a===t-1&&a===l+1?"":u.slice(a,t)},format:c.bind(null,"/"),parse(u){w(u,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return a;const l=u.charCodeAt(0)===v;let t;l?(a.root="/",t=1):t=0;let r=-1,s=0,o=-1,h=!0,p=u.length-1,d=0;for(;p>=t;--p){const S=u.charCodeAt(p);if(S===v){if(!h){s=p+1;break}continue}o===-1&&(h=!1,o=p+1),S===n?r===-1?r=p:d!==1&&(d=1):r!==-1&&(d=-1)}if(o!==-1){const S=s===0&&l?1:s;r===-1||d===0||d===1&&r===o-1&&r===s+1?a.base=a.name=u.slice(S,o):(a.name=u.slice(S,r),a.base=u.slice(S,o),a.ext=u.slice(r,o))}return s>0?a.dir=u.slice(0,s-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[105],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var A;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(b,...P){const n=P.reduce((i,I)=>(i[I]=!0,i),{}),v=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(i=>!n[i]).forEach(i=>{for(let I=0;I<v.length;I++)if(i.search(v[I])!==-1){delete b[i];break}})}e.sanitizeProcessEnvironment=R}),define(Q[80],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const A=[],R=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>b[n]||0,toEnum:n=>R[n]||0,toString:n=>A[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class P{constructor(v,y,i,I,M){this.ctrlKey=v,this.shiftKey=y,this.altKey=i,this.metaKey=I,this.scanCode=M}equals(v){return this.ctrlKey===v.ctrlKey&&this.shiftKey===v.shiftKey&&this.altKey===v.altKey&&this.metaKey===v.metaKey&&this.scanCode===v.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=P,function(){function n(v,y){A[v]=y,R[y]=v,b[y.toLowerCase()]=v}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let v=0;v<=193;v++)e.IMMUTABLE_CODE_TO_KEY_CODE[v]=-1;for(let v=0;v<=112;v++)e.IMMUTABLE_KEY_CODE_TO_CODE[v]=-1;function n(v,y){e.IMMUTABLE_CODE_TO_KEY_CODE[v]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=v)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Q[106],Z([0,1,57,80]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(P){P=P.toLowerCase().trim();let n=!1,v=!1,y=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(P)&&(n=!0,P=P.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(P)&&(v=!0,P=P.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(P)&&(y=!0,P=P.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(P)&&(i=!0,P=P.substr("meta-".length),I=!0),/^win(\+|\-)/.test(P)&&(i=!0,P=P.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(P)&&(i=!0,P=P.substr("cmd-".length),I=!0);while(I);let M;const w=P.indexOf(" ");return w>0?(M=P.substring(0,w),P=P.substring(w)):(M=P,P=""),{remains:P,ctrl:n,shift:v,alt:y,meta:i,key:M}}static parseSimpleKeybinding(P){const n=this._readModifiers(P),v=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,v),n.remains]}static parseKeybinding(P,n){if(!P)return null;const v=[];let y;do[y,P]=this.parseSimpleKeybinding(P),v.push(y);while(P.length>0);return new m.ChordKeybinding(v)}static parseSimpleUserBinding(P){const n=this._readModifiers(P),v=n.key.match(/^\[([^\]]+)\]$/);if(v){const i=v[1],I=A.ScanCodeUtils.lowerCaseToEnum(i);return[new A.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const y=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseUserBinding(P){if(!P)return[];const n=[];let v;for(;P.length>0;)[v,P]=this.parseSimpleUserBinding(P),n.push(v);return n}}e.KeybindingParser=R}),define(Q[107],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=m.globals.performance&&typeof m.globals.performance.now=="function";class R{constructor(P){this._highResolution=A&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new R(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Q[5],Z([0,1,22,43,2,79,107]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(E){E.None=()=>R.Disposable.None;function c(Y){return(U,z=null,G)=>{let N=!1,F;return F=Y(T=>{if(!N)return F?F.dispose():N=!0,U.call(z,T)},null,G),N&&F.dispose(),F}}E.once=c;function u(Y,U){return o((z,G=null,N)=>Y(F=>z.call(G,U(F)),null,N))}E.map=u;function a(Y,U){return o((z,G=null,N)=>Y(F=>{U(F),z.call(G,F)},null,N))}E.forEach=a;function l(Y,U){return o((z,G=null,N)=>Y(F=>U(F)&&z.call(G,F),null,N))}E.filter=l;function t(Y){return Y}E.signal=t;function r(...Y){return(U,z=null,G)=>R.combinedDisposable(...Y.map(N=>N(F=>U.call(z,F),null,G)))}E.any=r;function s(Y,U,z){let G=z;return u(Y,N=>(G=U(G,N),G))}E.reduce=s;function o(Y){let U;const z=new M({onFirstListenerAdd(){U=Y(z.fire,z)},onLastListenerRemove(){U.dispose()}});return z.event}E.snapshot=o;function h(Y,U,z=100,G=!1,N){let F,T,O,k=0;const W=new M({leakWarningThreshold:N,onFirstListenerAdd(){F=Y(C=>{k++,T=U(T,C),G&&!O&&(W.fire(T),T=void 0),clearTimeout(O),O=setTimeout(()=>{const V=T;T=void 0,O=void 0,(!G||k>1)&&W.fire(V),k=0},z)})},onLastListenerRemove(){F.dispose()}});return W.event}E.debounce=h;function p(Y){const U=new Date().getTime();return u(c(Y),z=>new Date().getTime()-U)}E.stopwatch=p;function d(Y,U=(z,G)=>z===G){let z=!0,G;return l(Y,N=>{const F=z||!U(N,G);return z=!1,G=N,F})}E.latch=d;function S(Y,U){return[E.filter(Y,U),E.filter(Y,z=>!U(z))]}E.split=S;function L(Y,U=!1,z=[]){let G=z.slice(),N=Y(O=>{G?G.push(O):T.fire(O)});const F=()=>{G&&G.forEach(O=>T.fire(O)),G=null},T=new M({onFirstListenerAdd(){N||(N=Y(O=>T.fire(O)))},onFirstListenerDidAdd(){G&&(U?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return T.event}E.buffer=L;class _{constructor(U){this.event=U}map(U){return new _(u(this.event,U))}forEach(U){return new _(a(this.event,U))}filter(U){return new _(l(this.event,U))}reduce(U,z){return new _(s(this.event,U,z))}latch(){return new _(d(this.event))}debounce(U,z=100,G=!1,N){return new _(h(this.event,U,z,G,N))}on(U,z,G){return this.event(U,z,G)}once(U,z,G){return c(this.event)(U,z,G)}}function H(Y){return new _(Y)}E.chain=H;function X(Y,U,z=G=>G){const G=(...O)=>T.fire(z(...O)),N=()=>Y.on(U,G),F=()=>Y.removeListener(U,G),T=new M({onFirstListenerAdd:N,onLastListenerRemove:F});return T.event}E.fromNodeEventEmitter=X;function ee(Y,U,z=G=>G){const G=(...O)=>T.fire(z(...O)),N=()=>Y.addEventListener(U,G),F=()=>Y.removeEventListener(U,G),T=new M({onFirstListenerAdd:N,onLastListenerRemove:F});return T.event}E.fromDOMEventEmitter=ee;function B(Y){const U=new M;let z=!1;return Y.then(void 0,()=>null).then(()=>{z?U.fire(void 0):setTimeout(()=>U.fire(void 0),0)}),z=!0,U.event}E.fromPromise=B;function J(Y){return new Promise(U=>c(Y)(U))}E.toPromise=J})(n=e.Event||(e.Event={}));class v{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${v._idPool++}`}start(c){this._stopWatch=new P.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}v._idPool=0;let y=-1;function i(E){const c=y;return y=E,{dispose(){y=c}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(c,u=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let u=y;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||c<u)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(a)||0;if(this._stacks.set(a,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[s,o]of this._stacks)(!t||r<o)&&(t=s,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class M{constructor(c){var u;this._disposed=!1,this._options=c,this._leakageMon=y>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new v(this._options._profName):void 0}get event(){return this._event||(this._event=(c,u,a)=>{var l;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[c,u]:c);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,u);const s=(l=this._leakageMon)===null||l===void 0?void 0:l.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=M._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof R.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(c){var u,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,c]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(r){m.onUnexpectedError(r)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var c,u,a,l,t;this._disposed||(this._disposed=!0,(c=this._listeners)===null||c===void 0||c.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(l=(a=this._options)===null||a===void 0?void 0:a.onLastListenerRemove)===null||l===void 0||l.call(a),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=M,M._noop=function(){};class w extends M{constructor(c){super(c);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=c==null?void 0:c.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=w;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new M({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const u={event:c,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const a=()=>{this.hasListeners&&this.unhook(u);const l=this.events.indexOf(u);this.events.splice(l,1)};return R.toDisposable(A.once(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(u=>this.emitter.fire(u))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class g{constructor(){this.buffers=[]}wrapEvent(c){return(u,a,l)=>c(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(a,t)):u.call(a,t)},void 0,l)}bufferEvents(c){const u=[];this.buffers.push(u);const a=c();return this.buffers.pop(),u.forEach(l=>l()),a}}e.EventBufferer=g;class D{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=R.Disposable.None,this.emitter=new M({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(Q[25],Z([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(n,v){const y=setTimeout(n.bind(v),0);return{dispose(){clearTimeout(y)}}});var R;(function(n){function v(y){return y===n.None||y===n.Cancelled||y instanceof b?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}n.isCancellationToken=v,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(R=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(v){this._token=void 0,this._parentListener=void 0,this._parentListener=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=R.Cancelled}dispose(v=!1){v&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=P}),define(Q[108],Z([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const M=this._icons.get(I.id);M?I.description?M.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new A;e.iconRegistry=R;function b(i,I){return new n(i,I)}e.registerCodicon=b;function P(i){return i?i.replace(/\$\((.*?)\)/g,(I,M)=>` ${M} `).trim():""}e.getCodiconAriaLabel=P;class n{constructor(I,M,w){this.id=I,this.definition=M,this.description=w,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function v(i,I){const M=["codicon","codicon-"+i];return I&&M.push("codicon-modifier-"+I),M}e.getClassNamesArray=v;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function M(g){if(g instanceof n)return["codicon","codicon-"+g.id];const D=I.exec(g.id);if(!D)return M(n.error);let[,E,c]=D;const u=["codicon","codicon-"+E];return c&&u.push("codicon-modifier-"+c.substr(1)),u}i.asClassNameArray=M;function w(g){return M(g).join(" ")}i.asClassName=w;function f(g){return"."+M(g).join(".")}i.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Q[64],Z([0,1,22,2]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(u){const a=u;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=R;function b(u){const a=u;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=b;function P(u,a){return new n(u,a)}e.newWriteableStream=P;class n{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?m.onUnexpectedError(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(l);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(u,a){const l=[];let t;for(;(t=u.read())!==null;)l.push(t);return a(l)}e.consumeReadable=v;function y(u,a,l){const t=[];let r;for(;(r=u.read())!==null&&t.length<l;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return u.read()}}}e.peekReadable=y;function i(u,a){return new Promise((l,t)=>{const r=[];I(u,{onData:s=>{a&&r.push(s)},onError:s=>{a?t(s):l(void 0)},onEnd:()=>{l(a?a(r):void 0)}})})}e.consumeStream=i;function I(u,a){u.on("error",l=>a.onError(l)),u.on("end",()=>a.onEnd()),u.on("data",l=>a.onData(l))}e.listenStream=I;function M(u,a){return new Promise((l,t)=>{const r=new A.DisposableStore,s=[],o=d=>{if(s.push(d),s.length>a)return r.dispose(),u.pause(),l({stream:u,buffer:s,ended:!1})},h=d=>t(d),p=()=>l({stream:u,buffer:s,ended:!0});r.add(A.toDisposable(()=>u.removeListener("error",h))),u.on("error",h),r.add(A.toDisposable(()=>u.removeListener("end",p))),u.on("end",p),r.add(A.toDisposable(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=M;function w(u,a){const l=P(a);return l.end(u),l}e.toStream=w;function f(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=f;function g(u){let a=!1;return{read:()=>a?null:(a=!0,u)}}e.toReadable=g;function D(u,a,l){const t=P(l);return I(u,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function E(u,a,l){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?l([u,r]):u)}}}e.prefixedReadable=E;function c(u,a,l){let t=!1;const r=P(l);return I(a,{onData:s=>t?r.write(s):(t=!0,r.write(l([u,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=c}),define(Q[23],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=m;const A=/{(\d+)}/g;function R(j,...ie){return ie.length===0?j:j.replace(A,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?ae:ie[fe]})}e.format=R;function b(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=b;function P(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function n(j,ie){let ae=0;const ce=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ce&&ae++;return ae}e.count=n;function v(j,ie,ae="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${ae}`}e.truncate=v;function y(j,ie=" "){const ae=i(j,ie);return I(ae,ie)}e.trim=y;function i(j,ie){if(!j||!ie)return j;const ae=ie.length;if(ae===0||j.length===0)return j;let ce=0;for(;j.indexOf(ie,ce)===ce;)ce=ce+ae;return j.substring(ce)}e.ltrim=i;function I(j,ie){if(!j||!ie)return j;const ae=ie.length,ce=j.length;if(ae===0||ce===0)return j;let fe=ce,Se=-1;for(;Se=j.lastIndexOf(ie,fe-1),!(Se===-1||Se+ae!==fe);){if(Se===0)return"";fe=Se}return j.substring(0,fe)}e.rtrim=I;function M(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=M;function w(j){return j.replace(/\*/g,"")}e.stripWildcards=w;function f(j,ie,ae={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=P(j)),ae.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=f;function g(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function D(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function E(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=E;function c(j){return j.split(/\r\n|\r|\n/)}e.splitLines=c;function u(j){for(let ie=0,ae=j.length;ie<ae;ie++){const ce=j.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function a(j,ie=0,ae=j.length){for(let ce=ie;ce<ae;ce++){const fe=j.charCodeAt(ce);if(fe!==32&&fe!==9)return j.substring(ie,ce)}return j.substring(ie,ae)}e.getLeadingWhitespace=a;function l(j,ie=j.length-1){for(let ae=ie;ae>=0;ae--){const ce=j.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=l;function t(j,ie){return j<ie?-1:j>ie?1:0}e.compare=t;function r(j,ie,ae=0,ce=j.length,fe=0,Se=ie.length){for(;ae<ce&&fe<Se;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue<ze)return-1;if(Ue>ze)return 1}const Me=ce-ae,Fe=Se-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=r;function s(j,ie){return o(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=s;function o(j,ie,ae=0,ce=j.length,fe=0,Se=ie.length){for(;ae<ce&&fe<Se;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue===ze)continue;const de=Ue-ze;if(!(de===32&&p(ze))&&!(de===-32&&p(Ue)))return h(Ue)&&h(ze)?de:r(j.toLowerCase(),ie.toLowerCase(),ae,ce,fe,Se)}const Me=ce-ae,Fe=Se-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=o;function h(j){return j>=97&&j<=122}e.isLowerAsciiLetter=h;function p(j){return j>=65&&j<=90}e.isUpperAsciiLetter=p;function d(j){return h(j)||p(j)}function S(j,ie){return j.length===ie.length&&L(j,ie)}e.equalsIgnoreCase=S;function L(j,ie,ae=j.length){for(let ce=0;ce<ae;ce++){const fe=j.charCodeAt(ce),Se=ie.charCodeAt(ce);if(fe!==Se){if(d(fe)&&d(Se)){const Me=Math.abs(fe-Se);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function _(j,ie){const ae=ie.length;return ie.length>j.length?!1:L(j,ie,ae)}e.startsWithIgnoreCase=_;function H(j,ie){let ae,ce=Math.min(j.length,ie.length);for(ae=0;ae<ce;ae++)if(j.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=H;function X(j,ie){let ae,ce=Math.min(j.length,ie.length);const fe=j.length-1,Se=ie.length-1;for(ae=0;ae<ce;ae++)if(j.charCodeAt(fe-ae)!==ie.charCodeAt(Se-ae))return ae;return ce}e.commonSuffixLength=X;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function B(j){return 56320<=j&&j<=57343}e.isLowSurrogate=B;function J(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=J;function Y(j,ie,ae){const ce=j.charCodeAt(ae);if(ee(ce)&&ae+1<ie){const fe=j.charCodeAt(ae+1);if(B(fe))return J(ce,fe)}return ce}e.getNextCodePoint=Y;function U(j,ie){const ae=j.charCodeAt(ie-1);if(B(ae)&&ie>1){const ce=j.charCodeAt(ie-2);if(ee(ce))return J(ce,ae)}return ae}function z(j,ie){const ae=Be.getInstance(),ce=ie,fe=j.length,Se=Y(j,fe,ie);ie+=Se>=65536?2:1;let Me=ae.getGraphemeBreakType(Se);for(;ie<fe;){const Fe=Y(j,fe,ie),Ue=ae.getGraphemeBreakType(Fe);if(He(Me,Ue))break;ie+=Fe>=65536?2:1,Me=Ue}return ie-ce}e.nextCharLength=z;function G(j,ie){const ae=Be.getInstance(),ce=ie,fe=U(j,ie);ie-=fe>=65536?2:1;let Se=ae.getGraphemeBreakType(fe);for(;ie>0;){const Me=U(j,ie),Fe=ae.getGraphemeBreakType(Me);if(He(Fe,Se))break;ie-=Me>=65536?2:1,Se=Fe}return ce-ie}e.prevCharLength=G;function N(j,ie){const ae=Be.getInstance(),ce=j.length,fe=ie,Se=Y(j,ce,ie),Me=ae.getGraphemeBreakType(Se);ie+=Se>=65536?2:1;let Fe=Me;for(;ie<ce;){const ze=Y(j,ce,ie),de=ae.getGraphemeBreakType(ze);if(He(Fe,de))break;ie+=ze>=65536?2:1,Fe=de}const Ue=ie;for(ie=fe,Fe=Me;ie>0;){const ze=U(j,ie),de=ae.getGraphemeBreakType(ze);if(He(de,Fe))break;ie-=ze>=65536?2:1,Fe=de}return[ie,Ue]}function F(j,ie){return ie>0&&B(j.charCodeAt(ie))?N(j,ie-1):N(j,ie)}e.getCharContainingOffset=F;function T(j){const ie=j.length;let ae=0,ce=0;for(;ce<ie;){const Me=Y(j,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const fe=new Uint8Array(ae);ce=0;let Se=0;for(;ce<ie;){const Me=Y(j,ie,ce);ce+=Me>=65536?2:1,Me<128?fe[Se++]=Me:Me<2048?(fe[Se++]=192|(Me&1984)>>>6,fe[Se++]=128|(Me&63)>>>0):Me<65536?(fe[Se++]=224|(Me&61440)>>>12,fe[Se++]=128|(Me&4032)>>>6,fe[Se++]=128|(Me&63)>>>0):(fe[Se++]=240|(Me&1835008)>>>18,fe[Se++]=128|(Me&258048)>>>12,fe[Se++]=128|(Me&4032)>>>6,fe[Se++]=128|(Me&63)>>>0)}return fe}e.encodeUTF8=T;function O(j){const ie=j.byteLength,ae=[];let ce=0;for(;ce<ie;){const fe=j[ce];let Se;if(fe>=240&&ce+3<ie?Se=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?Se=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?Se=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:Se=j[ce++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)ae.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const Me=Se-65536,Fe=55296+((Me&1047552)>>>10),Ue=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(Ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(j){return k.test(j)}e.containsRTL=W;const C=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(j){return C.test(j)}e.containsEmoji=V;const K=/^[\t\n\r\x20-\x7E]*$/;function q(j){return K.test(j)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=x;function ne(j){for(let ie=0,ae=j.length;ie<ae;ie++)if(re(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function re(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=re;function se(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=se;function le(j,ie){if(j.length<ie)return j;const ae=/\b/g;let ce=0;for(;ae.test(j)&&!(j.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=le;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function be(j){return j&&(j=j.replace(oe,""),j=j.replace(ue,""),j=j.replace(me,"")),j}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Ie(j){return De(j)?j.substr(1):j}e.stripUTF8BOM=Ie;function we(j,ie){if(!j||!ie||j.length<ie.length)return!1;const ae=ie.length,ce=j.toLowerCase();let fe=0,Se=-1;for(;fe<ae;){const Me=ce.indexOf(ie[fe],Se+1);if(Me<0)return!1;Se=Me,fe++}return!0}e.fuzzyContains=we;function ye(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=ye;function Le(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Le;function Te(j,ie=1){if(ie===0)return"";let ae=-1;do ae=j.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?j:(j[ae-1]==="\r"&&ae--,j.substr(0,ae))}e.getNLines=Te;function $e(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=$e;function Ne(j){return Be.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ne;function He(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=He;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ie<ae[3*fe])fe=2*fe;else if(ie>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(j,ie){if(j===0)return 0;const ae=ut(j,ie);if(ae!==void 0)return ae;const ce=U(ie,j);return j-=Xe(ce),j}e.getLeftDeleteOffset=tt;function ut(j,ie){let ae=U(ie,j);for(j-=Xe(ae);ht(ae)||ae===65039||ae===8419;){if(j===0)return;ae=U(ie,j),j-=Xe(ae)}if(!!se(ae)){if(j>=0){const ce=U(ie,j);ce===8205&&(j-=Xe(ce))}return j}}function Xe(j){return j>=65536?2:1}function ht(j){return 127995<=j&&j<=127999}var ot;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={}))}),define(Q[16],Z([0,1,23,64]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let n,v;class y{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return R?new y(Buffer.allocUnsafe(d)):new y(new Uint8Array(d))}static wrap(d){return R&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new y(d)}static fromString(d,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&R?new y(Buffer.from(d)):b?(n||(n=new TextEncoder),new y(n.encode(d))):new y(m.encodeUTF8(d))}static concat(d,S){if(typeof S=="undefined"){S=0;for(let H=0,X=d.length;H<X;H++)S+=d[H].byteLength}const L=y.alloc(S);let _=0;for(let H=0,X=d.length;H<X;H++){const ee=d[H];L.set(ee,_),_+=ee.byteLength}return L}toString(){return R?this.buffer.toString():P?(v||(v=new TextDecoder),v.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(d,S){return new y(this.buffer.subarray(d,S))}set(d,S){d instanceof y?this.buffer.set(d.buffer,S):this.buffer.set(d,S)}readUInt32BE(d){return M(this.buffer,d)}writeUInt32BE(d,S){w(this.buffer,d,S)}readUInt32LE(d){return f(this.buffer,d)}writeUInt32LE(d,S){g(this.buffer,d,S)}readUInt8(d){return D(this.buffer,d)}writeUInt8(d,S){E(this.buffer,d,S)}}e.VSBuffer=y;function i(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0}e.readUInt16LE=i;function I(p,d,S){p[S+0]=d&255,d=d>>>8,p[S+1]=d&255}e.writeUInt16LE=I;function M(p,d){return p[d]*2**24+p[d+1]*2**16+p[d+2]*2**8+p[d+3]}e.readUInt32BE=M;function w(p,d,S){p[S+3]=d,d=d>>>8,p[S+2]=d,d=d>>>8,p[S+1]=d,d=d>>>8,p[S]=d}e.writeUInt32BE=w;function f(p,d){return p[d+0]<<0>>>0|p[d+1]<<8>>>0|p[d+2]<<16>>>0|p[d+3]<<24>>>0}e.readUInt32LE=f;function g(p,d,S){p[S+0]=d&255,d=d>>>8,p[S+1]=d&255,d=d>>>8,p[S+2]=d&255,d=d>>>8,p[S+3]=d&255}e.writeUInt32LE=g;function D(p,d){return p[d]}e.readUInt8=D;function E(p,d,S){p[S]=d}e.writeUInt8=E;function c(p){return A.consumeReadable(p,d=>y.concat(d))}e.readableToBuffer=c;function u(p){return A.toReadable(p)}e.bufferToReadable=u;function a(p){return A.consumeStream(p,d=>y.concat(d))}e.streamToBuffer=a;async function l(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await a(p.stream)])}e.bufferedStreamToBuffer=l;function t(p){return A.toStream(p,d=>y.concat(d))}e.bufferToStream=t;function r(p){return A.transform(p,{data:d=>typeof d=="string"?y.fromString(d):y.wrap(d)},d=>y.concat(d))}e.streamToBufferReadableStream=r;function s(p){return A.newWriteableStream(d=>y.concat(d),p)}e.newWriteableBufferStream=s;function o(p,d){return A.prefixedReadable(p,d,S=>y.concat(S))}e.prefixedBufferReadable=o;function h(p,d){return A.prefixedStream(p,d,S=>y.concat(S))}e.prefixedBufferStream=h}),define(Q[81],Z([0,1,23]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(E){return R(E,0)}e.hash=A;function R(E,c){switch(typeof E){case"object":return E===null?b(349,c):Array.isArray(E)?v(E,c):y(E,c);case"string":return n(E,c);case"boolean":return P(E,c);case"number":return b(E,c);case"undefined":return b(937,c);default:return b(617,c)}}e.doHash=R;function b(E,c){return(c<<5)-c+E|0}function P(E,c){return b(E?433:863,c)}function n(E,c){c=b(149417,c);for(let u=0,a=E.length;u<a;u++)c=b(E.charCodeAt(u),c);return c}e.stringHash=n;function v(E,c){return c=b(104579,c),E.reduce((u,a)=>R(a,u),c)}function y(E,c){return c=b(181387,c),Object.keys(E).sort().reduce((u,a)=>(u=n(a,u),R(E[a],u)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=R(c,this._value),this._value}}e.Hasher=i;var I;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function M(E,c,u=32){const a=u-c,l=~((1<<a)-1);return(E<<c|(l&E)>>>a)>>>0}function w(E,c=0,u=E.byteLength,a=0){for(let l=0;l<u;l++)E[c+l]=a}function f(E,c,u="0"){for(;E.length<c;)E=u+E;return E}function g(E,c=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(u=>u.toString(16).padStart(2,"0")).join(""):f((E>>>0).toString(16),c/4)}e.toHexString=g;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const u=c.length;if(u===0)return;const a=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=c.charCodeAt(0),s=0);;){let o=r;if(m.isHighSurrogate(r))if(s+1<u){const h=c.charCodeAt(s+1);m.isLowSurrogate(h)?(s++,o=m.computeCodePoint(r,h)):o=65533}else{t=r;break}else m.isLowSurrogate(r)&&(o=65533);if(l=this._push(a,l,o),s++,s<u)r=c.charCodeAt(s);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(c,u,a){return a<128?c[u++]=a:a<2048?(c[u++]=192|(a&1984)>>>6,c[u++]=128|(a&63)>>>0):a<65536?(c[u++]=224|(a&61440)>>>12,c[u++]=128|(a&4032)>>>6,c[u++]=128|(a&63)>>>0):(c[u++]=240|(a&1835008)>>>18,c[u++]=128|(a&258048)>>>12,c[u++]=128|(a&4032)>>>6,c[u++]=128|(a&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=D._bigBlock32,u=this._buffDV;for(let d=0;d<64;d+=4)c.setUint32(d,u.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)c.setUint32(d,M(c.getUint32(d-12,!1)^c.getUint32(d-32,!1)^c.getUint32(d-56,!1)^c.getUint32(d-64,!1),1),!1);let a=this._h0,l=this._h1,t=this._h2,r=this._h3,s=this._h4,o,h,p;for(let d=0;d<80;d++)d<20?(o=l&t|~l&r,h=1518500249):d<40?(o=l^t^r,h=1859775393):d<60?(o=l&t|l&r|t&r,h=2400959708):(o=l^t^r,h=3395469782),p=M(a,5)+o+s+h+c.getUint32(d*4,!1)&4294967295,s=r,r=t,t=M(l,30),l=a,a=p;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(d){return Array.isArray(d)}e.isArray=m;function A(d){return typeof d=="string"}e.isString=A;function R(d){return Array.isArray(d)&&d.every(S=>A(S))}e.isStringArray=R;function b(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=b;function P(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=P;function n(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=n;function v(d){return d===!0||d===!1}e.isBoolean=v;function y(d){return typeof d=="undefined"}e.isUndefined=y;function i(d){return!I(d)}e.isDefined=i;function I(d){return y(d)||d===null}e.isUndefinedOrNull=I;function M(d,S){if(!d)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=M;function w(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=w;function f(...d){const S=[];for(let L=0;L<d.length;L++){const _=d[L];if(I(_))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);S.push(_)}return S}e.assertAllDefined=f;const g=Object.prototype.hasOwnProperty;function D(d){if(!b(d))return!1;for(let S in d)if(g.call(d,S))return!1;return!0}e.isEmptyObject=D;function E(d){return typeof d=="function"}e.isFunction=E;function c(...d){return d.length>0&&d.every(E)}e.areFunctions=c;function u(d,S){const L=Math.min(d.length,S.length);for(let _=0;_<L;_++)a(d[_],S[_])}e.validateConstraints=u;function a(d,S){if(A(S)){if(typeof d!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(E(S)){try{if(d instanceof S)return}catch(L){}if(!I(d)&&d.constructor===S||S.length===1&&S.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(d){let S=[],L=Object.getPrototypeOf(d);for(;Object.prototype!==L;)S=S.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return S}e.getAllPropertyNames=l;function t(d){const S=[];for(const L of l(d))typeof d[L]=="function"&&S.push(L);return S}e.getAllMethodNames=t;function r(d,S){const L=H=>function(){const X=Array.prototype.slice.call(arguments,0);return S(H,X)};let _={};for(const H of d)_[H]=L(H);return _}e.createProxyObject=r;function s(d){return d===null?void 0:d}e.withNullAsUndefined=s;function o(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=o;function h(d){return class{constructor(){return new Proxy({},{get(S,L){if(S[L])return S[L];throw new Error(`Not Implemented: ${d}->${String(L)}`)}})}}}e.NotImplementedProxy=h;function p(d){throw new Error("Unreachable")}e.assertNever=p}),define(Q[29],Z([0,1,3,23,8,13]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(s){return s===47||s===92}e.isPathSeparator=P;function n(s){return s.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=n;function v(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=v;function y(s,o=R.posix.sep){if(!s)return"";const h=s.length,p=s.charCodeAt(0);if(P(p)){if(P(s.charCodeAt(1))&&!P(s.charCodeAt(2))){let S=3;const L=S;for(;S<h&&!P(s.charCodeAt(S));S++);if(L!==S&&!P(s.charCodeAt(S+1))){for(S+=1;S<h;S++)if(P(s.charCodeAt(S)))return s.slice(0,S+1).replace(/[\\/]/g,o)}}return o}else if(E(p)&&s.charCodeAt(1)===58)return P(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let d=s.indexOf("://");if(d!==-1){for(d+=3;d<h;d++)if(P(s.charCodeAt(d)))return s.slice(0,d+1)}return""}e.getRoot=y;function i(s){if(!m.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let h=2;const p=h;for(;h<s.length&&(o=s.charCodeAt(h),o!==92);h++);return!(p===h||(o=s.charCodeAt(h+1),isNaN(o)||o===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,M=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,o=m.isWindows){const h=o?I:M;return!(!s||s.length===0||/^\s+$/.test(s)||(h.lastIndex=0,h.test(s))||o&&w.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function g(s,o,h){const p=s===o;return!h||p?p:!s||!o?!1:A.equalsIgnoreCase(s,o)}e.isEqual=g;function D(s,o,h,p=R.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(h){if(!A.startsWithIgnoreCase(s,o))return!1;if(o.length===s.length)return!0;let S=o.length;return o.charAt(o.length-1)===p&&S--,s.charAt(S)===p}return o.charAt(o.length-1)!==p&&(o+=p),s.indexOf(o)===0}e.isEqualOrParent=D;function E(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=E;function c(s,o){return m.isWindows&&s.endsWith(":")&&(s+=R.sep),R.isAbsolute(s)||(s=R.join(o,s)),s=R.normalize(s),m.isWindows?(s=A.rtrim(s,R.sep),s.endsWith(":")&&(s+=R.sep)):(s=A.rtrim(s,R.sep),s||(s=R.sep)),s}e.sanitizeFilePath=c;function u(s){const o=R.normalize(s);return m.isWindows?s.length>3?!1:a(o)&&(s.length===2||o.charCodeAt(2)===92):o===R.posix.sep}e.isRootOrDriveLetter=u;function a(s){return m.isWindows?E(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(s){return a(s)?s[0]:void 0}e.getDriveLetter=l;function t(s,o,h){return o.length>s.length?-1:s===o?0:(h&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=t;function r(s){const o=s.split(":");let h,p,d;if(o.forEach(S=>{const L=Number(S);b.isNumber(L)?p===void 0?p=L:d===void 0&&(d=L):h=h?[h,S].join(":"):S}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:p!==void 0?p:void 0,column:d!==void 0?d:p!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Q[44],Z([0,1,13]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const D=Array.isArray(g)?[]:{};return Object.keys(g).forEach(E=>{g[E]&&typeof g[E]=="object"?D[E]=A(g[E]):D[E]=g[E]}),D}e.deepClone=A;function R(g){if(!g||typeof g!="object")return g;const D=[g];for(;D.length>0;){const E=D.shift();Object.freeze(E);for(const c in E)if(b.call(E,c)){const u=E[c];typeof u=="object"&&!Object.isFrozen(u)&&D.push(u)}}return g}e.deepFreeze=R;const b=Object.prototype.hasOwnProperty;function P(g,D){return n(g,D,new Set)}e.cloneAndChange=P;function n(g,D,E){if(m.isUndefinedOrNull(g))return g;const c=D(g);if(typeof c!="undefined")return c;if(m.isArray(g)){const u=[];for(const a of g)u.push(n(a,D,E));return u}if(m.isObject(g)){if(E.has(g))throw new Error("Cannot clone recursive data-structure");E.add(g);const u={};for(let a in g)b.call(g,a)&&(u[a]=n(g[a],D,E));return E.delete(g),u}return g}function v(g,D,E=!0){return m.isObject(g)?(m.isObject(D)&&Object.keys(D).forEach(c=>{c in g?E&&(m.isObject(g[c])&&m.isObject(D[c])?v(g[c],D[c],E):g[c]=D[c]):g[c]=D[c]}),g):D}e.mixin=v;function y(g,D){if(g===D)return!0;if(g==null||D===null||D===void 0||typeof g!=typeof D||typeof g!="object"||Array.isArray(g)!==Array.isArray(D))return!1;let E,c;if(Array.isArray(g)){if(g.length!==D.length)return!1;for(E=0;E<g.length;E++)if(!y(g[E],D[E]))return!1}else{const u=[];for(c in g)u.push(c);u.sort();const a=[];for(c in D)a.push(c);if(a.sort(),!y(u,a))return!1;for(E=0;E<u.length;E++)if(!y(g[u[E]],D[u[E]]))return!1}return!0}e.equals=y;function i(g){const D=new Set;return JSON.stringify(g,(E,c)=>{if(m.isObject(c)||Array.isArray(c)){if(D.has(c))return"[Circular]";D.add(c)}return c})}e.safeStringify=i;function I(g,D,E){const c=D(g);return typeof c=="undefined"?E:c}e.getOrDefault=I;function M(g,D){const E=Object.create(null);return!g||!D||Object.keys(D).forEach(u=>{const a=g[u],l=D[u];y(a,l)||(E[u]=l)}),E}e.distinct=M;function w(g,D){const E=D.toLowerCase(),c=Object.keys(g).find(u=>u.toLowerCase()===E);return c?g[c]:g[D]}e.getCaseInsensitive=w;function f(g,D){const E=Object.create(null);for(const c of Object.keys(g))D(c,g[c])&&(E[c]=g[c]);return E}e.filter=f}),define(Q[7],Z([0,1,3,8]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,b=/^\//,P=/^\/\//;function n(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!R.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!b.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(s,o){return!s&&!o?"file":s}function y(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const i="",I="/",M=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(o,h,p,d,S,L=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=v(o,L),this.authority=h||i,this.path=y(this.scheme,p||i),this.query=d||i,this.fragment=S||i,n(this,L))}static isUri(o){return o instanceof w?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:h,authority:p,path:d,query:S,fragment:L}=o;return h===void 0?h=this.scheme:h===null&&(h=i),p===void 0?p=this.authority:p===null&&(p=i),d===void 0?d=this.path:d===null&&(d=i),S===void 0?S=this.query:S===null&&(S=i),L===void 0?L=this.fragment:L===null&&(L=i),h===this.scheme&&p===this.authority&&d===this.path&&S===this.query&&L===this.fragment?this:new g(h,p,d,S,L)}static parse(o,h=!1){const p=M.exec(o);return p?new g(p[2]||i,r(p[4]||i),r(p[5]||i),r(p[7]||i),r(p[9]||i),h):new g(i,i,i,i,i)}static file(o){let h=i;if(m.isWindows&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const p=o.indexOf(I,2);p===-1?(h=o.substring(2),o=I):(h=o.substring(2,p),o=o.substring(p)||I)}return new g("file",h,o,i,i)}static from(o){const h=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return n(h,!0),h}static joinPath(o,...h){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return m.isWindows&&o.scheme==="file"?p=w.file(A.win32.join(u(o,!0),...h)).path:p=A.posix.join(o.path,...h),o.with({path:p})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof w)return o;{const h=new g(o);return h._formatted=o.external,h._fsPath=o._sep===f?o.fsPath:null,h}}else return o}}e.URI=w;const f=m.isWindows?1:void 0;class g extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=f),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(s,o){let h,p=-1;for(let d=0;d<s.length;d++){const S=s.charCodeAt(d);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||o&&S===47)p!==-1&&(h+=encodeURIComponent(s.substring(p,d)),p=-1),h!==void 0&&(h+=s.charAt(d));else{h===void 0&&(h=s.substr(0,d));const L=D[S];L!==void 0?(p!==-1&&(h+=encodeURIComponent(s.substring(p,d)),p=-1),h+=L):p===-1&&(p=d)}}return p!==-1&&(h+=encodeURIComponent(s.substring(p))),h!==void 0?h:s}function c(s){let o;for(let h=0;h<s.length;h++){const p=s.charCodeAt(h);p===35||p===63?(o===void 0&&(o=s.substr(0,h)),o+=D[p]):o!==void 0&&(o+=s[h])}return o!==void 0?o:s}function u(s,o){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,m.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=u;function a(s,o){const h=o?c:E;let p="",{scheme:d,authority:S,path:L,query:_,fragment:H}=s;if(d&&(p+=d,p+=":"),(S||d==="file")&&(p+=I,p+=I),S){let X=S.indexOf("@");if(X!==-1){const ee=S.substr(0,X);S=S.substr(X+1),X=ee.indexOf(":"),X===-1?p+=h(ee,!1):(p+=h(ee.substr(0,X),!1),p+=":",p+=h(ee.substr(X+1),!1)),p+="@"}S=S.toLowerCase(),X=S.indexOf(":"),X===-1?p+=h(S,!1):(p+=h(S.substr(0,X),!1),p+=S.substr(X))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const X=L.charCodeAt(1);X>=65&&X<=90&&(L=`/${String.fromCharCode(X+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const X=L.charCodeAt(0);X>=65&&X<=90&&(L=`${String.fromCharCode(X+32)}:${L.substr(2)}`)}p+=h(L,!0)}return _&&(p+="?",p+=h(_,!1)),H&&(p+="#",p+=o?H:E(H,!1)),p}function l(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+l(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,o=>l(o)):s}}),define(Q[109],Z([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(y){const i=y;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=A;function R(y){const i=[];let I;try{const M=JSON.parse(y.arguments),w=M[M.length-1];w&&w.__$stack&&(M.pop(),I=w.__$stack),i.push(...M)}catch(M){i.push("Unable to log remote console arguments",y.arguments)}return{args:i,stack:I}}e.parse=R;function b(y){if(typeof y!="string")return b(R(y).stack);const i=y;if(i){const I=P(i),M=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(M&&M.length===4)return{uri:m.URI.file(M[1]),line:Number(M[2]),column:Number(M[3])}}}e.getFirstFrame=b;function P(y){if(!y)return y;const i=y.indexOf(`
`);return i===-1?y:y.substring(0,i)}function n(y,i){const{args:I,stack:M}=R(y),w=typeof I[0]=="string"&&I.length===1;let f=P(M);f&&(f=`(${f.trim()})`);let g=[];if(typeof I[0]=="string"?f&&w?g=[`%c[${i}] %c${I[0]} %c${f}`,v("blue"),v(""),v("grey")]:g=[`%c[${i}] %c${I[0]}`,v("blue"),v(""),...I.slice(1)]:g=[`%c[${i}]%`,v("blue"),...I],f&&!w&&g.push(f),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}e.log=n;function v(y){return`color: ${y}`}});var It=this&&this.__classPrivateFieldSet||function($,e,m,A,R){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!R:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?R.call($,m):R?R.value=m:e.set($,m),m},Ye=this&&this.__classPrivateFieldGet||function($,e,m,A){if(m==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!A:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?A:m==="a"?A.call($):A?A.value:e.get($)};define(Q[37],Z([0,1,7,23]),function($,e,m,A){"use strict";var R,b,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let o=t.get(r);return o===void 0&&(o=s,t.set(r,o)),o}e.getOrSet=n;function v(t){const r=[];return t.forEach((s,o)=>{r.push(`${o} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=v;function y(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?A.compareSubstring(r,this._value,0,r.length,this._from,this._to):A.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class M{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?A.compareSubstring(r,this._value,0,r.length,this._from,this._to):A.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var w;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(w||(w={}));class f{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return A.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return A.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return A.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return A.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new f(r))}static forPaths(){return new D(new M)}static forStrings(){return new D(new i)}static forConfigKeys(){return new D(new I)}clear(){this._root=void 0}set(r,s){const o=this._iter.reset(r);let h;for(this._root||(this._root=new g,this._root.segment=o.value()),h=this._root;;){const d=o.cmp(h.segment);if(d>0)h.left||(h.left=new g,h.left.segment=o.value()),h=h.left;else if(d<0)h.right||(h.right=new g,h.right.segment=o.value()),h=h.right;else if(o.hasNext())o.next(),h.mid||(h.mid=new g,h.mid.segment=o.value()),h=h.mid;else break}const p=h.value;return h.value=s,h.key=r,p}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const o=this._iter.reset(r),h=[];let p=this._root;for(;p;){const d=o.cmp(p.segment);if(d>0)h.push([1,p]),p=p.left;else if(d<0)h.push([-1,p]),p=p.right;else if(o.hasNext())o.next(),h.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;h.length>0&&p.isEmpty();){let[S,L]=h.pop();switch(S){case 1:L.left=void 0;break;case 0:L.mid=void 0;break;case-1:L.right=void 0;break}p=L}break}}}findSubstr(r){const s=this._iter.reset(r);let o=this._root,h;for(;o;){const p=s.cmp(o.segment);if(p>0)o=o.left;else if(p<0)o=o.right;else if(s.hasNext())s.next(),h=o.value||h,o=o.mid;else break}return o&&o.value||h}findSuperstr(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[s,o]of this)r(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const o=s.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&s.push(o.left),o.mid&&s.push(o.mid),o.right&&s.push(o.right))}}}e.TernarySearchTree=D;class E{constructor(r,s){this[R]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=s??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[o,h]of this.map)r(h,m.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield m.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[m.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[m.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const o=this._map.get(r);if(!!o)return s!==0&&this.touch(o,s),o.value}set(r,s,o=0){let h=this._map.get(r);if(h)h.value=s,o!==0&&this.touch(h,o);else{switch(h={key:r,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const o=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.key,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.value,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let o=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:[o.key,o.value],done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return h}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>r;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,o=r.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const o=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(o.previous=h,h.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const o=r.next,h=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=h,h.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,o)=>{r.push([o,s])}),r}fromJSON(r){this.clear();for(const[s,o]of r)this.set(s,o)}}e.LinkedMap=u;class a extends u{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class l{constructor(r){P.set(this,void 0),It(this,P,r,"f")}get size(){return Ye(this,P,"f").size}forEach(r,s){Ye(this,P,"f").forEach(r,s)}get(r){return Ye(this,P,"f").get(r)}has(r){return Ye(this,P,"f").has(r)}entries(){return Ye(this,P,"f").entries()}keys(){return Ye(this,P,"f").keys()}values(){return Ye(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ye(this,P,"f").entries()}}e.ReadonlyMapView=l}),define(Q[110],Z([0,1,16,23,7]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(y){return JSON.stringify(y,n)}e.stringify=b;function P(y){let i=JSON.parse(y);return i=v(i),i}e.parse=P;function n(y,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:A.regExpFlags(i)}:i}function v(y,i=0){if(!y||i>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return R.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof m.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let I=0;I<y.length;++I)y[I]=v(y[I],i+1);else for(const I in y)Object.hasOwnProperty.call(y,I)&&(y[I]=v(y[I],i+1))}return y}e.revive=v}),define(Q[10],Z([0,1,7,3]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}set(v,y,i){this._hosts[v]=y,this._ports[v]=i}setConnectionToken(v,y){this._connectionTokens[v]=y}rewrite(v){if(this._delegate)return this._delegate(v);const y=v.authority;let i=this._hosts[y];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[y],M=this._connectionTokens[y];let w=`path=${encodeURIComponent(v.path)}`;return typeof M=="string"&&(w+=`&tkn=${encodeURIComponent(M)}`),m.URI.from({scheme:A.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new b;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(v,y,i){const I=this.toUri(v,y);return I.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(I):A.isNative&&(i||A.isPreferringBrowserCodeLoad)&&I.scheme===R.file?I.with({scheme:R.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(v,y){const i=this.toUri(v,y);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(v,y){return m.URI.isUri(v)?v:m.URI.parse(y.toUrl(v))}}e.FileAccess=new P}),define(Q[65],Z([0,1,37]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new m.LRUCache(1e4);function R(y){return v(y,"NFC",A)}e.normalizeNFC=R;const b=new m.LRUCache(1e4);function P(y){return v(y,"NFD",b)}e.normalizeNFD=P;const n=/[^\u0000-\u0080]/;function v(y,i,I){if(!e.canNormalize||!y)return y;const M=I.get(y);if(M)return M;let w;return n.test(y)?w=y.normalize(i):w=y,I.set(y,w),w}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(i){return P(i).replace(y,"")}}else return function(y){return y}}()}),define(Q[15],Z([0,1,29,8,7,23,10,3]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(w){return R.uriToFsPath(w,!0)}e.originalFSPath=v;class y{constructor(f){this._ignorePathCasing=f}compare(f,g,D=!1){return f===g?0:b.compare(this.getComparisonKey(f,D),this.getComparisonKey(g,D))}isEqual(f,g,D=!1){return f===g?!0:!f||!g?!1:this.getComparisonKey(f,D)===this.getComparisonKey(g,D)}getComparisonKey(f,g=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,g,D=!1){if(f.scheme===g.scheme){if(f.scheme===P.Schemas.file)return m.isEqualOrParent(v(f),v(g),this._ignorePathCasing(f))&&f.query===g.query&&(D||f.fragment===g.fragment);if(e.isEqualAuthority(f.authority,g.authority))return m.isEqualOrParent(f.path,g.path,this._ignorePathCasing(f),"/")&&f.query===g.query&&(D||f.fragment===g.fragment)}return!1}joinPath(f,...g){return R.URI.joinPath(f,...g)}basenameOrAuthority(f){return e.basename(f)||f.authority}basename(f){return A.posix.basename(f.path)}extname(f){return A.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let g;return f.scheme===P.Schemas.file?g=R.URI.file(A.dirname(v(f))).path:(g=A.posix.dirname(f.path),f.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),g="/")),f.with({path:g})}normalizePath(f){if(!f.path.length)return f;let g;return f.scheme===P.Schemas.file?g=R.URI.file(A.normalize(v(f))).path:g=A.posix.normalize(f.path),f.with({path:g})}relativePath(f,g){if(f.scheme!==g.scheme||!e.isEqualAuthority(f.authority,g.authority))return;if(f.scheme===P.Schemas.file){const c=A.relative(v(f),v(g));return n.isWindows?m.toSlashes(c):c}let D=f.path||"/",E=g.path||"/";if(this._ignorePathCasing(f)){let c=0;for(const u=Math.min(D.length,E.length);c<u&&!(D.charCodeAt(c)!==E.charCodeAt(c)&&D.charAt(c).toLowerCase()!==E.charAt(c).toLowerCase());c++);D=E.substr(0,c)+D.substr(c)}return A.posix.relative(D,E)}resolvePath(f,g){if(f.scheme===P.Schemas.file){const D=R.URI.file(A.resolve(v(f),g));return f.with({authority:D.authority,path:D.path})}return g=m.toPosixPath(g),f.with({path:A.posix.resolve(f.path,g)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,g){return f===g||b.equalsIgnoreCase(f,g)}hasTrailingPathSeparator(f,g=A.sep){if(f.scheme===P.Schemas.file){const D=v(f);return D.length>m.getRoot(D).length&&D[D.length-1]===g}else{const D=f.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,g=A.sep){return e.hasTrailingPathSeparator(f,g)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,g=A.sep){let D=!1;if(f.scheme===P.Schemas.file){const E=v(f);D=E!==void 0&&E.length===m.getRoot(E).length&&E[E.length-1]===g}else{g="/";const E=f.path;D=E.length===1&&E.charCodeAt(E.length-1)===47}return!D&&!e.hasTrailingPathSeparator(f,g)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(w=>w.scheme===P.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new y(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(w,f){const g=[];for(let D=0;D<w.length;D++){const E=f(w[D]);w.some((c,u)=>u===D?!1:e.isEqualOrParent(E,f(c)))||g.push(w[D])}return g}e.distinctParents=i;var I;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(g){const D=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,l]=u.split(":");a&&l&&D.set(a,l)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&D.set(w.META_DATA_MIME,c),D}w.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function M(w,f,g){if(f){let D=w.path;return D&&D[0]!==A.posix.sep&&(D=A.posix.sep+D),w.with({scheme:g,authority:f,path:D})}return w.with({scheme:g})}e.toLocalResource=M}),define(Q[9],Z([0,1,25,22,5,2,79,15]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(N){return!!N&&typeof N.then=="function"}e.isThenable=v;function y(N){const F=new m.CancellationTokenSource,T=N(F.token),O=new Promise((k,W)=>{F.token.onCancellationRequested(()=>{W(A.canceled())}),Promise.resolve(T).then(C=>{F.dispose(),k(C)},C=>{F.dispose(),W(C)})});return new class{cancel(){F.cancel()}then(k,W){return O.then(k,W)}catch(k){return this.then(void 0,k)}finally(k){return O.finally(k)}}}e.createCancelablePromise=y;function i(N,F,T){return Promise.race([N,new Promise(O=>F.onCancellationRequested(()=>O(T)))])}e.raceCancellation=i;async function I(N){let F=-1;const T=N.map((k,W)=>k.then(C=>(F=W,C))),O=await Promise.race(T);return N.forEach((k,W)=>{W!==F&&k.cancel()}),O}e.raceCancellablePromises=I;function M(N,F,T){let O;const k=setTimeout(()=>{O==null||O(void 0),T==null||T()},F);return Promise.race([N.finally(()=>clearTimeout(k)),new Promise(W=>O=W)])}e.raceTimeout=M;function w(N){return new Promise((F,T)=>{const O=N();v(O)?O.then(F,T):F(O)})}e.asPromise=w;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(T,T).then(O)})}return new Promise((T,O)=>{this.queuedPromise.then(T,O)})}return this.activePromise=F(),new Promise((T,O)=>{this.activePromise.then(k=>{this.activePromise=null,T(k)},k=>{this.activePromise=null,O(k)})})}}e.Throttler=f;class g{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=g;class D{constructor(){this.promiseMap=new Map}queue(F,T){var O;const W=((O=this.promiseMap.get(F))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=D;class E{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,T=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,k)=>{this.doResolve=O,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(A.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class c{constructor(F){this.delayer=new E(F),this.throttler=new f}trigger(F,T){return this.delayer.trigger(()=>this.throttler.queue(F),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,T)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class a extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(N,F){return F?new Promise((T,O)=>{const k=setTimeout(T,N);F.onCancellationRequested(()=>{clearTimeout(k),O(A.canceled())})}):y(T=>l(N,T))}e.timeout=l;function t(N,F=0){const T=setTimeout(N,F);return b.toDisposable(()=>clearTimeout(T))}e.disposableTimeout=t;function r(N){return N.then(void 0,F=>{})}e.ignoreErrors=r;function s(N){const F=[];let T=0;const O=N.length;function k(){return T<O?N[T++]():null}function W(C){C!=null&&F.push(C);const V=k();return V?V.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=s;function o(N,F=O=>!!O,T=null){let O=0;const k=N.length,W=()=>{if(O>=k)return Promise.resolve(T);const C=N[O++];return Promise.resolve(C()).then(K=>F(K)?Promise.resolve(K):W())};return W()}e.first=o;function h(N,F=O=>!!O,T=null){if(N.length===0)return Promise.resolve(T);let O=N.length;const k=()=>{var W,C;O=-1;for(const V of N)(C=(W=V).cancel)===null||C===void 0||C.call(W)};return new Promise((W,C)=>{for(const V of N)V.then(K=>{--O>=0&&F(K)?(k(),W(K)):O===0&&W(T)}).catch(K=>{--O>=0&&(k(),C(K))})})}e.firstParallel=h;class p{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((T,O)=>{this.outstandingPromises.push({factory:F,c:T,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const T=F.factory();T.then(F.c,F.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class d extends p{constructor(){super(1)}}e.Queue=d;class S{constructor(){this.queues=new Map}queueFor(F,T=n.extUri){const O=T.getComparisonKey(F);let k=this.queues.get(O);return k||(k=new d,R.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(O)}),this.queues.set(O,k)),k}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=S;class L{constructor(F,T){this._token=-1,typeof F=="function"&&typeof T=="number"&&this.setIfNotSet(F,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},T)}setIfNotSet(F,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},T))}}e.TimeoutTimer=L;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,T){this.cancel(),this._token=setInterval(()=>{F()},T)}}e.IntervalTimer=_;class H{constructor(F,T){this.timeoutToken=-1,this.runner=F,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class X extends H{constructor(F,T){super(F,T);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const T=setTimeout(()=>F(N));let O=!1;return{dispose(){O||(O=!0,clearTimeout(T))}}}}else e.runWhenIdle=(N,F)=>{const T=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(T))}}}}();class ee{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ee;async function B(N,F,T){let O;for(let k=0;k<T;k++)try{return await N()}catch(W){O=W,await l(F)}throw O}e.retry=B;class J{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,T,O){return this._pending={taskId:F,cancel:()=>O==null?void 0:O(),promise:T},T.then(()=>this.donePending(F),()=>this.donePending(F)),T}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let T,O;const k=new Promise((W,C)=>{T=W,O=C});this._next={run:F,promise:k,promiseResolve:T,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=J;class Y{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,T)=>{this.completeCallback=F,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(T=>{this.completeCallback(F),this.resolved=!0,T()})}error(F){return new Promise(T=>{this.errorCallback(F),this.rejected=!0,T()})}cancel(){new Promise(F=>{this.errorCallback(A.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=U;class z extends R.Emitter{async fireAsync(F,T,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,F]);for(;this._asyncDeliveryQueue.size>0&&!T.isCancellationRequested;){const[k,W]=this._asyncDeliveryQueue.shift(),C=[],V=Object.assign(Object.assign({},W),{waitUntil:K=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");O&&(K=O(K,typeof k=="function"?k:k[0])),C.push(K)}});try{typeof k=="function"?k.call(void 0,V):k[0].call(k[1],V)}catch(K){A.onUnexpectedError(K);continue}Object.freeze(C),await G.settled(C).catch(K=>A.onUnexpectedError(K))}}}}e.AsyncEmitter=z;var G;(function(N){async function F(W){return typeof Promise.allSettled=="function"?T(W):O(W)}N.allSettled=F;async function T(W){return Promise.allSettled(W)}async function O(W){return Promise.all(W.map(C=>C.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function k(W){let C;const V=await Promise.all(W.map(K=>K.then(q=>q,q=>{C||(C=q)})));if(typeof C!="undefined")throw C;return V}N.settled=k})(G=e.Promises||(e.Promises={}))}),define(Q[111],Z([0,1,23,29,8,37,9]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const v="**",y="/",i="[/\\\\]",I="[^/\\\\]",M=/\//g;function w(T){switch(T){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function f(T,O){if(!T)return[];const k=[];let W=!1,C=!1,V="";for(const K of T){switch(K){case O:if(!W&&!C){k.push(V),V="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":C=!0;break;case"]":C=!1;break}V+=K}return V&&k.push(V),k}e.splitGlobAware=f;function g(T){if(!T)return"";let O="";const k=f(T,y);if(k.every(W=>W===v))O=".*";else{let W=!1;k.forEach((C,V)=>{if(C===v){W||(O+=w(2),W=!0);return}let K=!1,q="",x=!1,ne="";for(const re of C){if(re!=="}"&&K){q+=re;continue}if(x&&(re!=="]"||!ne)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!ne?se="^":re===y?se="":se=m.escapeRegExpCharacters(re),ne+=se;continue}switch(re){case"{":K=!0;continue;case"[":x=!0;continue;case"}":O+=`(?:${f(q,",").map(oe=>g(oe)).join("|")})`,K=!1,q="";break;case"]":O+="["+ne+"]",x=!1,ne="";break;case"?":O+=I;continue;case"*":O+=w(1);continue;default:O+=m.escapeRegExpCharacters(re)}}V<k.length-1&&(k[V+1]!==v||V+2<k.length)&&(O+=i),W=!1})}return O}const D=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),r=function(){return!1},s=function(){return null};function o(T,O){if(!T)return s;let k;typeof T!="string"?k=T.pattern:k=T,k=k.trim();const W=`${k}_${!!O.trimForExclusions}`;let C=t.get(W);if(C)return h(C,T);let V;if(D.test(k)){const K=k.substr(4);C=function(q,x){return typeof q=="string"&&q.endsWith(K)?k:null}}else(V=E.exec(p(k,O)))?C=d(V[1],k):(O.trimForExclusions?u:c).test(k)?C=S(k,O):(V=a.exec(p(k,O)))?C=L(V[1].substr(1),k,!0):(V=l.exec(p(k,O)))?C=L(V[1],k,!1):C=_(k);return t.set(W,C),h(C,T)}function h(T,O){return typeof O=="string"?T:function(k,W){return A.isEqualOrParent(k,O.base)?T(R.relative(O.base,k),W):null}}function p(T,O){return O.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function d(T,O){const k=`/${T}`,W=`\\${T}`,C=function(K,q){return typeof K!="string"?null:q?q===T?O:null:K===T||K.endsWith(k)||K.endsWith(W)?O:null},V=[T];return C.basenames=V,C.patterns=[O],C.allBasenames=V,C}function S(T,O){const k=F(T.slice(1,-1).split(",").map(q=>o(q,O)).filter(q=>q!==s),T),W=k.length;if(!W)return s;if(W===1)return k[0];const C=function(q,x){for(let ne=0,re=k.length;ne<re;ne++)if(k[ne](q,x))return T;return null},V=k.find(q=>!!q.allBasenames);V&&(C.allBasenames=V.allBasenames);const K=k.reduce((q,x)=>x.allPaths?q.concat(x.allPaths):q,[]);return K.length&&(C.allPaths=K),C}function L(T,O,k){const W=R.sep===R.posix.sep,C=W?T:T.replace(M,R.sep),V=R.sep+C,K=R.posix.sep+T,q=k?function(x,ne){return typeof x=="string"&&(x===C||x.endsWith(V)||!W&&(x===T||x.endsWith(K)))?O:null}:function(x,ne){return typeof x=="string"&&(x===C||!W&&x===T)?O:null};return q.allPaths=[(k?"*/":"./")+T],q}function _(T){try{const O=new RegExp(`^${g(T)}$`);return function(k){return O.lastIndex=0,typeof k=="string"&&O.test(k)?T:null}}catch(O){return s}}function H(T,O,k){return!T||typeof O!="string"?!1:X(T)(O,void 0,k)}e.match=H;function X(T,O={}){if(!T)return r;if(typeof T=="string"||Y(T)){const k=o(T,O);if(k===s)return r;const W=function(C,V){return!!k(C,V)};return k.allBasenames&&(W.allBasenames=k.allBasenames),k.allPaths&&(W.allPaths=k.allPaths),W}return G(T,O)}e.parse=X;function ee(T){if(!T)return;let O;return k=>(O||(O=(T()||Promise.resolve([])).then(W=>W?J(W):{})),O.then(W=>!!W[k]))}e.hasSiblingPromiseFn=ee;function B(T){if(!T)return;let O;return k=>{if(!O){const W=T();O=W?J(W):{}}return!!O[k]}}e.hasSiblingFn=B;function J(T){const O={};for(const k of T)O[k]=!0;return O}function Y(T){const O=T;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=Y;function U(T){return T.allBasenames||[]}e.getBasenameTerms=U;function z(T){return T.allPaths||[]}e.getPathTerms=z;function G(T,O){const k=F(Object.getOwnPropertyNames(T).map(q=>N(q,T[q],O)).filter(q=>q!==s)),W=k.length;if(!W)return s;if(!k.some(q=>!!q.requiresSiblings)){if(W===1)return k[0];const q=function(re,se){for(let le=0,oe=k.length;le<oe;le++){const ue=k[le](re,se);if(ue)return ue}return null},x=k.find(re=>!!re.allBasenames);x&&(q.allBasenames=x.allBasenames);const ne=k.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return ne.length&&(q.allPaths=ne),q}const C=function(q,x,ne){let re;for(let se=0,le=k.length;se<le;se++){const oe=k[se];oe.requiresSiblings&&ne&&(x||(x=R.basename(q)),re||(re=x.substr(0,x.length-R.extname(q).length)));const ue=oe(q,x,re,ne);if(ue)return ue}return null},V=k.find(q=>!!q.allBasenames);V&&(C.allBasenames=V.allBasenames);const K=k.reduce((q,x)=>x.allPaths?q.concat(x.allPaths):q,[]);return K.length&&(C.allPaths=K),C}function N(T,O,k){if(O===!1)return s;const W=o(T,k);if(W===s)return s;if(typeof O=="boolean")return W;if(O){const C=O.when;if(typeof C=="string"){const V=(K,q,x,ne)=>{if(!ne||!W(K,q))return null;const re=C.replace("$(basename)",x),se=ne(re);return P.isThenable(se)?se.then(le=>le?T:null):se?T:null};return V.requiresSiblings=!0,V}}return W}function F(T,O){const k=T.filter(q=>!!q.basenames);if(k.length<2)return T;const W=k.reduce((q,x)=>{const ne=x.basenames;return ne?q.concat(ne):q},[]);let C;if(O){C=[];for(let q=0,x=W.length;q<x;q++)C.push(O)}else C=k.reduce((q,x)=>{const ne=x.patterns;return ne?q.concat(ne):q},[]);const V=function(q,x){if(typeof q!="string")return null;if(!x){let re;for(re=q.length;re>0;re--){const se=q.charCodeAt(re-1);if(se===47||se===92)break}x=q.substr(re)}const ne=W.indexOf(x);return ne!==-1?C[ne]:null};V.basenames=W,V.patterns=C,V.allBasenames=W;const K=T.filter(q=>!q.basenames);return K.push(V),K}}),define(Q[30],Z([0,1,7,8,23,10,3,15,29]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(o,h,p){if(typeof o=="string"&&(o=m.URI.file(o)),p){const S=p.getWorkspaceFolder(o);if(S){const L=p.getWorkspace().folders.length>1;let _;if(n.isEqual(S.uri,o)?_="":_=n.relativePath(S.uri,o),L){const H=S.name?S.name:n.basename(S.uri);_=_?H+" \u2022 "+_:H}return _}}if(o.scheme!==b.Schemas.file&&o.scheme!==b.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if(v.hasDriveLetter(o.fsPath))return A.normalize(I(o.fsPath));let d=A.normalize(o.fsPath);return!P.isWindows&&(h==null?void 0:h.userHome)&&(d=w(d,h.userHome.fsPath)),d}e.getPathLabel=y;function i(o){if(!o)return;typeof o=="string"&&(o=m.URI.file(o));const h=n.basename(o)||(o.scheme===b.Schemas.file?o.fsPath:o.path);return P.isWindows&&v.isRootOrDriveLetter(h)?I(h):h}e.getBaseLabel=i;function I(o){return v.hasDriveLetter(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=I;let M=Object.create(null);function w(o,h){if(P.isWindows||!o||!h)return o;let p=M.original===h?M.normalized:void 0;return p||(p=`${R.rtrim(h,A.posix.sep)}${A.posix.sep}`,M={original:h,normalized:p}),(P.isLinux?o.startsWith(p):R.startsWithIgnoreCase(o,p))&&(o=`~/${o.substr(p.length)}`),o}e.tildify=w;function f(o,h){return o.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=f;const g="\u2026",D="\\\\",E="~";function c(o,h=A.sep){const p=new Array(o.length);let d=!1;for(let S=0;S<o.length;S++){let L=o[S];if(L===""){p[S]=`.${h}`;continue}if(!L){p[S]=L;continue}d=!0;let _="";L.indexOf(D)===0?(_=L.substr(0,L.indexOf(D)+D.length),L=L.substr(L.indexOf(D)+D.length)):L.indexOf(h)===0?(_=L.substr(0,L.indexOf(h)+h.length),L=L.substr(L.indexOf(h)+h.length)):L.indexOf(E)===0&&(_=L.substr(0,L.indexOf(E)+E.length),L=L.substr(L.indexOf(E)+E.length));const H=L.split(h);for(let X=1;d&&X<=H.length;X++)for(let ee=H.length-X;d&&ee>=0;ee--){d=!1;let B=H.slice(ee,ee+X).join(h);for(let J=0;!d&&J<o.length;J++)if(J!==S&&o[J]&&o[J].indexOf(B)>-1){const Y=ee+X===H.length,U=ee>0&&o[J].indexOf(h)>-1?h+B:B,z=o[J].endsWith(U);d=!Y||z}if(!d){let J="";(H[0].endsWith(":")||_!=="")&&(ee===1&&(ee=0,X++,B=H[0]+h+B),ee>0&&(J=H[0]+h),J=_+J),ee>0&&(J=J+g+h),J=J+B,ee+X<H.length&&(J=J+h+g),p[S]=J}}d&&(p[S]=L)}return p}e.shorten=c;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function a(o,h=Object.create(null)){const p=[];let d=!1,S="";for(const L of o)if(L==="$"||d&&L==="{")S&&p.push({value:S,type:u.TEXT}),S="",d=!0;else if(L==="}"&&d){const _=h[S];if(typeof _=="string")_.length&&p.push({value:_,type:u.VARIABLE});else if(_){const H=p[p.length-1];(!H||H.type!==u.SEPARATOR)&&p.push({value:_.label,type:u.SEPARATOR})}S="",d=!1}else S+=L;return S&&!d&&p.push({value:S,type:u.TEXT}),p.filter((L,_)=>{if(L.type===u.SEPARATOR){const H=p[_-1],X=p[_+1];return[H,X].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(o,h){return P.isMacintosh||h?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):o.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(o,h){return P.isMacintosh||h?o.replace(/\(&&\w\)|&&/g,""):P.isWindows?o.replace(/&&|&/g,p=>p==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(o){const h=o.indexOf("/")!==-1?A.posix:A.win32,p=h.basename(o),d=h.dirname(o);return p.length?{name:p,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(Q[27],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(v){return m.test(v)}e.isUUID=A;const R=new Uint8Array(16),b=[];for(let v=0;v<256;v++)b.push(v.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(v){for(let y=0;y<v.length;y++)v[y]=Math.floor(Math.random()*256);return v};function n(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let v=0,y="";return y+=b[R[v++]],y+=b[R[v++]],y+=b[R[v++]],y+=b[R[v++]],y+="-",y+=b[R[v++]],y+=b[R[v++]],y+="-",y+=b[R[v++]],y+=b[R[v++]],y+="-",y+=b[R[v++]],y+=b[R[v++]],y+="-",y+=b[R[v++]],y+=b[R[v++]],y+=b[R[v++]],y+=b[R[v++]],y+=b[R[v++]],y+=b[R[v++]],y}e.generateUuid=n}),define(Q[112],Z([0,1,31,58,43]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(P,n){if(await new Promise((i,I)=>{const M=m.createReadStream(P),w=A.createHash("sha1");M.pipe(w);const f=R.once((g,D)=>{M.removeAllListeners(),w.removeAllListeners(),g?I(g):i(D)});M.once("error",f),M.once("end",f),w.once("error",f),w.once("data",g=>f(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=b}),define(Q[82],Z([0,1,238]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(b="utf8"){this.stringDecoder=new m.StringDecoder(b),this.remaining=null}write(b){const P=[],n=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(n.length<1)return P;let v=0,y,i=v;for(;i<n.length;)if(y=n.charCodeAt(i),y===13||y===10){if(P.push(n.substring(v,i)),i++,i<n.length){const I=y;y=n.charCodeAt(i),(I===13&&y===10||I===10&&y===13)&&i++}v=i}else i++;return this.remaining=v<n.length?n.substr(v):null,P}end(){return this.remaining}}e.LineDecoder=A}),define(Q[113],Z([0,1,26]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(n){const v=n.replace(/\-/g,":").toLowerCase();return!A.has(v)}function b(){return new Promise(async(n,v)=>{const y=setTimeout(()=>v("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await P())}catch(i){v(i)}finally{clearTimeout(y)}})}e.getMac=b;function P(){return new Promise((n,v)=>{try{const y=m.networkInterfaces();for(let i in y){const I=y[i];if(I){for(const{mac:M}of I)if(R(M))return n(M)}}v("Unable to retrieve mac address (unexpected format)")}catch(y){v(y)}})}}),define(Q[66],Z([0,1,22,27,26,37,113]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const M=R.networkInterfaces();for(let w in M){const f=M[w];if(f)for(const{mac:g,internal:D}of f)D||(I+=1,this._isVirtualMachineMacAdress(g.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let n;async function v(){return n||(n=(async()=>await y()||A.generateUuid())()),n}e.getMachineId=v;async function y(){try{const i=await new Promise((M,w)=>{$(["crypto"],M,w)}),I=await P.getMac();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){m.onUnexpectedError(i);return}}}),define(Q[17],Z([0,1,31,26,114,8,9,3,29,27,65,15,7]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function f(U,z=w.UNLINK){if(v.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");return z===w.UNLINK?D(U):g(U)}async function g(U){try{const z=b.join(A.tmpdir(),y.generateUuid());try{await e.Promises.rename(U,z)}catch(G){return D(U)}D(z).catch(G=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function D(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function E(U){if(v.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(U,{recursive:!0})}e.rimrafSync=E;async function c(U,z){return l(await(z?u(U):R.promisify(m.readdir)(U)))}async function u(U){try{return await R.promisify(m.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const z=[],G=await c(U);for(const N of G){let F=!1,T=!1,O=!1;try{const k=await e.Promises.lstat(b.join(U,N));F=k.isFile(),T=k.isDirectory(),O=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}z.push({name:N,isFile:()=>F,isDirectory:()=>T,isSymbolicLink:()=>O})}return z}function a(U){return l(m.readdirSync(U))}e.readdirSync=a;function l(U){return U.map(z=>typeof z=="string"?n.isMacintosh?i.normalizeNFC(z):z:(z.name=n.isMacintosh?i.normalizeNFC(z.name):z.name,z))}async function t(U){const z=await c(U),G=[];for(const N of z)await s.existsDirectory(b.join(U,N))&&G.push(N);return G}function r(U,z=1e3){return new Promise(G=>{let N=!1;const F=setInterval(()=>{N||(N=!0,m.access(U,T=>{N=!1,T&&(clearInterval(F),G(void 0))}))},z)})}e.whenDeleted=r;var s;(function(U){async function z(F){let T;try{if(T=await e.Promises.lstat(F),!T.isSymbolicLink())return{stat:T}}catch(O){}try{return{stat:await e.Promises.stat(F),symbolicLink:(T==null?void 0:T.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw k}throw O}}U.stat=z;async function G(F){try{const{stat:T,symbolicLink:O}=await U.stat(F);return T.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(T){}return!1}U.existsFile=G;async function N(F){try{const{stat:T,symbolicLink:O}=await U.stat(F);return T.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(T){}return!1}U.existsDirectory=N})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function h(U,z,G){return o.queueFor(M.URI.file(U),I.extUriBiasedIgnorePathCase).queue(()=>{const N=L(G);return new Promise((F,T)=>d(U,z,N,O=>O?T(O):F()))})}let p=!0;function d(U,z,G,N){if(!p)return m.writeFile(U,z,{mode:G.mode,flag:G.flag},N);m.open(U,G.flag,G.mode,(F,T)=>{if(F)return N(F);m.writeFile(T,z,O=>{if(O)return m.close(T,()=>N(O));m.fdatasync(T,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),p=!1),m.close(T,W=>N(W))))})})}function S(U,z,G){const N=L(G);if(!p)return m.writeFileSync(U,z,{mode:N.mode,flag:N.flag});const F=m.openSync(U,N.flag,N.mode);try{m.writeFileSync(F,z);try{m.fdatasyncSync(F)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),p=!1}}finally{m.closeSync(F)}}e.writeFileSync=S;function L(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function _(U,z){if(U===z)return;async function G(N){try{const F=await e.Promises.lstat(N);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(N,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(U,z),await G(z)}catch(N){if(U.toLowerCase()!==z.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await H(U,z,{preserveSymlinks:!1}),await f(U,w.MOVE),await G(z);else throw N}}async function H(U,z,G){return ee(U,z,{root:{source:U,target:z},options:G,handledSourcePaths:new Set})}const X=511;async function ee(U,z,G){if(G.handledSourcePaths.has(U))return;G.handledSourcePaths.add(U);const{stat:N,symbolicLink:F}=await s.stat(U);if(F){if(G.options.preserveSymlinks)try{return await Y(U,z,G)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(F.dangling)return}return N.isDirectory()?B(U,z,N.mode&X,G):J(U,z,N.mode&X)}async function B(U,z,G,N){await e.Promises.mkdir(z,{recursive:!0,mode:G});const F=await c(U);for(const T of F)await ee(b.join(U,T),b.join(z,T),N)}async function J(U,z,G){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,G)}async function Y(U,z,G){let N=await e.Promises.readlink(U);v.isEqualOrParent(N,G.root.source,!n.isLinux)&&(N=b.join(G.root.target,N.substr(G.root.source.length+1))),await e.Promises.symlink(N,z)}e.Promises=new class{get access(){return R.promisify(m.access)}get stat(){return R.promisify(m.stat)}get lstat(){return R.promisify(m.lstat)}get utimes(){return R.promisify(m.utimes)}get read(){return R.promisify(m.read)}get readFile(){return R.promisify(m.readFile)}get write(){return R.promisify(m.write)}get appendFile(){return R.promisify(m.appendFile)}get fdatasync(){return R.promisify(m.fdatasync)}get truncate(){return R.promisify(m.truncate)}get rename(){return R.promisify(m.rename)}get copyFile(){return R.promisify(m.copyFile)}get open(){return R.promisify(m.open)}get close(){return R.promisify(m.close)}get symlink(){return R.promisify(m.symlink)}get readlink(){return R.promisify(m.readlink)}get chmod(){return R.promisify(m.chmod)}get mkdir(){return R.promisify(m.mkdir)}get unlink(){return R.promisify(m.unlink)}get rmdir(){return R.promisify(m.rmdir)}get realpath(){return R.promisify(m.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch(z){return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return f}get move(){return _}get copy(){return H}}}),define(Q[83],Z([0,1,31,23,8,17]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const I=R.dirname(i);if(i===I)return i;const M=(R.basename(i)||i).toLowerCase();try{const f=b.readdirSync(I).filter(g=>g.toLowerCase()===M);if(f.length===1){const g=P(I);if(g)return R.join(g,f[0])}else if(f.length>1){const g=f.indexOf(M);if(g>=0){const D=P(I);if(D)return R.join(D,f[g])}}}catch(w){}return null}e.realcaseSync=P;async function n(i){try{return await b.Promises.realpath(i)}catch(I){const M=y(i);return await b.Promises.access(M,m.constants.R_OK),M}}e.realpath=n;function v(i){try{return m.realpathSync(i)}catch(I){const M=y(i);return m.accessSync(M,m.constants.R_OK),M}}e.realpathSync=v;function y(i){return A.rtrim(R.normalize(i),R.sep)}}),define(Q[115],Z([0,1,59]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function A(n,v,y){let i=!1;return new Promise(I=>{const M=setTimeout(()=>{if(!i)return i=!0,I(0)},y);R(n,v,w=>{if(!i)return i=!0,clearTimeout(M),I(w)})})}e.findFreePort=A;function R(n,v,y){if(v===0)return y(0);const i=new m.Socket;i.once("connect",()=>(P(i),R(n+1,v-1,y))),i.once("data",()=>{}),i.once("error",I=>(P(i),I.code!=="ECONNREFUSED"?R(n+1,v-1,y):y(n))),i.connect(n,"127.0.0.1")}function b(n,v,y){let i=!1,I,M=1;const w=m.createServer({pauseOnConnect:!0});function f(g,D){i||(i=!0,w.removeAllListeners(),w.close(),I&&clearTimeout(I),D(g))}return new Promise(g=>{I=setTimeout(()=>{f(0,g)},y),w.on("listening",()=>{f(n,g)}),w.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&M<v?(n++,M++,w.listen(n,"127.0.0.1")):f(0,g)}),w.on("close",()=>{f(0,g)}),w.listen(n,"127.0.0.1")})}e.findFreePortFaster=b;function P(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(v){console.error(v)}}});var Oe=this&&this.__await||function($){return this instanceof Oe?(this.v=$,this):new Oe($)},wt=this&&this.__asyncGenerator||function($,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=m.apply($,e||[]),R,b=[];return R={},P("next"),P("throw"),P("return"),R[Symbol.asyncIterator]=function(){return this},R;function P(M){A[M]&&(R[M]=function(w){return new Promise(function(f,g){b.push([M,w,f,g])>1||n(M,w)})})}function n(M,w){try{v(A[M](w))}catch(f){I(b[0][3],f)}}function v(M){M.value instanceof Oe?Promise.resolve(M.value.v).then(y,i):I(b[0][2],M)}function y(M){n("next",M)}function i(M){n("throw",M)}function I(M,w){M(w),b.shift(),b.length&&n(b[0][0],b[0][1])}},pt=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],m;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),m={},A("next"),A("throw"),A("return"),m[Symbol.asyncIterator]=function(){return this},m);function A(b){m[b]=$[b]&&function(P){return new Promise(function(n,v){P=$[b](P),R(n,v,P.done,P.value)})}}function R(b,P,n,v){Promise.resolve(v).then(function(y){b({value:y,done:n})},P)}};define(Q[116],Z([0,1,17,26,8]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,P=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var v;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(v||(v={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function M({useAlternateBitness:a=!1}={}){return a?y===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:a=!1,findPreview:l=!1}={}){const t=M({useAlternateBitness:a});if(!t)return null;const r=R.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(r))return null;let s=-1,o=null;for(const d of await m.Promises.readdir(r)){let S=-1;if(l){const _=d.indexOf("-");if(_<0)continue;const H=d.substring(0,_);if(!b.test(H)||d.substring(_+1)!=="preview")continue;S=parseInt(H,10)}else{if(!b.test(d))continue;S=parseInt(d,10)}if(S<=s)continue;const L=R.join(r,d,"pwsh.exe");!await m.SymlinkSupport.existsFile(L)||(o=L,s=S)}if(!o)return null;const h=t.includes("x86")?" (x86)":"",p=l?" Preview":"";return new I(o,`PowerShell${p}${h}`,!0)}async function f({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await m.Promises.readdir(l))if(t.test(s)){const o=R.join(l,s,"pwsh.exe");return new I(o,r)}return null}function g(){const a=R.join(A.homedir(),".dotnet","tools","pwsh.exe");return new I(a,".NET Core PowerShell Global Tool")}function D(){const a=R.join(process.env.windir,y===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(a,"Windows PowerShell",!0)}function E(){return wt(this,arguments,function*(){let l=yield Oe(w());l&&(yield yield Oe(l)),l=yield Oe(w({useAlternateBitness:!0})),l&&(yield yield Oe(l)),l=yield Oe(f()),l&&(yield yield Oe(l)),l=g(),l&&(yield yield Oe(l)),l=yield Oe(w({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(f({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(w({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield Oe(l)),l=D(),l&&(yield yield Oe(l))})}function c(){return wt(this,arguments,function*(){var l,t;try{for(var r=pt(E()),s;s=yield Oe(r.next()),!s.done;){const o=s.value;(yield Oe(o.exists()))&&(yield yield Oe(o))}}catch(o){l={error:o}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=c;async function u(){var a,l;try{for(var t=pt(c()),r;r=await t.next(),!r.done;)return r.value}catch(s){a={error:s}}finally{try{r&&!r.done&&(l=t.return)&&await l.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(Q[84],Z([0,1,41,10]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(P){return new Promise((n,v)=>{let y;const i=new Map;function I(w,f,g,D,E){const c=i.get(f);if(w===P||c){const u={name:M(g),cmd:g,pid:w,ppid:f,load:D,mem:E};i.set(w,u),w===P&&(y=u),c&&(c.children||(c.children=[]),c.children.push(u),c.children.length>1&&(c.children=c.children.sort((a,l)=>a.pid-l.pid)))}}function M(w){const f=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,E=/\\pipe\\winpty-control/,c=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(g.exec(w))return"watcherService ";if(D.exec(w))return"electron-crash-reporter";if(E.exec(w))return"winpty-process";if(c.exec(w))return"console-window-host (Windows internal process)";let a=u.exec(w);if(a&&a.length===2)return a[1]==="renderer"?f.exec(w)?"shared-process":"window":a[1];const l=/[a-zA-Z-]+\.js/g;let t="";do a=l.exec(w),a&&(t+=a+" ");while(a);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${t}`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,g)=>{$(["windows-process-tree"],f,g)}).then(f=>{f.getProcessList(P,g=>{f.getProcessCpuUsage(g,D=>{const E=new Map;D.forEach(c=>{const u=w(c.commandLine||"");E.set(c.pid,{name:M(u),cmd:u,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),y=E.get(P),y?(E.forEach(c=>{const u=E.get(c.ppid);u&&(u.children||(u.children=[]),u.children.push(c))}),E.forEach(c=>{c.children&&(c.children=c.children.sort((u,a)=>u.pid-a.pid))}),n(y)):v(new Error(`Root process ${P} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[y];const g=[];for(;f.length;){const E=f.shift();E&&(g.push(E.pid),E.children&&(f=f.concat(E.children)))}let D=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);D+=" "+g.join(" "),m.exec(D,{},(E,c,u)=>{if(E||u)v(E||new Error(u.toString()));else{const a=c.toString().split(`
`);for(let l=0;l<g.length;l++){const t=i.get(g[l]);t.load=parseFloat(a[l])}if(!y){v(new Error(`Root process ${P} not found`));return}n(y)}})};m.exec("which ps",{},(f,g,D)=>{if(f||D)if(process.platform!=="linux")v(f||new Error(D.toString()));else{const E=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);m.exec(E,{},(c,u,a)=>{c||a?v(c||new Error(a.toString())):(b(u,I),w())})}else{const E=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";m.exec(`${E} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,a,l)=>{u||l&&!l.includes("screen size is bogus")?v(u||new Error(l.toString())):(b(a,I),process.platform==="linux"?w():y?n(y):v(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=R;function b(P,n){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=P.toString().split(`
`);for(const i of y){const I=v.exec(i.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Q[117],Z([0,1,8,31,3,65,2,17]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function v(I,M,w){return i({path:I,isDirectory:!1},M,w)}e.watchFile=v;function y(I,M,w){return i({path:I,isDirectory:!0},M,w)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function i(I,M,w){const f=m.basename(I.path),g=new Map;let D=!1,E=[P.toDisposable(()=>{g.forEach(c=>P.dispose(c)),g.clear()})];try{const c=A.watch(I.path);E.push(P.toDisposable(()=>{c.removeAllListeners(),c.close()}));const u=new Set;I.isDirectory&&n.Promises.readdir(I.path).then(a=>a.forEach(l=>u.add(l))),c.on("error",(a,l)=>{D||w(`Failed to watch ${I.path} for changes using fs.watch() (${a}, ${l})`)}),c.on("change",(a,l)=>{if(D)return;let t="";if(l&&(t=l.toString(),R.isMacintosh&&(t=b.normalizeNFC(t))),!t||a!=="change"&&a!=="rename")return;const r=I.isDirectory?m.join(I.path,t):I.path;if(I.isDirectory)if(a==="rename"){const s=g.get(r);s&&P.dispose(s);const o=setTimeout(async()=>{g.delete(r);const h=await n.Promises.exists(r);if(D)return;let p;h?u.has(t)?p="changed":(p="added",u.add(t)):(u.delete(t),p="deleted"),M(p,r)},e.CHANGE_BUFFER_DELAY);g.set(r,P.toDisposable(()=>clearTimeout(o)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),M(s,r)}else if(a==="rename"||t!==f){const s=setTimeout(async()=>{const o=await n.Promises.exists(r);D||(o?(M("changed",r),E=[i(I,M,w)]):M("deleted",r))},e.CHANGE_BUFFER_DELAY);P.dispose(E),E=[P.toDisposable(()=>clearTimeout(s))]}else M("changed",r)})}catch(c){n.Promises.exists(I.path).then(u=>{u&&!D&&w(`Failed to watch ${I.path} for changes using fs.watch() (${c.toString()})`)})}return P.toDisposable(()=>{D=!0,E=P.dispose(E)})}}),define(Q[118],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[119],Z([0,1,14,118,13]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){m.ipcMain.on(A.CONTEXT_MENU_CHANNEL,(n,v,y,i,I)=>{const M=P(n,i,y);M.popup({window:R.withNullAsUndefined(m.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{M&&n.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,v)}})})}e.registerContextMenuListener=b;function P(n,v,y){const i=new m.Menu;return y.forEach(I=>{let M;I.type==="separator"?M=new m.MenuItem({type:I.type}):Array.isArray(I.submenu)?M=new m.MenuItem({submenu:P(n,v,I.submenu),label:I.label}):M=new m.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(w,f,g)=>n.sender.send(v,I.id,g)}),i.append(M)}),i}});var he=this&&this.__decorate||function($,e,m,A){var R=arguments.length,b=R<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,m):A,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate($,e,m,A);else for(var n=$.length-1;n>=0;n--)(P=$[n])&&(b=(R<3?P(b):R>3?P(e,m,b):P(e,m))||b);return R>3&&b&&Object.defineProperty(e,m,b),b};define(Q[34],Z([0,1,5,2,9,25,22,16,36,13,110,23,46]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function f(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class c{constructor(T){this.buffer=T,this.pos=0}read(T){const O=this.buffer.slice(this.pos,this.pos+T);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var a;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(a||(a={}));function l(F){const T=n.VSBuffer.alloc(4);return T.writeUInt32BE(F,0),T}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const T=n.VSBuffer.alloc(1);return T.writeUInt8(F,0),T}const s={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},o=typeof Buffer!="undefined";function h(F,T){if(typeof T=="undefined")F.write(s.Undefined);else if(typeof T=="string"){const O=n.VSBuffer.fromString(T);F.write(s.String),F.write(l(O.byteLength)),F.write(O)}else if(o&&Buffer.isBuffer(T)){const O=n.VSBuffer.wrap(T);F.write(s.Buffer),F.write(l(O.byteLength)),F.write(O)}else if(T instanceof n.VSBuffer)F.write(s.VSBuffer),F.write(l(T.byteLength)),F.write(T);else if(Array.isArray(T)){F.write(s.Array),F.write(l(T.length));for(const O of T)h(F,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(T));F.write(s.Object),F.write(l(O.byteLength)),F.write(O)}}function p(F){switch(F.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return F.read(t(F)).toString();case a.Buffer:return F.read(t(F)).buffer;case a.VSBuffer:return F.read(t(F));case a.Array:{const O=t(F),k=[];for(let W=0;W<O;W++)k.push(p(F));return k}case a.Object:return JSON.parse(F.read(t(F)).toString())}}class d{constructor(T,O,k=null,W=1e3){this.protocol=T,this.ctx=O,this.logger=k,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(C=>this.onRawMessage(C)),this.sendResponse({type:200})}registerChannel(T,O){this.channels.set(T,O),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const O=this.send([T.type]);this.logger&&this.logger.logOutgoing(O,0,1,D(T.type));return}case 201:case 202:case 204:case 203:{const O=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(O,T.id,1,D(T.type),T.data);return}}}send(T,O=void 0){const k=new u;return h(k,T),h(k,O),this.sendBuffer(k.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(O){return 0}}onRawMessage(T){const O=new c(T),k=p(O),W=p(O),C=k[0];switch(C){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(C)}: ${k[2]}.${k[3]}`,W),this.onPromise({type:C,id:k[1],channelName:k[2],name:k[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(C)}: ${k[2]}.${k[3]}`,W),this.onEventListen({type:C,id:k[1],channelName:k[2],name:k[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(C)}`),this.disposeActiveRequest({type:C,id:k[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(C)}`),this.disposeActiveRequest({type:C,id:k[1]})}}onPromise(T){const O=this.channels.get(T.channelName);if(!O){this.collectPendingRequest(T);return}const k=new b.CancellationTokenSource;let W;try{W=O.call(this.ctx,T.name,T.arg,k.token)}catch(K){W=Promise.reject(K)}const C=T.id;W.then(K=>{this.sendResponse({id:C,data:K,type:201}),this.activeRequests.delete(T.id)},K=>{K instanceof Error?this.sendResponse({id:C,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:C,data:K,type:203}),this.activeRequests.delete(T.id)});const V=A.toDisposable(()=>k.cancel());this.activeRequests.set(T.id,V)}onEventListen(T){const O=this.channels.get(T.channelName);if(!O){this.collectPendingRequest(T);return}const k=T.id,C=O.listen(this.ctx,T.name,T.arg)(V=>this.sendResponse({id:k,data:V,type:204}));this.activeRequests.set(T.id,C)}disposeActiveRequest(T){const O=this.activeRequests.get(T.id);O&&(O.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let O=this.pendingRequests.get(T.channelName);O||(O=[],this.pendingRequests.set(T.channelName,O));const k=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:T,timeoutTimer:k})}flushPendingRequests(T){const O=this.pendingRequests.get(T);if(O){for(const k of O)switch(clearTimeout(k.timeoutTimer),k.request.type){case 100:this.onPromise(k.request);break;case 102:this.onEventListen(k.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var S;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(T,O=null){this.protocol=T,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(k=>this.onBuffer(k)),this.logger=O}getChannel(T){const O=this;return{call(k,W,C){return O.isDisposed?Promise.reject(P.canceled()):O.requestPromise(T,k,W,C)},listen(k,W){return O.isDisposed?Promise.reject(P.canceled()):O.requestEvent(T,k,W)}}}requestPromise(T,O,k,W=b.CancellationToken.None){const C=this.lastRequestId++,K={id:C,type:100,channelName:T,name:O,arg:k};if(W.isCancellationRequested)return Promise.reject(P.canceled());let q;return new Promise((ne,re)=>{if(W.isCancellationRequested)return re(P.canceled());const se=()=>{const me=be=>{switch(be.type){case 201:this.handlers.delete(C),ne(be.data);break;case 202:this.handlers.delete(C);const De=new Error(be.data.message);De.stack=be.data.stack,De.name=be.data.name,re(De);break;case 203:this.handlers.delete(C),re(be.data);break}};this.handlers.set(C,me),this.sendRequest(K)};let le=null;this.state===E.Idle?se():(le=R.createCancelablePromise(me=>this.whenInitialized()),le.then(()=>{le=null,se()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:C,type:101}),re(P.canceled())},ue=W.onCancellationRequested(oe);q=A.combinedDisposable(A.toDisposable(oe),ue),this.activeRequests.add(q)}).finally(()=>{this.activeRequests.delete(q)})}requestEvent(T,O,k){const W=this.lastRequestId++,V={id:W,type:102,channelName:T,name:O,arg:k};let K=null;const q=new m.Emitter({onFirstListenerAdd:()=>{K=R.createCancelablePromise(ne=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(q),this.sendRequest(V)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(q),this.sendRequest({id:W,type:103}))}}),x=ne=>q.fire(ne.data);return this.handlers.set(W,x),q.event}sendRequest(T){switch(T.type){case 100:case 102:{const O=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(O,T.id,0,`${f(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const O=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(O,T.id,0,f(T.type));return}}}send(T,O=void 0){const k=new u;return h(k,T),h(k,O),this.sendBuffer(k.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(O){return 0}}onBuffer(T){const O=new c(T),k=p(O),W=p(O),C=k[0];switch(C){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,D(C)),this.onResponse({type:k[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],0,D(C),W),this.onResponse({type:k[0],id:k[1],data:W})}}onResponse(T){if(T.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(T.id);O&&O(T)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}he([M.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class _{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:O,onDidClientDisconnect:k})=>{m.Event.once(O.onMessage)(C=>{const V=new c(C),K=p(V),q=new d(O,K),x=new L(O);this.channels.forEach((re,se)=>q.registerChannel(se,re));const ne={channelServer:q,channelClient:x,ctx:K};this._connections.add(ne),this._onDidAddConnection.fire(ne),k(()=>{q.dispose(),x.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const T=[];return this._connections.forEach(O=>T.push(O)),T}getChannel(T,O){const k=this;return{call(W,C,V){let K;if(y.isFunction(O)){let x=v.getRandomElement(k.connections.filter(O));K=x?Promise.resolve(x):m.Event.toPromise(m.Event.filter(k.onDidAddConnection,O))}else K=O.routeCall(k,W,C);const q=K.then(x=>x.channelClient.getChannel(T));return X(q).call(W,C,V)},listen(W,C){if(y.isFunction(O))return k.getMulticastEvent(T,O,W,C);const V=O.routeEvent(k,W,C).then(K=>K.channelClient.getChannel(T));return X(V).listen(W,C)}}}getMulticastEvent(T,O,k,W){const C=this;let V=new A.DisposableStore;const K=new m.Emitter({onFirstListenerAdd:()=>{V=new A.DisposableStore;const q=new m.EventMultiplexer,x=new Map,ne=se=>{const oe=se.channelClient.getChannel(T).listen(k,W),ue=q.add(oe);x.set(se,ue)},re=se=>{const le=x.get(se);!le||(le.dispose(),x.delete(se))};C.connections.filter(O).forEach(ne),m.Event.filter(C.onDidAddConnection,O)(ne,void 0,V),C.onDidRemoveConnection(re,void 0,V),q.event(K.fire,K,V),V.add(q)},onLastListenerRemove:()=>{V.dispose()}});return K.event}registerChannel(T,O){this.channels.set(T,O),this._connections.forEach(k=>{k.channelServer.registerChannel(T,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class H{constructor(T,O,k=null){const W=new u;h(W,O),T.send(W.buffer),this.channelClient=new L(T,k),this.channelServer=new d(T,O,k)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,O){this.channelServer.registerChannel(T,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=H;function X(F){return{call(T,O,k){return F.then(W=>W.call(T,O,k))},listen(T,O){const k=new m.Relay;return F.then(W=>k.input=W.listen(T,O)),k.event}}}e.getDelayedChannel=X;function ee(F){let T=!1;return{call(O,k,W){return T?F.call(O,k,W):R.timeout(0).then(()=>T=!0).then(()=>F.call(O,k,W))},listen(O,k){if(T)return F.listen(O,k);const W=new m.Relay;return R.timeout(0).then(()=>T=!0).then(()=>W.input=F.listen(O,k)),W.event}}}e.getNextTickChannel=ee;class B{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const O of T.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await m.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=B;var J;(function(F){function T(W,C){const V=W,K=C&&C.disableMarshalling,q=new Map;for(const x in V)k(x)&&q.set(x,m.Event.buffer(V[x],!0));return new class{listen(x,ne){const re=q.get(ne);if(re)return re;throw new Error(`Event not found: ${ne}`)}call(x,ne,re){const se=V[ne];if(typeof se=="function"){if(!K&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=i.revive(re[le]);return se.apply(V,re)}throw new Error(`Method not found: ${ne}`)}}}F.fromService=T;function O(W,C){const V=C&&C.disableMarshalling;return new Proxy({},{get(K,q){var x;if(typeof q=="string")return((x=C==null?void 0:C.properties)===null||x===void 0?void 0:x.has(q))?C.properties.get(q):k(q)?W.listen(q):async function(...ne){let re;C&&!y.isUndefinedOrNull(C.context)?re=[C.context,...ne]:re=ne;const se=await W.call(q,re);return V?se:i.revive(se)};throw new Error(`Property not found: ${String(q)}`)}})}F.toService=O;function k(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}})(J=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let T=F.toString();if(T!=="[object Object]")return T}return F}function z(F){return Array.isArray(F)?F.map(U):U(F)}function G(F,T,O,k,W,C,V){V=z(V);const K=Y[W],q=K[k%K.length];let x=[`%c[${F}]%c[${String(T).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(k).padStart(5," ")} - ${C}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(C)?(x=x.concat(V),x.push(")")):x.push(V),console.log.apply(console,x)}e.logWithColors=G;class N{constructor(T,O){this._outgoingPrefix=T,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,O,k,W,C){this._totalOutgoing+=T,G(this._outgoingPrefix,this._totalOutgoing,T,O,k,W,C)}logIncoming(T,O,k,W,C){this._totalIncoming+=T,G(this._incomingPrefix,this._totalIncoming,T,O,k,W,C)}}e.IPCLogger=N}),define(Q[120],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(R,b){this.sender=R,this.onMessage=b}send(R){try{this.sender.send("vscode:message",R.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(Q[121],Z([0,1,5,34,16]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(v){this.port=v,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",y=>R.VSBuffer.wrap(y.data)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class P extends A.IPCClient{constructor(v,y){const i=new b(v);super(i,y);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Q[85],Z([0,1,5,34,2,16,3,33]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var v;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function i(){return y||(y=b.VSBuffer.alloc(0)),y}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,h){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const L=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=o),L}if(this._chunks[0].byteLength>o){const L=this._chunks[0].slice(0,o);return h&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),L}let p=b.VSBuffer.alloc(o),d=0,S=0;for(;o>0;){const L=this._chunks[S];if(L.byteLength>o){const _=L.slice(0,o);p.set(_,d),d+=o,h&&(this._chunks[S]=L.slice(o),this._totalLength-=o),o-=o}else p.set(L,d),d+=L.byteLength,h?(this._chunks.shift(),this._totalLength-=L.byteLength):S++,o-=L.byteLength}return p}}e.ChunkStream=I;var M;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(M||(M={}));var w;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(o,h,p,d){this.type=o,this.id=h,this.ack=p,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends R.Disposable{constructor(o){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const p=this._state.messageType,d=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(p,d,S,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=b.VSBuffer.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this._writeSoon(h,o.data)}_bufferAdd(o,h){const p=this._totalLength===0;return this._data.push(o,h),this._totalLength+=o.byteLength+h.byteLength,p}_bufferTake(){const o=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,h){this._bufferAdd(o,h)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends R.Disposable{constructor(o){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new f(1,0,0,o))}}e.Protocol=E;class c extends A.IPCClient{constructor(o,h,p=null){super(o,h,p);this.protocol=o}static fromSocket(o,h){return new c(new E(o),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=c;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class a{constructor(o){this.data=o,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],h=0,p=this._first;for(;p;)o[h++]=p.data,p=p.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const h=new a(o);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class t{constructor(){this.lastRuns=[];const o=Date.now();for(let h=0;h<t._HISTORY_LENGTH;h++)this.lastRuns[h]=o-1e3*h;setInterval(()=>{for(let h=t._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const o=Date.now(),h=(1+t._HISTORY_LENGTH)*1e3;let p=0;for(let d=0;d<t._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=h&&p++;return 1-p/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(o,h=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=R.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new f(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const h=new f(4,0,0,i());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,h){this._isReconnecting=!0,this._socketDisposables=R.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let h=0,p=o.length;h<p;h++)this._socketWriter.write(o[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new f(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const h=this._outgoingUnackMsg.toArray();for(let p=0,d=h.length;p<d;p++)this._socketWriter.write(h[p]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new f(1,h,this._incomingAckId,o);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(o){const h=new f(2,0,0,o);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const o=this._outgoingUnackMsg.peek(),h=Date.now()-o.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new f(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(Q[122],Z([0,1,14,5,34,120,2,16]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function v(i,I){const M=A.Event.fromNodeEventEmitter(m.ipcMain,I,(f,g)=>({event:f,message:g})),w=A.Event.filter(M,({event:f})=>f.sender.id===i);return A.Event.map(w,({message:f})=>f&&n.VSBuffer.wrap(f))}class y extends R.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const I=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:M})=>M);return A.Event.map(I,M=>{const w=M.id,f=y.Clients.get(w);f&&f.dispose();const g=new A.Emitter;y.Clients.set(w,P.toDisposable(()=>g.fire()));const D=v(w,"vscode:message"),E=A.Event.any(A.Event.signal(v(w,"vscode:disconnect")),g.event);return{protocol:new b.Protocol(M,D),onDidClientDisconnect:E}})}}e.Server=y,y.Clients=new Map}),define(Q[86],Z([0,1,14,5,27,121]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends b.Client{constructor(y,i){super({addEventListener:(I,M)=>y.addListener(I,M),removeEventListener:(I,M)=>y.removeListener(I,M),postMessage:I=>y.postMessage(I),start:()=>y.start(),close:()=>y.close()},i)}}e.Client=P;async function n(v){if(v.isDestroyed()||v.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=R.generateUuid();v.webContents.send("vscode:createMessageChannel",y);const i=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(M,w)=>({nonce:w,port:M.ports[0]})),{port:I}=await A.Event.toPromise(A.Event.once(A.Event.filter(i,M=>M.nonce===y)));return I}e.connect=n}),define(Q[87],Z([0,1,2,5,9,13]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class v extends m.Disposable{constructor(I,M=Object.create(null)){super();this.database=I,this.options=M,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){var M,w;(M=I.changed)===null||M===void 0||M.forEach((f,g)=>this.accept(g,f)),(w=I.deleted)===null||w===void 0||w.forEach(f=>this.accept(f,void 0))}accept(I,M){if(this.state===n.Closed)return;let w=!1;b.isUndefinedOrNull(M)?w=this.cache.delete(I):this.cache.get(I)!==M&&(this.cache.set(I,M),w=!0),w&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,M){const w=this.cache.get(I);return b.isUndefinedOrNull(w)?M:w}getBoolean(I,M){const w=this.get(I);return b.isUndefinedOrNull(w)?M:w==="true"}getNumber(I,M){const w=this.get(I);return b.isUndefinedOrNull(w)?M:parseInt(w,10)}async set(I,M){if(this.state===n.Closed)return;if(b.isUndefinedOrNull(M))return this.delete(I);const w=String(M);if(this.cache.get(I)!==w)return this.cache.set(I,w),this.pendingInserts.set(I,w),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===n.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{var M;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(M=this.whenFlushedCallbacks.pop())===null||M===void 0||M()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((M,w)=>this.items.set(w,M)),I.delete&&I.delete.forEach(M=>this.items.delete(M))}async close(){}}e.InMemoryStorageDatabase=y}),define(Q[123],Z([0,1,5,9,37,8,17]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=b.basename(this.path),this.logger=new v(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return m.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(w=>I.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?R.mapToString(I.insert):"0"}), delete(${I.delete?R.setToString(I.delete):"0"})`),this.transaction(i,()=>{const M=I.insert,w=I.delete;if(M&&M.size>0){const f=[];f.push([]);let g=0;M.forEach((D,E)=>{let c=f[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],f.push(c)),c.push(E,D)}),f.forEach(D=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(D.length/2).fill("(?,?)").join(",")}`,E=>E.run(D),()=>{const E=[];let c=0;return M.forEach((u,a)=>{E.push(a),c+=u.length}),`Keys: ${E.join(", ")} Length: ${c}`})})}if(w&&w.size){const f=[];f.push([]);let g=0;w.forEach(D=>{let E=f[g];E.length>n.MAX_HOST_PARAMETERS&&(g++,E=[],f.push(E)),E.push(D)}),f.forEach(D=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(D.length).fill("?").join(",")})`,E=>E.run(D),()=>{const E=[];return w.forEach(c=>{E.push(c)}),`Keys: ${E.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((M,w)=>{i.db.close(f=>(f&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${f}`),this.path===n.IN_MEMORY_PATH?M():!i.isErroneous&&!i.isInMemory?this.backup().then(M,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),M())):typeof I=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const D=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>D(),E=>(D(),Promise.reject(E)))})).then(M,w):w(f||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return P.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,M=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),w=i?M.integrity_check:M.quick_check;return I.isErroneous?`${w} (last error: ${I.lastError})`:I.isInMemory?`${w} (in-memory!)`:w}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(M){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${M}`),M.code==="SQLITE_BUSY"&&I)return await A.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await P.Promises.unlink(i);try{await P.Promises.rename(this.toBackupPath(i),i)}catch(w){}return await this.doConnect(i)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,M)=>{new Promise((w,f)=>{$(["vscode-sqlite3"],w,f)}).then(w=>{const f={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(i,g=>g?f.db?f.db.close(()=>M(g)):M(g):this.exec(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(f),D=>f.db.close(()=>M(D)))),isInMemory:i===n.IN_MEMORY_PATH};f.db.on("error",g=>this.handleSQLiteError(f,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&f.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},M)})}exec(i,I){return new Promise((M,w)=>{i.db.exec(I,f=>f?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${f}`),w(f)):M())})}get(i,I){return new Promise((M,w)=>{i.db.get(I,(f,g)=>f?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${f}`),w(f)):M(g))})}all(i,I){return new Promise((M,w)=>{i.db.all(I,(f,g)=>f?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${f}`),w(f)):M(g))})}transaction(i,I){return new Promise((M,w)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",f=>f?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${f}`),w(f)):M())})})}prepare(i,I,M,w){const f=i.db.prepare(I),g=D=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${D} (${I}). Details: ${w()}`)};f.on("error",g),M(f),f.finalize(D=>{D&&g(D),f.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class v{constructor(i){i&&typeof i.logTrace=="function"&&process.env[v.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}v.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[124],Z([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(Q[125],Z([0,1,124]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,R=A*60,b=R*24,P=b*7,n=b*30,v=b*365;function y(I,M){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return m.localize(0,null,y(new Date().getTime()+w*1e3,!1));if(w<30)return m.localize(1,null);let f;return w<A?(f=w,M?f===1?m.localize(2,null,f):m.localize(3,null,f):f===1?m.localize(4,null,f):m.localize(5,null,f)):w<R?(f=Math.floor(w/A),M?f===1?m.localize(6,null,f):m.localize(7,null,f):f===1?m.localize(8,null,f):m.localize(9,null,f)):w<b?(f=Math.floor(w/R),M?f===1?m.localize(10,null,f):m.localize(11,null,f):f===1?m.localize(12,null,f):m.localize(13,null,f)):w<P?(f=Math.floor(w/b),M?f===1?m.localize(14,null,f):m.localize(15,null,f):f===1?m.localize(16,null,f):m.localize(17,null,f)):w<n?(f=Math.floor(w/P),M?f===1?m.localize(18,null,f):m.localize(19,null,f):f===1?m.localize(20,null,f):m.localize(21,null,f)):w<v?(f=Math.floor(w/n),M?f===1?m.localize(22,null,f):m.localize(23,null,f):f===1?m.localize(24,null,f):m.localize(25,null,f)):(f=Math.floor(w/v),M?f===1?m.localize(26,null,f):m.localize(27,null,f):f===1?m.localize(28,null,f):m.localize(29,null,f))}e.fromNow=y;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Q[126],Z([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Q[67],Z([0,1,126,13,36]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(y,i){return i&&(y.stack||y.stacktrace)?m.localize(0,null,n(y),P(y.stack)||P(y.stacktrace)):n(y)}function P(y){return Array.isArray(y)?y.join(`
`):y}function n(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?m.localize(1,null,y.message):y.message||m.localize(2,null)}function v(y=null,i=!1){if(!y)return m.localize(3,null);if(Array.isArray(y)){const I=R.coalesce(y),M=v(I[0],i);return I.length>1?m.localize(4,null,M,I.length):M}if(A.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return b(I.error,i);if(I.exception)return b(I.exception,i)}return y.stack?b(y,i):y.message?y.message:m.localize(5,null)}e.toErrorMessage=v}),define(Q[127],Z([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(Q[128],Z([0,1,127]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(P,n,v=n){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=n,this.modifierLabels[3]=v}toLabel(P,n,v){if(n.length===0)return null;const y=[];for(let i=0,I=n.length;i<I;i++){const M=n[i],w=v(M);if(w===null)return null;y[i]=R(M,w,this.modifierLabels[P])}return y.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(b,P,n){if(P===null)return"";const v=[];return b.ctrlKey&&v.push(n.ctrlKey),b.shiftKey&&v.push(n.shiftKey),b.altKey&&v.push(n.altKey),b.metaKey&&v.push(n.metaKey),P!==""&&v.push(P),v.join(n.separator)}}),define(Q[129],Z([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(Q[68],Z([0,1,8,17,41,129,33,13,44,29,3,82,10]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function w(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(a,l){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};l&&(t.cwd=l);const r=R.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(s=>{r.once("error",o=>{s({success:!1,error:o})}),r.once("exit",(o,h)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?w(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{R.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(s,o,h)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function g(a=P.env){return a.comspec||"cmd.exe"}e.getWindowsShell=g;class D{constructor(l,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=l,this.args=t,this.shell=r,this.options=s;else{const o=l;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(P.env).forEach(h=>{o[h]=P.env[h]}),Object.keys(this.options.env).forEach(h=>{o[h]=this.options.env[h]}),this.options.env=o}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const t=l.lastIndexOf(m.sep);return t!==-1&&(l=l.substring(t+1)),D.WellKnowCommands[l]?l:"other"}start(l){return i.isWindows&&(this.options&&this.options.cwd&&y.isUNC(this.options.cwd)||!this.options&&y.isUNC(P.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(t=>{let r,s;const o=new Promise((h,p)=>{r=h,s=p});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=R.exec(h,this.options,(p,d,S)=>{this.childProcess=null;const L=p;L&&L.killed?s({killed:this.terminateRequested,stdout:d.toString(),stderr:S.toString()}):this.handleExec(r,l,p,d,S)})}else{let h=null;const p=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,l,s);const S={terminated:this.terminateRequested};n.isNumber(d)&&(S.cmdCode=d),r(S)};if(this.shell&&i.isWindows){const d=v.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let S=!1,L=!1;const _=[];let H=this.ensureQuotes(this.cmd);_.push(H.value),S=H.quoted,this.args&&this.args.forEach(ee=>{H=this.ensureQuotes(ee),_.push(H.value),L=L&&H.quoted});const X=["/s","/c"];S?L?X.push('"'+_.join(" ")+'"'):_.length>1?X.push('"'+_[0]+'" '+_.slice(1).join(" ")):X.push('"'+_[0]+'"'):X.push(_.join(" ")),h=R.spawn(g(),X,d)}else this.cmd&&(h=R.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(n.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",d=>{this.childProcess=null,s({terminated:this.terminateRequested,error:d})}),h.pid&&(this.childProcess.on("close",p),this.handleSpawn(h,r,l,s,!0)))}return o})}handleClose(l,t,r,s){}ensureQuotes(l){return D.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,f(l,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!i.isWindows)return l(!1);const t=R.spawn(g(),["/s","/c"]);t.on("error",r=>l(!0)),t.on("exit",r=>l(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class E extends D{constructor(l,t,r,s){super(l,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,t,r,s,o){[s,o].forEach((h,p)=>{const d=new I.LineDecoder;d.write(h).forEach(_=>{t({line:_,source:p===0?0:1})});const L=d.end();L&&t({line:L,source:p===0?0:1})}),l({terminated:this.terminateRequested,error:r})}handleSpawn(l,t,r,s,o){const h=new I.LineDecoder,p=new I.LineDecoder;l.stdout.on("data",d=>{h.write(d).forEach(L=>r({line:L,source:0}))}),l.stderr.on("data",d=>{p.write(d).forEach(L=>r({line:L,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=p}handleClose(l,t,r,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=E;function c(a){let l=[],t=!1;const r=function(s){if(t){l.push(s);return}(!a.send(s,h=>{if(h&&console.error(h),t=!1,l.length>0){const p=l.slice(0);l=[],p.forEach(d=>r(d))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=c;var u;(function(a){async function l(t,r,s){if(m.isAbsolute(t))return t;if(r===void 0&&(r=P.cwd()),m.dirname(t)!=="."||(s===void 0&&n.isString(P.env.PATH)&&(s=P.env.PATH.split(m.delimiter)),s===void 0||s.length===0))return m.join(r,t);async function h(p){return await A.Promises.exists(p)?!(await A.Promises.stat(p)).isDirectory():!1}for(let p of s){let d;if(m.isAbsolute(p)?d=m.join(p,t):d=m.join(r,p,t),await h(d))return d;let S=d+".com";if(await h(S)||(S=d+".exe",await h(S)))return S}return m.join(r,t)}a.findExecutable=l})(u=e.win32||(e.win32={}))}),define(Q[130],Z([0,1,26,3,116,68]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(w,f){return w===1?A.isWindows?I():b.getWindowsShell(f):y(w,f)}e.getSystemShell=P;function n(w,f){return w===1?A.isWindows?M(f):b.getWindowsShell(f):y(w,f)}e.getSystemShellSync=n;let v=null;function y(w,f){if(A.isLinux&&w===2||A.isMacintosh&&w===3)return"/bin/bash";if(!v){let g;if(A.isWindows)g="/bin/bash";else{if(g=f.SHELL,!g)try{g=m.userInfo().shell}catch(D){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}v=g}return v}let i=null;async function I(){return i||(i=(await R.getFirstAvailablePowerShellInstallation()).exePath),i}function M(w){if(i)return i;const f=A.isWindows&&parseFloat(m.release())>=10,g=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${w.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?D:b.getWindowsShell(w)}}),define(Q[88],Z([0,1,41,2,9,44,5,68,34,109,25,22,16,3]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends v.ChannelServer{constructor(E){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(u){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",c=>M.VSBuffer.wrap(Buffer.from(c,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=f;class g{constructor(E,c){this.modulePath=E,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new R.Delayer(u),this.child=null,this._client=null}getChannel(E){const c=this;return{call(u,a,l){return c.requestPromise(E,u,a,l)},listen(u,a){return c.requestEvent(E,u,a)}}}requestPromise(E,c,u,a=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(E),t=R.createCancelablePromise(o=>l.call(c,u,o)),r=a.onCancellationRequested(()=>t.cancel()),s=A.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,c,u){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let a;const l=new P.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(E).listen(c,u)(l.fire,l),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env=Object.assign(Object.assign({},b.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(c.env=Object.assign(Object.assign({},c.env),this.options.env)),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),w.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,E,c);const u=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if(y.isRemoteConsoleLog(h)){y.log(h,`IPC Library: ${this.options.serverName}`);return}u.fire(M.VSBuffer.wrap(Buffer.from(h,"base64")))});const l=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=h=>this.child&&this.child.connected&&l.send(h.buffer.toString("base64")),r=u.event,s={send:t,onMessage:r};this._client=new v.ChannelClient(s);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,p)=>{process.removeListener("exit",o),this.activeRequests.forEach(d=>A.dispose(d)),this.activeRequests.clear(),h!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:p})})}return this._client}getCachedChannel(E){let c=this.channels.get(E);return c||(c=this.client.getChannel(E),this.channels.set(E,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Q[131],Z([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(Q[132],Z([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[133],Z([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[134],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(Q[135],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(Q[136],Z([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[137],Z([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[138],Z([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[139],Z([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Q[140],Z([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(Q[141],Z([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Q[142],Z([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[143],Z([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[144],Z([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[145],Z([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[146],Z([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Q[147],Z([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[148],Z([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[149],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(Q[150],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[151],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[152],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[153],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[154],Z([0,1,5,2]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,v,y){switch(v){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(n,v,y){switch(v){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class b extends A.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,v,y){this.channel.call("attach",[n,v,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,v){this.channel.call("terminate",[n,v])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,v,y){return this.channel.call("openExtensionDevelopmentHostWindow",[n,v||{},y])}}e.ExtensionHostDebugChannelClient=b}),define(Q[155],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(P){this.driver=P}listen(P,n){throw new Error(`No event found: ${n}`)}call(P,n,v){switch(n){case"click":return this.driver.click(v[0],v[1],v[2]);case"doubleClick":return this.driver.doubleClick(v);case"setValue":return this.driver.setValue(v[0],v[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(v);case"getElements":return this.driver.getElements(v[0],v[1]);case"getElementXY":return this.driver.getElementXY(v[0],v[1],v[2]);case"typeInEditor":return this.driver.typeInEditor(v[0],v[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(v);case"writeInTerminal":return this.driver.writeInTerminal(v[0],v[1])}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=m;class A{constructor(P){this.channel=P}click(P,n,v){return this.channel.call("click",[P,n,v])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,n){return this.channel.call("setValue",[P,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,n){return this.channel.call("getElements",[P,n])}getElementXY(P,n,v){return this.channel.call("getElementXY",[P,n,v])}typeInEditor(P,n){return this.channel.call("typeInEditor",[P,n])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,n){return this.channel.call("writeInTerminal",[P,n])}}e.WindowDriverChannelClient=A;class R{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=R}),define(Q[156],Z([0,1,8,15,46,125,10,7,33]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(f,g,D){this._args=f,this.paths=g,this.productService=D}get appRoot(){return m.dirname(P.FileAccess.asFileUri("",$).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return A.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return A.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=b.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return A.joinPath(n.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return A.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return A.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=v.env.VSCODE_PORTABLE;return f?n.URI.file(m.join(f,"argv.json")):A.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return A.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?m.resolve(f):m.normalize(m.join(P.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?m.resolve(f):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return m.resolve(f);const g=v.env.VSCODE_EXTENSIONS;if(g)return g;const D=v.env.VSCODE_PORTABLE;return D?m.join(D,"extensions"):A.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(g=>/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file(m.normalize(g)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?n.URI.parse(f):n.URI.file(m.normalize(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!v.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return A.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([R.memoize],y.prototype,"appRoot",null),he([R.memoize],y.prototype,"userHome",null),he([R.memoize],y.prototype,"userDataPath",null),he([R.memoize],y.prototype,"appSettingsHome",null),he([R.memoize],y.prototype,"tmpDir",null),he([R.memoize],y.prototype,"userRoamingDataHome",null),he([R.memoize],y.prototype,"settingsResource",null),he([R.memoize],y.prototype,"userDataSyncHome",null),he([R.memoize],y.prototype,"userDataSyncLogResource",null),he([R.memoize],y.prototype,"sync",null),he([R.memoize],y.prototype,"machineSettingsResource",null),he([R.memoize],y.prototype,"globalStorageHome",null),he([R.memoize],y.prototype,"workspaceStorageHome",null),he([R.memoize],y.prototype,"keybindingsResource",null),he([R.memoize],y.prototype,"keyboardLayoutResource",null),he([R.memoize],y.prototype,"argvResource",null),he([R.memoize],y.prototype,"snippetsHome",null),he([R.memoize],y.prototype,"isExtensionDevelopment",null),he([R.memoize],y.prototype,"untitledWorkspacesHome",null),he([R.memoize],y.prototype,"installSourcePath",null),he([R.memoize],y.prototype,"builtinExtensionsPath",null),he([R.memoize],y.prototype,"extensionsPath",null),he([R.memoize],y.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],y.prototype,"extensionDevelopmentKind",null),he([R.memoize],y.prototype,"extensionTestsLocationURI",null),he([R.memoize],y.prototype,"debugExtensionHost",null),he([R.memoize],y.prototype,"serviceMachineIdResource",null),he([R.memoize],y.prototype,"telemetryLogResource",null),he([R.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function i(w,f){return M(w["inspect-extensions"],w["inspect-brk-extensions"],5870,f,w.debugId)}e.parseExtensionHostPort=i;function I(w,f){return M(w["inspect-search"],w["inspect-brk-search"],5876,f)}e.parseSearchPort=I;function M(w,f,g,D,E){const u=Number(f||w)||(D?null:g),a=u?Boolean(!!f):!1;return{port:u,break:a,debugId:E}}}),define(Q[89],Z([0,1,239,134,3]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:A.localize(0,null),e:A.localize(1,null),t:A.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:A.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:A.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:A.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:A.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:A.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:A.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:A.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:A.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:A.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:A.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:A.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:A.localize(14,null)},category:{type:"string",cat:"e",description:A.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:A.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:A.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:A.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:A.localize(19,null)},verbose:{type:"boolean",cat:"t",description:A.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:A.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:A.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:A.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:A.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:A.localize(25,null)},sync:{type:"string",cat:"t",description:A.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:A.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:A.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:A.localize(29,null)},"max-memory":{type:"string",cat:"t",description:A.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:A.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(f,g,D=P){const E={},c=[],u=[];for(let r in g){const s=g[r];s.alias&&(E[r]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(r),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(u.push(r),s.deprecates&&u.push(s.deprecates))}const a=m(f,{string:c,boolean:u,alias:E}),l={},t=a;l._=a._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in g){const s=g[r];s.alias&&delete t[s.alias];let o=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(o||(o=t[s.deprecates]),delete t[s.deprecates]),typeof o!="undefined"&&(s.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):s.type==="string"&&Array.isArray(o)&&(o=o.pop(),D.onMultipleValues(r,o)),l[r]=o),delete t[r]}for(let r in t)D.onUnknownOption(r);return l}e.parseArgs=n;function v(f,g){let D="";return g.args&&(Array.isArray(g.args)?D=` <${g.args.join("> <")}>`:D=` <${g.args}>`),g.alias?`-${g.alias} --${f}${D}`:`--${f}${D}`}function y(f,g){let D=0,E=[];for(const l in f){const t=f[l],r=v(l,t);D=Math.max(D,r.length),E.push([r,t.description])}let c=D+2+1;if(g-c<25)return E.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=g-c-1,a=[];for(const l of E){let t=l[0],r=I(l[1],u),s=i(c-t.length-2);a.push("  "+t+s+r[0]);for(let o=1;o<r.length;o++)a.push(i(c)+r[o])}return a}e.formatOptions=y;function i(f){return" ".repeat(f)}function I(f,g){let D=[];for(;f.length;){let E=f.length<g?f.length:f.lastIndexOf(" ",g),c=f.slice(0,E).trim();f=f.slice(E),D.push(c)}return D}function M(f,g,D,E,c=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${f} ${D}`];a.push(""),a.push(`${A.localize(32,null)}: ${g} [${A.localize(33,null)}][${A.localize(34,null)}...]`),a.push(""),c&&(R.isWindows?a.push(A.localize(35,null,g)):a.push(A.localize(36,null,g)),a.push(""));const l={};for(const t in E){const r=E[t];if(r.description&&r.cat){let s=l[r.cat];s||(l[r.cat]=s={}),s[t]=r}}for(let t in l){const r=t;let s=l[r];s&&(a.push(b[r]),a.push(...y(s,u)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=M;function w(f,g){return`${f||A.localize(37,null)}
${g||A.localize(38,null)}
${process.arch}`}e.buildVersionMessage=w}),define(Q[157],Z([0,1,89,59,154]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends R.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,v,y){return v==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(n,v,y)}async openExtensionDevelopmentHostWindow(n,v,y){const i=m.parseArgs(n,m.OPTIONS);i.debugRenderer=y;const I=i.extensionDevelopmentPath;if(!I)return{success:!1};let M;const w=Object.keys(v);for(let u of w){let a=v[u];a===null||(M||(M=Object.create(null)),M[u]=a)}const[f]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:i,userEnv:M});if(!y)return{success:!0};const g=f.win;if(!g)return{success:!0};const D=g.webContents.debugger;let E=D.isAttached()?Infinity:0;const c=A.createServer(u=>{E++==0&&D.attach();let a=!1;const l=s=>{a||u.write(JSON.stringify(s)+"\0")},t=(s,o,h,p)=>l({method:o,params:h,sessionId:p});g.on("close",()=>{D.removeListener("message",t),u.end(),a=!0}),D.addListener("message",t);let r=Buffer.alloc(0);u.on("data",s=>{r=Buffer.concat([r,s]);for(let o=r.indexOf(0);o!==-1;o=r.indexOf(0)){let h;try{const p=r.slice(0,o).toString("utf8");r=r.slice(o+1),h=JSON.parse(p)}catch(p){console.error("error reading cdp line",p)}D.sendCommand(h.method,h.params,h.sessionId).then(p=>l({id:h.id,sessionId:h.sessionId,result:p})).catch(p=>l({id:h.id,sessionId:h.sessionId,error:{code:0,message:p.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{a=!0,--E==0&&D.detach()})});return await new Promise(u=>c.listen(0,u)),g.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function $(e,m,A,R){function b(n){const v=P(n),y=[v];return e.isAbsolute(v)||y.unshift(R),e.resolve(...y)}function P(n){const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");const y=n["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(I,"AppData","Roaming")}break;case"darwin":i=e.join(m.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,A)}return{getUserDataPath:b}}if(typeof define=="function")define(Q[158],Z([0,159,26,10,15,33]),function(e,m,A,R,b,P){const n=b.dirname(R.FileAccess.asFileUri("",e)),v=e.__$__nodeRequire(b.joinPath(n,"package.json").fsPath);return $(m,A,v.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),A=require("os");module.exports=$(m,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[160],Z([0,1,26,158,156]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends R.AbstractNativeEnvironmentService{constructor(n,v){super(n,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:A.getUserDataPath(n)},v)}}e.NativeEnvironmentService=b}),define(Q[161],Z([0,1,31,26,8]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(P){const n=R.join(A.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),P&&console.log(`Marker file for --wait created: ${n}`),n}catch(v){P&&console.error(`Failed to create marker file for --wait: ${v}`);return}}e.createWaitMarkerFile=b}),define(Q[162],Z([0,1,137]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function b(M){return M=M.trim(),M==="*"||A.test(M)}e.isValidVersionStr=b;function P(M){if(!b(M))return null;if(M=M.trim(),M==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=M.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=P;function n(M){if(!M)return null;let w=M.majorBase,f=M.majorMustEqual,g=M.minorBase,D=M.minorMustEqual,E=M.patchBase,c=M.patchMustEqual;M.hasCaret&&(w===0||(D=!1),c=!1);let u=0;if(M.preRelease){const a=R.exec(M.preRelease);if(a){const[,l,t,r]=a;u=Date.UTC(Number(l),Number(t)-1,Number(r))}}return{majorBase:w,majorMustEqual:f,minorBase:g,minorMustEqual:D,patchBase:E,patchMustEqual:c,isMinimum:M.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function v(M,w,f){let g;typeof M=="string"?g=n(P(M)):g=M;let D;w instanceof Date?D=w.getTime():typeof w=="string"&&(D=new Date(w).getTime());let E;if(typeof f=="string"?E=n(P(f)):E=f,!g||!E)return!1;let c=g.majorBase,u=g.minorBase,a=g.patchBase,l=E.majorBase,t=E.minorBase,r=E.patchBase,s=E.notBefore,o=E.majorMustEqual,h=E.minorMustEqual,p=E.patchMustEqual;return E.isMinimum?c>l?!0:c<l?!1:u>t?!0:u<t||D&&D<s?!1:a>=r:(c===1&&l===0&&(!o||!h||!p)&&(l=1,t=0,r=0,o=!0,h=!1,p=!1),c<l?!1:c>l?!o:u<t?!1:u>t?!h:a<r?!1:a>r?!p:!(D&&D<s))}e.isValidVersion=v;function y(M,w,f,g){return f.isBuiltin||typeof f.main=="undefined"?!0:I(M,w,f.engines.vscode,g)}e.isValidExtensionVersion=y;function i(M,w,f){return M==="*"||I(w,f,M)}e.isEngineValid=i;function I(M,w,f,g=[]){let D=n(P(f));if(!D)return g.push(m.localize(0,null,f)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return g.push(m.localize(1,null,f)),!1}else if(!D.majorMustEqual)return g.push(m.localize(2,null,f)),!1;return v(M,w,D)?!0:(g.push(m.localize(3,null,M,f)),!1)}}),define(Q[163],Z([0,1,34,88,2,10]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends R.Disposable{constructor(v,y,i,I){super();this.folders=v,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(v.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(v){this.verboseLogging=v,!this.isDisposed&&this.service&&this.service.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${v}`})}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[164],Z([0,1,34,88,2,10]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends R.Disposable{constructor(v,y,i,I,M={}){super();this.folders=v,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=M,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const v=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(v.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(v.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${v}`})}setVerboseLogging(v){this.verboseLogging=v,this.service&&this.service.setVerboseLogging(v)}setFolders(v){this.folders=v,this.service&&this.service.setRoots(v)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[165],Z([0,1,41,82,111,10]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(v,y,i,I,M){this.watchedFolder=v,this.eventCallback=i,this.logCallback=I,this.verboseLogging=M,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(w=>R.parse(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${v}`),this.startWatcher()}startWatcher(){const v=[this.watchedFolder];this.verboseLogging&&v.push("-verbose"),this.handle=m.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,v);const y=new A.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];y.write(i).forEach(M=>{const w=M.split("|");if(w.length===2){const f=Number(w[0]),g=w[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(D=>D(g))){this.verboseLogging&&this.log(g);return}I.push({type:P.changeTypeMap[f],path:g})}else this.log(w[1])}}),I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(v){this.error("process error: "+v.toString())}onExit(v,y){this.handle&&(this.error(`terminated unexpectedly (code: ${v}, signal: ${y})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(v){this.logCallback({type:"error",message:`[File Watcher (C#)] ${v}`})}log(v){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${v}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(Q[166],Z([0,1,165,8,23]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(n,v,y,i){this.onDidFilesChange=v,this.onLogMessage=y,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=R.rtrim(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(Q[69],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(b,P=[],n=!1){this.ctor=b,this.staticArguments=P,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m;const A=(R,...b)=>new m(R,b);e.createSyncDescriptor=A}),define(Q[167],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=m;class A{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let P of this._nodes.values())P.outgoing.size===0&&b.push(P);return b}insertEdge(b,P){const n=this.lookupOrInsertNode(b),v=this.lookupOrInsertNode(P);n.outgoing.set(this._hashFn(P),v),v.incoming.set(this._hashFn(b),n)}removeNode(b){const P=this._hashFn(b);this._nodes.delete(P);for(let n of this._nodes.values())n.outgoing.delete(P),n.incoming.delete(P)}lookupOrInsertNode(b){const P=this._hashFn(b);let n=this._nodes.get(P);return n||(n=new m(b),this._nodes.set(P,n)),n}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[P,n]of this._nodes)b.push(`${P}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return b.join(`
`)}findCycleSlow(){for(let[b,P]of this._nodes){const n=new Set([b]),v=this._findCycle(P,n);if(v)return v}}_findCycle(b,P){for(let[n,v]of b.outgoing){if(P.has(n))return[...P,n].join(" -> ");P.add(n);const y=this._findCycle(v,P);if(y)return y;P.delete(n)}}}e.Graph=A}),define(Q[4],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function v(y){return y[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=v})(m=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function A(n,v,y,i){v[m.DI_TARGET]===v?v[m.DI_DEPENDENCIES].push({id:n,index:y,optional:i}):(v[m.DI_DEPENDENCIES]=[{id:n,index:y,optional:i}],v[m.DI_TARGET]=v)}function R(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const v=function(y,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(v,y,I,!1)};return v.toString=()=>n,m.serviceIds.set(n,v),v}e.createDecorator=R;function b(n){return n}e.refineServiceDecorator=b;function P(n){return function(v,y,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(n,v,i,!0)}}e.optional=P}),define(Q[70],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=m.createDecorator(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=A}),define(Q[90],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=m.createDecorator("encryptionMainService");class A{constructor(b){this.machineId=b}encryption(){return new Promise((b,P)=>$(["vscode-encrypt"],b,P))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(P){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(P){return b}}}e.EncryptionMainService=A}),define(Q[47],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=m.createDecorator("environmentService"),e.INativeEnvironmentService=m.refineServiceDecorator(e.IEnvironmentService)}),define(Q[168],Z([0,1,136,4,10]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=b;var P;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var n;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var v;(function(I){I.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var y;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=A.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(M,w){super(M);this.code=w}}e.ExtensionManagementError=i,e.IExtensionManagementService=A.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=A.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=A.createDecorator("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=m.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=m.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=A.createDecorator("IExtensionManagementCLIService")}),define(Q[169],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=m.createDecorator("extensionUrlTrustService")}),define(Q[170],Z([0,1,23,4]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=R;function b(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=b,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,M){if(typeof I=="undefined"||I===null)return typeof M=="undefined"||M===null;if(typeof M=="undefined"||M===null)return!1;if(typeof I=="string"||typeof M=="string"){let w=typeof I=="string"?I:I.value,f=typeof M=="string"?M:M.value;return m.equalsIgnoreCase(w,f)}return I._lower===M._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function v(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=A.createDecorator("IBuiltinExtensionsScannerService")}),define(Q[171],Z([0,1,23,170]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(w,f){return w.uuid&&f.uuid?w.uuid===f.uuid:w.id===f.id?!0:m.compareIgnoreCase(w.id,f.id)===0}e.areSameExtensions=R;class b{constructor(f,g){this.version=g,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof b?R(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=b;function P(w,f){return`${w}.${f}`}e.getExtensionId=P;function n(w){return w.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function v(w,f){return n(P(w,f))}e.getGalleryExtensionId=v;function y(w,f){const g=[],D=E=>{for(const c of g)if(c.some(u=>R(f(u),f(E))))return c;return null};for(const E of w){const c=D(E);c?c.push(E):g.push([E])}return g}e.groupByExtension=y;function i(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(w){return Object.assign({id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0)},w.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function M(w){const f=new Set;for(const g of w)g.malicious&&f.add(g.id.id);return f}e.getMaliciousExtensionsSet=M}),define(Q[91],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=m.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=m.createDecorator("externalTerminal")}),define(Q[172],Z([0,1,41,8,68,138,17,3,91,10,105]),function($,e,m,A,R,b,P,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=b.localize(0,null);class M{async getDefaultTerminalForPlatforms(){const a=await g.getDefaultTerminalLinuxReady();return{windows:w.getDefaultTerminalWindows(),linux:a,osx:"xterm"}}}class w extends M{openTerminal(a,l){return this.spawnTerminal(m,a,R.getWindowsShell(),l)}spawnTerminal(a,l,t,r){const s=l.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=A.basename(s).toLowerCase();if(o==="cmder"||o==="cmder.exe")return a.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return s.indexOf(" ")>=0&&h.push('""'),h.push(s),(o==="wt"||o==="wt.exe")&&h.push("-d ."),new Promise((p,d)=>{const S=D(process),L=a.spawn(t,h,{cwd:r,env:S});L.on("error",d),L.on("exit",()=>p())})}runInTerminal(a,l,t,r,s){const o="windowsExec"in s&&s.windowsExec?s.windowsExec:w.getDefaultTerminalWindows();return new Promise((h,p)=>{const d=`"${l} - ${I}"`,S=`""${t.join('" "')}" & pause"`,L=["/c","start",d,"/wait",o,"/c",S],_=Object.assign({},D(process),r);Object.keys(_).filter(ee=>_[ee]===null).forEach(ee=>delete _[ee]);const H={cwd:l,env:_,windowsVerbatimArguments:!0};m.spawn(w.CMD,L,H).on("error",ee=>{p(E(ee))}),h(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class f extends M{openTerminal(a,l){return this.spawnTerminal(m,a,l)}runInTerminal(a,l,t,r,s){const o=s.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((h,p)=>{if(o===v.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const d=o===v.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[y.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,$).fsPath,"-t",a||I,"-w",l];for(let X of t)L.push("-a"),L.push(X);if(r)for(let X in r){const ee=r[X];ee===null?(L.push("-u"),L.push(X)):(L.push("-e"),L.push(`${X}=${ee}`))}let _="";const H=m.spawn(f.OSASCRIPT,L);H.on("error",X=>{p(E(X))}),H.stderr.on("data",X=>{_+=X.toString()}),H.on("exit",X=>{if(X===0)h(void 0);else if(_){const ee=_.split(`
`,1);p(new Error(ee[0]))}else p(new Error(b.localize(1,null,d,X)))})}else p(new Error(b.localize(2,null,o)))})}spawnTerminal(a,l,t){const r=l.osxExec||v.DEFAULT_TERMINAL_OSX;return new Promise((s,o)=>{const h=["-a",r];t&&h.push(t);const p=a.spawn("/usr/bin/open",h);p.on("error",o),p.on("exit",()=>s())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class g extends M{openTerminal(a,l){return this.spawnTerminal(m,a,l)}runInTerminal(a,l,t,r,s){const o=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((h,p)=>{let d=[];o.then(S=>{S.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const L=`${c(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;d.push(`''${L}''`);const _=Object.assign({},process.env,r);Object.keys(_).filter(B=>_[B]===null).forEach(B=>delete _[B]);const H={cwd:l,env:_};let X="";const ee=m.spawn(S,d,H);ee.on("error",B=>{p(E(B))}),ee.stderr.on("data",B=>{X+=B.toString()}),ee.on("exit",B=>{if(B===0)h(void 0);else if(X){const J=X.split(`
`,1);p(new Error(J[0]))}else p(new Error(b.localize(4,null,S,B)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{n.isLinux?await P.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,t){const r=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,o)=>{r.then(h=>{const p=D(process),d=a.spawn(h,[],{cwd:t,env:p});d.on("error",o),d.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=b.localize(3,null);function D(u){const a=u.env;return i.sanitizeProcessEnvironment(a),a}function E(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(b.localize(5,null,u.path)):u}function c(u){let a="";for(let l of u)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(Q[18],Z([0,1,140,8,7,4,23,13,37]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=b.createDecorator("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var M;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(M=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=w;function f(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=f;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function D(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=D;var E;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(z,G){super(z);this.code=G}}e.FileSystemProviderError=c;function u(U,z){const G=new c(U.toString(),z);return l(G,z),G}e.createFileSystemProviderError=u;function a(U){return U||u(m.localize(0,null),E.Unknown)}e.ensureFileSystemProviderError=a;function l(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function t(U){if(!U)return E.Unknown;if(U instanceof c)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return E.Unknown;switch(z[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof S)return U.fileOperationResult;switch(t(U)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(z,G,N){this.resource=z,this.operation=G,this.target=N}isOperation(z){return this.operation===z}}e.FileOperationEvent=o;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class p{constructor(z,G){this.changes=z,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of z)switch(N.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>G)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>G)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>G)),this.deleted.set(N.resource,N);break}}contains(z,...G){return this.doContains(z,{includeChildren:!1},...G)}affects(z,...G){return this.doContains(z,{includeChildren:!0},...G)}doContains(z,G,...N){var F,T,O,k,W,C;if(!z)return!1;const V=N.length>0;return!!((!V||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(z))||G.includeChildren&&((T=this.added)===null||T===void 0?void 0:T.findSuperstr(z)))||(!V||N.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(z))||G.includeChildren&&((k=this.updated)===null||k===void 0?void 0:k.findSuperstr(z)))||(!V||N.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(z))||G.includeChildren&&((C=this.deleted)===null||C===void 0?void 0:C.findSuperstr(z))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function d(U,z,G){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==A.sep&&(z+=A.sep),G?P.startsWithIgnoreCase(U,z):U.indexOf(z)===0)}e.isParent=d;class S extends Error{constructor(z,G,N){super(z);this.fileOperationResult=G,this.options=N}}e.FileOperationError=S;class L extends S{constructor(z,G,N){super(z,2,N);this.stat=G}}e.NotModifiedSinceFileOperationError=L;var _;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=X;async function ee(U,z){if(!z.canHandleResource(R.URI.from({scheme:U.scheme})))return new Promise(G=>{const N=z.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===U.scheme&&F.added&&(N.dispose(),G())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return n.isNumber(z)||(z=0),z<B.KB?m.localize(1,null,z.toFixed(0)):z<B.MB?m.localize(2,null,(z/B.KB).toFixed(2)):z<B.GB?m.localize(3,null,(z/B.MB).toFixed(2)):z<B.TB?m.localize(4,null,(z/B.GB).toFixed(2)):m.localize(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var J;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(J=e.Arch||(e.Arch={}));function Y(U){return{maxFileSize:U===0?300*B.MB:16*B.GB,maxHeapSize:U===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=Y}),define(Q[54],Z([0,1,240,135,18,89]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(M,w){const f={onUnknownOption:D=>{console.warn(A.localize(0,null,D))},onMultipleValues:(D,E)=>{console.warn(A.localize(1,null,D,E))}},g=b.parseArgs(M,b.OPTIONS,w?f:void 0);return g.goto&&g._.forEach(D=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),A.localize(2,null))),g["max-memory"]&&m(parseInt(g["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(M){const w=M.findIndex(f=>!/^-/.test(f));if(w>-1)return[...M.slice(0,w),...M.slice(w+1)]}function v(M){let[,...w]=M;process.env.VSCODE_DEV&&(w=n(w)||[]);const f=!I(process.env);return P(w,f)}e.parseMainProcessArgv=v;function y(M){const[,,...w]=M;return P(w,!0)}e.parseCLIProcessArgv=y;function i(M,...w){const f=M.indexOf("--");return f===-1?M.push(...w):M.splice(f,0,...w),M}e.addArg=i;function I(M){return M.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Q[92],Z([0,1,159,41,27,3,54,67,130]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(M,w,f){return w["force-disable-user-env"]?(M.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(M.trace("resolveShellEnv(): skipped (Windows)"),{}):P.isLaunchedFromCli(f)&&!w["force-user-env"]?(M.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(P.isLaunchedFromCli(f)?M.trace("resolveShellEnv(): running (--force-user-env)"):M.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=new Promise(async g=>{const D=setTimeout(()=>{M.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),g({})},1e4);try{const E=await I(M);g(E)}catch(E){M.error(`[resolve shell env] Unable to resolve shell environment (${E}). Proceeding without shell environment...`),g({})}finally{clearTimeout(D)}})),i)}e.resolveShellEnv=y;let i;async function I(M){const w=new Promise(async(f,g)=>{const D=process.env.ELECTRON_RUN_AS_NODE;M.trace("getUnixShellEnvironment#runAsNode",D);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;M.trace("getUnixShellEnvironment#noAttach",E);const c=R.generateUuid().replace(/-/g,"").substr(0,12),u=new RegExp(c+"(.*)"+c),a=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});M.trace("getUnixShellEnvironment#env",a);const l=await v.getSystemShell(b.OS,a);M.trace("getUnixShellEnvironment#shell",l);const t=m.basename(l);let r,s;/^pwsh(-preview)?$/.test(t)?(r=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,s=["-Login","-Command"]):(r=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s=["-ilc"]),M.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),r);const o=A.spawn(l,[...s,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});o.on("error",d=>{M.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(d)),f({})});const h=[];o.stdout.on("data",d=>h.push(d));const p=[];o.stderr.on("data",d=>p.push(d)),o.on("close",(d,S)=>{const L=Buffer.concat(h).toString("utf8");M.trace("getUnixShellEnvironment#raw",L);const _=Buffer.concat(p).toString("utf8");if(_.trim()&&M.trace("getUnixShellEnvironment#stderr",_),d||S)return g(new Error(`Failed to get environment (code ${d}, signal ${S})`));const H=u.exec(L),X=H?H[1]:"{}";try{const ee=JSON.parse(X);D?ee.ELECTRON_RUN_AS_NODE=D:delete ee.ELECTRON_RUN_AS_NODE,E?ee.ELECTRON_NO_ATTACH_CONSOLE=E:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,M.trace("getUnixShellEnvironment#result",ee),f(ee)}catch(ee){M.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(ee)),g(ee)}})});try{return await w}catch(f){return M.error("getUnixShellEnvironment#error",n.toErrorMessage(f)),{}}}}),define(Q[93],Z([0,1,7,18,3]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(v){return v.map(y=>({type:y.type,resource:m.URI.file(y.path)}))}e.toFileChanges=b;function P(v){const y=new n;for(const i of v)y.processEvent(i);return y.normalize()}e.normalizeFileChanges=P;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const i=this.mapPathToChange.get(y.path);if(i){const I=i.type,M=y.type;I===1&&M===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&M===1?i.type=0:I===1&&M===0||(i.type=M)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],i=[];return this.normalized.filter(I=>I.type!==2?(y.push(I),!1):!0).sort((I,M)=>I.path.length-M.path.length).filter(I=>i.some(M=>A.isParent(I.path,M,!R.isLinux))?!1:(i.push(I.path),!0)).concat(y)}}}),define(Q[173],Z([0,1,93,2,17,83,117,9,8]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends A.Disposable{constructor(I,M,w,f){super();this.path=I,this.onDidFilesChange=M,this.onLogMessage=w,this.verboseLogging=f,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:M}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(M)try{w=await b.realpath(w)}catch(f){if(this.onError(f),M.dangling)return}I.isDirectory()?this._register(P.watchFolder(w,(f,g)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:v.join(this.path,v.basename(g))})},f=>this.onError(f))):this._register(P.watchFile(w,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const M=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=m.normalizeFileChanges(M);this.verboseLogging&&w.forEach(f=>{this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`)}),w.length>0&&this.onDidFilesChange(w)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(Q[71],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...R){this._entries=new Map;for(let[b,P]of R)this.set(b,P)}set(R,b){const P=this._entries.get(R);return this._entries.set(R,b),P}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=m}),define(Q[174],Z([0,1,22,167,69,4,71,9]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const v=!1;class y extends Error{constructor(f){var g;super("cyclic dependency between services");this.message=(g=f.findCycleSlow())!==null&&g!==void 0?g:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class i{constructor(f=new P.ServiceCollection,g=!1,D){this._activeInstantiations=new Set,this._services=f,this._strict=g,this._parent=D,this._services.set(b.IInstantiationService,this)}createChild(f){return new i(f,this._strict,this)}invokeFunction(f,...g){let D=M.traceInvocation(f),E=!1;try{return f({get:(u,a)=>{if(E)throw m.illegalState("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(u,D);if(!l&&a!==b.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return l}},...g)}finally{E=!0,D.stop()}}createInstance(f,...g){let D,E;return f instanceof R.SyncDescriptor?(D=M.traceCreation(f.ctor),E=this._createInstance(f.ctor,f.staticArguments.concat(g),D)):(D=M.traceCreation(f),E=this._createInstance(f,g,D)),D.stop(),E}_createInstance(f,g=[],D){let E=b._util.getServiceDependencies(f).sort((a,l)=>a.index-l.index),c=[];for(const a of E){let l=this._getOrCreateServiceInstance(a.id,D);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`);c.push(l)}let u=E.length>0?E[0].index:g.length;if(g.length!==u){console.warn(`[createInstance] First service dependency of ${f.name} at position ${u+1} conflicts with ${g.length} static arguments`);let a=u-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,u)}return new f(...[...g,...c])}_setServiceInstance(f,g){if(this._services.get(f)instanceof R.SyncDescriptor)this._services.set(f,g);else if(this._parent)this._parent._setServiceInstance(f,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let g=this._services.get(f);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):g}_getOrCreateServiceInstance(f,g){let D=this._getServiceInstanceOrDescriptor(f);return D instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,D,g.branch(f,!0)):(g.branch(f,!1),D)}_safeCreateAndCacheServiceInstance(f,g,D){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,g,D)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,g,D){const E=new A.Graph(a=>a.id.toString());let c=0;const u=[{id:f,desc:g,_trace:D}];for(;u.length;){const a=u.pop();if(E.lookupOrInsertNode(a),c++>1e3)throw new y(E);for(let l of b._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${f} depends on ${l.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:l.id,desc:t,_trace:a._trace.branch(l.id,!0)};E.insertEdge(a,r),u.push(r)}}}for(;;){const a=E.roots();if(a.length===0){if(!E.isEmpty())throw new y(E);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}E.removeNode(l)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,g,D=[],E,c){if(this._services.get(f)instanceof R.SyncDescriptor)return this._createServiceInstance(g,D,E,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,g,D,E,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(f,g=[],D,E){if(D){const c=new n.IdleValue(()=>this._createInstance(f,g,E));return new Proxy(Object.create(null),{get(u,a){if(a in u)return u[a];let l=c.value,t=l[a];return typeof t!="function"||(t=t.bind(l),u[a]=t),t},set(u,a,l){return c.value[a]=l,!0}})}else return this._createInstance(f,g,E)}}e.InstantiationService=i;var I;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(I||(I={}));class M{constructor(f,g){this.type=f,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return v?new M(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):M._None}static traceCreation(f){return v?new M(0,f.name):M._None}branch(f,g){let D=new M(2,f.toString());return this._dep.push([f,g,D]),D}stop(){let f=Date.now()-this._start;M._totals+=f;let g=!1;function D(c,u){let a=[],l=new Array(c+1).join("	");for(const[t,r,s]of u._dep)if(r&&s){g=!0,a.push(`${l}CREATES -> ${t}`);let o=D(c+1,s);o&&a.push(o)}else a.push(`${l}uses -> ${t}`);return a.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${M._totals.toFixed(2)}ms)`];(f>2||g)&&console.log(E.join(`
`))}}M._None=new class extends M{constructor(){super(-1,null)}stop(){}branch(){return this}},M._totals=0}),define(Q[175],Z([0,1,22,128,57]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends R.ResolvedKeybinding{constructor(n,v){super();if(v.length===0)throw m.illegalArgument("parts");this._os=n,this._parts=v}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new R.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=b}),define(Q[176],Z([0,1,57,175]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class R extends A.BaseResolvedKeybinding{constructor(P,n){super(n,P.parts)}_keyCodeToUILabel(P){if(this._os===2)switch(P){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(P)}_getLabel(P){return P.isDuplicateModifierCase()?"":this._keyCodeToUILabel(P.keyCode)}_getAriaLabel(P){return P.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(P.keyCode)}_keyCodeToElectronAccelerator(P){if(P>=93&&P<=108)return null;switch(P){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(P)}_getElectronAccelerator(P){return P.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(P.keyCode)}_getUserSettingsLabel(P){if(P.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(P.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(P){return R.getDispatchStr(P)}static getDispatchStr(P){if(P.isModifierKey())return null;let n="";return P.ctrlKey&&(n+="ctrl+"),P.shiftKey&&(n+="shift+"),P.altKey&&(n+="alt+"),P.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(P.keyCode),n}_getSingleModifierDispatchPart(P){return P.keyCode===5&&!P.shiftKey&&!P.altKey&&!P.metaKey?"ctrl":P.keyCode===4&&!P.ctrlKey&&!P.altKey&&!P.metaKey?"shift":P.keyCode===6&&!P.ctrlKey&&!P.shiftKey&&!P.metaKey?"alt":P.keyCode===57&&!P.ctrlKey&&!P.shiftKey&&!P.altKey?"meta":null}}e.USLayoutResolvedKeybinding=R}),define(Q[177],Z([0,1,9]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(R,b){if(R.length===0)return Promise.resolve(!1);const P=[];let n=!1;for(let v of R){if(v===!0)return Promise.resolve(!0);m.isThenable(v)&&P.push(v.then(y=>{y&&(n=!0)},y=>{b(y),n=!0}))}return m.Promises.settled(P).then(()=>n)}e.handleVetos=A}),define(Q[6],Z([0,1,4,2,3,5,67]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=m.createDecorator("logService"),e.ILoggerService=m.createDecorator("loggerService");function n(){return new Date().toISOString()}var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;class y extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class i extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(v.Trace)&&this.log(v.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(v.Debug)&&this.log(v.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(v.Info)&&this.log(v.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(v.Warning)&&this.log(v.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(v.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(v.Error,this.format(s))}else this.log(v.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(v.Critical)&&this.log(v.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let o=t[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}r+=(s>0?" ":"")+o}return r}}e.AbstractMessageLogger=i;class I extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=v.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=v.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=v.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=v.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=v.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=v.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class M extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=v.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=v.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=v.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=v.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=v.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=v.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=M;class w extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=v.Trace&&this.adapter.log(v.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=v.Debug&&this.adapter.log(v.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=v.Info&&this.adapter.log(v.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=v.Warning&&this.adapter.log(v.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=v.Error&&this.adapter.log(v.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=v.Critical&&this.adapter.log(v.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:P.toErrorMessage(t,this.getLevel()<=v.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class f extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class g extends A.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=g;class D extends A.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?v.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class E{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=E;function c(l){if(l.verbose)return v.Trace;if(typeof l.logLevel=="string"){const t=u(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(l){switch(l){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Critical;case"off":return v.Off}}e.parseLogLevel=u;function a(l){switch(l){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Critical:return"critical";case v.Off:return"off"}}e.LogLevelToString=a});var te=this&&this.__param||function($,e){return function(m,A){e(m,A,$)}};define(Q[178],Z([0,1,9,16,40,78,47,18,4,6]),function($,e,m,A,R,b,P,n,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(M){M.ERROR_INVALID_FILE="ERROR_INVALID_FILE",M.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=v.createDecorator(e.UserConfigurationFileServiceId);let I=class{constructor(w,f,g){this.environmentService=w,this.fileService=f,this.logService=g,this.queue=new m.Queue}async updateSettings(w,f){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,w,f))}async doWrite(w,f,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,w.toString(),f);const{value:D,mtime:E,etag:c}=await this.fileService.readFile(w,{atomic:!0});let u=D.toString();const a=[];if(R.parse(u,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(f,u,g)[0];if(l){u=u.substring(0,l.offset)+l.content+u.substring(l.offset+l.length);try{await this.fileService.writeFile(w,A.VSBuffer.fromString(u),{etag:c,mtime:E})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:w,path:f},g,D){return f.length?b.setProperty(g,f,w,D):[{content:JSON.stringify(w,null,D.insertSpaces&&D.tabSize?" ".repeat(D.tabSize):"	"),length:g.length,offset:0}]}};I=he([te(0,P.IEnvironmentService),te(1,n.IFileService),te(2,y.ILogService)],I),e.UserConfigurationFileService=I}),define(Q[94],Z([0,1,6]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(b,P){switch(P){case m.LogLevel.Trace:return b.trace;case m.LogLevel.Debug:return b.debug;case m.LogLevel.Info:return b.info;case m.LogLevel.Warning:return b.warn;case m.LogLevel.Error:return b.error;case m.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class R extends m.AbstractLogger{constructor(P=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(P){this._logger=P;for(const{level:n,args:v}of this.buffer)A(P,n).apply(P,v);this.buffer=[]}_log(P,...n){this._logger?A(this._logger,P).apply(this._logger,n):this.getLevel()<=P&&this.buffer.push({level:P,args:n})}trace(P,...n){this._log(m.LogLevel.Trace,P,...n)}debug(P,...n){this._log(m.LogLevel.Debug,P,...n)}info(P,...n){this._log(m.LogLevel.Info,P,...n)}warn(P,...n){this._log(m.LogLevel.Warning,P,...n)}error(P,...n){this._log(m.LogLevel.Error,P,...n)}critical(P,...n){this._log(m.LogLevel.Critical,P,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(Q[179],Z([0,1,6,18,9,16,15,4,94]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*A.ByteSize.MB;let i=class extends m.AbstractLogger{constructor(w,f,g,D){super();this.name=w,this.resource=f,this.fileService=D,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new R.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=w.stack,this._log(m.LogLevel.Error,this.format(f))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(w,f){this._log(w,this.format(f))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,f){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>y&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(g)),g=""),g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${f}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(g))})}getCurrentTimestamp(){const w=D=>D<10?`0${D}`:D,f=D=>D<10?`00${D}`:D<100?`0${D}`:D,g=new Date;return`${g.getFullYear()}-${w(g.getMonth()+1)}-${w(g.getDate())} ${w(g.getHours())}:${w(g.getMinutes())}:${w(g.getSeconds())}.${f(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,P.joinPath(P.dirname(this.resource),`${P.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(w){return""}}stringifyLogLevel(w){switch(w){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(w){let f="";for(let g=0;g<w.length;g++){let D=w[g];if(typeof D=="object")try{D=JSON.stringify(D)}catch(E){}f+=(g>0?" ":"")+D}return f}};i=he([te(3,A.IFileService)],i),e.FileLogger=i;let I=class extends m.AbstractLoggerService{constructor(w,f,g){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=f,this.fileService=g}doCreateLogger(w,f){const g=new v.BufferLogService(f);return A.whenProviderRegistered(w,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(i,P.basename(w),w,g.getLevel())),g}};I=he([te(0,m.ILogService),te(1,n.IInstantiationService),te(2,A.IFileService)],I),e.FileLoggerService=I}),define(Q[180],Z([0,1,6,5,7]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(M){this.service=M,this.onDidChangeLogLevel=A.Event.buffer(M.onDidChangeLogLevel,!0)}listen(M,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(M,w,f){switch(w){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=b;class P{constructor(M){this.channel=M}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(M){P.setLevel(this.channel,M)}static setLevel(M,w){return M.call("setLevel",w)}}e.LogLevelChannelClient=P;class n{constructor(M){this.loggerService=M,this.loggers=new Map}listen(M,w){throw new Error(`Event not found: ${w}`)}async call(M,w,f){switch(w){case"createLogger":this.createLogger(R.URI.revive(f[0]),f[1]);return;case"log":return this.log(R.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${w}`)}createLogger(M,w){this.loggers.set(M.toString(),this.loggerService.createLogger(M,w))}consoleLog(M,w){let f=console.log;switch(M){case m.LogLevel.Error:f=console.error;break;case m.LogLevel.Warning:f=console.warn;break;case m.LogLevel.Info:f=console.info;break}f.call(console,...w)}log(M,w){const f=this.loggers.get(M.toString());if(!f)throw new Error("Create the logger before logging");for(const[g,D]of w)switch(g){case m.LogLevel.Trace:f.trace(D);break;case m.LogLevel.Debug:f.debug(D);break;case m.LogLevel.Info:f.info(D);break;case m.LogLevel.Warning:f.warn(D);break;case m.LogLevel.Error:f.error(D);break;case m.LogLevel.Critical:f.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class v extends m.AbstractLoggerService{constructor(M,w,f){super(M,w);this.channel=f}createConsoleMainLogger(){return new m.AdapterLogger({log:(M,w)=>{this.channel.call("consoleLog",[M,w])}})}doCreateLogger(M,w,f){return new y(this.channel,M,w,f)}}e.LoggerChannelClient=v;class y extends m.AbstractMessageLogger{constructor(M,w,f,g){super(g==null?void 0:g.always);this.channel=M,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[w,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(M,w){const f=[[M,w]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(M){this.channel.call("log",[this.file,M])}}class i extends m.LogService{constructor(M,w){super(w);this.parent=M,this._register(M.onDidChangeLogLevel(f=>w.setLevel(f)))}setLevel(M){super.setLevel(M),this.parent.setLevel(M)}}e.FollowerLogService=i}),define(Q[95],Z([0,1,6,18]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(v,y,i,I){try{const M=await new Promise((w,f)=>{$(["spdlog"],w,f)});return M.setFlushOn(m.LogLevel.Trace),M.createAsyncRotatingLogger(v,y,i,I)}catch(M){console.error(M)}return null}function b(v,y,i,I){const M=$.__$__nodeRequire("spdlog");return M.setFlushOn(m.LogLevel.Trace),M.createRotatingLogger(v,y,i,I)}e.createRotatingLogger=b;function P(v,y,i){switch(y){case m.LogLevel.Trace:v.trace(i);break;case m.LogLevel.Debug:v.debug(i);break;case m.LogLevel.Info:v.info(i);break;case m.LogLevel.Warning:v.warn(i);break;case m.LogLevel.Error:v.error(i);break;case m.LogLevel.Critical:v.critical(i);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(y,i,I,M){super();this.name=y,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(M),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const y=this.rotating?6:1,i=30/y*A.ByteSize.MB;return R(this.name,this.filepath,i,y).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:M,message:w}of this.buffer)P(this._logger,M,w);this.buffer=[]}})}log(y,i){this._logger?P(this._logger,y,i):this.getLevel()<=y&&this.buffer.push({level:y,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Q[181],Z([0,1,6,15,10,179,95,18,27]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends m.AbstractLoggerService{constructor(I,M){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=M}doCreateLogger(I,M,w){var f;if(I.scheme===R.Schemas.file){const g=new P.SpdLogLogger((w==null?void 0:w.name)||v.generateUuid(),I.fsPath,!(w==null?void 0:w.donotRotate),M);return(w==null?void 0:w.donotUseFormatters)&&g.clearFormatters(),g}else return new b.FileLogger((f=w==null?void 0:w.name)!==null&&f!==void 0?f:A.basename(I),I,M,this.fileService)}};y=he([te(0,m.ILogService),te(1,n.IFileService)],y),e.LoggerService=y}),define(Q[182],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function A(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function R(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function b(P){return!m(P)&&!A(P)&&!R(P)}e.isMenubarMenuItemAction=b}),define(Q[48],Z([0,1,10,3,33,15]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof A.globals.vscode!="undefined"&&typeof A.globals.vscode.context!="undefined"){const n=A.globals.vscode.context.configuration();if(n)P=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof($==null?void 0:$.__$__nodeRequire)=="function"){const n=b.dirname(m.FileAccess.asFileUri("",$));P=$.__$__nodeRequire(b.joinPath(n,"product.json").fsPath);const v=$.__$__nodeRequire(b.joinPath(n,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:v.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.58.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Q[96],Z([0,1,141,16,18,22,48]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,M,w,f,g,D){let E;try{await v(I,M,w,f,g,D)}catch(c){E=c}finally{E&&g.errorTransformer&&(E=g.errorTransformer(E)),typeof E!="undefined"&&w.error(E),w.end()}}e.readFileIntoStream=n;async function v(I,M,w,f,g,D){y(D);const E=await I.open(M,{create:!1});try{y(D);let c=0,u=0,a=g&&typeof g.length=="number"?g.length:void 0,l=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,r=0;do u=await I.read(E,t,l.buffer,r,l.byteLength-r),t+=u,r+=u,c+=u,typeof a=="number"&&(a-=u),r===l.byteLength&&(await w.write(f(l)),l=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),r=0);while(u>0&&(typeof a!="number"||a>0)&&y(D)&&i(c,g));if(r>0){let s=r;typeof a=="number"&&(s=Math.min(r,a)),w.write(f(l.slice(0,s)))}}catch(c){throw R.ensureFileSystemProviderError(c)}finally{await I.close(E)}}function y(I){if(I.isCancellationRequested)throw b.canceled();return!0}function i(I,M){if(M==null?void 0:M.limits){if(typeof M.limits.memory=="number"&&I>M.limits.memory)throw R.createFileSystemProviderError(m.localize(0,null,P.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof M.limits.size=="number"&&I>M.limits.size)throw R.createFileSystemProviderError(m.localize(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[183],Z([0,1,139,72,2,18,5,15,37,36,6,16,64,9,25,10,96,63]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends R.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new w.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);A.mark(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const t=new R.DisposableStore;return t.add(l.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(l))))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),R.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),R.dispose(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){l.push(t)}}),!this.provider.has(a)&&await w.Promises.settled(l)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,l){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return E.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!n.isAbsolutePath(a))throw new b.FileOperationError(m.localize(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=m.localize(1,null,a.toString()),t}return l}async withReadProvider(a){const l=await this.withProvider(a);if(b.hasOpenReadWriteCloseCapability(l)||b.hasReadWriteCapability(l)||b.hasFileReadStreamCapability(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if(b.hasOpenReadWriteCloseCapability(l)||b.hasReadWriteCapability(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(t){throw b.toFileSystemProviderErrorCode(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError(m.localize(2,null,this.resourceForError(a)),1):b.ensureFileSystemProviderError(t)}}async doResolveFile(a,l){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),s=l==null?void 0:l.resolveTo,o=l==null?void 0:l.resolveSingleChildDescendants,h=l==null?void 0:l.resolveMetadata,p=await t.stat(a);let d;return this.toFileStat(t,a,p,void 0,!!h,(S,L)=>(d||(d=v.TernarySearchTree.forUris(()=>!r),d.set(a,!0),y.isNonEmptyArray(s)&&s.forEach(_=>d.set(_,!0))),Boolean(d.findSuperstr(S.resource)||d.get(S.resource))?!0:S.isDirectory&&o?L===1:!1))}async toFileStat(a,l,t,r,s,o){var h;const{providerExtUri:p}=this.getExtUri(a),d={resource:l,name:p.basename(l),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((h=t.permissions)!==null&&h!==void 0?h:0)&b.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:b.etag({mtime:t.mtime,size:t.size})};if(d.isDirectory&&o(d,r)){try{const S=await a.readdir(l),L=await w.Promises.settled(S.map(async([_,H])=>{try{const X=p.joinPath(l,_),ee=s?await a.stat(X):{type:H};return await this.toFileStat(a,X,ee,S.length,s,o)}catch(X){return this.logService.trace(X),null}}));d.children=y.coalesce(L)}catch(S){this.logService.trace(S),d.children=[]}return d}return d}async resolveAll(a){return w.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(t){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(t){return t}return!0}async doValidateCreateFile(a,l){if(!(l==null?void 0:l.overwrite)&&await this.exists(a))throw new b.FileOperationError(m.localize(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=I.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,l);return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,r)),r}async writeFile(a,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,s.dirname(a));let h;if(b.hasReadWriteCapability(r)&&!(l instanceof I.VSBuffer))if(M.isReadableStream(l)){const p=await M.peekStream(l,3);p.ended?h=I.VSBuffer.concat(p.buffer):h=p}else h=M.peekReadable(l,p=>I.VSBuffer.concat(p),3);else h=l;!b.hasOpenReadWriteCloseCapability(r)||b.hasReadWriteCapability(r)&&h instanceof I.VSBuffer?await this.doWriteUnbuffered(r,a,t,h):await this.doWriteBuffered(r,a,t,h instanceof I.VSBuffer?I.bufferToReadable(h):h)}catch(o){throw new b.FileOperationError(m.localize(4,null,this.resourceForError(a),b.ensureFileSystemProviderError(o).toString()),b.toFileOperationResult(o),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,t){if(!!(t==null?void 0:t.unlock)&&!(a.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(l)));let s;try{s=await a.stat(l)}catch(o){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError(m.localize(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==b.etag({mtime:t.mtime,size:s.size}))throw new b.FileOperationError(m.localize(7,null),3,t);return s}async readFile(a,l){const t=await this.withReadProvider(a);return(l==null?void 0:l.atomic)?this.doReadFileAtomic(t,a,l):this.doReadFile(t,a,l)}async doReadFileAtomic(a,l,t){return new Promise((r,s)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,l,t);r(o)}catch(o){s(o)}})})}async doReadFile(a,l,t){const r=await this.doReadFileStream(a,l,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await I.streamToBuffer(r.value)})}async readFileStream(a,l){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,l)}async doReadFileStream(a,l,t){const r=new f.CancellationTokenSource,s=this.validateReadFile(l,t).then(h=>h,h=>{throw r.cancel(),h});let o;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await s,!(b.hasOpenReadWriteCloseCapability(a)||b.hasFileReadStreamCapability(a))||b.hasReadWriteCapability(a)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(a,l,t):b.hasFileReadStreamCapability(a)?o=this.readFileStreamed(a,l,r.token,t):o=this.readFileBuffered(a,l,r.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:o})}catch(h){o&&await M.consumeStream(o);const p=m.localize(8,null,this.resourceForError(l),b.ensureFileSystemProviderError(h).toString());throw h instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(p,h.stat,t):new b.FileOperationError(p,b.toFileOperationResult(h),t)}}readFileStreamed(a,l,t,r=Object.create(null)){const s=a.readFileStream(l,r,t);return M.transform(s,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>new b.FileOperationError(m.localize(9,null,this.resourceForError(l),b.ensureFileSystemProviderError(o).toString()),b.toFileOperationResult(o),r)},o=>I.VSBuffer.concat(o))}readFileBuffered(a,l,t,r=Object.create(null)){const s=I.newWriteableBufferStream();return D.readFileIntoStream(a,l,s,o=>o,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new b.FileOperationError(m.localize(10,null,this.resourceForError(l),b.ensureFileSystemProviderError(o).toString()),b.toFileOperationResult(o),r)}),t),s}readFileUnbuffered(a,l,t){const r=M.newWriteableStream(s=>I.VSBuffer.concat(s));return(async()=>{try{let s=await a.readFile(l);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(l,s.byteLength,t),r.end(I.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(a,l){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError(m.localize(11,null,this.resourceForError(a)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==b.ETAG_DISABLED&&l.etag===t.etag)throw new b.NotModifiedSinceFileOperationError(m.localize(12,null),t,l);return this.validateReadFileLimits(a,t.size,l),t}validateReadFileLimits(a,l,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&l>t.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError(m.localize(13,null,this.resourceForError(a)),r)}}async canMove(a,l,t){return this.doCanMoveCopy(a,l,"move",t)}async canCopy(a,l,t){return this.doCanMoveCopy(a,l,"copy",t)}async doCanMoveCopy(a,l,t,r){if(a.toString()!==l.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(s,a,o,l,t,r)}catch(s){return s}return!0}async move(a,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(r,a,s,l,"move",!!t),h=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,o==="move"?2:3,h)),h}async copy(a,l,t){const r=await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(r,a,s,l,"copy",!!t),h=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,o==="copy"?3:2,h)),h}async doMoveCopy(a,l,t,r,s,o){if(l.toString()===r.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(a,l,t,r,s,o);if(h&&!p&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(a===t&&b.hasFileFolderCopyCapability(a))await a.copy(l,r,{overwrite:o});else{const d=await this.resolve(l);d.isDirectory?await this.doCopyFolder(a,d,t,r):await this.doCopyFile(a,l,t,r)}return s}else return a===t?(await a.rename(l,r,{overwrite:o}),s):(await this.doMoveCopy(a,l,t,r,"copy",o),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,t,r){if(b.hasOpenReadWriteCloseCapability(a)&&b.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(a,l,t,r);if(b.hasOpenReadWriteCloseCapability(a)&&b.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(a,l,t,r);if(b.hasReadWriteCapability(a)&&b.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(a,l,t,r);if(b.hasReadWriteCapability(a)&&b.hasReadWriteCapability(t))return this.doPipeUnbuffered(a,l,t,r)}async doCopyFolder(a,l,t,r){await t.mkdir(r),Array.isArray(l.children)&&await w.Promises.settled(l.children.map(async s=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(a,await this.resolve(s.resource),t,o):this.doCopyFile(a,s.resource,t,o)}))}async doValidateMoveCopy(a,l,t,r,s,o){let h=!1;if(a===t){const{providerExtUri:d,isPathCaseSensitive:S}=this.getExtUri(a);if(S||(h=d.isEqual(l,r)),h&&s==="copy")throw new Error(m.localize(14,null,this.resourceForError(l),this.resourceForError(r)));if(!h&&d.isEqualOrParent(r,l))throw new Error(m.localize(15,null,this.resourceForError(l),this.resourceForError(r)))}const p=await this.exists(r);if(p&&!h){if(!o)throw new b.FileOperationError(m.localize(16,null,this.resourceForError(l),this.resourceForError(r)),4);if(a===t){const{providerExtUri:d}=this.getExtUri(a);if(d.isEqualOrParent(l,r))throw new Error(m.localize(17,null,this.resourceForError(l),this.resourceForError(r)))}}return{exists:p,isSameResourceWithDifferentPathCase:h}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,t)),t}async mkdirp(a,l){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(l,r.dirname(l));)try{if(((await a.stat(l)).type&b.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(l)));break}catch(s){if(b.toFileSystemProviderErrorCode(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(l)),l=r.dirname(l)}for(let s=t.length-1;s>=0;s--){l=r.joinPath(l,t[s]);try{await a.mkdir(l)}catch(o){if(b.toFileSystemProviderErrorCode(o)!==b.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(t){return t}return!0}async doValidateDelete(a,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(l==null?void 0:l.useTrash)&&!(t.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(a)));let s;try{s=await t.stat(a)}catch(h){}if(s)this.throwIfFileIsReadonly(a,s);else throw new b.FileOperationError(m.localize(20,null,this.resourceForError(a)),1);if(!!!(l==null?void 0:l.recursive)){const h=await this.resolve(a);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(a)))}return t}async del(a,l){const t=await this.doValidateDelete(a,l),r=!!(l==null?void 0:l.useTrash),s=!!(l==null?void 0:l.recursive);await t.delete(a,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(a,1))}watch(a,l={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(a,l).then(s=>{t?R.dispose(s):r=()=>R.dispose(s)},s=>this.logService.error(s)),R.toDisposable(()=>r())}async doWatch(a,l){const t=await this.withProvider(a),r=this.toWatchKey(t,a,l),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,l)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,R.toDisposable(()=>{s.count--,s.count===0&&(R.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,l,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>R.dispose(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{var s;const o=await a.open(l,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{M.isReadableStream(r)||M.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(a,o,r):await this.doWriteReadableBufferedQueued(a,o,r)}catch(h){throw b.ensureFileSystemProviderError(h)}finally{await a.close(o)}})}async doWriteStreamBufferedQueued(a,l,t){let r=0,s;if(M.isReadableBufferedStream(t)){if(t.buffer.length>0){const o=I.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,l,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(o,h)=>{M.listenStream(s,{onData:async p=>{s.pause();try{await this.doWriteBuffer(a,l,p,p.byteLength,r,0)}catch(d){return h(d)}r+=p.byteLength,setTimeout(()=>s.resume())},onError:p=>h(p),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,l,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(a,l,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(a,l,t,r,s,o){let h=0;for(;h<r;)h+=await a.write(l,s+h,t.buffer,o+h,r-h)}async doWriteUnbuffered(a,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,t,r))}async doWriteUnbufferedQueued(a,l,t,r){var s;let o;r instanceof I.VSBuffer?o=r:M.isReadableStream(r)?o=await I.streamToBuffer(r):M.isReadableBufferedStream(r)?o=await I.bufferedStreamToBuffer(r):o=I.readableToBuffer(r),await a.writeFile(l,o.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,t,r))}async doPipeBufferedQueued(a,l,t,r){let s,o;try{s=await a.open(l,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const h=I.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,d=0,S=0;do S=await a.read(s,p,h.buffer,d,h.byteLength-d),await this.doWriteBuffer(t,o,h,S,p,d),p+=S,d+=S,d===h.byteLength&&(d=0);while(S>0)}catch(h){throw b.ensureFileSystemProviderError(h)}finally{await w.Promises.settled([typeof s=="number"?a.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,t,r))}async doPipeUnbufferedQueued(a,l,t,r){return t.writeFile(r,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,t,r))}async doPipeUnbufferedToBufferedQueued(a,l,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const o=await a.readFile(l);await this.doWriteBuffer(t,s,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw b.ensureFileSystemProviderError(o)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(a,l,t,r){const s=await I.streamToBuffer(this.readFileBuffered(a,l,f.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new b.FileOperationError(m.localize(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){var t;if(((t=l.permissions)!==null&&t!==void 0?t:0)&b.FilePermission.Readonly)throw new b.FileOperationError(m.localize(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===g.Schemas.file?a.fsPath:a.toString(!0)}};c=he([te(0,i.ILogService)],c),e.FileService=c}),define(Q[184],Z([0,1,2,18,5,3,17,8,15,29,9,6,142,93,164,166,163,173,64,96,36,16]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends m.Disposable{constructor(s,o){var h;super();this.logService=s,this.options=o,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:o,symbolicLink:h}=await P.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(o,h),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(s){try{const o=await P.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),h=[];return await Promise.all(o.map(async p=>{try{let d;p.isSymbolicLink()?d=(await this.stat(v.joinPath(s,p.name))).type:d=this.toType(p),h.push([p.name,d])}catch(d){this.logService.trace(d)}})),h}catch(o){throw this.toFileSystemProviderError(o)}}toType(s,o){let h;return(o==null?void 0:o.dangling)?h=A.FileType.Unknown:s.isFile()?h=A.FileType.File:s.isDirectory()?h=A.FileType.Directory:h=A.FileType.Unknown,o&&(h|=A.FileType.SymbolicLink),h}async readFile(s){try{const o=this.toFilePath(s);return await P.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(s,o,h){const p=c.newWriteableStream(d=>l.VSBuffer.concat(d.map(S=>l.VSBuffer.wrap(S))).buffer);return u.readFileIntoStream(this,s,p,d=>d.buffer,Object.assign(Object.assign({},o),{bufferSize:this.BUFFER_SIZE}),h),p}async writeFile(s,o,h){let p;try{const d=this.toFilePath(s);if(!h.create||!h.overwrite){if(await P.Promises.exists(d)){if(!h.overwrite)throw A.createFileSystemProviderError(M.localize(0,null),A.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw A.createFileSystemProviderError(M.localize(1,null),A.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(s,{create:!0,unlock:h.unlock}),await this.write(p,0,o,0,o.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(s,d)}finally{typeof p=="number"&&await this.close(p)}}async open(s,o){try{const h=this.toFilePath(s);if(A.isFileOpenForWriteOptions(o)&&o.unlock)try{const{stat:S}=await P.SymlinkSupport.stat(h);S.mode&128||await P.Promises.chmod(h,S.mode|128)}catch(S){this.logService.trace(S)}let p;if(A.isFileOpenForWriteOptions(o)){if(b.isWindows)try{await P.Promises.truncate(h,0),p="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}p||(p="w")}else p="r";const d=await P.Promises.open(h,p);return this.mapHandleToPos.set(d,0),A.isFileOpenForWriteOptions(o)&&this.writeHandles.set(d,s),d}catch(h){throw A.isFileOpenForWriteOptions(o)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await P.Promises.fdatasync(s)}catch(o){this.canFlush=!1,this.logService.error(o)}return await P.Promises.close(s)}catch(o){throw this.toFileSystemProviderError(o)}}async read(s,o,h,p,d){const S=this.normalizePos(s,o);let L=null;try{const _=await P.Promises.read(s,h,p,d,S);return typeof _=="number"?L=_:L=_.bytesRead,L}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,S,L)}}normalizePos(s,o){return o===this.mapHandleToPos.get(s)?null:o}updatePos(s,o,h){const p=this.mapHandleToPos.get(s);typeof p=="number"&&(typeof o=="number"||(typeof h=="number"?this.mapHandleToPos.set(s,p+h):this.mapHandleToPos.delete(s)))}async write(s,o,h,p,d){return i.retry(()=>this.doWrite(s,o,h,p,d),100,3)}async doWrite(s,o,h,p,d){const S=this.normalizePos(s,o);let L=null;try{const _=await P.Promises.write(s,h,p,d,S);return typeof _=="number"?L=_:L=_.bytesWritten,L}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),_)}finally{this.updatePos(s,S,L)}}async mkdir(s){try{await P.Promises.mkdir(this.toFilePath(s))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(s,o){try{const h=this.toFilePath(s);await this.doDelete(h,o)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(s,o){o.recursive?await P.Promises.rm(s,P.RimRafMode.MOVE):await P.Promises.unlink(s)}async rename(s,o,h){const p=this.toFilePath(s),d=this.toFilePath(o);if(p!==d)try{await this.validateTargetDeleted(s,o,"move",h.overwrite),await P.Promises.move(p,d)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error(M.localize(2,null,n.basename(p),n.basename(n.dirname(d)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(s,o,h){const p=this.toFilePath(s),d=this.toFilePath(o);if(p!==d)try{await this.validateTargetDeleted(s,o,"copy",h.overwrite),await P.Promises.copy(p,d,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error(M.localize(3,null,n.basename(p),n.basename(n.dirname(d)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(s,o,h,p){const d=this.toFilePath(s),S=this.toFilePath(o);let L=!1;if(!!(this.capabilities&1024)||(L=y.isEqual(d,S,!0)),L&&h==="copy")throw A.createFileSystemProviderError(M.localize(4,null),A.FileSystemProviderErrorCode.FileExists);if(!L&&await P.Promises.exists(S)){if(!p)throw A.createFileSystemProviderError(M.localize(5,null),A.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(s,o){return o.recursive?this.watchRecursive(s,o.excludes):this.watchNonRecursive(s)}watchRecursive(s,o){const h={path:this.toFilePath(s),excludes:o},p=a.insert(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,o,h;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let p,d;((o=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||o===void 0?void 0:o.usePolling)?(p=f.FileWatcher,d=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?b.isWindows?p=g.FileWatcher:p=f.FileWatcher:p=D.FileWatcher,this.recursiveWatcher=new p(this.recursiveFoldersToWatch,S=>this._onDidChangeFile.fire(w.toFileChanges(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===I.LogLevel.Trace,d),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const o=new E.FileWatcher(this.toFilePath(s),p=>this._onDidChangeFile.fire(w.toFileChanges(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return m.combinedDisposable(o,h)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof A.FileSystemProviderError)return s;let o;switch(s.code){case"ENOENT":o=A.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=A.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=A.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=A.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=A.FileSystemProviderErrorCode.NoPermissions;break;default:o=A.FileSystemProviderErrorCode.Unknown}return A.createFileSystemProviderError(s,o)}async toFileSystemProviderWriteError(s,o){let h=this.toFileSystemProviderError(o);if(s&&h.code===A.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await P.SymlinkSupport.stat(this.toFilePath(s));p.mode&128||(h=A.createFileSystemProviderError(o,A.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return h}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Q[19],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=m.createDecorator("productService")}),define(Q[185],Z([0,1,58,6,19]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(n,v){this.productService=n,this.logService=v,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,v){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(v);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",v),!1;const[,i,I]=y;let M=this.trustedExtensionUrlPublicKeys.get(n);if(!M){if(M=this.productService.trustedExtensionUrlPublicKeys[n],!M||M.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...M])}const w=Buffer.from(decodeURIComponent(I),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",v),!1;const f=w.slice(0,6),g=w.readUIntBE(0,6),D=Date.now()-g;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",v),!1;const E=w.slice(6),c=m.createVerify("SHA256");c.write(f),c.write(Buffer.from(i)),c.end();for(let u=0;u<M.length;u++){let a=M[u];if(a!==null){if(typeof a=="string")try{a=m.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),M[u]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,l),M[u]=null;continue}if(c.verify(a,E))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",v),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",v),!1}};b=he([te(0,R.IProductService),te(1,A.ILogService)],b),e.ExtensionUrlTrustService=b}),define(Q[55],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=m.createDecorator("protocolMainService")}),define(Q[186],Z([0,1,2,10,7,47,14,6,37,3,15,27]),function($,e,m,A,R,b,P,n,v,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let M=class extends m.Disposable{constructor(f,g){super();this.logService=g,this.validRoots=v.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(R.URI.file(f.appRoot)),this.addValidFileRoot(R.URI.file(f.extensionsPath)),this.addValidFileRoot(f.globalStorageHome),this.addValidFileRoot(f.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:f}=P.session;f.protocol.registerFileProtocol(A.Schemas.vscodeFileResource,(g,D)=>this.handleResourceRequest(g,D)),f.protocol.interceptFileProtocol(A.Schemas.file,(g,D)=>this.handleFileRequest(g,D)),this._register(m.toDisposable(()=>{f.protocol.unregisterProtocol(A.Schemas.vscodeFileResource),f.protocol.uninterceptProtocol(A.Schemas.file)}))}addValidFileRoot(f){return this.validRoots.get(f)?m.Disposable.None:(this.validRoots.set(f,!0),m.toDisposable(()=>this.validRoots.delete(f)))}handleFileRequest(f,g){const D=R.URI.parse(f.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${A.Schemas.file}: protocol (original URL: ${f.url})`),g({error:-3})):this.validRoots.findSubstr(D)?g({path:D.fsPath}):this.validExtensions.has(i.extname(D))?g({path:D.fsPath}):(this.logService.error(`${A.Schemas.file}: Refused to load resource ${D.fsPath} from ${A.Schemas.file}: protocol (original URL: ${f.url})`),g({error:-3}))}handleResourceRequest(f,g){const D=R.URI.parse(f.url),E=A.FileAccess.asFileUri(D);return this.validRoots.findSubstr(E)?g({path:E.fsPath}):this.validExtensions.has(i.extname(E))?g({path:E.fsPath}):(this.logService.error(`${A.Schemas.vscodeFileResource}: Refused to load resource ${E.fsPath} from ${A.Schemas.vscodeFileResource}: protocol (original URL: ${f.url})`),g({error:-3}))}createIPCObjectUrl(){let f;const g=R.URI.from({scheme:"vscode",path:I.generateUuid()}),D=g.toString(),E=async()=>f;return P.ipcMain.handle(D,E),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:g,update:c=>f=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),P.ipcMain.removeHandler(D)}}}};M=he([te(0,b.INativeEnvironmentService),te(1,n.ILogService)],M),e.ProtocolMainService=M}),define(Q[38],Z([0,1,13,103]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(P,n){A.ok(m.isString(P)),A.ok(m.isObject(n)),A.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,n)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new R}),define(Q[187],Z([0,1,38,5]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class b{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,y){this.schemasById[R(v)]=y,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new b;m.Registry.add(e.Extensions.JSONContribution,P)}),define(Q[49],Z([0,1,132,5,38,13,187]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const v=R.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,c=!0){this.registerConfigurations([E],c)}registerConfigurations(E,c=!0){const u=[];E.forEach(a=>{u.push(...this.validateAndRegisterProperties(a,c,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(E){const c=[],u=a=>{if(a.properties)for(const l in a.properties)c.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,a.properties[l]);a.allOf&&a.allOf.forEach(l=>u(l))};for(const a of E){u(a);const l=this.configurationContributors.indexOf(a);l!==-1&&this.configurationContributors.splice(l,1)}v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(E){const c=[],u=[];for(const a of E)for(const l in a)if(c.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),a[l]);const t={type:"object",default:this.defaultValues[l],description:m.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=a[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(E){const c=[];for(const u of E)for(const a in u)if(c.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const c of E)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,c=!0,u,a=3){var l;a=b.isUndefinedOrNull(E.scope)?a:E.scope;let t=[],r=E.properties;if(r)for(let o in r){if(c&&f(o)){delete r[o];continue}const h=r[o];if(this.updatePropertyDefaultValue(o,h),e.OVERRIDE_PROPERTY_PATTERN.test(o)?h.scope=void 0:(h.scope=b.isUndefinedOrNull(h.scope)?a:h.scope,h.restricted=b.isUndefinedOrNull(h.restricted)?!!((l=u==null?void 0:u.restrictedConfigurations)===null||l===void 0?void 0:l.includes(o)):h.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),t.push(o)}let s=E.allOf;if(s)for(let o of s)t.push(...this.validateAndRegisterProperties(o,c,u,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const c=u=>{let a=u.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let l=u.allOf;l&&l.forEach(c)};c(E)}updateSchema(E,c){switch(e.allSettings.properties[E]=c,c.scope){case 1:e.applicationSettings.properties[E]=c;break;case 2:e.machineSettings.properties[E]=c;break;case 6:e.machineOverridableSettings.properties[E]=c;break;case 3:e.windowSettings.properties[E]=c;break;case 4:e.resourceSettings.properties[E]=c;break;case 5:e.resourceSettings.properties[E]=c,this.resourceLanguageSettingsSchema.properties[E]=c;break}}removeFromSchema(E,c){switch(delete e.allSettings.properties[E],c.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const c=`[${E}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,u),e.allSettings.properties[c]=u,e.applicationSettings.properties[c]=u,e.machineSettings.properties[c]=u,e.machineOverridableSettings.properties[c]=u,e.windowSettings.properties[c]=u,e.resourceSettings.properties[c]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,c){let u=this.defaultValues[E];b.isUndefined(u)&&(u=c.default),b.isUndefined(u)&&(u=M(c.type)),c.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=I;function M(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=M;const w=new y;R.Registry.add(e.Extensions.Configuration,w);function f(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?m.localize(5,null,D):w.getConfigurationProperties()[D]!==void 0?m.localize(6,null,D):null:m.localize(4,null)}e.validateProperty=f;function g(){const D=[],E=w.getConfigurationProperties();for(const c of Object.keys(E))D.push([c,E[c].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=g}),define(Q[20],Z([0,1,44,13,7,38,4,49]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=P.createDecorator("configurationService");function v(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=v;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,s){const o=s?r?s.keys.filter(H=>r.keys.indexOf(H)===-1):[...s.keys]:[],h=r?s?r.keys.filter(H=>s.keys.indexOf(H)===-1):[...r.keys]:[],p=[];if(s&&r){for(const H of r.keys)if(s.keys.indexOf(H)!==-1){const X=E(r.contents,H),ee=E(s.contents,H);m.equals(X,ee)||p.push(H)}}const d=[],S=H=>{const X={};for(const ee of H)for(const B of ee.identifiers)X[l(B)]=ee;return X},L=s?S(s.overrides):{},_=r?S(r.overrides):{};if(Object.keys(L).length)for(const H of o){const X=L[H];X&&d.push([n.overrideIdentifierFromKey(H),X.keys])}if(Object.keys(_).length)for(const H of h){const X=_[H];X&&d.push([n.overrideIdentifierFromKey(H),X.keys])}if(Object.keys(L).length&&Object.keys(_).length)for(const H of p){const X=_[H],ee=L[H];if(X&&ee){const B=I({contents:X.contents,keys:X.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});d.push([n.overrideIdentifierFromKey(H),[...B.added,...B.removed,...B.updated]])}}return{added:o,removed:h,updated:p,overrides:d}}e.compare=I;function M(r,s){const o=[];for(const h of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(h)){const p={};for(const d in r[h])p[d]=r[h][d];o.push({identifiers:[n.overrideIdentifierFromKey(h).trim()],keys:Object.keys(p),contents:w(p,s)})}return o}e.toOverrides=M;function w(r,s){const o=Object.create(null);for(let h in r)f(o,h,r[h],s);return o}e.toValuesTree=w;function f(r,s,o,h){const p=s.split("."),d=p.pop();let S=r;for(let L=0;L<p.length;L++){let _=p[L],H=S[_];switch(typeof H){case"undefined":H=S[_]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${p.slice(0,L+1).join(".")} is ${JSON.stringify(H)}`);return}S=H}if(typeof S=="object"&&S!==null)try{S[d]=o}catch(L){h(`Ignoring ${s} as ${p.join(".")} is ${JSON.stringify(S)}`)}else h(`Ignoring ${s} as ${p.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=f;function g(r,s){const o=s.split(".");D(r,o)}e.removeFromValueTree=g;function D(r,s){const o=s.shift();if(s.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const h=r[o];typeof h=="object"&&!Array.isArray(h)&&(D(h,s),Object.keys(h).length===0&&delete r[o])}}function E(r,s,o){function h(S,L){let _=S;for(const H of L){if(typeof _!="object"||_===null)return;_=_[H]}return _}const p=s.split("."),d=h(r,p);return typeof d=="undefined"?o:d}e.getConfigurationValue=E;function c(r,s,o){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in r?A.isObject(r[h])&&A.isObject(s[h])?c(r[h],s[h],o):o&&(r[h]=s[h]):r[h]=s[h])})}e.merge=c;function u(){const r=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function a(){const r=Object.create(null),s=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let o in s){let h=s[o].default;f(r,o,h,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=a;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,s,o){const h=r.inspect(s),p=r.inspect(o);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Q[188],Z([0,1,40,37,36,13,44,7,49,20,38,2,5]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?y.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?y.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[o],p=r[o];p&&(typeof h=="object"&&typeof p=="object"?(h=P.deepClone(h),this.mergeContents(h,p)):h=p),s[o]=h}return new w(s,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),s=P.deepClone(this.overrides),o=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const p of h.overrides){const[d]=s.filter(S=>R.equals(S.identifiers,p.identifiers));d?this.mergeContents(d.contents,p.contents):s.push(P.deepClone(p))}for(const p of h.keys)o.indexOf(p)===-1&&o.push(p)}return new w(r,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&b.isObject(t[s])&&b.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=P.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),y.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&y.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=w;class f extends w{constructor(){const t=y.getDefaultValues(),r=y.getConfigurationKeys(),s=[];for(const o of Object.keys(t))v.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[v.overrideIdentifierFromKey(o).trim()],keys:Object.keys(t[o]),contents:y.toValuesTree(t[o],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,s)}}e.DefaultConfigurationModel=f;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!b.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:o,overrides:h,restricted:p}=this.doParseRaw(t,r);this._configurationModel=new w(s,o,h),this._restrictedConfigurations=p||[]}doParseContent(t){let r={},s=null,o=[],h=[],p=[];function d(L){Array.isArray(o)?o.push(L):s&&(o[s]=L)}let S={onObjectBegin:()=>{let L={};d(L),h.push(o),o=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{let L=[];d(L),h.push(o),o=L,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:d,onError:(L,_,H)=>{p.push({error:L,offset:_,length:H})}};if(t)try{m.visit(t,S),r=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return r}doParseRaw(t,r){const s=i.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,r);t=o.raw;const h=y.toValuesTree(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),p=Object.keys(t),d=y.toOverrides(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:h,keys:p,overrides:d,restricted:o.restricted}}filter(t,r,s,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const h={},p=[];for(let d in t)if(v.OVERRIDE_PROPERTY_PATTERN.test(d)&&s){const S=this.filter(t[d],r,!1,o);h[d]=S.raw,p.push(...S.restricted)}else{const S=r[d],L=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&p.push(d),(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&(o.skipRestricted&&(S==null?void 0:S.restricted)||(h[d]=t[d]))}return{raw:h,restricted:p}}}e.ConfigurationModelParser=g;class D extends I.Disposable{constructor(t,r,s,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class E{constructor(t,r,s=new w,o=new w,h=new A.ResourceMap,p=new w,d=new A.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=h,this._memoryConfiguration=p,this._memoryConfigurationByResource=d,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new w,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const o=this.getConsolidateConfigurationModel(r,s),h=this.getFolderConfigurationModelForResource(r.resource,s),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),L=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,ee=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(t):p.getValue(t),B=o.getValue(t),J=R.distinct(R.flatten(o.overrides.map(Y=>Y.identifiers))).filter(Y=>o.getOverrideValue(t,Y)!==void 0);return{defaultValue:d,userValue:S,userLocalValue:L,userRemoteValue:_,workspaceValue:H,workspaceFolderValue:X,memoryValue:ee,value:B,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:p.getValue(t),override:r.overrideIdentifier?p.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:J.length?J:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(o=>v.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const h=v.overrideIdentifierFromKey(o),p=this._defaultConfiguration.getKeysForOverrideIdentifier(h),d=t.getKeysForOverrideIdentifier(h),S=[...d.filter(L=>p.indexOf(L)===-1),...p.filter(L=>d.indexOf(L)===-1),...p.filter(L=>!P.equals(this._defaultConfiguration.override(h).getValue(L),t.override(h).getValue(L)))];return[h,S]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:h}=y.compare(this.localUserConfiguration,t),p=[...r,...s,...o];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:h}=y.compare(this.remoteUserConfiguration,t);let p=[...r,...s,...o];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:o,overrides:h}=y.compare(this.workspaceConfiguration,t);let p=[...r,...s,...o];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:o,updated:h,removed:p,overrides:d}=y.compare(s,r);let S=[...o,...h,...p];return(S.length||!s)&&this.updateFolderConfiguration(t,r),{keys:S,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:h,overrides:p}=y.compare(r,void 0);return{keys:[...s,...o,...h],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=s.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:o,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((p,d)=>(p.set(n.URI.revive(d[0]),this.parseConfigurationModel(d[1])),p),new A.ResourceMap);return new E(r,s,new w,o,h,new w,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new w(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const o of l)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,p])=>{const d=A.getOrSet(r,h,new Set);p.forEach(S=>d.add(S))});const s=[];return r.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=c;class u{constructor(t,r,s,o){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(d=>h.add(d)),t.overrides.forEach(([,d])=>d.forEach(S=>h.add(S))),this.affectedKeys=[...h.values()];const p=new w;this.affectedKeys.forEach(d=>p.setValue(d,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=y.toValuesTree({[r]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=u;class a extends u{constructor(t,r,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a}),define(Q[189],Z([0,1,38,49,2,20,188,5,9,15]),function($,e,m,A,R,b,P,n,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(M,w){super();this.settingsResource=M,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,w)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const M=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,M)}getConfigurationData(){return this.configuration.toData()}getValue(M,w){const f=typeof M=="string"?M:void 0,g=b.isConfigurationOverrides(M)?M:b.isConfigurationOverrides(w)?w:{};return this.configuration.getValue(f,g,void 0)}updateValue(M,w,f,g){return Promise.reject(new Error("not supported"))}inspect(M){return this.configuration.inspect(M,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const M=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(M)}onDidChangeUserConfiguration(M){const w=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(M);this.trigger(f,w,1)}onDidDefaultConfigurationChange(M){const w=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,M);this.trigger(f,w,6)}trigger(M,w,f){const g=new P.ConfigurationChangeEvent(M,{data:w},this.configuration);g.source=f,g.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(M){switch(M){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Q[190],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=m.createDecorator("remoteAuthorityResolverService");var A;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(P,n=A.Unknown,v){super(P);this._message=P,this._code=n,this._detail=v,this.isHandled=n===A.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===A.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===A.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}}e.RemoteAuthorityResolverError=R}),define(Q[191],Z([0,1,85,27,2,16,5,190,22,9,25]),function($,e,m,A,R,b,P,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var M;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(M=e.ConnectionType||(e.ConnectionType={}));function w(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(k){const W=new i.CancellationTokenSource;return setTimeout(()=>W.cancel(),k),W.token}function g(k,W){if(k.isCancellationRequested||W.isCancellationRequested)return i.CancellationToken.Cancelled;const C=new i.CancellationTokenSource;return k.onCancellationRequested(()=>C.cancel()),W.onCancellationRequested(()=>C.cancel()),C.token}class D{constructor(W){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((C,V)=>{this._resolvePromise=C,this._rejectPromise=V}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function E(k,W){const C=new D(W);return C.registerDisposable(k.onControlMessage(V=>{const K=JSON.parse(V.toString()),q=G(K);q?C.reject(q):C.resolve(K)})),C.promise}function c(k,W,C,V,K,q){const x=new D(q);return W.connect(C,V,K,(ne,re)=>{x.didTimeout?(ne&&k.error(ne),re==null||re.dispose()):ne||!re?x.reject(ne):x.resolve(re)}),x.promise}function u(k,W){const C=new D(W);return k.then(V=>{C.didTimeout||C.resolve(V)},V=>{C.didTimeout||C.reject(V)}),C.promise}async function a(k,W,C,V){const K=T(k,W);k.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let q;try{q=await c(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,V)}catch(se){throw k.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),k.logService.error(se),se}k.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let x,ne;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(q,null),x=k.reconnectionProtocol,ne=!1):(x=new m.PersistentProtocol(q,null),ne=!0),k.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:k.connectionToken||"00000000000000000000"};x.sendControl(b.VSBuffer.fromString(JSON.stringify(re)));try{const se=await E(x,g(V,f(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}k.logService.trace(`${K} 4/6. received SignRequest control message.`);const le=await u(k.signService.sign(se.data),V),oe={type:"connectionType",commit:k.commit,signedData:le,desiredConnectionType:W};return C&&(oe.args=C),k.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(b.VSBuffer.fromString(JSON.stringify(oe))),{protocol:x,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(k.logService.error(`${K} the handshake timed out. Error:`),k.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${K} received error control message when negotiating connection. Error:`),k.logService.error(se)),ne&&z(x),se}}async function l(k,W,C,V){const K=Date.now(),q=T(k,W),{protocol:x,ownsProtocol:ne}=await a(k,W,C,V),re=new D(V);return re.registerDisposable(x.onControlMessage(se=>{const le=JSON.parse(se.toString()),oe=G(le);oe?(k.logService.error(`${q} received error control message when negotiating connection. Error:`),k.logService.error(oe),ne&&z(x),re.reject(oe)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${O(K)}!`),re.resolve({protocol:x,firstMessage:le}))})),re.promise}async function t(k,W){const{protocol:C}=await l(k,1,void 0,W);return{protocol:C}}async function r(k,W,C){const{protocol:V,firstMessage:K}=await l(k,2,W,C),q=K&&K.debugPort;return{protocol:V,debugPort:q}}async function s(k,W,C){const V=Date.now(),K=T(k,3),{protocol:q}=await a(k,3,W,C);return k.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${O(V)}!`),q}async function o(k,W,C){const{host:V,port:K,connectionToken:q}=await k.addressProvider.getAddress();return{commit:k.commit,host:V,port:K,connectionToken:q,reconnectionToken:W,reconnectionProtocol:C,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function h(k,W,C){try{const V=A.generateUuid(),K=await o(k,V,null),{protocol:q}=await t(K,i.CancellationToken.None);return new Y(k,W,C,V,q)}catch(V){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(V),J.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=h;async function p(k,W){try{const C=A.generateUuid(),V=await o(k,C,null),{protocol:K,debugPort:q}=await r(V,W,i.CancellationToken.None);return new U(k,W,C,K,q)}catch(C){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(C),J.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(C)),C}}e.connectRemoteAgentExtensionHost=p;async function d(k,W){const C=await o(k,A.generateUuid(),null);return await s(C,{port:W},i.CancellationToken.None)}e.connectRemoteAgentTunnel=d;function S(k){return y.createCancelablePromise(W=>new Promise((C,V)=>{const K=setTimeout(C,k*1e3);W.onCancellationRequested(()=>{clearTimeout(K),C()})}))}var L;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(W,C){this.reconnectionToken=W,this.millisSinceLastIncomingData=C,this.type=0}}e.ConnectionLostEvent=_;class H{constructor(W,C,V,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=C,this.durationSeconds=V,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class X{constructor(W,C,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=C,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=X;class ee{constructor(W,C,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=C,this.attempt=V,this.type=4}}e.ConnectionGainEvent=ee;class B{constructor(W,C,V,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=C,this.attempt=V,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class J extends R.Disposable{constructor(W,C,V,K){super();this._connectionType=W,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=C,this.reconnectionToken=V,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(K.onSocketClose(q=>{const x=F(this._connectionType,this.reconnectionToken,!0);q?q.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const q=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${q} received socket timeout event.`),this._beginReconnecting()})),J._instances.push(this),J._permanentFailure&&this._gotoPermanentFailure(J._permanentFailureMillisSinceLastIncomingData,J._permanentFailureAttempt,J._permanentFailureHandled)}static triggerPermanentFailure(W,C,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=C,this._permanentFailureHandled=V,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(J._permanentFailure)return;const W=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const C=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const K=V<C.length?C[V]:C[C.length-1];try{if(K>0){const x=S(K);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,x)),this._options.logService.info(`${W} waiting for ${K} seconds before reconnecting...`);try{await x}catch(ne){}}if(J._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this._options.logService.info(`${W} resolving connection...`);const q=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,f(I)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),J.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),J.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(v.isPromiseCanceledError(q)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),J.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,n.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),J.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!J._permanentFailure)}_gotoPermanentFailure(W,C,V){this._onDidStateChange.fire(new B(this.reconnectionToken,W,C,V)),z(this.protocol)}}J._permanentFailure=!1,J._permanentFailureMillisSinceLastIncomingData=0,J._permanentFailureAttempt=0,J._permanentFailureHandled=!1,J._instances=[];class Y extends J{constructor(W,C,V,K,q){super(1,W,K,q);this.client=this._register(new m.Client(q,{remoteAuthority:C,clientId:V},W.ipcLogger))}async _reconnect(W,C){await t(W,C)}}e.ManagementPersistentConnection=Y;class U extends J{constructor(W,C,V,K,q){super(2,W,V,K);this._startArguments=C,this.debugPort=q}async _reconnect(W,C){await r(W,this._startArguments,C)}}e.ExtensionHostPersistentConnection=U;function z(k){try{k.acceptDisconnect();const W=k.getSocket();k.dispose(),W.dispose()}catch(W){v.onUnexpectedError(W)}}function G(k){if(k&&k.type==="error"){const W=new Error(`Connection error: ${k.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function N(k,W){for(;k.length<W;)k+=" ";return k}function F(k,W,C){return`[remote-connection][${N(w(k),13)}][${W.substr(0,5)}\u2026][${C?"reconnect":"initial"}]`}function T(k,W){return`${F(W,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function O(k){return`${Date.now()-k} ms`}}),define(Q[73],Z([0,1,10]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function A(y){return y.scheme===m.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=A;function R(y){if(!y)return;const i=y.indexOf("+");return i<0?y:y.substr(0,i)}e.getRemoteName=R;function b(y){return y.scheme!==m.Schemas.file&&y.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=b;function P(y){if(y.folders.length)return y.folders.every(i=>b(i.uri))?y.folders[0].uri:void 0;if(y.configuration&&b(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=P;function n(y){var i;return(i=P(y))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function v(y){return P(y)!==void 0}e.isVirtualWorkspace=v}),define(Q[74],Z([0,1,5,3,4,6]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=R.createDecorator("tunnelService");var P;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(M){if(M.scheme!=="http"&&M.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(M.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(M){return e.LOCALHOST_ADDRESSES.indexOf(M)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(M){return e.ALL_INTERFACES_ADDRESSES.indexOf(M)>=0}e.isAllInterfaces=y;function i(M,w){return w?w!==1&&M<1024:!A.isWindows&&M<1024}e.isPortPrivileged=i;let I=class{constructor(w){this.logService=w,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,f){return this._tunnelProvider=w,w?(this._canElevate=f.elevation,this._canMakePublic=f.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async w=>{const f=[],g=Array.from(this._tunnels.values());for(let D of g){const E=Array.from(D.values());for(let c of E){const u=await c.value;u&&f.push(u)}}w(f)})}async dispose(){for(const w of this._tunnels.values()){for(const{value:f}of w.values())await f.then(g=>g==null?void 0:g.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,f,g,D,E=!1,c=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${g} on local port ${D}.`),!w)return;f||(f="localhost");const u=this.retainOrCreateTunnel(w,f,g,D,E,c);return u?u.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(a);return(a.tunnelRemoteHost!==f||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,public:w.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const f=this._tunnels.get(w.tunnelRemoteHost);if(f){const g=f.get(w.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,g))}}}}async tryDisposeTunnel(w,f,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${f}.`);const D=g.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(f),D}}async closeTunnel(w,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${f} `);const g=this._tunnels.get(w);if(g&&g.has(f)){const D=g.get(f);D.refcount=0,await this.tryDisposeTunnel(w,f,D)}}addTunnelToMap(w,f,g){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(f,{refcount:1,value:g})}async removeEmptyTunnelFromMap(w,f){const g=this._tunnels.get(w);g&&(await g.get(f)||g.delete(f),g.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,f){let g=[w];v(w)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):y(w)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const D=g.map(E=>this._tunnels.get(E));for(const E of D){const c=E==null?void 0:E.get(f);if(c)return c}}canTunnel(w){return!!n(w)}createWithProvider(w,f,g,D,E,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${g} on local port ${D}.`);const a={elevationRequired:E?i(D===void 0?g:D):!1},l={remoteAddress:{host:f,port:g},localAddressPort:D,public:c},t=w.forwardPort(l,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(f,g,t),t}};I=he([te(0,b.ILogService)],I),e.AbstractTunnelService=I}),define(Q[50],Z([0,1,146,4,49,38,16]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=A.createDecorator("requestService");function n(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=n;function v(f){return f.res.statusCode===204}async function y(f){if(!n(f))throw new Error("Server returned "+f.res.statusCode);return v(f)?null:(await P.streamToBuffer(f.stream)).toString()}e.asText=y;async function i(f){if(!n(f))throw new Error("Server returned "+f.res.statusCode);if(v(f))return null;const D=(await P.streamToBuffer(f.stream)).toString();try{return JSON.parse(D)}catch(E){throw E.message+=`:
`+D,E}}e.asJson=i;function I(f){w(f)}e.updateProxyConfigurationsScope=I;let M;function w(f){const g=b.Registry.as(R.Extensions.Configuration);M&&g.deregisterConfigurations([M]),M={id:"http",order:15,title:m.localize(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},g.registerConfiguration(M)}w(2)}),define(Q[192],Z([0,1,193,13]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(P,n){return P.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:P.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function b(P,n,v={}){const y=m.parse(P),i=v.proxyUrl||R(y,n);if(!i)return null;const I=m.parse(i);if(!/^https?:$/.test(I.protocol||""))return null;const M={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:A.isBoolean(v.strictSSL)?v.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((w,f)=>{$(["http-proxy-agent"],w,f)}))(M):new(await new Promise((w,f)=>{$(["https-proxy-agent"],w,f)}))(M)}e.getProxyAgent=b}),define(Q[194],Z([0,1,27,16]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(b,P,n){let v=n&&n.get("storage.serviceMachineId",0)||null;if(v)return v;try{const i=(await P.readFile(b.serviceMachineIdResource)).value.toString();v=m.isUUID(i)?i:null}catch(y){v=null}if(!v){v=m.generateUuid();try{await P.writeFile(b.serviceMachineIdResource,A.VSBuffer.fromString(v))}catch(y){}}return n&&n.store("storage.serviceMachineId",v,0,1),v}e.getServiceMachineId=R}),define(Q[75],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=m.createDecorator(e.SIGN_SERVICE_ID)}),define(Q[195],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((R,b)=>$(["vsda"],R,b))}async sign(R){try{const b=await this.vsda(),P=new b.signer;if(P)return P.sign(R)}catch(b){}return R}}e.SignService=m}),define(Q[39],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=m.createDecorator("stateMainService")}),define(Q[21],Z([0,1,14,6,39,5,4,177,3,2,9,13,33]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=P.createDecorator("lifecycleMainService");var w;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(w=e.UnloadReason||(e.UnloadReason={}));var f;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(f=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let g=class lt extends y.Disposable{constructor(E,c){super();this.logService=E,this.stateMainService=c,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),v.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",E);const c=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!v.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",c),m.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",E),m.app.removeListener("window-all-closed",c),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(c){E.push(c)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(E)}catch(c){this.logService.error(c)}try{await this.stateMainService.close()}catch(c){this.logService.error(c)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const c=this.phaseWhen.get(this._phase);c&&(c.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let c=this.phaseWhen.get(E);c||(c=new i.Barrier,this.phaseWhen.set(E,c)),await c.wait()}registerWindow(E){const c=new y.DisposableStore;this.windowCounter++,c.add(E.onWillLoad(a=>this._onWillLoadWindow.fire({window:E,workspace:a.workspace})));const u=I.assertIsDefined(E.win);u.on("close",a=>{const l=E.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),a.preventDefault(),this.unload(E,1).then(t=>{if(t){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(E),E.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,c.dispose(),this.windowCounter===0&&(!v.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,c){await this.unload(E,3)||E.reload(c)}async unload(E,c){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const u=this._quitRequested?2:c;let a=await this.onBeforeUnloadWindowInRenderer(E,u);return a?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(a)):(a=await this.onBeforeUnloadWindowInMain(E,u),a?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(a)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,u),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,c){return new Promise(u=>{const a=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${a}`,t=`vscode:cancel${a}`;m.ipcMain.once(l,()=>{u(!1)}),m.ipcMain.once(t,()=>{u(!0)}),E.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:t,reason:c})})}onBeforeUnloadWindowInMain(E,c){const u=[];return this._onBeforeUnloadWindow.fire({reason:c,window:E,veto(a){u.push(a)}}),n.handleVetos(u,a=>this.logService.error(a))}onWillUnloadWindowInRenderer(E,c){return new Promise(u=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(l,()=>u()),E.send("vscode:onWillUnload",{replyChannel:l,reason:c})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(c=>{this.pendingQuitPromiseResolve=c,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const c=process.argv.slice(1);if((E==null?void 0:E.addArgs)&&c.push(...E.addArgs),E==null?void 0:E.removeArgs)for(const l of E.removeArgs){const t=c.indexOf(l);t>=0&&c.splice(t,1)}const u=()=>{try{if(v.isWindows){const l=M.cwd();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:c})};m.app.once("quit",u),await this.quit(!0)&&m.app.removeListener("quit",u)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const c of m.BrowserWindow.getAllWindows())if(c&&!c.isDestroyed()){let u;c.webContents&&!c.webContents.isDestroyed()?u=new Promise(a=>c.once("closed",a)):u=Promise.resolve(),c.destroy(),await u}})()]),m.app.exit(E)}};g.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",g=he([te(0,A.ILogService),te(1,R.IStateMainService)],g),e.LifecycleMainService=g}),define(Q[196],Z([0,1,4,5,2,21]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=m.createDecorator("keyboardLayoutMainService");let P=class extends R.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((i,I)=>{$(["native-keymap"],i,I)});this._keyboardLayoutData=n(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=he([te(0,b.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function n(v){const y=v.getKeyMap(),i=v.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:i}}}),define(Q[97],Z([0,1,4,5,2,13,87,9]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";e.IStorageService=m.createDecorator("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class M extends R.Disposable{constructor(D={flushInterval:M.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){R.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,E){E===v?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:E,target:this.getKeyTargets(D)[E]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,E,c){var u;return(u=this.getStorage(E))===null||u===void 0?void 0:u.get(D,c)}getBoolean(D,E,c){var u;return(u=this.getStorage(E))===null||u===void 0?void 0:u.getBoolean(D,c)}getNumber(D,E,c){var u;return(u=this.getStorage(E))===null||u===void 0?void 0:u.getNumber(D,c)}store(D,E,c,u){if(b.isUndefinedOrNull(E)){this.remove(D,c);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(D,c,u),(a=this.getStorage(c))===null||a===void 0||a.set(D,E)})}remove(D,E){this.withPausedEmitters(()=>{var c;this.updateKeyTarget(D,E,void 0),(c=this.getStorage(E))===null||c===void 0||c.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,E){const c=[],u=this.getKeyTargets(D);for(const a of Object.keys(u))u[a]===E&&c.push(a);return c}updateKeyTarget(D,E,c){var u,a;const l=this.getKeyTargets(E);typeof c=="number"?l[D]!==c&&(l[D]=c,(u=this.getStorage(E))===null||u===void 0||u.set(v,JSON.stringify(l))):typeof l[D]=="number"&&(delete l[D],(a=this.getStorage(E))===null||a===void 0||a.set(v,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const E=this.get(v,D);if(E)try{return JSON.parse(E)}catch(c){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,E,c,u;this._onWillSaveState.fire({reason:y.NONE}),await n.Promises.settled([(E=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(u=(c=this.getStorage(1))===null||c===void 0?void 0:c.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var D,E,c,u,a,l;const t=(E=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&E!==void 0?E:new Map,r=(u=(c=this.getStorage(1))===null||c===void 0?void 0:c.items)!==null&&u!==void 0?u:new Map;return f(t,r,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(l=this.getLogDetails(1))!==null&&l!==void 0?l:"")}}e.AbstractStorageService=M,M.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends M{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=w;async function f(g,D,E,c){const u=h=>{try{return JSON.parse(h)}catch(p){return h}},a=new Map,l=new Map;g.forEach((h,p)=>{a.set(p,h),l.set(p,u(h))});const t=new Map,r=new Map;D.forEach((h,p)=>{t.set(p,h),r.set(p,u(h))}),console.group(`Storage: Global (path: ${E})`);let s=[];a.forEach((h,p)=>{s.push({key:p,value:h})}),console.table(s),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${c})`);let o=[];t.forEach((h,p)=>{o.push({key:p,value:h})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=f}),define(Q[197],Z([0,1,3,33,27,7]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(y){if(m.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function n(y,i,I,M,w,f,g,D,E,c){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=R.generateUuid()+Date.now(),u.commitHash=w,u.version=f,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=m.PlatformToString(m.platform),u["common.nodePlatform"]=A.platform,u["common.nodeArch"]=M,u["common.product"]=c||"desktop";const a=v(D||[]);a&&(u["common.msftInternal"]=a);let l=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),m.isLinuxSnap&&(u["common.snap"]="true");const r=P(I);r&&(u["common.platformDetail"]=r);try{const s=await y.readFile(b.URI.file(E));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=n;function v(y){const i=A.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return y.some(M=>I===M)}e.verifyMicrosoftInternalDomain=v}),define(Q[32],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=m.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[198],Z([0,1,26,66,70,8,40,84,19,3,7,32,63,10,18,17]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(l,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,o=new Map,h=2e4;function p(L,_,H,X){const ee=_.substring(L.length+1);return new Promise(async B=>{var J,Y,U;let z;try{z=await g.Promises.readdir(_,{withFileTypes:!0})}catch(F){B();return}if(X.count>=h){X.count+=z.length,X.maxReached=!0,B();return}let G=z.length;if(G===0){B();return}let N=z;X.count+z.length>h&&(X.maxReached=!0,G=h-X.count,N=z.slice(0,G)),X.count+=z.length;for(const F of N)if(F.isDirectory()){if(H.includes(F.name)||await p(L,b.join(_,F.name),H,X),--G==0){B();return}}else{const T=F.name.lastIndexOf(".");if(T>=0){const O=F.name.substring(T+1);O&&s.set(O,((J=s.get(O))!==null&&J!==void 0?J:0)+1)}for(const O of r)((Y=O.relativePathPattern)===null||Y===void 0?void 0:Y.test(ee))!==!1&&O.filePattern.test(F.name)&&o.set(O.tag,((U=o.get(O.tag))!==null&&U!==void 0?U:0)+1);if(--G==0){B();return}}})}const d={count:0,maxReached:!1};await p(l,l,t,d);const S=await u(l);return{configFiles:E(o),fileTypes:E(s),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:S}}e.collectWorkspaceStats=D;function E(l){return[...M.Iterable.map(l.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function c(){const l={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},t=m.cpus();return t&&t.length>0&&(l.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),l}e.getMachineInfo=c;async function u(l){try{const t=new Map,r=b.join(l,".vscode","launch.json"),s=await g.Promises.readFile(r),o=[],h=P.parse(s.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if(P.getNodeType(h)==="object"&&h.configurations)for(const p of h.configurations){const d=p.type;d&&(t.has(d)?t.set(d,t.get(d)+1):t.set(d,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=u;let a=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const s=m.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(m.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||r.push(`Load (avg):       ${m.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([n.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[o,h]=s,p=this.formatProcessList(t,o);return r.forEach(d=>{if(R.isRemoteDiagnosticError(d))p+=`
${d.errorMessage}`,h+=`
${d.errorMessage}`;else if(p+=`

Remote: ${d.hostName}`,d.processes&&(p+=`
${this.formatProcessList(t,d.processes)}`),d.workspaceMetadata){h+=`
|  Remote: ${d.hostName}`;for(const S of Object.keys(d.workspaceMetadata)){const L=d.workspaceMetadata[S];let _=`${L.fileCount} files`;L.maxFilesReached&&(_=`more than ${_}`),h+=`|    Folder (${S}): ${_}`,h+=this.formatWorkspaceStats(L)}}}),{processInfo:p,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:s,vmHint:o,os:h,cpus:p}=c(),d={os:h,memory:s,cpus:p,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return y.isWindows||(d.load=`${m.loadavg().map(S=>Math.round(S)).join(", ")}`),y.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(t,r){const s=[];return n.listProcesses(t.mainPID).then(async o=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,o)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if(R.isRemoteDiagnosticError(h))s.push(`
${h.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${h.hostName}`),s.push(this.formatMachineInfo(h.machineInfo)),h.processes&&s.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const p of Object.keys(h.workspaceMetadata)){const d=h.workspaceMetadata[p];let S=`${d.fileCount} files`;d.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${p}): ${S}`),s.push(this.formatWorkspaceStats(d))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const r=[],s=60;let o=0;const h=(L,_)=>{const H=` ${L}(${_})`;o+H.length>s?(r.push(p),p="|                 ",o=p.length):o+=H.length,p+=H};let p="|      File types:";const d=10;let S=t.fileTypes.length>d?d:t.fileTypes.length;for(let L=0;L<S;L++){const _=t.fileTypes[L];h(_.name,_.count)}if(r.push(p),t.configFiles.length>=0&&(p="|      Conf files:",o=0,t.configFiles.forEach(L=>{h(L.name,L.count)}),r.push(p)),t.launchConfigFiles.length>0){let L="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{L+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(L)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],s=[];return t.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const p=i.URI.revive(h);if(p.scheme===w.Schemas.file){const d=p.fsPath;s.push(D(d,["node_modules",".git"]).then(S=>{let L=`${S.fileCount} files`;S.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${b.basename(d)}): ${L}`),r.push(this.formatWorkspaceStats(S))}).catch(S=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${S.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,r){const s=new Map;t.windows.forEach(h=>s.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,s,o,r,0),o.join(`
`)}formatProcessItem(t,r,s,o,h){const p=h===0;let d;p?d=o.pid===t?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(d=`${d} (${r.get(o.pid)})`));const S=process.platform==="win32"?o.mem:m.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(S/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(o.children)&&o.children.forEach(L=>this.formatProcessItem(t,r,s,L,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const s=i.URI.revive(r);if(s.scheme!==w.Schemas.file)continue;const o=s.fsPath;try{const h=await D(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})}),h.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})}),h.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})})}catch(h){}}}};a=he([te(0,I.ITelemetryService),te(1,v.IProductService)],a),e.DiagnosticsService=a}),define(Q[199],Z([0,1,22,168,171,44,32,50,162,47,25,6,18,7,19,97,194,4,15]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(u||(u={}));function a(...F){return String(F.reduce((T,O)=>T|O,0))}var l;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class h{constructor(T=o){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,O=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:O}))}withFilter(T,...O){const k=[...this.state.criteria,...O.length?O.map(W=>({filterType:T,value:W})):[{filterType:T}]];return new h(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(T){return new h(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new h(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new h(Object.assign(Object.assign({},this.state),{flags:T.reduce((O,k)=>O|k,0)}))}withAssetTypes(...T){return new h(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:O,pageSize:k,sortBy:W,sortOrder:C,flags:V,assetTypes:K}=this.state;return{filters:[{criteria:T,pageNumber:O,pageSize:k,sortBy:W,sortOrder:C}],assetTypes:K,flags:V}}get searchText(){const T=this.state.criteria.filter(O=>O.filterType===l.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function p(F,T){const O=(F||[]).filter(k=>k.statisticName===T)[0];return O?O.value:0}function d(F){const T="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(k=>k.assetType.indexOf(T)===0).reduce((k,W)=>{const C=H(F,W.assetType);return C&&k.push([W.assetType.substring(T.length),C]),k},[])}function S(F){if(F.properties){const T=F.properties.filter(W=>W.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),k=T.filter(W=>O.test(W.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return H(F,t.Repository)}function L(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function _(F){const T=H(F,t.Icon);if(T)return T;const O=A.DefaultIconPath;return{uri:O,fallbackUri:O}}function H(F,T){return F.files.filter(k=>k.assetType===T)[0]?{uri:`${F.assetUri}/${T}`,fallbackUri:`${F.fallbackAssetUri}/${T}`}:null}function X(F,T){const O=F.properties?F.properties.filter(W=>W.key===T):[],k=O.length>0&&O[0].value;return k?k.split(",").map(W=>R.adoptToGalleryExtensionId(W)):[]}function ee(F){const T=F.properties?F.properties.filter(O=>O.key===r.Engine):[];return T.length>0&&T[0].value||""}function B(F){const T=F.properties?F.properties.filter(k=>k.key===r.LocalizedLanguages):[],O=T.length>0&&T[0].value||"";return O?O.split(","):[]}function J(F){return F.indexOf("preview")!==-1}function Y(F){const T=F.properties?F.properties.find(O=>O.key===r.WebExtension):void 0;return!!T&&T.value==="true"}function U(F){return F.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?c.joinPath(w.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function z(F,T,O,k,W){const C={manifest:H(T,t.Manifest),readme:H(T,t.Details),changelog:H(T,t.Changelog),license:H(T,t.License),repository:S(T),download:L(T),icon:_(T),coreTranslations:d(T)};return{identifier:{id:R.getGalleryExtensionId(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:T.version,date:T.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:p(F.statistics,"install"),rating:p(F.statistics,"averagerating"),ratingCount:p(F.statistics,"ratingcount"),assetUri:w.URI.parse(T.assetUri),webResource:U(T),assetTypes:T.files.map(({assetType:V})=>V),assets:C,properties:{dependencies:X(T,r.Dependency),extensionPack:X(T,r.ExtensionPack),engine:ee(T),localizedLanguages:B(T),webExtension:Y(T)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+O,querySource:W},preview:J(F.flags)}}let G=class{constructor(T,O,k,W,C,V,K){this.requestService=T,this.logService=O,this.environmentService=k,this.telemetryService=W,this.fileService=C,this.productService=V;const q=V.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,K)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,O){const k=[];let{total:W,firstPage:C,getPage:V}=await this.query({names:T,pageSize:T.length},O);k.push(...C);for(let K=1;k.length<W&&(C=await V(K,O),C.length);K++)k.push(...C);return k}async getCompatibleExtension(T,O){const k=await this.getCompatibleExtensionByEngine(T,O);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(T,O){const k=A.isIExtensionIdentifier(T)?null:T;if(k&&k.properties.engine&&v.isEngineValid(k.properties.engine,this.productService.version,this.productService.date))return k;const{id:W,uuid:C}=k?k.identifier:T;let V=new h().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");C?V=V.withFilter(l.ExtensionId,C):V=V.withFilter(l.ExtensionName,W);const{galleryExtensions:K}=await this.queryGallery(V,i.CancellationToken.None),[q]=K;if(!q||!q.versions.length)return null;if(O){const ne=q.versions.filter(re=>re.version===O)[0];if(ne){const re=z(q,ne,0,V);if(re.properties.engine&&v.isEngineValid(re.properties.engine,this.productService.version,this.productService.date))return re}return null}const x=await this.getLastValidExtensionVersion(q,q.versions);return x?z(q,x,0,V):null}async query(T,O){const k=i.CancellationToken.isCancellationToken(T)?{}:T,W=i.CancellationToken.isCancellationToken(T)?T:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let C=k.text||"";const V=b.getOrDefault(k,se=>se.pageSize,50);let K=new h().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,V).withFilter(l.Target,"Microsoft.VisualStudio.Code");C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(l.Category,oe||le),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(l.Tag,oe||le),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(l.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),K=K.withFilter(l.SearchText,C)),K=K.withSortBy(0)):k.ids?K=K.withFilter(l.ExtensionId,...k.ids):k.names?K=K.withFilter(l.ExtensionName,...k.names):K=K.withSortBy(4),typeof k.sortBy=="number"&&(K=K.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(K=K.withSortOrder(k.sortOrder));const{galleryExtensions:q,total:x}=await this.queryGallery(K,W),ne=q.map((se,le)=>z(se,se.versions[0],le,K,k.source)),re=async(se,le)=>{if(le.isCancellationRequested)throw m.canceled();const oe=K.withPage(se+1),{galleryExtensions:ue}=await this.queryGallery(oe,le);return ue.map((me,be)=>z(me,me.versions[0],be,oe,k.source))};return{firstPage:ne,total:x,pageSize:K.pageSize,getPage:re}}async queryGallery(T,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,u.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,a(u.Unpublished));const k=await this.commonHeadersPromise,W=JSON.stringify(T.raw),C=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),V=new Date().getTime();let K,q,x=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:C},O),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:x};const ne=await n.asJson(K);if(ne){const re=ne.results[0],se=re.extensions,le=re.resultMetadata&&re.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return x=le&&le.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:x}}return{galleryExtensions:[],total:x}}catch(ne){throw q=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-V,success:!!K&&n.isSuccess(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:q?m.isPromiseCanceledError(q)?"canceled":m.getErrorMessage(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(x)}))}}async reportStatistic(T,O,k,W){if(!this.isEnabled())return;const C=await this.commonHeadersPromise,V=Object.assign(Object.assign({},C),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${O}/${k}/stats?statType=${W}`),headers:V},i.CancellationToken.None)}catch(K){}}async download(T,O,k){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const W=R.getGalleryExtensionTelemetryData(T),C=new Date().getTime(),V=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ne})),K=k===1?"install":k===2?"update":"",q=K?{uri:`${T.assets.download.uri}&${K}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${K}=true`}:T.assets.download,x=await this.getAsset(q);await this.fileService.writeFile(O,x.stream),V(new Date().getTime()-C)}async getReadme(T,O){if(T.assets.readme){const k=await this.getAsset(T.assets.readme,{},O);return await n.asText(k)||""}return""}async getManifest(T,O){if(T.assets.manifest){const k=await this.getAsset(T.assets.manifest,{},O),W=await n.asText(k);return W?JSON.parse(W):null}return null}async getCoreTranslation(T,O){const k=T.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(k){const W=await this.getAsset(k[1]),C=await n.asText(W);return C?JSON.parse(C):null}return null}async getChangelog(T,O){if(T.assets.changelog){const k=await this.getAsset(T.assets.changelog,{},O);return await n.asText(k)||""}return""}async getAllVersions(T,O){let k=new h().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?k=k.withFilter(l.ExtensionId,T.identifier.uuid):k=k.withFilter(l.ExtensionName,T.identifier.id);const W=[],{galleryExtensions:C}=await this.queryGallery(k,i.CancellationToken.None);return C.length&&(O?await Promise.all(C[0].versions.map(async V=>{let K;try{K=await this.getEngine(V)}catch(q){}K&&v.isEngineValid(K,this.productService.version,this.productService.date)&&W.push({version:V.version,date:V.lastUpdated})})):W.push(...C[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),W}async getAsset(T,O={},k=i.CancellationToken.None){const W=await this.commonHeadersPromise,C={type:"GET"},V=Object.assign(Object.assign({},W),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),C),{headers:V});const K=T.uri,q=T.fallbackUri,x=Object.assign(Object.assign({},O),{url:K});try{const ne=await this.requestService.request(x,k);if(ne.res.statusCode===200)return ne;const re=await n.asText(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${re}`)}catch(ne){if(m.isPromiseCanceledError(ne))throw ne;const re=m.getErrorMessage(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:re});const se=Object.assign(Object.assign({},O),{url:q});return this.requestService.request(se,k)}}async getLastValidExtensionVersion(T,O){const k=this.getLastValidExtensionVersionFromProperties(T,O);return k||this.getLastValidExtensionVersionRecursively(T,O)}getLastValidExtensionVersionFromProperties(T,O){for(const k of O){const W=ee(k);if(!W)return null;if(v.isEngineValid(W,this.productService.version,this.productService.date))return k}return null}async getEngine(T){const O=ee(T);if(O)return O;const k=H(T,t.Manifest);if(!k)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},C=await this.getAsset(k,{headers:W}),V=await n.asJson(C);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,O){if(!O.length)return null;const k=O[0],W=await this.getEngine(k);return v.isEngineValid(W,this.productService.version,this.productService.date)?Object.assign(Object.assign({},k),{properties:[...k.properties||[],{key:r.Engine,value:W}]}):this.getLastValidExtensionVersionRecursively(T,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await n.asJson(T),k=new Map;if(O)for(const W of O.malicious){const C=k.get(W)||{id:{id:W},malicious:!0,slow:!1};C.malicious=!0,k.set(W,C)}return[...k.values()]}};G=he([te(0,n.IRequestService),te(1,I.ILogService),te(2,y.IEnvironmentService),te(3,P.ITelemetryService),te(4,M.IFileService),te(5,f.IProductService),te(6,E.optional(g.IStorageService))],G),e.ExtensionGalleryService=G;async function N(F,T,O,k){const W={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},C=await D.getServiceMachineId(T,O,k);return W["X-Market-User-Id"]=C,W}e.resolveMarketplaceHeaders=N}),define(Q[200],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(b){this.appender=b}listen(b,P){throw new Error(`Event not found: ${P}`)}call(b,P,{eventName:n,data:v}){return this.appender.log(n,v),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class A{constructor(b){this.channel=b}log(b,P){return this.channel.call("log",{eventName:b,data:P}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(Q[201],Z([0,1,48,147,23,4,20,49,2,44,38]),function($,e,m,A,R,b,P,n,v,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(f,g){this._configurationService=g,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(R.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const E=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(f,g){this._experimentProperties[f]=g}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const g=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(M);this._userOptIn=g?g.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let g=f.sessionID,D=f["common.instanceId"],E=f["common.machineId"],c=f["common.firstSessionDate"],u=f["common.msftInternal"];return{sessionId:g,instanceId:D,machineId:E,firstSessionDate:c,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(f,g,D){return this.isOptedIn?this._commonProperties.then(E=>{g=y.mixin(g,E),g=y.mixin(g,this._experimentProperties),g=y.cloneAndChange(g,c=>{if(typeof c=="string")return this._cleanupInfo(c,D)}),this._appender.log(f,g)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(f,g,D){return this.publicLog(f,g,D)}publicLogError(f,g){return this.sendErrorTelemetry?this.publicLog(f,g,!0):Promise.resolve(void 0)}publicLogError2(f,g){return this.publicLogError(f,g)}_cleanupInfo(f,g){let D=f;if(g){const E=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(f);if(!t)break;E.push([t.index,l.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(D="";;){const l=u.exec(f);if(!l)break;!c.test(l[0])&&E.every(([t,r])=>l.index<t||l.index>=r)&&(D+=f.substring(a,l.index)+"<REDACTED: user-file-path>",a=u.lastIndex)}a<f.length&&(D+=f.substr(a))}for(let E of this._cleanupPatterns)D=D.replace(E,"");return D}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=he([te(1,b.optional(P.IConfigurationService))],I),e.TelemetryService=I;const M="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:M,order:110,type:"object",title:A.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?A.localize(2,null,m.default.privacyStatementUrl):A.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[98],Z([0,1,20,44,13,9]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,g){return Promise.resolve(void 0)}publicLog2(f,g){return this.publicLog(f,g)}publicLogError(f,g){return Promise.resolve(void 0)}publicLogError2(f,g){return this.publicLogError(f,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(g,D,E){}async publicLogError(g,D,E){}}e.NullEndpointTelemetryService=P;function n(...f){return{log:(g,D)=>f.forEach(E=>E.log(g,D)),flush:()=>b.Promises.settled(f.map(g=>g.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(f,g){return g.onDidChangeConfiguration(D=>{D.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(D.source),configurationKeys:M(D.sourceConfig)})})}e.configurationTelemetry=v;function y(f){const g=Object.create(null),D=Object.create(null),E=Object.create(null);I(f,E);for(let c in E){c=c.length>150?c.substr(c.length-149):c;const u=E[c];typeof u=="number"?D[c]=u:typeof u=="boolean"?D[c]=u?1:0:typeof u=="string"?g[c]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(g[c]=u)}return{properties:g,measurements:D}}e.validateTelemetryData=y;function i(f){if(!f)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{f.indexOf(`${E}+`)===0&&(g=E)}),g}e.cleanRemoteAuthority=i;function I(f,g,D=0,E){if(!!f)for(let c of Object.getOwnPropertyNames(f)){const u=f[c],a=E?E+c:c;Array.isArray(u)?g[a]=A.safeStringify(u):u instanceof Date?g[a]=u.toISOString():R.isObject(u)?D<2?I(u,g,D+1,a+"."):g[a]=A.safeStringify(u):g[a]=u}}function M(f){if(!f)return[];const g=[];return w(g,"",f),g}function w(f,g,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(E=>w(f,g?`${g}.${E}`:E,D[E])):f.push(g)}}),define(Q[202],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(Q[203],Z([0,1,4,2,38,5,202,108]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=m.createDecorator("themeService");var v;(function(D){function E(c){return c&&typeof c=="object"&&typeof c.id=="string"}D.isThemeColor=E})(v=e.ThemeColor||(e.ThemeColor={}));function y(D){return{id:D}}e.themeColorFromId=y;var i;(function(D){function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||v.isThemeColor(r.color))}D.isThemeIcon=E;const c=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const s=c.exec(r);if(!s)return;let[,o]=s;return{id:o}}D.fromString=u;function a(r,s){let o=r.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),s&&(o=`${o}~${s}`),{id:o}}D.modify=a;function l(r,s){var o,h;return r.id===s.id&&((o=r.color)===null||o===void 0?void 0:o.id)===((h=s.color)===null||h===void 0?void 0:h.id)}D.isEqual=l;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=n.CSSIcon.asClassNameArray,D.asClassName=n.CSSIcon.asClassName,D.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function I(D){switch(D){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class M{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),A.toDisposable(()=>{const c=this.themingParticipants.indexOf(E);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new M;R.Registry.add(e.Extensions.ThemingContribution,w);function f(D){return w.onColorThemeChange(D)}e.registerThemingParticipant=f;class g extends A.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,c){let u=this.theme.getColor(E);return u&&c&&(u=c(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(Q[60],Z([0,1,14,3,39,4]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",n="#1E1E1E",v="#000000",y="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=b.createDecorator("themeMainService");let M=class{constructor(f){this.stateMainService=f}getBackgroundColor(){if((A.isWindows||A.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return v;let f=this.stateMainService.getItem(i,null);if(!f){let g;(A.isWindows||A.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],f=g==="hc-black"?v:g==="vs"?P:n}return A.isMacintosh&&f.toUpperCase()===n&&(f="#171717"),f}saveWindowSplash(f,g){this.stateMainService.setItems([{key:y,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:I,data:g}]),typeof f=="number"&&this.updateBackgroundColor(f,g)}updateBackgroundColor(f,g){for(const D of m.BrowserWindow.getAllWindows())if(D.id===f){D.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};M=he([te(0,R.IStateMainService)],M),e.ThemeMainService=M}),define(Q[42],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(A=e.StateType||(e.StateType={}));var R;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,P)=>({type:"idle",updateType:b,error:P}),CheckingForUpdates:b=>({type:"checking for updates",explicit:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=m.createDecorator("updateService")}),define(Q[204],Z([0,1,38,49,148,3]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:R.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:R.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[R.localize(2,null),R.localize(3,null),R.localize(4,null),R.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:R.localize(6,null),deprecationMessage:R.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:R.localize(8,null),description:R.localize(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:R.localize(10,null),tags:["usesOnlineServices"]}}})}),define(Q[205],Z([0,1,5,42]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(n){this.service=n}listen(n,v){switch(v){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${v}`)}call(n,v,y){switch(v){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${v}`)}}e.UpdateChannel=R;class b{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(v=>this.state=v),this.channel.call("_getInitialState").then(v=>this.state=v)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(Q[99],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=m.createDecorator("urlService")}),define(Q[206],Z([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(n){this.handler=n}listen(n,v){throw new Error(`Event not found: ${v}`)}call(n,v,y){switch(v){case"handleURL":return this.handler.handleURL(m.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${v}`)}}e.URLHandlerChannel=A;class R{constructor(n){this.channel=n}handleURL(n,v){return this.channel.call("handleURL",[n.toJSON(),v])}}e.URLHandlerChannelClient=R;class b{constructor(n){this.next=n}async routeCall(n,v,y,i){if(v!=="handleURL")throw new Error(`Call not found: ${v}`);if(y){const I=m.URI.revive(y);if(I&&I.query){const M=/\bwindowId=(\d+)/.exec(I.query);if(M){const w=M[1],f=new RegExp(`window:${w}`),g=n.connections.find(D=>f.test(D.ctx));if(g)return g}}}return this.next.routeCall(n,v,y,i)}routeEvent(n,v){throw new Error(`Event not found: ${v}`)}}e.URLHandlerRouter=b}),define(Q[207],Z([0,1,7,9,2,19]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,i){const I=[...this.handlers.values()];return A.first(I.map(M=>()=>M.handleURL(y,i)),void 0,!1).then(M=>M||!1)}registerHandler(y){return this.handlers.add(y),R.toDisposable(()=>this.handlers.delete(y))}}e.AbstractURLService=P;let n=class extends P{constructor(y){super();this.productService=y}create(y){let{authority:i,path:I,query:M,fragment:w}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),m.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:M,fragment:w})}};n=he([te(0,b.IProductService)],n),e.NativeURLService=n}),define(Q[208],Z([0,1,5,14,7,2,3,9]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function v(i){try{return R.URI.parse(i)}catch(I){return null}}class y{constructor(I,M,w,f,g){if(this.urlService=M,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=I,P.isWindows){const c=f.isBuilt?[]:[`"${f.appRoot}"`];c.push("--open-url","--"),A.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const D=m.Event.map(m.Event.fromNodeEventEmitter(A.app,"open-url",(c,u)=>({event:c,url:u})),({event:c,url:u})=>(c.preventDefault(),u));this.disposables.add(D(c=>{const u=v(c);!u||this.urlService.open(u,{originalUrl:c})})),w.getWindows().filter(c=>c.isReady).length>0?this.flush():m.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const M of this.uris)await this.urlService.open(M.uri,{originalUrl:M.url})||I.push(M);I.length!==0&&(this.uris=I,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(Q[76],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=m.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(Q[209],Z([0,1,14,2,10,7,76]),function($,e,m,A,R,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends A.Disposable{constructor(){super();const y=m.session.fromPartition(P.webviewPartitionId),i=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(R.Schemas.vscodeWebview,i),y.protocol.registerFileProtocol(R.Schemas.vscodeWebview,i)}async handleWebviewRequest(y,i){try{const I=b.URI.parse(y.url),M=n.validWebviewFilePaths.get(I.path);if(typeof M=="string"){const w=I.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${M}`:`vs/workbench/contrib/webview/browser/pre/${M}`,f=R.FileAccess.asFileUri(w,$);return i(decodeURIComponent(f.fsPath))}}catch(I){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(Q[61],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(y){return!!y.workspaceUri}e.isWorkspaceToOpen=A;function R(y){return!!y.folderUri}e.isFolderToOpen=R;function b(y){return!!y.fileUri}e.isFileToOpen=b;function P(y){const i=n(y),I=y.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||m.isMacintosh&&m.isNative?"classic":I}e.getMenuBarVisibility=P;function n(y){if(m.isWeb)return"custom";const i=y.getValue("window");if(i){if(m.isMacintosh&&i.nativeTabs===!0||m.isMacintosh&&i.nativeFullScreen===!1)return"native";const w=i.titleBarStyle;if(w==="native"||w==="custom")return w}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function v(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=v}),define(Q[35],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var A;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}));const R=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=R;var b;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var P;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={})),e.IWindowsMainService=m.createDecorator("windowsMainService")}),define(Q[210],Z([0,1,14,2,74,76,209,35]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let v=class extends A.Disposable{constructor(i,I){super();this.windowsMainService=I,this._register(new P.WebviewProtocolProvider);const M=m.session.fromPartition(b.webviewPartitionId);M.setPermissionRequestHandler((w,f,g)=>g(f==="clipboard-read")),M.setPermissionCheckHandler((w,f)=>f==="clipboard-read")}async setIgnoreMenuShortcuts(i,I){let M;if(typeof i.windowId=="number"){const{windowId:w}=i,f=this.windowsMainService.getWindowById(w);if(!(f==null?void 0:f.win))throw new Error(`Invalid windowId: ${w}`);M=f.win.webContents}else{const{webContentsId:w}=i;if(M=m.webContents.fromId(w),!M)throw new Error(`Invalid webContentsId: ${w}`)}M.isDestroyed()||M.setIgnoreMenuShortcuts(I)}};v=he([te(0,R.ITunnelService),te(1,n.IWindowsMainService)],v),e.WebviewMainService=v}),define(Q[211],Z([0,1,5,2,9]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends A.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:v,getActiveWindowId:y}){super();this.disposables=this._register(new A.DisposableStore),m.Event.latch(m.Event.any(n,v))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=R.createCancelablePromise(()=>y()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(Q[212],Z([0,1,7,15,4,37]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=R.createDecorator("contextService");var P;(function(M){M[M.EMPTY=1]="EMPTY",M[M.FOLDER=2]="FOLDER",M[M.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function n(M){const w=M;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=n;function v(M){const w=M;return!!(w&&typeof w=="object"&&m.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=v;class y{constructor(w,f,g,D){this._id=w,this._configuration=g,this._ignorePathCasing=D,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(w){this._id=w.id,this._configuration=w.configuration,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class i{constructor(w,f){this.raw=f,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return A.joinPath(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(M){return new i({uri:M,index:0,name:A.basenameOrAuthority(M)},{uri:M.toString()})}e.toWorkspaceFolder=I}),define(Q[28],Z([0,1,4,151,212,7,3,8,15,78,40,10,30,29,73]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:A.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(U){return(typeof U=="string"?n.extname(U):v.extname(U))===g}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=m.createDecorator("workspacesService");function E(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=E;function c(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=c;function u(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=u;function a(U){const z=U;return typeof(z==null?void 0:z.id)=="string"&&b.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(U){const z=U;return typeof(z==null?void 0:z.id)=="string"&&b.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function r(U){const z=U;if(z==null?void 0:z.uri)return{id:z.id,uri:b.URI.revive(z.uri)};const G=U;if(G==null?void 0:G.configPath)return{id:G.id,configPath:b.URI.revive(G.configPath)};if(U==null?void 0:U.id)return{id:U.id}}e.reviveIdentifier=r;function s(U,z){return v.extUriBiasedIgnorePathCase.isEqualOrParent(U,z.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(U){return h(U)||p(U)}e.isStoredWorkspaceFolder=o;function h(U){const z=U;return typeof(z==null?void 0:z.path)=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=h;function p(U){const z=U;return typeof(z==null?void 0:z.uri)=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=p;function d(U,z,G,N,F=!P.isWindows,T){if(U.scheme!==N.scheme)return{name:G,uri:U.toString(!0)};let O=z?void 0:T.relativePath(N,U);if(O!==void 0)O.length===0?O=".":P.isWindows&&U.scheme===I.Schemas.file&&!F&&(O=O.replace(/\//g,"\\"));else if(U.scheme===I.Schemas.file)O=U.fsPath,P.isWindows&&(O=M.normalizeDriveLetter(O),F&&(O=w.toSlashes(O)));else{if(!T.isEqualAuthority(U.authority,N.authority))return{name:G,uri:U.toString(!0)};O=U.path}return{name:G,path:O}}e.getStoredWorkspaceFolder=d;function S(U,z,G){let N=[],F=new Set;const T=G.dirname(z);for(let O of U){let k;if(h(O))O.path&&(k=G.resolvePath(T,O.path));else if(p(O))try{k=b.URI.parse(O.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(W){console.warn(W)}if(k){let W=G.getComparisonKey(k);if(!F.has(W)){F.add(W);const C=O.name||G.basenameOrAuthority(k);N.push(new R.WorkspaceFolder({uri:k,name:C,index:N.length},O))}}}return N}e.toWorkspaceFolders=S;function L(U,z,G,N,F){let T=_(z,U);const O=F.dirname(z),k=F.dirname(N),W=[],C=H(T.folders);for(const x of T.folders){const ne=h(x)?F.resolvePath(O,x.path):b.URI.parse(x.uri);let re;G?re=!1:re=!h(x)||n.isAbsolute(x.path),W.push(d(ne,re,x.name,k,C,F))}const V={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},K=y.setProperty(U,["folders"],W,V);let q=y.applyEdits(U,K);return T.remoteAuthority===f.getRemoteAuthority(N)&&(q=y.applyEdits(q,y.removeProperty(q,["remoteAuthority"],V))),q}e.rewriteWorkspaceFileForNewLocation=L;function _(U,z){let G=i.parse(z);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(N=>o(N));else throw new Error(`${U} looks like an invalid workspace file.`);return G}function H(U){return P.isWindows?U.some(z=>h(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function X(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function ee(U){return typeof U.folderUri=="string"}function B(U){return typeof U.fileUri=="string"}function J(U,z){const G={workspaces:[],files:[]};if(U){const N=function(T,O){for(let k=0;k<T.length;k++)try{O(T[k],k)}catch(W){z.warn(`Error restoring recent entry ${JSON.stringify(T[k])}: ${W.toString()}. Skip entry.`)}},F=U;if(Array.isArray(F.entries))N(F.entries,T=>{const O=T.label,k=T.remoteAuthority;X(T)?G.workspaces.push({label:O,remoteAuthority:k,workspace:{id:T.workspace.id,configPath:b.URI.parse(T.workspace.configPath)}}):ee(T)?G.workspaces.push({label:O,remoteAuthority:k,folderUri:b.URI.parse(T.folderUri)}):B(T)&&G.files.push({label:O,remoteAuthority:k,fileUri:b.URI.parse(T.fileUri)})});else{const T=U;Array.isArray(T.workspaces3)&&N(T.workspaces3,(O,k)=>{const W=Array.isArray(T.workspaceLabels)&&T.workspaceLabels[k]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?G.workspaces.push({label:W,workspace:{id:O.id,configPath:b.URI.parse(O.configURIPath)}}):typeof O=="string"&&G.workspaces.push({label:W,folderUri:b.URI.parse(O)})}),Array.isArray(T.files2)&&N(T.files2,(O,k)=>{const W=Array.isArray(T.fileLabels)&&T.fileLabels[k]||void 0;typeof O=="string"&&G.files.push({label:W,fileUri:b.URI.parse(O)})})}}return G}e.restoreRecentlyOpened=J;function Y(U){const z={entries:[]};for(const G of U.workspaces)c(G)?z.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):z.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of U.files)z.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return z}e.toStoreData=Y}),define(Q[51],Z([0,1,4,28]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=m.createDecorator("backupMainService");function R(b){const P=b;return P&&A.isWorkspaceIdentifier(P.workspace)}e.isWorkspaceBackupInfo=R}),define(Q[52],Z([0,1,4,14,9,39,3,8,65,17,13,133,28,30,2,81]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=m.createDecorator("dialogMainService");let D=class gt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,pickFiles:!0,title:I.localize(0,null)}),u)}pickFolder(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,title:I.localize(1,null)}),u)}pickFile(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:I.localize(2,null)}),u)}pickWorkspace(c,u){const a=I.localize(3,null),l=w.mnemonicButtonLabel(I.localize(4,null)),t=M.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:a,filters:t,buttonLabel:l}),u)}async doPick(c,u){const a={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};a.defaultPath=c.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(a.properties=void 0,c.pickFiles&&c.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),P.isMacintosh&&a.properties.push("treatPackageAsDirectory");const l=u||A.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(a,i.withNullAsUndefined(l));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(c){if(c){let u=this.windowDialogQueues.get(c.id);return u||(u=new R.Queue,this.windowDialogQueues.set(c.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(c,u){return this.getWindowDialogQueue(u).queue(async()=>u?A.dialog.showMessageBox(u,c):A.dialog.showMessageBox(c))}async showSaveDialog(c,u){const a=this.acquireFileDialogLock(c,u);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await A.dialog.showSaveDialog(u,c):l=await A.dialog.showSaveDialog(c),l.filePath=this.normalizePath(l.filePath),l})}finally{f.dispose(a)}}normalizePath(c){return c&&P.isMacintosh&&(c=v.normalizeNFC(c)),c}normalizePaths(c){return c.map(u=>this.normalizePath(u))}async showOpenDialog(c,u){c.defaultPath&&(await y.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const a=this.acquireFileDialogLock(c,u);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await A.dialog.showOpenDialog(u,c):l=await A.dialog.showOpenDialog(c),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{f.dispose(a)}}acquireFileDialogLock(c,u){if(!u)return f.Disposable.None;let a=this.windowFileDialogLocks.get(u.id);a||(a=new Set,this.windowFileDialogLocks.set(u.id,a));const l=g.hash(c);if(!a.has(l))return a.add(l),f.toDisposable(()=>{a==null||a.delete(l),(a==null?void 0:a.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=he([te(0,b.IStateMainService)],D),e.DialogMainService=D}),define(Q[213],Z([0,1,5,2,28]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends A.Disposable{constructor(n,v){super();this.logService=n,this.storageMainService=v,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,v)=>(n?n.push(v):n=[v],n),b.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const v=new Map,y=new Set;return n.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?v.set(i.key,I):y.add(i.key)}),{changed:Array.from(v.entries()),deleted:Array.from(y.values())}}listen(n,v){switch(v){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${v}`)}async call(n,v,y){const i=R.reviveIdentifier(y.workspace),I=await this.withStorageInitialized(i);switch(v){case"getItems":return Array.from(I.items.entries());case"updateItems":{const M=y;if(M.insert)for(const[w,f]of M.insert)I.set(w,f);M.delete&&M.delete.forEach(w=>I.delete(w));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${v}`)}}async withStorageInitialized(n){const v=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await v.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${y}`)}return v}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[214],Z([0,1,17,5,2,6,123,87,8,97,32,27,28]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends R.Disposable{constructor(E){super();this.logService=E,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new A.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const E=await this.doCreate();this.storage.dispose(),this.storage=E,this._register(E.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(E);const c=E.getBoolean(y.IS_NEW_KEY);c===void 0?E.set(y.IS_NEW_KEY,!0):c&&E.set(y.IS_NEW_KEY,!1)}catch(E){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${E}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?E=>this.logService.trace(E):void 0,logError:E=>this.logService.error(E)}}doInit(E){return E.init()}get items(){return this.storage.items}get(E,c){return this.storage.get(E,c)}set(E,c){return this.storage.set(E,c)}delete(E){return this.storage.delete(E)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class f extends w{constructor(E,c,u){super(c);this.options=E,this.environmentService=u}async doCreate(){let E;return this.options.useInMemoryStorage?E=P.SQLiteStorageDatabase.IN_MEMORY_PATH:E=v.join(this.environmentService.globalStorageHome.fsPath,f.STORAGE_NAME),new n.Storage(new P.SQLiteStorageDatabase(E,{logging:this.createLogginOptions()}))}async doInit(E){await super.doInit(E),this.updateTelemetryState(E)}updateTelemetryState(E){E.get(i.instanceStorageKey,void 0)===void 0&&E.set(i.instanceStorageKey,I.generateUuid()),E.get(i.firstSessionDateStorageKey,void 0)===void 0&&E.set(i.firstSessionDateStorageKey,new Date().toUTCString());const a=E.get(i.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();E.set(i.lastSessionDateStorageKey,typeof a=="undefined"?null:a),E.set(i.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=f,f.STORAGE_NAME="state.vscdb";class g extends w{constructor(E,c,u,a){super(u);this.workspace=E,this.options=c,this.environmentService=a}async doCreate(){const{storageFilePath:E,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new P.SQLiteStorageDatabase(E,{logging:this.createLogginOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const E=v.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=v.join(E,g.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(E)?{storageFilePath:c,wasCreated:!1}:(await m.Promises.mkdir(E,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(E),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(E){let c;if(M.isSingleFolderWorkspaceIdentifier(this.workspace)?c={folder:this.workspace.uri.toString()}:M.isWorkspaceIdentifier(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const u=v.join(E,g.WORKSPACE_META_NAME);await m.Promises.exists(u)||await m.Promises.writeFile(u,JSON.stringify(c,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Q[100],Z([0,1,43,2,47,4,21,6,214]),function($,e,m,A,R,b,P,n,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=b.createDecorator("storageMainService");let y=class extends A.Disposable{constructor(I,M,w){super();this.logService=I,this.environmentService=M,this.lifecycleMainService=w,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,M]of this.mapWorkspaceToStorage)I.join(M.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new v.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return m.once(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new v.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let M=this.mapWorkspaceToStorage.get(I.id);return M||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),M=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,M),m.once(M.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),M}};y=he([te(0,n.ILogService),te(1,R.IEnvironmentService),te(2,P.ILifecycleMainService)],y),e.StorageMainService=y}),define(Q[101],Z([0,1,7,28,15]),function($,e,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(v,y,i){for(const M of v){const w=M.openedWorkspace;if(A.isWorkspaceIdentifier(w)){const f=i(w);if(f){if(f.folders.some(g=>R.extUriBiasedIgnorePathCase.isEqualOrParent(y,g.uri)))return M}else if(R.extUriBiasedIgnorePathCase.isEqualOrParent(y,w.configPath))return M}}const I=v.filter(M=>A.isSingleFolderWorkspaceIdentifier(M.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqualOrParent(y,M.openedWorkspace.uri));if(I.length)return I.sort((M,w)=>-(M.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function P(v,y){for(const i of v)if(A.isWorkspaceIdentifier(i.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,y)||A.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,y))return i}e.findWindowOnWorkspaceOrFolder=P;function n(v,y){var i,I;const M=w=>y.some(f=>R.extUriBiasedIgnorePathCase.isEqual(m.URI.file(f),m.URI.file(w)));for(const w of v)if((I=(i=w.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||I===void 0?void 0:I.some(f=>M(f)))return w}e.findWindowOnExtensionDevelopmentPath=n}),define(Q[215],Z([0,1,14,2,3,15,7,20,21,6,39,35,28]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class mt extends A.Disposable{constructor(u,a,l,t,r){super();this.windowsMainService=u,this.stateMainService=a,this.lifecycleMainService=l,this.logService=t,this.configurationService=r,this._state=f(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const a=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const l=D(u);this.stateMainService.setItem(mt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{var t;const r=M.isWorkspaceIdentifier(u.openedWorkspace)&&((t=l.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=M.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)&&l.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(r||s)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(u){return{workspace:M.isWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:M.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const a=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");let t;return a.hasDefaultState?t=!!((l==null?void 0:l.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0)||R.isMacintosh&&(l==null?void 0:l.nativeFullScreen)!==!1:(t=!!(this.lifecycleMainService.wasRestarted||(l==null?void 0:l.restoreFullscreen)),t&&R.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),a.mode===3&&!t&&(a.mode=1),a}doGetNewWindowState(u){const a=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=u.workspace;if(M.isWorkspaceIdentifier(h)){const d=this.state.openedWindows.filter(S=>S.workspace&&S.workspace.id===h.id).map(S=>S.uiState);if(d.length)return d[0]}if(M.isSingleFolderWorkspaceIdentifier(h)){const d=this.state.openedWindows.filter(S=>S.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(S.folderUri,h.uri)).map(S=>S.uiState);if(d.length)return d[0]}else if(u.backupPath){const d=this.state.openedWindows.filter(S=>S.backupPath===u.backupPath).map(S=>S.uiState);if(d.length)return d[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!a&&p)return p.uiState}let l;const t=m.screen.getAllDisplays();if(t.length===1)l=t[0];else{if(R.isMacintosh){const h=m.screen.getCursorScreenPoint();l=m.screen.getDisplayNearestPoint(h)}!l&&a&&(l=m.screen.getDisplayMatching(a.getBounds())),l||(l=m.screen.getPrimaryDisplay()||t[0])}let r=I.defaultWindowState();r.x=Math.round(l.bounds.x+l.bounds.width/2-r.width/2),r.y=Math.round(l.bounds.y+l.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let o=!0;if(R.isMacintosh&&(s==null?void 0:s.nativeFullScreen)!==!1&&(a==null?void 0:a.isFullScreen))r.mode=3;else if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&a){const h=a.serializeWindowState();h.mode===3?r.mode=3:r=h,o=r.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};w.windowsStateStorageKey="windowsState",w=he([te(0,I.IWindowsMainService),te(1,i.IStateMainService),te(2,v.ILifecycleMainService),te(3,y.ILogService),te(4,n.IConfigurationService)],w),e.WindowsStateHandler=w;function f(c){const u={openedWindows:[]},a=c||{openedWindows:[]};return a.lastActiveWindow&&(u.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(u.openedWindows=a.openedWindows.map(l=>g(l))),u}e.restoreWindowsState=f;function g(c){const u={uiState:c.uiState};return c.backupPath&&(u.backupPath=c.backupPath),c.remoteAuthority&&(u.remoteAuthority=c.remoteAuthority),c.folder&&(u.folderUri=P.URI.parse(c.folder)),c.workspaceIdentifier&&(u.workspace={id:c.workspaceIdentifier.id,configPath:P.URI.parse(c.workspaceIdentifier.configURIPath)}),u}function D(c){return{lastActiveWindow:c.lastActiveWindow&&E(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&E(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(u=>E(u))}}e.getWindowsStateStoreData=D;function E(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Q[56],Z([0,1,58,59,216,5,34,8,26,27,2,16,85,22,3]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(d){this.socket=d,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;w.onUnexpectedError(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const S=L=>d(I.VSBuffer.wrap(L));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(d){const S=L=>{d({type:0,hadError:L,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,S=>{if(S){if(S.code==="EPIPE")return;w.onUnexpectedError(S)}})}catch(S){if(S.code==="EPIPE")return;w.onUnexpectedError(S)}}end(){this.socket.end()}drain(){return new Promise((d,S)=>{if(this.socket.bufferSize===0){d();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),d()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=g;var D;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var E;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(E||(E={}));class c extends i.Disposable{constructor(d,S,L,_){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=_,S?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),w.onUnexpectedError(H),this._onClose.fire({type:0,hadError:!0,error:H})}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),w.onUnexpectedError(H),this._onClose.fire({type:0,hadError:!0,error:H})}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new M.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(H=>this._onClose.fire(H)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(I.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,S){let L=2;d.byteLength<126?L+=0:d.byteLength<2**16?L+=2:L+=8;const _=I.VSBuffer.alloc(L);if(S?_.writeUInt8(194,0):_.writeUInt8(130,0),d.byteLength<126)_.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){_.writeUInt8(126,1);let H=1;_.writeUInt8(d.byteLength>>>8&255,++H),_.writeUInt8(d.byteLength>>>0&255,++H)}else{_.writeUInt8(127,1);let H=1;_.writeUInt8(0,++H),_.writeUInt8(0,++H),_.writeUInt8(0,++H),_.writeUInt8(0,++H),_.writeUInt8(d.byteLength>>>24&255,++H),_.writeUInt8(d.byteLength>>>16&255,++H),_.writeUInt8(d.byteLength>>>8&255,++H),_.writeUInt8(d.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=_.byteLength+d.byteLength,this.socket.write(I.VSBuffer.concat([_,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),_=(S.readUInt8(0)&128)>>>7,H=S.readUInt8(1),X=(H&128)>>>7,ee=H&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=_,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),L=S.readUInt8(1),_=(L&128)>>>7;let H=L&127,X=1;H===126?H=S.readUInt8(++X)*2**8+S.readUInt8(++X):H===127&&(H=S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*2**24+S.readUInt8(++X)*2**16+S.readUInt8(++X)*2**8+S.readUInt8(++X));let ee=0;_&&(ee=S.readUInt8(++X)*2**24+S.readUInt8(++X)*2**16+S.readUInt8(++X)*2**8+S.readUInt8(++X)),this._state.state=3,this._state.readLen=H,this._state.mask=ee}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);u(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(I.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function u(p,d){if(d===0)return;let S=p.byteLength>>>2;for(let B=0;B<S;B++){const J=p.readUInt32BE(B*4);p.writeUInt32BE(J^d,B*4)}let L=S*4,_=p.byteLength-L;const H=d>>>24&255,X=d>>>16&255,ee=d>>>8&255;_>=1&&p.writeUInt8(p.readUInt8(L)^H,L),_>=2&&p.writeUInt8(p.readUInt8(L+1)^X,L+1),_>=3&&p.writeUInt8(p.readUInt8(L+2)^ee,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const p=y.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let d;return e.XDG_RUNTIME_DIR?d=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):d=n.join(v.tmpdir(),`vscode-ipc-${p}.sock`),r(d),d}e.createRandomIPCHandle=l;function t(p,d,S){const L=m.createHash("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${S}-${d}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=n.join(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${S}-${d}.sock`):_=n.join(p,`${S}-${d}.sock`),r(_),_}e.createStaticIPCHandle=t;function r(p){const d=a[f.platform];typeof d=="number"&&p.length>=d&&console.warn(`WARNING: IPC handle "${p}" is longer than ${d} chars, try a shorter --user-data-dir`)}class s extends P.IPCServer{constructor(d){super(s.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const S=b.Event.fromNodeEventEmitter(d,"connection");return b.Event.map(S,L=>({protocol:new M.Protocol(new g(L)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(p){return new Promise((d,S)=>{const L=A.createServer();L.on("error",S),L.listen(p,()=>{L.removeListener("error",S),d(new s(L))})})}e.serve=o;function h(p,d){return new Promise((S,L)=>{const _=A.createConnection(p,()=>{_.removeListener("error",L),S(M.Client.fromSocket(new g(_),d))});_.once("error",L)})}e.connect=h}),define(Q[217],Z([0,1,56]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(v){this.driver=v}listen(v,y){throw new Error("No event found")}call(v,y,i){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=A;class R{constructor(v){this.channel=v}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(v){return this.channel.call("capturePage",v)}reloadWindow(v){return this.channel.call("reloadWindow",v)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(v,y){return this.channel.call("dispatchKeybinding",[v,y])}click(v,y,i,I){return this.channel.call("click",[v,y,i,I])}doubleClick(v,y){return this.channel.call("doubleClick",[v,y])}setValue(v,y,i){return this.channel.call("setValue",[v,y,i])}getTitle(v){return this.channel.call("getTitle",[v])}isActiveElement(v,y){return this.channel.call("isActiveElement",[v,y])}getElements(v,y,i){return this.channel.call("getElements",[v,y,i])}getElementXY(v,y,i,I){return this.channel.call("getElementXY",[v,y,i,I])}typeInEditor(v,y,i){return this.channel.call("typeInEditor",[v,y,i])}getTerminalBuffer(v,y){return this.channel.call("getTerminalBuffer",[v,y])}writeInTerminal(v,y,i){return this.channel.call("writeInTerminal",[v,y,i])}}e.DriverChannelClient=R;class b{constructor(v){this.registry=v}listen(v,y){throw new Error(`Event not found: ${y}`)}call(v,y,i){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=b;async function P(n){const v=await m.connect(n,"driverClient"),y=v.getChannel("driver"),i=new R(y);return{client:v,driver:i}}e.connect=P}),define(Q[24],Z([0,1,8,46,4,47,160,56]),function($,e,m,A,R,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=R.refineServiceDecorator(b.IEnvironmentService);class v extends P.NativeEnvironmentService{get cachedLanguagesPath(){return m.join(this.userDataPath,"clp")}get backupHome(){return m.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return m.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([A.memoize],v.prototype,"cachedLanguagesPath",null),he([A.memoize],v.prototype,"backupHome",null),he([A.memoize],v.prototype,"backupWorkspacesPath",null),he([A.memoize],v.prototype,"mainIPCHandle",null),he([A.memoize],v.prototype,"sandbox",null),he([A.memoize],v.prototype,"driverVerbose",null),he([A.memoize],v.prototype,"disableUpdates",null),he([A.memoize],v.prototype,"disableKeytar",null),he([A.memoize],v.prototype,"codeCachePath",null),e.EnvironmentMainService=v}),define(Q[218],Z([0,1,31,58,8,3,17,51,24,20,18,6,28,7,29,10,15]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let E=class{constructor(u,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>f.isEqual(t,r,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await P.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let a=[];try{Array.isArray(u.rootURIWorkspaces)&&(a=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:w.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(u.folderURIWorkspaces)&&(l=u.folderURIWorkspaces.map(t=>w.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const a=this.configurationService.getValue();return((u=a==null?void 0:a.files)===null||u===void 0?void 0:u.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,a){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const l=this.getBackupPath(u.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(u,a){if(m.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),m.existsSync(a))try{m.renameSync(a,u)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(u){const a=u.id,l=this.workspaces.findIndex(t=>t.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(a=>this.backupUriComparer.isEqual(u,a))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(u,l));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(u,a){const l=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(u){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,u));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(u){return R.join(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const a=new Set,l=[];for(let t of u){const r=t.workspace;if(!M.isWorkspaceIdentifier(r))return[];if(!a.has(r.id)){a.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==g.Schemas.file||await P.Promises.exists(r.configPath.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const a=[],l=new Set;for(let t of u){const r=this.backupUriComparer.getComparisonKey(t);if(!l.has(r)){l.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==g.Schemas.file||await P.Promises.exists(t.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const a=[],l=new Set;for(let t of u){const r=t.backupFolder;if(typeof r!="string")return[];if(!l.has(r)){l.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?a.push(t):await this.deleteStaleBackup(s)}}return a}async deleteStaleBackup(u){try{await P.Promises.exists(u)&&await P.Promises.rm(u,P.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(u){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await P.Promises.rename(u,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(u){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{m.renameSync(u,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const u=[];for(const a of this.workspaces)await this.hasBackups(a)&&u.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&u.push(a);return u}hasBackups(u){let a;return w.URI.isUri(u)?a=this.getBackupPath(this.getFolderHash(u)):n.isWorkspaceBackupInfo(u)?a=this.getBackupPath(u.workspace.id):a=u.backupFolder,this.doHasBackups(a)}async doHasBackups(u){try{const a=await P.Promises.readdir(u);for(const l of a)try{if((await P.Promises.readdir(R.join(u,l))).length>0)return!0}catch(t){}}catch(a){}return!1}saveSync(){try{P.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await P.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let a;return u.scheme===g.Schemas.file?a=b.isLinux?u.fsPath:u.fsPath.toLowerCase():a=u.toString().toLowerCase(),A.createHash("md5").update(a).digest("hex")}};E=he([te(0,v.IEnvironmentMainService),te(1,y.IConfigurationService),te(2,I.ILogService)],E),e.BackupMainService=E}),define(Q[45],Z([0,1,41,114,145,83,5,35,14,21,3,24,52,17,7,32,4,26,66,6,8,19,46,2,60,30]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=D.createDecorator("nativeHostMainService");let h=class ct extends r.Disposable{constructor(d,S,L,_,H,X,ee,B,J){super();this.sharedProcess=d,this.windowsMainService=S,this.dialogMainService=L,this.lifecycleMainService=_,this.environmentMainService=H,this.telemetryService=X,this.logService=ee,this.productService=B,this.themeMainService=J,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(v.app,"browser-window-maximize",(Y,U)=>U.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(v.app,"browser-window-unmaximize",(Y,U)=>U.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(Y,U)=>U.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),P.Event.filter(P.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(Y,U)=>U.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(v.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new P.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(v.screen,"display-metrics-changed",(Y,U,z)=>z),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),P.Event.fromNodeEventEmitter(v.screen,"display-added"),P.Event.fromNodeEventEmitter(v.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors,dark:v.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(S=>{var L,_;return{id:S.id,workspace:S.openedWorkspace,title:(_=(L=S.win)===null||L===void 0?void 0:L.getTitle())!==null&&_!==void 0?_:"",filename:S.getRepresentedFilename(),dirty:S.isDocumentEdited()}})}async getWindowCount(d){return this.windowsMainService.getWindowCount()}async getActiveWindowId(d){const S=v.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(S)return S.id}openWindow(d,S,L){return Array.isArray(S)?this.doOpenWindow(d,S,L):this.doOpenEmptyWindow(d,S)}async doOpenWindow(d,S,L=Object.create(null)){S.length>0&&this.windowsMainService.open({context:5,contextWindowId:d,urisToOpen:S,cli:this.environmentMainService.args,forceNewWindow:L.forceNewWindow,forceReuseWindow:L.forceReuseWindow,preferNewWindow:L.preferNewWindow,diffMode:L.diffMode,addMode:L.addMode,gotoLineMode:L.gotoLineMode,noRecentEntry:L.noRecentEntry,waitMarkerFileURI:L.waitMarkerFileURI,remoteAuthority:L.remoteAuthority||void 0})}async doOpenEmptyWindow(d,S){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:d},S)}async toggleFullScreen(d){const S=this.windowById(d);S&&S.toggleFullScreen()}async handleTitleDoubleClick(d){const S=this.windowById(d);S&&S.handleTitleDoubleClick()}async isMaximized(d){const S=this.windowById(d);return(S==null?void 0:S.win)?S.win.isMaximized():!1}async maximizeWindow(d){const S=this.windowById(d);(S==null?void 0:S.win)&&S.win.maximize()}async unmaximizeWindow(d){const S=this.windowById(d);(S==null?void 0:S.win)&&S.win.unmaximize()}async minimizeWindow(d){const S=this.windowById(d);(S==null?void 0:S.win)&&S.win.minimize()}async focusWindow(d,S){var L;S&&typeof S.windowId=="number"&&(d=S.windowId);const _=this.windowById(d);_&&_.focus({force:(L=S==null?void 0:S.force)!==null&&L!==void 0?L:!1})}async setMinimumSize(d,S,L){const _=this.windowById(d);if(_==null?void 0:_.win){const[H,X]=_.win.getSize(),[ee,B]=_.win.getMinimumSize(),[J,Y]=[S??ee,L??B],[U,z]=[Math.max(H,J),Math.max(X,Y)];(ee!==J||B!==Y)&&_.win.setMinimumSize(J,Y),(H!==U||X!==z)&&_.win.setSize(U,z)}}async saveWindowSplash(d,S){this.themeMainService.saveWindowSplash(d,S)}async installShellCommand(d){const{source:S,target:L}=await this.getShellCommandLink();try{const{symbolicLink:_}=await w.SymlinkSupport.stat(S);if(_&&!_.dangling){const H=await b.realpath(S);if(L===H)return}await w.Promises.unlink(S)}catch(_){if(_.code!=="ENOENT")throw _}try{await w.Promises.symlink(L,S)}catch(_){if(_.code!=="EACCES"&&_.code!=="ENOENT")throw _;const{response:H}=await this.showMessageBox(d,{title:this.productService.nameLong,type:"info",message:R.localize(0,null,this.productService.nameShort),buttons:[o.mnemonicButtonLabel(R.localize(1,null)),o.mnemonicButtonLabel(R.localize(2,null))],noLink:!0,defaultId:0,cancelId:1});if(H===0)try{const X=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${L}' '${S}'\\" with administrator privileges"`;await A.promisify(m.exec)(X)}catch(X){throw new Error(R.localize(3,null,S))}}}async uninstallShellCommand(d){const{source:S}=await this.getShellCommandLink();try{await w.Promises.unlink(S)}catch(L){switch(L.code){case"EACCES":const{response:_}=await this.showMessageBox(d,{title:this.productService.nameLong,type:"info",message:R.localize(4,null,this.productService.nameShort),buttons:[o.mnemonicButtonLabel(R.localize(5,null)),o.mnemonicButtonLabel(R.localize(6,null))],noLink:!0,defaultId:0,cancelId:1});if(_===0)try{const H=`osascript -e "do shell script \\"rm '${S}'\\" with administrator privileges"`;await A.promisify(m.exec)(H)}catch(H){throw new Error(R.localize(7,null,S))}break;case"ENOENT":break;default:throw L}}}async getShellCommandLink(){const d=a.resolve(this.environmentMainService.appRoot,"bin","code"),S=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(d))throw new Error(R.localize(8,null,d));return{source:S,target:d}}async showMessageBox(d,S){return this.dialogMainService.showMessageBox(S,this.toBrowserWindow(d))}async showSaveDialog(d,S){return this.dialogMainService.showSaveDialog(S,this.toBrowserWindow(d))}async showOpenDialog(d,S){return this.dialogMainService.showOpenDialog(S,this.toBrowserWindow(d))}toBrowserWindow(d){const S=this.windowById(d);if(S==null?void 0:S.win)return S.win}async pickFileFolderAndOpen(d,S){const L=await this.dialogMainService.pickFileFolder(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openFileFolder",S.telemetryExtraData),this.doOpenPicked(await Promise.all(L.map(async _=>await w.SymlinkSupport.existsDirectory(_)?{folderUri:f.URI.file(_)}:{fileUri:f.URI.file(_)})),S,d))}async pickFolderAndOpen(d,S){const L=await this.dialogMainService.pickFolder(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openFolder",S.telemetryExtraData),this.doOpenPicked(L.map(_=>({folderUri:f.URI.file(_)})),S,d))}async pickFileAndOpen(d,S){const L=await this.dialogMainService.pickFile(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openFile",S.telemetryExtraData),this.doOpenPicked(L.map(_=>({fileUri:f.URI.file(_)})),S,d))}async pickWorkspaceAndOpen(d,S){const L=await this.dialogMainService.pickWorkspace(S);L&&(this.sendPickerTelemetry(L,S.telemetryEventName||"openWorkspace",S.telemetryExtraData),this.doOpenPicked(L.map(_=>({workspaceUri:f.URI.file(_)})),S,d))}doOpenPicked(d,S,L){this.windowsMainService.open({context:3,contextWindowId:L,cli:this.environmentMainService.args,urisToOpen:d,forceNewWindow:S.forceNewWindow})}sendPickerTelemetry(d,S,L){const _=d?d.length:0;this.telemetryService.publicLog(S,Object.assign(Object.assign({},L),{outcome:_?"success":"canceled",numberOfPaths:_}))}async showItemInFolder(d,S){v.shell.showItemInFolder(S)}async setRepresentedFilename(d,S){const L=this.windowById(d);L&&L.setRepresentedFilename(S)}async setDocumentEdited(d,S){const L=this.windowById(d);L&&L.setDocumentEdited(S)}async openExternal(d,S){return i.isLinuxSnap?this.safeSnapOpenExternal(S):v.shell.openExternal(S),!0}safeSnapOpenExternal(d){const S=process.env.GDK_PIXBUF_MODULE_FILE,L=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,v.shell.openExternal(d),process.env.GDK_PIXBUF_MODULE_FILE=S,process.env.GDK_PIXBUF_MODULEDIR=L}moveItemToTrash(d,S){return v.shell.trashItem(S)}async isAdmin(){let d;return i.isWindows?d=(await new Promise((S,L)=>{$(["native-is-elevated"],S,L)}))():d=process.getuid()===0,d}async writeElevated(d,S,L,_){const H=await new Promise((X,ee)=>{$(["sudo-prompt"],X,ee)});return new Promise((X,ee)=>{const B=[`"${this.cliPath}"`];(_==null?void 0:_.unlock)&&B.push("--file-chmod"),B.push("--file-write",`"${S.fsPath}"`,`"${L.fsPath}"`);const J={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?a.join(a.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};H.exec(B.join(" "),J,(Y,U,z)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),z&&this.logService.trace(`[sudo-prompt] received stderr: ${z}`),Y?ee(Y):X(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?a.join(a.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):a.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?a.join(a.dirname(process.execPath),"bin",`${this.productService.applicationName}`):a.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?a.join(this.environmentMainService.appRoot,"bin","code"):a.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:E.totalmem(),freemem:E.freemem(),loadavg:E.loadavg()}}async getOSProperties(){return{arch:E.arch(),platform:E.platform(),release:E.release(),type:E.type(),cpus:E.cpus()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(d,S,L){process.kill(S,L)}async readClipboardText(d,S){return v.clipboard.readText(S)}async writeClipboardText(d,S,L){return v.clipboard.writeText(S,L)}async readClipboardFindText(d){return v.clipboard.readFindText()}async writeClipboardFindText(d,S){return v.clipboard.writeFindText(S)}async writeClipboardBuffer(d,S,L,_){return v.clipboard.writeBuffer(S,Buffer.from(L),_)}async readClipboardBuffer(d,S){return v.clipboard.readBuffer(S)}async hasClipboard(d,S,L){return v.clipboard.has(S,L)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){v.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){v.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){v.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){v.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){v.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(d,S){const L=this.windowById(d);L&&L.updateTouchBar(S)}async notifyReady(d){const S=this.windowById(d);S&&S.setReady()}async relaunch(d,S){return this.lifecycleMainService.relaunch(S)}async reload(d,S){const L=this.windowById(d);if(L)return this.lifecycleMainService.reload(L,(S==null?void 0:S.disableExtensions)!==void 0?{_:[],"disable-extensions":S==null?void 0:S.disableExtensions}:void 0)}async closeWindow(d){this.closeWindowById(d,d)}async closeWindowById(d,S){const L=this.windowById(S);if(L==null?void 0:L.win)return L.win.close()}async quit(d){const S=this.windowsMainService.getLastActiveWindow();(S==null?void 0:S.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&S.win?S.win.close():this.lifecycleMainService.quit()}async exit(d,S){await this.lifecycleMainService.kill(S)}async resolveProxy(d,S){var L,_;const H=this.windowById(d),X=(_=(L=H==null?void 0:H.win)===null||L===void 0?void 0:L.webContents)===null||_===void 0?void 0:_.session;if(X)return X.resolveProxy(S)}async openDevTools(d,S){const L=this.windowById(d);(L==null?void 0:L.win)&&L.win.webContents.openDevTools(S)}async toggleDevTools(d){const S=this.windowById(d);(S==null?void 0:S.win)&&S.win.webContents.toggleDevTools()}async sendInputEvent(d,S){const L=this.windowById(d);(L==null?void 0:L.win)&&(S.type==="mouseDown"||S.type==="mouseUp")&&L.win.webContents.sendInputEvent(S)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(d,S,L,_){if(!i.isWindows)return;const H=await new Promise((X,ee)=>{$(["vscode-windows-registry"],X,ee)});try{return H.GetStringRegKey(S,L,_)}catch(X){return}}async getPassword(d,S,L){const _=await this.withKeytar(),H=await _.getPassword(S,L);if(H)try{let{content:X,hasNextChunk:ee}=JSON.parse(H);if(!X||!ee)return H;let B=1;for(;ee;){const J=await _.getPassword(S,`${L}-${B}`),Y=JSON.parse(J);X+=Y.content,ee=Y.hasNextChunk}return X}catch(X){return H}return H}async setPassword(d,S,L,_){const H=await this.withKeytar(),X=3,ee=async(B,J,Y)=>{let U=0,z;for(;U<X;)try{await H.setPassword(B,J,Y);return}catch(G){z=G,this.logService.warn("Error attempting to set a password: ",G),U++,await new Promise(N=>setTimeout(N,200))}throw z};if(i.isWindows&&_.length>ct.MAX_PASSWORD_LENGTH){let B=0,J=0,Y=!0;for(;Y;){const U=_.substring(B,B+ct.PASSWORD_CHUNK_SIZE);B+=ct.PASSWORD_CHUNK_SIZE,Y=_.length-B>0;const z={content:U,hasNextChunk:Y};await ee(S,J?`${L}-${J}`:L,JSON.stringify(z)),J++}}else await ee(S,L,_);this._onDidChangePassword.fire({service:S,account:L})}async deletePassword(d,S,L){const H=await(await this.withKeytar()).deletePassword(S,L);return H&&this._onDidChangePassword.fire({service:S,account:L}),H}async findPassword(d,S){return(await this.withKeytar()).findPassword(S)}async findCredentials(d,S){return(await this.withKeytar()).findCredentials(S)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((d,S)=>{$(["keytar"],d,S)})}windowById(d){if(typeof d=="number")return this.windowsMainService.getWindowById(d)}};h.MAX_PASSWORD_LENGTH=2500,h.PASSWORD_CHUNK_SIZE=h.MAX_PASSWORD_LENGTH-100,he([t.memoize],h.prototype,"cliPath",null),h=he([te(1,n.IWindowsMainService),te(2,M.IDialogMainService),te(3,y.ILifecycleMainService),te(4,I.IEnvironmentMainService),te(5,g.ITelemetryService),te(6,u.ILogService),te(7,l.IProductService),te(8,s.IThemeMainService)],h),e.NativeHostMainService=h}),define(Q[219],Z([0,1,2,5,81,14,6,35,45,90,27,19,25]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let f=class extends m.Disposable{constructor(D,E,c,u,a){super();this.logService=D,this.windowsMainService=E,this.nativeHostMainService=c,this.encryptionMainService=u,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=A.Event.fromNodeEventEmitter(b.app,"login",(E,c,u,a,l)=>({event:E,webContents:c,req:u,authInfo:a,callback:l}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:E,req:c,callback:u}){if(!E.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(E);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(a==null?void 0:a.username,a==null?void 0:a.password)}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const E=await this.doResolveProxyCredentials(D);if(E)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),E;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var E,c,u,a;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const l=String(R.hash({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const p=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l);if(p){const d=JSON.parse(await this.encryptionMainService.decrypt(p));t=d.username,r=d.password}}catch(p){this.logService.error(p)}if(this.state!==w.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const o={authInfo:D,username:(c=(E=this.sessionCredentials)===null||E===void 0?void 0:E.username)!==null&&c!==void 0?c:t,password:(a=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&a!==void 0?a:r,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,o),this.state=w.LoginDialogShown;const h=await new Promise(p=>{var d;const S=async(L,_,H)=>{var X;if(_===o.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",S),H){const ee={username:H.username,password:H.password};try{if(H.remember){const B=await this.encryptionMainService.encrypt(JSON.stringify(ee));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l,B)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l)}catch(B){this.logService.error(B)}p({username:ee.username,password:ee.password})}else p(void 0)};(d=s.win)===null||d===void 0||d.webContents.on("ipc-message",S)});return this.sessionCredentials=h,h}};f=he([te(0,P.ILogService),te(1,n.IWindowsMainService),te(2,v.INativeHostMainService),te(3,y.IEncryptionMainService),te(4,I.IProductService)],f),e.ProxyAuthHandler=f}),define(Q[220],Z([0,1,217,155,35,56,2,34,57,176,3,5,80,106,9,21,45]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function E(a){return a<21}let c=class{constructor(l,t,r,s,o){this.windowServer=l,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new I.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,t){await this.whenUnfrozen(l);const r=w.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(l,s)}async _dispatchKeybinding(l,t){if(t instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(l);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,o=new v.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),p=new y.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),d=[];t.ctrlKey&&d.push("ctrl"),t.metaKey&&d.push("meta"),t.shiftKey&&d.push("shift"),t.altKey&&d.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:p,modifiers:d}),E(t.keyCode)||s.sendInputEvent({type:"char",keyCode:p,modifiers:d}),s.sendInputEvent({type:"keyUp",keyCode:p,modifiers:d}),await f.timeout(100)}async click(l,t,r,s){await(await this.getWindowDriver(l)).click(t,r,s)}async doubleClick(l,t){await(await this.getWindowDriver(l)).doubleClick(t)}async setValue(l,t,r){await(await this.getWindowDriver(l)).setValue(t,r)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,t){return await(await this.getWindowDriver(l)).isActiveElement(t)}async getElements(l,t,r){return await(await this.getWindowDriver(l)).getElements(t,r)}async getElementXY(l,t,r,s){return await(await this.getWindowDriver(l)).getElementXY(t,r,s)}async typeInEditor(l,t,r){await(await this.getWindowDriver(l)).typeInEditor(t,r)}async getTerminalBuffer(l,t){return await(await this.getWindowDriver(l)).getTerminalBuffer(t)}async writeInTerminal(l,t,r){await(await this.getWindowDriver(l)).writeInTerminal(t,r)}async getWindowDriver(l){await this.whenUnfrozen(l);const t=`window:${l}`,r=new n.StaticRouter(o=>o===t),s=this.windowServer.getChannel("windowDriver",r);return new A.WindowDriverChannelClient(s)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await I.Event.toPromise(this.onDidReloadingChange.event)}};c=he([te(2,R.IWindowsMainService),te(3,g.ILifecycleMainService),te(4,D.INativeHostMainService)],c),e.Driver=c;async function u(a,l,t,r){const s=t.driverVerbose,o=r.createInstance(c,a,{verbose:s}),h=new m.WindowDriverRegistryChannel(o);a.registerChannel("windowDriverRegistry",h);const p=await b.serve(l),d=new m.DriverChannel(o);return p.registerChannel("driver",d),P.combinedDisposable(p,a)}e.serve=u}),define(Q[221],Z([0,1,59,56]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,b,P,n){const v=i=>n(i,void 0),y=m.createConnection({host:R,port:b},()=>{y.removeListener("error",v);const i=Buffer.alloc(16);for(let f=0;f<16;f++)i[f]=Math.round(Math.random()*256);const I=i.toString("base64");let M=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${b}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];y.write(M.join(`\r
`)+`\r
\r
`);const w=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",w),n(void 0,new A.NodeSocket(y)))};y.on("data",w)});y.once("error",v)}}}),define(Q[222],Z([0,1,59,9,2,115,20,6,19,191,74,221,75]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function w(E,c,u,a,l){return new f(E,c,u,a,l).waitForReady()}class f extends R.Disposable{constructor(c,u,a,l,t){super();this.defaultTunnelHost=u,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=m.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){var c;let u=await b.findFreePortFaster((c=this.suggestedLocalPort)!==null&&c!==void 0?c:this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const u=await y.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),a=u.getSocket().socket,l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&c.write(l.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),a.end()}),c.on("close",()=>a.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),a.destroy()}),a.on("end",()=>c.end()),a.on("close",()=>c.end()),a.on("error",()=>{c.destroy()}),c.pipe(a),a.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),a.end()})}}let g=class extends i.AbstractTunnelService{constructor(c,u,a,l,t){super(u);this.socketFactory=c,this.signService=a,this.productService=l,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,u,a,l,t,r){const s=this.getTunnelFromMap(u,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,a,l,t,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${a} on local port ${l}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},h=w(o,this.defaultTunnelHost,u,a,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,a,h),h}}};g=he([te(1,n.ILogService),te(2,M.ISignService),te(3,v.IProductService),te(4,P.IConfigurationService)],g),e.BaseTunnelService=g;let D=class extends g{constructor(c,u,a,l){super(I.nodeSocketFactory,c,u,a,l)}};D=he([te(0,n.ILogService),te(1,M.ISignService),te(2,v.IProductService),te(3,P.IConfigurationService)],D),e.TunnelService=D}),define(Q[223],Z([0,1,216,193,2,13,22,192,20,6,16,47,92]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends R.Disposable{constructor(g,D,E){super();this.environmentService=D,this.logService=E,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,D){this.logService.trace("RequestService#request",g.url);const{proxyUrl:E,strictSSL:c}=this,u=Object.assign(Object.assign({},process.env),await M.resolveShellEnv(this.logService,this.environmentService.args,process.env)),a=g.agent?g.agent:await n.getProxyAgent(g.url||"",u,{proxyUrl:E,strictSSL:c});return g.agent=a,g.strictSSL=c,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,D)}async getNodeRequest(g){return(A.parse(g.url).protocol==="https:"?await new Promise((c,u)=>{$(["https"],c,u)}):await new Promise((c,u)=>{$(["http"],c,u)})).request}_request(g,D){return new Promise(async(E,c)=>{let u;const a=A.parse(g.url),l=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:b.isBoolean(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),u=l(t,r=>{const s=b.isNumber(g.followRedirects)?g.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},g),{url:r.headers.location,followRedirects:s-1}),D).then(E,c);else{let o=r;r.headers["content-encoding"]==="gzip"&&(o=r.pipe(m.createGunzip())),E({res:r,stream:i.streamToBufferReadableStream(o)})}}),u.on("error",c),g.timeout&&u.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&u.write(g.data),u.end(),D.onCancellationRequested(()=>{u.abort(),c(P.canceled())})})}async resolveProxy(g){}};w=he([te(0,v.IConfigurationService),te(1,I.INativeEnvironmentService),te(2,y.ILogService)],w),e.RequestService=w}),define(Q[224],Z([0,1,223,14]),function($,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(P){return A.net.request}class b extends m.RequestService{request(n,v){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:R}),v)}}e.RequestMainService=b}),define(Q[225],Z([0,1,48,14,24,9,6,21,60,10,3,2,86,13,5,55]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends I.Disposable{constructor(c,u,a,l,t,r,s){super();this.machineId=c,this.userEnv=u,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new b.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new f.Emitter),this.onDidError=f.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),A.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,u)=>this.onWindowConnection(c,u))}async onWindowConnection(c,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(c.sender.isDestroyed())return a.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[a])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>A.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>A.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new A.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var u;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,u,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:u}})))}async connect(){await this.whenIpcReady;const c=w.assertIsDefined(this.window);return M.connect(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,u;return(u=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&u!==void 0?u:!1}};D=he([te(2,R.IEnvironmentMainService),te(3,n.ILifecycleMainService),te(4,P.ILogService),te(5,v.IThemeMainService),te(6,g.IProtocolMainService)],D),e.SharedProcess=D}),define(Q[226],Z([0,1,7,8,13,6,24,9,18,16]),function($,e,m,A,R,b,P,n,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(w,f,g){this.storagePath=w,this.logService=f,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,f){const g=this.storage[w];return R.isUndefinedOrNull(g)?f:g}setItem(w,f){this.setItems([{key:w,data:f}])}setItems(w){let f=!1;for(const{key:g,data:D}of w)this.storage[g]!==D&&(R.isUndefinedOrNull(D)?R.isUndefined(this.storage[g])||(this.storage[g]=void 0,f=!0):(this.storage[g]=D,f=!0));f&&this.save()}removeItem(w){R.isUndefined(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,y.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(f){this.logService.error(f)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class bt{constructor(w,f,g){this.fileStorage=new i(m.URI.file(A.join(w.userDataPath,bt.STATE_FILE)),f,g)}async init(){return this.fileStorage.init()}getItem(w,f){return this.fileStorage.getItem(w,f)}setItem(w,f){this.fileStorage.setItem(w,f)}setItems(w){this.fileStorage.setItems(w)}removeItem(w){this.fileStorage.removeItem(w)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,P.IEnvironmentMainService),te(1,b.ILogService),te(2,v.IFileService)],I),e.StateMainService=I}),define(Q[77],Z([0,1,5,9,20,21,19,42,24,6,50,25]),function($,e,m,A,R,b,P,n,v,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function M(f,g,D){return`${D.updateUrl}/api/update/${f}/${g}/${D.commit}`}e.createUpdateURL=M;let w=class{constructor(g,D,E,c,u,a){this.lifecycleMainService=g,this.configurationService=D,this.environmentMainService=E,this.requestService=c,this.logService=u,this.productService=a,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=R.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(g);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,E=>this.logService.error(E))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return A.timeout(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},I.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};w=he([te(0,b.ILifecycleMainService),te(1,R.IConfigurationService),te(2,v.IEnvironmentMainService),te(3,i.IRequestService),te(4,y.ILogService),te(5,P.IProductService)],w),e.AbstractUpdateService=w}),define(Q[227],Z([0,1,14,2,5,46,20,21,42,32,24,6,77,50,19]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends M.AbstractUpdateService{constructor(E,c,u,a,l,t,r){super(E,c,a,l,t,r);this.telemetryService=u,this.disposables=new A.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"error",(E,c)=>c)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(E,c,u)=>({url:c,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(E,c,u,a)=>({releaseNotes:c,version:u,productVersion:u,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(E){this.logService.error("UpdateService error:",E);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?E:void 0;this.setState(v.State.Idle(1,u))}buildUpdateFeedUrl(E){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const u=M.createUpdateURL(c,E,this.productService);try{m.autoUpdater.setFeedURL({url:u})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return u}doCheckForUpdates(E){this.setState(v.State.CheckingForUpdates(E)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(E){this.state.type==="checking for updates"&&this.setState(v.State.Downloading(E))}onUpdateDownloaded(E){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:E.version}),this.setState(v.State.Ready(E)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(v.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([b.memoize],g.prototype,"onRawError",null),he([b.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([b.memoize],g.prototype,"onRawUpdateAvailable",null),he([b.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([te(0,n.ILifecycleMainService),te(1,P.IConfigurationService),te(2,y.ITelemetryService),te(3,i.IEnvironmentMainService),te(4,w.IRequestService),te(5,I.ILogService),te(6,f.IProductService)],g),e.DarwinUpdateService=g}),define(Q[228],Z([0,1,19,20,21,42,32,24,6,77,50,25,45]),function($,e,m,A,R,b,P,n,v,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends y.AbstractUpdateService{constructor(g,D,E,c,u,a,l,t){super(g,D,c,u,a,t);this.telemetryService=E,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return y.createUpdateURL(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},I.CancellationToken.None).then(i.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const E=g?D.message||D:void 0;this.setState(b.State.Idle(1,E))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};w=he([te(0,R.ILifecycleMainService),te(1,A.IConfigurationService),te(2,P.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,i.IRequestService),te(5,v.ILogService),te(6,M.INativeHostMainService),te(7,m.IProductService)],w),e.LinuxUpdateService=w}),define(Q[229],Z([0,1,5,9,21,42,24,6,8,31,41,32]),function($,e,m,A,R,b,P,n,v,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let M=class{constructor(g,D,E){if(this.lifecycleMainService=g,this.logService=E,this._state=b.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return A.timeout(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};M=he([te(0,R.ILifecycleMainService),te(1,P.IEnvironmentMainService),te(2,n.ILogService)],M);let w=class extends M{constructor(g,D,E,c,u,a){super(E,c,u);this.snap=g,this.snapRevision=D,this.telemetryService=a;const l=y.watch(v.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(l,"change",(h,p)=>p),r=m.Event.filter(t,h=>h==="current"),o=m.Event.debounce(r,(h,p)=>p,2e3)(()=>this.checkForUpdates(!1));E.onWillShutdown(()=>{o.dispose(),l.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+v.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((E,c)=>y.realpath(`${v.dirname(this.snap)}/current`,(u,a)=>u?c(u):E(a))),D=v.basename(g);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=he([te(2,R.ILifecycleMainService),te(3,P.IEnvironmentMainService),te(4,n.ILogService),te(5,I.ITelemetryService)],w),e.SnapUpdateService=w}),define(Q[230],Z([0,1,31,8,17,46,20,21,19,42,32,24,6,77,50,112,26,41,25,9,18,7,45]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(p,d=1e3){for(;!p();)await u.timeout(d)}let s;function o(){return typeof s=="undefined"&&(s=m.existsSync(A.join(A.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends w.AbstractUpdateService{constructor(d,S,L,_,H,X,ee,B,J){super(d,S,_,H,X,J);this.telemetryService=L,this.fileService=ee,this.nativeHostMainService=B}get cachePath(){const d=A.join(D.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return R.Promises.mkdir(d,{recursive:!0}).then(()=>d)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(d){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),o()===1?S+="-archive":this.productService.target==="user"&&(S+="-user"),w.createUpdateURL(S,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(y.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},c.CancellationToken.None).then(f.asJson).then(S=>{const L=o();return!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(y.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(y.State.AvailableForDownload(S)),Promise.resolve(null)):(this.setState(y.State.Downloading(S)),this.cleanup(S.version).then(()=>this.getUpdatePackagePath(S.version).then(_=>R.Promises.exists(_).then(H=>{if(H)return Promise.resolve(_);const X=S.url,ee=S.hash,B=`${_}.tmp`;return this.requestService.request({url:X},c.CancellationToken.None).then(J=>this.fileService.writeFile(l.URI.file(B),J.stream)).then(ee?()=>g.checksum(B,S.hash):()=>{}).then(()=>R.Promises.rename(B,_)).then(()=>_)})).then(_=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:_},H&&S.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(S)):this.setState(y.State.Ready(S))})))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const L=d?S.message||S:void 0;this.setState(y.State.Idle(o(),L))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(y.State.Idle(o()))}async getUpdatePackagePath(d){const S=await this.cachePath;return A.join(S,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const S=d?X=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(X):()=>!0,L=await this.cachePath,H=(await R.Promises.readdir(L)).filter(S).map(async X=>{try{await R.Promises.unlink(A.join(L,X))}catch(ee){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(y.State.Updating(d));const S=await this.cachePath;this.availableUpdate.updateFilePath=A.join(S,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await R.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),E.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(o()))});const _=`${this.productService.win32MutexName}-ready`,H=await new Promise((X,ee)=>{$(["windows-mutex"],X,ee)});r(()=>H.isActive(_)).then(()=>this.setState(y.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):E.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};he([b.memoize],h.prototype,"cachePath",null),h=he([te(0,n.ILifecycleMainService),te(1,P.IConfigurationService),te(2,i.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,f.IRequestService),te(5,M.ILogService),te(6,a.IFileService),te(7,t.INativeHostMainService),te(8,v.IProductService)],h),e.Win32UpdateService=h}),define(Q[53],Z([0,1,28,24,8,17,31,3,5,6,58,40,10,2,15,4,153,19,14,13,51,52,101,30]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=g.createDecorator("workspacesManagementMainService");let s=class extends w.Disposable{constructor(d,S,L,_,H){super();this.environmentMainService=d,this.logService=S,this.backupMainService=L,this.dialogMainService=_,this.productService=H,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new v.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new v.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(d){if(!this.isWorkspacePath(d)||d.scheme!==M.Schemas.file)return;let S;try{S=P.readFileSync(d.fsPath,"utf8")}catch(L){return}return this.doResolveWorkspace(d,S)}isWorkspacePath(d){return m.isUntitledWorkspace(d,this.environmentMainService)||m.hasWorkspaceFileExtension(d)}doResolveWorkspace(d,S){try{const L=this.doParseStoredWorkspace(d,S),_=o(d);return{id:_.id,configPath:_.configPath,folders:m.toWorkspaceFolders(L.folders,_.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:L.remoteAuthority}}catch(L){this.logService.warn(L.toString())}}doParseStoredWorkspace(d,S){const L=I.parse(S);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(_=>m.isStoredWorkspaceFolder(_));else throw new Error(`${d.toString(!0)} looks like an invalid workspace file.`);return L}async createUntitledWorkspace(d,S){const{workspace:L,storedWorkspace:_}=this.newUntitledWorkspace(d,S),H=L.configPath.fsPath;return await b.Promises.mkdir(R.dirname(H),{recursive:!0}),await b.Promises.writeFile(H,JSON.stringify(_,null,"	")),L}createUntitledWorkspaceSync(d,S){const{workspace:L,storedWorkspace:_}=this.newUntitledWorkspace(d,S),H=L.configPath.fsPath;return P.mkdirSync(R.dirname(H),{recursive:!0}),b.writeFileSync(H,JSON.stringify(_,null,"	")),L}newUntitledWorkspace(d=[],S){const L=(Date.now()+Math.round(Math.random()*1e3)).toString(),_=f.joinPath(this.untitledWorkspacesHome,L),H=f.joinPath(_,m.UNTITLED_WORKSPACE_NAME),X=[];for(const ee of d)X.push(m.getStoredWorkspaceFolder(ee.uri,!0,ee.name,_,!n.isWindows,f.extUriBiasedIgnorePathCase));return{workspace:o(H),storedWorkspace:{folders:X,remoteAuthority:S}}}async getWorkspaceIdentifier(d){return o(d)}isUntitledWorkspace(d){return m.isUntitledWorkspace(d.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(d){!this.isUntitledWorkspace(d)||(this.doDeleteUntitledWorkspaceSync(d),this._onDidDeleteUntitledWorkspace.fire(d))}async deleteUntitledWorkspace(d){this.deleteUntitledWorkspaceSync(d)}doDeleteUntitledWorkspaceSync(d){const S=f.originalFSPath(d.configPath);try{b.rimrafSync(R.dirname(S));const L=R.join(this.environmentMainService.workspaceStorageHome.fsPath,d.id);P.existsSync(L)&&b.writeFileSync(R.join(L,"obsolete"),"")}catch(L){this.logService.warn(`Unable to delete untitled workspace ${S} (${L}).`)}}getUntitledWorkspacesSync(){const d=[];try{const S=b.readdirSync(this.untitledWorkspacesHome.fsPath).map(L=>f.joinPath(this.untitledWorkspacesHome,L,m.UNTITLED_WORKSPACE_NAME));for(const L of S){const _=o(L),H=this.resolveLocalWorkspaceSync(L);H?d.push({workspace:_,remoteAuthority:H.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(_)}}catch(S){S.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${S}).`)}return d}async enterWorkspace(d,S,L){if(!d||!d.win||!d.isReady||!await this.isValidTargetWorkspacePath(d,S,L))return;const H=this.doEnterWorkspace(d,o(L));if(!!H)return this._onDidEnterWorkspace.fire({window:d,workspace:H.workspace}),H}async isValidTargetWorkspacePath(d,S,L){if(!L)return!0;if(m.isWorkspaceIdentifier(d.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(d.openedWorkspace.configPath,L))return!1;if(t.findWindowOnWorkspaceOrFolder(S,L)){const _={title:this.productService.nameLong,type:"info",buttons:[r.mnemonicButtonLabel(D.localize(0,null))],message:D.localize(1,null,f.basename(L)),detail:D.localize(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(_,u.withNullAsUndefined(c.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(d,S){if(!d.config)return;d.focus();let L;return d.config.extensionDevelopmentPath||(L=this.backupMainService.registerWorkspaceBackupSync({workspace:S,remoteAuthority:d.remoteAuthority},d.config.backupPath)),m.isWorkspaceIdentifier(d.openedWorkspace)&&this.isUntitledWorkspace(d.openedWorkspace)&&this.deleteUntitledWorkspaceSync(d.openedWorkspace),d.config.workspace=S,d.config.backupPath=L,{workspace:S,backupPath:L}}};s=he([te(0,A.IEnvironmentMainService),te(1,y.ILogService),te(2,a.IBackupMainService),te(3,l.IDialogMainService),te(4,E.IProductService)],s),e.WorkspacesManagementMainService=s;function o(p){function d(){let S=p.scheme===M.Schemas.file?f.originalFSPath(p):p.toString();return n.isLinux||(S=S.toLowerCase()),i.createHash("md5").update(S).digest("hex")}return{id:d(),configPath:p}}e.getWorkspaceIdentifier=o;function h(p,d){function S(){if(p.scheme!==M.Schemas.file)return i.createHash("md5").update(p.toString()).digest("hex");if(!d)try{d=P.statSync(p.fsPath)}catch(H){return}let _;return n.isLinux?_=d.ino:n.isMacintosh?_=d.birthtime.getTime():n.isWindows&&(typeof d.birthtimeMs=="number"?_=Math.floor(d.birthtimeMs):_=d.birthtime.getTime()),i.createHash("md5").update(p.fsPath).update(_?String(_):"").digest("hex")}const L=S();if(typeof L=="string")return{id:L,uri:p}}e.getSingleFolderWorkspaceIdentifier=h}),define(Q[102],Z([0,1,6,99,3,4,35,17,53,20,7,14,36,54,25,28,13]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=b.createDecorator(e.ID);let E=class{constructor(u,a,l,t,r){this.logService=u,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=t,this.configurationService=r}async start(u,a){this.logService.trace("Received data from other instance: ",u,a),R.isMacintosh&&I.app.focus({steal:!0});const l=this.parseOpenUrl(u);if(l.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of l)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(u,a)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?M.coalesce(u._urls.map(a=>{try{return{uri:i.URI.parse(a),url:a}}catch(l){return null}})):[]}async startOpenWindow(u,a){const l=w.isLaunchedFromCli(a)?0:4;let t=[];const r=u.wait&&u.waitMarkerFilePath?i.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:l,cli:u,userEnv:a,waitMarkerFileURI:r,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let o=!1;if(u["new-window"]||u["unity-launch"])o=!0;else if(u["reuse-window"])o=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!R.isMacintosh}}if(o)t=this.windowsMainService.open({context:l,cli:u,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:l,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:l,cli:u,userEnv:a,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:u.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return I.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?u.push(this.codeWindowToInfo(l)):u.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const o=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",f.CancellationToken.None,{replyChannel:o,args:h}),I.ipcMain.once(o,(p,d)=>{d||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(d)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const a=[],l=u.openedWorkspace;if(g.isSingleFolderWorkspaceIdentifier(l))a.push(l.uri);else if(g.isWorkspaceIdentifier(l)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);t&&t.folders.forEach(s=>{a.push(s.uri)})}return a}codeWindowToInfo(u){const a=this.getFolderURIs(u),l=D.assertIsDefined(u.win);return this.browserWindowToInfo(l,a,u.remoteAuthority)}browserWindowToInfo(u,a=[],l){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:a,remoteAuthority:l}}};E=he([te(0,m.ILogService),te(1,P.IWindowsMainService),te(2,A.IURLService),te(3,v.IWorkspacesManagementMainService),te(4,y.IConfigurationService)],E),e.LaunchMainService=E}),define(Q[231],Z([0,1,143,26,48,14,102,70,24,3,6,84,52,4,61,10,45,55,2,30,19]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=w.createDecorator("issueMainService");let l=class Et{constructor(r,s,o,h,p,d,S,L,_){this.userEnv=r,this.environmentMainService=s,this.launchMainService=o,this.logService=h,this.diagnosticsService=p,this.dialogMainService=d,this.nativeHostMainService=S,this.protocolMainService=L,this.productService=_,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){b.ipcMain.on("vscode:issueSystemInfoRequest",async r=>{const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),h=await this.diagnosticsService.getSystemInfo(s,o);this.safeSend(r,"vscode:issueSystemInfoResponse",h)}),b.ipcMain.on("vscode:listProcesses",async r=>{const s=[];try{const o=await this.launchMainService.getMainProcessId();s.push({name:m.localize(0,null),rootProcess:await I.listProcesses(o)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(p=>{n.isRemoteDiagnosticError(p)?s.push({name:p.hostName,rootProcess:p}):p.processes&&s.push({name:p.hostName,rootProcess:p.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(r,"vscode:listProcessesResponse",s)}),b.ipcMain.on("vscode:issueReporterClipboard",async r=>{const s={title:this.productService.nameLong,message:m.localize(1,null),type:"warning",buttons:[u.mnemonicButtonLabel(m.localize(2,null)),u.mnemonicButtonLabel(m.localize(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(r,"vscode:issueReporterClipboardResponse",o.response===0)}}),b.ipcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const s=await this.getPerformanceInfo();this.safeSend(r,"vscode:issuePerformanceInfoResponse",s)}),b.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.productService.nameLong,message:m.localize(4,null),type:"warning",buttons:[u.mnemonicButtonLabel(m.localize(5,null)),u.mnemonicButtonLabel(m.localize(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(r,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),b.ipcMain.on("vscode:workbenchCommand",(r,s)=>{const{id:o,from:h,args:p}=s;let d;switch(h){case"issueReporter":d=this.issueReporterParentWindow;break;case"processExplorer":d=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${h}`)}d&&d.webContents.send("vscode:runAction",{id:o,from:h,args:p})}),b.ipcMain.on("vscode:openExternal",(r,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),b.ipcMain.on("vscode:closeIssueReporter",r=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),b.ipcMain.on("vscode:closeProcessExplorer",r=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),b.ipcMain.on("vscode:windowsInfoRequest",async r=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(r,"vscode:windowsInfoResponse",s.windows)})}safeSend(r,s,...o){r.sender.isDestroyed()||r.sender.send(s,...o)}async openReporter(r){var s;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new c.DisposableStore,h=o.add(this.protocolMainService.createIPCObjectUrl()),p=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(p,h,{backgroundColor:r.styles.backgroundColor,title:m.localize(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1}),h.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:r,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:A.type(),arch:A.arch(),release:A.release()},product:R.default}),this.issueReporterWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}(s=this.issueReporterWindow)===null||s===void 0||s.focus()}async openProcessExplorer(r){var s;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new c.DisposableStore,h=o.add(this.protocolMainService.createIPCObjectUrl()),p=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(p,h,{backgroundColor:r.styles.backgroundColor,title:m.localize(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0}),h.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:r,product:R.default}),this.processExplorerWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}(s=this.processExplorerWindow)===null||s===void 0||s.focus()}createBrowserWindow(r,s,o){const h=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:o.title,backgroundColor:o.backgroundColor||Et.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:f.zoomLevelToZoomFactor(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(r,s)}getWindowPosition(r,s,o){let h;const p=b.screen.getAllDisplays();if(p.length===1)h=p[0];else{if(y.isMacintosh){const L=b.screen.getCursorScreenPoint();h=b.screen.getDisplayNearestPoint(L)}!h&&r&&(h=b.screen.getDisplayMatching(r.getBounds())),h||(h=b.screen.getPrimaryDisplay()||p[0])}const d={width:s,height:o},S=h.bounds;return d.x=S.x+S.width/2-d.width/2,d.y=S.y+S.height/2-d.height/2,S.width>0&&S.height>0&&(d.x<S.x&&(d.x=S.x),d.y<S.y&&(d.y=S.y),d.x>S.x+S.width&&(d.x=S.x),d.y>S.y+S.height&&(d.y=S.y),d.width>S.width&&(d.width=S.width),d.height>S.height&&(d.height=S.height)),d}async getPerformanceInfo(){try{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(r,s)}catch(r){throw this.logService.warn("issueService#getPerformanceInfo ",r.message),r}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([te(1,v.IEnvironmentMainService),te(2,P.ILaunchMainService),te(3,i.ILogService),te(4,n.IDiagnosticsService),te(5,M.IDialogMainService),te(6,D.INativeHostMainService),te(7,E.IProtocolMainService),te(8,a.IProductService)],l),e.IssueMainService=l}),define(Q[232],Z([0,1,8,149,72,5,7,14,24,6,20,19,61,2,3,35,28,53,51,199,60,32,52,30,203,21,100,18,10,54,25,55]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t,r,s,o,h,p,d,S,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.LOADING=1]="LOADING",ee[ee.NAVIGATING=2]="NAVIGATING",ee[ee.READY=3]="READY"})(H||(H={}));let X=class extends w.Disposable{constructor(B,J,Y,U,z,G,N,F,T,O,k,W,C,V){super();this.logService=J,this.environmentMainService=Y,this.fileService=U,this.configurationService=G,this.themeMainService=N,this.workspacesManagementMainService=F,this.backupMainService=T,this.telemetryService=O,this.dialogMainService=k,this.lifecycleMainService=W,this.productService=C,this.protocolMainService=V,this._onWillLoad=this._register(new b.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new b.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new b.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new b.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[K,q]=this.restoreWindowState(B.state);this.windowState=K,this.logService.trace("window#ctor: using window state",K);const x=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!x,title:this.productService.nameLong,webPreferences:Object.assign({preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:f.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:M.zoomLevelToZoomFactor(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};f.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${f.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),f.isLinux?re.icon=m.join(this.environmentMainService.appRoot,"resources/linux/code.png"):f.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=m.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),f.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),f.isMacintosh&&(re.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(re.acceptFirstMouse=!1));const se=f.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;se&&(re.tabbingIdentifier=this.productService.nameShort);const le=M.getTitleBarStyle(this.configurationService)==="custom";if(le&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,f.isMacintosh||(re.frame=!1)),R.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(re),R.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),f.isMacintosh&&le&&this._win.setSheetOffset(22),f.isMacintosh&&q&&(!se||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}x&&(R.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),R.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=u.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:K=>z.globalStorage.get(K),store:(K,q)=>z.globalStorage.set(K,q)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){f.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return f.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){f.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return f.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){f.isMacintosh&&(B==null?void 0:B.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function J(){Y.dispose(),U.dispose(),B()}const Y=this.onDidClose(()=>J()),U=this.onWillLoad(()=>J())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,G)=>this.onWindowError(2,G)),this._win.webContents.on("did-fail-load",(z,G,N)=>this.onWindowError(3,{reason:N,exitCode:G})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),J=z=>{for(let G=z;G;G=G.parent)if(G.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Y=z=>z.resourceType==="xhr"||J(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,G)=>{const N=P.URI.parse(z.url);return N.path.endsWith(".svg")&&!(B.has(N.scheme)||N.path.includes(d.Schemas.vscodeRemoteResource))?G({cancel:!Y(z)}):G({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,G)=>{const N=z.responseHeaders,F=N["content-type"]||N["Content-Type"];if(F&&Array.isArray(F)){const T=P.URI.parse(z.url);if(T.path.endsWith(".svg")&&B.has(T.scheme))return N["Content-Type"]=["image/svg+xml"],G({cancel:!1,responseHeaders:N});if(!T.path.includes(d.Schemas.vscodeRemoteResource)&&F.some(O=>O.toLowerCase().includes("image/svg")))return G({cancel:!Y(z)})}return G({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(z,G)=>{const N=await this.marketplaceHeadersPromise;G({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,N)})})}async onWindowError(B,J){var Y;switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${(J==null?void 0:J.reason)||"<unknown>"}, code: ${(J==null?void 0:J.exitCode)||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window (reason: ${(J==null?void 0:J.reason)||"<unknown>"}, code: ${(J==null?void 0:J.exitCode)||"<unknown>"})`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:B,reason:J==null?void 0:J.reason,code:J==null?void 0:J.exitCode}),B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(A.localize(0,null)),r.mnemonicButtonLabel(A.localize(1,null)),r.mnemonicButtonLabel(A.localize(2,null))],message:A.localize(3,null),detail:A.localize(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(B===2){let U;J?U=A.localize(6,null,J.reason,(Y=J.exitCode)!==null&&Y!==void 0?Y:"<unknown>"):U=A.localize(5,null);const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(A.localize(7,null)),r.mnemonicButtonLabel(A.localize(8,null))],message:U,detail:A.localize(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;z.response===0?this.reload():z.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var J;((J=this.openedWorkspace)===null||J===void 0?void 0:J.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let J=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(J==null?void 0:J.endsWith("/"))&&(J=J.substr(0,J.length-1));const Y=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((J||"").indexOf("@")===-1&&(J!==this.currentHttpProxy||Y!==this.currentNoProxy)){this.currentHttpProxy=J,this.currentNoProxy=Y;const U=J||"",z=Y?`${Y},<local>`:"<local>";this.logService.trace(`Setting proxy to '${U}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:U,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(B){f.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,J=Object.create(null)){this.isDocumentEdited()&&(!J.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),J.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(B,J),this.readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:B.workspace})}updateConfiguration(B,J){var Y,U;const z=(U=(Y=this.currentConfig)!==null&&Y!==void 0?Y:this.pendingLoadConfig)===null||U===void 0?void 0:U.userEnv;z&&S.isLaunchedFromCli(z)&&!S.isLaunchedFromCli(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},z),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),J.disableExtensions!==void 0&&(B["disable-extensions"]=J.disableExtensions),B.fullscreen=this.isFullScreen,B.maximized=this._win.isMaximized(),B.partsSplash=this.themeMainService.getWindowSplash(),R.mark("code/willOpenNewWindow"),B.perfMarks=R.getMarks(),this.configObjectUrl.update(B)}async reload(B){const J=Object.assign({},this.currentConfig);J.workspace=await this.validateWorkspace(J),delete J.filesToOpenOrCreate,delete J.filesToDiff,delete J.filesToWait,this.isExtensionDevelopmentHost&&B&&(J.verbose=B.verbose,J.debugId=B.debugId,J["inspect-extensions"]=B["inspect-extensions"],J["inspect-brk-extensions"]=B["inspect-brk-extensions"],J["extensions-dir"]=B["extensions-dir"]),J.isInitialStartup=!1,this.load(J,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspace(B){if(D.isWorkspaceIdentifier(B.workspace)){const J=B.workspace.configPath;if(J.scheme===d.Schemas.file&&!await this.fileService.exists(J))return}else if(D.isSingleFolderWorkspaceIdentifier(B.workspace)){const J=B.workspace.uri;if(J.scheme===d.Schemas.file&&!await this.fileService.exists(J))return}return B.workspace}serializeWindowState(){if(!this._win)return g.defaultWindowState();if(this.isFullScreen){let Y;try{Y=n.screen.getDisplayMatching(this.getBounds())}catch(G){}const U=g.defaultWindowState();return{mode:3,display:Y?Y.id:void 0,width:this.windowState.width||U.width,height:this.windowState.height||U.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let J;if(!f.isMacintosh&&this._win.isMaximized()?J=0:J=1,J===0?B.mode=0:B.mode=1,J===1||J===0){let Y;J===1?Y=this.getBounds():Y=this._win.getNormalBounds(),B.x=Y.x,B.y=Y.y,B.width=Y.width,B.height=Y.height}return B}restoreWindowState(B){R.mark("code/willRestoreCodeWindowState");let J=!1;if(B)try{const Y=n.screen.getAllDisplays();J=Y.length>1,B=this.validateWindowState(B,Y)}catch(Y){this.logService.warn(`Unexpected error validating window state: ${Y}
${Y.stack}`)}return R.mark("code/didRestoreCodeWindowState"),[B||g.defaultWindowState(),J]}validateWindowState(B,J){var Y,U;if(this.logService.trace(`window#validateWindowState: validating window state on ${J.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(J.length===1){const N=this.getWorkingArea(J[0]);if(N){let F=function(){!B||typeof B.x!="number"||typeof B.y!="number"||!N||(B.x<N.x&&(B.x=N.x),B.y<N.y&&(B.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),F(),B.width>N.width&&(B.width=N.width),B.height>N.height&&(B.height=N.height),B.x>N.x+N.width-128&&(B.x=N.x+N.width-B.width),B.y>N.y+N.height-128&&(B.y=N.y+N.height-B.height),F()}return B}if(B.display&&B.mode===3){const N=J.find(F=>F.id===B.display);if(N&&typeof((Y=N.bounds)===null||Y===void 0?void 0:Y.x)=="number"&&typeof((U=N.bounds)===null||U===void 0?void 0:U.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=g.defaultWindowState(3);return F.x=N.bounds.x,F.y=N.bounds.y,F}}let z,G;try{z=n.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),G=this.getWorkingArea(z)}catch(N){}if(z&&G&&B.x+B.width>G.x&&B.y+B.height>G.y&&B.x<G.x+G.width&&B.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,J]=this._win.getPosition(),[Y,U]=this._win.getSize();return{x:B,y:J,width:Y,height:U}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=M.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,J=!0){f.isMacintosh||(B==="toggle"&&J&&this.send("vscode:showInfoMessage",A.localize(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const J=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!J),this._win.autoHideMenuBar=J;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(f.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,J,...Y){this.isReady?this.send(B,...Y):this.ready().then(()=>{J.isCancellationRequested||this.send(B,...Y)})}send(B,...J){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...J)}}updateTouchBar(B){!f.isMacintosh||this.touchBarGroups.forEach((J,Y)=>{const U=B[Y];J.segments=this.createTouchBarGroupSegments(U)})}createTouchBar(){if(!!f.isMacintosh){for(let B=0;B<10;B++){const J=this.createTouchBarGroup();this.touchBarGroups.push(J)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const J=this.createTouchBarGroupSegments(B),Y=new n.TouchBar.TouchBarSegmentedControl({segments:J,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:Y.segments[U].id,from:"touchbar"})}});return Y}createTouchBarGroupSegments(B=[]){return B.map(Y=>{var U,z;let G;Y.icon&&!s.ThemeIcon.isThemeIcon(Y.icon)&&((z=(U=Y.icon)===null||U===void 0?void 0:U.dark)===null||z===void 0?void 0:z.scheme)===d.Schemas.file&&(G=n.nativeImage.createFromPath(P.URI.revive(Y.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let N;return typeof Y.title=="string"?N=Y.title:N=Y.title.value,{id:Y.id,label:G?void 0:N,icon:G}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};X=he([te(1,y.ILogService),te(2,v.IEnvironmentMainService),te(3,p.IFileService),te(4,h.IStorageMainService),te(5,i.IConfigurationService),te(6,a.IThemeMainService),te(7,E.IWorkspacesManagementMainService),te(8,c.IBackupMainService),te(9,l.ITelemetryService),te(10,t.IDialogMainService),te(11,o.ILifecycleMainService),te(12,I.IProductService),te(13,_.IProtocolMainService)],X),e.CodeWindow=X}),define(Q[62],Z([0,1,152,36,39,14,6,30,5,3,28,53,9,15,7,10,17,21,4,2]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=c.createDecorator("workspacesHistoryMainService");let a=class Ke extends u.Disposable{constructor(p,d,S,L){super();this.stateMainService=p,this.logService=d,this.workspacesManagementMainService=S,this.lifecycleMainService=L,this._onDidChangeRecentlyOpened=this._register(new v.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(p=>this.addRecentlyOpened([{workspace:p.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(p){const d=[],S=[];for(let L of p)if(i.isRecentWorkspace(L))!this.workspacesManagementMainService.isUntitledWorkspace(L.workspace)&&r(d,L.workspace)===-1&&d.push(L);else if(i.isRecentFolder(L))s(d,L.folderUri)===-1&&d.push(L);else{const _=o(S,L.fileUri)>=0,H=L.fileUri.scheme===g.Schemas.file&&Ke.COMMON_FILES_FILTER.indexOf(w.basename(L.fileUri))>=0;!_&&!H&&(S.push(L),y.isWindows&&L.fileUri.scheme===g.Schemas.file&&b.app.addRecentDocument(L.fileUri.fsPath))}this.addEntriesFromStorage(d,S),d.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(d.length=Ke.MAX_TOTAL_RECENT_ENTRIES),S.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(S.length=Ke.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:d,files:S}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(p){const d=H=>{const X=t(H);for(const ee of p)if(w.extUriBiasedIgnorePathCase.isEqual(ee,X))return!1;return!0},S=this.getRecentlyOpened(),L=S.workspaces.filter(d),_=S.files.filter(d);(L.length!==S.workspaces.length||_.length!==S.files.length)&&(this.saveRecentlyOpened({files:_,workspaces:L}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;b.app.clearRecentDocuments();const p=this.getRecentlyOpened(),d=[];let S=0;for(let _=0;_<p.workspaces.length&&S<Ke.MAX_MACOS_DOCK_RECENT_WORKSPACES;_++){const H=t(p.workspaces[_]);if(H.scheme===g.Schemas.file){const X=w.originalFSPath(H);await D.Promises.exists(X)&&(d.push(X),S++)}}const L=[];for(let _=0;_<p.files.length&&S<Ke.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;_++){const H=t(p.files[_]);if(H.scheme===g.Schemas.file){const X=w.originalFSPath(H);if(Ke.COMMON_FILES_FILTER.includes(w.basename(H))||d.includes(X))continue;await D.Promises.exists(X)&&(L.push(X),S++)}}L.reverse().forEach(_=>b.app.addRecentDocument(_)),d.reverse().forEach(_=>b.app.addRecentDocument(_))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(p){var d,S;const L=[],_=[],H=(d=p==null?void 0:p.config)===null||d===void 0?void 0:d.workspace;i.isWorkspaceIdentifier(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?L.push({workspace:H}):i.isSingleFolderWorkspaceIdentifier(H)&&L.push({folderUri:H.uri});const X=(S=p==null?void 0:p.config)===null||S===void 0?void 0:S.filesToOpenOrCreate;if(X)for(let ee of X){const B=ee.fileUri;B&&o(_,B)===-1&&_.push({fileUri:B})}return this.addEntriesFromStorage(L,_),{workspaces:L,files:_}}addEntriesFromStorage(p,d){let S=this.getRecentlyOpenedFromStorage();for(let L of S.workspaces){let _=i.isRecentFolder(L)?s(p,L.folderUri):r(p,L.workspace);_>=0?p[_].label=p[_].label||L.label:p.push(L)}for(let L of S.files){let _=o(d,L.fileUri);_>=0?d[_].label=d[_].label||L.label:d.push(L)}}getRecentlyOpenedFromStorage(){const p=this.stateMainService.getItem(Ke.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(p,this.logService)}saveRecentlyOpened(p){const d=i.toStoreData(p);this.stateMainService.setItem(Ke.recentlyOpenedStorageKey,d)}updateWindowsJumpList(){if(!y.isWindows)return;const p=[];if(p.push({type:"tasks",items:[{type:"task",title:m.localize(0,null),description:m.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let d=[];for(let _ of b.app.getJumpListSettings().removedItems){const H=_.args;if(H){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);X&&d.push(f.URI.parse(X[2]))}}this.removeRecentlyOpened(d);let S=!1;const L=A.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(_=>{const H=i.isRecentWorkspace(_)?_.workspace:_.folderUri,{title:X,description:ee}=this.getWindowsJumpListLabel(H,_.label);let B;return f.URI.isUri(H)?B=`--folder-uri "${H.toString()}"`:(S=!0,B=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ee.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));L.length>0&&p.push({type:"custom",name:S?m.localize(2,null):m.localize(3,null),items:L})}p.push({type:"recent"});try{b.app.setJumpList(p)}catch(d){this.logService.warn("updateWindowsJumpList#setJumpList",d)}}getWindowsJumpListLabel(p,d){if(d)return{title:n.splitName(d).name,description:d};if(f.URI.isUri(p))return{title:w.basename(p),description:l(p)};if(this.workspacesManagementMainService.isUntitledWorkspace(p))return{title:m.localize(4,null),description:""};let S=w.basename(p.configPath);return S.endsWith(i.WORKSPACE_EXTENSION)&&(S=S.substr(0,S.length-i.WORKSPACE_EXTENSION.length-1)),{title:m.localize(5,null,S),description:l(p.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=he([te(0,R.IStateMainService),te(1,P.ILogService),te(2,I.IWorkspacesManagementMainService),te(3,E.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function l(h){return h.scheme==="file"?n.normalizeDriveLetter(h.fsPath):h.toString()}function t(h){return i.isRecentFolder(h)?h.folderUri:i.isRecentFile(h)?h.fileUri:h.workspace.configPath}function r(h,p){return h.findIndex(d=>i.isRecentWorkspace(d)&&d.workspace.id===p.id)}function s(h,p){return h.findIndex(d=>i.isRecentFolder(d)&&w.extUriBiasedIgnorePathCase.isEqual(d.folderUri,p))}function o(h,p){return h.findIndex(d=>w.extUriBiasedIgnorePathCase.isEqual(d.fileUri,p))}}),define(Q[233],Z([0,1,144,3,24,14,61,20,32,42,19,9,6,30,35,62,182,7,39,21,45,25]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class vt{constructor(h,p,d,S,L,_,H,X,ee,B,J){this.updateService=h,this.configurationService=p,this.windowsMainService=d,this.environmentMainService=S,this.telemetryService=L,this.workspacesHistoryMainService=_,this.stateMainService=H,this.lifecycleMainService=X,this.logService=ee,this.nativeHostMainService=B,this.productService=J,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new I.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new I.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||P.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,H,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,H,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const p=this.productService.requestFeatureUrl;p&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(p,"openUserVoiceUrl"));const d=this.productService.reportIssueUrl;d&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(d,"openReportIssues"));const S=this.productService.licenseUrl;S&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const _=S.indexOf("?")>0?"&":"?";this.openUrl(`${S}${_}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(S,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&S&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(A.language){const _=S.indexOf("?")>0?"&":"?";this.openUrl(`${L}${_}lang=${A.language}`,"openPrivacyStatement")}else this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,p){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!A.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!A.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=b.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(A.isMacintosh?new b.Menu:null);return}const p=new b.Menu;let d;if(A.isMacintosh){const L=new b.Menu;d=new b.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),p.append(d)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new b.Menu;L.append(new b.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:L});this.setMenuById(L,"File"),p.append(_)}if(this.shouldDrawMenu("Edit")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),p.append(_)}if(this.shouldDrawMenu("Selection")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),p.append(_)}if(this.shouldDrawMenu("View")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:L});this.setMenuById(L,"View"),p.append(_)}if(this.shouldDrawMenu("Go")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),p.append(_)}if(this.shouldDrawMenu("Run")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),p.append(_)}if(this.shouldDrawMenu("Terminal")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),p.append(_)}let S;if(this.shouldDrawMenu("Window")){const L=new b.Menu;S=new b.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(S&&p.append(S),this.shouldDrawMenu("Help")){const L=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),p.append(_)}p.items&&p.items.length>0?b.Menu.setApplicationMenu(p):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const p=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),d=this.getUpdateMenuItems();let S;if(this.shouldDrawMenu("Preferences")){const Y=new b.Menu;this.setMenuById(Y,"Preferences"),S=new b.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:Y})}const L=new b.Menu,_=new b.MenuItem({label:m.localize(12,null),role:"services",submenu:L}),H=new b.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new b.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new b.MenuItem({label:m.localize(15,null),role:"unhide"}),B=new b.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const Y=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||(Y==null?void 0:Y.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),J=[p];J.push(...d),S&&J.push(s(),S),J.push(s(),_,s(),H,X,ee,s(),B),J.forEach(Y=>h.append(Y))}shouldDrawMenu(h){if(!A.isMacintosh&&P.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,p){p.forEach(d=>{if(D.isMenubarMenuItemSeparator(d))h.append(s());else if(D.isMenubarMenuItemSubmenu(d)){const S=new b.Menu,L=new b.MenuItem({label:this.mnemonicLabel(d.label),submenu:S});this.setMenu(S,d.submenu.items),h.append(L)}else D.isMenubarMenuItemRecentAction(d)?h.append(this.createOpenRecentMenuItem(d)):D.isMenubarMenuItemAction(d)&&(d.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[d.id]?h.append(new b.MenuItem(this.likeAction(d.id,{label:this.mnemonicLabel(d.label),click:this.fallbackMenuHandlers[d.id]}))):h.append(this.createMenuItem(d.label,d.id,!1,d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)))})}setMenuById(h,p){this.menubarMenus&&this.menubarMenus[p]&&this.setMenu(h,this.menubarMenus[p].items)}insertCheckForUpdatesItems(h){const p=this.getUpdateMenuItems();p.length&&(p.forEach(d=>h.append(d)),h.append(s()))}createOpenRecentMenuItem(h){const p=E.URI.revive(h.uri),d=h.id,S=d==="openRecentFile"?{fileUri:p}:d==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new b.MenuItem(this.likeAction(d,{label:h.label,click:(L,_,H)=>{const X=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[S],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([p])}},!1))}isOptionClick(h){return!!(h&&(!A.isMacintosh&&(h.ctrlKey||h.shiftKey)||A.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,p,d){const S={label:this.mnemonicLabel(h),role:d,enabled:!0};return new b.MenuItem(this.withKeybinding(p,S))}setMacWindowMenu(h){const p=new b.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),d=new b.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),S=new b.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(s()),_.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,d,s(),L,..._,s(),S].forEach(H=>h.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,p,d,S){const L=this.mnemonicLabel(h),_=typeof p=="function"?p:(J,Y,U)=>{const z=J?J.userSettingsLabel:null;let G=p;Array.isArray(p)&&(G=this.isOptionClick(U)?p[1]:p[0]),z&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:z}):this.runActionInRenderer({type:"commandId",commandId:G})},H=typeof d=="boolean"?d:this.windowsMainService.getWindowCount()>0,X=typeof S=="boolean"?S:!1,ee={label:L,click:_,enabled:H};X&&(ee.type="checkbox",ee.checked=X);let B;return typeof p=="string"?B=p:Array.isArray(p)&&(B=p[0]),A.isMacintosh&&(B==="editor.action.clipboardCutAction"?ee.role="cut":B==="editor.action.clipboardCopyAction"?ee.role="copy":B==="editor.action.clipboardPasteAction"&&(ee.role="paste"),B==="undo"?ee.click=this.makeContextAwareClickHandler(_,{inDevTools:J=>J.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?ee.click=this.makeContextAwareClickHandler(_,{inDevTools:J=>J.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(_,{inDevTools:J=>J.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(B,ee))}makeContextAwareClickHandler(h,p){return(d,S,L)=>{const _=b.BrowserWindow.getFocusedWindow();if(!_)return p.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return p.inDevTools(_.webContents.devToolsWebContents);h(d,S||_,L)}}runActionInRenderer(h){let p=b.BrowserWindow.getFocusedWindow();if(!p){const S=this.windowsMainService.getLastActiveWindow();(S==null?void 0:S.isMinimized())&&(p=S.win)}const d=p?this.windowsMainService.getWindowById(p.id):void 0;if(d){if(this.logService.trace("menubar#runActionInRenderer",h),A.isMacintosh&&!this.environmentMainService.isBuilt&&!d.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const S={id:h.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",l.CancellationToken.None,S)}else{const S={userSettingsLabel:h.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",l.CancellationToken.None,S)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,p){const d=typeof h=="string"?this.keybindings[h]:void 0;if(d==null?void 0:d.label){if(d.isNative!==!1)p.accelerator=d.label,p.userSettingsLabel=d.userSettingsLabel;else if(typeof p.label=="string"){const S=p.label.indexOf("[");S>=0?p.label=`${p.label.substr(0,S)} [${d.label}]`:p.label=`${p.label} [${d.label}]`}}else p.accelerator=void 0;return p}likeAction(h,p,d=!p.accelerator){d&&(p=this.withKeybinding(h,p));const S=p.click;return p.click=(L,_,H)=>{this.reportMenuActionTelemetry(h),S&&S(L,_,H)},p}openUrl(h,p){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(p)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return w.mnemonicMenuLabel(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([te(0,y.IUpdateService),te(1,n.IConfigurationService),te(2,f.IWindowsMainService),te(3,R.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,g.IWorkspacesHistoryMainService),te(6,c.IStateMainService),te(7,u.ILifecycleMainService),te(8,M.ILogService),te(9,a.INativeHostMainService),te(10,i.IProductService)],r),e.Menubar=r;function s(){return new b.MenuItem({type:"separator"})}}),define(Q[234],Z([0,1,233,6,4,21]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=R.createDecorator("menubarMainService");let P=class{constructor(v,y,i){this.instantiationService=v,this.lifecycleMainService=y,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(v,y){this.logService.trace("menubarService#updateMenubar",v),(await this.menubar).updateMenu(y,v)}};P=he([te(0,R.IInstantiationService),te(1,b.ILifecycleMainService),te(2,A.ILogService)],P),e.MenubarMainService=P}),define(Q[235],Z([0,1,31,26,48,72,8,150,36,51,24,39,232,14,21,20,6,61,101,5,19,62,3,28,4,10,7,15,73,215,53,43,2,52,13,29,30,25,18,33,55]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t,r,s,o,h,p,d,S,L,_,H,X,ee,B,J,Y,U,z,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(O){return r.isWorkspaceIdentifier(O==null?void 0:O.workspace)}function F(O){return r.isSingleFolderWorkspaceIdentifier(O==null?void 0:O.workspace)}let T=class xe extends H.Disposable{constructor(k,W,C,V,K,q,x,ne,re,se,le,oe,ue,me,be){super();this.machineId=k,this.initialUserEnv=W,this.logService=C,this.stateMainService=V,this.environmentMainService=K,this.lifecycleMainService=q,this.backupMainService=x,this.configurationService=ne,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=le,this.dialogMainService=oe,this.fileService=ue,this.productService=me,this.protocolMainService=be,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new S.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var W,C;if(((W=k.config)===null||W===void 0?void 0:W.extensionDevelopmentPath)||((C=k.config)===null||C===void 0?void 0:C.extensionTestsPath)){const V=new H.DisposableStore;if(V.add(u.Event.any(k.onDidClose,k.onDidDestroy)(()=>V.dispose())),k.config.extensionDevelopmentPath)for(const K of k.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(h.URI.file(K)));k.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(h.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,W){let C=this.environmentMainService.args;const V=(W==null?void 0:W.remoteAuthority)||void 0,K=!0,q=W==null?void 0:W.forceReuseWindow,x=!q;return this.open(Object.assign(Object.assign({},k),{cli:C,forceEmpty:K,forceNewWindow:x,forceReuseWindow:q,remoteAuthority:V}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const W=[],C=[],V=[],K=[],q=[];let x,ne=0;const re=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",re);for(const me of re)F(me)?k.addMode?W.push(me):C.push(me):N(me)?V.push(me):me.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),x.filesToOpenOrCreate.push(me)):me.backupPath?q.push({backupFolder:P.basename(me.backupPath),remoteAuthority:me.remoteAuthority}):ne++;k.diffMode&&(x==null?void 0:x.filesToOpenOrCreate.length)===2&&(x.filesToDiff=x.filesToOpenOrCreate,x.filesToOpenOrCreate=[]),x&&k.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(K.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...K),q.push(...this.backupMainService.getEmptyWindowBackupPaths())):q.length=0;const{windows:se,filesOpenedInWindow:le}=this.doOpen(k,V,C,q,ne,x,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${C.length}, emptyToRestore: ${q.length}, emptyToOpen: ${ne})`),se.length>1)if(le)le.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let be=!0,De=!0;if(me){const Ie=se.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),be=!1,De=!1)}if(be)for(let Ie=se.length-1;Ie>=0;Ie--){const we=se[Ie];if(!(we.openedWorkspace&&K.some(ye=>we.openedWorkspace&&ye.workspace.id===we.openedWorkspace.id)||we.backupPath&&q.some(ye=>we.backupPath&&ye.backupFolder===P.basename(we.backupPath)))){we.focus(),De=!1;break}}De&&se[se.length-1].focus()}const oe=x&&x.filesToDiff.length>0;if(!se.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!k.noRecentEntry){const me=[];for(const be of re)N(be)?me.push({label:be.label,workspace:be.workspace,remoteAuthority:be.remoteAuthority}):F(be)?me.push({label:be.label,folderUri:be.workspace.uri,remoteAuthority:be.remoteAuthority}):be.fileUri&&me.push({label:be.label,fileUri:be.fileUri,remoteAuthority:be.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const ue=k.waitMarkerFileURI;return k.context===0&&ue&&se.length===1&&se[0]&&(async()=>{await se[0].whenClosedOrLoaded;try{await this.fileService.del(ue)}catch(me){}})(),se}doOpen(k,W,C,V,K,q,x){const ne=[];let re;function se(Ie,we){ne.push(Ie),we&&(re=Ie,q=void 0)}let{openFolderInNewWindow:le,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&x.length>0){const Ie=x[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(Ie);we&&se(this.doAddFoldersToExistingWindow(we,x.map(ye=>ye.workspace.uri)))}const ue=C.length+W.length+V.length;if(q&&ue===0){const Ie=q.filesToOpenOrCreate[0]||q.filesToDiff[0],we=this.getWindows().filter(Le=>q&&Le.remoteAuthority===q.remoteAuthority);let ye;(Ie==null?void 0:Ie.fileUri)&&!oe&&((k.context===4||k.context===0||k.context===1)&&(ye=c.findWindowOnFile(we,Ie.fileUri,Le=>Le.configPath.scheme===o.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),ye||(ye=this.doGetLastActiveWindow(we))),ye?r.isWorkspaceIdentifier(ye.openedWorkspace)?W.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):r.isSingleFolderWorkspaceIdentifier(ye.openedWorkspace)?C.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):se(this.doOpenFilesInExistingWindow(k,ye,q),!0):se(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const me=v.distinct(W,Ie=>Ie.workspace.id);if(me.length>0){const Ie=v.coalesce(me.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.configPath)));if(Ie.length>0){const we=Ie[0],ye=(q==null?void 0:q.remoteAuthority)===we.remoteAuthority?q:void 0;se(this.doOpenFilesInExistingWindow(k,we,ye),!!ye),le=!0}me.forEach(we=>{if(Ie.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===we.workspace.id))return;const ye=we.remoteAuthority,Le=(q==null?void 0:q.remoteAuthority)===ye?q:void 0;se(this.doOpenFolderOrWorkspace(k,we,le,Le),!!Le),le=!0})}const be=v.distinct(C,Ie=>p.extUriBiasedIgnorePathCase.getComparisonKey(Ie.workspace.uri));if(be.length>0){const Ie=v.coalesce(be.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.uri)));if(Ie.length>0){const we=Ie[0],ye=(q==null?void 0:q.remoteAuthority)===we.remoteAuthority?q:void 0;se(this.doOpenFilesInExistingWindow(k,we,ye),!!ye),le=!0}be.forEach(we=>{if(Ie.some(Te=>r.isSingleFolderWorkspaceIdentifier(Te.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,we.workspace.uri)))return;const ye=we.remoteAuthority,Le=(q==null?void 0:q.remoteAuthority)===ye?q:void 0;se(this.doOpenFolderOrWorkspace(k,we,le,Le),!!Le),le=!0})}const De=v.distinct(V,Ie=>Ie.backupFolder);if(De.length>0&&De.forEach(Ie=>{const we=Ie.remoteAuthority,ye=(q==null?void 0:q.remoteAuthority)===we?q:void 0;se(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:ye,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:Ie}),!!ye),le=!0}),ne.length===0||q){q&&!K&&K++;const Ie=q?q.remoteAuthority:k.remoteAuthority;for(let we=0;we<K;we++)se(this.doOpenEmpty(k,le,Ie,q),!!q),le=!0}return{windows:v.distinct(ne),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(k,W,C){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const K={filesToOpenOrCreate:C==null?void 0:C.filesToOpenOrCreate,filesToDiff:C==null?void 0:C.filesToDiff,filesToWait:C==null?void 0:C.filesToWait,termProgram:(V=k==null?void 0:k.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",Y.CancellationToken.None,K),W}doAddFoldersToExistingWindow(k,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const C={foldersToAdd:W};return k.sendWhenReady("vscode:addFolders",Y.CancellationToken.None,C),k}doOpenEmpty(k,W,C,V,K){return!W&&!K&&typeof k.contextWindowId=="number"&&(K=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:C,forceNewWindow:W,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:K})}doOpenFolderOrWorkspace(k,W,C,V,K){return!C&&!K&&typeof k.contextWindowId=="number"&&(K=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:C,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:K})}getPathsToOpen(k){var W;let C,V=!1,K=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(C=this.doExtractPathsFromAPI(k),V=!0):k.forceEmpty?C=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(C=this.doExtractPathsFromCLI(k.cli),C.length===0&&C.push(Object.create(null)),V=!0):(C=this.doGetPathsFromLastSession(),C.length===0&&C.push(Object.create(null)),K=!0),!k.addMode&&V){const q=C.filter(x=>F(x));if(q.length>1){const x=q[0].remoteAuthority;if(q.every(ne=>ne.remoteAuthority===x)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(q.map(re=>({uri:re.workspace.uri})));C.push({workspace:ne,remoteAuthority:x}),C=C.filter(re=>!F(re))}}}return k.initialStartup&&!K&&((W=this.configurationService.getValue("window"))===null||W===void 0?void 0:W.restoreWindows)==="preserve"&&C.unshift(...this.doGetPathsFromLastSession().filter(q=>N(q)||F(q)||q.backupPath)),C}doExtractPathsFromAPI(k){const W=[],C={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const V of v.coalesce(k.urisToOpen||[])){const K=this.resolveOpenable(V,C);if(K)K.label=V.label,W.push(K);else{const q=this.resourceFromOpenable(V),x={title:this.productService.nameLong,type:"info",buttons:[J.mnemonicButtonLabel(n.localize(0,null))],defaultId:0,message:q.scheme===o.Schemas.file?n.localize(1,null):n.localize(2,null),detail:q.scheme===o.Schemas.file?n.localize(3,null,J.getPathLabel(q.fsPath,this.environmentMainService)):n.localize(4,null,q.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,ee.withNullAsUndefined(w.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(k){const W=[],C={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},V=k["folder-uri"];if(V)for(const x of V){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable({folderUri:ne},C);re&&W.push(re)}}const K=k["file-uri"];if(K)for(const x of K){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable(r.hasWorkspaceFileExtension(x)?{workspaceUri:ne}:{fileUri:ne},C);re&&W.push(re)}}const q=k._;for(const x of q){const ne=C.remoteAuthority?this.doResolvePathRemote(x,C):this.doResolveFilePath(x,C);ne&&W.push(ne)}return W}cliArgToUri(k){try{const W=h.URI.parse(k);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${k}, ${W.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];k!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const C=[];for(const V of W)if(V.workspace){const K=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(K)&&C.push(K)}else if(V.folderUri){const K=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});F(K)&&C.push(K)}else k!=="folders"&&V.backupPath&&C.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return C}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const W=this.configurationService.getValue("window");k=(W==null?void 0:W.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,W={}){let C=this.resourceFromOpenable(k);return C.scheme===o.Schemas.file?(E.isFileToOpen(k)&&(W=Object.assign(Object.assign({},W),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(C.fsPath,W)):this.doResolveRemoteOpenable(k,W)}doResolveRemoteOpenable(k,W){let C=this.resourceFromOpenable(k);const V=d.getRemoteAuthority(C)||W.remoteAuthority;if(C=p.removeTrailingPathSeparator(p.normalizePath(C)),E.isFileToOpen(k)){if(W.gotoLineMode){const{path:K,line:q,column:x}=B.parseLineAndColumnAware(C.path);return{fileUri:C.with({path:K}),lineNumber:q,columnNumber:x,remoteAuthority:V}}return{fileUri:C,remoteAuthority:V}}else if(E.isWorkspaceToOpen(k))return{workspace:L.getWorkspaceIdentifier(C),remoteAuthority:V};return{workspace:L.getSingleFolderWorkspaceIdentifier(C),remoteAuthority:V}}resourceFromOpenable(k){return E.isWorkspaceToOpen(k)?k.workspaceUri:E.isFolderToOpen(k)?k.folderUri:k.fileUri}doResolveFilePath(k,W){let C,V;W.gotoLineMode&&({path:k,line:C,column:V}=B.parseLineAndColumnAware(k)),k=B.sanitizeFilePath(P.normalize(k),z.cwd());try{const K=m.statSync(k);if(K.isFile()){if(!W.forceOpenWorkspaceAsFile){const q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(k));if(q)return{workspace:{id:q.id,configPath:q.configPath},remoteAuthority:q.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(k),lineNumber:C,columnNumber:V,exists:!0}}else if(K.isDirectory())return{workspace:L.getSingleFolderWorkspaceIdentifier(h.URI.file(k),K),exists:!0}}catch(K){const q=h.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([q]),W.ignoreFileNotFound)return{fileUri:q,exists:!1}}}doResolvePathRemote(k,W){const C=k.charCodeAt(0),V=W.remoteAuthority;let K,q;W.gotoLineMode&&({path:k,line:K,column:q}=B.parseLineAndColumnAware(k)),C!==47&&(B.isWindowsDriveLetter(C)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=B.toSlashes(k)),k=`/${k}`);const x=h.URI.from({scheme:o.Schemas.vscodeRemote,authority:V,path:k});if(k.charCodeAt(k.length-1)!==47){if(r.hasWorkspaceFileExtension(k))return W.forceOpenWorkspaceAsFile?{fileUri:x,lineNumber:K,columnNumber:q,remoteAuthority:W.remoteAuthority}:{workspace:L.getWorkspaceIdentifier(x),remoteAuthority:V};if(W.gotoLineMode||P.posix.basename(k).indexOf(".")!==-1)return{fileUri:x,lineNumber:K,columnNumber:q,remoteAuthority:V}}return{workspace:L.getSingleFolderWorkspaceIdentifier(x),remoteAuthority:V}}shouldOpenNewWindow(k){const W=this.configurationService.getValue("window"),C=(W==null?void 0:W.openFoldersInNewWindow)||"default",V=(W==null?void 0:W.openFilesInNewWindow)||"off";let K=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(C==="on"||C==="off")&&(K=C==="on");let q=!1;return k.forceNewWindow||k.forceReuseWindow?q=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(q=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!k.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(q=V==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:q}}openExtensionDevelopmentHostWindow(k,W){const C=c.findWindowOnExtensionDevelopmentPath(this.getWindows(),k);if(C)return this.lifecycleMainService.reload(C,W.cli),C.focus(),[C];let V=W.cli["folder-uri"]||[],K=W.cli["file-uri"]||[],q=W.cli._;if(!q.length&&!V.length&&!K.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=se&&(se.workspace||se.folderUri);le&&(h.URI.isUri(le)?le.scheme===o.Schemas.file?q=[le.fsPath]:V=[le.toString()]:le.configPath.scheme===o.Schemas.file?q=[p.originalFSPath(le.configPath)]:K=[le.configPath.toString()])}let x=W.remoteAuthority;for(const se of k)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=h.URI.parse(se),oe=d.getRemoteAuthority(le);oe&&(x?oe!==x&&this.logService.error("more than one extension development path authority"):x=oe)}q=q.filter(se=>{const le=h.URI.file(se);return c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:d.getRemoteAuthority(le)===x}),V=V.filter(se=>{const le=this.cliArgToUri(se);return le&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?d.getRemoteAuthority(le)===x:!1}),K=K.filter(se=>{const le=this.cliArgToUri(se);return le&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?d.getRemoteAuthority(le)===x:!1}),W.cli._=q,W.cli["folder-uri"]=V,W.cli["file-uri"]=K;const ne=!q.length&&!V.length&&!K.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:x};return this.open(re)}openInBrowserWindow(k){var W,C,V,K,q;const x=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:k.emptyWindowBackupInfo?P.join(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(W=k.filesToOpen)===null||W===void 0?void 0:W.filesToOpenOrCreate,filesToDiff:(C=k.filesToOpen)===null||C===void 0?void 0:C.filesToDiff,filesToWait:(V=k.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:k.initialStartup,perfMarks:b.getMarks(),os:{release:A.release(),hostname:A.hostname()},zoomLevel:typeof(x==null?void 0:x.zoomLevel)=="number"?x.zoomLevel:void 0,autoDetectHighContrast:(K=x==null?void 0:x.autoDetectHighContrast)!==null&&K!==void 0?K:!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}});let re;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(re=k.windowToUse||this.getLastActiveWindow(),re&&re.focus()),re){const se=re.config;!ne.extensionDevelopmentPath&&se&&!!se.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=se.extensionDevelopmentPath,ne.verbose=se.verbose,ne["inspect-brk-extensions"]=se["inspect-brk-extensions"],ne.debugId=se.debugId,ne["inspect-extensions"]=se["inspect-extensions"],ne["extensions-dir"]=se["extensions-dir"])}else{const se=this.windowsStateHandler.getNewWindowState(ne);b.mark("code/willCreateCodeWindow");const le=re=this.instantiationService.createInstance(M.CodeWindow,{state:se,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if(b.mark("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ue=this.getLastActiveWindow();ue&&ue.addTabbedWindow(le)}xe.WINDOWS.push(le),this._onDidOpenWindow.fire(le),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),_.once(le.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(le)),_.once(le.onDidClose)(()=>this.onWindowClosed(le)),_.once(le.onDidDestroy)(()=>this._onDidDestroyWindow.fire(le));const oe=ee.assertIsDefined((q=le.win)===null||q===void 0?void 0:q.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(le)),this.lifecycleMainService.registerWindow(le)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(se=>{se||this.doOpenInBrowserWindow(re,ne,k)}):this.doOpenInBrowserWindow(re,ne,k),re}doOpenInBrowserWindow(k,W,C){if(!W.extensionDevelopmentPath)if(r.isWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if(r.isSingleFolderWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const V=C.emptyWindowBackupInfo&&C.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,W.remoteAuthority)}k.load(W)}onWindowClosed(k){const W=xe.WINDOWS.indexOf(k);xe.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=w.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===k))}doGetLastActiveWindow(k){const W=Math.max.apply(Math,k.map(C=>C.lastFocusTime));return k.find(C=>C.lastFocusTime===W)}sendToFocused(k,...W){const C=this.getFocusedWindow()||this.getLastActiveWindow();C&&C.sendWhenReady(k,Y.CancellationToken.None,...W)}sendToAll(k,W,C){for(const V of this.getWindows())C&&C.indexOf(V.id)>=0||V.sendWhenReady(k,Y.CancellationToken.None,W)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(k){const W=this.getWindows().filter(C=>C.id===k);return v.firstOrDefault(W)}getWindowByWebContents(k){const W=w.BrowserWindow.fromWebContents(k);if(!!W)return this.getWindowById(W.id)}};T.WINDOWS=[],T=he([te(2,D.ILogService),te(3,I.IStateMainService),te(4,i.IEnvironmentMainService),te(5,f.ILifecycleMainService),te(6,y.IBackupMainService),te(7,g.IConfigurationService),te(8,l.IWorkspacesHistoryMainService),te(9,L.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,X.IDialogMainService),te(12,U.IFileService),te(13,a.IProductService),te(14,G.IProtocolMainService)],T),e.WindowsMainService=T}),define(Q[236],Z([0,1,53,35,62,51]),function($,e,m,A,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(v,y,i,I){this.workspacesManagementMainService=v,this.windowsMainService=y,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(v,y){const i=this.windowsMainService.getWindowById(v);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(v,y,i){return this.workspacesManagementMainService.createUntitledWorkspace(y,i)}deleteUntitledWorkspace(v,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(v,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(v){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(v))}async addRecentlyOpened(v,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(v,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(v){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=he([te(0,m.IWorkspacesManagementMainService),te(1,A.IWindowsMainService),te(2,R.IWorkspacesHistoryMainService),te(3,b.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Q[237],Z([0,1,26,31,14,3,235,21,92,42,205,34,122,86,225,102,4,71,69,6,39,24,20,99,206,32,98,200,201,197,19,219,2,35,7,28,236,66,230,228,227,231,180,22,208,220,234,119,8,15,131,10,229,100,213,218,51,62,207,53,70,157,45,52,13,30,210,76,18,40,27,16,90,211,196,54,29,169,185,43,73,75,91,172,178]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t,r,s,o,h,p,d,S,L,_,H,X,ee,B,J,Y,U,z,G,N,F,T,O,k,W,C,V,K,q,x,ne,re,se,le,oe,ue,me,be,De,Ie,we,ye,Le,Te,$e,Ne,He,et,Be,st,tt,ut,Xe,ht,ot,j,ie,ae,ce,fe,Se,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends H.Disposable{constructor(de,pe,ve,ge,Ee,ke,Ae,Re,Pe,Ce){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Ee,this.lifecycleMainService=ke,this.configurationService=Ae,this.stateMainService=Re,this.fileService=Pe,this.productService=Ce,this.configureSession(),this.registerListeners()}configureSession(){const de=ve=>ve.startsWith(`${x.Schemas.vscodeWebview}://`);R.session.defaultSession.setPermissionRequestHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?Ee(ge==="clipboard-read"):Ee(!1)),R.session.defaultSession.setPermissionCheckHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?ge==="clipboard-read":!1);const pe=R.session.defaultSession;typeof pe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&pe.setCodeCachePath(V.join(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){T.setUnexpectedErrorHandler(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>this.onUnexpectedError(ve)),process.on("unhandledRejection",ve=>T.onUnexpectedError(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),C.registerContextMenuListener(),R.app.on("accessibility-support-changed",(ve,ge)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ge)}),R.app.on("activate",(ve,ge)=>{var Ee;this.logService.trace("app#activate"),ge||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),R.app.on("web-contents-created",(ve,ge)=>{ge.on("will-attach-webview",(Ee,ke,Ae)=>{const Re=Pe=>{if(!Pe)return!1;const Ce=ee.URI.parse(Pe);if(Ce.scheme===x.Schemas.vscodeWebview)return Ce.path==="/index.html"||Ce.path==="/electron-browser-index.html";const je=Ce.fsPath.toLowerCase(),qe=ee.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return je.startsWith(qe+V.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Re(Ae.src)&&Re(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ee.preventDefault())}),ge.on("will-navigate",Ee=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ge.setWindowOpenHandler(({url:Ee})=>{var ke;return(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Ee),{action:"deny"}})});let de=[],pe;R.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),R.app.on("new-window-for-tab",()=>{var ve;(ve=this.windowsMainService)===null||ve===void 0||ve.openEmptyWindow({context:4})}),R.ipcMain.handle("vscode:fetchShellEnv",ve=>{var ge;const Ee=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(ve.sender);let ke,Ae;return(Ee==null?void 0:Ee.config)?(ke=Ee.config,Ae=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(ke=this.environmentMainService.args,Ae=process.env),v.resolveShellEnv(this.logService,ke,Ae)}),R.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Ee)=>{const ke=this.validateNlsPath([ge]);if(!ke||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ke,st.VSBuffer.fromString(Ee))}),R.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Ee=this.validateNlsPath(ge);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),R.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),R.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),R.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let pe;for(const ve of de)typeof ve=="string"&&(typeof pe!="string"?pe=ve:pe=V.join(pe,ve));if(!(typeof pe!="string"||!V.isAbsolute(pe)||!ot.isEqualOrParent(pe,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return ee.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ve={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ve))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;b.isWindows&&de&&R.app.setAppUserModelId(de);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!R.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&R.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new M.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Ee,sharedProcessClient:ke}=this.setupSharedProcess(ve),Ae=await this.initServices(ve,ge,Ee);if(this.environmentMainService.driverHandle){const Pe=await k.serve(pe,this.environmentMainService.driverHandle,this.environmentMainService,Ae);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(Ae.createInstance(_.ProxyAuthHandler)),Ae.invokeFunction(Pe=>this.initChannels(Pe,pe,ke));const Re=Ae.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));Ae.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&Ae.invokeFunction(Pe=>this.stopTracingEventually(Pe,Re))}async resolveMachineId(){let de=this.stateMainService.getItem(o.machineIdKey);return(!de||b.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await Y.getMachineId(),this.stateMainService.setItem(o.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(f.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new w.Client(Ee,"main")})(),ge=(async()=>(await pe.whenReady(),ve))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,pe,ve){const ge=new E.ServiceCollection;switch(process.platform){case"win32":ge.set(y.IUpdateService,new c.SyncDescriptor(U.Win32UpdateService));break;case"linux":b.isLinuxSnap?ge.set(y.IUpdateService,new c.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(y.IUpdateService,new c.SyncDescriptor(z.LinuxUpdateService));break;case"darwin":ge.set(y.IUpdateService,new c.SyncDescriptor(G.DarwinUpdateService));break}ge.set(X.IWindowsMainService,new c.SyncDescriptor(P.WindowsMainService,[de,this.userEnv])),ge.set(ye.IDialogMainService,new c.SyncDescriptor(ye.DialogMainService)),ge.set(g.ILaunchMainService,new c.SyncDescriptor(g.LaunchMainService)),ge.set(De.IDiagnosticsService,I.ProxyChannel.toService(I.getDelayedChannel(ve.then(ke=>ke.getChannel("diagnostics"))))),ge.set(N.IIssueMainService,new c.SyncDescriptor(N.IssueMainService,[this.userEnv])),ge.set(tt.IEncryptionMainService,new c.SyncDescriptor(tt.EncryptionMainService,[de])),ge.set(Xe.IKeyboardLayoutMainService,new c.SyncDescriptor(Xe.KeyboardLayoutMainService)),ge.set(we.INativeHostMainService,new c.SyncDescriptor(we.NativeHostMainService,[pe])),ge.set(Ne.IWebviewManagerService,new c.SyncDescriptor($e.WebviewMainService)),ge.set(B.IWorkspacesService,new c.SyncDescriptor(J.WorkspacesMainService)),ge.set(be.IWorkspacesManagementMainService,new c.SyncDescriptor(be.WorkspacesManagementMainService)),ge.set(ue.IWorkspacesHistoryMainService,new c.SyncDescriptor(ue.WorkspacesHistoryMainService)),ge.set(W.IMenubarMainService,new c.SyncDescriptor(W.MenubarMainService)),ge.set(j.IExtensionUrlTrustService,new c.SyncDescriptor(ie.ExtensionUrlTrustService)),ge.set(re.IStorageMainService,new c.SyncDescriptor(re.StorageMainService)),b.isWindows?ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(Me.WindowsExternalTerminalService)):b.isMacintosh?ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(Me.MacExternalTerminalService)):b.isLinux&&ge.set(Se.IExternalTerminalMainService,new c.SyncDescriptor(Me.LinuxExternalTerminalService));const Ee=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(oe.IBackupMainService,Ee),ge.set(r.IURLService,new c.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const ke=I.getDelayedChannel(ve.then(je=>je.getChannel("telemetryAppender"))),Ae=new p.TelemetryAppenderClient(ke),Re=S.resolveCommonProperties(this.fileService,m.release(),m.hostname(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:Ae,commonProperties:Re,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(o.ITelemetryService,new c.SyncDescriptor(d.TelemetryService,[Ce]))}else ge.set(o.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,pe,ve){const ge=I.ProxyChannel.fromService(de.get(g.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge),pe.registerChannel(Fe.UserConfigurationFileServiceId,I.ProxyChannel.fromService(new Fe.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ee=new i.UpdateChannel(de.get(y.IUpdateService));pe.registerChannel("update",Ee);const ke=I.ProxyChannel.fromService(de.get(N.IIssueMainService));pe.registerChannel("issue",ke);const Ae=I.ProxyChannel.fromService(de.get(tt.IEncryptionMainService));pe.registerChannel("encryption",Ae);const Re=I.ProxyChannel.fromService(de.get(fe.ISignService));pe.registerChannel("sign",Re);const Pe=I.ProxyChannel.fromService(de.get(Xe.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=de.get(we.INativeHostMainService);const Ce=I.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ce),ve.then(Ve=>Ve.registerChannel("nativeHost",Ce));const je=I.ProxyChannel.fromService(de.get(B.IWorkspacesService));pe.registerChannel("workspaces",je);const qe=I.ProxyChannel.fromService(de.get(W.IMenubarMainService));pe.registerChannel("menubar",qe);const Ge=I.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Ge);const Qe=I.ProxyChannel.fromService(de.get(j.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Qe);const _e=I.ProxyChannel.fromService(de.get(Ne.IWebviewManagerService));pe.registerChannel("webview",_e);const it=this._register(new se.StorageDatabaseChannel(this.logService,de.get(re.IStorageMainService)));pe.registerChannel("storage",it),ve.then(Ve=>Ve.registerChannel("storage",it));const nt=I.ProxyChannel.fromService(de.get(Se.IExternalTerminalMainService));pe.registerChannel("externalTerminal",nt);const Ze=new F.LogLevelChannel(de.get(u.ILogService));pe.registerChannel("logLevel",Ze),ve.then(Ve=>Ve.registerChannel("logLevel",Ze));const rt=new F.LoggerChannel(de.get(u.ILoggerService));pe.registerChannel("logger",rt),ve.then(Ve=>Ve.registerChannel("logger",rt));const at=new Ie.ElectronExtensionHostDebugBroadcastChannel(de.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",at)}openFirstWindow(de,pe){const ve=this.windowsMainService=de.get(X.IWindowsMainService),ge=de.get(r.IURLService),Ee=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const ke=[],Ae=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:ee.URI.parse(We),url:We}}catch(Je){return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(We.uri);return Je?(ke.push(Je),!1):!0}),Re=this,Pe=this.environmentMainService,Ce=this.productService;ge.registerHandler({async handleURL(We,Je){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:ee.URI.parse(We.query).path,query:""})),Re.shouldBlockURI(We))return!0;const St=Re.getWindowOpenableFromProtocolLink(We);if(St){const[ft]=ve.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[St],gotoLineMode:!0});return ft.focus(),!0}if(b.isMacintosh&&ve.getWindowCount()===0){const[ft]=ve.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:ce.getRemoteAuthority(We)});return await ft.ready(),ge.open(We,Je)}return!1}});const je=this._register(new ut.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),qe=new I.StaticRouter(We=>je.getActiveClientId().then(Je=>We===Je)),Ge=new s.URLHandlerRouter(qe),Qe=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Qe)),this._register(new O.ElectronURLListener(Ae,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=ht.isLaunchedFromCli(process.env)?0:4,Ze=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],Ve=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?ee.URI.file(_e.waitMarkerFilePath):void 0,yt=_e.remote||void 0;return ke.length>0?ve.open({context:nt,cli:_e,urisToOpen:ke,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Ze&&!rt&&!at?ve.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:yt}):it.length&&!Ze&&!rt&&!at?ve.open({context:1,cli:_e,urisToOpen:it.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Ve,waitMarkerFileURI:dt,initialStartup:!0}):ve.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Ze&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:Ve,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:yt})}shouldBlockURI(de){return!!(de.authority===x.Schemas.file&&b.isWindows&&R.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Te.mnemonicButtonLabel(q.localize(0,null)),Te.mnemonicButtonLabel(q.localize(1,null))],defaultId:0,cancelId:1,message:q.localize(2,null,Te.getPathLabel(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:q.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===x.Schemas.file)return{fileUri:ee.URI.file(de.fsPath)};if(de.authority===x.Schemas.vscodeRemote){const pe=de.path.indexOf(V.posix.sep,1);if(pe!==-1){const ve=de.path.substring(1,pe),ge=de.path.substring(pe),Ee=ee.URI.from({scheme:x.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return B.hasWorkspaceFileExtension(ge)?{workspaceUri:Ee}:/:[\d]+$/.test(ge)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(de){try{if(A.statSync(de).isDirectory())return{folderUri:ee.URI.file(de)};if(B.hasWorkspaceFileExtension(de))return{workspaceUri:ee.URI.file(de)}}catch(pe){}return{fileUri:ee.URI.file(de)}}async afterWindowOpen(de,pe){var ve;this.lifecycleMainService.phase=3;let ge=!1;ae.once(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Ee=de.get(o.ITelemetryService);this._register(pe.onDidError(({type:Re,details:Pe})=>{var Ce,je,qe,Ge;let Qe;switch(Re){case 1:Qe="SharedProcess: detected unresponsive window";break;case 2:Qe=`SharedProcess: crashed (detail: ${(Ce=Pe==null?void 0:Pe.reason)!==null&&Ce!==void 0?Ce:"<unknown>"}, code: ${(je=Pe==null?void 0:Pe.exitCode)!==null&&je!==void 0?je:"<unknown>"})`;break;case 3:Qe=`SharedProcess: failed to load (detail: ${(qe=Pe==null?void 0:Pe.reason)!==null&&qe!==void 0?qe:"<unknown>"}, code: ${(Ge=Pe==null?void 0:Pe.exitCode)!==null&&Ge!==void 0?Ge:"<unknown>"})`;break}T.onUnexpectedError(new Error(Qe)),Ee.publicLog2("sharedprocesserror",{type:Re,reason:Pe==null?void 0:Pe.reason,code:Pe==null?void 0:Pe.exitCode,visible:pe.isVisible(),shuttingdown:ge})}));const ke=this.productService.win32MutexName;if(b.isWindows&&ke)try{const Re=$.__$__nodeRequire("windows-mutex").Mutex,Pe=new Re(ke);ae.once(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(Re){this.logService.error(Re)}R.protocol.registerHttpProtocol(x.Schemas.vscodeRemoteResource,(Re,Pe)=>{Pe({url:Re.url.replace(/^vscode-remote-resource:/,"http:"),method:Re.method})});const Ae=de.get(y.IUpdateService);(Ae instanceof U.Win32UpdateService||Ae instanceof z.LinuxUpdateService||Ae instanceof G.DarwinUpdateService)&&Ae.initialize(),v.resolveShellEnv(this.logService,this.environmentMainService.args,process.env);try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(et.stripComments(Pe))["enable-crash-reporter"]===void 0){const je=(ve=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ve!==void 0?ve:!0,qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${Be.generateUuid()}"`,"}"],Ge=Pe.substring(0,Pe.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,st.VSBuffer.fromString(Ge))}}catch(Re){this.logService.error(Re)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(ye.IDialogMainService);let ge=!1;const Ee=async Ae=>{if(ge)return;ge=!0;const Re=await R.contentTracing.stopRecording(K.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ae?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:q.localize(4,null),detail:q.localize(5,null,Re),buttons:[Te.mnemonicButtonLabel(q.localize(6,null))],defaultId:0,noLink:!0},Le.withNullAsUndefined(R.BrowserWindow.getFocusedWindow()))},ke=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(Ae=>Ae.ready())).then(()=>{clearTimeout(ke),Ee(!1)})}};Ue=he([te(2,D.IInstantiationService),te(3,u.ILogService),te(4,l.IEnvironmentMainService),te(5,n.ILifecycleMainService),te(6,t.IConfigurationService),te(7,a.IStateMainService),te(8,He.IFileService),te(9,L.IProductService)],Ue),e.CodeApplication=Ue}),define(Q[241],Z([0,1,14,31,17,11,3,72,48,54,161,21,34,56,174,71,69,6,226,39,20,189,50,224,237,30,95,94,22,60,43,75,195,198,183,184,10,18,74,222,19,29,23,8,36,24,67,98,181,33,55,186,9,204]),function($,e,m,A,R,b,P,n,v,y,i,I,M,w,f,g,D,E,c,u,a,l,t,r,s,o,h,p,d,S,L,_,H,X,ee,B,J,Y,U,z,G,N,F,T,O,k,W,C,V,K,q,x,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(oe){console.error(oe.message),m.app.exit(1)}}async startup(){d.setUnexpectedErrorHandler(ye=>console.error(ye));const[oe,ue,me,be,De,Ie,we]=this.createServices();try{try{await this.initServices(me,be,De)}catch(ye){throw this.handleStartupDataDirError(me,we.nameLong,ye),ye}await oe.invokeFunction(async ye=>{const Le=ye.get(E.ILogService),Te=ye.get(I.ILifecycleMainService),$e=ye.get(Y.IFileService),Ne=await this.claimInstance(Le,me,Te,oe,we,!0);return Ie.logger=new h.SpdLogLogger("main",T.join(me.logsPath,"main.log"),!0,Ie.getLevel()),L.once(Te.onWillShutdown)(()=>{$e.dispose(),be.dispose()}),oe.createInstance(s.CodeApplication,Ne,ue).startup()})}catch(ye){oe.invokeFunction(this.quit,ye)}}createServices(){const oe=new g.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},v.default);oe.set(G.IProductService,ue);const me=new k.EnvironmentMainService(this.resolveArgs(),ue),be=this.patchEnvironment(me);oe.set(k.IEnvironmentMainService,me);const De=new p.BufferLogService,Ie=new E.MultiplexLogService([new E.ConsoleMainLogger(E.getLogLevel(me)),De]);process.once("exit",()=>Ie.dispose()),oe.set(E.ILogService,Ie);const we=new ee.FileService(Ie);oe.set(Y.IFileService,we);const ye=new B.DiskFileSystemProvider(Ie);we.registerProvider(J.Schemas.file,ye),oe.set(E.ILoggerService,new V.LoggerService(Ie,we));const Le=new l.ConfigurationService(me.settingsResource,we);oe.set(a.IConfigurationService,Le),oe.set(I.ILifecycleMainService,new D.SyncDescriptor(I.LifecycleMainService));const Te=new c.StateMainService(me,Ie,we);return oe.set(u.IStateMainService,Te),oe.set(t.IRequestService,new D.SyncDescriptor(r.RequestMainService)),oe.set(S.IThemeMainService,new D.SyncDescriptor(S.ThemeMainService)),oe.set(_.ISignService,new D.SyncDescriptor(H.SignService)),oe.set(U.ITunnelService,new D.SyncDescriptor(z.TunnelService)),oe.set(q.IProtocolMainService,new D.SyncDescriptor(x.ProtocolMainService)),[new f.InstantiationService(oe,!0),be,me,Le,Te,De,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const be=process.env[me];typeof be=="string"&&(ue[me]=be)}),Object.assign(process.env,ue),ue}initServices(oe,ue,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(be=>be?R.Promises.mkdir(be,{recursive:!0}):void 0)),ue.initialize(),me.init()])}async claimInstance(oe,ue,me,be,De,Ie){let we;try{n.mark("code/willStartMainServer"),we=await w.serve(ue.mainIPCHandle),n.mark("code/didStartMainServer"),L.once(me.onWillShutdown)(()=>we.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,De.nameLong,ye),ye;let Le;try{Le=await w.connect(ue.mainIPCHandle,"main")}catch(Ne){if(!Ie||P.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog(b.localize(0,null,De.nameShort),b.localize(1,null),De.nameLong),Ne;try{A.unlinkSync(ue.mainIPCHandle)}catch(He){throw oe.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(oe,ue,me,be,De,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Le.dispose(),new Error(Ne)}let Te;!ue.args.wait&&!ue.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog(b.localize(2,null,De.nameShort),b.localize(3,null),De.nameLong)},1e4));const $e=M.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return be.invokeFunction(async()=>{const Ne=new X.DiagnosticsService(C.NullTelemetryService,De),He=await $e.getMainProcessInfo(),et=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(He,et);throw console.log(Be),new d.ExpectedError});throw P.isWindows&&await this.windowsAllowSetForegroundWindow($e,oe),oe.trace("Sending env to running instance..."),await $e.start(ue.args,process.env),Le.dispose(),Te&&clearTimeout(Te),new d.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(oe,ue,me){if(me.code==="EACCES"||me.code==="EPERM"){const be=O.coalesce([oe.userDataPath,oe.extensionsPath,w.XDG_RUNTIME_DIR]).map(De=>o.getPathLabel(De,oe));this.showStartupWarningDialog(b.localize(4,null),b.localize(5,null,W.toErrorMessage(me),be.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,me){m.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[o.mnemonicButtonLabel(b.localize(6,null))],message:oe,detail:ue,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(P.isWindows){const me=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((be,De)=>{$(["windows-foreground-love"],be,De)})).allowSetForegroundWindow(me)}catch(be){ue.error(be)}}}quit(oe,ue){const me=oe.get(E.ILogService),be=oe.get(I.ILifecycleMainService);let De=0;ue&&(ue.isExpected?ue.message&&me.trace(ue.message):(De=1,ue.stack?me.error(ue.stack):me.error(`Startup error: ${ue.toString()}`))),be.kill(De)}resolveArgs(){const oe=this.validatePaths(y.parseMainProcessArgv(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=i.createWaitMarkerFile(oe.verbose);ue&&(y.addArg(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const me=K.cwd(),be=oe.map(we=>{let ye=String(we),Le;ue&&(Le=N.parseLineAndColumnAware(ye),ye=Le.path),ye&&(ye=this.preparePath(me,ye));const Te=N.sanitizeFilePath(ye,me),$e=T.basename(Te);return $e&&!N.isValidBasename($e)?null:ue&&Le?(Le.path=Te,this.toPath(Le)):Te}),De=P.isWindows||P.isMacintosh,Ie=O.distinct(be,we=>we&&De?we.toLowerCase():we||"");return O.coalesce(Ie)}preparePath(oe,ue){return P.isWindows&&(ue=F.rtrim(ue,'"')),ue=F.trim(F.trim(ue," "),"	"),P.isWindows&&(ue=T.resolve(oe,ue),ue=F.rtrim(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b79d23d3568db6c926c5ac428457c31f4dfc1c00/core/vs/code/electron-main/main.js.map
