/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(X){for(var e=[],p=0,L=X.length;p<L;p++)e[p]=ge[X[p]];return e};define(ge[50],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=p}),define(ge[67],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function L(r){const I=[];for(let l in r)p.call(r,l)&&I.push(r[l]);return I}e.values=L;function k(r,I){for(let l in r)if(p.call(r,l)&&I({key:l,value:r[l]},function(){delete r[l]})===!1)return}e.forEach=k;function y(r,I){const l=Object.create(null);for(const h of r){const c=I(h);let f=l[c];f||(f=l[c]=[]),f.push(h)}return l}e.groupBy=y;function A(r){const I=Object.create(null);return r&&r.forEach((l,h)=>{I[h]=l}),I}e.fromMap=A;function P(r,I){const l=[],h=[];for(let c of r)I.has(c)||l.push(c);for(let c of I)r.has(c)||h.push(c);return{removed:l,added:h}}e.diffSets=P;function S(r,I){const l=[],h=[];for(let[c,f]of r)I.has(c)||l.push(f);for(let[c,f]of I)r.has(c)||h.push(f);return{removed:l,added:h}}e.diffMaps=S;class C{constructor(){this.map=new Map}add(I,l){let h=this.map.get(I);h||(h=new Set,this.map.set(I,h)),h.add(l)}delete(I,l){const h=this.map.get(I);!h||(h.delete(l),h.size===0&&this.map.delete(I))}forEach(I,l){const h=this.map.get(I);!h||h.forEach(l)}}e.SetMap=C}),define(ge[51],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(P,S,C)=>{let r=null,I=null;if(typeof C.value=="function"?(r="value",I=C.value):typeof C.get=="function"&&(r="get",I=C.get),!I)throw new Error("not supported");C[r]=A(I,S)}}e.createDecorator=p;function L(A,P,S){let C=null,r=null;if(typeof S.value=="function"?(C="value",r=S.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",r=S.get),!r)throw new Error("not supported");const I=`$memoize$${P}`;S[C]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,l)}),this[I]}}e.memoize=L;function k(A,P,S){return p((C,r)=>{const I=`$debounce$${r}`,l=`$debounce$result$${r}`;return function(...h){this[l]||(this[l]=S?S():void 0),clearTimeout(this[I]),P&&(this[l]=P(this[l],...h),h=[this[l]]),this[I]=setTimeout(()=>{C.apply(this,h),this[l]=S?S():void 0},A)}})}e.debounce=k;function y(A,P,S){return p((C,r)=>{const I=`$throttle$timer$${r}`,l=`$throttle$result$${r}`,h=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...f){if(this[l]||(this[l]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[l]=P(this[l],...f)),this[c])return;const E=this[h]+A;E<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=S?S():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),C.apply(this,[this[l]]),this[l]=S?S():void 0},E-Date.now()))}})}e.throttle=y}),define(ge[14],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function k(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=k;function y(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function A(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=A;const P="Canceled";function S(g){return g instanceof Error&&g.name===P&&g.message===P}e.isPromiseCanceledError=S;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function r(){const g=new Error(P);return g.name=g.message,g}e.canceled=r;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function h(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function c(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function f(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=f;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function u(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function d(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=d}),define(ge[18],pe([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,T=0){return W[W.length-(1+T)]}e.tail=L;function k(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=k;function y(W,T,F=(N,x)=>N===x){if(W===T)return!0;if(!W||!T||W.length!==T.length)return!1;for(let N=0,x=W.length;N<x;N++)if(!F(W[N],T[N]))return!1;return!0}e.equals=y;function A(W,T,F){let N=0,x=W.length-1;for(;N<=x;){const G=(N+x)/2|0,se=F(W[G],T);if(se<0)N=G+1;else if(se>0)x=G-1;else return G}return-(N+1)}e.binarySearch=A;function P(W,T){let F=0,N=W.length;if(N===0)return 0;for(;F<N;){const x=Math.floor((F+N)/2);T(W[x])?N=x:F=x+1}return F}e.findFirstInSorted=P;function S(W,T,F){if(W=W|0,W>=T.length)throw new TypeError("invalid index");let N=T[Math.floor(T.length*Math.random())],x=[],G=[],se=[];for(let be of T){const Ie=F(be,N);Ie<0?x.push(be):Ie>0?G.push(be):se.push(be)}return W<x.length?S(W,x,F):W<x.length+se.length?se[0]:S(W-(x.length+se.length),G,F)}e.quickSelect=S;function C(W,T){const F=[];let N;for(const x of W.slice(0).sort(T))!N||T(N[0],x)!==0?(N=[x],F.push(N)):N.push(x);return F}e.groupBy=C;function r(W,T,F){const N=[];function x(be,Ie,Ce){if(Ie===0&&Ce.length===0)return;const Me=N[N.length-1];Me&&Me.start+Me.deleteCount===be?(Me.deleteCount+=Ie,Me.toInsert.push(...Ce)):N.push({start:be,deleteCount:Ie,toInsert:Ce})}let G=0,se=0;for(;;){if(G===W.length){x(G,0,T.slice(se));break}if(se===T.length){x(G,W.length-G,[]);break}const be=W[G],Ie=T[se],Ce=F(be,Ie);Ce===0?(G+=1,se+=1):Ce<0?(x(G,1,[]),G+=1):Ce>0&&(x(G,0,[Ie]),se+=1)}return N}e.sortedDiff=r;function I(W,T,F){const N=r(W,T,F),x=[],G=[];for(const se of N)x.push(...W.slice(se.start,se.start+se.deleteCount)),G.push(...se.toInsert);return{removed:x,added:G}}e.delta=I;function l(W,T,F){if(F===0)return[];const N=W.slice(0,F).sort(T);return c(W,T,N,F,W.length),N}e.top=l;function h(W,T,F,N,x){return F===0?Promise.resolve([]):new Promise((G,se)=>{(async()=>{const be=W.length,Ie=W.slice(0,F).sort(T);for(let Ce=F,Me=Math.min(F+N,be);Ce<be;Ce=Me,Me=Math.min(Me+N,be)){if(Ce>F&&await new Promise(qe=>setTimeout(qe)),x&&x.isCancellationRequested)throw p.canceled();c(W,T,Ie,Ce,Me)}return Ie})().then(G,se)})}e.topAsync=h;function c(W,T,F,N,x){for(const G=F.length;N<x;N++){const se=W[N];if(T(se,F[G-1])<0){F.pop();const be=P(F,Ie=>T(se,Ie)<0);F.splice(be,0,se)}}}function f(W){return W.filter(T=>!!T)}e.coalesce=f;function E(W){let T=0;for(let F=0;F<W.length;F++)W[F]&&(W[T]=W[F],T+=1);W.length=T}e.coalesceInPlace=E;function w(W,T,F){W.splice(F,0,W.splice(T,1)[0])}e.move=w;function b(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=b;function u(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=u;function d(W,T){if(!T)return W.filter((N,x)=>W.indexOf(N)===x);const F=Object.create(null);return W.filter(N=>{const x=T(N);return F[x]?!1:(F[x]=!0,!0)})}e.distinct=d;function g(W){const T=new Set;return W.filter(F=>T.has(F)?!1:(T.add(F),!0))}e.distinctES6=g;function t(W){const T=Object.create(null);return F=>{const N=W(F);return T[N]?!1:(T[N]=!0,!0)}}e.uniqueFilter=t;function i(W,T){for(let F=W.length-1;F>=0;F--){const N=W[F];if(T(N))return F}return-1}e.lastIndex=i;function s(W,T){return W.length>0?W[0]:T}e.firstOrDefault=s;function n(W,T,F=(N,x)=>N===x){let N=0;for(let x=0,G=Math.min(W.length,T.length);x<G&&F(W[x],T[x]);x++)N++;return N}e.commonPrefixLength=n;function o(W){return[].concat(...W)}e.flatten=o;function v(W,T){let F=typeof T=="number"?W:0;typeof T=="number"?F=W:(F=0,T=W);const N=[];if(F<=T)for(let x=F;x<T;x++)N.push(x);else for(let x=F;x>T;x--)N.push(x);return N}e.range=v;function m(W,T,F){return W.reduce((N,x)=>(N[T(x)]=F?F(x):x,N),Object.create(null))}e.index=m;function _(W,T){return W.push(T),()=>D(W,T)}e.insert=_;function D(W,T){const F=W.indexOf(T);if(F>-1)return W.splice(F,1),T}e.remove=D;function a(W,T,F){const N=W.slice(0,T),x=W.slice(T);return N.concat(F,x)}e.arrayInsert=a;function R(W,T){let F;if(typeof T=="number"){let N=T;F=()=>{const x=Math.sin(N++)*179426549;return x-Math.floor(x)}}else F=Math.random;for(let N=W.length-1;N>0;N-=1){const x=Math.floor(F()*(N+1)),G=W[N];W[N]=W[x],W[x]=G}}e.shuffle=R;function M(W,T){const F=W.indexOf(T);F>-1&&(W.splice(F,1),W.unshift(T))}e.pushToStart=M;function $(W,T){const F=W.indexOf(T);F>-1&&(W.splice(F,1),W.push(T))}e.pushToEnd=$;function Y(W,T){return Array.isArray(W)?W.map(T):T(W)}e.mapArrayOrNot=Y;function le(W){return Array.isArray(W)?W:[W]}e.asArray=le;function q(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=q;function U(W,T){for(const F of W){const N=T(F);if(N!==void 0)return N}}e.mapFind=U;function z(W,T){let F=Number.MAX_SAFE_INTEGER,N=0;return W.forEach((x,G)=>{const se=T(x);se<F&&(F=se,N=G)}),N}e.minIndex=z;function O(W,T){let F=Number.MIN_SAFE_INTEGER,N=0;return W.forEach((x,G)=>{const se=T(x);se>F&&(F=se,N=G)}),N}e.maxIndex=O}),define(ge[68],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const k=this;let y=!1,A;return function(){return y||(y=!0,A=L.apply(k,arguments)),A}}e.once=p}),define(ge[69],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(ge[70],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function k(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=k;const y=Object.freeze([]);function A(){return y}L.empty=A;function*P(g){yield g}L.single=P;function S(g){return g||y}L.from=S;function C(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=C;function r(g){return g[Symbol.iterator]().next().value}L.first=r;function I(g,t){for(const i of g)if(t(i))return!0;return!1}L.some=I;function l(g,t){for(const i of g)if(t(i))return i}L.find=l;function*h(g,t){for(const i of g)t(i)&&(yield i)}L.filter=h;function*c(g,t){let i=0;for(const s of g)yield t(s,i++)}L.map=c;function*f(...g){for(const t of g)for(const i of t)yield i}L.concat=f;function*E(g){for(const t of g)for(const i of t)yield i}L.concatNested=E;function w(g,t,i){let s=i;for(const n of g)s=t(s,n);return s}L.reduce=w;function*b(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}L.slice=b;function u(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let n=0;n<t;n++){const o=s.next();if(o.done)return[i,L.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return s}}]}L.consume=u;function d(g,t,i=(s,n)=>s===n){const s=g[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const o=s.next(),v=n.next();if(o.done!==v.done)return!1;if(o.done)return!0;if(!i(o.value,v.value))return!1}}L.equals=d})(p=e.Iterable||(e.Iterable={}))}),define(ge[52],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,i=!1){let s=0,n=t.length,o="",v=0,m=16,_=0;function D(q){let U=0,z=0;for(;U<q;){const O=t.charCodeAt(s);if(O>=48&&O<=57)z=z*16+O-48;else if(O>=65&&O<=70)z=z*16+O-65+10;else if(O>=97&&O<=102)z=z*16+O-97+10;else break;s++,U++}return U<q&&(z=-1),z}function a(q){s=q,o="",v=0,m=16,_=0}function R(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return _=3,t.substring(q,s);let U=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;U=s}else _=3;return t.substring(q,U)}function M(){let q="",U=s;for(;;){if(s>=n){q+=t.substring(U,s),_=2;break}const z=t.charCodeAt(s);if(z===34){q+=t.substring(U,s),s++;break}if(z===92){if(q+=t.substring(U,s),s++,s>=n){_=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const W=D(4);W>=0?q+=String.fromCharCode(W):_=4;break;default:_=5}U=s;continue}if(z>=0&&z<=31)if(S(z)){q+=t.substring(U,s),_=2;break}else _=6;s++}return q}function $(){if(o="",_=0,v=s,s>=n)return v=n,m=17;let q=t.charCodeAt(s);if(P(q)){do s++,o+=String.fromCharCode(q),q=t.charCodeAt(s);while(P(q));return m=15}if(S(q))return s++,o+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(q){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=M(),m=10;case 47:const U=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!S(t.charCodeAt(s));)s++;return o=t.substring(U,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const z=n-1;let O=!1;for(;s<z;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,O=!0;break}s++}return O||(s++,_=1),o=t.substring(U,s),m=13}return o+=String.fromCharCode(q),s++,m=16;case 45:if(o+=String.fromCharCode(q),s++,s===n||!C(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),m=11;default:for(;s<n&&Y(q);)s++,q=t.charCodeAt(s);if(v!==s){switch(o=t.substring(v,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(q),s++,m=16}}function Y(q){if(P(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let q;do q=$();while(q>=12&&q<=15);return q}return{setPosition:a,getPosition:()=>s,scan:i?le:$,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>_}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function I(t,i){const s=[],n=new Object;let o;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function _(D,a,R,M){v.value=D,v.offset=a,v.length=R,v.type=M,v.colonOffset=void 0,o=v}try{u(t,{onObjectBegin:(D,a)=>{if(i<=D)throw n;o=void 0,m=i>D,s.push("")},onObjectProperty:(D,a,R)=>{if(i<a||(_(D,a,R,"property"),s[s.length-1]=D,i<=a+R))throw n},onObjectEnd:(D,a)=>{if(i<=D)throw n;o=void 0,s.pop()},onArrayBegin:(D,a)=>{if(i<=D)throw n;o=void 0,s.push(0)},onArrayEnd:(D,a)=>{if(i<=D)throw n;o=void 0,s.pop()},onLiteralValue:(D,a,R)=>{if(i<a||(_(D,a,R,g(D)),i<=a+R))throw n},onSeparator:(D,a,R)=>{if(i<=a)throw n;if(D===":"&&o&&o.type==="property")o.colonOffset=a,m=!1,o=void 0;else if(D===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==n)throw D}return{path:s,previousNode:o,isAtPropertyKey:m,matches:D=>{let a=0;for(let R=0;a<D.length&&R<s.length;R++)if(D[a]===s[R]||D[a]==="*")a++;else if(D[a]!=="**")return!1;return a===D.length}}}e.getLocation=I;function l(t,i=[],s=y.DEFAULT){let n=null,o=[];const v=[];function m(D){Array.isArray(o)?o.push(D):n!==null&&(o[n]=D)}return u(t,{onObjectBegin:()=>{const D={};m(D),v.push(o),o=D,n=null},onObjectProperty:D=>{n=D},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const D=[];m(D),v.push(o),o=D,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:m,onError:(D,a,R)=>{i.push({error:D,offset:a,length:R})}},s),o[0]}e.parse=l;function h(t,i=[],s=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){n.type==="property"&&(n.length=D-n.offset,n=n.parent)}function v(D){return n.children.push(D),D}u(t,{onObjectBegin:D=>{n=v({type:"object",offset:D,length:-1,parent:n,children:[]})},onObjectProperty:(D,a,R)=>{n=v({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:D,offset:a,length:R,parent:n})},onObjectEnd:(D,a)=>{n.length=D+a-n.offset,n=n.parent,o(D+a)},onArrayBegin:(D,a)=>{n=v({type:"array",offset:D,length:-1,parent:n,children:[]})},onArrayEnd:(D,a)=>{n.length=D+a-n.offset,n=n.parent,o(D+a)},onLiteralValue:(D,a,R)=>{v({type:g(D),offset:a,length:R,parent:n,value:D}),o(a+R)},onSeparator:(D,a,R)=>{n.type==="property"&&(D===":"?n.colonOffset=a:D===","&&o(a))},onError:(D,a,R)=>{i.push({error:D,offset:a,length:R})}},s);const _=n.children[0];return _&&delete _.parent,_}e.parseTree=h;function c(t,i){if(!t)return;let s=t;for(let n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===n){s=v.children[1],o=!0;break}if(!o)return}else{const o=n;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=c;function f(t){if(!t.parent||!t.parent.children)return[];const i=f(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=f;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const i=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=E(n))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=w;function b(t,i,s=!1){if(w(t,i,s)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=i;o++){const v=b(n[o],i,s);if(v)return v}return t}}e.findNodeAtOffset=b;function u(t,i,s=y.DEFAULT){const n=A(t,!1);function o(se){return se?()=>se(n.getTokenOffset(),n.getTokenLength()):()=>!0}function v(se){return se?be=>se(be,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=o(i.onObjectBegin),_=v(i.onObjectProperty),D=o(i.onObjectEnd),a=o(i.onArrayBegin),R=o(i.onArrayEnd),M=v(i.onLiteralValue),$=v(i.onSeparator),Y=o(i.onComment),le=v(i.onError),q=s&&s.disallowComments,U=s&&s.allowTrailingComma;function z(){for(;;){const se=n.scan();switch(n.getTokenError()){case 4:O(14);break;case 5:O(15);break;case 3:O(13);break;case 1:q||O(11);break;case 2:O(12);break;case 6:O(16);break}switch(se){case 12:case 13:q?O(10):Y();break;case 16:O(1);break;case 15:case 14:break;default:return se}}}function O(se,be=[],Ie=[]){if(le(se),be.length+Ie.length>0){let Ce=n.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){z();break}else if(Ie.indexOf(Ce)!==-1)break;Ce=z()}}}function W(se){const be=n.getTokenValue();return se?M(be):_(be),z(),!0}function T(){switch(n.getToken()){case 11:let se=0;try{se=JSON.parse(n.getTokenValue()),typeof se!="number"&&(O(2),se=0)}catch(be){O(2)}M(se);break;case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return z(),!0}function F(){return n.getToken()!==10?(O(3,[],[2,5]),!1):(W(!1),n.getToken()===6?($(":"),z(),G()||O(4,[],[2,5])):O(5,[],[2,5]),!0)}function N(){m(),z();let se=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(se||O(4,[],[]),$(","),z(),n.getToken()===2&&U)break}else se&&O(6,[],[]);F()||O(4,[],[2,5]),se=!0}return D(),n.getToken()!==2?O(7,[2],[]):z(),!0}function x(){a(),z();let se=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(se||O(4,[],[]),$(","),z(),n.getToken()===4&&U)break}else se&&O(6,[],[]);G()||O(4,[],[4,5]),se=!0}return R(),n.getToken()!==4?O(8,[4],[]):z(),!0}function G(){switch(n.getToken()){case 3:return x();case 1:return N();case 10:return W(!0);default:return T()}}return z(),n.getToken()===17?s.allowEmptyContent?!0:(O(4,[],[]),!1):G()?(n.getToken()!==17&&O(9,[],[]),!0):(O(4,[],[]),!1)}e.visit=u;function d(t,i){let s=A(t),n=[],o,v=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:v!==m&&n.push(t.substring(v,m)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),v=s.getPosition();break}while(o!==17);return n.join("")}e.stripComments=d;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ge[132],pe([0,1,52]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,C,r){let I,l,h,c,f;if(C){for(c=C.offset,f=c+C.length,h=c;h>0&&!P(S,h-1);)h--;let v=f;for(;v<S.length&&!P(S,v);)v++;l=S.substring(h,v),I=y(l,r)}else l=S,I=0,h=0,c=0,f=S.length;const E=A(r,S);let w=!1,b=0,u;r.insertSpaces?u=k(" ",r.tabSize||4):u="	";const d=p.createScanner(l,!1);let g=!1;function t(){return E+k(u,I+b)}function i(){let v=d.scan();for(w=!1;v===15||v===14;)w=w||v===14,v=d.scan();return g=v===16||d.getTokenError()!==0,v}const s=[];function n(v,m,_){!g&&m<f&&_>c&&S.substring(m,_)!==v&&s.push({offset:m,length:_-m,content:v})}let o=i();if(o!==17){const v=d.getTokenOffset()+h,m=k(u,I);n(m,h,v)}for(;o!==17;){let v=d.getTokenOffset()+d.getTokenLength()+h,m=i(),_="";for(;!w&&(m===12||m===13);){const a=d.getTokenOffset()+h;n(" ",v,a),v=d.getTokenOffset()+d.getTokenLength()+h,_=m===12?t():"",m=i()}if(m===2)o!==1&&(b--,_=t());else if(m===4)o!==3&&(b--,_=t());else{switch(o){case 3:case 1:b++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(m===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?_=" ":m!==5&&m!==17&&(g=!0);break;case 16:g=!0;break}w&&(m===12||m===13)&&(_=t())}const D=d.getTokenOffset()+h;n(_,v,D),o=m}return s}e.format=L;function k(S,C){let r="";for(let I=0;I<C;I++)r+=S;return r}function y(S,C){let r=0,I=0;const l=C.tabSize||4;for(;r<S.length;){const h=S.charAt(r);if(h===" ")I++;else if(h==="	")I+=l;else break;r++}return Math.floor(I/l)}function A(S,C){for(let r=0;r<C.length;r++){const I=C.charAt(r);if(I==="\r")return r+1<C.length&&C.charAt(r+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=A;function P(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=P}),define(ge[133],pe([0,1,52,132]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(C,r,I){return y(C,r,void 0,I)}e.removeProperty=k;function y(C,r,I,l,h){const c=r.slice(),f=[],E=p.parseTree(C,f);let w,b;for(;c.length>0&&(b=c.pop(),w=p.findNodeAtLocation(E,c),w===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const u=p.findNodeAtLocation(w,[b]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const d=w.children.indexOf(u.parent);let g,t=u.parent.offset+u.parent.length;if(d>0){const i=w.children[d-1];g=i.offset+i.length}else g=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(C,{offset:g,length:t-g,content:""},l)}else return A(C,{offset:u.offset,length:u.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const d=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,g=h?h(w.children.map(i=>i.children[0].value)):w.children.length;let t;if(g>0){const i=w.children[g-1];t={offset:i.offset+i.length,length:0,content:","+d}}else w.children.length===0?t={offset:w.offset+1,length:0,content:d}:t={offset:w.offset+1,length:0,content:d+","};return A(C,t,l)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let d;if(w.children.length===0||b===0)d={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const g=b===-1||b>w.children.length?w.children.length:b,t=w.children[g-1];d={offset:t.offset+t.length,length:0,content:","+u}}return A(C,d,l)}else{const u=b,d=w.children[u];let g;if(w.children.length===1)g={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],i=t.offset+t.length,s=w.offset+w.length;g={offset:i,length:s-2-i,content:""}}else g={offset:d.offset,length:w.children[u+1].offset-d.offset,content:""};return A(C,g,l)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(I)},l)}}e.setProperty=y;function A(C,r,I){let l=P(C,r),h=r.offset,c=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;h>0&&!L.isEOL(l,h-1);)h--;for(;c<l.length&&!L.isEOL(l,c);)c++}const f=L.format(l,{offset:h,length:c-h},I);for(let w=f.length-1;w>=0;w--){const b=f[w];l=P(l,b),h=Math.min(h,b.offset),c=Math.max(c,b.offset+b.length),c+=b.content.length-b.length}const E=C.length-(l.length-c)-h;return[{offset:h,length:E,content:l.substring(h,c)}]}e.withFormatting=A;function P(C,r){return C.substring(0,r.offset)+r.content+C.substring(r.offset+r.length)}e.applyEdit=P;function S(C,r){let I=r.slice(0).sort((h,c)=>{const f=h.offset-c.offset;return f===0?h.length-c.length:f}),l=C.length;for(let h=I.length-1;h>=0;h--){let c=I[h];if(c.offset+c.length<=l)C=P(C,c);else throw new Error("Overlapping edit");l=c.offset}return C}e.applyEdits=S}),define(ge[134],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new p(()=>k(this.getValue()))}}e.Lazy=p}),define(ge[6],pe([0,1,68,70]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let y=null;function A(d){y=d}if(e.setDisposableTracker=A,k){const d="__is_disposable_tracked__";y=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[d]||console.log(t)},3e3)}markTracked(g){if(g&&g!==f.None)try{g[d]=!0}catch(t){}}}}function P(d){!y||y.markTracked(d)}function S(d){return y&&y.trackDisposable(d),d}e.trackDisposable=S;class C extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=C;function r(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=r;function I(d){if(L.Iterable.is(d)){let g=[];for(const t of d)if(t){P(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new C(g);return Array.isArray(d)?[]:d}else if(d)return P(d),d.dispose(),d}e.dispose=I;function l(...d){return d.forEach(P),h(()=>I(d))}e.combinedDisposable=l;function h(d){const g=S({dispose:()=>{P(g),d()}});return g}e.toDisposable=h;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return P(g),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new c,S(this)}dispose(){P(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&P(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,P(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,n=p.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:n}}}e.ReferenceCollection=w;class b{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=b;class u{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=u}),define(ge[71],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(y){this.element=y,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let y=this._first;for(;y!==p.Undefined;){const A=y.next;y.prev=p.Undefined,y.next=p.Undefined,y=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const P=new p(y);if(this._first===p.Undefined)this._first=P,this._last=P;else if(A){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==p.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==p.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==p.Undefined&&y.next!==p.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===p.Undefined&&y.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):y.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):y.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==p.Undefined;)yield y.element,y=y.next}}e.LinkedList=L}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(De,Se){for(var Pe=0;Pe<Se.length;Pe++){var ae=Se[Pe];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(De,ae.key,ae)}}function e(De,Se,Pe){return Se&&X(De.prototype,Se),Pe&&X(De,Pe),De}function p(De,Se){if(!!De){if(typeof De=="string")return L(De,Se);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return L(De,Se)}}function L(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Pe=0,ae=new Array(Se);Pe<Se;Pe++)ae[Pe]=De[Pe];return ae}function k(De,Se){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=p(De))||Se&&De&&typeof De.length=="number"){Pe&&(De=Pe);var ae=0;return function(){return ae>=De.length?{done:!0}:{done:!1,value:De[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function y(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var A=y(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(ae){De.exports.defaults=ae}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),P=/[&<>"']/,S=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(Se){return I[Se]};function h(De,Se){if(Se){if(P.test(De))return De.replace(S,l)}else if(C.test(De))return De.replace(r,l);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(De){return De.replace(c,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(De,Se){De=De.source||De,Se=Se||"";var Pe={replace:function(fe,H){return H=H.source||H,H=H.replace(E,"$1"),De=De.replace(fe,H),Pe},getRegex:function(){return new RegExp(De,Se)}};return Pe}var b=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(De,Se,Pe){if(De){var ae;try{ae=decodeURIComponent(f(Pe)).replace(b,"").toLowerCase()}catch(fe){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!u.test(Pe)&&(Pe=n(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(fe){return null}return Pe}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(De,Se){g[" "+De]||(t.test(De)?g[" "+De]=De+"/":g[" "+De]=_(De,"/",!0)),De=g[" "+De];var Pe=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:De.replace(i,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:De.replace(s,"$1")+Se:De+Se}var o={exec:function(){}};function v(De){for(var Se=1,Pe,ae;Se<arguments.length;Se++){Pe=arguments[Se];for(ae in Pe)Object.prototype.hasOwnProperty.call(Pe,ae)&&(De[ae]=Pe[ae])}return De}function m(De,Se){var Pe=De.replace(/\|/g,function(H,ee,ue){for(var Ae=!1,Re=ee;--Re>=0&&ue[Re]==="\\";)Ae=!Ae;return Ae?"|":" |"}),ae=Pe.split(/ \|/),fe=0;if(ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function _(De,Se,Pe){var ae=De.length;if(ae===0)return"";for(var fe=0;fe<ae;){var H=De.charAt(ae-fe-1);if(H===Se&&!Pe)fe++;else if(H!==Se&&Pe)fe++;else break}return De.substr(0,ae-fe)}function D(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Pe=De.length,ae=0,fe=0;fe<Pe;fe++)if(De[fe]==="\\")fe++;else if(De[fe]===Se[0])ae++;else if(De[fe]===Se[1]&&(ae--,ae<0))return fe;return-1}function a(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(De,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=De),Se>>=1,De+=De;return Pe+De}var M={escape:h,unescape:f,edit:w,cleanUrl:d,resolveUrl:n,noopTest:o,merge:v,splitCells:m,rtrim:_,findClosingBracket:D,checkSanitizeDeprecation:a,repeatString:R},$=A.defaults,Y=M.rtrim,le=M.splitCells,q=M.escape,U=M.findClosingBracket;function z(De,Se,Pe){var ae=Se.href,fe=Se.title?q(Se.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:ae,title:fe,text:H}:{type:"image",raw:Pe,href:ae,title:fe,text:q(H)}}function O(De,Se){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var ae=Pe[1];return Se.split(`
`).map(function(fe){var H=fe.match(/^\s+/);if(H===null)return fe;var ee=H[0];return ee.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var W=function(){function De(Pe){this.options=Pe||$}var Se=De.prototype;return Se.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe)return fe[0].length>1?{type:"space",raw:fe[0]}:{raw:`
`}},Se.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var H=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?H:Y(H,`
`)}}},Se.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var H=fe[0],ee=O(H,fe[3]||"");return{type:"code",raw:H,lang:fe[2]?fe[2].trim():fe[2],text:ee}}},Se.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var H=fe[2].trim();if(/#$/.test(H)){var ee=Y(H,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(H=ee.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:H}}},Se.nptable=function(ae){var fe=this.rules.block.nptable.exec(ae);if(fe){var H={type:"table",header:le(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[],raw:fe[0]};if(H.header.length===H.align.length){var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=le(H.cells[ue],H.header.length);return H}}},Se.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},Se.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var H=fe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:fe[0],text:H}}},Se.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var H=fe[0],ee=fe[2],ue=ee.length>1,Ae={type:"list",raw:H,ordered:ue,start:ue?+ee.slice(0,-1):"",loose:!1,items:[]},Re=fe[0].match(this.rules.block.item),Ue=!1,ze,Ze,Je,Xe,nt,gt,_e,ye,de=Re.length;Je=this.rules.block.listItemStart.exec(Re[0]);for(var Q=0;Q<de;Q++){if(ze=Re[Q],H=ze,Q!==de-1){if(Xe=this.rules.block.listItemStart.exec(Re[Q+1]),this.options.pedantic?Xe[1].length>Je[1].length:Xe[1].length>Je[0].length||Xe[1].length>3){Re.splice(Q,2,Re[Q]+`
`+Re[Q+1]),Q--,de--;continue}else(!this.options.pedantic||this.options.smartLists?Xe[2][Xe[2].length-1]!==ee[ee.length-1]:ue===(Xe[2].length===1))&&(nt=Re.slice(Q+1).join(`
`),Ae.raw=Ae.raw.substring(0,Ae.raw.length-nt.length),Q=de-1);Je=Xe}Ze=ze.length,ze=ze.replace(/^ *([*+-]|\d+[.)]) ?/,""),~ze.indexOf(`
 `)&&(Ze-=ze.length,ze=this.options.pedantic?ze.replace(/^ {1,4}/gm,""):ze.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),gt=Ue||/\n\n(?!\s*$)/.test(ze),Q!==de-1&&(Ue=ze.charAt(ze.length-1)===`
`,gt||(gt=Ue)),gt&&(Ae.loose=!0),this.options.gfm&&(_e=/^\[[ xX]\] /.test(ze),ye=void 0,_e&&(ye=ze[1]!==" ",ze=ze.replace(/^\[[ xX]\] +/,""))),Ae.items.push({type:"list_item",raw:H,task:_e,checked:ye,loose:gt,text:ze})}return Ae}},Se.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe)return{type:this.options.sanitize?"paragraph":"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):q(fe[0]):fe[0]}},Se.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var H=fe[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:fe[0],href:fe[2],title:fe[3]}}},Se.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var H={type:"table",header:le(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=fe[0];var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=le(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},Se.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1]}},Se.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe)return{type:"paragraph",raw:fe[0],text:fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1]}},Se.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0]}},Se.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:q(fe[1])}},Se.tag=function(ae,fe,H){var ee=this.rules.inline.tag.exec(ae);if(ee)return!fe&&/^<a /i.test(ee[0])?fe=!0:fe&&/^<\/a>/i.test(ee[0])&&(fe=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:fe,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]}},Se.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var H=fe[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var ee=Y(H.slice(0,-1),"\\");if((H.length-ee.length)%2==0)return}else{var ue=U(fe[2],"()");if(ue>-1){var Ae=fe[0].indexOf("!")===0?5:4,Re=Ae+fe[1].length+ue;fe[2]=fe[2].substring(0,ue),fe[0]=fe[0].substring(0,Re).trim(),fe[3]=""}}var Ue=fe[2],ze="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Ze&&(Ue=Ze[1],ze=Ze[3])}else ze=fe[3]?fe[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(H)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),z(fe,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},fe[0])}},Se.reflink=function(ae,fe){var H;if((H=this.rules.inline.reflink.exec(ae))||(H=this.rules.inline.nolink.exec(ae))){var ee=(H[2]||H[1]).replace(/\s+/g," ");if(ee=fe[ee.toLowerCase()],!ee||!ee.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return z(H,ee,H[0])}},Se.emStrong=function(ae,fe,H){H===void 0&&(H="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ee&&!(ee[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ee[1]||ee[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Ae=ee[0].length-1,Re,Ue,ze=Ae,Ze=0,Je=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Je.lastIndex=0,fe=fe.slice(-1*ae.length+Ae);(ee=Je.exec(fe))!=null;)if(Re=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Re){if(Ue=Re.length,ee[3]||ee[4]){ze+=Ue;continue}else if((ee[5]||ee[6])&&Ae%3&&!((Ae+Ue)%3)){Ze+=Ue;continue}if(ze-=Ue,!(ze>0)){if(ze+Ze-Ue<=0&&!fe.slice(Je.lastIndex).match(Je)&&(Ue=Math.min(Ue,Ue+ze+Ze)),Math.min(Ae,Ue)%2)return{type:"em",raw:ae.slice(0,Ae+ee.index+Ue+1),text:ae.slice(1,Ae+ee.index+Ue)};if(Math.min(Ae,Ue)%2==0)return{type:"strong",raw:ae.slice(0,Ae+ee.index+Ue+1),text:ae.slice(2,Ae+ee.index+Ue-1)}}}}}},Se.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var H=fe[2].replace(/\n/g," "),ee=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return ee&&ue&&(H=H.substring(1,H.length-1)),H=q(H,!0),{type:"codespan",raw:fe[0],text:H}}},Se.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},Se.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2]}},Se.autolink=function(ae,fe){var H=this.rules.inline.autolink.exec(ae);if(H){var ee,ue;return H[2]==="@"?(ee=q(this.options.mangle?fe(H[1]):H[1]),ue="mailto:"+ee):(ee=q(H[1]),ue=ee),{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},Se.url=function(ae,fe){var H;if(H=this.rules.inline.url.exec(ae)){var ee,ue;if(H[2]==="@")ee=q(this.options.mangle?fe(H[0]):H[0]),ue="mailto:"+ee;else{var Ae;do Ae=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Ae!==H[0]);ee=q(H[0]),H[1]==="www."?ue="http://"+ee:ue=ee}return{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},Se.inlineText=function(ae,fe,H){var ee=this.rules.inline.text.exec(ae);if(ee){var ue;return fe?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]:ue=q(this.options.smartypants?H(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},De}(),T=M.noopTest,F=M.edit,N=M.merge,x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:T,table:T,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=F(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,x.item=F(x.item,"gm").replace(/bull/g,x.bullet).getRegex(),x.listItemStart=F(/^( *)(bull)/).replace("bull",x.bullet).getRegex(),x.list=F(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=F(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=F(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.blockquote=F(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=N({},x),x.gfm=N({},x.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.nptable=F(x.gfm.nptable).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.gfm.table=F(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.pedantic=N({},x.normal,{html:F(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:T,paragraph:F(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:T,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:T,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=F(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=F(x._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=F(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=F(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=F(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=F(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=F(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=F(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=F(G.reflink).replace("label",G._label).getRegex(),G.reflinkSearch=F(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=N({},G),G.pedantic=N({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:F(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:F(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=N({},G.normal,{escape:F(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),G.gfm.url=F(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=N({},G.gfm,{br:F(G.br).replace("{2,}","*").getRegex(),text:F(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var se={block:x,inline:G},be=A.defaults,Ie=se.block,Ce=se.inline,Me=M.repeatString;function qe(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function He(De){var Se="",Pe,ae,fe=De.length;for(Pe=0;Pe<fe;Pe++)ae=De.charCodeAt(Pe),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var Ve=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||be,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ae={block:Ie.normal,inline:Ce.normal};this.options.pedantic?(ae.block=Ie.pedantic,ae.inline=Ce.pedantic):this.options.gfm&&(ae.block=Ie.gfm,this.options.breaks?ae.inline=Ce.breaks:ae.inline=Ce.gfm),this.tokenizer.rules=ae}De.lex=function(ae,fe){var H=new De(fe);return H.lex(ae)},De.lexInline=function(ae,fe){var H=new De(fe);return H.inlineTokens(ae)};var Se=De.prototype;return Se.lex=function(ae){return ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(ae,fe,H){fe===void 0&&(fe=[]),H===void 0&&(H=!0),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var ee,ue,Ae,Re;ae;){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.type&&fe.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),Re=fe[fe.length-1],Re&&Re.type==="paragraph"?(Re.raw+=`
`+ee.raw,Re.text+=`
`+ee.text):fe.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.nptable(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],H),fe.push(ee);continue}if(ee=this.tokenizer.list(ae)){for(ae=ae.substring(ee.raw.length),Ae=ee.items.length,ue=0;ue<Ae;ue++)ee.items[ue].tokens=this.blockTokens(ee.items[ue].text,[],!1);fe.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(H&&(ee=this.tokenizer.def(ae))){ae=ae.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(H&&(ee=this.tokenizer.paragraph(ae))){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),Re=fe[fe.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+ee.raw,Re.text+=`
`+ee.text):fe.push(ee);continue}if(ae){var Ue="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return fe},Se.inline=function(ae){var fe,H,ee,ue,Ae,Re,Ue=ae.length;for(fe=0;fe<Ue;fe++)switch(Re=ae[fe],Re.type){case"paragraph":case"text":case"heading":{Re.tokens=[],this.inlineTokens(Re.text,Re.tokens);break}case"table":{for(Re.tokens={header:[],cells:[]},ue=Re.header.length,H=0;H<ue;H++)Re.tokens.header[H]=[],this.inlineTokens(Re.header[H],Re.tokens.header[H]);for(ue=Re.cells.length,H=0;H<ue;H++)for(Ae=Re.cells[H],Re.tokens.cells[H]=[],ee=0;ee<Ae.length;ee++)Re.tokens.cells[H][ee]=[],this.inlineTokens(Ae[ee],Re.tokens.cells[H][ee]);break}case"blockquote":{this.inline(Re.tokens);break}case"list":{for(ue=Re.items.length,H=0;H<ue;H++)this.inline(Re.items[H].tokens);break}}return ae},Se.inlineTokens=function(ae,fe,H,ee){fe===void 0&&(fe=[]),H===void 0&&(H=!1),ee===void 0&&(ee=!1);var ue,Ae,Re=ae,Ue,ze,Ze;if(this.tokens.links){var Je=Object.keys(this.tokens.links);if(Je.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)Je.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,Ue.index)+"["+Me("a",Ue[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,Ue.index)+"["+Me("a",Ue[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,Ue.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;){if(ze||(Ze=""),ze=!1,ue=this.tokenizer.escape(ae)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.tag(ae,H,ee)){ae=ae.substring(ue.raw.length),H=ue.inLink,ee=ue.inRawBlock;var Xe=fe[fe.length-1];Xe&&ue.type==="text"&&Xe.type==="text"?(Xe.raw+=ue.raw,Xe.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.link(ae)){ae=ae.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ee)),fe.push(ue);continue}if(ue=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ue.raw.length);var nt=fe[fe.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ee),fe.push(ue)):nt&&ue.type==="text"&&nt.type==="text"?(nt.raw+=ue.raw,nt.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.emStrong(ae,Re,Ze)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),fe.push(ue);continue}if(ue=this.tokenizer.codespan(ae)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.br(ae)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.del(ae)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),fe.push(ue);continue}if(ue=this.tokenizer.autolink(ae,He)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(!H&&(ue=this.tokenizer.url(ae,He))){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.inlineText(ae,ee,qe)){ae=ae.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Ze=ue.raw.slice(-1)),ze=!0,Ae=fe[fe.length-1],Ae&&Ae.type==="text"?(Ae.raw+=ue.raw,Ae.text+=ue.text):fe.push(ue);continue}if(ae){var gt="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return fe},e(De,null,[{key:"rules",get:function(){return{block:Ie,inline:Ce}}}]),De}(),j=A.defaults,Z=M.cleanUrl,ne=M.escape,oe=function(){function De(Pe){this.options=Pe||j}var Se=De.prototype;return Se.code=function(ae,fe,H){var ee=(fe||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(ae,ee);ue!=null&&ue!==ae&&(H=!0,ae=ue)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+ne(ee,!0)+'">'+(H?ae:ne(ae,!0))+`</code></pre>
`:"<pre><code>"+(H?ae:ne(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,fe,H,ee){return this.options.headerIds?"<h"+fe+' id="'+this.options.headerPrefix+ee.slug(H)+'">'+ae+"</h"+fe+`>
`:"<h"+fe+">"+ae+"</h"+fe+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,fe,H){var ee=fe?"ol":"ul",ue=fe&&H!==1?' start="'+H+'"':"";return"<"+ee+ue+`>
`+ae+"</"+ee+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,fe){var H=fe.header?"th":"td",ee=fe.align?"<"+H+' align="'+fe.align+'">':"<"+H+">";return ee+ae+"</"+H+`>
`},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,fe,H){if(ae=Z(this.options.sanitize,this.options.baseUrl,ae),ae===null)return H;var ee='<a href="'+ne(ae)+'"';return fe&&(ee+=' title="'+fe+'"'),ee+=">"+H+"</a>",ee},Se.image=function(ae,fe,H){if(ae=Z(this.options.sanitize,this.options.baseUrl,ae),ae===null)return H;var ee='<img src="'+ae+'" alt="'+H+'"';return fe&&(ee+=' title="'+fe+'"'),ee+=this.options.xhtml?"/>":">",ee},Se.text=function(ae){return ae},De}(),J=function(){function De(){}var Se=De.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,fe,H){return""+H},Se.image=function(ae,fe,H){return""+H},Se.br=function(){return""},De}(),ce=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,fe){var H=ae,ee=0;if(this.seen.hasOwnProperty(H)){ee=this.seen[ae];do ee++,H=ae+"-"+ee;while(this.seen.hasOwnProperty(H))}return fe||(this.seen[ae]=ee,this.seen[H]=0),H},Se.slug=function(ae,fe){fe===void 0&&(fe={});var H=this.serialize(ae);return this.getNextSafeSlug(H,fe.dryrun)},De}(),me=A.defaults,Le=M.unescape,We=function(){function De(Pe){this.options=Pe||me,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new ce}De.parse=function(ae,fe){var H=new De(fe);return H.parse(ae)},De.parseInline=function(ae,fe){var H=new De(fe);return H.parseInline(ae)};var Se=De.prototype;return Se.parse=function(ae,fe){fe===void 0&&(fe=!0);var H="",ee,ue,Ae,Re,Ue,ze,Ze,Je,Xe,nt,gt,_e,ye,de,Q,xe,we,Ye,et=ae.length;for(ee=0;ee<et;ee++)switch(nt=ae[ee],nt.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Le(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(Je="",Ze="",Re=nt.header.length,ue=0;ue<Re;ue++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[ue]),{header:!0,align:nt.align[ue]});for(Je+=this.renderer.tablerow(Ze),Xe="",Re=nt.cells.length,ue=0;ue<Re;ue++){for(ze=nt.tokens.cells[ue],Ze="",Ue=ze.length,Ae=0;Ae<Ue;Ae++)Ze+=this.renderer.tablecell(this.parseInline(ze[Ae]),{header:!1,align:nt.align[Ae]});Xe+=this.renderer.tablerow(Ze)}H+=this.renderer.table(Je,Xe);continue}case"blockquote":{Xe=this.parse(nt.tokens),H+=this.renderer.blockquote(Xe);continue}case"list":{for(gt=nt.ordered,_e=nt.start,ye=nt.loose,Re=nt.items.length,Xe="",ue=0;ue<Re;ue++)Q=nt.items[ue],xe=Q.checked,we=Q.task,de="",Q.task&&(Ye=this.renderer.checkbox(xe),ye?Q.tokens.length>0&&Q.tokens[0].type==="text"?(Q.tokens[0].text=Ye+" "+Q.tokens[0].text,Q.tokens[0].tokens&&Q.tokens[0].tokens.length>0&&Q.tokens[0].tokens[0].type==="text"&&(Q.tokens[0].tokens[0].text=Ye+" "+Q.tokens[0].tokens[0].text)):Q.tokens.unshift({type:"text",text:Ye}):de+=Ye),de+=this.parse(Q.tokens,ye),Xe+=this.renderer.listitem(de,we,xe);H+=this.renderer.list(Xe,gt,_e);continue}case"html":{H+=this.renderer.html(nt.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Xe=nt.tokens?this.parseInline(nt.tokens):nt.text;ee+1<et&&ae[ee+1].type==="text";)nt=ae[++ee],Xe+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);H+=fe?this.renderer.paragraph(Xe):Xe;continue}default:{var rt='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}return H},Se.parseInline=function(ae,fe){fe=fe||this.renderer;var H="",ee,ue,Ae=ae.length;for(ee=0;ee<Ae;ee++)switch(ue=ae[ee],ue.type){case"escape":{H+=fe.text(ue.text);break}case"html":{H+=fe.html(ue.text);break}case"link":{H+=fe.link(ue.href,ue.title,this.parseInline(ue.tokens,fe));break}case"image":{H+=fe.image(ue.href,ue.title,ue.text);break}case"strong":{H+=fe.strong(this.parseInline(ue.tokens,fe));break}case"em":{H+=fe.em(this.parseInline(ue.tokens,fe));break}case"codespan":{H+=fe.codespan(ue.text);break}case"br":{H+=fe.br();break}case"del":{H+=fe.del(this.parseInline(ue.tokens,fe));break}case"text":{H+=fe.text(ue.text);break}default:{var Re='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}return H},De}(),Ee=M.merge,Ke=M.checkSanitizeDeprecation,K=M.escape,ie=A.getDefaults,ve=A.changeDefaults,Fe=A.defaults;function Ne(De,Se,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=Ee({},Ne.defaults,Se||{}),Ke(Se),Pe){var ae=Se.highlight,fe;try{fe=Ve.lex(De,Se)}catch(Ae){return Pe(Ae)}var H=function(Re){var Ue;if(!Re)try{Ue=We.parse(fe,Se)}catch(ze){Re=ze}return Se.highlight=ae,Re?Pe(Re):Pe(null,Ue)};if(!ae||ae.length<3||(delete Se.highlight,!fe.length))return H();var ee=0;Ne.walkTokens(fe,function(Ae){Ae.type==="code"&&(ee++,setTimeout(function(){ae(Ae.text,Ae.lang,function(Re,Ue){if(Re)return H(Re);Ue!=null&&Ue!==Ae.text&&(Ae.text=Ue,Ae.escaped=!0),ee--,ee===0&&H()})},0))}),ee===0&&H();return}try{var ue=Ve.lex(De,Se);return Se.walkTokens&&Ne.walkTokens(ue,Se.walkTokens),We.parse(ue,Se)}catch(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+K(Ae.message+"",!0)+"</pre>";throw Ae}}Ne.options=Ne.setOptions=function(De){return Ee(Ne.defaults,De),ve(Ne.defaults),Ne},Ne.getDefaults=ie,Ne.defaults=Fe,Ne.use=function(De){var Se=Ee({},De);if(De.renderer&&function(){var ae=Ne.defaults.renderer||new oe,fe=function(ue){var Ae=ae[ue];ae[ue]=function(){for(var Re=arguments.length,Ue=new Array(Re),ze=0;ze<Re;ze++)Ue[ze]=arguments[ze];var Ze=De.renderer[ue].apply(ae,Ue);return Ze===!1&&(Ze=Ae.apply(ae,Ue)),Ze}};for(var H in De.renderer)fe(H);Se.renderer=ae}(),De.tokenizer&&function(){var ae=Ne.defaults.tokenizer||new W,fe=function(ue){var Ae=ae[ue];ae[ue]=function(){for(var Re=arguments.length,Ue=new Array(Re),ze=0;ze<Re;ze++)Ue[ze]=arguments[ze];var Ze=De.tokenizer[ue].apply(ae,Ue);return Ze===!1&&(Ze=Ae.apply(ae,Ue)),Ze}};for(var H in De.tokenizer)fe(H);Se.tokenizer=ae}(),De.walkTokens){var Pe=Ne.defaults.walkTokens;Se.walkTokens=function(ae){De.walkTokens(ae),Pe&&Pe(ae)}}Ne.setOptions(Se)},Ne.walkTokens=function(De,Se){for(var Pe=k(De),ae;!(ae=Pe()).done;){var fe=ae.value;switch(Se(fe),fe.type){case"table":{for(var H=k(fe.tokens.header),ee;!(ee=H()).done;){var ue=ee.value;Ne.walkTokens(ue,Se)}for(var Ae=k(fe.tokens.cells),Re;!(Re=Ae()).done;)for(var Ue=Re.value,ze=k(Ue),Ze;!(Ze=ze()).done;){var Je=Ze.value;Ne.walkTokens(Je,Se)}break}case"list":{Ne.walkTokens(fe.items,Se);break}default:fe.tokens&&Ne.walkTokens(fe.tokens,Se)}}},Ne.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=Ee({},Ne.defaults,Se||{}),Ke(Se);try{var Pe=Ve.lexInline(De,Se);return Se.walkTokens&&Ne.walkTokens(Pe,Se.walkTokens),We.parseInline(Pe,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+K(ae.message+"",!0)+"</pre>";throw ae}},Ne.Parser=We,Ne.parser=We.parse,Ne.Renderer=oe,Ne.TextRenderer=J,Ne.Lexer=Ve,Ne.lexer=Ve.lex,Ne.Tokenizer=W,Ne.Slugger=ce,Ne.parse=Ne;var Qe=Ne;return Qe}),define(ge[72],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(A,P,S){return Math.min(Math.max(A,P),S)}e.clamp=p;function L(A,P){return(P+A%P)%P}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class y{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function A(S){y.push(S,Date.now())}function P(){const S=[];for(let C=0;C<y.length;C+=2)S.push({name:y[C],startTime:y[C+1]});return S}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(k+A.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(ge[11],pe([0,1]),function(X,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let k=!1,y=!1,A=!1,P=!1,S=!1,C=!1,r=!1,I,l=L,h,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const E=typeof((p=f==null?void 0:f.versions)===null||p===void 0?void 0:p.electron)=="string"&&f.type==="renderer";if(e.isElectronSandboxed=E&&(f==null?void 0:f.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=f==null?void 0:f.env.VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)c=navigator.userAgent,k=c.indexOf("Windows")>=0,y=c.indexOf("Macintosh")>=0,r=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,C=!0,I=navigator.language,l=I;else if(typeof f=="object"){k=f.platform==="win32",y=f.platform==="darwin",A=f.platform==="linux",P=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,I=L,l=L;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),v=o.availableLanguages["*"];I=o.locale,l=v||L,h=o._translationsConfigFile}catch(o){}S=!0}else console.error("Unable to resolve platform.");var w;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let u=0;y?u=1:k?u=3:A&&(u=2),e.isWindows=k,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=P,e.isNative=S,e.isWeb=C,e.isIOS=r,e.platform=u,e.userAgent=c,e.language=l;var d;(function(n){function o(){return e.language}n.value=o;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=v;function m(){return e.language==="en"}n.isDefault=m})(d=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let v=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let D=0,a=v.length;D<a;D++){const R=v[D];if(R.id===_.data.vscodeSetImmediateId){v.splice(D,1),R.callback();return}}});let m=0;return _=>{const D=++m;v.push({id:D,callback:_}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof(f==null?void 0:f.nextTick)=="function")return f.nextTick.bind(f);const o=Promise.resolve();return v=>o.then(v)}();var g;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||r?2:k?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,t=new Uint16Array(n.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(ge[37],pe([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const k=p.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return p.setImmediate(y)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(k){return p.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(ge[9],pe([0,1,37]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,y=90,A=122,P=46,S=47,C=92,r=58,I=63;class l extends Error{constructor(d,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${s} ${i} of type ${g}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,d){if(typeof u!="string")throw new l(d,"string",u)}function c(u){return u===S||u===C}function f(u){return u===S}function E(u){return u>=L&&u<=y||u>=k&&u<=A}function w(u,d,g,t){let i="",s=0,n=-1,o=0,v=0;for(let m=0;m<=u.length;++m){if(m<u.length)v=u.charCodeAt(m);else{if(t(v))break;v=S}if(t(v)){if(!(n===m-1||o===1))if(o===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const _=i.lastIndexOf(g);_===-1?(i="",s=0):(i=i.slice(0,_),s=i.length-1-i.lastIndexOf(g)),n=m,o=0;continue}else if(i.length!==0){i="",s=0,n=m,o=0;continue}}d&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${u.slice(n+1,m)}`:i=u.slice(n+1,m),s=m-n-1;n=m,o=0}else v===P&&o!==-1?++o:o=-1}return i}function b(u,d){if(d===null||typeof d!="object")throw new l("pathObject","Object",d);const g=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return g?g===d.root?`${g}${t}`:`${g}${u}${t}`:t}e.win32={resolve(...u){let d="",g="",t=!1;for(let i=u.length-1;i>=-1;i--){let s;if(i>=0){if(s=u[i],h(s,"path"),s.length===0)continue}else d.length===0?s=p.cwd():(s=p.env[`=${d}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==d.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${d}\\`));const n=s.length;let o=0,v="",m=!1;const _=s.charCodeAt(0);if(n===1)c(_)&&(o=1,m=!0);else if(c(_))if(m=!0,c(s.charCodeAt(1))){let D=2,a=D;for(;D<n&&!c(s.charCodeAt(D));)D++;if(D<n&&D!==a){const R=s.slice(a,D);for(a=D;D<n&&c(s.charCodeAt(D));)D++;if(D<n&&D!==a){for(a=D;D<n&&!c(s.charCodeAt(D));)D++;(D===n||D!==a)&&(v=`\\\\${R}\\${s.slice(a,D)}`,o=D)}}}else o=1;else E(_)&&s.charCodeAt(1)===r&&(v=s.slice(0,2),o=2,n>2&&c(s.charCodeAt(2))&&(m=!0,o=3));if(v.length>0)if(d.length>0){if(v.toLowerCase()!==d.toLowerCase())continue}else d=v;if(t){if(d.length>0)break}else if(g=`${s.slice(o)}\\${g}`,t=m,m&&d.length>0)break}return g=w(g,!t,"\\",c),t?`${d}\\${g}`:`${d}${g}`||"."},normalize(u){h(u,"path");const d=u.length;if(d===0)return".";let g=0,t,i=!1;const s=u.charCodeAt(0);if(d===1)return f(s)?"\\":u;if(c(s))if(i=!0,c(u.charCodeAt(1))){let o=2,v=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==v){const m=u.slice(v,o);for(v=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==v){for(v=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return`\\\\${m}\\${u.slice(v)}\\`;o!==v&&(t=`\\\\${m}\\${u.slice(v,o)}`,g=o)}}}else g=1;else E(s)&&u.charCodeAt(1)===r&&(t=u.slice(0,2),g=2,d>2&&c(u.charCodeAt(2))&&(i=!0,g=3));let n=g<d?w(u.slice(g),!i,"\\",c):"";return n.length===0&&!i&&(n="."),n.length>0&&c(u.charCodeAt(d-1))&&(n+="\\"),t===void 0?i?`\\${n}`:n:i?`${t}\\${n}`:`${t}${n}`},isAbsolute(u){h(u,"path");const d=u.length;if(d===0)return!1;const g=u.charCodeAt(0);return c(g)||d>2&&E(g)&&u.charCodeAt(1)===r&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,g;for(let s=0;s<u.length;++s){const n=u[s];h(n,"path"),n.length>0&&(d===void 0?d=g=n:d+=`\\${n}`)}if(d===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++i;const s=g.length;s>1&&c(g.charCodeAt(1))&&(++i,s>2&&(c(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<d.length&&c(d.charCodeAt(i));)i++;i>=2&&(d=`\\${d.slice(i)}`)}return e.win32.normalize(d)},relative(u,d){if(h(u,"from"),h(d,"to"),u===d)return"";const g=e.win32.resolve(u),t=e.win32.resolve(d);if(g===t||(u=g.toLowerCase(),d=t.toLowerCase(),u===d))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===C;)i++;let s=u.length;for(;s-1>i&&u.charCodeAt(s-1)===C;)s--;const n=s-i;let o=0;for(;o<d.length&&d.charCodeAt(o)===C;)o++;let v=d.length;for(;v-1>o&&d.charCodeAt(v-1)===C;)v--;const m=v-o,_=n<m?n:m;let D=-1,a=0;for(;a<_;a++){const M=u.charCodeAt(i+a);if(M!==d.charCodeAt(o+a))break;M===C&&(D=a)}if(a!==_){if(D===-1)return t}else{if(m>_){if(d.charCodeAt(o+a)===C)return t.slice(o+a+1);if(a===2)return t.slice(o+a)}n>_&&(u.charCodeAt(i+a)===C?D=a:a===2&&(D=3)),D===-1&&(D=0)}let R="";for(a=i+D+1;a<=s;++a)(a===s||u.charCodeAt(a)===C)&&(R+=R.length===0?"..":"\\..");return o+=D,R.length>0?`${R}${t.slice(o,v)}`:(t.charCodeAt(o)===C&&++o,t.slice(o,v))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=e.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===C){if(d.charCodeAt(1)===C){const g=d.charCodeAt(2);if(g!==I&&g!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(E(d.charCodeAt(0))&&d.charCodeAt(1)===r&&d.charCodeAt(2)===C)return`\\\\?\\${d}`;return u},dirname(u){h(u,"path");const d=u.length;if(d===0)return".";let g=-1,t=0;const i=u.charCodeAt(0);if(d===1)return c(i)?u:".";if(c(i)){if(g=t=1,c(u.charCodeAt(1))){let o=2,v=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==v){for(v=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==v){for(v=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return u;o!==v&&(g=t=o+1)}}}}else E(i)&&u.charCodeAt(1)===r&&(g=d>2&&c(u.charCodeAt(2))?3:2,t=g);let s=-1,n=!0;for(let o=d-1;o>=t;--o)if(c(u.charCodeAt(o))){if(!n){s=o;break}}else n=!1;if(s===-1){if(g===-1)return".";s=g}return u.slice(0,s)},basename(u,d){d!==void 0&&h(d,"ext"),h(u,"path");let g=0,t=-1,i=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===r&&(g=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,o=-1;for(s=u.length-1;s>=g;--s){const v=u.charCodeAt(s);if(c(v)){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===d.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=g;--s)if(c(u.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){h(u,"path");let d=0,g=-1,t=0,i=-1,s=!0,n=0;u.length>=2&&u.charCodeAt(1)===r&&E(u.charCodeAt(0))&&(d=t=2);for(let o=u.length-1;o>=d;--o){const v=u.charCodeAt(o);if(c(v)){if(!s){t=o+1;break}continue}i===-1&&(s=!1,i=o+1),v===P?g===-1?g=o:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||i===-1||n===0||n===1&&g===i-1&&g===t+1?"":u.slice(g,i)},format:b.bind(null,"\\"),parse(u){h(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const g=u.length;let t=0,i=u.charCodeAt(0);if(g===1)return c(i)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(c(i)){if(t=1,c(u.charCodeAt(1))){let D=2,a=D;for(;D<g&&!c(u.charCodeAt(D));)D++;if(D<g&&D!==a){for(a=D;D<g&&c(u.charCodeAt(D));)D++;if(D<g&&D!==a){for(a=D;D<g&&!c(u.charCodeAt(D));)D++;D===g?t=D:D!==a&&(t=D+1)}}}}else if(E(i)&&u.charCodeAt(1)===r){if(g<=2)return d.root=d.dir=u,d;if(t=2,c(u.charCodeAt(2))){if(g===3)return d.root=d.dir=u,d;t=3}}t>0&&(d.root=u.slice(0,t));let s=-1,n=t,o=-1,v=!0,m=u.length-1,_=0;for(;m>=t;--m){if(i=u.charCodeAt(m),c(i)){if(!v){n=m+1;break}continue}o===-1&&(v=!1,o=m+1),i===P?s===-1?s=m:_!==1&&(_=1):s!==-1&&(_=-1)}return o!==-1&&(s===-1||_===0||_===1&&s===o-1&&s===n+1?d.base=d.name=u.slice(n,o):(d.name=u.slice(n,s),d.base=u.slice(n,o),d.ext=u.slice(s,o))),n>0&&n!==t?d.dir=u.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let d="",g=!1;for(let t=u.length-1;t>=-1&&!g;t--){const i=t>=0?u[t]:p.cwd();h(i,"path"),i.length!==0&&(d=`${i}/${d}`,g=i.charCodeAt(0)===S)}return d=w(d,!g,"/",f),g?`/${d}`:d.length>0?d:"."},normalize(u){if(h(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===S,g=u.charCodeAt(u.length-1)===S;return u=w(u,!d,"/",f),u.length===0?d?"/":g?"./":".":(g&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return h(u,"path"),u.length>0&&u.charCodeAt(0)===S},join(...u){if(u.length===0)return".";let d;for(let g=0;g<u.length;++g){const t=u[g];h(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(u,d){if(h(u,"from"),h(d,"to"),u===d||(u=e.posix.resolve(u),d=e.posix.resolve(d),u===d))return"";const g=1,t=u.length,i=t-g,s=1,n=d.length-s,o=i<n?i:n;let v=-1,m=0;for(;m<o;m++){const D=u.charCodeAt(g+m);if(D!==d.charCodeAt(s+m))break;D===S&&(v=m)}if(m===o)if(n>o){if(d.charCodeAt(s+m)===S)return d.slice(s+m+1);if(m===0)return d.slice(s+m)}else i>o&&(u.charCodeAt(g+m)===S?v=m:m===0&&(v=0));let _="";for(m=g+v+1;m<=t;++m)(m===t||u.charCodeAt(m)===S)&&(_+=_.length===0?"..":"/..");return`${_}${d.slice(s+v)}`},toNamespacedPath(u){return u},dirname(u){if(h(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===S;let g=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===S){if(!t){g=i;break}}else t=!1;return g===-1?d?"/":".":d&&g===1?"//":u.slice(0,g)},basename(u,d){d!==void 0&&h(d,"ext"),h(u,"path");let g=0,t=-1,i=!0,s;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,o=-1;for(s=u.length-1;s>=0;--s){const v=u.charCodeAt(s);if(v===S){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===d.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===S){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){h(u,"path");let d=-1,g=0,t=-1,i=!0,s=0;for(let n=u.length-1;n>=0;--n){const o=u.charCodeAt(n);if(o===S){if(!i){g=n+1;break}continue}t===-1&&(i=!1,t=n+1),o===P?d===-1?d=n:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||t===-1||s===0||s===1&&d===t-1&&d===g+1?"":u.slice(d,t)},format:b.bind(null,"/"),parse(u){h(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const g=u.charCodeAt(0)===S;let t;g?(d.root="/",t=1):t=0;let i=-1,s=0,n=-1,o=!0,v=u.length-1,m=0;for(;v>=t;--v){const _=u.charCodeAt(v);if(_===S){if(!o){s=v+1;break}continue}n===-1&&(o=!1,n=v+1),_===P?i===-1?i=v:m!==1&&(m=1):i!==-1&&(m=-1)}if(n!==-1){const _=s===0&&g?1:s;i===-1||m===0||m===1&&i===n-1&&i===s+1?d.base=d.name=u.slice(_,n):(d.name=u.slice(_,i),d.base=u.slice(_,n),d.ext=u.slice(i,n))}return s>0?d.dir=u.slice(0,s-1):g&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[135],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...A){const P=A.reduce((r,I)=>(r[I]=!0,r),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(r=>!P[r]).forEach(r=>{for(let I=0;I<S.length;I++)if(r.search(S[I])!==-1){delete y[r];break}})}e.sanitizeProcessEnvironment=k}),define(ge[43],pe([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class k{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ge[3],pe([0,1,14,68,6,71,43]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>k.Disposable.None;function b(q){return(U,z=null,O)=>{let W=!1,T;return T=q(F=>{if(!W)return T?T.dispose():W=!0,U.call(z,F)},null,O),W&&T.dispose(),T}}w.once=b;function u(q,U){return n((z,O=null,W)=>q(T=>z.call(O,U(T)),null,W))}w.map=u;function d(q,U){return n((z,O=null,W)=>q(T=>{U(T),z.call(O,T)},null,W))}w.forEach=d;function g(q,U){return n((z,O=null,W)=>q(T=>U(T)&&z.call(O,T),null,W))}w.filter=g;function t(q){return q}w.signal=t;function i(...q){return(U,z=null,O)=>k.combinedDisposable(...q.map(W=>W(T=>U.call(z,T),null,O)))}w.any=i;function s(q,U,z){let O=z;return u(q,W=>(O=U(O,W),O))}w.reduce=s;function n(q){let U;const z=new l({onFirstListenerAdd(){U=q(z.fire,z)},onLastListenerRemove(){U.dispose()}});return z.event}w.snapshot=n;function o(q,U,z=100,O=!1,W){let T,F,N,x=0;const G=new l({leakWarningThreshold:W,onFirstListenerAdd(){T=q(se=>{x++,F=U(F,se),O&&!N&&(G.fire(F),F=void 0),clearTimeout(N),N=setTimeout(()=>{const be=F;F=void 0,N=void 0,(!O||x>1)&&G.fire(be),x=0},z)})},onLastListenerRemove(){T.dispose()}});return G.event}w.debounce=o;function v(q){const U=new Date().getTime();return u(b(q),z=>new Date().getTime()-U)}w.stopwatch=v;function m(q,U=(z,O)=>z===O){let z=!0,O;return g(q,W=>{const T=z||!U(W,O);return z=!1,O=W,T})}w.latch=m;function _(q,U){return[w.filter(q,U),w.filter(q,z=>!U(z))]}w.split=_;function D(q,U=!1,z=[]){let O=z.slice(),W=q(N=>{O?O.push(N):F.fire(N)});const T=()=>{O&&O.forEach(N=>F.fire(N)),O=null},F=new l({onFirstListenerAdd(){W||(W=q(N=>F.fire(N)))},onFirstListenerDidAdd(){O&&(U?setTimeout(T):T())},onLastListenerRemove(){W&&W.dispose(),W=null}});return F.event}w.buffer=D;class a{constructor(U){this.event=U}map(U){return new a(u(this.event,U))}forEach(U){return new a(d(this.event,U))}filter(U){return new a(g(this.event,U))}reduce(U,z){return new a(s(this.event,U,z))}latch(){return new a(m(this.event))}debounce(U,z=100,O=!1,W){return new a(o(this.event,U,z,O,W))}on(U,z,O){return this.event(U,z,O)}once(U,z,O){return b(this.event)(U,z,O)}}function R(q){return new a(q)}w.chain=R;function M(q,U,z=O=>O){const O=(...N)=>F.fire(z(...N)),W=()=>q.on(U,O),T=()=>q.removeListener(U,O),F=new l({onFirstListenerAdd:W,onLastListenerRemove:T});return F.event}w.fromNodeEventEmitter=M;function $(q,U,z=O=>O){const O=(...N)=>F.fire(z(...N)),W=()=>q.addEventListener(U,O),T=()=>q.removeEventListener(U,O),F=new l({onFirstListenerAdd:W,onLastListenerRemove:T});return F.event}w.fromDOMEventEmitter=$;function Y(q){const U=new l;let z=!1;return q.then(void 0,()=>null).then(()=>{z?U.fire(void 0):setTimeout(()=>U.fire(void 0),0)}),z=!0,U.event}w.fromPromise=Y;function le(q){return new Promise(U=>b(q)(U))}w.toPromise=le})(P=e.Event||(e.Event={}));class S{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${S._idPool++}`}start(b){this._stopWatch=new A.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let C=-1;function r(w){const b=C;return C=w,{dispose(){C=b}}}e.setGlobalLeakWarningThreshold=r;class I{constructor(b,u=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let u=C;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||b<u)return;this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),g=this._stacks.get(d)||0;if(this._stacks.set(d,g+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[s,n]of this._stacks)(!t||i<n)&&(t=s,i=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}class l{constructor(b){var u;this._disposed=!1,this._options=b,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(b,u,d)=>{var g;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[b,u]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,u);const s=(g=this._leakageMon)===null||g===void 0?void 0:g.check(this._listeners.size);let n;return n={dispose:()=>{s&&s(),n.dispose=l._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof k.DisposableStore?d.add(n):Array.isArray(d)&&d.push(n),n}),this._event}fire(b){var u,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,b]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,t]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,t):g[0].call(g[1],t)}catch(i){p.onUnexpectedError(i)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var b,u,d,g,t;this._disposed||(this._disposed=!0,(b=this._listeners)===null||b===void 0||b.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(g=(d=this._options)===null||d===void 0?void 0:d.onLastListenerRemove)===null||g===void 0||g.call(d),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=l,l._noop=function(){};class h extends l{constructor(b){super(b);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=h;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const u={event:b,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const d=()=>{this.hasListeners&&this.unhook(u);const g=this.events.indexOf(u);this.events.splice(g,1)};return k.toDisposable(L.once(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(u=>this.emitter.fire(u))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class f{constructor(){this.buffers=[]}wrapEvent(b){return(u,d,g)=>b(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(d,t)):u.call(d,t)},void 0,g)}bufferEvents(b){const u=[];this.buffers.push(u);const d=b();return this.buffers.pop(),u.forEach(g=>g()),d}}e.EventBufferer=f;class E{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=k.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,S){const C=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(C)}}});var k;(function(P){function S(C){return C===P.None||C===P.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ge[91],pe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function y(r,I){return new P(r,I)}e.registerCodicon=y;function A(r){return r?r.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(I,l,h){this.id=I,this.definition=l,this.description=h,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function S(r,I){const l=["codicon","codicon-"+r];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=S;var C;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function l(f){if(f instanceof P)return["codicon","codicon-"+f.id];const E=I.exec(f.id);if(!E)return l(P.error);let[,w,b]=E;const u=["codicon","codicon-"+w];return b&&u.push("codicon-modifier-"+b.substr(1)),u}r.asClassNameArray=l;function h(f){return l(f).join(" ")}r.asClassName=h;function c(f){return"."+l(f).join(".")}r.asCSSSelector=c})(C=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(ge[92],pe([0,1,14,6]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(u){const d=u;return d?[d.on,d.pause,d.resume,d.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=k;function y(u){const d=u;return d?k(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(u,d){return new P(u,d)}e.newWriteableStream=A;class P{constructor(d,g){this.reducer=d,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(g=>g(d))}emitError(d){this.listeners.error.length===0?p.onUnexpectedError(d):this.listeners.error.slice(0).forEach(g=>g(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,g){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(d,g){if(this.state.destroyed)return;let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(u,d){const g=[];let t;for(;(t=u.read())!==null;)g.push(t);return d(g)}e.consumeReadable=S;function C(u,d,g){const t=[];let i;for(;(i=u.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return u.read()}}}e.peekReadable=C;function r(u,d){return new Promise((g,t)=>{const i=[];I(u,{onData:s=>{d&&i.push(s)},onError:s=>{d?t(s):g(void 0)},onEnd:()=>{g(d?d(i):void 0)}})})}e.consumeStream=r;function I(u,d){u.on("error",g=>d.onError(g)),u.on("end",()=>d.onEnd()),u.on("data",g=>d.onData(g))}e.listenStream=I;function l(u,d){return new Promise((g,t)=>{const i=new L.DisposableStore,s=[],n=m=>{if(s.push(m),s.length>d)return i.dispose(),u.pause(),g({stream:u,buffer:s,ended:!1})},o=m=>t(m),v=()=>g({stream:u,buffer:s,ended:!0});i.add(L.toDisposable(()=>u.removeListener("error",o))),u.on("error",o),i.add(L.toDisposable(()=>u.removeListener("end",v))),u.on("end",v),i.add(L.toDisposable(()=>u.removeListener("data",n))),u.on("data",n)})}e.peekStream=l;function h(u,d){const g=A(d);return g.end(u),g}e.toStream=h;function c(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function f(u){let d=!1;return{read:()=>d?null:(d=!0,u)}}e.toReadable=f;function E(u,d,g){const t=A(g);return I(u,{onData:i=>t.write(d.data(i)),onError:i=>t.error(d.error?d.error(i):i),onEnd:()=>t.end()}),t}e.transform=E;function w(u,d,g){let t=!1;return{read:()=>{const i=d.read();return t?i:(t=!0,i!==null?g([u,i]):u)}}}e.prefixedReadable=w;function b(u,d,g){let t=!1;const i=A(g);return I(d,{onData:s=>t?i.write(s):(t=!0,i.write(g([u,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=b}),define(ge[8],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function k(H,...ee){return ee.length===0?H:H.replace(L,function(ue,Ae){const Re=parseInt(Ae,10);return isNaN(Re)||Re<0||Re>=ee.length?ue:ee[Re]})}e.format=k;function y(H){return H.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=y;function A(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function P(H,ee){let ue=0;const Ae=ee.charCodeAt(0);for(let Re=H.length-1;Re>=0;Re--)H.charCodeAt(Re)===Ae&&ue++;return ue}e.count=P;function S(H,ee,ue="\u2026"){return H.length<=ee?H:`${H.substr(0,ee)}${ue}`}e.truncate=S;function C(H,ee=" "){const ue=r(H,ee);return I(ue,ee)}e.trim=C;function r(H,ee){if(!H||!ee)return H;const ue=ee.length;if(ue===0||H.length===0)return H;let Ae=0;for(;H.indexOf(ee,Ae)===Ae;)Ae=Ae+ue;return H.substring(Ae)}e.ltrim=r;function I(H,ee){if(!H||!ee)return H;const ue=ee.length,Ae=H.length;if(ue===0||Ae===0)return H;let Re=Ae,Ue=-1;for(;Ue=H.lastIndexOf(ee,Re-1),!(Ue===-1||Ue+ue!==Re);){if(Ue===0)return"";Re=Ue}return H.substring(0,Re)}e.rtrim=I;function l(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function h(H){return H.replace(/\*/g,"")}e.stripWildcards=h;function c(H,ee,ue={}){if(!H)throw new Error("Cannot create regex from empty string");ee||(H=A(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Ae="";return ue.global&&(Ae+="g"),ue.matchCase||(Ae+="i"),ue.multiline&&(Ae+="m"),ue.unicode&&(Ae+="u"),new RegExp(H,Ae)}e.createRegExp=c;function f(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function E(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function b(H){return H.split(/\r\n|\r|\n/)}e.splitLines=b;function u(H){for(let ee=0,ue=H.length;ee<ue;ee++){const Ae=H.charCodeAt(ee);if(Ae!==32&&Ae!==9)return ee}return-1}e.firstNonWhitespaceIndex=u;function d(H,ee=0,ue=H.length){for(let Ae=ee;Ae<ue;Ae++){const Re=H.charCodeAt(Ae);if(Re!==32&&Re!==9)return H.substring(ee,Ae)}return H.substring(ee,ue)}e.getLeadingWhitespace=d;function g(H,ee=H.length-1){for(let ue=ee;ue>=0;ue--){const Ae=H.charCodeAt(ue);if(Ae!==32&&Ae!==9)return ue}return-1}e.lastNonWhitespaceIndex=g;function t(H,ee){return H<ee?-1:H>ee?1:0}e.compare=t;function i(H,ee,ue=0,Ae=H.length,Re=0,Ue=ee.length){for(;ue<Ae&&Re<Ue;ue++,Re++){let Je=H.charCodeAt(ue),Xe=ee.charCodeAt(Re);if(Je<Xe)return-1;if(Je>Xe)return 1}const ze=Ae-ue,Ze=Ue-Re;return ze<Ze?-1:ze>Ze?1:0}e.compareSubstring=i;function s(H,ee){return n(H,ee,0,H.length,0,ee.length)}e.compareIgnoreCase=s;function n(H,ee,ue=0,Ae=H.length,Re=0,Ue=ee.length){for(;ue<Ae&&Re<Ue;ue++,Re++){let Je=H.charCodeAt(ue),Xe=ee.charCodeAt(Re);if(Je===Xe)continue;const nt=Je-Xe;if(!(nt===32&&v(Xe))&&!(nt===-32&&v(Je)))return o(Je)&&o(Xe)?nt:i(H.toLowerCase(),ee.toLowerCase(),ue,Ae,Re,Ue)}const ze=Ae-ue,Ze=Ue-Re;return ze<Ze?-1:ze>Ze?1:0}e.compareSubstringIgnoreCase=n;function o(H){return H>=97&&H<=122}e.isLowerAsciiLetter=o;function v(H){return H>=65&&H<=90}e.isUpperAsciiLetter=v;function m(H){return o(H)||v(H)}function _(H,ee){return H.length===ee.length&&D(H,ee)}e.equalsIgnoreCase=_;function D(H,ee,ue=H.length){for(let Ae=0;Ae<ue;Ae++){const Re=H.charCodeAt(Ae),Ue=ee.charCodeAt(Ae);if(Re!==Ue){if(m(Re)&&m(Ue)){const ze=Math.abs(Re-Ue);if(ze!==0&&ze!==32)return!1}else if(String.fromCharCode(Re).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function a(H,ee){const ue=ee.length;return ee.length>H.length?!1:D(H,ee,ue)}e.startsWithIgnoreCase=a;function R(H,ee){let ue,Ae=Math.min(H.length,ee.length);for(ue=0;ue<Ae;ue++)if(H.charCodeAt(ue)!==ee.charCodeAt(ue))return ue;return Ae}e.commonPrefixLength=R;function M(H,ee){let ue,Ae=Math.min(H.length,ee.length);const Re=H.length-1,Ue=ee.length-1;for(ue=0;ue<Ae;ue++)if(H.charCodeAt(Re-ue)!==ee.charCodeAt(Ue-ue))return ue;return Ae}e.commonSuffixLength=M;function $(H){return 55296<=H&&H<=56319}e.isHighSurrogate=$;function Y(H){return 56320<=H&&H<=57343}e.isLowSurrogate=Y;function le(H,ee){return(H-55296<<10)+(ee-56320)+65536}e.computeCodePoint=le;function q(H,ee,ue){const Ae=H.charCodeAt(ue);if($(Ae)&&ue+1<ee){const Re=H.charCodeAt(ue+1);if(Y(Re))return le(Ae,Re)}return Ae}e.getNextCodePoint=q;function U(H,ee){const ue=H.charCodeAt(ee-1);if(Y(ue)&&ee>1){const Ae=H.charCodeAt(ee-2);if($(Ae))return le(Ae,ue)}return ue}function z(H,ee){const ue=Ne.getInstance(),Ae=ee,Re=H.length,Ue=q(H,Re,ee);ee+=Ue>=65536?2:1;let ze=ue.getGraphemeBreakType(Ue);for(;ee<Re;){const Ze=q(H,Re,ee),Je=ue.getGraphemeBreakType(Ze);if(ve(ze,Je))break;ee+=Ze>=65536?2:1,ze=Je}return ee-Ae}e.nextCharLength=z;function O(H,ee){const ue=Ne.getInstance(),Ae=ee,Re=U(H,ee);ee-=Re>=65536?2:1;let Ue=ue.getGraphemeBreakType(Re);for(;ee>0;){const ze=U(H,ee),Ze=ue.getGraphemeBreakType(ze);if(ve(Ze,Ue))break;ee-=ze>=65536?2:1,Ue=Ze}return Ae-ee}e.prevCharLength=O;function W(H,ee){const ue=Ne.getInstance(),Ae=H.length,Re=ee,Ue=q(H,Ae,ee),ze=ue.getGraphemeBreakType(Ue);ee+=Ue>=65536?2:1;let Ze=ze;for(;ee<Ae;){const Xe=q(H,Ae,ee),nt=ue.getGraphemeBreakType(Xe);if(ve(Ze,nt))break;ee+=Xe>=65536?2:1,Ze=nt}const Je=ee;for(ee=Re,Ze=ze;ee>0;){const Xe=U(H,ee),nt=ue.getGraphemeBreakType(Xe);if(ve(nt,Ze))break;ee-=Xe>=65536?2:1,Ze=nt}return[ee,Je]}function T(H,ee){return ee>0&&Y(H.charCodeAt(ee))?W(H,ee-1):W(H,ee)}e.getCharContainingOffset=T;function F(H){const ee=H.length;let ue=0,Ae=0;for(;Ae<ee;){const ze=q(H,ee,Ae);Ae+=ze>=65536?2:1,ze<128?ue+=1:ze<2048?ue+=2:ze<65536?ue+=3:ue+=4}const Re=new Uint8Array(ue);Ae=0;let Ue=0;for(;Ae<ee;){const ze=q(H,ee,Ae);Ae+=ze>=65536?2:1,ze<128?Re[Ue++]=ze:ze<2048?(Re[Ue++]=192|(ze&1984)>>>6,Re[Ue++]=128|(ze&63)>>>0):ze<65536?(Re[Ue++]=224|(ze&61440)>>>12,Re[Ue++]=128|(ze&4032)>>>6,Re[Ue++]=128|(ze&63)>>>0):(Re[Ue++]=240|(ze&1835008)>>>18,Re[Ue++]=128|(ze&258048)>>>12,Re[Ue++]=128|(ze&4032)>>>6,Re[Ue++]=128|(ze&63)>>>0)}return Re}e.encodeUTF8=F;function N(H){const ee=H.byteLength,ue=[];let Ae=0;for(;Ae<ee;){const Re=H[Ae];let Ue;if(Re>=240&&Ae+3<ee?Ue=(H[Ae++]&7)<<18>>>0|(H[Ae++]&63)<<12>>>0|(H[Ae++]&63)<<6>>>0|(H[Ae++]&63)<<0>>>0:Re>=224&&Ae+2<ee?Ue=(H[Ae++]&15)<<12>>>0|(H[Ae++]&63)<<6>>>0|(H[Ae++]&63)<<0>>>0:Re>=192&&Ae+1<ee?Ue=(H[Ae++]&31)<<6>>>0|(H[Ae++]&63)<<0>>>0:Ue=H[Ae++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)ue.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const ze=Ue-65536,Ze=55296+((ze&1047552)>>>10),Je=56320+((ze&1023)>>>0);ue.push(String.fromCharCode(Ze)),ue.push(String.fromCharCode(Je))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=N;const x=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(H){return x.test(H)}e.containsRTL=G;const se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(H){return se.test(H)}e.containsEmoji=be;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Ce(H){return Ie.test(H)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Me(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Me;function qe(H){for(let ee=0,ue=H.length;ee<ue;ee++)if(He(H.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=qe;function He(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=He;function Ve(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=Ve;function j(H,ee){if(H.length<ee)return H;const ue=/\b/g;let Ae=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<ee);)Ae=ue.lastIndex,ue.lastIndex+=1;return H.substring(Ae).replace(/^\s/,"")}e.lcut=j;const Z=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function J(H){return H&&(H=H.replace(Z,""),H=H.replace(ne,""),H=H.replace(oe,"")),H}e.removeAnsiEscapeCodes=J,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function me(H){return ce(H)?H.substr(1):H}e.stripUTF8BOM=me;function Le(H,ee){if(!H||!ee||H.length<ee.length)return!1;const ue=ee.length,Ae=H.toLowerCase();let Re=0,Ue=-1;for(;Re<ue;){const ze=Ae.indexOf(ee[Re],Ue+1);if(ze<0)return!1;Ue=ze,Re++}return!0}e.fuzzyContains=Le;function We(H,ee=!1){return H?(ee&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=We;function Ee(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ee;function Ke(H,ee=1){if(ee===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),ee--;while(ee>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=Ke;function K(H){const ee=90-65+1;return H=H%(2*ee),H<ee?String.fromCharCode(97+H):String.fromCharCode(65+H-ee)}e.singleLetterHash=K;function ie(H){return Ne.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=ie;function ve(H,ee){return H===0?ee!==5&&ee!==7:H===2&&ee===3?!1:H===4||H===2||H===3||ee===4||ee===2||ee===3?!0:!(H===8&&(ee===8||ee===9||ee===11||ee===12)||(H===11||H===9)&&(ee===9||ee===10)||(H===12||H===10)&&ee===10||ee===5||ee===13||ee===7||H===1||H===13&&ee===14||H===6&&ee===6)}e.breakBetweenGraphemeBreakType=ve;var Fe;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Qe()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ue=this._data,Ae=ue.length/3;let Re=1;for(;Re<=Ae;)if(ee<ue[3*Re])Re=2*Re;else if(ee>ue[3*Re+1])Re=2*Re+1;else return ue[3*Re+2];return 0}}Ne._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,ee){if(H===0)return 0;const ue=Se(H,ee);if(ue!==void 0)return ue;const Ae=U(ee,H);return H-=Pe(Ae),H}e.getLeftDeleteOffset=De;function Se(H,ee){let ue=U(ee,H);for(H-=Pe(ue);ae(ue)||ue===65039||ue===8419;){if(H===0)return;ue=U(ee,H),H-=Pe(ue)}if(!!Ve(ue)){if(H>=0){const Ae=U(ee,H);Ae===8205&&(H-=Pe(Ae))}return H}}function Pe(H){return H>=65536?2:1}function ae(H){return 127995<=H&&H<=127999}var fe;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(fe||(fe={}))}),define(ge[22],pe([0,1,8,92]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,S;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return k?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&k?new C(Buffer.from(m)):y?(P||(P=new TextEncoder),new C(P.encode(m))):new C(p.encodeUTF8(m))}static concat(m,_){if(typeof _=="undefined"){_=0;for(let R=0,M=m.length;R<M;R++)_+=m[R].byteLength}const D=C.alloc(_);let a=0;for(let R=0,M=m.length;R<M;R++){const $=m[R];D.set($,a),a+=$.byteLength}return D}toString(){return k?this.buffer.toString():A?(S||(S=new TextDecoder),S.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(m,_){return new C(this.buffer.subarray(m,_))}set(m,_){m instanceof C?this.buffer.set(m.buffer,_):this.buffer.set(m,_)}readUInt32BE(m){return l(this.buffer,m)}writeUInt32BE(m,_){h(this.buffer,m,_)}readUInt32LE(m){return c(this.buffer,m)}writeUInt32LE(m,_){f(this.buffer,m,_)}readUInt8(m){return E(this.buffer,m)}writeUInt8(m,_){w(this.buffer,m,_)}}e.VSBuffer=C;function r(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0}e.readUInt16LE=r;function I(v,m,_){v[_+0]=m&255,m=m>>>8,v[_+1]=m&255}e.writeUInt16LE=I;function l(v,m){return v[m]*2**24+v[m+1]*2**16+v[m+2]*2**8+v[m+3]}e.readUInt32BE=l;function h(v,m,_){v[_+3]=m,m=m>>>8,v[_+2]=m,m=m>>>8,v[_+1]=m,m=m>>>8,v[_]=m}e.writeUInt32BE=h;function c(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0|v[m+2]<<16>>>0|v[m+3]<<24>>>0}e.readUInt32LE=c;function f(v,m,_){v[_+0]=m&255,m=m>>>8,v[_+1]=m&255,m=m>>>8,v[_+2]=m&255,m=m>>>8,v[_+3]=m&255}e.writeUInt32LE=f;function E(v,m){return v[m]}e.readUInt8=E;function w(v,m,_){v[_]=m}e.writeUInt8=w;function b(v){return L.consumeReadable(v,m=>C.concat(m))}e.readableToBuffer=b;function u(v){return L.toReadable(v)}e.bufferToReadable=u;function d(v){return L.consumeStream(v,m=>C.concat(m))}e.streamToBuffer=d;async function g(v){return v.ended?C.concat(v.buffer):C.concat([...v.buffer,await d(v.stream)])}e.bufferedStreamToBuffer=g;function t(v){return L.toStream(v,m=>C.concat(m))}e.bufferToStream=t;function i(v){return L.transform(v,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=i;function s(v){return L.newWriteableStream(m=>C.concat(m),v)}e.newWriteableBufferStream=s;function n(v,m){return L.prefixedReadable(v,m,_=>C.concat(_))}e.prefixedBufferReadable=n;function o(v,m){return L.prefixedStream(v,m,_=>C.concat(_))}e.prefixedBufferStream=o}),define(ge[73],pe([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(w){return k(w,0)}e.hash=L;function k(w,b){switch(typeof w){case"object":return w===null?y(349,b):Array.isArray(w)?S(w,b):C(w,b);case"string":return P(w,b);case"boolean":return A(w,b);case"number":return y(w,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=k;function y(w,b){return(b<<5)-b+w|0}function A(w,b){return y(w?433:863,b)}function P(w,b){b=y(149417,b);for(let u=0,d=w.length;u<d;u++)b=y(w.charCodeAt(u),b);return b}e.stringHash=P;function S(w,b){return b=y(104579,b),w.reduce((u,d)=>k(d,u),b)}function C(w,b){return b=y(181387,b),Object.keys(w).sort().reduce((u,d)=>(u=P(d,u),k(w[d],u)),b)}class r{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=k(b,this._value),this._value}}e.Hasher=r;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,b,u=32){const d=u-b,g=~((1<<d)-1);return(w<<b|(g&w)>>>d)>>>0}function h(w,b=0,u=w.byteLength,d=0){for(let g=0;g<u;g++)w[b+g]=d}function c(w,b,u="0"){for(;w.length<b;)w=u+w;return w}function f(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),b/4)}e.toHexString=f;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const u=b.length;if(u===0)return;const d=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=b.charCodeAt(0),s=0);;){let n=i;if(p.isHighSurrogate(i))if(s+1<u){const o=b.charCodeAt(s+1);p.isLowSurrogate(o)?(s++,n=p.computeCodePoint(i,o)):n=65533}else{t=i;break}else p.isLowSurrogate(i)&&(n=65533);if(g=this._push(d,g,n),s++,s<u)i=b.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(b,u,d){return d<128?b[u++]=d:d<2048?(b[u++]=192|(d&1984)>>>6,b[u++]=128|(d&63)>>>0):d<65536?(b[u++]=224|(d&61440)>>>12,b[u++]=128|(d&4032)>>>6,b[u++]=128|(d&63)>>>0):(b[u++]=240|(d&1835008)>>>18,b[u++]=128|(d&258048)>>>12,b[u++]=128|(d&4032)>>>6,b[u++]=128|(d&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=E._bigBlock32,u=this._buffDV;for(let m=0;m<64;m+=4)b.setUint32(m,u.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)b.setUint32(m,l(b.getUint32(m-12,!1)^b.getUint32(m-32,!1)^b.getUint32(m-56,!1)^b.getUint32(m-64,!1),1),!1);let d=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,n,o,v;for(let m=0;m<80;m++)m<20?(n=g&t|~g&i,o=1518500249):m<40?(n=g^t^i,o=1859775393):m<60?(n=g&t|g&i|t&i,o=2400959708):(n=g^t^i,o=3395469782),v=l(d,5)+n+s+o+b.getUint32(m*4,!1)&4294967295,s=i,i=t,t=l(g,30),g=d,d=v;this._h0=this._h0+d&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[53],pe([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const y="error",A="warning",P="warn",S="info",C="ignore";function r(l){return l?p.equalsIgnoreCase(y,l)?k.Error:p.equalsIgnoreCase(A,l)||p.equalsIgnoreCase(P,l)?k.Warning:p.equalsIgnoreCase(S,l)?k.Info:k.Ignore:k.Ignore}k.fromValue=r;function I(l){switch(l){case k.Error:return y;case k.Warning:return A;case k.Info:return S;default:return C}}k.toString=I}(L||(L={})),e.default=L}),define(ge[15],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function L(m){return typeof m=="string"}e.isString=L;function k(m){return Array.isArray(m)&&m.every(_=>L(_))}e.isStringArray=k;function y(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=y;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function P(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=P;function S(m){return m===!0||m===!1}e.isBoolean=S;function C(m){return typeof m=="undefined"}e.isUndefined=C;function r(m){return!I(m)}e.isDefined=r;function I(m){return C(m)||m===null}e.isUndefinedOrNull=I;function l(m,_){if(!m)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=l;function h(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=h;function c(...m){const _=[];for(let D=0;D<m.length;D++){const a=m[D];if(I(a))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);_.push(a)}return _}e.assertAllDefined=c;const f=Object.prototype.hasOwnProperty;function E(m){if(!y(m))return!1;for(let _ in m)if(f.call(m,_))return!1;return!0}e.isEmptyObject=E;function w(m){return typeof m=="function"}e.isFunction=w;function b(...m){return m.length>0&&m.every(w)}e.areFunctions=b;function u(m,_){const D=Math.min(m.length,_.length);for(let a=0;a<D;a++)d(m[a],_[a])}e.validateConstraints=u;function d(m,_){if(L(_)){if(typeof m!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(m instanceof _)return}catch(D){}if(!I(m)&&m.constructor===_||_.length===1&&_.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function g(m){let _=[],D=Object.getPrototypeOf(m);for(;Object.prototype!==D;)_=_.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return _}e.getAllPropertyNames=g;function t(m){const _=[];for(const D of g(m))typeof m[D]=="function"&&_.push(D);return _}e.getAllMethodNames=t;function i(m,_){const D=R=>function(){const M=Array.prototype.slice.call(arguments,0);return _(R,M)};let a={};for(const R of m)a[R]=D(R);return a}e.createProxyObject=i;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function o(m){return class{constructor(){return new Proxy({},{get(_,D){if(_[D])return _[D];throw new Error(`Not Implemented: ${m}->${String(D)}`)}})}}}e.NotImplementedProxy=o;function v(m){throw new Error("Unreachable")}e.assertNever=v}),define(ge[29],pe([0,1,11,8,9,15]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function P(s){return s.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function S(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function C(s,n=k.posix.sep){if(!s)return"";const o=s.length,v=s.charCodeAt(0);if(A(v)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let _=3;const D=_;for(;_<o&&!A(s.charCodeAt(_));_++);if(D!==_&&!A(s.charCodeAt(_+1))){for(_+=1;_<o;_++)if(A(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,n)}}return n}else if(w(v)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(A(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=C;function r(s){if(!p.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let o=2;const v=o;for(;o<s.length&&(n=s.charCodeAt(o),n!==92);o++);return!(v===o||(n=s.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=r;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,n=p.isWindows){const o=n?I:l;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||n&&h.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function f(s,n,o){const v=s===n;return!o||v?v:!s||!n?!1:L.equalsIgnoreCase(s,n)}e.isEqual=f;function E(s,n,o,v=k.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(o){if(!L.startsWithIgnoreCase(s,n))return!1;if(n.length===s.length)return!0;let _=n.length;return n.charAt(n.length-1)===v&&_--,s.charAt(_)===v}return n.charAt(n.length-1)!==v&&(n+=v),s.indexOf(n)===0}e.isEqualOrParent=E;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function b(s,n){return p.isWindows&&s.endsWith(":")&&(s+=k.sep),k.isAbsolute(s)||(s=k.join(n,s)),s=k.normalize(s),p.isWindows?(s=L.rtrim(s,k.sep),s.endsWith(":")&&(s+=k.sep)):(s=L.rtrim(s,k.sep),s||(s=k.sep)),s}e.sanitizeFilePath=b;function u(s){const n=k.normalize(s);return p.isWindows?s.length>3?!1:d(n)&&(s.length===2||n.charCodeAt(2)===92):n===k.posix.sep}e.isRootOrDriveLetter=u;function d(s){return p.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function g(s){return d(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,n,o){return n.length>s.length?-1:s===n?0:(o&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function i(s){const n=s.split(":");let o,v,m;if(n.forEach(_=>{const D=Number(_);y.isNumber(D)?v===void 0?v=D:m===void 0&&(m=D):o=o?[o,_].join(":"):_}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(ge[25],pe([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const E=Array.isArray(f)?[]:{};return Object.keys(f).forEach(w=>{f[w]&&typeof f[w]=="object"?E[w]=L(f[w]):E[w]=f[w]}),E}e.deepClone=L;function k(f){if(!f||typeof f!="object")return f;const E=[f];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const b in w)if(y.call(w,b)){const u=w[b];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return f}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function A(f,E){return P(f,E,new Set)}e.cloneAndChange=A;function P(f,E,w){if(p.isUndefinedOrNull(f))return f;const b=E(f);if(typeof b!="undefined")return b;if(p.isArray(f)){const u=[];for(const d of f)u.push(P(d,E,w));return u}if(p.isObject(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const u={};for(let d in f)y.call(f,d)&&(u[d]=P(f[d],E,w));return w.delete(f),u}return f}function S(f,E,w=!0){return p.isObject(f)?(p.isObject(E)&&Object.keys(E).forEach(b=>{b in f?w&&(p.isObject(f[b])&&p.isObject(E[b])?S(f[b],E[b],w):f[b]=E[b]):f[b]=E[b]}),f):E}e.mixin=S;function C(f,E){if(f===E)return!0;if(f==null||E===null||E===void 0||typeof f!=typeof E||typeof f!="object"||Array.isArray(f)!==Array.isArray(E))return!1;let w,b;if(Array.isArray(f)){if(f.length!==E.length)return!1;for(w=0;w<f.length;w++)if(!C(f[w],E[w]))return!1}else{const u=[];for(b in f)u.push(b);u.sort();const d=[];for(b in E)d.push(b);if(d.sort(),!C(u,d))return!1;for(w=0;w<u.length;w++)if(!C(f[u[w]],E[u[w]]))return!1}return!0}e.equals=C;function r(f){const E=new Set;return JSON.stringify(f,(w,b)=>{if(p.isObject(b)||Array.isArray(b)){if(E.has(b))return"[Circular]";E.add(b)}return b})}e.safeStringify=r;function I(f,E,w){const b=E(f);return typeof b=="undefined"?w:b}e.getOrDefault=I;function l(f,E){const w=Object.create(null);return!f||!E||Object.keys(E).forEach(u=>{const d=f[u],g=E[u];C(d,g)||(w[u]=g)}),w}e.distinct=l;function h(f,E){const w=E.toLowerCase(),b=Object.keys(f).find(u=>u.toLowerCase()===w);return b?f[b]:f[E]}e.getCaseInsensitive=h;function c(f,E){const w=Object.create(null);for(const b of Object.keys(f))E(b,f[b])&&(w[b]=f[b]);return w}e.filter=c}),define(ge[93],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function L(y){return y<0?0:y>255?255:y|0}e.toUint8=L;function k(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=k}),define(ge[2],pe([0,1,11,9]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function P(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!k.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,n){return!s&&!n?"file":s}function C(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const r="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(n,o,v,m,_,D=!1){typeof n=="object"?(this.scheme=n.scheme||r,this.authority=n.authority||r,this.path=n.path||r,this.query=n.query||r,this.fragment=n.fragment||r):(this.scheme=S(n,D),this.authority=o||r,this.path=C(this.scheme,v||r),this.query=m||r,this.fragment=_||r,P(this,D))}static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return u(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:m,query:_,fragment:D}=n;return o===void 0?o=this.scheme:o===null&&(o=r),v===void 0?v=this.authority:v===null&&(v=r),m===void 0?m=this.path:m===null&&(m=r),_===void 0?_=this.query:_===null&&(_=r),D===void 0?D=this.fragment:D===null&&(D=r),o===this.scheme&&v===this.authority&&m===this.path&&_===this.query&&D===this.fragment?this:new f(o,v,m,_,D)}static parse(n,o=!1){const v=l.exec(n);return v?new f(v[2]||r,i(v[4]||r),i(v[5]||r),i(v[7]||r),i(v[9]||r),o):new f(r,r,r,r,r)}static file(n){let o=r;if(p.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const v=n.indexOf(I,2);v===-1?(o=n.substring(2),n=I):(o=n.substring(2,v),n=n.substring(v)||I)}return new f("file",o,n,r,r)}static from(n){const o=new f(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return p.isWindows&&n.scheme==="file"?v=h.file(L.win32.join(u(n,!0),...o)).path:v=L.posix.join(n.path,...o),n.with({path:v})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const o=new f(n);return o._formatted=n.external,o._fsPath=n._sep===c?n.fsPath:null,o}}else return n}}e.URI=h;const c=p.isWindows?1:void 0;class f extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,n){let o,v=-1;for(let m=0;m<s.length;m++){const _=s.charCodeAt(m);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||n&&_===47)v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o!==void 0&&(o+=s.charAt(m));else{o===void 0&&(o=s.substr(0,m));const D=E[_];D!==void 0?(v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o+=D):v===-1&&(v=m)}}return v!==-1&&(o+=encodeURIComponent(s.substring(v))),o!==void 0?o:s}function b(s){let n;for(let o=0;o<s.length;o++){const v=s.charCodeAt(o);v===35||v===63?(n===void 0&&(n=s.substr(0,o)),n+=E[v]):n!==void 0&&(n+=s[o])}return n!==void 0?n:s}function u(s,n){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,p.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function d(s,n){const o=n?b:w;let v="",{scheme:m,authority:_,path:D,query:a,fragment:R}=s;if(m&&(v+=m,v+=":"),(_||m==="file")&&(v+=I,v+=I),_){let M=_.indexOf("@");if(M!==-1){const $=_.substr(0,M);_=_.substr(M+1),M=$.indexOf(":"),M===-1?v+=o($,!1):(v+=o($.substr(0,M),!1),v+=":",v+=o($.substr(M+1),!1)),v+="@"}_=_.toLowerCase(),M=_.indexOf(":"),M===-1?v+=o(_,!1):(v+=o(_.substr(0,M),!1),v+=_.substr(M))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const M=D.charCodeAt(1);M>=65&&M<=90&&(D=`/${String.fromCharCode(M+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const M=D.charCodeAt(0);M>=65&&M<=90&&(D=`${String.fromCharCode(M+32)}:${D.substr(2)}`)}v+=o(D,!0)}return a&&(v+="?",v+=o(a,!1)),R&&(v+="#",v+=n?R:w(R,!1)),v}function g(s){try{return decodeURIComponent(s)}catch(n){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,n=>g(n)):s}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[23],pe([0,1,2,8]),function(X,e,p,L){"use strict";var k,y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,i,s){let n=t.get(i);return n===void 0&&(n=s,t.set(i,n)),n}e.getOrSet=P;function S(t){const i=[];return t.forEach((s,n)=>{i.push(`${n} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=S;function C(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=C;class r{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=r;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?L.compareSubstring(i,this._value,0,i.length,this._from,this._to):L.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?L.compareSubstring(i,this._value,0,i.length,this._from,this._to):L.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return L.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(i){this._iter=i}static forUris(i=()=>!1){return new E(new c(i))}static forPaths(){return new E(new l)}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new I)}clear(){this._root=void 0}set(i,s){const n=this._iter.reset(i);let o;for(this._root||(this._root=new f,this._root.segment=n.value()),o=this._root;;){const m=n.cmp(o.segment);if(m>0)o.left||(o.left=new f,o.left.segment=n.value()),o=o.left;else if(m<0)o.right||(o.right=new f,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new f,o.mid.segment=n.value()),o=o.mid;else break}const v=o.value;return o.value=s,o.key=i,v}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const n=this._iter.reset(i),o=[];let v=this._root;for(;v;){const m=n.cmp(v.segment);if(m>0)o.push([1,v]),v=v.left;else if(m<0)o.push([-1,v]),v=v.right;else if(n.hasNext())n.next(),o.push([0,v]),v=v.mid;else{for(s?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;o.length>0&&v.isEmpty();){let[_,D]=o.pop();switch(_){case 1:D.left=void 0;break;case 0:D.mid=void 0;break;case-1:D.right=void 0;break}v=D}break}}}findSubstr(i){const s=this._iter.reset(i);let n=this._root,o;for(;n;){const v=s.cmp(n.segment);if(v>0)n=n.left;else if(v<0)n=n.right;else if(s.hasNext())s.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[s,n]of this)i(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const n=s.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&s.push(n.left),n.mid&&s.push(n.mid),n.right&&s.push(n.right))}}}e.TernarySearchTree=E;class w{constructor(i,s){this[k]="ResourceMap",i instanceof w?(this.map=new Map(i.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=i??w.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[n,o]of this.map)i(o,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var b;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const n=this._map.get(i);if(!!n)return s!==0&&this.touch(n,s),n.value}set(i,s,n=0){let o=this._map.get(i);if(o)o.value=s,n!==0&&this.touch(o,n);else{switch(o={key:i,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const n=this._state;let o=this._head;for(;o;){if(s?i.bind(s)(o.value,o.key,this):i(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}values(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}entries(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>i;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,n=i.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const n=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const n=i.next,o=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,n)=>{i.push([n,s])}),i}fromJSON(i){this.clear();for(const[s,n]of i)this.set(s,n)}}e.LinkedMap=u;class d extends u{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class g{constructor(i){A.set(this,void 0),it(this,A,i,"f")}get size(){return Be(this,A,"f").size}forEach(i,s){Be(this,A,"f").forEach(i,s)}get(i){return Be(this,A,"f").get(i)}has(i){return Be(this,A,"f").has(i)}entries(){return Be(this,A,"f").entries()}keys(){return Be(this,A,"f").keys()}values(){return Be(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Be(this,A,"f").entries()}}e.ReadonlyMapView=g}),define(ge[94],pe([0,1,23,8]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...J){return function(ce,me){for(let Le=0,We=J.length;Le<We;Le++){const Ee=J[Le](ce,me);if(Ee)return Ee}return null}}e.or=k,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(J,ce,me){if(!me||me.length<ce.length)return null;let Le;return J?Le=L.startsWithIgnoreCase(me,ce):Le=me.indexOf(ce)===0,Le?ce.length>0?[{start:0,end:ce.length}]:[]:null}function A(J,ce){const me=ce.toLowerCase().indexOf(J.toLowerCase());return me===-1?null:[{start:me,end:me+J.length}]}e.matchesContiguousSubString=A;function P(J,ce){return S(J.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=P;function S(J,ce,me,Le){if(me===J.length)return[];if(Le===ce.length)return null;if(J[me]===ce[Le]){let We=null;return(We=S(J,ce,me+1,Le+1))?w({start:Le,end:Le+1},We):null}return S(J,ce,me,Le+1)}function C(J){return 97<=J&&J<=122}function r(J){return 65<=J&&J<=90}e.isUpper=r;function I(J){return 48<=J&&J<=57}function l(J){return J===32||J===9||J===10||J===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>h.add(J.charCodeAt(0)));function c(J){return l(J)||h.has(J)}function f(J,ce){return J===ce||c(J)&&c(ce)}function E(J){return C(J)||r(J)||I(J)}function w(J,ce){return ce.length===0?ce=[J]:J.end===ce[0].start?ce[0].start=J.start:ce.unshift(J),ce}function b(J,ce){for(let me=ce;me<J.length;me++){const Le=J.charCodeAt(me);if(r(Le)||I(Le)||me>0&&!E(J.charCodeAt(me-1)))return me}return J.length}function u(J,ce,me,Le){if(me===J.length)return[];if(Le===ce.length)return null;if(J[me]!==ce[Le].toLowerCase())return null;{let We=null,Ee=Le+1;for(We=u(J,ce,me+1,Le+1);!We&&(Ee=b(ce,Ee))<ce.length;)We=u(J,ce,me+1,Ee),Ee++;return We===null?null:w({start:Le,end:Le+1},We)}}function d(J){let ce=0,me=0,Le=0,We=0,Ee=0;for(let Fe=0;Fe<J.length;Fe++)Ee=J.charCodeAt(Fe),r(Ee)&&ce++,C(Ee)&&me++,E(Ee)&&Le++,I(Ee)&&We++;const Ke=ce/J.length,K=me/J.length,ie=Le/J.length,ve=We/J.length;return{upperPercent:Ke,lowerPercent:K,alphaPercent:ie,numericPercent:ve}}function g(J){const{upperPercent:ce,lowerPercent:me}=J;return me===0&&ce>.6}function t(J){const{upperPercent:ce,lowerPercent:me,alphaPercent:Le,numericPercent:We}=J;return me>.2&&ce<.8&&Le>.6&&We<.2}function i(J){let ce=0,me=0,Le=0,We=0;for(let Ee=0;Ee<J.length;Ee++)Le=J.charCodeAt(Ee),r(Le)&&ce++,C(Le)&&me++,l(Le)&&We++;return(ce===0||me===0)&&We===0?J.length<=30:ce<=5}function s(J,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!i(J)||ce.length>60)return null;const me=d(ce);if(!t(me)){if(!g(me))return null;ce=ce.toLowerCase()}let Le=null,We=0;for(J=J.toLowerCase();We<ce.length&&(Le=u(J,ce,0,We))===null;)We=b(ce,We+1);return Le}e.matchesCamelCase=s;function n(J,ce,me=!1){if(!ce||ce.length===0)return null;let Le=null,We=0;for(J=J.toLowerCase(),ce=ce.toLowerCase();We<ce.length&&(Le=o(J,ce,0,We,me))===null;)We=v(ce,We+1);return Le}e.matchesWords=n;function o(J,ce,me,Le,We){if(me===J.length)return[];if(Le===ce.length)return null;if(f(J.charCodeAt(me),ce.charCodeAt(Le))){let Ee=null,Ke=Le+1;if(Ee=o(J,ce,me+1,Le+1,We),!We)for(;!Ee&&(Ke=v(ce,Ke))<ce.length;)Ee=o(J,ce,me+1,Ke,We),Ke++;return Ee===null?null:w({start:Le,end:Le+1},Ee)}else return null}function v(J,ce){for(let me=ce;me<J.length;me++)if(c(J.charCodeAt(me))||me>0&&c(J.charCodeAt(me-1)))return me;return J.length}const m=k(e.matchesPrefix,s,A),_=k(e.matchesPrefix,s,P),D=new p.LRUCache(1e4);function a(J,ce,me=!1){if(typeof J!="string"||typeof ce!="string")return null;let Le=D.get(J);Le||(Le=new RegExp(L.convertSimple2RegExpPattern(J),"i"),D.set(J,Le));const We=Le.exec(ce);return We?[{start:We.index,end:We.index+We[0].length}]:me?_(J,ce):m(J,ce)}e.matchesFuzzy=a;function R(J,ce){const me=qe(J,J.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return me?$(me):null}e.matchesFuzzy2=R;function M(J,ce,me,Le,We,Ee){const Ke=Math.min(13,J.length);for(;me<Ke;me++){const K=qe(J,ce,me,Le,We,Ee,!1);if(K)return K}return[0,Ee]}e.anyScore=M;function $(J){if(typeof J=="undefined")return[];const ce=[],me=J[1];for(let Le=J.length-1;Le>1;Le--){const We=J[Le]+me,Ee=ce[ce.length-1];Ee&&Ee.end===We?Ee.end=We+1:ce.push({start:We,end:We+1})}return ce}e.createMatches=$;const Y=128;function le(){const J=[],ce=[];for(let me=0;me<=Y;me++)ce[me]=0;for(let me=0;me<=Y;me++)J.push(ce.slice(0));return J}function q(J){const ce=[];for(let me=0;me<=J;me++)ce[me]=0;return ce}const U=q(2*Y),z=q(2*Y),O=le(),W=le(),T=le(),F=!1;function N(J,ce,me,Le,We){function Ee(K,ie,ve=" "){for(;K.length<ie;)K=ve+K;return K}let Ke=` |   |${Le.split("").map(K=>Ee(K,3)).join("|")}
`;for(let K=0;K<=me;K++)K===0?Ke+=" |":Ke+=`${ce[K-1]}|`,Ke+=J[K].slice(0,We+1).map(ie=>Ee(ie.toString(),3)).join("|")+`
`;return Ke}function x(J,ce,me,Le){J=J.substr(ce),me=me.substr(Le),console.log(N(W,J,J.length,me,me.length)),console.log(N(T,J,J.length,me,me.length)),console.log(N(O,J,J.length,me,me.length))}function G(J,ce){if(ce<0||ce>=J.length)return!1;const me=J.codePointAt(ce);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(me)}}function se(J,ce){if(ce<0||ce>=J.length)return!1;switch(J.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function be(J,ce,me){return ce[J]!==me[J]}function Ie(J,ce,me,Le,We,Ee,Ke=!1){for(;ce<me&&We<Ee;)J[ce]===Le[We]&&(Ke&&(U[ce]=We),ce+=1),We+=1;return ce===me}e.isPatternInWord=Ie;var Ce;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Me;(function(J){J.Default=[-100,0];function ce(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}J.isDefault=ce})(Me=e.FuzzyScore||(e.FuzzyScore={}));function qe(J,ce,me,Le,We,Ee,Ke){const K=J.length>Y?Y:J.length,ie=Le.length>Y?Y:Le.length;if(me>=K||Ee>=ie||K-me>ie-Ee||!Ie(ce,me,K,We,Ee,ie,!0))return;He(K,ie,me,Ee,ce,We);let ve=1,Fe=1,Ne=me,Qe=Ee;const De=[!1];for(ve=1,Ne=me;Ne<K;ve++,Ne++){const H=U[Ne],ee=z[Ne],ue=Ne+1<K?z[Ne+1]:ie;for(Fe=H-Ee+1,Qe=H;Qe<ue;Fe++,Qe++){let Ae=Number.MIN_SAFE_INTEGER,Re=!1;Qe<=ee&&(Ae=Ve(J,ce,Ne,me,Le,We,Qe,ie,Ee,O[ve-1][Fe-1]===0,De));let Ue=0;Ae!==Number.MAX_SAFE_INTEGER&&(Re=!0,Ue=Ae+W[ve-1][Fe-1]);const ze=Qe>H,Ze=ze?W[ve][Fe-1]+(O[ve][Fe-1]>0?-5:0):0,Je=Qe>H+1&&O[ve][Fe-1]>0,Xe=Je?W[ve][Fe-2]+(O[ve][Fe-2]>0?-5:0):0;if(Je&&(!ze||Xe>=Ze)&&(!Re||Xe>=Ue))W[ve][Fe]=Xe,T[ve][Fe]=3,O[ve][Fe]=0;else if(ze&&(!Re||Ze>=Ue))W[ve][Fe]=Ze,T[ve][Fe]=2,O[ve][Fe]=0;else if(Re)W[ve][Fe]=Ue,T[ve][Fe]=1,O[ve][Fe]=O[ve-1][Fe-1]+1;else throw new Error("not possible")}}if(F&&x(J,me,Le,Ee),!De[0]&&!Ke)return;ve--,Fe--;const Se=[W[ve][Fe],Ee];let Pe=0,ae=0;for(;ve>=1;){let H=Fe;do{const ee=T[ve][H];if(ee===3)H=H-2;else if(ee===2)H=H-1;else break}while(H>=1);Pe>1&&ce[me+ve-1]===We[Ee+Fe-1]&&!be(H+Ee-1,Le,We)&&Pe+1>O[ve][H]&&(H=Fe),H===Fe?Pe++:Pe=1,ae||(ae=H),ve--,Fe=H-1,Se.push(Fe)}ie===K&&(Se[0]+=2);const fe=ae-K;return Se[0]-=fe,Se}e.fuzzyScore=qe;function He(J,ce,me,Le,We,Ee){let Ke=J-1,K=ce-1;for(;Ke>=me&&K>=Le;)We[Ke]===Ee[K]&&(z[Ke]=K,Ke--),K--}function Ve(J,ce,me,Le,We,Ee,Ke,K,ie,ve,Fe){if(ce[me]!==Ee[Ke])return Number.MIN_SAFE_INTEGER;let Ne=1,Qe=!1;return Ke===me-Le?Ne=J[me]===We[Ke]?7:5:be(Ke,We,Ee)&&(Ke===0||!be(Ke-1,We,Ee))?(Ne=J[me]===We[Ke]?7:5,Qe=!0):G(Ee,Ke)&&(Ke===0||!G(Ee,Ke-1))?Ne=5:(G(Ee,Ke-1)||se(Ee,Ke-1))&&(Ne=5,Qe=!0),Ne>1&&me===Le&&(Fe[0]=!0),Qe||(Qe=be(Ke,We,Ee)||G(Ee,Ke-1)||se(Ee,Ke-1)),me===Le?Ke>ie&&(Ne-=Qe?3:5):ve?Ne+=Qe?2:0:Ne+=Qe?0:1,Ke+1===K&&(Ne-=Qe?3:5),Ne}function j(J,ce,me,Le,We,Ee,Ke){return ne(J,ce,me,Le,We,Ee,!0,Ke)}e.fuzzyScoreGracefulAggressive=j;function Z(J,ce,me,Le,We,Ee,Ke){return ne(J,ce,me,Le,We,Ee,!1,Ke)}e.fuzzyScoreGraceful=Z;function ne(J,ce,me,Le,We,Ee,Ke,K){let ie=qe(J,ce,me,Le,We,Ee,K);if(ie&&!Ke)return ie;if(J.length>=3){const ve=Math.min(7,J.length-1);for(let Fe=me+1;Fe<ve;Fe++){const Ne=oe(J,Fe);if(Ne){const Qe=qe(Ne,Ne.toLowerCase(),me,Le,We,Ee,K);Qe&&(Qe[0]-=3,(!ie||Qe[0]>ie[0])&&(ie=Qe))}}}return ie}function oe(J,ce){if(ce+1>=J.length)return;const me=J[ce],Le=J[ce+1];if(me!==Le)return J.slice(0,ce)+Le+me+J.slice(ce+2)}}),define(ge[136],pe([0,1,91,94,8]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function P(f){return f.replace(A,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=P;const S=new RegExp(`\\\\${y.source}`,"g");function C(f){return f.replace(S,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=C;const r=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(r,(E,w,b,u)=>b?E:w||u||"")}e.stripIcons=I;function l(f){const E=f.indexOf(e.iconStartMarker);return E===-1?{text:f}:h(f,E)}e.parseLabelWithIcons=l;function h(f,E){const w=[];let b="";function u(v){if(v){b+=v;for(const m of v)w.push(t)}}let d=-1,g="",t=0,i,s,n=E;const o=f.length;for(u(f.substr(0,E));n<o;)i=f[n],s=f[n+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(d=n,u(g),g=e.iconStartMarker,n++):i===")"&&d!==-1?(t+=n-d+1,d=-1,g=""):d!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(u(g),d=-1,g=""):u(i),n++;return u(g),{text:b,iconOffsets:w}}function c(f,E,w=!1){const{text:b,iconOffsets:u}=E;if(!u||u.length===0)return L.matchesFuzzy(f,b,w);const d=k.ltrim(b," "),g=b.length-d.length,t=L.matchesFuzzy(f,d,w);if(t)for(const i of t){const s=u[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=c}),define(ge[95],pe([0,1,136,14]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",c=!1){var f,E;if(this.value=h,typeof this.value!="string")throw L.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(f=c.isTrusted)!==null&&f!==void 0?f:void 0,this.supportThemeIcons=(E=c.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(h,c=0){return this.value+=C(this.supportThemeIcons?p.escapeIcons(h):h).replace(/([ \t]+)/g,(f,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,c){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=y;function A(l){return P(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function P(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function S(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=S;function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function r(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=r;function I(l){const h=[],c=l.split("|").map(E=>E.trim());l=c[0];const f=c[1];if(f){const E=/height=(\d+)/.exec(f),w=/width=(\d+)/.exec(f),b=E?E[1]:"",u=w?w[1]:"",d=isFinite(parseInt(u)),g=isFinite(parseInt(b));d&&h.push(`width="${u}"`),g&&h.push(`height="${b}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=I}),define(ge[54],pe([0,1,22,8,2]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(C){return JSON.stringify(C,P)}e.stringify=y;function A(C){let r=JSON.parse(C);return r=S(r),r}e.parse=A;function P(C,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:L.regExpFlags(r)}:r}function S(C,r=0){if(!C||r>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return k.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof p.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=S(C[I],r+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=S(C[I],r+1))}return C}e.revive=S}),define(ge[10],pe([0,1,2,11]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,r){this._hosts[S]=C,this._ports[S]=r}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let r=this._hosts[C];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const I=this._ports[C],l=this._connectionTokens[C];let h=`path=${encodeURIComponent(S.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),p.URI.from({scheme:L.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${r}:${I}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new y;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,C,r){const I=this.toUri(S,C);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):L.isNative&&(r||L.isPreferringBrowserCodeLoad)&&I.scheme===k.file?I.with({scheme:k.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,C){const r=this.toUri(S,C);return r.scheme===k.vscodeFileResource?r.with({scheme:k.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(S,C){return p.URI.isUri(S)?S:p.URI.parse(C.toUrl(S))}}e.FileAccess=new A}),define(ge[74],pe([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new p.LRUCache(1e4);function k(C){return S(C,"NFC",L)}e.normalizeNFC=k;const y=new p.LRUCache(1e4);function A(C){return S(C,"NFD",y)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function S(C,r,I){if(!e.canNormalize||!C)return C;const l=I.get(C);if(l)return l;let h;return P.test(C)?h=C.normalize(r):h=C,I.set(C,h),h}e.removeAccents=function(){if(e.canNormalize){const C=/[\u0300-\u036f]/g;return function(r){return A(r).replace(C,"")}}else return function(C){return C}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(h){return k.uriToFsPath(h,!0)}e.originalFSPath=S;class C{constructor(c){this._ignorePathCasing=c}compare(c,f,E=!1){return c===f?0:y.compare(this.getComparisonKey(c,E),this.getComparisonKey(f,E))}isEqual(c,f,E=!1){return c===f?!0:!c||!f?!1:this.getComparisonKey(c,E)===this.getComparisonKey(f,E)}getComparisonKey(c,f=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,f,E=!1){if(c.scheme===f.scheme){if(c.scheme===A.Schemas.file)return p.isEqualOrParent(S(c),S(f),this._ignorePathCasing(c))&&c.query===f.query&&(E||c.fragment===f.fragment);if(e.isEqualAuthority(c.authority,f.authority))return p.isEqualOrParent(c.path,f.path,this._ignorePathCasing(c),"/")&&c.query===f.query&&(E||c.fragment===f.fragment)}return!1}joinPath(c,...f){return k.URI.joinPath(c,...f)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return L.posix.basename(c.path)}extname(c){return L.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let f;return c.scheme===A.Schemas.file?f=k.URI.file(L.dirname(S(c))).path:(f=L.posix.dirname(c.path),c.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),f="/")),c.with({path:f})}normalizePath(c){if(!c.path.length)return c;let f;return c.scheme===A.Schemas.file?f=k.URI.file(L.normalize(S(c))).path:f=L.posix.normalize(c.path),c.with({path:f})}relativePath(c,f){if(c.scheme!==f.scheme||!e.isEqualAuthority(c.authority,f.authority))return;if(c.scheme===A.Schemas.file){const b=L.relative(S(c),S(f));return P.isWindows?p.toSlashes(b):b}let E=c.path||"/",w=f.path||"/";if(this._ignorePathCasing(c)){let b=0;for(const u=Math.min(E.length,w.length);b<u&&!(E.charCodeAt(b)!==w.charCodeAt(b)&&E.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);E=w.substr(0,b)+E.substr(b)}return L.posix.relative(E,w)}resolvePath(c,f){if(c.scheme===A.Schemas.file){const E=k.URI.file(L.resolve(S(c),f));return c.with({authority:E.authority,path:E.path})}return f=p.toPosixPath(f),c.with({path:L.posix.resolve(c.path,f)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,f){return c===f||y.equalsIgnoreCase(c,f)}hasTrailingPathSeparator(c,f=L.sep){if(c.scheme===A.Schemas.file){const E=S(c);return E.length>p.getRoot(E).length&&E[E.length-1]===f}else{const E=c.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,f=L.sep){return e.hasTrailingPathSeparator(c,f)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,f=L.sep){let E=!1;if(c.scheme===A.Schemas.file){const w=S(c);E=w!==void 0&&w.length===p.getRoot(w).length&&w[w.length-1]===f}else{f="/";const w=c.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!e.hasTrailingPathSeparator(c,f)?c.with({path:c.path+"/"}):c}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===A.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(h,c){const f=[];for(let E=0;E<h.length;E++){const w=c(h[E]);h.some((b,u)=>u===E?!1:e.isEqualOrParent(w,c(b)))||f.push(h[E])}return f}e.distinctParents=r;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(f){const E=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,g]=u.split(":");d&&g&&E.set(d,g)});const b=f.path.substring(0,f.path.indexOf(";"));return b&&E.set(h.META_DATA_MIME,b),E}h.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function l(h,c,f){if(c){let E=h.path;return E&&E[0]!==L.posix.sep&&(E=L.posix.sep+E),h.with({scheme:f,authority:c,path:E})}return h.with({scheme:f})}e.toLocalResource=l}),define(ge[16],pe([0,1,21,14,3,6,71,24]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(W){return!!W&&typeof W.then=="function"}e.isThenable=S;function C(W){const T=new p.CancellationTokenSource,F=W(T.token),N=new Promise((x,G)=>{T.token.onCancellationRequested(()=>{G(L.canceled())}),Promise.resolve(F).then(se=>{T.dispose(),x(se)},se=>{T.dispose(),G(se)})});return new class{cancel(){T.cancel()}then(x,G){return N.then(x,G)}catch(x){return this.then(void 0,x)}finally(x){return N.finally(x)}}}e.createCancelablePromise=C;function r(W,T,F){return Promise.race([W,new Promise(N=>T.onCancellationRequested(()=>N(F)))])}e.raceCancellation=r;async function I(W){let T=-1;const F=W.map((x,G)=>x.then(se=>(T=G,se))),N=await Promise.race(F);return W.forEach((x,G)=>{G!==T&&x.cancel()}),N}e.raceCancellablePromises=I;function l(W,T,F){let N;const x=setTimeout(()=>{N==null||N(void 0),F==null||F()},T);return Promise.race([W.finally(()=>clearTimeout(x)),new Promise(G=>N=G)])}e.raceTimeout=l;function h(W){return new Promise((T,F)=>{const N=W();S(N)?N.then(T,F):T(N)})}e.asPromise=h;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(F,F).then(N)})}return new Promise((F,N)=>{this.queuedPromise.then(F,N)})}return this.activePromise=T(),new Promise((F,N)=>{this.activePromise.then(x=>{this.activePromise=null,F(x)},x=>{this.activePromise=null,N(x)})})}}e.Throttler=c;class f{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=f;class E{constructor(){this.promiseMap=new Map}queue(T,F){var N;const G=((N=this.promiseMap.get(T))!==null&&N!==void 0?N:Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(T)===G&&this.promiseMap.delete(T)});return this.promiseMap.set(T,G),G}}e.SequencerByKey=E;class w{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,F=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,x)=>{this.doResolve=N,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},F),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class b{constructor(T){this.delayer=new w(T),this.throttler=new c}trigger(T,F){return this.delayer.trigger(()=>this.throttler.queue(T),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class u{constructor(){this._isOpen=!1,this._promise=new Promise((T,F)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function g(W,T){return T?new Promise((F,N)=>{const x=setTimeout(F,W);T.onCancellationRequested(()=>{clearTimeout(x),N(L.canceled())})}):C(F=>g(W,F))}e.timeout=g;function t(W,T=0){const F=setTimeout(W,T);return y.toDisposable(()=>clearTimeout(F))}e.disposableTimeout=t;function i(W){return W.then(void 0,T=>{})}e.ignoreErrors=i;function s(W){const T=[];let F=0;const N=W.length;function x(){return F<N?W[F++]():null}function G(se){se!=null&&T.push(se);const be=x();return be?be.then(G):Promise.resolve(T)}return Promise.resolve(null).then(G)}e.sequence=s;function n(W,T=N=>!!N,F=null){let N=0;const x=W.length,G=()=>{if(N>=x)return Promise.resolve(F);const se=W[N++];return Promise.resolve(se()).then(Ie=>T(Ie)?Promise.resolve(Ie):G())};return G()}e.first=n;function o(W,T=N=>!!N,F=null){if(W.length===0)return Promise.resolve(F);let N=W.length;const x=()=>{var G,se;N=-1;for(const be of W)(se=(G=be).cancel)===null||se===void 0||se.call(G)};return new Promise((G,se)=>{for(const be of W)be.then(Ie=>{--N>=0&&T(Ie)?(x(),G(Ie)):N===0&&G(F)}).catch(Ie=>{--N>=0&&(x(),se(Ie))})})}e.firstParallel=o;class v{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((F,N)=>{this.outstandingPromises.push({factory:T,c:F,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const F=T.factory();F.then(T.c,T.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class m extends v{constructor(){super(1)}}e.Queue=m;class _{constructor(){this.queues=new Map}queueFor(T,F=P.extUri){const N=F.getComparisonKey(T);let x=this.queues.get(N);return x||(x=new m,k.Event.once(x.onFinished)(()=>{x==null||x.dispose(),this.queues.delete(N)}),this.queues.set(N,x)),x}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=_;class D{constructor(T,F){this._token=-1,typeof T=="function"&&typeof F=="number"&&this.setIfNotSet(T,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},F)}setIfNotSet(T,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},F))}}e.TimeoutTimer=D;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,F){this.cancel(),this._token=setInterval(()=>{T()},F)}}e.IntervalTimer=a;class R{constructor(T,F){this.timeoutToken=-1,this.runner=T,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class M extends R{constructor(T,F){super(T,F);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const F=setTimeout(()=>T(W));let N=!1;return{dispose(){N||(N=!0,clearTimeout(F))}}}}else e.runWhenIdle=(W,T)=>{const F=requestIdleCallback(W,typeof T=="number"?{timeout:T}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(F))}}}}();class ${constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function Y(W,T,F){let N;for(let x=0;x<F;x++)try{return await W()}catch(G){N=G,await g(T)}throw N}e.retry=Y;class le{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,F,N){return this._pending={taskId:T,cancel:()=>N==null?void 0:N(),promise:F},F.then(()=>this.donePending(T),()=>this.donePending(T)),F}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let F,N;const x=new Promise((G,se)=>{F=G,N=se});this._next={run:T,promise:x,promiseResolve:F,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=le;class q{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,F)=>{this.completeCallback=T,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(F=>{this.completeCallback(T),this.resolved=!0,F()})}error(T){return new Promise(F=>{this.errorCallback(T),this.rejected=!0,F()})}cancel(){new Promise(T=>{this.errorCallback(L.canceled()),this.rejected=!0,T()})}}e.DeferredPromise=U;class z extends k.Emitter{async fireAsync(T,F,N){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const x of this._listeners)this._asyncDeliveryQueue.push([x,T]);for(;this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[x,G]=this._asyncDeliveryQueue.shift(),se=[],be=Object.assign(Object.assign({},G),{waitUntil:Ie=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");N&&(Ie=N(Ie,typeof x=="function"?x:x[0])),se.push(Ie)}});try{typeof x=="function"?x.call(void 0,be):x[0].call(x[1],be)}catch(Ie){L.onUnexpectedError(Ie);continue}Object.freeze(se),await O.settled(se).catch(Ie=>L.onUnexpectedError(Ie))}}}}e.AsyncEmitter=z;var O;(function(W){async function T(G){return typeof Promise.allSettled=="function"?F(G):N(G)}W.allSettled=T;async function F(G){return Promise.allSettled(G)}async function N(G){return Promise.all(G.map(se=>se.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function x(G){let se;const be=await Promise.all(G.map(Ie=>Ie.then(Ce=>Ce,Ce=>{se||(se=Ce)})));if(typeof se!="undefined")throw se;return be}W.settled=x})(O=e.Promises||(e.Promises={}))}),define(ge[96],pe([0,1,9,16]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new L.IdleValue(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),y=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(D,a,R=!1){const M=D||"",$=a||"",Y=k.value.collator.compare(M,$);return k.value.collatorIsNumeric&&Y===0&&M!==$?M<$?-1:1:Y}e.compareFileNames=P;function S(D,a){const R=y.value.collator;return D=D||"",a=a||"",g(R,D,a)}e.compareFileNamesDefault=S;function C(D,a){const R=y.value.collator;return D=D||"",a=a||"",n(D,a)||g(R,D,a)}e.compareFileNamesUpper=C;function r(D,a){const R=y.value.collator;return D=D||"",a=a||"",s(D,a)||g(R,D,a)}e.compareFileNamesLower=r;function I(D,a){return D=D||"",a=a||"",D===a?0:D<a?-1:1}e.compareFileNamesUnicode=I;function l(D,a,R=!1){R||(D=D&&D.toLowerCase(),a=a&&a.toLowerCase());const[M,$]=u(D),[Y,le]=u(a);return M!==Y?M<Y?-1:1:$===le?0:$<le?-1:1}e.noIntlCompareFileNames=l;function h(D,a){const[R,M]=u(D),[$,Y]=u(a);let le=k.value.collator.compare(M,Y);if(le===0){if(k.value.collatorIsNumeric&&M!==Y)return M<Y?-1:1;if(le=k.value.collator.compare(R,$),k.value.collatorIsNumeric&&le===0&&R!==$)return R<$?-1:1}return le}e.compareFileExtensions=h;function c(D,a){D=D||"",a=a||"";const R=d(D),M=d(a),$=y.value.collator,Y=A.value.collator;return g(Y,R,M)||g($,D,a)}e.compareFileExtensionsDefault=c;function f(D,a){D=D||"",a=a||"";const R=d(D),M=d(a),$=y.value.collator,Y=A.value.collator;return g(Y,R,M)||n(D,a)||g($,D,a)}e.compareFileExtensionsUpper=f;function E(D,a){D=D||"",a=a||"";const R=d(D),M=d(a),$=y.value.collator,Y=A.value.collator;return g(Y,R,M)||s(D,a)||g($,D,a)}e.compareFileExtensionsLower=E;function w(D,a){D=D||"",a=a||"";const R=d(D).toLowerCase(),M=d(a).toLowerCase();return R!==M?R<M?-1:1:D!==a?D<a?-1:1:0}e.compareFileExtensionsUnicode=w;const b=/^(.*?)(\.([^.]*))?$/;function u(D,a=!1){const R=D?b.exec(D):[];let M=[R&&R[1]||"",R&&R[3]||""];return a&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function d(D){const a=D?b.exec(D):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(D,a,R){let M=D.compare(a,R);return M!==0?M:a.length!==R.length?a.length<R.length?-1:1:0}function t(D){const a=D.charAt(0);return a.toLocaleUpperCase()!==a}function i(D){const a=D.charAt(0);return a.toLocaleLowerCase()!==a}function s(D,a){return t(D)&&i(a)?-1:i(D)&&t(a)?1:0}function n(D,a){return i(D)&&t(a)?-1:t(D)&&i(a)?1:0}function o(D,a,R=!1){return R||(D=D&&D.toLowerCase(),a=a&&a.toLowerCase()),D===a?0:D<a?-1:1}function v(D,a,R=!1){const M=D.split(p.sep),$=a.split(p.sep),Y=M.length-1,le=$.length-1;let q,U;for(let z=0;;z++){if(q=Y===z,U=le===z,q&&U)return P(M[z],$[z],R);if(q)return-1;if(U)return 1;const O=o(M[z],$[z],R);if(O!==0)return O}}e.comparePaths=v;function m(D,a,R){const M=D.toLowerCase(),$=a.toLowerCase(),Y=_(D,a,R);if(Y)return Y;const le=M.endsWith(R),q=$.endsWith(R);if(le!==q)return le?-1:1;const U=P(M,$);return U!==0?U:M.localeCompare($)}e.compareAnything=m;function _(D,a,R){const M=D.toLowerCase(),$=a.toLowerCase(),Y=M.startsWith(R),le=$.startsWith(R);if(Y!==le)return Y?-1:1;if(Y&&le){if(M.length<$.length)return-1;if(M.length>$.length)return 1}return 0}e.compareByPrefix=_}),define(ge[97],pe([0,1,96,94,9,11,8]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,S=[P,[]];function C(q,U,z,O){if(!q||!U)return S;const W=q.length,T=U.length;if(W<T)return S;const F=q.toLowerCase();return!O&&!F.includes(z)?S:r(U,z,T,q,F,W)}e.scoreFuzzy=C;function r(q,U,z,O,W,T){const F=[],N=[];for(let be=0;be<z;be++){const Ie=be*T,Ce=Ie-T,Me=be>0,qe=q[be],He=U[be];for(let Ve=0;Ve<T;Ve++){const j=Ve>0,Z=Ie+Ve,ne=Z-1,oe=Ce+Ve-1,J=j?F[ne]:0,ce=Me&&j?F[oe]:0,me=Me&&j?N[oe]:0;let Le;!ce&&Me?Le=0:Le=I(qe,He,O,W,Ve,me),Le&&ce+Le>=J?(N[Z]=me+1,F[Z]=ce+Le):(N[Z]=P,F[Z]=J)}}const x=[];let G=z-1,se=T-1;for(;G>=0&&se>=0;){const be=G*T+se;N[be]===P||(x.push(se),G--),se--}return[F[z*T-1],x.reverse()]}function I(q,U,z,O,W,T){let F=0;if(!l(U,O[W]))return F;if(F+=1,T>0&&(F+=T*5),q===z[W]&&(F+=1),W===0)F+=8;else{const N=h(z.charCodeAt(W-1));N?F+=N:L.isUpper(z.charCodeAt(W))&&(F+=2)}return F}function l(q,U){return q===U?!0:q==="/"||q==="\\"?U==="/"||U==="\\":!1}function h(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function f(q,U,z=0,O=0){const W=U;return W.values&&W.values.length>1?E(q,W.values,z,O):w(q,U,z,O)}e.scoreFuzzy2=f;function E(q,U,z,O){let W=0;const T=[];for(const F of U){const[N,x]=w(q,F,z,O);if(typeof N!="number")return c;W+=N,T.push(...x)}return[W,v(T)]}function w(q,U,z,O){const W=L.fuzzyScore(U.original,U.originalLowercase,z,q,q.toLowerCase(),O,!0);return W?[W[0],L.createMatches(W)]:c}const b=Object.freeze({score:0}),u=1<<18,d=1<<17,g=1<<16;function t(q,U,z,O,W){if(!q||!U.normalized)return b;const T=O.getItemLabel(q);if(!T)return b;const F=O.getItemDescription(q);let N;F?N=`${T}${F}${U.normalized}${Array.isArray(U.values)?U.values.length:""}${z}`:N=`${T}${U.normalized}${Array.isArray(U.values)?U.values.length:""}${z}`;const x=W[N];if(x)return x;const G=i(T,F,O.getItemPath(q),U,z);return W[N]=G,G}e.scoreItemFuzzy=t;function i(q,U,z,O,W){const T=!z||!O.containsPathSeparator;return z&&(y.isLinux?O.pathNormalized===z:A.equalsIgnoreCase(O.pathNormalized,z))?{score:u,labelMatch:[{start:0,end:q.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:O.values&&O.values.length>1?s(q,U,z,O.values,T,W):n(q,U,z,O,T,W)}function s(q,U,z,O,W,T){let F=0;const N=[],x=[];for(const G of O){const{score:se,labelMatch:be,descriptionMatch:Ie}=n(q,U,z,G,W,T);if(se===P)return b;F+=se,be&&N.push(...be),Ie&&x.push(...Ie)}return{score:F,labelMatch:v(N),descriptionMatch:v(x)}}function n(q,U,z,O,W,T){if(W||!U){const[F,N]=C(q,O.normalized,O.normalizedLowercase,T);if(F){const x=L.matchesPrefix(O.normalized,q);let G;return x?(G=d,G+=Math.round(O.normalized.length/q.length*100)):G=g,{score:G+F,labelMatch:x||o(N)}}}if(U){let F=U;z&&(F=`${U}${k.sep}`);const N=F.length,x=`${F}${q}`,[G,se]=C(x,O.normalized,O.normalizedLowercase,T);if(G){const be=o(se),Ie=[],Ce=[];return be.forEach(Me=>{Me.start<N&&Me.end>N?(Ie.push({start:0,end:Me.end-N}),Ce.push({start:Me.start,end:N})):Me.start>=N?Ie.push({start:Me.start-N,end:Me.end-N}):Ce.push(Me)}),{score:G,labelMatch:Ie,descriptionMatch:Ce}}}return b}function o(q){const U=[];if(!q)return U;let z;for(const O of q)z&&z.end===O?z.end+=1:(z={start:O,end:O+1},U.push(z));return U}function v(q){const U=q.sort((W,T)=>W.start-T.start),z=[];let O;for(const W of U)!O||!m(O,W)?(O=W,z.push(W)):(O.start=Math.min(O.start,W.start),O.end=Math.max(O.end,W.end));return z}function m(q,U){return!(q.end<U.start||U.end<q.start)}function _(q,U,z,O,W,T){const F=t(q,z,O,W,T),N=t(U,z,O,W,T),x=F.score,G=N.score;if((x===u||G===u)&&x!==G)return x===u?-1:1;if(x>g||G>g){if(x!==G)return x>G?-1:1;if(x<d&&G<d){const He=a(F.labelMatch,N.labelMatch);if(He!==0)return He}const Me=W.getItemLabel(q)||"",qe=W.getItemLabel(U)||"";if(Me.length!==qe.length)return Me.length-qe.length}if(x!==G)return x>G?-1:1;const se=Array.isArray(F.labelMatch)&&F.labelMatch.length>0,be=Array.isArray(N.labelMatch)&&N.labelMatch.length>0;if(se&&!be)return-1;if(be&&!se)return 1;const Ie=D(q,F,W),Ce=D(U,N,W);return Ie&&Ce&&Ie!==Ce?Ce>Ie?-1:1:R(q,U,z,W)}e.compareItemsByFuzzyScore=_;function D(q,U,z){let O=-1,W=-1;if(U.descriptionMatch&&U.descriptionMatch.length?O=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(O=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(W=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const T=z.getItemDescription(q);T&&(W+=T.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(W=U.descriptionMatch[U.descriptionMatch.length-1].end);return W-O}function a(q,U){if(!q&&!U||(!q||!q.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!q||!q.length)return 1;const z=q[0].start,W=q[q.length-1].end-z,T=U[0].start,N=U[U.length-1].end-T;return W===N?0:N<W?1:-1}function R(q,U,z,O){const W=O.getItemLabel(q)||"",T=O.getItemLabel(U)||"",F=O.getItemDescription(q),N=O.getItemDescription(U),x=W.length+(F?F.length:0),G=T.length+(N?N.length:0);if(x!==G)return x-G;const se=O.getItemPath(q),be=O.getItemPath(U);return se&&be&&se.length!==be.length?se.length-be.length:W!==T?p.compareAnything(W,T,z.normalized):F&&N&&F!==N?p.compareAnything(F,N,z.normalized):se&&be&&se!==be?p.compareAnything(se,be,z.normalized):0}const M=" ";function $(q){typeof q!="string"&&(q="");const U=q.toLowerCase(),{pathNormalized:z,normalized:O,normalizedLowercase:W}=Y(q),T=z.indexOf(k.sep)>=0;let F;const N=q.split(M);if(N.length>1)for(const x of N){const{pathNormalized:G,normalized:se,normalizedLowercase:be}=Y(x);se&&(F||(F=[]),F.push({original:x,originalLowercase:x.toLowerCase(),pathNormalized:G,normalized:se,normalizedLowercase:be}))}return{original:q,originalLowercase:U,pathNormalized:z,normalized:O,normalizedLowercase:W,values:F,containsPathSeparator:T}}e.prepareQuery=$;function Y(q){let U;y.isWindows?U=q.replace(/\//g,k.sep):U=q.replace(/\\/g,k.sep);const z=A.stripWildcards(U).replace(/\s/g,"");return{pathNormalized:U,normalized:z,normalizedLowercase:z.toLowerCase()}}function le(q){return Array.isArray(q)?$(q.map(U=>U.original).join(M)):$(q.original)}e.pieceToQuery=le}),define(ge[30],pe([0,1,8,29,9,23,16]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",C="/",r="[/\\\\]",I="[^/\\\\]",l=/\//g;function h(F){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${r}|${I}+${r}|${r}${I}+)*?`}}function c(F,N){if(!F)return[];const x=[];let G=!1,se=!1,be="";for(const Ie of F){switch(Ie){case N:if(!G&&!se){x.push(be),be="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":se=!0;break;case"]":se=!1;break}be+=Ie}return be&&x.push(be),x}e.splitGlobAware=c;function f(F){if(!F)return"";let N="";const x=c(F,C);if(x.every(G=>G===S))N=".*";else{let G=!1;x.forEach((se,be)=>{if(se===S){G||(N+=h(2),G=!0);return}let Ie=!1,Ce="",Me=!1,qe="";for(const He of se){if(He!=="}"&&Ie){Ce+=He;continue}if(Me&&(He!=="]"||!qe)){let Ve;He==="-"?Ve=He:(He==="^"||He==="!")&&!qe?Ve="^":He===C?Ve="":Ve=p.escapeRegExpCharacters(He),qe+=Ve;continue}switch(He){case"{":Ie=!0;continue;case"[":Me=!0;continue;case"}":N+=`(?:${c(Ce,",").map(Z=>f(Z)).join("|")})`,Ie=!1,Ce="";break;case"]":N+="["+qe+"]",Me=!1,qe="";break;case"?":N+=I;continue;case"*":N+=h(1);continue;default:N+=p.escapeRegExpCharacters(He)}}be<x.length-1&&(x[be+1]!==S||be+2<x.length)&&(N+=r),G=!1})}return N}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function n(F,N){if(!F)return s;let x;typeof F!="string"?x=F.pattern:x=F,x=x.trim();const G=`${x}_${!!N.trimForExclusions}`;let se=t.get(G);if(se)return o(se,F);let be;if(E.test(x)){const Ie=x.substr(4);se=function(Ce,Me){return typeof Ce=="string"&&Ce.endsWith(Ie)?x:null}}else(be=w.exec(v(x,N)))?se=m(be[1],x):(N.trimForExclusions?u:b).test(x)?se=_(x,N):(be=d.exec(v(x,N)))?se=D(be[1].substr(1),x,!0):(be=g.exec(v(x,N)))?se=D(be[1],x,!1):se=a(x);return t.set(G,se),o(se,F)}function o(F,N){return typeof N=="string"?F:function(x,G){return L.isEqualOrParent(x,N.base)?F(k.relative(N.base,x),G):null}}function v(F,N){return N.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function m(F,N){const x=`/${F}`,G=`\\${F}`,se=function(Ie,Ce){return typeof Ie!="string"?null:Ce?Ce===F?N:null:Ie===F||Ie.endsWith(x)||Ie.endsWith(G)?N:null},be=[F];return se.basenames=be,se.patterns=[N],se.allBasenames=be,se}function _(F,N){const x=T(F.slice(1,-1).split(",").map(Ce=>n(Ce,N)).filter(Ce=>Ce!==s),F),G=x.length;if(!G)return s;if(G===1)return x[0];const se=function(Ce,Me){for(let qe=0,He=x.length;qe<He;qe++)if(x[qe](Ce,Me))return F;return null},be=x.find(Ce=>!!Ce.allBasenames);be&&(se.allBasenames=be.allBasenames);const Ie=x.reduce((Ce,Me)=>Me.allPaths?Ce.concat(Me.allPaths):Ce,[]);return Ie.length&&(se.allPaths=Ie),se}function D(F,N,x){const G=k.sep===k.posix.sep,se=G?F:F.replace(l,k.sep),be=k.sep+se,Ie=k.posix.sep+F,Ce=x?function(Me,qe){return typeof Me=="string"&&(Me===se||Me.endsWith(be)||!G&&(Me===F||Me.endsWith(Ie)))?N:null}:function(Me,qe){return typeof Me=="string"&&(Me===se||!G&&Me===F)?N:null};return Ce.allPaths=[(x?"*/":"./")+F],Ce}function a(F){try{const N=new RegExp(`^${f(F)}$`);return function(x){return N.lastIndex=0,typeof x=="string"&&N.test(x)?F:null}}catch(N){return s}}function R(F,N,x){return!F||typeof N!="string"?!1:M(F)(N,void 0,x)}e.match=R;function M(F,N={}){if(!F)return i;if(typeof F=="string"||q(F)){const x=n(F,N);if(x===s)return i;const G=function(se,be){return!!x(se,be)};return x.allBasenames&&(G.allBasenames=x.allBasenames),x.allPaths&&(G.allPaths=x.allPaths),G}return O(F,N)}e.parse=M;function $(F){if(!F)return;let N;return x=>(N||(N=(F()||Promise.resolve([])).then(G=>G?le(G):{})),N.then(G=>!!G[x]))}e.hasSiblingPromiseFn=$;function Y(F){if(!F)return;let N;return x=>{if(!N){const G=F();N=G?le(G):{}}return!!N[x]}}e.hasSiblingFn=Y;function le(F){const N={};for(const x of F)N[x]=!0;return N}function q(F){const N=F;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}e.isRelativePattern=q;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function z(F){return F.allPaths||[]}e.getPathTerms=z;function O(F,N){const x=T(Object.getOwnPropertyNames(F).map(Ce=>W(Ce,F[Ce],N)).filter(Ce=>Ce!==s)),G=x.length;if(!G)return s;if(!x.some(Ce=>!!Ce.requiresSiblings)){if(G===1)return x[0];const Ce=function(He,Ve){for(let j=0,Z=x.length;j<Z;j++){const ne=x[j](He,Ve);if(ne)return ne}return null},Me=x.find(He=>!!He.allBasenames);Me&&(Ce.allBasenames=Me.allBasenames);const qe=x.reduce((He,Ve)=>Ve.allPaths?He.concat(Ve.allPaths):He,[]);return qe.length&&(Ce.allPaths=qe),Ce}const se=function(Ce,Me,qe){let He;for(let Ve=0,j=x.length;Ve<j;Ve++){const Z=x[Ve];Z.requiresSiblings&&qe&&(Me||(Me=k.basename(Ce)),He||(He=Me.substr(0,Me.length-k.extname(Ce).length)));const ne=Z(Ce,Me,He,qe);if(ne)return ne}return null},be=x.find(Ce=>!!Ce.allBasenames);be&&(se.allBasenames=be.allBasenames);const Ie=x.reduce((Ce,Me)=>Me.allPaths?Ce.concat(Me.allPaths):Ce,[]);return Ie.length&&(se.allPaths=Ie),se}function W(F,N,x){if(N===!1)return s;const G=n(F,x);if(G===s)return s;if(typeof N=="boolean")return G;if(N){const se=N.when;if(typeof se=="string"){const be=(Ie,Ce,Me,qe)=>{if(!qe||!G(Ie,Ce))return null;const He=se.replace("$(basename)",Me),Ve=qe(He);return A.isThenable(Ve)?Ve.then(j=>j?F:null):Ve?F:null};return be.requiresSiblings=!0,be}}return G}function T(F,N){const x=F.filter(Ce=>!!Ce.basenames);if(x.length<2)return F;const G=x.reduce((Ce,Me)=>{const qe=Me.basenames;return qe?Ce.concat(qe):Ce},[]);let se;if(N){se=[];for(let Ce=0,Me=G.length;Ce<Me;Ce++)se.push(N)}else se=x.reduce((Ce,Me)=>{const qe=Me.patterns;return qe?Ce.concat(qe):Ce},[]);const be=function(Ce,Me){if(typeof Ce!="string")return null;if(!Me){let He;for(He=Ce.length;He>0;He--){const Ve=Ce.charCodeAt(He-1);if(Ve===47||Ve===92)break}Me=Ce.substr(He)}const qe=G.indexOf(Me);return qe!==-1?se[qe]:null};be.basenames=G,be.patterns=se,be.allBasenames=G;const Ie=F.filter(Ce=>!Ce.basenames);return Ie.push(be),Ie}}),define(ge[75],pe([0,1,2,9,8,10,11,24,29]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(n,o,v){if(typeof n=="string"&&(n=p.URI.file(n)),v){const _=v.getWorkspaceFolder(n);if(_){const D=v.getWorkspace().folders.length>1;let a;if(P.isEqual(_.uri,n)?a="":a=P.relativePath(_.uri,n),D){const R=_.name?_.name:P.basename(_.uri);a=a?R+" \u2022 "+a:R}return a}}if(n.scheme!==y.Schemas.file&&n.scheme!==y.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if(S.hasDriveLetter(n.fsPath))return L.normalize(I(n.fsPath));let m=L.normalize(n.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(m=h(m,o.userHome.fsPath)),m}e.getPathLabel=C;function r(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const o=P.basename(n)||(n.scheme===y.Schemas.file?n.fsPath:n.path);return A.isWindows&&S.isRootOrDriveLetter(o)?I(o):o}e.getBaseLabel=r;function I(n){return S.hasDriveLetter(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let l=Object.create(null);function h(n,o){if(A.isWindows||!n||!o)return n;let v=l.original===o?l.normalized:void 0;return v||(v=`${k.rtrim(o,L.posix.sep)}${L.posix.sep}`,l={original:o,normalized:v}),(A.isLinux?n.startsWith(v):k.startsWithIgnoreCase(n,v))&&(n=`~/${n.substr(v.length)}`),n}e.tildify=h;function c(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=c;const f="\u2026",E="\\\\",w="~";function b(n,o=L.sep){const v=new Array(n.length);let m=!1;for(let _=0;_<n.length;_++){let D=n[_];if(D===""){v[_]=`.${o}`;continue}if(!D){v[_]=D;continue}m=!0;let a="";D.indexOf(E)===0?(a=D.substr(0,D.indexOf(E)+E.length),D=D.substr(D.indexOf(E)+E.length)):D.indexOf(o)===0?(a=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length)):D.indexOf(w)===0&&(a=D.substr(0,D.indexOf(w)+w.length),D=D.substr(D.indexOf(w)+w.length));const R=D.split(o);for(let M=1;m&&M<=R.length;M++)for(let $=R.length-M;m&&$>=0;$--){m=!1;let Y=R.slice($,$+M).join(o);for(let le=0;!m&&le<n.length;le++)if(le!==_&&n[le]&&n[le].indexOf(Y)>-1){const q=$+M===R.length,U=$>0&&n[le].indexOf(o)>-1?o+Y:Y,z=n[le].endsWith(U);m=!q||z}if(!m){let le="";(R[0].endsWith(":")||a!=="")&&($===1&&($=0,M++,Y=R[0]+o+Y),$>0&&(le=R[0]+o),le=a+le),$>0&&(le=le+f+o),le=le+Y,$+M<R.length&&(le=le+o+f),v[_]=le}}m&&(v[_]=D)}return v}e.shorten=b;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function d(n,o=Object.create(null)){const v=[];let m=!1,_="";for(const D of n)if(D==="$"||m&&D==="{")_&&v.push({value:_,type:u.TEXT}),_="",m=!0;else if(D==="}"&&m){const a=o[_];if(typeof a=="string")a.length&&v.push({value:a,type:u.VARIABLE});else if(a){const R=v[v.length-1];(!R||R.type!==u.SEPARATOR)&&v.push({value:a.label,type:u.SEPARATOR})}_="",m=!1}else _+=D;return _&&!m&&v.push({value:_,type:u.TEXT}),v.filter((D,a)=>{if(D.type===u.SEPARATOR){const R=v[a-1],M=v[a+1];return[R,M].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=d;function g(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,v=>v==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(n){const o=n.indexOf("/")!==-1?L.posix:L.win32,v=o.basename(n),m=o.dirname(n);return v.length?{name:v,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(ge[98],pe([0,1,9,8,30,10,24]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let S=[],C=[],r=[];function I(i,s=!1){const n=l(i);S.push(n),n.userConfigured?r.push(n):C.push(n),s&&!n.userConfigured&&S.forEach(o=>{o.mime===n.mime||o.userConfigured||(n.extension&&o.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&o.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&o.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&o.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=I;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(p.posix.sep)>=0:!1}}function h(i){i?(S=S.filter(s=>!s.userConfigured),r=[]):(S=[],C=[],r=[])}e.clearTextMimes=h;function c(i,s){let n;if(i)switch(i.scheme){case y.Schemas.file:n=i.fsPath;break;case y.Schemas.data:n=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break;default:n=i.path}if(!n)return[P.unknown];n=n.toLowerCase();const o=p.basename(n),v=f(n,o,r);if(v)return[v,P.text];const m=f(n,o,C);if(m)return[m,P.text];if(s){const _=E(s);if(_)return[_,P.text]}return[P.unknown]}e.guessMimeTypes=c;function f(i,s,n){let o=null,v=null,m=null;for(let _=n.length-1;_>=0;_--){const D=n[_];if(s===D.filenameLowercase){o=D;break}if(D.filepattern&&(!v||D.filepattern.length>v.filepattern.length)){const a=D.filepatternOnPath?i:s;k.match(D.filepatternLowercase,a)&&(v=D)}D.extension&&(!m||D.extension.length>m.extension.length)&&s.endsWith(D.extensionLowercase)&&(m=D)}return o?o.mime:v?v.mime:m?m.mime:null}function E(i){if(L.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=S.length-1;s>=0;s--){const n=S[s];if(!n.firstline)continue;const o=i.match(n.firstline);if(o&&o.length>0)return n.mime}return null}function w(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(i){const s=p.extname(i);return b[s.toLowerCase()]}e.getMediaMime=u;function d(i){for(const s in b)if(b[s]===i)return s}e.getExtensionForMimeType=d;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var n;const o=g.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${(n=o[3])!==null&&n!==void 0?n:""}`:s?void 0:i}e.normalizeMimeType=t}),define(ge[99],pe([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(r){return r.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:L(p.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:L(p.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:p.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function y(r,I,l){if(!r||l>200)return null;if(typeof r=="object"){if(r instanceof p.URI)return I.transformOutgoing(r);for(let h in r)if(Object.hasOwnProperty.call(r,h)){const c=y(r[h],I,l+1);c!==null&&(r[h]=c)}}return null}function A(r,I){const l=y(r,I,0);return l===null?r:l}e.transformOutgoingURIs=A;function P(r,I,l,h){if(!r||h>200)return null;if(typeof r=="object"){if(r.$mid===1)return l?p.URI.revive(I.transformIncoming(r)):I.transformIncoming(r);for(let c in r)if(Object.hasOwnProperty.call(r,c)){const f=P(r[c],I,l,h+1);f!==null&&(r[c]=f)}}return null}function S(r,I){const l=P(r,I,!1,0);return l===null?r:l}e.transformIncomingURIs=S;function C(r,I){const l=P(r,I,!0,0);return l===null?r:l}e.transformAndReviveIncomingURIs=C}),define(ge[32],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return p.test(S)}e.isUUID=L;const k=new Uint8Array(16),y=[];for(let S=0;S<256;S++)y.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function P(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let S=0,C="";return C+=y[k[S++]],C+=y[k[S++]],C+=y[k[S++]],C+=y[k[S++]],C+="-",C+=y[k[S++]],C+=y[k[S++]],C+="-",C+=y[k[S++]],C+=y[k[S++]],C+="-",C+=y[k[S++]],C+=y[k[S++]],C+="-",C+=y[k[S++]],C+=y[k[S++]],C+=y[k[S++]],C+=y[k[S++]],C+=y[k[S++]],C+=y[k[S++]],C}e.generateUuid=P}),define(ge[137],pe([0,1,100]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(y="utf8"){this.stringDecoder=new p.StringDecoder(y),this.remaining=null}write(y){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(P.length<1)return A;let S=0,C,r=S;for(;r<P.length;)if(C=P.charCodeAt(r),C===13||C===10){if(A.push(P.substring(S,r)),r++,r<P.length){const I=C;C=P.charCodeAt(r),(I===13&&C===10||I===10&&C===13)&&r++}S=r}else r++;return this.remaining=S<P.length?P.substr(S):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(ge[28],pe([0,1,55,101,277,9,16,11,29,32,74,24,2]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function c(U,z=h.UNLINK){if(S.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");return z===h.UNLINK?E(U):f(U)}async function f(U){try{const z=y.join(L.tmpdir(),C.generateUuid());try{await e.Promises.rename(U,z)}catch(O){return E(U)}E(z).catch(O=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function E(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function w(U){if(S.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(U,{recursive:!0})}e.rimrafSync=w;async function b(U,z){return g(await(z?u(U):k.promisify(p.readdir)(U)))}async function u(U){try{return await k.promisify(p.readdir)(U,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const z=[],O=await b(U);for(const W of O){let T=!1,F=!1,N=!1;try{const x=await e.Promises.lstat(y.join(U,W));T=x.isFile(),F=x.isDirectory(),N=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}z.push({name:W,isFile:()=>T,isDirectory:()=>F,isSymbolicLink:()=>N})}return z}function d(U){return g(p.readdirSync(U))}e.readdirSync=d;function g(U){return U.map(z=>typeof z=="string"?P.isMacintosh?r.normalizeNFC(z):z:(z.name=P.isMacintosh?r.normalizeNFC(z.name):z.name,z))}async function t(U){const z=await b(U),O=[];for(const W of z)await s.existsDirectory(y.join(U,W))&&O.push(W);return O}function i(U,z=1e3){return new Promise(O=>{let W=!1;const T=setInterval(()=>{W||(W=!0,p.access(U,F=>{W=!1,F&&(clearInterval(T),O(void 0))}))},z)})}e.whenDeleted=i;var s;(function(U){async function z(T){let F;try{if(F=await e.Promises.lstat(T),!F.isSymbolicLink())return{stat:F}}catch(N){}try{return{stat:await e.Promises.stat(T),symbolicLink:(F==null?void 0:F.isSymbolicLink())?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(P.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw x}throw N}}U.stat=z;async function O(T){try{const{stat:F,symbolicLink:N}=await U.stat(T);return F.isFile()&&(N==null?void 0:N.dangling)!==!0}catch(F){}return!1}U.existsFile=O;async function W(T){try{const{stat:F,symbolicLink:N}=await U.stat(T);return F.isDirectory()&&(N==null?void 0:N.dangling)!==!0}catch(F){}return!1}U.existsDirectory=W})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function o(U,z,O){return n.queueFor(l.URI.file(U),I.extUriBiasedIgnorePathCase).queue(()=>{const W=D(O);return new Promise((T,F)=>m(U,z,W,N=>N?F(N):T()))})}let v=!0;function m(U,z,O,W){if(!v)return p.writeFile(U,z,{mode:O.mode,flag:O.flag},W);p.open(U,O.flag,O.mode,(T,F)=>{if(T)return W(T);p.writeFile(F,z,N=>{if(N)return p.close(F,()=>W(N));p.fdatasync(F,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),v=!1),p.close(F,G=>W(G))))})})}function _(U,z,O){const W=D(O);if(!v)return p.writeFileSync(U,z,{mode:W.mode,flag:W.flag});const T=p.openSync(U,W.flag,W.mode);try{p.writeFileSync(T,z);try{p.fdatasyncSync(T)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),v=!1}}finally{p.closeSync(T)}}e.writeFileSync=_;function D(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function a(U,z){if(U===z)return;async function O(W){try{const T=await e.Promises.lstat(W);if(T.isDirectory()||T.isSymbolicLink())return;await e.Promises.utimes(W,T.atime,new Date)}catch(T){}}try{await e.Promises.rename(U,z),await O(z)}catch(W){if(U.toLowerCase()!==z.toLowerCase()&&W.code==="EXDEV"||U.endsWith("."))await R(U,z,{preserveSymlinks:!1}),await c(U,h.MOVE),await O(z);else throw W}}async function R(U,z,O){return $(U,z,{root:{source:U,target:z},options:O,handledSourcePaths:new Set})}const M=511;async function $(U,z,O){if(O.handledSourcePaths.has(U))return;O.handledSourcePaths.add(U);const{stat:W,symbolicLink:T}=await s.stat(U);if(T){if(O.options.preserveSymlinks)try{return await q(U,z,O)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(T.dangling)return}return W.isDirectory()?Y(U,z,W.mode&M,O):le(U,z,W.mode&M)}async function Y(U,z,O,W){await e.Promises.mkdir(z,{recursive:!0,mode:O});const T=await b(U);for(const F of T)await $(y.join(U,F),y.join(z,F),W)}async function le(U,z,O){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,O)}async function q(U,z,O){let W=await e.Promises.readlink(U);S.isEqualOrParent(W,O.root.source,!P.isLinux)&&(W=y.join(O.root.target,W.substr(O.root.source.length+1))),await e.Promises.symlink(W,z)}e.Promises=new class{get access(){return k.promisify(p.access)}get stat(){return k.promisify(p.stat)}get lstat(){return k.promisify(p.lstat)}get utimes(){return k.promisify(p.utimes)}get read(){return k.promisify(p.read)}get readFile(){return k.promisify(p.readFile)}get write(){return k.promisify(p.write)}get appendFile(){return k.promisify(p.appendFile)}get fdatasync(){return k.promisify(p.fdatasync)}get truncate(){return k.promisify(p.truncate)}get rename(){return k.promisify(p.rename)}get copyFile(){return k.promisify(p.copyFile)}get open(){return k.promisify(p.open)}get close(){return k.promisify(p.close)}get symlink(){return k.promisify(p.symlink)}get readlink(){return k.promisify(p.readlink)}get chmod(){return k.promisify(p.chmod)}get mkdir(){return k.promisify(p.mkdir)}get unlink(){return k.promisify(p.unlink)}get rmdir(){return k.promisify(p.rmdir)}get realpath(){return k.promisify(p.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch(z){return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return c}get move(){return a}get copy(){return R}}}),define(ge[102],pe([0,1,55,8,9,28]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(r){const I=k.dirname(r);if(r===I)return r;const l=(k.basename(r)||r).toLowerCase();try{const c=y.readdirSync(I).filter(f=>f.toLowerCase()===l);if(c.length===1){const f=A(I);if(f)return k.join(f,c[0])}else if(c.length>1){const f=c.indexOf(l);if(f>=0){const E=A(I);if(E)return k.join(E,c[f])}}}catch(h){}return null}e.realcaseSync=A;async function P(r){try{return await y.Promises.realpath(r)}catch(I){const l=C(r);return await y.Promises.access(l,p.constants.R_OK),l}}e.realpath=P;function S(r){try{return p.realpathSync(r)}catch(I){const l=C(r);return p.accessSync(l,p.constants.R_OK),l}}e.realpathSync=S;function C(r){return L.rtrim(k.normalize(r),k.sep)}});var je=this&&this.__decorate||function(X,e,p,L){var k=arguments.length,y=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,p,L);else for(var P=X.length-1;P>=0;P--)(A=X[P])&&(y=(k<3?A(y):k>3?A(e,p,y):A(e,p))||y);return k>3&&y&&Object.defineProperty(e,p,y),y};define(ge[103],pe([0,1,3,6,16,21,14,22,18,15,54,8,51]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function c(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function E(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(w||(w={}));class b{constructor(F){this.buffer=F,this.pos=0}read(F){const N=this.buffer.slice(this.pos,this.pos+F);return this.pos+=N.byteLength,N}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var d;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(d||(d={}));function g(T){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(T,0),F}function t(T){return T.read(4).readUInt32BE(0)}function i(T){const F=P.VSBuffer.alloc(1);return F.writeUInt8(T,0),F}const s={Undefined:i(d.Undefined),String:i(d.String),Buffer:i(d.Buffer),VSBuffer:i(d.VSBuffer),Array:i(d.Array),Object:i(d.Object)},n=typeof Buffer!="undefined";function o(T,F){if(typeof F=="undefined")T.write(s.Undefined);else if(typeof F=="string"){const N=P.VSBuffer.fromString(F);T.write(s.String),T.write(g(N.byteLength)),T.write(N)}else if(n&&Buffer.isBuffer(F)){const N=P.VSBuffer.wrap(F);T.write(s.Buffer),T.write(g(N.byteLength)),T.write(N)}else if(F instanceof P.VSBuffer)T.write(s.VSBuffer),T.write(g(F.byteLength)),T.write(F);else if(Array.isArray(F)){T.write(s.Array),T.write(g(F.length));for(const N of F)o(T,N)}else{const N=P.VSBuffer.fromString(JSON.stringify(F));T.write(s.Object),T.write(g(N.byteLength)),T.write(N)}}function v(T){switch(T.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return T.read(t(T)).toString();case d.Buffer:return T.read(t(T)).buffer;case d.VSBuffer:return T.read(t(T));case d.Array:{const N=t(T),x=[];for(let G=0;G<N;G++)x.push(v(T));return x}case d.Object:return JSON.parse(T.read(t(T)).toString())}}class m{constructor(F,N,x=null,G=1e3){this.protocol=F,this.ctx=N,this.logger=x,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(F,N){this.channels.set(F,N),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const N=this.send([F.type]);this.logger&&this.logger.logOutgoing(N,0,1,E(F.type));return}case 201:case 202:case 204:case 203:{const N=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(N,F.id,1,E(F.type),F.data);return}}}send(F,N=void 0){const x=new u;return o(x,F),o(x,N),this.sendBuffer(x.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(N){return 0}}onRawMessage(F){const N=new b(F),x=v(N),G=v(N),se=x[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${c(se)}: ${x[2]}.${x[3]}`,G),this.onPromise({type:se,id:x[1],channelName:x[2],name:x[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${c(se)}: ${x[2]}.${x[3]}`,G),this.onEventListen({type:se,id:x[1],channelName:x[2],name:x[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${c(se)}`),this.disposeActiveRequest({type:se,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],1,`${c(se)}`),this.disposeActiveRequest({type:se,id:x[1]})}}onPromise(F){const N=this.channels.get(F.channelName);if(!N){this.collectPendingRequest(F);return}const x=new y.CancellationTokenSource;let G;try{G=N.call(this.ctx,F.name,F.arg,x.token)}catch(Ie){G=Promise.reject(Ie)}const se=F.id;G.then(Ie=>{this.sendResponse({id:se,data:Ie,type:201}),this.activeRequests.delete(F.id)},Ie=>{Ie instanceof Error?this.sendResponse({id:se,data:{message:Ie.message,name:Ie.name,stack:Ie.stack?Ie.stack.split?Ie.stack.split(`
`):Ie.stack:void 0},type:202}):this.sendResponse({id:se,data:Ie,type:203}),this.activeRequests.delete(F.id)});const be=L.toDisposable(()=>x.cancel());this.activeRequests.set(F.id,be)}onEventListen(F){const N=this.channels.get(F.channelName);if(!N){this.collectPendingRequest(F);return}const x=F.id,se=N.listen(this.ctx,F.name,F.arg)(be=>this.sendResponse({id:x,data:be,type:204}));this.activeRequests.set(F.id,se)}disposeActiveRequest(F){const N=this.activeRequests.get(F.id);N&&(N.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let N=this.pendingRequests.get(F.channelName);N||(N=[],this.pendingRequests.set(F.channelName,N));const x=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:F,timeoutTimer:x})}flushPendingRequests(F){const N=this.pendingRequests.get(F);if(N){for(const x of N)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var _;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(F,N=null){this.protocol=F,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=N}getChannel(F){const N=this;return{call(x,G,se){return N.isDisposed?Promise.reject(A.canceled()):N.requestPromise(F,x,G,se)},listen(x,G){return N.isDisposed?Promise.reject(A.canceled()):N.requestEvent(F,x,G)}}}requestPromise(F,N,x,G=y.CancellationToken.None){const se=this.lastRequestId++,Ie={id:se,type:100,channelName:F,name:N,arg:x};if(G.isCancellationRequested)return Promise.reject(A.canceled());let Ce;return new Promise((qe,He)=>{if(G.isCancellationRequested)return He(A.canceled());const Ve=()=>{const oe=J=>{switch(J.type){case 201:this.handlers.delete(se),qe(J.data);break;case 202:this.handlers.delete(se);const ce=new Error(J.data.message);ce.stack=J.data.stack,ce.name=J.data.name,He(ce);break;case 203:this.handlers.delete(se),He(J.data);break}};this.handlers.set(se,oe),this.sendRequest(Ie)};let j=null;this.state===w.Idle?Ve():(j=k.createCancelablePromise(oe=>this.whenInitialized()),j.then(()=>{j=null,Ve()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:se,type:101}),He(A.canceled())},ne=G.onCancellationRequested(Z);Ce=L.combinedDisposable(L.toDisposable(Z),ne),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(F,N,x){const G=this.lastRequestId++,be={id:G,type:102,channelName:F,name:N,arg:x};let Ie=null;const Ce=new p.Emitter({onFirstListenerAdd:()=>{Ie=k.createCancelablePromise(qe=>this.whenInitialized()),Ie.then(()=>{Ie=null,this.activeRequests.add(Ce),this.sendRequest(be)})},onLastListenerRemove:()=>{Ie?(Ie.cancel(),Ie=null):(this.activeRequests.delete(Ce),this.sendRequest({id:G,type:103}))}}),Me=qe=>Ce.fire(qe.data);return this.handlers.set(G,Me),Ce.event}sendRequest(F){switch(F.type){case 100:case 102:{const N=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(N,F.id,0,`${c(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(N,F.id,0,c(F.type));return}}}send(F,N=void 0){const x=new u;return o(x,F),o(x,N),this.sendBuffer(x.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(N){return 0}}onBuffer(F){const N=new b(F),x=v(N),G=v(N),se=x[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,E(se)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,x[1],0,E(se),G),this.onResponse({type:x[0],id:x[1],data:G})}}onResponse(F){if(F.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const N=this.handlers.get(F.id);N&&N(F)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}je([l.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class a{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:N,onDidClientDisconnect:x})=>{p.Event.once(N.onMessage)(se=>{const be=new b(se),Ie=v(be),Ce=new m(N,Ie),Me=new D(N);this.channels.forEach((He,Ve)=>Ce.registerChannel(Ve,He));const qe={channelServer:Ce,channelClient:Me,ctx:Ie};this._connections.add(qe),this._onDidAddConnection.fire(qe),x(()=>{Ce.dispose(),Me.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const F=[];return this._connections.forEach(N=>F.push(N)),F}getChannel(F,N){const x=this;return{call(G,se,be){let Ie;if(C.isFunction(N)){let Me=S.getRandomElement(x.connections.filter(N));Ie=Me?Promise.resolve(Me):p.Event.toPromise(p.Event.filter(x.onDidAddConnection,N))}else Ie=N.routeCall(x,G,se);const Ce=Ie.then(Me=>Me.channelClient.getChannel(F));return M(Ce).call(G,se,be)},listen(G,se){if(C.isFunction(N))return x.getMulticastEvent(F,N,G,se);const be=N.routeEvent(x,G,se).then(Ie=>Ie.channelClient.getChannel(F));return M(be).listen(G,se)}}}getMulticastEvent(F,N,x,G){const se=this;let be=new L.DisposableStore;const Ie=new p.Emitter({onFirstListenerAdd:()=>{be=new L.DisposableStore;const Ce=new p.EventMultiplexer,Me=new Map,qe=Ve=>{const Z=Ve.channelClient.getChannel(F).listen(x,G),ne=Ce.add(Z);Me.set(Ve,ne)},He=Ve=>{const j=Me.get(Ve);!j||(j.dispose(),Me.delete(Ve))};se.connections.filter(N).forEach(qe),p.Event.filter(se.onDidAddConnection,N)(qe,void 0,be),se.onDidRemoveConnection(He,void 0,be),Ce.event(Ie.fire,Ie,be),be.add(Ce)},onLastListenerRemove:()=>{be.dispose()}});return Ie.event}registerChannel(F,N){this.channels.set(F,N),this._connections.forEach(x=>{x.channelServer.registerChannel(F,N)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=a;class R{constructor(F,N,x=null){const G=new u;o(G,N),F.send(G.buffer),this.channelClient=new D(F,x),this.channelServer=new m(F,N,x)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,N){this.channelServer.registerChannel(F,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function M(T){return{call(F,N,x){return T.then(G=>G.call(F,N,x))},listen(F,N){const x=new p.Relay;return T.then(G=>x.input=G.listen(F,N)),x.event}}}e.getDelayedChannel=M;function $(T){let F=!1;return{call(N,x,G){return F?T.call(N,x,G):k.timeout(0).then(()=>F=!0).then(()=>T.call(N,x,G))},listen(N,x){if(F)return T.listen(N,x);const G=new p.Relay;return k.timeout(0).then(()=>F=!0).then(()=>G.input=T.listen(N,x)),G.event}}}e.getNextTickChannel=$;class Y{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const N of F.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await p.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=Y;var le;(function(T){function F(G,se){const be=G,Ie=se&&se.disableMarshalling,Ce=new Map;for(const Me in be)x(Me)&&Ce.set(Me,p.Event.buffer(be[Me],!0));return new class{listen(Me,qe){const He=Ce.get(qe);if(He)return He;throw new Error(`Event not found: ${qe}`)}call(Me,qe,He){const Ve=be[qe];if(typeof Ve=="function"){if(!Ie&&Array.isArray(He))for(let j=0;j<He.length;j++)He[j]=r.revive(He[j]);return Ve.apply(be,He)}throw new Error(`Method not found: ${qe}`)}}}T.fromService=F;function N(G,se){const be=se&&se.disableMarshalling;return new Proxy({},{get(Ie,Ce){var Me;if(typeof Ce=="string")return((Me=se==null?void 0:se.properties)===null||Me===void 0?void 0:Me.has(Ce))?se.properties.get(Ce):x(Ce)?G.listen(Ce):async function(...qe){let He;se&&!C.isUndefinedOrNull(se.context)?He=[se.context,...qe]:He=qe;const Ve=await G.call(Ce,He);return be?Ve:r.revive(Ve)};throw new Error(`Property not found: ${String(Ce)}`)}})}T.toService=N;function x(G){return G[0]==="o"&&G[1]==="n"&&I.isUpperAsciiLetter(G.charCodeAt(2))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let F=T.toString();if(F!=="[object Object]")return F}return T}function z(T){return Array.isArray(T)?T.map(U):U(T)}function O(T,F,N,x,G,se,be){be=z(be);const Ie=q[G],Ce=Ie[x%Ie.length];let Me=[`%c[${T}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(se)?(Me=Me.concat(be),Me.push(")")):Me.push(be),console.log.apply(console,Me)}e.logWithColors=O;class W{constructor(F,N){this._outgoingPrefix=F,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,N,x,G,se){this._totalOutgoing+=F,O(this._outgoingPrefix,this._totalOutgoing,F,N,x,G,se)}logIncoming(F,N,x,G,se){this._totalIncoming+=F,O(this._incomingPrefix,this._totalIncoming,F,N,x,G,se)}}e.IPCLogger=W}),define(ge[104],pe([0,1,3,103,6,22,11,37]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function r(){return C||(C=y.VSBuffer.alloc(0)),C}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return r();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const D=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),D}if(this._chunks[0].byteLength>n){const D=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),D}let v=y.VSBuffer.alloc(n),m=0,_=0;for(;n>0;){const D=this._chunks[_];if(D.byteLength>n){const a=D.slice(0,n);v.set(a,m),m+=n,o&&(this._chunks[_]=D.slice(n),this._totalLength-=n),n-=n}else v.set(D,m),m+=D.byteLength,o?(this._chunks.shift(),this._totalLength-=D.byteLength):_++,n-=D.byteLength}return v}}e.ChunkStream=I;var l;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,o,v,m){this.type=n,this.id=o,this.ack=v,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends k.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const v=this._state.messageType,m=this._state.id,_=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(v,m,_,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=y.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const v=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,v}_bufferTake(){const n=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends k.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=w;class b extends L.IPCClient{constructor(n,o,v=null){super(n,o,v);this.protocol=n}static fromSocket(n,o){return new b(new w(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class d{constructor(n){this.data=n,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,v=this._first;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new d(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=o&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class i{constructor(n,o=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=k.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,r());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new c(4,0,0,r());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=k.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,v=n.length;o<v;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new c(6,0,0,r())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let v=0,m=o.length;v<m;v++)this._socketWriter.write(o[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new c(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(n){const o=new c(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,r());this._socketWriter.write(n)}}e.PersistentProtocol=i}),define(ge[105],pe([0,1,93]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(P){let S=p.toUint8(P);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(P){let S=new Uint8Array(256);for(let C=0;C<256;C++)S[C]=P;return S}set(P,S){let C=p.toUint8(S);P>=0&&P<256?this._asciiMap[P]=C:this._map.set(P,C)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class y{constructor(){this._actual=new L(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=y}),define(ge[138],pe([0,1,105]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends p.CharacterClassifier{constructor(P){super(0);for(let S=0,C=P.length;S<C;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function y(A){let P={};return S=>(P.hasOwnProperty(S)||(P[S]=A(S)),P[S])}e.getMapForWordSeparators=y(A=>new k(A))}),define(ge[44],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(k,y){this.lineNumber=k,this.column=y}with(k=this.lineNumber,y=this.column){return k===this.lineNumber&&y===this.column?this:new p(k,y)}delta(k=0,y=0){return this.with(this.lineNumber+k,this.column+y)}equals(k){return p.equals(this,k)}static equals(k,y){return!k&&!y?!0:!!k&&!!y&&k.lineNumber===y.lineNumber&&k.column===y.column}isBefore(k){return p.isBefore(this,k)}static isBefore(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<y.column}isBeforeOrEqual(k){return p.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<=y.column}static compare(k,y){let A=k.lineNumber|0,P=y.lineNumber|0;if(A===P){let S=k.column|0,C=y.column|0;return S-C}return A-P}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new p(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=p}),define(ge[41],pe([0,1,44]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(y,A,P,S){y>P||y===P&&A>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return L.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return L.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return L.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return L.plusRange(this,y)}static plusRange(y,A){let P,S,C,r;return A.startLineNumber<y.startLineNumber?(P=A.startLineNumber,S=A.startColumn):A.startLineNumber===y.startLineNumber?(P=A.startLineNumber,S=Math.min(A.startColumn,y.startColumn)):(P=y.startLineNumber,S=y.startColumn),A.endLineNumber>y.endLineNumber?(C=A.endLineNumber,r=A.endColumn):A.endLineNumber===y.endLineNumber?(C=A.endLineNumber,r=Math.max(A.endColumn,y.endColumn)):(C=y.endLineNumber,r=y.endColumn),new L(P,S,C,r)}intersectRanges(y){return L.intersectRanges(this,y)}static intersectRanges(y,A){let P=y.startLineNumber,S=y.startColumn,C=y.endLineNumber,r=y.endColumn,I=A.startLineNumber,l=A.startColumn,h=A.endLineNumber,c=A.endColumn;return P<I?(P=I,S=l):P===I&&(S=Math.max(S,l)),C>h?(C=h,r=c):C===h&&(r=Math.min(r,c)),P>C||P===C&&S>r?null:new L(P,S,C,r)}equalsRange(y){return L.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(y){return new p.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(y){return new p.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new L(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new L(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(y){return new L(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new L(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new L(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const C=y.startLineNumber|0,r=A.startLineNumber|0;if(C===r){const I=y.startColumn|0,l=A.startColumn|0;if(I===l){const h=y.endLineNumber|0,c=A.endLineNumber|0;if(h===c){const f=y.endColumn|0,E=A.endColumn|0;return f-E}return h-c}return I-l}return C-r}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=L}),define(ge[139],pe([0,1,44,41]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class y extends L.Range{constructor(P,S,C,r){super(P,S,C,r);this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return y.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,P,S):new y(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,S){return this.getDirection()===0?new y(P,S,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new y(P.lineNumber,P.column,S.lineNumber,S.column)}static liftSelection(P){return new y(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let C=0,r=P.length;C<r;C++)if(!this.selectionsEqual(P[C],S[C]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,C,r,I){return I===0?new y(P,S,C,r):new y(C,r,P,S)}}e.Selection=y}),define(ge[106],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(f){this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace)}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class S{constructor(f,E){this.range=f,this.matches=E}}e.FindMatch=S;var C;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(r=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(f,E,w,b,u,d){this.identifier=f,this.range=E,this.text=w,this.forceMoveMarkers=b,this.isAutoWhitespaceEdit=u,this._isTracked=d}}e.ValidAnnotatedEditOperation=l;class h{constructor(f,E,w){this.reverseEdits=f,this.changes=E,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=h}),define(ge[140],pe([0,1,8,138,44,41,106]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(u,d,g,t){this.searchString=u,this.isRegex=d,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let d=null;try{d=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let g=!this.isRegex&&!u;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new r(d,this.wordSeparators?L.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function C(b){if(!b||b.length===0)return!1;for(let u=0,d=b.length;u<d;u++)if(b.charCodeAt(u)===92){if(u++,u>=d)break;const t=b.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class r{constructor(u,d,g){this.regex=u,this.wordSeparators=d,this.simpleSearch=g}}e.SearchData=r;function I(b,u,d){if(!d)return new A.FindMatch(b,null);let g=[];for(let t=0,i=u.length;t<i;t++)g[t]=u[t];return new A.FindMatch(b,g)}e.createFindMatch=I;class l{constructor(u){let d=[],g=0;for(let t=0,i=u.length;t<i;t++)u.charCodeAt(t)===10&&(d[g++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(u){const d=this._lineFeedsOffsets;let g=0,t=d.length-1;if(t===-1||u<=d[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);d[i]>=u?t=i-1:d[i+1]>=u?(g=i,t=i):g=i+1}return g+1}}class h{static findMatches(u,d,g,t,i){const s=d.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,g,new w(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(u,g,s,t,i):[]}static _getMultilineMatchRange(u,d,g,t,i,s){let n,o=0;t?(o=t.findLineFeedCountBeforeOffset(i),n=d+i+o):n=d+i;let v;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-o;v=n+s.length+a}else v=n+s.length;const m=u.getPositionAt(n),_=u.getPositionAt(v);return new y.Range(m.lineNumber,m.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(u,d,g,t,i){const s=u.getOffsetAt(d.getStartPosition()),n=u.getValueInRange(d,1),o=u.getEOL()===`\r
`?new l(n):null,v=[];let m=0,_;for(g.reset(0);_=g.next(n);)if(v[m++]=I(this._getMultilineMatchRange(u,s,n,o,_.index,_[0]),_,t),m>=i)return v;return v}static _doFindMatchesLineByLine(u,d,g,t,i){const s=[];let n=0;if(d.startLineNumber===d.endLineNumber){const v=u.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return n=this._findMatchesInLine(g,v,d.startLineNumber,d.startColumn-1,n,s,t,i),s}const o=u.getLineContent(d.startLineNumber).substring(d.startColumn-1);n=this._findMatchesInLine(g,o,d.startLineNumber,d.startColumn-1,n,s,t,i);for(let v=d.startLineNumber+1;v<d.endLineNumber&&n<i;v++)n=this._findMatchesInLine(g,u.getLineContent(v),v,0,n,s,t,i);if(n<i){const v=u.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);n=this._findMatchesInLine(g,v,d.endLineNumber,0,n,s,t,i)}return s}static _findMatchesInLine(u,d,g,t,i,s,n,o){const v=u.wordSeparators;if(!n&&u.simpleSearch){const D=u.simpleSearch,a=D.length,R=d.length;let M=-a;for(;(M=d.indexOf(D,M+a))!==-1;)if((!v||E(v,d,R,M,a))&&(s[i++]=new A.FindMatch(new y.Range(g,M+1+t,g,M+1+a+t),null),i>=o))return i;return i}const m=new w(u.wordSeparators,u.regex);let _;m.reset(0);do if(_=m.next(d),_&&(s[i++]=I(new y.Range(g,_.index+1+t,g,_.index+1+_[0].length+t),_,n),i>=o))return i;while(_);return i}static findNextMatch(u,d,g,t){const i=d.parseSearchRequest();if(!i)return null;const s=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(u,g,s,t):this._doFindNextMatchLineByLine(u,g,s,t)}static _doFindNextMatchMultiline(u,d,g,t){const i=new k.Position(d.lineNumber,1),s=u.getOffsetAt(i),n=u.getLineCount(),o=u.getValueInRange(new y.Range(i.lineNumber,i.column,n,u.getLineMaxColumn(n)),1),v=u.getEOL()===`\r
`?new l(o):null;g.reset(d.column-1);let m=g.next(o);return m?I(this._getMultilineMatchRange(u,s,o,v,m.index,m[0]),m,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(u,new k.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(u,d,g,t){const i=u.getLineCount(),s=d.lineNumber,n=u.getLineContent(s),o=this._findFirstMatchInLine(g,n,s,d.column,t);if(o)return o;for(let v=1;v<=i;v++){const m=(s+v-1)%i,_=u.getLineContent(m+1),D=this._findFirstMatchInLine(g,_,m+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(u,d,g,t,i){u.reset(t-1);const s=u.next(d);return s?I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(u,d,g,t){const i=d.parseSearchRequest();if(!i)return null;const s=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(u,g,s,t):this._doFindPreviousMatchLineByLine(u,g,s,t)}static _doFindPreviousMatchMultiline(u,d,g,t){const i=this._doFindMatchesMultiline(u,new y.Range(1,1,d.lineNumber,d.column),g,t,10*P);if(i.length>0)return i[i.length-1];const s=u.getLineCount();return d.lineNumber!==s||d.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new k.Position(s,u.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(u,d,g,t){const i=u.getLineCount(),s=d.lineNumber,n=u.getLineContent(s).substring(0,d.column-1),o=this._findLastMatchInLine(g,n,s,t);if(o)return o;for(let v=1;v<=i;v++){const m=(i+s-v-1)%i,_=u.getLineContent(m+1),D=this._findLastMatchInLine(g,_,m+1,t);if(D)return D}return null}static _findLastMatchInLine(u,d,g,t){let i=null,s;for(u.reset(0);s=u.next(d);)i=I(new y.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=h;function c(b,u,d,g,t){if(g===0)return!0;const i=u.charCodeAt(g-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g);if(b.get(s)!==0)return!0}return!1}function f(b,u,d,g,t){if(g+t===d)return!0;const i=u.charCodeAt(g+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g+t-1);if(b.get(s)!==0)return!0}return!1}function E(b,u,d,g,t){return c(b,u,d,g,t)&&f(b,u,d,g,t)}e.isValidMatch=E;class w{constructor(u,d){this._wordSeparators=u,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const d=u.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(g=this._searchRegex.exec(u),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){p.getNextCodePoint(u,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||E(this._wordSeparators,u,d,t,i))return g}while(g);return null}}e.Searcher=w}),define(ge[107],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(P=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)P.indexOf(C)>=0||(S+="\\"+C);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=p();function L(P){let S=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)S=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),S=new RegExp(P.source,C)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function y(P,S,C,r,I=k){if(C.length>I.maxLen){let E=P-I.maxLen/2;return E<0?E=0:r+=E,C=C.substring(E,P+I.maxLen/2),y(P,S,C,r,I)}const l=Date.now(),h=P-1-r;let c=-1,f=null;for(let E=1;!(Date.now()-l>=I.timeBudget);E++){const w=h-I.windowSize*E;S.lastIndex=Math.max(0,w);const b=A(S,C,h,c);if(!b&&f||(f=b,w<=0))break;c=w}if(f){let E={word:f[0],startColumn:r+1+f.index,endColumn:r+1+f.index+f[0].length};return S.lastIndex=0,E}return null}e.getWordAtText=y;function A(P,S,C,r){let I;for(;I=P.exec(S);){const l=I.index||0;if(l<=C&&P.lastIndex>=C)return I;if(r>0&&l>r)return null}return null}}),define(ge[141],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class L{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let S=0,C=P.notIn.length;S<C;S++)switch(P.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)y(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),y(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),y(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),y(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&y(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function y(A,P,S){A.has(P)?A.get(P).push(S):A.set(P,[S])}}),define(ge[76],pe([0,1,30,9]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(y,A,P,S){if(Array.isArray(y)){let C=0;for(const r of y){const I=k(r,A,P,S);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof y=="string")return S?y==="*"?5:y===P?10:0:0;if(y){const{language:C,pattern:r,scheme:I,hasAccessToAllModels:l}=y;if(!S&&!l)return 0;let h=0;if(I)if(I===A.scheme)h=10;else if(I==="*")h=5;else return 0;if(C)if(C===P)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(r){let c;if(typeof r=="string"?c=r:c=Object.assign(Object.assign({},r),{base:L.normalize(r.base)}),c===A.fsPath||p.match(c,A.fsPath))h=10;else return 0}return h}else return 0}}e.score=k}),define(ge[142],pe([0,1,105]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(c,f,E){const w=new Uint8Array(c*f);for(let b=0,u=c*f;b<u;b++)w[b]=E;this._data=w,this.rows=c,this.cols=f}get(c,f){return this._data[c*this.cols+f]}set(c,f,E){this._data[c*this.cols+f]=E}}e.Uint8Matrix=k;class y{constructor(c){let f=0,E=0;for(let b=0,u=c.length;b<u;b++){let[d,g,t]=c[b];g>f&&(f=g),d>E&&(E=d),t>E&&(E=t)}f++,E++;let w=new k(E,f,0);for(let b=0,u=c.length;b<u;b++){let[d,g,t]=c[b];w.set(d,g,t)}this._states=w,this._maxCharCode=f}nextState(c,f){return f<0||f>=this._maxCharCode?0:this._states.get(c,f)}}e.StateMachine=y;let A=null;function P(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var S;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function r(){if(C===null){C=new p.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<h.length;f++)C.set(h.charCodeAt(f),1);const c=".,;";for(let f=0;f<c.length;f++)C.set(c.charCodeAt(f),2)}return C}class I{static _createLink(c,f,E,w,b){let u=b-1;do{const d=f.charCodeAt(u);if(c.get(d)!==2)break;u--}while(u>w);if(w>0){const d=f.charCodeAt(w-1),g=f.charCodeAt(u);(d===40&&g===41||d===91&&g===93||d===123&&g===125)&&u--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:u+2},url:f.substring(w,u+1)}}static computeLinks(c,f=P()){const E=r();let w=[];for(let b=1,u=c.getLineCount();b<=u;b++){const d=c.getLineContent(b),g=d.length;let t=0,i=0,s=0,n=1,o=!1,v=!1,m=!1,_=!1;for(;t<g;){let D=!1;const a=d.charCodeAt(t);if(n===13){let R;switch(a){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:m=!0,v=!0,R=0;break;case 93:m=!1,R=v?0:1;break;case 123:_=!0,R=0;break;case 125:R=_?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=m?0:1;break;default:R=E.get(a)}R===1&&(w.push(I._createLink(E,d,b,i,t)),D=!0)}else if(n===12){let R;a===91?(v=!0,R=0):R=E.get(a),R===1?D=!0:n=13}else n=f.nextState(n,a),n===0&&(D=!0);D&&(n=1,o=!1,v=!1,_=!1,i=t+1,s=a),t++}n===13&&w.push(I._createLink(E,d,b,i,g))}return w}}e.LinkComputer=I;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:I.computeLinks(h)}e.computeLinks=l}),define(ge[143],pe([0,1,3,6]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,P){return this._map.set(A,P),this.fire([A]),L.toDisposable(()=>{this._map.get(A)===P&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,P){let S=null,C=!1;return this._promises.set(A,P.then(r=>{this._promises.delete(A),!(C||!r)&&(S=this.register(A,r))})),L.toDisposable(()=>{C=!0,S&&S.dispose()})}getPromise(A){const P=this.get(A);if(P)return Promise.resolve(P);const S=this._promises.get(A);return S?S.then(C=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(ge[108],pe([0,1,22,11]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function y(I){for(let l=0,h=I.length;l<h;l+=4){const c=I[l+0],f=I[l+1],E=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=E,I[l+2]=f,I[l+3]=c}}function A(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||y(l),p.VSBuffer.wrap(l)}function P(I){const l=I.buffer;if(L.isLittleEndian()||y(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function S(I){const l=new Uint32Array(C(I));let h=0;if(l[h++]=I.id,I.type==="full")l[h++]=1,l[h++]=I.data.length,l.set(I.data,h),h+=I.data.length;else{l[h++]=2,l[h++]=I.deltas.length;for(const c of I.deltas)l[h++]=c.start,l[h++]=c.deleteCount,c.data?(l[h++]=c.data.length,l.set(c.data,h),h+=c.data.length):l[h++]=0}return A(l)}e.encodeSemanticTokensDto=S;function C(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const h of I.deltas)h.data&&(l+=h.data.length)}return l}function r(I){const l=P(I);let h=0;const c=l[h++];if(l[h++]===1){const b=l[h++],u=l.subarray(h,h+b);return h+=b,{id:c,type:"full",data:u}}const E=l[h++];let w=[];for(let b=0;b<E;b++){const u=l[h++],d=l[h++],g=l[h++];let t;g>0&&(t=l.subarray(h,h+g),h+=g),w[b]={start:u,deleteCount:d,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(ge[109],pe([0,1,93]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(A,P){this.index=A,this.remainder=P}}e.PrefixSumIndexOfResult=L;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,P){A=p.toUint32(A);const S=this.values,C=this.prefixSum,r=P.length;return r===0?!1:(this.values=new Uint32Array(S.length+r),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A),A+r),this.values.set(P,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,P){return A=p.toUint32(A),P=p.toUint32(P),this.values[A]===P?!1:(this.values[A]=P,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,P){A=p.toUint32(A),P=p.toUint32(P);const S=this.values,C=this.prefixSum;if(A>=S.length)return!1;let r=S.length-A;return P>=r&&(P=r),P===0?!1:(this.values=new Uint32Array(S.length-P),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A+P),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=p.toUint32(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),A>=this.values.length&&(A=this.values.length-1);for(let S=P;S<=A;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let P=0,S=this.values.length-1,C=0,r=0,I=0;for(;P<=S;)if(C=P+(S-P)/2|0,r=this.prefixSum[C],I=r-this.values[C],A<I)S=C-1;else if(A>=r)P=C+1;else break;return new L(C,A-I)}}e.PrefixSumComputer=k}),define(ge[144],pe([0,1,8,44,109]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(P,S,C,r){this._uri=P,this._lines=S,this._eol=C,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const S=P.changes;for(const C of S)this._acceptDeleteRange(C.range),this._acceptInsertText(new L.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,S=this._lines.length,C=new Uint32Array(S);for(let r=0;r<S;r++)C[r]=this._lines[r].length+P;this._lineStarts=new k.PrefixSumComputer(C)}}_setLineText(P,S){this._lines[P]=S,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,S){if(S.length===0)return;let C=p.splitLines(S);if(C.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+C[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}C[C.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+C[0]);let r=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(P.lineNumber+I-1,0,C[I]),r[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,r)}}e.MirrorTextModel=y}),define(ge[145],pe([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,y=k*24,A=y*7,P=y*30,S=y*365;function C(I,l){typeof I!="number"&&(I=I.getTime());const h=Math.round((new Date().getTime()-I)/1e3);if(h<-30)return p.localize(0,null,C(new Date().getTime()+h*1e3,!1));if(h<30)return p.localize(1,null);let c;return h<L?(c=h,l?c===1?p.localize(2,null,c):p.localize(3,null,c):c===1?p.localize(4,null,c):p.localize(5,null,c)):h<k?(c=Math.floor(h/L),l?c===1?p.localize(6,null,c):p.localize(7,null,c):c===1?p.localize(8,null,c):p.localize(9,null,c)):h<y?(c=Math.floor(h/k),l?c===1?p.localize(10,null,c):p.localize(11,null,c):c===1?p.localize(12,null,c):p.localize(13,null,c)):h<A?(c=Math.floor(h/y),l?c===1?p.localize(14,null,c):p.localize(15,null,c):c===1?p.localize(16,null,c):p.localize(17,null,c)):h<P?(c=Math.floor(h/A),l?c===1?p.localize(18,null,c):p.localize(19,null,c):c===1?p.localize(20,null,c):p.localize(21,null,c)):h<S?(c=Math.floor(h/P),l?c===1?p.localize(22,null,c):p.localize(23,null,c):c===1?p.localize(24,null,c):p.localize(25,null,c)):(c=Math.floor(h/S),l?c===1?p.localize(26,null,c):p.localize(27,null,c):c===1?p.localize(28,null,c):p.localize(29,null,c))}e.fromNow=C;function r(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(ge[147],pe([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ge[56],pe([0,1,147,15,18]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,r){return r&&(C.stack||C.stacktrace)?p.localize(0,null,P(C),A(C.stack)||A(C.stacktrace)):P(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?p.localize(1,null,C.message):C.message||p.localize(2,null)}function S(C=null,r=!1){if(!C)return p.localize(3,null);if(Array.isArray(C)){const I=k.coalesce(C),l=S(I[0],r);return I.length>1?p.localize(4,null,l,I.length):l}if(L.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return y(I.error,r);if(I.exception)return y(I.exception,r)}return C.stack?y(C,r):C.message?C.message:p.localize(5,null)}e.toErrorMessage=S}),define(ge[148],pe([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ge[110],pe([0,1,9,28,38,148,37,15,25,29,11,137,10]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(d,g){if(r.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};g&&(t.cwd=g);const i=k.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(s=>{i.once("error",n=>{s({success:!1,error:n})}),i.once("exit",(n,o)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?h(t.status):1})}else if(r.isLinux||r.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(i=>{k.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(s,n,o)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function f(d=A.env){return d.comspec||"cmd.exe"}e.getWindowsShell=f;class E{constructor(g,t,i,s){if(t!==void 0&&i!==void 0&&s!==void 0)this.cmd=g,this.args=t,this.shell=i,this.options=s;else{const n=g;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(A.env).forEach(o=>{n[o]=A.env[o]}),Object.keys(this.options.env).forEach(o=>{n[o]=this.options.env[o]}),this.options.env=n}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const t=g.lastIndexOf(p.sep);return t!==-1&&(g=g.substring(t+1)),E.WellKnowCommands[g]?g:"other"}start(g){return r.isWindows&&(this.options&&this.options.cwd&&C.isUNC(this.options.cwd)||!this.options&&C.isUNC(A.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let i,s;const n=new Promise((o,v)=>{i=o,s=v});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=k.exec(o,this.options,(v,m,_)=>{this.childProcess=null;const D=v;D&&D.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:_.toString()}):this.handleExec(i,g,v,m,_)})}else{let o=null;const v=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,g,s);const _={terminated:this.terminateRequested};P.isNumber(m)&&(_.cmdCode=m),i(_)};if(this.shell&&r.isWindows){const m=S.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let _=!1,D=!1;const a=[];let R=this.ensureQuotes(this.cmd);a.push(R.value),_=R.quoted,this.args&&this.args.forEach($=>{R=this.ensureQuotes($),a.push(R.value),D=D&&R.quoted});const M=["/s","/c"];_?D?M.push('"'+a.join(" ")+'"'):a.length>1?M.push('"'+a[0]+'" '+a.slice(1).join(" ")):M.push('"'+a[0]+'"'):M.push(a.join(" ")),o=k.spawn(f(),M,m)}else this.cmd&&(o=k.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(P.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",v),this.handleSpawn(o,i,g,s,!0)))}return n})}handleClose(g,t,i,s){}ensureQuotes(g){return E.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,c(g,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!r.isWindows)return g(!1);const t=k.spawn(f(),["/s","/c"]);t.on("error",i=>g(!0)),t.on("exit",i=>g(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class w extends E{constructor(g,t,i,s){super(g,t,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,t,i,s,n){[s,n].forEach((o,v)=>{const m=new I.LineDecoder;m.write(o).forEach(a=>{t({line:a,source:v===0?0:1})});const D=m.end();D&&t({line:D,source:v===0?0:1})}),g({terminated:this.terminateRequested,error:i})}handleSpawn(g,t,i,s,n){const o=new I.LineDecoder,v=new I.LineDecoder;g.stdout.on("data",m=>{o.write(m).forEach(D=>i({line:D,source:0}))}),g.stderr.on("data",m=>{v.write(m).forEach(D=>i({line:D,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=v}handleClose(g,t,i,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=w;function b(d){let g=[],t=!1;const i=function(s){if(t){g.push(s);return}(!d.send(s,o=>{if(o&&console.error(o),t=!1,g.length>0){const v=g.slice(0);g=[],v.forEach(m=>i(m))}})||r.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=b;var u;(function(d){async function g(t,i,s){if(p.isAbsolute(t))return t;if(i===void 0&&(i=A.cwd()),p.dirname(t)!=="."||(s===void 0&&P.isString(A.env.PATH)&&(s=A.env.PATH.split(p.delimiter)),s===void 0||s.length===0))return p.join(i,t);async function o(v){return await L.Promises.exists(v)?!(await L.Promises.stat(v)).isDirectory():!1}for(let v of s){let m;if(p.isAbsolute(v)?m=p.join(v,t):m=p.join(i,v,t),await o(m))return m;let _=m+".com";if(await o(_)||(_=m+".exe",await o(_)))return _}return p.join(i,t)}d.findExecutable=g})(u=e.win32||(e.win32={}))}),define(ge[149],pe([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,11,107]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=A;class P{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,ve){this._values[ie]=ve}}e.ValidatedEditorOptions=P;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class C{constructor(ie,ve,Fe,Ne){this.id=ie,this.name=ve,this.defaultValue=Fe,this.schema=Ne}compute(ie,ve,Fe){return Fe}}class r{constructor(ie,ve=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ie){return this.defaultValue}}class I{constructor(ie,ve,Fe,Ne){this.id=ie,this.name=ve,this.defaultValue=Fe,this.schema=Ne}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,ve,Fe){return Fe}}function l(K,ie){return typeof K=="undefined"?ie:K==="false"?!1:Boolean(K)}e.boolean=l;class h extends I{constructor(ie,ve,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Fe),super(ie,ve,Fe,Ne)}validate(ie){return l(ie,this.defaultValue)}}class c extends I{constructor(ie,ve,Fe,Ne,Qe,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Fe,De.minimum=Ne,De.maximum=Qe),super(ie,ve,Fe,De),this.minimum=Ne,this.maximum=Qe}static clampedInt(ie,ve,Fe,Ne){if(typeof ie=="undefined")return ve;let Qe=parseInt(ie,10);return isNaN(Qe)?ve:(Qe=Math.max(Fe,Qe),Qe=Math.min(Ne,Qe),Qe|0)}validate(ie){return c.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class f extends I{constructor(ie,ve,Fe,Ne,Qe){typeof Qe!="undefined"&&(Qe.type="number",Qe.default=Fe),super(ie,ve,Fe,Qe),this.validationFn=Ne}static clamp(ie,ve,Fe){return ie<ve?ve:ie>Fe?Fe:ie}static float(ie,ve){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return ve;const Fe=parseFloat(ie);return isNaN(Fe)?ve:Fe}validate(ie){return this.validationFn(f.float(ie,this.defaultValue))}}class E extends I{static string(ie,ve){return typeof ie!="string"?ve:ie}constructor(ie,ve,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Fe),super(ie,ve,Fe,Ne)}validate(ie){return E.string(ie,this.defaultValue)}}function w(K,ie,ve){return typeof K!="string"||ve.indexOf(K)===-1?ie:K}e.stringSet=w;class b extends I{constructor(ie,ve,Fe,Ne,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Fe),super(ie,ve,Fe,Qe),this._allowedValues=Ne}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class u extends C{constructor(ie,ve,Fe,Ne,Qe,De,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Qe,Se.default=Ne),super(ie,ve,Fe,Se),this._allowedValues=Qe,this._convert=De}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function d(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,ve,Fe){return Fe===0?ie.accessibilitySupport:Fe}}class t extends C{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(K){switch(K){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function v(K){switch(K){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends r{constructor(){super(125,[63,31])}compute(ie,ve,Fe){const Ne=["monaco-editor"];return ve.get(31)&&Ne.push(ve.get(31)),ie.extraEditorClassName&&Ne.push(ie.extraEditorClassName),ve.get(63)==="default"?Ne.push("mouse-default"):ve.get(63)==="copy"&&Ne.push("mouse-copy"),ve.get(98)&&Ne.push("showUnused"),ve.get(123)&&Ne.push("showDeprecated"),Ne.join(" ")}}class _ extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ie,ve,Fe){return Fe&&ie.emptySelectionClipboard}}class D extends C{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:p.localize(13,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:p.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?a.OFF:ie==="true"?a.ON:ie:Boolean(ie)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class R extends r{constructor(){super(40)}compute(ie,ve,Fe){return ie.fontInfo}}class M extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(ie){let ve=f.float(ie,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ve,6,100)}compute(ie,ve,Fe){return ie.fontInfo.fontSize}}class $ extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(c.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class Y extends C{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:p.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:p.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:p.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:p.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:p.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Fe,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Fe,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Fe,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Fe,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Fe,description:p.localize(35,null)}})}validate(ie){var ve,Fe,Ne,Qe,De;if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{multiple:w(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=Se.multipleDefinitions)!==null&&ve!==void 0?ve:w(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=Se.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:w(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ne=Se.multipleDeclarations)!==null&&Ne!==void 0?Ne:w(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Qe=Se.multipleImplementations)!==null&&Qe!==void 0?Qe:w(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(De=Se.multipleReferences)!==null&&De!==void 0?De:w(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends C{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:p.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:c.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var q;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class U extends r{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ie,ve,Fe){return U.computeLayout(ve,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const ve=ie.height/ie.lineHeight,Fe=ie.scrollBeyondLastLine?ve-1:0,Ne=(ie.viewLineCount+Fe)/(ie.pixelRatio*ie.height),Qe=Math.floor(ie.viewLineCount/Ne);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:Qe}}static _computeMinimapLayout(ie,ve){const Fe=ie.outerWidth,Ne=ie.outerHeight,Qe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const De=ve.stableMinimapLayoutInput,Se=De&&ie.outerHeight===De.outerHeight&&ie.lineHeight===De.lineHeight&&ie.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&ie.pixelRatio===De.pixelRatio&&ie.scrollBeyondLastLine===De.scrollBeyondLastLine&&ie.minimap.enabled===De.minimap.enabled&&ie.minimap.side===De.minimap.side&&ie.minimap.size===De.minimap.size&&ie.minimap.showSlider===De.minimap.showSlider&&ie.minimap.renderCharacters===De.minimap.renderCharacters&&ie.minimap.maxColumn===De.minimap.maxColumn&&ie.minimap.scale===De.minimap.scale&&ie.verticalScrollbarWidth===De.verticalScrollbarWidth&&ie.isViewportWrapping===De.isViewportWrapping,Pe=ie.lineHeight,ae=ie.typicalHalfwidthCharacterWidth,fe=ie.scrollBeyondLastLine,H=ie.minimap.renderCharacters;let ee=Qe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ue=ie.minimap.maxColumn,Ae=ie.minimap.size,Re=ie.minimap.side,Ue=ie.verticalScrollbarWidth,ze=ie.viewLineCount,Ze=ie.remainingWidth,Je=ie.isViewportWrapping,Xe=H?2:3;let nt=Math.floor(Qe*Ne);const gt=nt/Qe;let _e=!1,ye=!1,de=Xe*ee,Q=ee/Qe,xe=1;if(Ae==="fill"||Ae==="fit"){const{typicalViewportLineCount:wt,extraLinesBeyondLastLine:Et,desiredRatio:vt,minimapLineCount:xt}=U.computeContainedMinimapLineCount({viewLineCount:ze,scrollBeyondLastLine:fe,height:Ne,lineHeight:Pe,pixelRatio:Qe});if(ze/xt>1)_e=!0,ye=!0,ee=1,de=1,Q=ee/Qe;else{let ht=!1,ct=ee+1;if(Ae==="fit"){const dt=Math.ceil((ze+Et)*de);Je&&Se&&Ze<=ve.stableFitRemainingWidth?(ht=!0,ct=ve.stableFitMaxMinimapScale):ht=dt>nt}if(Ae==="fill"||ht){_e=!0;const dt=ee;de=Math.min(Pe*Qe,Math.max(1,Math.floor(1/vt))),Je&&Se&&Ze<=ve.stableFitRemainingWidth&&(ct=ve.stableFitMaxMinimapScale),ee=Math.min(ct,Math.max(1,Math.floor(de/Xe))),ee>dt&&(xe=Math.min(2,ee/dt)),Q=ee/Qe/xe,nt=Math.ceil(Math.max(wt,ze+Et)*de),Je?(ve.stableMinimapLayoutInput=ie,ve.stableFitRemainingWidth=Ze,ve.stableFitMaxMinimapScale=ee):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const we=Math.floor(ue*Q),Ye=Math.min(we,Math.max(0,Math.floor((Ze-Ue-2)*Q/(ae+Q)))+e.MINIMAP_GUTTER_WIDTH);let et=Math.floor(Qe*Ye);const rt=et/Qe;et=Math.floor(et*xe);const st=H?1:2,pt=Re==="left"?0:Fe-Ye-Ue;return{renderMinimap:st,minimapLeft:pt,minimapWidth:Ye,minimapHeightIsEditorHeight:_e,minimapIsSampling:ye,minimapScale:ee,minimapLineHeight:de,minimapCanvasInnerWidth:et,minimapCanvasInnerHeight:nt,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:gt}}static computeLayout(ie,ve){const Fe=ve.outerWidth|0,Ne=ve.outerHeight|0,Qe=ve.lineHeight|0,De=ve.lineNumbersDigitCount|0,Se=ve.typicalHalfwidthCharacterWidth,Pe=ve.maxDigitWidth,ae=ve.pixelRatio,fe=ve.viewLineCount,H=ie.get(120),ee=H==="inherit"?ie.get(119):H,ue=ee==="inherit"?ie.get(115):ee,Ae=ie.get(118),Re=ie.get(2),Ue=ve.isDominatedByLongLines,ze=ie.get(46),Ze=ie.get(57).renderType!==0,Je=ie.get(58),Xe=ie.get(92),nt=ie.get(62),gt=ie.get(90),_e=gt.verticalScrollbarSize,ye=gt.verticalHasArrows,de=gt.arrowSize,Q=gt.horizontalScrollbarSize,xe=ie.get(55),we=ie.get(35);let Ye;if(typeof xe=="string"&&/^\d+(\.\d+)?ch$/.test(xe)){const At=parseFloat(xe.substr(0,xe.length-2));Ye=c.clampedInt(At*Se,0,0,1e3)}else Ye=c.clampedInt(xe,0,0,1e3);we&&(Ye+=16);let et=0;if(Ze){const At=Math.max(De,Je);et=Math.round(At*Pe)}let rt=0;ze&&(rt=Qe);let st=0,pt=st+rt,wt=pt+et,Et=wt+Ye;const vt=Fe-rt-et-Ye;let xt=!1,_t=!1,ht=-1;Re!==2&&(ee==="inherit"&&Ue?(xt=!0,_t=!0):ue==="on"||ue==="bounded"?_t=!0:ue==="wordWrapColumn"&&(ht=Ae));const ct=U._computeMinimapLayout({outerWidth:Fe,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:Se,pixelRatio:ae,scrollBeyondLastLine:Xe,minimap:nt,verticalScrollbarWidth:_e,viewLineCount:fe,remainingWidth:vt,isViewportWrapping:_t},ve.memory||new S);ct.renderMinimap!==0&&ct.minimapLeft===0&&(st+=ct.minimapWidth,pt+=ct.minimapWidth,wt+=ct.minimapWidth,Et+=ct.minimapWidth);const dt=vt-ct.minimapWidth,Ht=Math.max(1,Math.floor((dt-_e-2)/Se)),kt=ye?de:0;return _t&&(ht=Math.max(1,Ht),ue==="bounded"&&(ht=Math.min(ht,Ae))),{width:Fe,height:Ne,glyphMarginLeft:st,glyphMarginWidth:rt,lineNumbersLeft:pt,lineNumbersWidth:et,decorationsLeft:wt,decorationsWidth:Ye,contentLeft:Et,contentWidth:dt,minimap:ct,viewportColumn:Ht,isWordWrapMinified:xt,isViewportWrapping:_t,wrappingColumn:ht,verticalScrollbarWidth:_e,horizontalScrollbarHeight:Q,overviewRuler:{top:kt,width:_e,height:Ne-2*kt,right:0}}}}e.EditorLayoutInfoComputer=U;class z extends C{constructor(){const ie={enabled:!0};super(54,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:p.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class O extends C{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:p.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class W extends f{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>f.clamp(ie,0,150),{markdownDescription:p.localize(43,null)})}compute(ie,ve,Fe){return ie.fontInfo.lineHeight}}class T extends C{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:ie.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:p.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ve.scale,1,1,3),maxColumn:c.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function F(K){return K==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class N extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{top:c.clampedInt(ve.top,0,0,1e3),bottom:c.clampedInt(ve.bottom,0,0,1e3)}}}class x extends C{constructor(){const ie={enabled:!0,cycle:!1};super(73,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:p.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class G extends r{constructor(){super(126)}compute(ie,ve,Fe){return ie.pixelRatio}}class se extends C{constructor(){const ie={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:p.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:p.localize(59,null)},other:{type:"boolean",default:ie.other,description:p.localize(60,null)}}}],default:ie,description:p.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const ve=ie,Fe={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var be;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(ie){let ve=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(ve=4,Fe=ie):ie==="interval"?ve=3:ie==="relative"?ve=2:ie==="on"?ve=1:ve=0),{renderType:ve,renderFn:Fe}}}function Ce(K){const ie=K.get(85);return ie==="editable"?K.get(78):ie!=="on"}e.filterValidationDecorations=Ce;class Me extends C{constructor(){const ie=[],ve={type:"number",description:p.localize(67,null)};super(89,"rulers",ie,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:ie,description:p.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let ve=[];for(let Fe of ie)if(typeof Fe=="number")ve.push({column:c.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Ne=Fe;ve.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Fe,Ne)=>Fe.column-Ne.column),ve}return this.defaultValue}}function qe(K,ie){if(typeof K!="string")return ie;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie,Fe=c.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(ve.vertical,this.defaultValue.vertical),horizontal:qe(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:c.clampedInt(ve.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class Ve extends C{constructor(){const ie={enabled:!1};super(52,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:p.localize(70,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class j extends C{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(71,null),p.localize(72,null)],default:ie.insertMode,description:p.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:p.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:p.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:p.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:p.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:p.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:p.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:p.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:p.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const ve=ie;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(113,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends r{constructor(){super(127,[78])}compute(ie,ve,Fe){return ve.get(78)?!0:ie.tabFocusMode}}var oe;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function J(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ce extends r{constructor(){super(129,[128])}compute(ie,ve,Fe){const Ne=ve.get(128);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const me="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Le:L.isLinux?We:me,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(K){return e.editorOptionsRegistry[K.id]=K,K}var Ke;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.inlineSuggest=52]="inlineSuggest",K[K.letterSpacing=53]="letterSpacing",K[K.lightbulb=54]="lightbulb",K[K.lineDecorationsWidth=55]="lineDecorationsWidth",K[K.lineHeight=56]="lineHeight",K[K.lineNumbers=57]="lineNumbers",K[K.lineNumbersMinChars=58]="lineNumbersMinChars",K[K.linkedEditing=59]="linkedEditing",K[K.links=60]="links",K[K.matchBrackets=61]="matchBrackets",K[K.minimap=62]="minimap",K[K.mouseStyle=63]="mouseStyle",K[K.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=65]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",K[K.multiCursorModifier=67]="multiCursorModifier",K[K.multiCursorPaste=68]="multiCursorPaste",K[K.occurrencesHighlight=69]="occurrencesHighlight",K[K.overviewRulerBorder=70]="overviewRulerBorder",K[K.overviewRulerLanes=71]="overviewRulerLanes",K[K.padding=72]="padding",K[K.parameterHints=73]="parameterHints",K[K.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",K[K.quickSuggestions=76]="quickSuggestions",K[K.quickSuggestionsDelay=77]="quickSuggestionsDelay",K[K.readOnly=78]="readOnly",K[K.renameOnType=79]="renameOnType",K[K.renderControlCharacters=80]="renderControlCharacters",K[K.renderIndentGuides=81]="renderIndentGuides",K[K.renderFinalNewline=82]="renderFinalNewline",K[K.renderLineHighlight=83]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=85]="renderValidationDecorations",K[K.renderWhitespace=86]="renderWhitespace",K[K.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",K[K.roundedSelection=88]="roundedSelection",K[K.rulers=89]="rulers",K[K.scrollbar=90]="scrollbar",K[K.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=92]="scrollBeyondLastLine",K[K.scrollPredominantAxis=93]="scrollPredominantAxis",K[K.selectionClipboard=94]="selectionClipboard",K[K.selectionHighlight=95]="selectionHighlight",K[K.selectOnLineNumbers=96]="selectOnLineNumbers",K[K.showFoldingControls=97]="showFoldingControls",K[K.showUnused=98]="showUnused",K[K.snippetSuggestions=99]="snippetSuggestions",K[K.smartSelect=100]="smartSelect",K[K.smoothScrolling=101]="smoothScrolling",K[K.stickyTabStops=102]="stickyTabStops",K[K.stopRenderingLineAfter=103]="stopRenderingLineAfter",K[K.suggest=104]="suggest",K[K.suggestFontSize=105]="suggestFontSize",K[K.suggestLineHeight=106]="suggestLineHeight",K[K.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",K[K.suggestSelection=108]="suggestSelection",K[K.tabCompletion=109]="tabCompletion",K[K.tabIndex=110]="tabIndex",K[K.unusualLineTerminators=111]="unusualLineTerminators",K[K.useShadowDOM=112]="useShadowDOM",K[K.useTabStops=113]="useTabStops",K[K.wordSeparators=114]="wordSeparators",K[K.wordWrap=115]="wordWrap",K[K.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=118]="wordWrapColumn",K[K.wordWrapOverride1=119]="wordWrapOverride1",K[K.wordWrapOverride2=120]="wordWrapOverride2",K[K.wrappingIndent=121]="wrappingIndent",K[K.wrappingStrategy=122]="wrappingStrategy",K[K.showDeprecated=123]="showDeprecated",K[K.inlayHints=124]="inlayHints",K[K.editorClassName=125]="editorClassName",K[K.pixelRatio=126]="pixelRatio",K[K.tabFocusMode=127]="tabFocusMode",K[K.layoutInfo=128]="layoutInfo",K[K.wrappingInfo=129]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(114,null)})),acceptSuggestionOnEnter:Ee(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(115,null),""],markdownDescription:p.localize(116,null)})),accessibilitySupport:Ee(new g),accessibilityPageSize:Ee(new c(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(117,null)})),ariaLabel:Ee(new E(4,"ariaLabel",p.localize(118,null))),autoClosingBrackets:Ee(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(119,null),p.localize(120,null),""],description:p.localize(121,null)})),autoClosingDelete:Ee(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(122,null),""],description:p.localize(123,null)})),autoClosingOvertype:Ee(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(124,null),""],description:p.localize(125,null)})),autoClosingQuotes:Ee(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(126,null),p.localize(127,null),""],description:p.localize(128,null)})),autoIndent:Ee(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[p.localize(129,null),p.localize(130,null),p.localize(131,null),p.localize(132,null),p.localize(133,null)],description:p.localize(134,null)})),automaticLayout:Ee(new h(10,"automaticLayout",!1)),autoSurround:Ee(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null),""],description:p.localize(138,null)})),stickyTabStops:Ee(new h(102,"stickyTabStops",!1,{description:p.localize(139,null)})),codeLens:Ee(new h(12,"codeLens",!0,{description:p.localize(140,null)})),codeLensFontFamily:Ee(new E(13,"codeLensFontFamily","",{description:p.localize(141,null)})),codeLensFontSize:Ee(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(142,null)})),colorDecorators:Ee(new h(15,"colorDecorators",!0,{description:p.localize(143,null)})),columnSelection:Ee(new h(16,"columnSelection",!1,{description:p.localize(144,null)})),comments:Ee(new t),contextmenu:Ee(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new h(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(145,null)})),cursorBlinking:Ee(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:p.localize(146,null)})),cursorSmoothCaretAnimation:Ee(new h(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(147,null)})),cursorStyle:Ee(new u(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:p.localize(148,null)})),cursorSurroundingLines:Ee(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(149,null)})),cursorSurroundingLinesStyle:Ee(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(150,null),p.localize(151,null)],description:p.localize(152,null)})),cursorWidth:Ee(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(153,null)})),disableLayerHinting:Ee(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new h(28,"domReadOnly",!1)),dragAndDrop:Ee(new h(29,"dragAndDrop",!0,{description:p.localize(154,null)})),emptySelectionClipboard:Ee(new _),extraEditorClassName:Ee(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new f(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:p.localize(155,null)})),find:Ee(new D),fixedOverflowWidgets:Ee(new h(34,"fixedOverflowWidgets",!1)),folding:Ee(new h(35,"folding",!0,{description:p.localize(156,null)})),foldingStrategy:Ee(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(157,null),p.localize(158,null)],description:p.localize(159,null)})),foldingHighlight:Ee(new h(37,"foldingHighlight",!0,{description:p.localize(160,null)})),unfoldOnClickAfterEndOfLine:Ee(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(161,null)})),fontFamily:Ee(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(162,null)})),fontInfo:Ee(new R),fontLigatures2:Ee(new a),fontSize:Ee(new M),fontWeight:Ee(new $),formatOnPaste:Ee(new h(44,"formatOnPaste",!1,{description:p.localize(163,null)})),formatOnType:Ee(new h(45,"formatOnType",!1,{description:p.localize(164,null)})),glyphMargin:Ee(new h(46,"glyphMargin",!0,{description:p.localize(165,null)})),gotoLocation:Ee(new Y),hideCursorInOverviewRuler:Ee(new h(48,"hideCursorInOverviewRuler",!1,{description:p.localize(166,null)})),highlightActiveIndentGuide:Ee(new h(49,"highlightActiveIndentGuide",!0,{description:p.localize(167,null)})),hover:Ee(new le),inDiffEditor:Ee(new h(51,"inDiffEditor",!1)),letterSpacing:Ee(new f(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>f.clamp(K,-5,20),{description:p.localize(168,null)})),lightbulb:Ee(new z),lineDecorationsWidth:Ee(new I(55,"lineDecorationsWidth",10)),lineHeight:Ee(new W),lineNumbers:Ee(new Ie),lineNumbersMinChars:Ee(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new h(59,"linkedEditing",!1,{description:p.localize(169,null)})),links:Ee(new h(60,"links",!0,{description:p.localize(170,null)})),matchBrackets:Ee(new b(61,"matchBrackets","always",["always","near","never"],{description:p.localize(171,null)})),minimap:Ee(new T),mouseStyle:Ee(new b(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new f(64,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:p.localize(172,null)})),mouseWheelZoom:Ee(new h(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(173,null)})),multiCursorMergeOverlapping:Ee(new h(66,"multiCursorMergeOverlapping",!0,{description:p.localize(174,null)})),multiCursorModifier:Ee(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],F,{markdownEnumDescriptions:[p.localize(175,null),p.localize(176,null)],markdownDescription:p.localize(177,null)})),multiCursorPaste:Ee(new b(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(178,null),p.localize(179,null)],markdownDescription:p.localize(180,null)})),occurrencesHighlight:Ee(new h(69,"occurrencesHighlight",!0,{description:p.localize(181,null)})),overviewRulerBorder:Ee(new h(70,"overviewRulerBorder",!0,{description:p.localize(182,null)})),overviewRulerLanes:Ee(new c(71,"overviewRulerLanes",3,0,3)),padding:Ee(new N),parameterHints:Ee(new x),peekWidgetDefaultFocus:Ee(new b(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(183,null),p.localize(184,null)],description:p.localize(185,null)})),definitionLinkOpensInPeek:Ee(new h(75,"definitionLinkOpensInPeek",!1,{description:p.localize(186,null)})),quickSuggestions:Ee(new se),quickSuggestionsDelay:Ee(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(187,null)})),readOnly:Ee(new h(78,"readOnly",!1)),renameOnType:Ee(new h(79,"renameOnType",!1,{description:p.localize(188,null),markdownDeprecationMessage:p.localize(189,null)})),renderControlCharacters:Ee(new h(80,"renderControlCharacters",!1,{description:p.localize(190,null)})),renderIndentGuides:Ee(new h(81,"renderIndentGuides",!0,{description:p.localize(191,null)})),renderFinalNewline:Ee(new h(82,"renderFinalNewline",!0,{description:p.localize(192,null)})),renderLineHighlight:Ee(new b(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(193,null)],description:p.localize(194,null)})),renderLineHighlightOnlyWhenFocus:Ee(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(195,null)})),renderValidationDecorations:Ee(new b(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new b(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(196,null),p.localize(197,null),p.localize(198,null),""],description:p.localize(199,null)})),revealHorizontalRightPadding:Ee(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new h(88,"roundedSelection",!0,{description:p.localize(200,null)})),rulers:Ee(new Me),scrollbar:Ee(new He),scrollBeyondLastColumn:Ee(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(201,null)})),scrollBeyondLastLine:Ee(new h(92,"scrollBeyondLastLine",!0,{description:p.localize(202,null)})),scrollPredominantAxis:Ee(new h(93,"scrollPredominantAxis",!0,{description:p.localize(203,null)})),selectionClipboard:Ee(new h(94,"selectionClipboard",!0,{description:p.localize(204,null),included:L.isLinux})),selectionHighlight:Ee(new h(95,"selectionHighlight",!0,{description:p.localize(205,null)})),selectOnLineNumbers:Ee(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new b(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(206,null),p.localize(207,null)],description:p.localize(208,null)})),showUnused:Ee(new h(98,"showUnused",!0,{description:p.localize(209,null)})),showDeprecated:Ee(new h(123,"showDeprecated",!0,{description:p.localize(210,null)})),inlayHints:Ee(new O),snippetSuggestions:Ee(new b(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(211,null),p.localize(212,null),p.localize(213,null),p.localize(214,null)],description:p.localize(215,null)})),smartSelect:Ee(new Z),smoothScrolling:Ee(new h(101,"smoothScrolling",!1,{description:p.localize(216,null)})),stopRenderingLineAfter:Ee(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new j),inlineSuggest:Ee(new Ve),suggestFontSize:Ee(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(217,null)})),suggestLineHeight:Ee(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(218,null)})),suggestOnTriggerCharacters:Ee(new h(107,"suggestOnTriggerCharacters",!0,{description:p.localize(219,null)})),suggestSelection:Ee(new b(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(220,null),p.localize(221,null),p.localize(222,null)],description:p.localize(223,null)})),tabCompletion:Ee(new b(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(224,null),p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),tabIndex:Ee(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new b(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(228,null),p.localize(229,null),p.localize(230,null)],description:p.localize(231,null)})),useShadowDOM:Ee(new h(112,"useShadowDOM",!0)),useTabStops:Ee(new h(113,"useTabStops",!0,{description:p.localize(232,null)})),wordSeparators:Ee(new E(114,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:p.localize(233,null)})),wordWrap:Ee(new b(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),wordWrapBreakAfterCharacters:Ee(new E(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new E(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(239,null)})),wordWrapOverride1:Ee(new b(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new b(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],J,{enumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null),p.localize(243,null)],description:p.localize(244,null)})),wrappingStrategy:Ee(new b(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(245,null),p.localize(246,null)],description:p.localize(247,null)})),editorClassName:Ee(new m),pixelRatio:Ee(new G),tabFocusMode:Ee(new ne),layoutInfo:Ee(new U),wrappingInfo:Ee(new ce)}}),define(ge[151],pe([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[155],pe([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ge[156],pe([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[167],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[168],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[169],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[170],pe([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[171],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var p;(function(A){A[A.ACTIVATE=0]="ACTIVATE",A[A.RESTORE=1]="RESTORE",A[A.PRESERVE=2]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var L;(function(A){A[A.PICK=1]="PICK",A[A.DISABLED=2]="DISABLED"})(L=e.EditorOverride||(e.EditorOverride={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[172],pe([0,1,153]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||L.test(l)}e.isValidVersionStr=y;function A(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=A;function P(l){if(!l)return null;let h=l.majorBase,c=l.majorMustEqual,f=l.minorBase,E=l.minorMustEqual,w=l.patchBase,b=l.patchMustEqual;l.hasCaret&&(h===0||(E=!1),b=!1);let u=0;if(l.preRelease){const d=k.exec(l.preRelease);if(d){const[,g,t,i]=d;u=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:h,majorMustEqual:c,minorBase:f,minorMustEqual:E,patchBase:w,patchMustEqual:b,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=P;function S(l,h,c){let f;typeof l=="string"?f=P(A(l)):f=l;let E;h instanceof Date?E=h.getTime():typeof h=="string"&&(E=new Date(h).getTime());let w;if(typeof c=="string"?w=P(A(c)):w=c,!f||!w)return!1;let b=f.majorBase,u=f.minorBase,d=f.patchBase,g=w.majorBase,t=w.minorBase,i=w.patchBase,s=w.notBefore,n=w.majorMustEqual,o=w.minorMustEqual,v=w.patchMustEqual;return w.isMinimum?b>g?!0:b<g?!1:u>t?!0:u<t||E&&E<s?!1:d>=i:(b===1&&g===0&&(!n||!o||!v)&&(g=1,t=0,i=0,n=!0,o=!1,v=!1),b<g?!1:b>g?!n:u<t?!1:u>t?!o:d<i?!1:d>i?!v:!(E&&E<s))}e.isValidVersion=S;function C(l,h,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:I(l,h,c.engines.vscode,f)}e.isValidExtensionVersion=C;function r(l,h,c){return l==="*"||I(h,c,l)}e.isEngineValid=r;function I(l,h,c,f=[]){let E=P(A(c));if(!E)return f.push(p.localize(0,null,c)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return f.push(p.localize(1,null,c)),!1}else if(!E.majorMustEqual)return f.push(p.localize(2,null,c)),!1;return S(l,h,E)?!0:(f.push(p.localize(3,null,l,c)),!1)}}),define(ge[111],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(y,A=[],P=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p;const L=(k,...y)=>new p(k,y);e.createSyncDescriptor=L}),define(ge[77],pe([0,1,111]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(A,P,S){P instanceof p.SyncDescriptor||(P=new p.SyncDescriptor(P,[],S)),L.push([A,P])}e.registerSingleton=k;function y(){return L}e.getSingletonServiceDescriptors=y}),define(ge[173],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=p;class L{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const P=this.lookupOrInsertNode(y),S=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(y),P)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let P=this._nodes.get(A);return P||(P=new p(y),this._nodes.set(A,P)),P}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,P]of this._nodes)y.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const P=new Set([y]),S=this._findCycle(A,P);if(S)return S}}_findCycle(y,A){for(let[P,S]of y.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const C=this._findCycle(S,A);if(C)return C;A.delete(P)}}}e.Graph=L}),define(ge[4],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function S(C){return C[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(P,S,C,r){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:P,index:C,optional:r}):(S[p.DI_DEPENDENCIES]=[{id:P,index:C,optional:r}],S[p.DI_TARGET]=S)}function k(P){if(p.serviceIds.has(P))return p.serviceIds.get(P);const S=function(C,r,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,C,I,!1)};return S.toString=()=>P,p.serviceIds.set(P,S),S}e.createDecorator=k;function y(P){return P}e.refineServiceDecorator=y;function A(P){return function(S,C,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,S,r,!0)}}e.optional=A}),define(ge[174],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=p.createDecorator("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(ge[175],pe([0,1,3,73,6,23,72,76,174]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(h,c){let f={selector:h,provider:c,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),k.toDisposable(()=>{if(f){let E=this._entries.indexOf(f);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const c=[];for(let f of this._entries)f._score>0&&c.push(f.provider);return c}ordered(h){const c=[];return this._orderedForEach(h,f=>c.push(f.provider)),c}orderedGroups(h){const c=[];let f,E;return this._orderedForEach(h,w=>{f&&E===w._score?f.push(w.provider):(E=w._score,f=[w.provider],c.push(f))}),c}_orderedForEach(h,c){if(!!h){this._updateScores(h);for(const f of this._entries)f._score>0&&c(f)}}_updateScores(h){let c={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let f of this._entries)if(f._score=P.score(f.selector,h.uri,h.getLanguageIdentifier().language,S.shouldSynchronizeModel(h)),C(f.selector)&&f._score>0){for(let E of this._entries)E._score=0;f._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(h,c){return h._score<c._score?1:h._score>c._score?-1:h._time<c._time?1:h._time>c._time?-1:0}}e.LanguageFeatureRegistry=r;class I{constructor(h,c,f=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=c,this.max=f,this._cache=new y.LRUCache(50,.7)}_key(h){return h.id+L.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const c=this._key(h),f=this._cache.get(c);return this._clamp(f==null?void 0:f.value)}update(h,c){const f=this._key(h);let E=this._cache.get(f);return E||(E=new A.MovingAverage,this._cache.set(f,E)),E.update(c),this.get(h)}}e.LanguageFeatureRequestDelays=I}),define(ge[78],pe([0,1,2,41,175,143,91]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class S{constructor(R,M){this.language=R,this.id=M}}e.LanguageIdentifier=S;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var r;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(R){return(R&255)>>>0}static getTokenType(R){return(R&1792)>>>8}static getFontStyle(R){return(R&14336)>>>11}static getForeground(R){return(R&8372224)>>>14}static getBackground(R){return(R&4286578688)>>>23}static getClassNameFromMetadata(R){let M=this.getForeground(R),$="mtk"+M,Y=this.getFontStyle(R);return Y&1&&($+=" mtki"),Y&2&&($+=" mtkb"),Y&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(R,M){const $=this.getForeground(R),Y=this.getFontStyle(R);let le=`color: ${M[$]};`;return Y&1&&(le+="font-style: italic;"),Y&2&&(le+="font-weight: bold;"),Y&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=h;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(R){const M=a[R];let $=M&&A.iconRegistry.get(M);return $||(console.info("No codicon found for CompletionItemKind "+R),$=A.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(R,M){let $=a[R];return typeof $=="undefined"&&!M&&($=9),$}}();var f;(function(a){a[a.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&p.URI.isUri(a.uri)&&L.Range.isIRange(a.range)&&(L.Range.isIRange(a.originSelectionRange)||L.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const R=new Map;R.set("file",0),R.set("module",1),R.set("namespace",2),R.set("package",3),R.set("class",4),R.set("method",5),R.set("property",6),R.set("field",7),R.set("constructor",8),R.set("enum",9),R.set("interface",10),R.set("function",11),R.set("variable",12),R.set("constant",13),R.set("string",14),R.set("number",15),R.set("boolean",16),R.set("array",17),R.set("object",18),R.set("key",19),R.set("null",20),R.set("enum-member",21),R.set("struct",22),R.set("event",23),R.set("operator",24),R.set("type-parameter",25);const M=new Map;M.set(0,"file"),M.set(1,"module"),M.set(2,"namespace"),M.set(3,"package"),M.set(4,"class"),M.set(5,"method"),M.set(6,"property"),M.set(7,"field"),M.set(8,"constructor"),M.set(9,"enum"),M.set(10,"interface"),M.set(11,"function"),M.set(12,"variable"),M.set(13,"constant"),M.set(14,"string"),M.set(15,"number"),M.set(16,"boolean"),M.set(17,"array"),M.set(18,"object"),M.set(19,"key"),M.set(20,"null"),M.set(21,"enum-member"),M.set(22,"struct"),M.set(23,"event"),M.set(24,"operator"),M.set(25,"type-parameter");function $(q){return R.get(q)}a.fromString=$;function Y(q){return M.get(q)}a.toString=Y;function le(q,U){const z=M.get(q);let O=z&&A.iconRegistry.get("symbol-"+z);return O||(console.info("No codicon found for SymbolKind "+q),O=A.Codicon.symbolProperty),`${U?"inline":"block"} ${O.classNames}`}a.toCssClassName=le})(n=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(R){this.value=R}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var v;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var _;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var D;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[112],pe([0,1,8,4,11]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=k.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(D){D[D.False=0]="False",D[D.True=1]="True",D[D.Defined=2]="Defined",D[D.Not=3]="Not",D[D.Equals=4]="Equals",D[D.NotEquals=5]="NotEquals",D[D.And=6]="And",D[D.Regex=7]="Regex",D[D.NotRegex=8]="NotRegex",D[D.Or=9]="Or",D[D.In=10]="In",D[D.NotIn=11]="NotIn",D[D.Greater=12]="Greater",D[D.GreaterEquals=13]="GreaterEquals",D[D.Smaller=14]="Smaller",D[D.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(a){return h.create(a)}static equals(a,R){return c.create(a,R)}static notEquals(a,R){return w.create(a,R)}static regex(a,R){return i.create(a,R)}static in(a,R){return f.create(a,R)}static not(a){return b.create(a)}static and(...a){return n.create(a)}static or(...a){return o.create(a)}static greater(a,R){return u.create(a,R)}static less(a,R){return g.create(a,R)}static deserialize(a,R=!1){if(!!a)return this._deserializeOrExpression(a,R)}static _deserializeOrExpression(a,R){let M=a.split("||");return o.create(M.map($=>this._deserializeAndExpression($,R)))}static _deserializeAndExpression(a,R){let M=a.split("&&");return n.create(M.map($=>this._deserializeOne($,R)))}static _deserializeOne(a,R){if(a=a.trim(),a.indexOf("!=")>=0){let M=a.split("!=");return w.create(M[0].trim(),this._deserializeValue(M[1],R))}if(a.indexOf("==")>=0){let M=a.split("==");return c.create(M[0].trim(),this._deserializeValue(M[1],R))}if(a.indexOf("=~")>=0){let M=a.split("=~");return i.create(M[0].trim(),this._deserializeRegexValue(M[1],R))}if(a.indexOf(" in ")>=0){let M=a.split(" in ");return f.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const M=a.split(">=");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const M=a.split(">");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const M=a.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const M=a.split("<");return g.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(a)?b.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,R){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let M=/^'([^']*)'$/.exec(a);return M?M[1].trim():a}static _deserializeRegexValue(a,R){if(p.isFalsyOrWhitespace(a)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=a.indexOf("/"),$=a.lastIndexOf("/");if(M===$||M<0){if(R)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let Y=a.slice(M+1,$),le=a[$+1]==="i"?"i":"";try{return new RegExp(Y,le)}catch(q){if(R)throw new Error(`bad regexp-value '${a}', parse error: ${q}`);return console.warn(`bad regexp-value '${a}', parse error: ${q}`),null}}}e.ContextKeyExpr=C;function r(D,a){return D.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(a){this.key=a,this.type=2}static create(a){const R=A.get(a);return typeof R=="boolean"?R?l.INSTANCE:I.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=h;class c{constructor(a,R){this.key=a,this.value=R,this.type=4}static create(a,R){if(typeof R=="boolean")return R?h.create(a):b.create(a);const M=A.get(a);return typeof M=="boolean"?R===(M?"true":"false")?l.INSTANCE:I.INSTANCE:new c(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class f{constructor(a,R){this.key=a,this.valueKey=R,this.type=10}static create(a,R){return new f(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const R=a.getValue(this.valueKey),M=a.getValue(this.key);return Array.isArray(R)?R.indexOf(M)>=0:typeof M=="string"&&typeof R=="object"&&R!==null?P.call(R,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=f;class E{constructor(a){this._actual=a,this.type=11}static create(a){return new E(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new E(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(a,R){this.key=a,this.value=R,this.type=5}static create(a,R){if(typeof R=="boolean")return R?b.create(a):h.create(a);const M=A.get(a);return typeof M=="boolean"?R===(M?"true":"false")?I.INSTANCE:l.INSTANCE:new w(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(a){this.key=a,this.type=3}static create(a){const R=A.get(a);return typeof R=="boolean"?R?I.INSTANCE:l.INSTANCE:new b(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=b;class u{constructor(a,R){this.key=a,this.value=R,this.type=12}static create(a,R){return new u(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class d{constructor(a,R){this.key=a,this.value=R,this.type=13}static create(a,R){return new d(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class g{constructor(a,R){this.key=a,this.value=R,this.type=14}static create(a,R){return new g(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,R){this.key=a,this.value=R,this.type=15}static create(a,R){return new t(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:_(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,R){this.key=a,this.regexp=R,this.type=7}static create(a,R){return new i(a,R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const R=this.regexp?this.regexp.source:"",M=a.regexp?a.regexp.source:"";return R<M?-1:R>M?1:0}equals(a){if(a.type===this.type){const R=this.regexp?this.regexp.source:"",M=a.regexp?a.regexp.source:"";return this.key===a.key&&R===M}return!1}evaluate(a){let R=a.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class n{constructor(a){this.expr=a,this.type=6}static create(a){return n._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,M=this.expr.length;R<M;R++){const $=r(this.expr[R],a.expr[R]);if($!==0)return $}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,M=this.expr.length;R<M;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,M=this.expr.length;R<M;R++)if(!this.expr[R].evaluate(a))return!1;return!0}static _normalizeArr(a){const R=[];let M=!1;for(const $ of a)if(!!$){if($.type===1){M=!0;continue}if($.type===0)return I.INSTANCE;if($.type===6){R.push(...$.expr);continue}R.push($)}if(R.length===0&&M)return l.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(r);R.length>1;){const $=R[R.length-1];if($.type!==9)break;R.pop();const Y=R.pop(),le=o.create($.expr.map(q=>n.create([q,Y])));le&&(R.push(le),R.sort(r))}return R.length===1?R[0]:new n(R)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new n(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let R of this.expr)a.push(R.negate());return o.create(a)}}e.ContextKeyAndExpr=n;class o{constructor(a){this.expr=a,this.type=9}static create(a){const R=o._normalizeArr(a);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,M=this.expr.length;R<M;R++){const $=r(this.expr[R],a.expr[R]);if($!==0)return $}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,M=this.expr.length;R<M;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,M=this.expr.length;R<M;R++)if(this.expr[R].evaluate(a))return!0;return!1}static _normalizeArr(a){let R=[],M=!1;if(a){for(let $=0,Y=a.length;$<Y;$++){const le=a[$];if(!!le){if(le.type===0){M=!0;continue}if(le.type===1)return[l.INSTANCE];if(le.type===9){R=R.concat(le.expr);continue}R.push(le)}}if(R.length===0&&M)return[I.INSTANCE];R.sort(r)}return R}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new o(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let M of this.expr)a.push(M.negate());const R=M=>M.type===9?M.expr:[M];for(;a.length>1;){const M=a.shift(),$=a.shift(),Y=[];for(const le of R(M))for(const q of R($))Y.push(C.and(le,q));a.unshift(C.or(...Y))}return a[0]}}e.ContextKeyOrExpr=o;class v extends h{constructor(a,R,M){super(a);this._defaultValue=R,typeof M=="object"?v._info.push(Object.assign(Object.assign({},M),{key:a})):M!==!0&&v._info.push({key:a,description:M,type:R!=null?typeof R:void 0})}static all(){return v._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=L.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(D,a){return D<a?-1:D>a?1:0}function _(D,a,R,M){return D<R?-1:D>R?1:a<M?-1:a>M?1:0}}),define(ge[176],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=p.createDecorator("environmentService"),e.INativeEnvironmentService=p.refineServiceDecorator(e.IEnvironmentService)}),define(ge[177],pe([0,1,152,4,10]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=y;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var S;(function(I){I.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var C;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(l,h){super(l);this.code=h}}e.ExtensionManagementError=r,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=p.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=p.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkpaceSupportTypeMessage=k;function y(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let h=typeof I=="string"?I:I.value,c=typeof l=="string"?l:l.value;return p.equalsIgnoreCase(h,c)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=P;function S(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function C(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[178],pe([0,1,8,26]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,c){return h.uuid&&c.uuid?h.uuid===c.uuid:h.id===c.id?!0:p.compareIgnoreCase(h.id,c.id)===0}e.areSameExtensions=k;class y{constructor(c,f){this.version=f,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(h,c){return`${h}.${c}`}e.getExtensionId=A;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(h,c){return P(A(h,c))}e.getGalleryExtensionId=S;function C(h,c){const f=[],E=w=>{for(const b of f)if(b.some(u=>k(c(u),c(w))))return b;return null};for(const w of h){const b=E(w);b?b.push(w):f.push([w])}return f}e.groupByExtension=C;function r(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function I(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function l(h){const c=new Set;for(const f of h)f.malicious&&c.add(f.id.id);return c}e.getMaliciousExtensionsSet=l}),define(ge[179],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=p.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=p.createDecorator("externalTerminal")}),define(ge[180],pe([0,1,38,9,110,154,28,11,179,10,135]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=y.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const d=await f.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:d,osx:"xterm"}}}class h extends l{openTerminal(d,g){return this.spawnTerminal(p,d,k.getWindowsShell(),g)}spawnTerminal(d,g,t,i){const s=g.windowsExec||h.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=L.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return d.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((v,m)=>{const _=E(process),D=d.spawn(t,o,{cwd:i,env:_});D.on("error",m),D.on("exit",()=>v())})}runInTerminal(d,g,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((o,v)=>{const m=`"${g} - ${I}"`,_=`""${t.join('" "')}" & pause"`,D=["/c","start",m,"/wait",n,"/c",_],a=Object.assign({},E(process),i);Object.keys(a).filter($=>a[$]===null).forEach($=>delete a[$]);const R={cwd:g,env:a,windowsVerbatimArguments:!0};p.spawn(h.CMD,D,R).on("error",$=>{v(w($))}),o(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class c extends l{openTerminal(d,g){return this.spawnTerminal(p,d,g)}runInTerminal(d,g,t,i,s){const n=s.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((o,v)=>{if(n===S.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,X).fsPath,"-t",d||I,"-w",g];for(let M of t)D.push("-a"),D.push(M);if(i)for(let M in i){const $=i[M];$===null?(D.push("-u"),D.push(M)):(D.push("-e"),D.push(`${M}=${$}`))}let a="";const R=p.spawn(c.OSASCRIPT,D);R.on("error",M=>{v(w(M))}),R.stderr.on("data",M=>{a+=M.toString()}),R.on("exit",M=>{if(M===0)o(void 0);else if(a){const $=a.split(`
`,1);v(new Error($[0]))}else v(new Error(y.localize(1,null,m,M)))})}else v(new Error(y.localize(2,null,n)))})}spawnTerminal(d,g,t){const i=g.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const o=["-a",i];t&&o.push(t);const v=d.spawn("/usr/bin/open",o);v.on("error",n),v.on("exit",()=>s())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class f extends l{openTerminal(d,g){return this.spawnTerminal(p,d,g)}runInTerminal(d,g,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((o,v)=>{let m=[];n.then(_=>{_.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const D=`${b(t)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;m.push(`''${D}''`);const a=Object.assign({},process.env,i);Object.keys(a).filter(Y=>a[Y]===null).forEach(Y=>delete a[Y]);const R={cwd:g,env:a};let M="";const $=p.spawn(_,m,R);$.on("error",Y=>{v(w(Y))}),$.stderr.on("data",Y=>{M+=Y.toString()}),$.on("exit",Y=>{if(Y===0)o(void 0);else if(M){const le=M.split(`
`,1);v(new Error(le[0]))}else v(new Error(y.localize(4,null,_,Y)))})})})}static async getDefaultTerminalLinuxReady(){return f._DEFAULT_TERMINAL_LINUX_READY||(f._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{P.isLinux?await A.Promises.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,g,t){const i=g.linuxExec?Promise.resolve(g.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(o=>{const v=E(process),m=d.spawn(o,[],{cwd:t,env:v});m.on("error",n),m.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=y.localize(3,null);function E(u){const d=u.env;return r.sanitizeProcessEnvironment(d),d}function w(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(y.localize(5,null,u.path)):u}function b(u){let d="";for(let g of u)g.indexOf(" ")>=0?d+='"'+g+'"':d+=g,d+=" ";return d}}),define(ge[42],pe([0,1,155,9,2,4,8,15,23]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function C(U){return U.create===!0}e.isFileOpenForWriteOptions=C;var r;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=h;function c(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=c;function f(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function E(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=E;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,O){super(z);this.code=O}}e.FileSystemProviderError=b;function u(U,z){const O=new b(U.toString(),z);return g(O,z),O}e.createFileSystemProviderError=u;function d(U){return U||u(p.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=d;function g(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=g;function t(U){if(!U)return w.Unknown;if(U instanceof b)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return w.Unknown;switch(z[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function i(U){if(U instanceof _)return U.fileOperationResult;switch(t(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(z,O,W){this.resource=z,this.operation=O,this.target=W}isOperation(z){return this.operation===z}}e.FileOperationEvent=n;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class v{constructor(z,O){this.changes=z,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const W of z)switch(W.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>O)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>O)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>O)),this.deleted.set(W.resource,W);break}}contains(z,...O){return this.doContains(z,{includeChildren:!1},...O)}affects(z,...O){return this.doContains(z,{includeChildren:!0},...O)}doContains(z,O,...W){var T,F,N,x,G,se;if(!z)return!1;const be=W.length>0;return!!((!be||W.includes(1))&&(((T=this.added)===null||T===void 0?void 0:T.get(z))||O.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(z)))||(!be||W.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(z))||O.includeChildren&&((x=this.updated)===null||x===void 0?void 0:x.findSuperstr(z)))||(!be||W.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(z))||O.includeChildren&&((se=this.deleted)===null||se===void 0?void 0:se.findSuperstr(z))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function m(U,z,O){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),O?A.startsWithIgnoreCase(U,z):U.indexOf(z)===0)}e.isParent=m;class _ extends Error{constructor(z,O,W){super(z);this.fileOperationResult=O,this.options=W}}e.FileOperationError=_;class D extends _{constructor(z,O,W){super(z,2,W);this.stat=O}}e.NotModifiedSinceFileOperationError=D;var a;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=M;async function $(U,z){if(!z.canHandleResource(k.URI.from({scheme:U.scheme})))return new Promise(O=>{const W=z.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===U.scheme&&T.added&&(W.dispose(),O())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Y{static formatSize(z){return P.isNumber(z)||(z=0),z<Y.KB?p.localize(1,null,z.toFixed(0)):z<Y.MB?p.localize(2,null,(z/Y.KB).toFixed(2)):z<Y.GB?p.localize(3,null,(z/Y.MB).toFixed(2)):z<Y.TB?p.localize(4,null,(z/Y.GB).toFixed(2)):p.localize(5,null,(z/Y.TB).toFixed(2))}}e.ByteSize=Y,Y.KB=1024,Y.MB=Y.KB*Y.KB,Y.GB=Y.MB*Y.KB,Y.TB=Y.GB*Y.KB;var le;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function q(U){return{maxFileSize:U===0?300*Y.MB:16*Y.GB,maxHeapSize:U===0?700*Y.MB:2*700*Y.MB}}e.getPlatformLimits=q}),define(ge[79],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...k){this._entries=new Map;for(let[y,A]of k)this.set(y,A)}set(k,y){const A=this._entries.get(k);return this._entries.set(k,y),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=p}),define(ge[181],pe([0,1,14,173,111,4,79,16]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(c){var f;super("cyclic dependency between services");this.message=(f=c.findCycleSlow())!==null&&f!==void 0?f:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class r{constructor(c=new A.ServiceCollection,f=!1,E){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=E,this._services.set(y.IInstantiationService,this)}createChild(c){return new r(c,this._strict,this)}invokeFunction(c,...f){let E=l.traceInvocation(c),w=!1;try{return c({get:(u,d)=>{if(w)throw p.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(u,E);if(!g&&d!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return g}},...f)}finally{w=!0,E.stop()}}createInstance(c,...f){let E,w;return c instanceof k.SyncDescriptor?(E=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(f),E)):(E=l.traceCreation(c),w=this._createInstance(c,f,E)),E.stop(),w}_createInstance(c,f=[],E){let w=y._util.getServiceDependencies(c).sort((d,g)=>d.index-g.index),b=[];for(const d of w){let g=this._getOrCreateServiceInstance(d.id,E);if(!g&&this._strict&&!d.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${d.id}.`);b.push(g)}let u=w.length>0?w[0].index:f.length;if(f.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${f.length} static arguments`);let d=u-f.length;d>0?f=f.concat(new Array(d)):f=f.slice(0,u)}return new c(...[...f,...b])}_setServiceInstance(c,f){if(this._services.get(c)instanceof k.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let E=this._getServiceInstanceOrDescriptor(c);return E instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,E,f.branch(c,!0)):(f.branch(c,!1),E)}_safeCreateAndCacheServiceInstance(c,f,E){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,E)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,E){const w=new L.Graph(d=>d.id.toString());let b=0;const u=[{id:c,desc:f,_trace:E}];for(;u.length;){const d=u.pop();if(w.lookupOrInsertNode(d),b++>1e3)throw new C(w);for(let g of y._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${c} depends on ${g.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const i={id:g.id,desc:t,_trace:d._trace.branch(g.id,!0)};w.insertEdge(d,i),u.push(i)}}}for(;;){const d=w.roots();if(d.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:g}of d){if(this._getServiceInstanceOrDescriptor(g.id)instanceof k.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}w.removeNode(g)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,E=[],w,b){if(this._services.get(c)instanceof k.SyncDescriptor)return this._createServiceInstance(f,E,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,E,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],E,w){if(E){const b=new P.IdleValue(()=>this._createInstance(c,f,w));return new Proxy(Object.create(null),{get(u,d){if(d in u)return u[d];let g=b.value,t=g[d];return typeof t!="function"||(t=t.bind(g),u[d]=t),t},set(u,d,g){return b.value[d]=g,!0}})}else return this._createInstance(c,f,w)}}e.InstantiationService=r;var I;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(I||(I={}));class l{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return S?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return S?new l(0,c.name):l._None}branch(c,f){let E=new l(2,c.toString());return this._dep.push([c,f,E]),E}stop(){let c=Date.now()-this._start;l._totals+=c;let f=!1;function E(b,u){let d=[],g=new Array(b+1).join("	");for(const[t,i,s]of u._dep)if(i&&s){f=!0,d.push(`${g}CREATES -> ${t}`);let n=E(b+1,s);n&&d.push(n)}else d.push(`${g}uses -> ${t}`);return d.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ge[12],pe([0,1,4,6,11,3,56]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=p.createDecorator("logService"),e.ILoggerService=p.createDecorator("loggerService");function P(){return new Date().toISOString()}var S;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class C extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class r extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(o){}i+=(s>0?" ":"")+n}return i}}e.AbstractMessageLogger=r;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}debug(t,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}info(t,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}warn(t,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...i):console.warn(`[main ${P()}]`,t,...i))}error(t,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}critical(t,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends C{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class c extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class f extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=f;class E extends L.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?S.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=w;function b(g){if(g.verbose)return S.Trace;if(typeof g.logLevel=="string"){const t=u(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function u(g){switch(g){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=u;function d(g){switch(g){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=d}),define(ge[113],pe([0,1,12,42]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(S,C,r,I){try{const l=await new Promise((h,c)=>{X(["spdlog"],h,c)});return l.setFlushOn(p.LogLevel.Trace),l.createAsyncRotatingLogger(S,C,r,I)}catch(l){console.error(l)}return null}function y(S,C,r,I){const l=X.__$__nodeRequire("spdlog");return l.setFlushOn(p.LogLevel.Trace),l.createRotatingLogger(S,C,r,I)}e.createRotatingLogger=y;function A(S,C,r){switch(C){case p.LogLevel.Trace:S.trace(r);break;case p.LogLevel.Debug:S.debug(r);break;case p.LogLevel.Info:S.info(r);break;case p.LogLevel.Warning:S.warn(r);break;case p.LogLevel.Error:S.error(r);break;case p.LogLevel.Critical:S.critical(r);break;default:throw new Error("Invalid log level")}}class P extends p.AbstractMessageLogger{constructor(C,r,I,l){super();this.name=C,this.filepath=r,this.rotating=I,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const C=this.rotating?6:1,r=30/C*L.ByteSize.MB;return k(this.name,this.filepath,r,C).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:l,message:h}of this.buffer)A(this._logger,l,h);this.buffer=[]}})}log(C,r){this._logger?A(this._logger,C,r):this.getLevel()<=C&&this.buffer.push({level:C,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ge[114],pe([0,1,4,156,53]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(c,f){return f-c}S.compare=C;const r=Object.create(null);r[S.Error]=L.localize(0,null),r[S.Warning]=L.localize(1,null),r[S.Info]=L.localize(2,null);function I(c){return r[c]||""}S.toString=I;function l(c){switch(c){case k.default.Error:return S.Error;case k.default.Warning:return S.Warning;case k.default.Info:return S.Info;case k.default.Ignore:return S.Hint}}S.fromSeverity=l;function h(c){switch(c){case S.Error:return k.default.Error;case S.Warning:return k.default.Warning;case S.Info:return k.default.Info;case S.Hint:return k.default.Ignore}}S.toSeverity=h}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const C="";function r(l){return I(l,!0)}S.makeKey=r;function I(l,h){let c=[C];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(C),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(C),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(C),l.message&&h?c.push(l.message.replace("\xA6","\\\xA6")):c.push(C),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(C),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(C),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(C),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(C),c.push(C),c.join("\xA6")}S.makeKeyOptionalMessage=I})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=p.createDecorator("markerService")}),define(ge[182],pe([0,1,53,4,3]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=L.createDecorator("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=S}),define(ge[183],pe([0,1,6,8,2,4]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function A(P,S){return k.URI.isUri(P)?L.equalsIgnoreCase(P.scheme,S):L.startsWithIgnoreCase(P,S+":")}e.matchesScheme=A}),define(ge[184],pe([0,1,10,11,37,24]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(X==null?void 0:X.__$__nodeRequire)=="function"){const P=y.dirname(p.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(y.joinPath(P,"product.json").fsPath);const S=X.__$__nodeRequire(y.joinPath(P,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:S.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.58.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var $e=this&&this.__param||function(X,e){return function(p,L){e(p,L,X)}};define(ge[115],pe([0,1,4,21,6,16]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=p.createDecorator("progressService");var A;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(I,l){super();this.deferred=new y.DeferredPromise,l.withProgress(I,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(k.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=je([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,h=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(k.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(k.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(k.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=p.createDecorator("editorProgressService")}),define(ge[57],pe([0,1,15,50]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,P){L.ok(p.isString(A)),L.ok(p.isObject(P)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ge[185],pe([0,1,57,3]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class y{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[k(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;p.Registry.add(e.Extensions.JSONContribution,A)}),define(ge[80],pe([0,1,151,3,57,15,185]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=k.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const u=[];w.forEach(d=>{u.push(...this.validateAndRegisterProperties(d,b,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const b=[],u=d=>{if(d.properties)for(const g in d.properties)b.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,d.properties[g]);d.allOf&&d.allOf.forEach(g=>u(g))};for(const d of w){u(d);const g=this.configurationContributors.indexOf(d);g!==-1&&this.configurationContributors.splice(g,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],u=[];for(const d of w)for(const g in d)if(b.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),d[g]);const t={type:"object",default:this.defaultValues[g],description:p.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=d[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const u of w)for(const d in u)if(b.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const g=this.configurationProperties[d];g&&(this.updatePropertyDefaultValue(d,g),this.updateSchema(d,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,u,d=3){var g;d=y.isUndefinedOrNull(w.scope)?d:w.scope;let t=[],i=w.properties;if(i)for(let n in i){if(b&&c(n)){delete i[n];continue}const o=i[n];if(this.updatePropertyDefaultValue(n,o),e.OVERRIDE_PROPERTY_PATTERN.test(n)?o.scope=void 0:(o.scope=y.isUndefinedOrNull(o.scope)?d:o.scope,o.restricted=y.isUndefinedOrNull(o.restricted)?!!((g=u==null?void 0:u.restrictedConfigurations)===null||g===void 0?void 0:g.includes(n)):o.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),t.push(n)}let s=w.allOf;if(s)for(let n of s)t.push(...this.validateAndRegisterProperties(n,b,u,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=u=>{let d=u.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let g=u.allOf;g&&g.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,u={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,u),e.allSettings.properties[b]=u,e.applicationSettings.properties[b]=u,e.machineSettings.properties[b]=u,e.machineOverridableSettings.properties[b]=u,e.windowSettings.properties[b]=u,e.resourceSettings.properties[b]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let u=this.defaultValues[w];y.isUndefined(u)&&(u=b.default),y.isUndefined(u)&&(u=l(b.type)),b.default=u}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function I(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=I;function l(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const h=new C;k.Registry.add(e.Extensions.Configuration,h);function c(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?p.localize(5,null,E):h.getConfigurationProperties()[E]!==void 0?p.localize(6,null,E):null:p.localize(4,null)}e.validateProperty=c;function f(){const E=[],w=h.getConfigurationProperties();for(const b of Object.keys(w))E.push([b,w[b].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=f}),define(ge[116],pe([0,1,25,15,2,57,4,80]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function S(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof k.URI)}e.isConfigurationOverrides=S;var C;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function I(i,s){const n=s?i?s.keys.filter(R=>i.keys.indexOf(R)===-1):[...s.keys]:[],o=i?s?i.keys.filter(R=>s.keys.indexOf(R)===-1):[...i.keys]:[],v=[];if(s&&i){for(const R of i.keys)if(s.keys.indexOf(R)!==-1){const M=w(i.contents,R),$=w(s.contents,R);p.equals(M,$)||v.push(R)}}const m=[],_=R=>{const M={};for(const $ of R)for(const Y of $.identifiers)M[g(Y)]=$;return M},D=s?_(s.overrides):{},a=i?_(i.overrides):{};if(Object.keys(D).length)for(const R of n){const M=D[R];M&&m.push([P.overrideIdentifierFromKey(R),M.keys])}if(Object.keys(a).length)for(const R of o){const M=a[R];M&&m.push([P.overrideIdentifierFromKey(R),M.keys])}if(Object.keys(D).length&&Object.keys(a).length)for(const R of v){const M=a[R],$=D[R];if(M&&$){const Y=I({contents:M.contents,keys:M.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([P.overrideIdentifierFromKey(R),[...Y.added,...Y.removed,...Y.updated]])}}return{added:n,removed:o,updated:v,overrides:m}}e.compare=I;function l(i,s){const n=[];for(const o of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const v={};for(const m in i[o])v[m]=i[o][m];n.push({identifiers:[P.overrideIdentifierFromKey(o).trim()],keys:Object.keys(v),contents:h(v,s)})}return n}e.toOverrides=l;function h(i,s){const n=Object.create(null);for(let o in i)c(n,o,i[o],s);return n}e.toValuesTree=h;function c(i,s,n,o){const v=s.split("."),m=v.pop();let _=i;for(let D=0;D<v.length;D++){let a=v[D],R=_[a];switch(typeof R){case"undefined":R=_[a]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${v.slice(0,D+1).join(".")} is ${JSON.stringify(R)}`);return}_=R}if(typeof _=="object"&&_!==null)try{_[m]=n}catch(D){o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(_)}`)}else o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=c;function f(i,s){const n=s.split(".");E(i,n)}e.removeFromValueTree=f;function E(i,s){const n=s.shift();if(s.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const o=i[n];typeof o=="object"&&!Array.isArray(o)&&(E(o,s),Object.keys(o).length===0&&delete i[n])}}function w(i,s,n){function o(_,D){let a=_;for(const R of D){if(typeof a!="object"||a===null)return;a=a[R]}return a}const v=s.split("."),m=o(i,v);return typeof m=="undefined"?n:m}e.getConfigurationValue=w;function b(i,s,n){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in i?L.isObject(i[o])&&L.isObject(s[o])?b(i[o],s[o],n):n&&(i[o]=s[o]):i[o]=s[o])})}e.merge=b;function u(){const i=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function d(){const i=Object.create(null),s=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let n in s){let o=s[n].default;c(i,n,o,v=>console.error(`Conflict in default settings: ${v}`))}return i}e.getDefaultValues=d;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,n){const o=i.inspect(s),v=i.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[186],pe([0,1,52,23,18,15,25,2,80,116,57,6,3]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?C.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[n],v=i[n];v&&(typeof o=="object"&&typeof v=="object"?(o=A.deepClone(o),this.mergeContents(o,v)):o=v),s[n]=o}return new h(s,this.keys,this.overrides)}merge(...t){const i=A.deepClone(this.contents),s=A.deepClone(this.overrides),n=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const v of o.overrides){const[m]=s.filter(_=>k.equals(_.identifiers,v.identifiers));m?this.mergeContents(m.contents,v.contents):s.push(A.deepClone(v))}for(const v of o.keys)n.indexOf(v)===-1&&n.push(v)}return new h(i,n,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=A.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),C.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class c extends h{constructor(){const t=C.getDefaultValues(),i=C.getConfigurationKeys(),s=[];for(const n of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[S.overrideIdentifierFromKey(n).trim()],keys:Object.keys(t[n]),contents:C.toValuesTree(t[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,s)}}e.DefaultConfigurationModel=c;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:n,overrides:o,restricted:v}=this.doParseRaw(t,i);this._configurationModel=new h(s,n,o),this._restrictedConfigurations=v||[]}doParseContent(t){let i={},s=null,n=[],o=[],v=[];function m(D){Array.isArray(n)?n.push(D):s&&(n[s]=D)}let _={onObjectBegin:()=>{let D={};m(D),o.push(n),n=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let D=[];m(D),o.push(n),n=D,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:m,onError:(D,a,R)=>{v.push({error:D,offset:a,length:R})}};if(t)try{p.visit(t,_),i=n[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(t,i){const s=r.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,i);t=n.raw;const o=C.toValuesTree(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),v=Object.keys(t),m=C.toOverrides(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:o,keys:v,overrides:m,restricted:n.restricted}}filter(t,i,s,n){if(!(n==null?void 0:n.scopes)&&!(n==null?void 0:n.skipRestricted))return{raw:t,restricted:[]};const o={},v=[];for(let m in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const _=this.filter(t[m],i,!1,n);o[m]=_.raw,v.push(..._.restricted)}else{const _=i[m],D=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&v.push(m),(D===void 0||n.scopes===void 0||n.scopes.includes(D))&&(n.skipRestricted&&(_==null?void 0:_.restricted)||(o[m]=t[m]))}return{raw:o,restricted:v}}}e.ConfigurationModelParser=f;class E extends I.Disposable{constructor(t,i,s,n){super();this.userSettingsResource=t,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,i,s=new h,n=new h,o=new L.ResourceMap,v=new h,m=new L.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=v,this._memoryConfigurationByResource=m,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new h,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(t):n.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const n=this.getConsolidateConfigurationModel(i,s),o=this.getFolderConfigurationModelForResource(i.resource,s),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,M=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,$=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(t):v.getValue(t),Y=n.getValue(t),le=k.distinct(k.flatten(n.overrides.map(q=>q.identifiers))).filter(q=>n.getOverrideValue(t,q)!==void 0);return{defaultValue:m,userValue:_,userLocalValue:D,userRemoteValue:a,workspaceValue:R,workspaceFolderValue:M,memoryValue:$,value:Y,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:v.getValue(t),override:i.overrideIdentifier?v.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(n=>S.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=S.overrideIdentifierFromKey(n),v=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),_=[...m.filter(D=>v.indexOf(D)===-1),...v.filter(D=>m.indexOf(D)===-1),...v.filter(D=>!A.equals(this._defaultConfiguration.override(o).getValue(D),t.override(o).getValue(D)))];return[o,_]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=C.compare(this.localUserConfiguration,t),v=[...i,...s,...n];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=C.compare(this.remoteUserConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=C.compare(this.workspaceConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:n,updated:o,removed:v,overrides:m}=C.compare(s,i);let _=[...n,...o,...v];return(_.length||!s)&&this.updateFolderConfiguration(t,i),{keys:_,overrides:m}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:o,overrides:v}=C.compare(i,void 0);return{keys:[...s,...n,...o],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const n=i.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(i=s.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:n,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((v,m)=>(v.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),v),new L.ResourceMap);return new w(i,s,new h,n,o,new h,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const n of g)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,v])=>{const m=L.getOrSet(i,o,new Set);v.forEach(_=>m.add(_))});const s=[];return i.forEach((n,o)=>s.push([o,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=b;class u{constructor(t,i,s,n){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(m=>o.add(m)),t.overrides.forEach(([,m])=>m.forEach(_=>o.add(_))),this.affectedKeys=[...o.values()];const v=new h;this.affectedKeys.forEach(m=>v.setValue(m,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!A.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=C.toValuesTree({[i]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=u;class d extends u{constructor(t,i,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=d}),define(ge[117],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=p.createDecorator("remoteAuthorityResolverService");var L;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,P=L.Unknown,S){super(A);this._message=A,this._code=P,this._detail=S,this.isHandled=P===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(ge[81],pe([0,1,10]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(C){return C.scheme===p.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=L;function k(C){if(!C)return;const r=C.indexOf("+");return r<0?C:C.substr(0,r)}e.getRemoteName=k;function y(C){return C.scheme!==p.Schemas.file&&C.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=y;function A(C){if(C.folders.length)return C.folders.every(r=>y(r.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=A;function P(C){var r;return(r=A(C))===null||r===void 0?void 0:r.scheme}e.getVirtualWorkspaceScheme=P;function S(C){return A(C)!==void 0}e.isVirtualWorkspace=S}),define(ge[187],pe([0,1,3,11,4,12]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=k.createDecorator("tunnelService");var A;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore"})(A=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=C;function r(l,h){return h?h!==1&&l<1024:!L.isWindows&&l<1024}e.isPortPrivileged=r;let I=class{constructor(h){this.logService=h,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,c){return this._tunnelProvider=h,h?(this._canElevate=c.elevation,this._canMakePublic=c.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const c=[],f=Array.from(this._tunnels.values());for(let E of f){const w=Array.from(E.values());for(let b of w){const u=await b.value;u&&c.push(u)}}h(c)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:c}of h.values())await c.then(f=>f==null?void 0:f.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,c,f,E,w=!1,b=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${f} on local port ${E}.`),!h)return;c||(c="localhost");const u=this.retainOrCreateTunnel(h,c,f,E,w,b);return u?u.then(d=>{if(!d){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.makeTunnel(d);return(d.tunnelRemoteHost!==c||d.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(g),g}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const c=this._tunnels.get(h.tunnelRemoteHost);if(c){const f=c.get(h.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,f))}}}}async tryDisposeTunnel(h,c,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${c}.`);const E=f.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(c),E}}async closeTunnel(h,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${c} `);const f=this._tunnels.get(h);if(f&&f.has(c)){const E=f.get(c);E.refcount=0,await this.tryDisposeTunnel(h,c,E)}}addTunnelToMap(h,c,f){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(c,{refcount:1,value:f})}async removeEmptyTunnelFromMap(h,c){const f=this._tunnels.get(h);f&&(await f.get(c)||f.delete(c),f.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,c){let f=[h];S(h)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):C(h)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const E=f.map(w=>this._tunnels.get(w));for(const w of E){const b=w==null?void 0:w.get(c);if(b)return b}}canTunnel(h){return!!P(h)}createWithProvider(h,c,f,E,w,b){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${f} on local port ${E}.`);const d={elevationRequired:w?r(E===void 0?f:E):!1},g={remoteAddress:{host:c,port:f},localAddressPort:E,public:b},t=h.forwardPort(g,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(c,f,t),t}};I=je([$e(0,y.ILogService)],I),e.AbstractTunnelService=I}),define(ge[188],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((k,y)=>X(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(k)}catch(y){}return k}}e.SignService=p}),define(ge[189],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,y,A=5){let P;return P=y(S=>{const C=typeof S=="string"?S:S.data;let r=this._terminalBufferMap.get(k);if(r){r.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(k),A);r={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),P.dispose()}},this._terminalBufferMap.set(k,r)}),P}stopBuffering(k){const y=this._terminalBufferMap.get(k);y&&y.dispose()}flushBuffer(k){const y=this._terminalBufferMap.get(k);y&&(this._terminalBufferMap.delete(k),this._callback(k,y.data.join("")))}}e.TerminalDataBufferer=p}),define(ge[45],pe([0,1,2,24,4,23]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=k.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function P(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=P;function S(l){const h=l;return!!(h&&typeof h=="object"&&p.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(h,c,f,E){this._id=h,this._configuration=f,this._ignorePathCasing=E,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class r{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return L.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function I(l){return new r({uri:l,index:0,name:L.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(ge[190],pe([0,1,4,157,45,2,11,9,24,133,52,10,75,29,81]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:L.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(U){return(typeof U=="string"?P.extname(U):S.extname(U))===f}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=p.createDecorator("workspacesService");function w(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=b;function u(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=u;function d(U){const z=U;return typeof(z==null?void 0:z.id)=="string"&&y.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=d;function g(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(U){const z=U;return typeof(z==null?void 0:z.id)=="string"&&y.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function i(U){const z=U;if(z==null?void 0:z.uri)return{id:z.id,uri:y.URI.revive(z.uri)};const O=U;if(O==null?void 0:O.configPath)return{id:O.id,configPath:y.URI.revive(O.configPath)};if(U==null?void 0:U.id)return{id:U.id}}e.reviveIdentifier=i;function s(U,z){return S.extUriBiasedIgnorePathCase.isEqualOrParent(U,z.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(U){return o(U)||v(U)}e.isStoredWorkspaceFolder=n;function o(U){const z=U;return typeof(z==null?void 0:z.path)=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=o;function v(U){const z=U;return typeof(z==null?void 0:z.uri)=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=v;function m(U,z,O,W,T=!A.isWindows,F){if(U.scheme!==W.scheme)return{name:O,uri:U.toString(!0)};let N=z?void 0:F.relativePath(W,U);if(N!==void 0)N.length===0?N=".":A.isWindows&&U.scheme===I.Schemas.file&&!T&&(N=N.replace(/\//g,"\\"));else if(U.scheme===I.Schemas.file)N=U.fsPath,A.isWindows&&(N=l.normalizeDriveLetter(N),T&&(N=h.toSlashes(N)));else{if(!F.isEqualAuthority(U.authority,W.authority))return{name:O,uri:U.toString(!0)};N=U.path}return{name:O,path:N}}e.getStoredWorkspaceFolder=m;function _(U,z,O){let W=[],T=new Set;const F=O.dirname(z);for(let N of U){let x;if(o(N))N.path&&(x=O.resolvePath(F,N.path));else if(v(N))try{x=y.URI.parse(N.uri),x.path[0]!=="/"&&(x=x.with({path:"/"+x.path}))}catch(G){console.warn(G)}if(x){let G=O.getComparisonKey(x);if(!T.has(G)){T.add(G);const se=N.name||O.basenameOrAuthority(x);W.push(new k.WorkspaceFolder({uri:x,name:se,index:W.length},N))}}}return W}e.toWorkspaceFolders=_;function D(U,z,O,W,T){let F=a(z,U);const N=T.dirname(z),x=T.dirname(W),G=[],se=R(F.folders);for(const Me of F.folders){const qe=o(Me)?T.resolvePath(N,Me.path):y.URI.parse(Me.uri);let He;O?He=!1:He=!o(Me)||P.isAbsolute(Me.path),G.push(m(qe,He,Me.name,x,se,T))}const be={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Ie=C.setProperty(U,["folders"],G,be);let Ce=C.applyEdits(U,Ie);return F.remoteAuthority===c.getRemoteAuthority(W)&&(Ce=C.applyEdits(Ce,C.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=D;function a(U,z){let O=r.parse(z);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(W=>n(W));else throw new Error(`${U} looks like an invalid workspace file.`);return O}function R(U){return A.isWindows?U.some(z=>o(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function M(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function $(U){return typeof U.folderUri=="string"}function Y(U){return typeof U.fileUri=="string"}function le(U,z){const O={workspaces:[],files:[]};if(U){const W=function(F,N){for(let x=0;x<F.length;x++)try{N(F[x],x)}catch(G){z.warn(`Error restoring recent entry ${JSON.stringify(F[x])}: ${G.toString()}. Skip entry.`)}},T=U;if(Array.isArray(T.entries))W(T.entries,F=>{const N=F.label,x=F.remoteAuthority;M(F)?O.workspaces.push({label:N,remoteAuthority:x,workspace:{id:F.workspace.id,configPath:y.URI.parse(F.workspace.configPath)}}):$(F)?O.workspaces.push({label:N,remoteAuthority:x,folderUri:y.URI.parse(F.folderUri)}):Y(F)&&O.files.push({label:N,remoteAuthority:x,fileUri:y.URI.parse(F.fileUri)})});else{const F=U;Array.isArray(F.workspaces3)&&W(F.workspaces3,(N,x)=>{const G=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[x]||void 0;typeof N=="object"&&typeof N.id=="string"&&typeof N.configURIPath=="string"?O.workspaces.push({label:G,workspace:{id:N.id,configPath:y.URI.parse(N.configURIPath)}}):typeof N=="string"&&O.workspaces.push({label:G,folderUri:y.URI.parse(N)})}),Array.isArray(F.files2)&&W(F.files2,(N,x)=>{const G=Array.isArray(F.fileLabels)&&F.fileLabels[x]||void 0;typeof N=="string"&&O.files.push({label:G,fileUri:y.URI.parse(N)})})}}return O}e.restoreRecentlyOpened=le;function q(U){const z={entries:[]};for(const O of U.workspaces)b(O)?z.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):z.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of U.files)z.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return z}e.toStoreData=q}),define(ge[82],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const y=this._idPool++;return this._data.set(y,k),this.logDebugInfo(),y}get(k,y){return this._data.has(k)?this._data.get(k)[y]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(ge[46],pe([0,1,2,3,4]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=k.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(S=>({name:S.name,group:S.group,resource:p.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(ge[58],pe([0,1,10,4]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,P){P===null?this._providerInfo.delete(A):this._providerInfo.set(A,P)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=L.createDecorator("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=p.createDecorator("IExtHostInitDataService")}),define(ge[191],pe([0,1,16]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(A,P,S){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of C.values())r.complete()}catch(r){for(const I of C.values())I.error(r)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(A,P){let S=this._value[A];return typeof S=="undefined"&&(S=P),S}update(A,P){this._value[A]=P;let S=this._deferredPromises.get(A);if(S!==void 0)return S.p;const C=new p.DeferredPromise;return this._deferredPromises.set(A,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(A,P){super(A.identifier.value,!0,P);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(ge[192],pe([0,1,3,2,12]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(P,S){this._logService=P,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,S,C){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(P)).acceptModelChanged(S,C)}$acceptDirtyStateChanged(P,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(P)).acceptDirty(S)}$acceptModelSaved(P){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(P));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(P,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,S);const C=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(P));C.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=je([$e(0,k.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(ge[13],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=p.createDecorator("IExtHostRpcService");class L{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=L});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[193],pe([0,1,26,3]),function(X,e,p,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(P,S){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(P.identifier),it(this,k,S,"f"),Be(this,k,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(P){return Be(this,k,"f").get(this._id,P)}store(P,S){return Be(this,k,"f").store(this._id,P,S)}delete(P){return Be(this,k,"f").delete(this._id,P)}}e.ExtensionSecrets=y,k=new WeakMap}),define(ge[118],pe([0,1,4,3]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=p.createDecorator("IExtHostTelemetry")}),define(ge[83],pe([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var L;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(L=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,y=A=>{let P=k.get(A);return P||(P={children:new Map,bus:new p.Emitter},k.set(A,P)),P};e.getPrivateApiFor=y}),define(ge[47],pe([0,1,4,3,13]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(P){function S(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}P.fromApiTunnel=S;function C(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}P.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=p.createDecorator("IExtHostTunnelService");let A=class{constructor(S){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,C){return{dispose:()=>{}}}async $providePortAttributes(S,C,r,I,l){return[]}async $forwardPort(S,C){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=je([$e(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[7],pe([0,1,18,14,95,23,98,15,2,32,42,117,83]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";var h,c,f,E,w,b,u,d,g,t,i,s,n,o,v,m,_,D;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(V){function B(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(B,V),Object.setPrototypeOf(B.prototype,V.prototype),B}let R=w=class{constructor(B){h.set(this,void 0),it(this,h,B,"f")}static from(...B){let re=B;return new w(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof Be(this,h,"f")=="function"&&(Be(this,h,"f").call(this),it(this,h,void 0,"f"))}};h=new WeakMap,R=w=je([a],R),e.Disposable=R;let M=b=class{constructor(B,re){if(B<0)throw L.illegalArgument("line must be non-negative");if(re<0)throw L.illegalArgument("character must be non-negative");this._line=B,this._character=re}static Min(...B){if(B.length===0)throw new TypeError;let re=B[0];for(let ke=1;ke<B.length;ke++){const Ge=B[ke];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...B){if(B.length===0)throw new TypeError;let re=B[0];for(let ke=1;ke<B.length;ke++){const Ge=B[ke];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(B){if(!B)return!1;if(B instanceof b)return!0;let{line:re,character:ke}=B;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,re=0){if(B===null||re===null)throw L.illegalArgument();let ke;return typeof B=="undefined"?ke=0:typeof B=="number"?ke=B:(ke=typeof B.lineDelta=="number"?B.lineDelta:0,re=typeof B.characterDelta=="number"?B.characterDelta:0),ke===0&&re===0?this:new b(this.line+ke,this.character+re)}with(B,re=this.character){if(B===null||re===null)throw L.illegalArgument();let ke;return typeof B=="undefined"?ke=this.line:typeof B=="number"?ke=B:(ke=typeof B.line=="number"?B.line:this.line,re=typeof B.character=="number"?B.character:this.character),ke===this.line&&re===this.character?this:new b(ke,re)}toJSON(){return{line:this.line,character:this.character}}};M=b=je([a],M),e.Position=M;let $=u=class{constructor(B,re,ke,Ge){let tt,at;if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(tt=new M(B,re),at=new M(ke,Ge)):B instanceof M&&re instanceof M&&(tt=B,at=re),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(B){return B instanceof u?!0:B?M.isPosition(B.start)&&M.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof M?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const re=M.Max(B.start,this._start),ke=M.Min(B.end,this._end);if(!re.isAfter(ke))return new u(re,ke)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const re=M.Min(B.start,this._start),ke=M.Max(B.end,this.end);return new u(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,re=this.end){if(B===null||re===null)throw L.illegalArgument();let ke;return B?M.isPosition(B)?ke=B:(ke=B.start||this.start,re=B.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new u(ke,re)}toJSON(){return[this.start,this.end]}};$=u=je([a],$),e.Range=$;let Y=d=class extends ${constructor(B,re,ke,Ge){let tt,at;if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(tt=new M(B,re),at=new M(ke,Ge)):B instanceof M&&re instanceof M&&(tt=B,at=re),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(B){return B instanceof d?!0:B?$.isRange(B)&&M.isPosition(B.anchor)&&M.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Y=d=je([a],Y),e.Selection=Y;class le{constructor(B,re,ke){if(typeof B!="string"||B.length===0)throw L.illegalArgument("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw L.illegalArgument("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw L.illegalArgument("connectionToken");this.host=B,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=le;class q extends Error{constructor(B,re=I.RemoteAuthorityResolverErrorCode.Unknown,ke){super(B);this._message=B,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}static NotAvailable(B,re){return new q(B,I.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(B){return new q(B,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=q;var U;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var z;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let O=g=class{constructor(B,re){this._range=B,this._newText=re}static isTextEdit(B){return B instanceof g?!0:B?$.isRange(B)&&typeof B.newText=="string":!1}static replace(B,re){return new g(B,re)}static insert(B,re){return g.replace(new $(B,B),re)}static delete(B){return g.replace(B,"")}static setEndOfLine(B){const re=new g(new $(new M(0,0),new M(0,0)),"");return re.newEol=B,re}get range(){return this._range}set range(B){if(B&&!$.isRange(B))throw L.illegalArgument("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw L.illegalArgument("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw L.illegalArgument("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};O=g=je([a],O),e.TextEdit=O;var W;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(W=e.FileEditType||(e.FileEditType={}));let T=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,re,ke,Ge){this._edits.push({_type:1,from:B,to:re,options:ke,metadata:Ge})}createFile(B,re,ke){this._edits.push({_type:1,from:void 0,to:B,options:re,metadata:ke})}deleteFile(B,re,ke){this._edits.push({_type:1,from:B,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata(B,re,ke){this._edits.push({_type:3,metadata:ke,uri:B,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(B,re,ke,Ge,tt){let at,lt,yt=[],Pt;if(jt.isNotebookRange(re)&&Rt.isNotebookCellDataArray(ke)&&!Rt.isNotebookCellDataArray(Ge)?(at=re.start,lt=re.end,yt=ke,Pt=Ge):typeof re=="number"&&typeof ke=="number"&&Rt.isNotebookCellDataArray(Ge)&&(at=re,lt=ke,yt=Ge,Pt=tt),at===void 0||lt===void 0)throw new Error("Invalid arguments");(at!==lt||yt.length>0)&&this._edits.push({_type:5,uri:B,index:at,count:lt-at,cells:yt,metadata:Pt})}replaceNotebookCellMetadata(B,re,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:B,edit:{editType:8,index:re,metadata:ke}})}replace(B,re,ke,Ge){this._edits.push({_type:2,uri:B,edit:new O(re,ke),metadata:Ge})}insert(B,re,ke,Ge){this.replace(B,new $(re,re),ke,Ge)}delete(B,re,ke){this.replace(B,re,"",ke)}has(B){return this._edits.some(re=>re._type===2&&re.uri.toString()===B.toString())}set(B,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:B,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===B.toString()&&(this._edits[ke]=void 0)}p.coalesceInPlace(this._edits)}}get(B){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===B.toString()&&re.push(ke.edit);return re}entries(){const B=new y.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=B.get(re.uri);ke||(ke=[re.uri,[]],B.set(re.uri,ke)),ke[1].push(re.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};T=je([a],T),e.WorkspaceEdit=T;let F=t=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof t?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=t._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,re=this._tabstop++){if(typeof B=="function"){const ke=new t;ke._tabstop=this._tabstop,B(ke),this._tabstop=ke._tabstop,B=ke.value}else B=t._escape(B);return this.value+="${",this.value+=re,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,re=this._tabstop++){const ke=B.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(B,re){if(typeof re=="function"){const ke=new t;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,re&&(this.value+=":",this.value+=re),this.value+="}",this}};F=t=je([a],F),e.SnippetString=F;var N;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=i=class{constructor(B,re){if(this.uri=B,re)if(re instanceof $)this.range=re;else if(re instanceof M)this.range=new $(re,re);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof i?!0:B?$.isRange(B.range)&&S.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=i=je([a],G),e.Location=G;let se=class{constructor(B,re){this.location=B,this.message=re}static is(B){return B?typeof B.message=="string"&&B.location&&$.isRange(B.location.range)&&S.URI.isUri(B.location.uri):!1}static isEqual(B,re){return B===re?!0:!B||!re?!1:B.message===re.message&&B.location.range.isEqual(re.location.range)&&B.location.uri.toString()===re.location.uri.toString()}};se=je([a],se),e.DiagnosticRelatedInformation=se;let be=class{constructor(B,re,ke=x.Error){if(!$.isRange(B))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=B,this.message=re,this.severity=ke}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,re){return B===re?!0:!B||!re?!1:B.message===re.message&&B.severity===re.severity&&B.code===re.code&&B.severity===re.severity&&B.source===re.source&&B.range.isEqual(re.range)&&p.equals(B.tags,re.tags)&&p.equals(B.relatedInformation,re.relatedInformation,se.isEqual)}};be=je([a],be),e.Diagnostic=be;let Ie=class{constructor(B,re){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:k.isMarkdownString(B)?this.contents=[B]:this.contents=[B],this.range=re}};Ie=je([a],Ie),e.Hover=Ie;var Ce;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(B,re=Ce.Text){this.range=B,this.kind=re}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};Me=je([a],Me),e.DocumentHighlight=Me;var qe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var He;(function(V){V[V.Deprecated=1]="Deprecated"})(He=e.SymbolTag||(e.SymbolTag={}));let Ve=s=class{constructor(B,re,ke,Ge,tt){this.name=B,this.kind=re,this.containerName=tt,typeof ke=="string"&&(this.containerName=ke),Ge instanceof G?this.location=Ge:ke instanceof $&&(this.location=new G(Ge,ke)),s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};Ve=s=je([a],Ve),e.SymbolInformation=Ve;let j=n=class{constructor(B,re,ke,Ge,tt){this.name=B,this.detail=re,this.kind=ke,this.range=Ge,this.selectionRange=tt,this.children=[],n.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(n.validate)}};j=n=je([a],j),e.DocumentSymbol=j;var Z;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(B,re){this.title=B,this.kind=re}};ne=je([a],ne),e.CodeAction=ne;let oe=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};oe.sep=".",oe=o=je([a],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let J=class{constructor(B,re){if(this.range=B,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=je([a],J),e.SelectionRange=J;class ce{constructor(B,re,ke,Ge,tt,at){this.kind=B,this.name=re,this.detail=ke,this.uri=Ge,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=ce;class me{constructor(B,re){this.fromRanges=re,this.from=B}}e.CallHierarchyIncomingCall=me;class Le{constructor(B,re){this.fromRanges=re,this.to=B}}e.CallHierarchyOutgoingCall=Le;let We=class{constructor(B,re){this.range=B,this.command=re}get isResolved(){return!!this.command}};We=je([a],We),e.CodeLens=We;let Ee=v=class{constructor(B,re=!1){c.set(this,void 0),it(this,c,new k.MarkdownString(B,{supportThemeIcons:re}),"f")}static isMarkdownString(B){return B instanceof v?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return Be(this,c,"f").value}set value(B){Be(this,c,"f").value=B}get isTrusted(){return Be(this,c,"f").isTrusted}set isTrusted(B){Be(this,c,"f").isTrusted=B}get supportThemeIcons(){return Be(this,c,"f").supportThemeIcons}appendText(B){return Be(this,c,"f").appendText(B),this}appendMarkdown(B){return Be(this,c,"f").appendMarkdown(B),this}appendCodeblock(B,re){return Be(this,c,"f").appendCodeblock(re??"",B),this}};c=new WeakMap,Ee=v=je([a],Ee),e.MarkdownString=Ee;let Ke=class{constructor(B,re){this.label=B,this.documentation=re}};Ke=je([a],Ke),e.ParameterInformation=Ke;let K=class{constructor(B,re){this.label=B,this.documentation=re,this.parameters=[]}};K=je([a],K),e.SignatureInformation=K;let ie=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ie=je([a],ie),e.SignatureHelp=ie;var ve;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(B,re,ke){this.text=B,this.position=re,this.kind=ke}};Ne=je([a],Ne),e.InlayHint=Ne;var Qe;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var Se;(function(V){V[V.Deprecated=1]="Deprecated"})(Se=e.CompletionItemTag||(e.CompletionItemTag={}));let Pe=class{constructor(B,re){this.label=B,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pe=je([a],Pe),e.CompletionItem=Pe;let ae=class{constructor(B=[],re=!1){this.items=B,this.isIncomplete=re}};ae=je([a],ae),e.CompletionList=ae;let fe=class{constructor(B,re,ke){this.text=B,this.range=re,this.command=ke}};fe=je([a],fe),e.InlineSuggestion=fe;let H=class{constructor(B){this.items=B}};H=je([a],H),e.InlineSuggestions=H;var ee;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var ue;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ze;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function B(re){switch(re){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=B}(ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Je=class{constructor(B,re){if(re&&!S.URI.isUri(re))throw L.illegalArgument("target");if(!$.isRange(B)||B.isEmpty)throw L.illegalArgument("range");this.range=B,this.target=re}};Je=je([a],Je),e.DocumentLink=Je;let Xe=class{constructor(B,re,ke,Ge){this.red=B,this.green=re,this.blue=ke,this.alpha=Ge}};Xe=je([a],Xe),e.Color=Xe;let nt=class{constructor(B,re){if(re&&!(re instanceof Xe))throw L.illegalArgument("color");if(!$.isRange(B)||B.isEmpty)throw L.illegalArgument("range");this.range=B,this.color=re}};nt=je([a],nt),e.ColorInformation=nt;let gt=class{constructor(B){if(!B||typeof B!="string")throw L.illegalArgument("label");this.label=B}};gt=je([a],gt),e.ColorPresentation=gt;var _e;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(_e=e.ColorFormat||(e.ColorFormat={}));var ye;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class de{constructor(B,re,ke){if(this.startIndex=B,this.length=re,this.tooltip=ke,typeof B!="number"||B<0)throw L.illegalArgument("startIndex");if(typeof re!="number"||re<1)throw L.illegalArgument("length");if(ke!==void 0&&typeof ke!="string")throw L.illegalArgument("tooltip")}}e.TerminalLink=de;class Q{constructor(B){this.options=B,typeof B!="object"&&L.illegalArgument("options")}}e.TerminalProfile=Q;var xe;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var we;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(we=e.TaskPanelKind||(e.TaskPanelKind={}));let Ye=m=class{constructor(B,re){if(typeof B!="string"||typeof re!="string")throw L.illegalArgument("name");this._id=B}static from(B){switch(B){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};Ye.Clean=new m("clean","Clean"),Ye.Build=new m("build","Build"),Ye.Rebuild=new m("rebuild","Rebuild"),Ye.Test=new m("test","Test"),Ye=m=je([a],Ye),e.TaskGroup=Ye;function et(V){let B="";for(let re=0;re<V.length;re++)B+=V[re].replace(/,/g,",,")+",";return B}let rt=class{constructor(B,re,ke){if(typeof B!="string")throw L.illegalArgument("process");this._args=[],this._process=B,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process(B){if(typeof B!="string")throw L.illegalArgument("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let re of this._args)B.push(re);return et(B)}};rt=je([a],rt),e.ProcessExecution=rt;let st=class{constructor(B,re,ke){if(this._args=[],Array.isArray(re)){if(!B)throw L.illegalArgument("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw L.illegalArgument("command");this._command=B,this._args=re,this._options=ke}else{if(typeof B!="string")throw L.illegalArgument("commandLine");this._commandLine=B,this._options=re}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw L.illegalArgument("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw L.illegalArgument("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)B.push(typeof re=="string"?re:re.value);return et(B)}};st=je([a],st),e.ShellExecution=st;var pt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Et{constructor(B){this._callback=B}computeId(){return"customExecution"+C.generateUuid()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=Et;let vt=_=class{constructor(B,re,ke,Ge,tt,at){this.__deprecated=!1,this._definition=this.definition=B;let lt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ge,lt=tt,this.__deprecated=!0):re===wt.Global||re===wt.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=tt,lt=at):(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=tt,lt=at),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof rt?this._definition={type:_.ProcessType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:_.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:_.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:_.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(B){if(B==null)throw L.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw L.illegalArgument("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const re=this._definition.type;(_.EmptyType===re||_.ProcessType===re||_.ShellType===re||_.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw L.illegalArgument("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=_=je([a],vt),e.Task=vt;var xt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));let _t=class{constructor(B,re=ht.None){this.collapsibleState=re,S.URI.isUri(B)?this.resourceUri=B:this.label=B}};_t=je([a],_t),e.TreeItem=_t;var ht;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ct=class{constructor(B,re){this.id=B,this.color=re}};ct=je([a],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let dt=class{constructor(B){this.id=B}};dt=je([a],dt),e.ThemeColor=dt;var Ht;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(B,re){if(typeof B!="string"&&(!B||!S.URI.isUri(B)&&!S.URI.isUri(B.uri)))throw L.illegalArgument("base");if(typeof re!="string")throw L.illegalArgument("pattern");typeof B=="string"?(this.baseFolder=S.URI.file(B),this.base=B):S.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=re}};kt=je([a],kt),e.RelativePattern=kt;let At=class{constructor(B,re,ke,Ge){this.enabled=typeof B=="boolean"?B:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};At=je([a],At),e.Breakpoint=At;let Kt=class extends At{constructor(B,re,ke,Ge,tt){super(re,ke,Ge,tt);if(B===null)throw L.illegalArgument("location");this.location=B}};Kt=je([a],Kt),e.SourceBreakpoint=Kt;let St=class extends At{constructor(B,re,ke,Ge,tt){super(re,ke,Ge,tt);this.functionName=B}};St=je([a],St),e.FunctionBreakpoint=St;let en=class extends At{constructor(B,re,ke,Ge,tt,at,lt){super(Ge,tt,at,lt);if(!re)throw L.illegalArgument("dataId");this.label=B,this.dataId=re,this.canPersist=ke}};en=je([a],en),e.DataBreakpoint=en;let tn=class{constructor(B,re,ke){this.command=B,this.args=re||[],this.options=ke}};tn=je([a],tn),e.DebugAdapterExecutable=tn;let mt=class{constructor(B,re){this.port=B,this.host=re}};mt=je([a],mt),e.DebugAdapterServer=mt;let Qt=class{constructor(B){this.path=B}};Qt=je([a],Qt),e.DebugAdapterNamedPipeServer=Qt;let zt=class{constructor(B){this.implementation=B}};zt=je([a],zt),e.DebugAdapterInlineImplementation=zt;let nn=class{constructor(B,re){this.range=B,this.expression=re}};nn=je([a],nn),e.EvaluatableExpression=nn;var yn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(yn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dt=class{constructor(B,re){this.range=B,this.text=re}};Dt=je([a],Dt),e.InlineValueText=Dt;let Xt=class{constructor(B,re,ke=!0){this.range=B,this.variableName=re,this.caseSensitiveLookup=ke}};Xt=je([a],Xt),e.InlineValueVariableLookup=Xt;let rn=class{constructor(B,re){this.range=B,this.expression=re}};rn=je([a],rn),e.InlineValueEvaluatableExpression=rn;let Bt=class{constructor(B,re){this.frameId=B,this.stoppedLocation=re}};Bt=je([a],Bt),e.InlineValueContext=Bt;var ut;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(ut=e.FileChangeType||(e.FileChangeType={}));let sn=D=class extends Error{constructor(B,re=r.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(S.URI.isUri(B)?B.toString(!0):B);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",r.markAsFileSystemProviderError(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(B){return new D(B,r.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(B){return new D(B,r.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(B){return new D(B,r.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(B){return new D(B,r.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(B){return new D(B,r.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(B){return new D(B,r.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};sn=D=je([a],sn),e.FileSystemError=sn;let Tt=class{constructor(B,re,ke){this.start=B,this.end=re,this.kind=ke}};Tt=je([a],Tt),e.FoldingRange=Tt;var Vt;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Vt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Dn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Dn=e.CommentMode||(e.CommentMode={}));class mn{constructor(B,re=[]){this.tokenTypes=B,this.tokenModifiers=re}}e.SemanticTokensLegend=mn;function Cn(V){return typeof V=="undefined"||P.isStringArray(V)}class Yt{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let re=0,ke=B.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set(B.tokenTypes[re],re);for(let re=0,ke=B.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set(B.tokenModifiers[re],re)}}push(B,re,ke,Ge,tt){if(typeof B=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(B,re,ke,Ge,tt);if($.isRange(B)&&typeof re=="string"&&Cn(ke))return this._push(B,re,ke);throw L.illegalArgument()}_push(B,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=B.start.line,tt=B.start.character,at=B.end.character-B.start.character,lt=this._tokenTypeStrToInt.get(re);let yt=0;if(ke)for(const Pt of ke){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(Pt);yt|=1<<Lt>>>0}this._pushEncoded(Ge,tt,at,lt,yt)}_pushEncoded(B,re,ke,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Pt=0,Lt=0;for(let Mt=0;Mt<yt;Mt++){let Nt=this._data[5*Mt],dn=this._data[5*Mt+1];Nt===0?(Nt=Pt,dn+=Lt):Nt+=Pt,this._data[5*Mt]=Nt,this._data[5*Mt+1]=dn,Pt=Nt,Lt=dn}}let at=B,lt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=B,this._prevChar=re}static _sortAndDeltaEncode(B){let re=[];const ke=B.length/5|0;for(let lt=0;lt<ke;lt++)re[lt]=lt;re.sort((lt,yt)=>{const Pt=B[5*lt],Lt=B[5*yt];if(Pt===Lt){const Mt=B[5*lt+1],Nt=B[5*yt+1];return Mt-Nt}return Pt-Lt});const Ge=new Uint32Array(B.length);let tt=0,at=0;for(let lt=0;lt<ke;lt++){const yt=5*re[lt],Pt=B[yt+0],Lt=B[yt+1],Mt=B[yt+2],Nt=B[yt+3],dn=B[yt+4],Nn=Pt-tt,Wn=Nn===0?Lt-at:Lt,hn=5*lt;Ge[hn+0]=Nn,Ge[hn+1]=Wn,Ge[hn+2]=Mt,Ge[hn+3]=Nt,Ge[hn+4]=dn,tt=Pt,at=Lt}return Ge}build(B){return this._dataIsSortedAndDeltaEncoded?new Ft(new Uint32Array(this._data),B):new Ft(Yt._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=Yt;class Ft{constructor(B,re){this.resultId=re,this.data=B}}e.SemanticTokens=Ft;class kn{constructor(B,re,ke){this.start=B,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=kn;class on{constructor(B,re){this.resultId=re,this.edits=B}}e.SemanticTokensEdits=on;var an;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pn;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(Pn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new ct("arrow-left")},Jt=je([a],Jt),e.QuickInputButtons=Jt;var Ot;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(Ot=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(B,re,ke){this.badge=B,this.tooltip=re,this.color=ke}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=In;let ln=class{constructor(B){this.kind=B}};ln=je([a],ln),e.ColorTheme=ln;var An;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{constructor(B,re){if(B<0)throw L.illegalArgument("start must be positive");if(re<0)throw L.illegalArgument("end must be positive");B<=re?(this._start=B,this._end=re):(this._start=re,this._end=B)}static isNotebookRange(B){return B instanceof jt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let re=this._start,ke=this._end;return B.start!==void 0&&(re=B.start),B.end!==void 0&&(ke=B.end),re===this._start&&ke===this._end?this:new jt(re,ke)}}e.NotebookRange=jt;class Rt{constructor(B,re,ke,Ge,tt,at){this.kind=B,this.value=re,this.languageId=ke,this.outputs=Ge??[],this.metadata=tt,this.executionSummary=at,Rt.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(re=>Rt.isNotebookCellData(re))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Rt;class gn{constructor(B){this.cells=B}}e.NotebookData=gn;class It{constructor(B,re){this.data=B,this.mime=re;const ke=A.normalizeMimeType(re,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+re);this.mime=ke}static isNotebookCellOutputItem(B){return B instanceof It?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const re={name:B.name,message:B.message,stack:B.stack};return It.json(re,"application/vnd.code.notebook.error")}static stdout(B){return It.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return It.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,re="application/octet-stream"){return new It(B,re)}static text(B,re=A.Mimes.text){const ke=Be(It,f,"f",E).encode(String(B));return new It(ke,re)}static json(B,re="application/json"){const ke=JSON.stringify(B,void 0,"	");return It.text(ke,re)}}e.NotebookCellOutputItem=It,f=It,E={value:new TextEncoder};class $t{constructor(B,re,ke){this.items=$t.ensureUniqueMimeTypes(B,!0),typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=C.generateUuid(),this.metadata=re??ke)}static isNotebookCellOutput(B){return B instanceof $t?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&P.isArray(B.items)}static ensureUniqueMimeTypes(B,re=!1){const ke=new Set,Ge=new Set;for(let tt=0;tt<B.length;tt++){const at=B[tt],lt=A.normalizeMimeType(at.mime);if(!ke.has(lt)){ke.add(lt);continue}Ge.add(tt),re&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?B:B.filter((tt,at)=>!Ge.has(at))}}e.NotebookCellOutput=$t;var Oe;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Oe=e.NotebookCellKind||(e.NotebookCellKind={}));var cn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pn;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(pn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ft;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(ft=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Tn{constructor(B,re){this.text=B,this.alignment=re}}e.NotebookCellStatusBarItem=Tn;var Rn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Rn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class vn{constructor(B,re=[]){this.uri=B,this.provides=p.asArray(re)}}e.NotebookRendererScript=vn;let Zt=class{constructor(B,re){this.label=B,this.timestamp=re}};Zt=je([a],Zt),e.TimelineItem=Zt;var un;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var Ln;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Ln=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class Mn{constructor(B,re){this.ranges=B,this.wordPattern=re}}e.LinkedEditingRanges=Mn;class wn{constructor(B,re){this._port=B,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=wn;var On;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var bn;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information",V[V.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var En;(function(V){V[V.Pending=0]="Pending",V[V.Resolved=1]="Resolved"})(En=e.TestItemStatus||(e.TestItemStatus={}));const Wt=(V,B,re,ke)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(tt){ke(Ge,tt)||(Ge=tt,V.bus.fire([3,B,tt]))}}},qt=(V,B)=>V===B,te=(V,B)=>V===B?!0:!V||!B?!1:V.isEqual(B);class he{constructor(B,re,ke,Ge){this.label=re,this.data=Ge;const tt=l.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new y.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:Wt(tt,"range",void 0,te),description:Wt(tt,"description",void 0,qt),runnable:Wt(tt,"runnable",!0,qt),debuggable:Wt(tt,"debuggable",!1,qt),status:Wt(tt,"status",En.Resolved,qt),error:Wt(tt,"error",void 0,qt)})}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){const B=l.getPrivateApiFor(this);B.parent&&l.getPrivateApiFor(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof he))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=l.getPrivateApiFor(this);if(re.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);re.children.set(B.id,B),l.getPrivateApiFor(B).parent=this,re.bus.fire([0,B])}}e.TestItemImpl=he;class Te{constructor(B){this.message=B,this.severity=bn.Error}static diff(B,re,ke){const Ge=new Te(B);return Ge.expectedOutput=re,Ge.actualOutput=ke,Ge}}e.TestMessage=Te;var ot;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(ot=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ct;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore"})(Ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[119],pe([0,1,50,10,8,144,107,7,18]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function r(c,f){f?C.set(c,f):C.delete(c)}e.setWordDefinitionFor=r;function I(c){return C.get(c)}e.getWordDefinitionFor=I;class l extends y.MirrorTextModel{constructor(f,E,w,b,u,d,g,t){super(E,w,b,u);this._proxy=f,this._languageId=d,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){p.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return S.equals(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===L.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(E){return E?f._getTextInRange(E):f.getText()},get eol(){return f._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(E){return f._lineAt(E)},offsetAt(E){return f._offsetAt(E)},positionAt(E){return f._positionAt(E)},validateRange(E){return f._validateRange(E)},validatePosition(E){return f._validatePosition(E)},getWordRangeAtPosition(E,w){return f._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(f){p.ok(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){p.ok(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const E=this._validateRange(f);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,b=E.start.line,u=E.end.line,d=[];d.push(this._lines[b].substring(E.start.character));for(let g=b+1;g<u;g++)d.push(this._lines[g]);return d.push(this._lines[u].substring(0,E.end.character)),d.join(w)}_lineAt(f){let E;if(f instanceof P.Position?E=f.line:typeof f=="number"&&(E=f),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new h(E,this._lines[E],E===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(f),w=this._lines[E.index].length;return new P.Position(E.index,Math.min(E.remainder,w))}_validateRange(f){if(!(f instanceof P.Range))throw new Error("Invalid argument");const E=this._validatePosition(f.start),w=this._validatePosition(f.end);return E===f.start&&w===f.end?f:new P.Range(E.line,E.character,w.line,w.character)}_validatePosition(f){if(!(f instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:E,character:w}=f,b=!1;if(E<0)E=0,w=0,b=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,b=!0;else{const u=this._lines[E].length;w<0?(w=0,b=!0):w>u&&(w=u,b=!0)}return b?new P.Position(E,w):f}_getWordRangeAtPosition(f,E){const w=this._validatePosition(f);if(!E)E=I(this._languageId);else if(k.regExpLeadsToEndlessLoop(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const b=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(E),this._lines[w.line],0);if(b)return new P.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(f,E,w){this._line=f,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(ge[194],pe([0,1,7,3,109,6,76,23,2,32]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(l,h,c,f){this._notebook=c,this._selector=f,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const l=[],h=[];for(const c of this._notebook.getCells())c.kind===p.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),h.push(c.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){var h,c;if(!l){let u="";for(const d of this._cells)u+=d.document.getText()+`
`;return u=u.slice(0,-1),u}if(l.isEmpty)return"";const f=this.locationAt(l.start),E=this.locationAt(l.end),w=this._cells[(h=this._cellUris.get(f.uri))!==null&&h!==void 0?h:-1],b=this._cells[(c=this._cellUris.get(E.uri))!==null&&c!==void 0?c:-1];if(!w||!b)return"";if(w===b)return w.document.getText(new p.Range(f.range.start,E.range.end));{const u=w.document.getText(new p.Range(f.range.start,new p.Position(w.document.lineCount,0))),d=b.document.getText(new p.Range(new p.Position(0,0),E.range.end));return u+`
`+d}}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getPrefixSum(h.index-1),f=this._cells[h.index].document.offsetAt(l.with(h.remainder));return c+f}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),f=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(f)}const h=this._cellUris.get(l.uri);if(h!==void 0){const c=this._cellLines.getPrefixSum(h-1);return new p.Position(c+l.range.start.line,l.range.start.character)}return new p.Position(0,0)}locationAt(l){p.Range.isRange(l)||(l=new p.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let c=h;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const f=new p.Position(h.remainder,l.start.character),E=new p.Position(c.remainder,l.end.character),w=new p.Range(f,E),b=this._cells[h.index];return new p.Location(b.document.uri,b.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(h,c)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),c=new p.Position(h.remainder,l.character),f=this._cells[h.index].document.validatePosition(c),E=this._cellLines.getPrefixSum(h.index-1);return new p.Position(E+f.line,f.character)}}e.ExtHostNotebookConcatDocument=r}),define(ge[195],pe([0,1,7,13,3]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(P){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let S=P==="light"?p.ColorThemeKind.Light:P==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=je([$e(0,L.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(ge[59],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=p.createDecorator("IURITransformerService");class L{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=L}),define(ge[196],pe([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function k(P,S){if(S.serializeBuffersForPostMessage){const C=new L,r=(h,c)=>{if(c instanceof ArrayBuffer){const f=C.add(c);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(c)){const f=y(c);if(f){const E=C.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:f,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(P,r),l=C.buffers.map(h=>{const c=new Uint8Array(h);return p.VSBuffer.wrap(c)});return{message:I,buffers:l}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=k;function y(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,S){const C=S.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),r=S.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const c=h,{index:f}=c,E=C[f];if(c.view)switch(c.view.type){case 1:return new Int8Array(E,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return h}:void 0;return{message:JSON.parse(P,r),arrayBuffers:C}}e.deserializeWebviewMessage=A}),define(ge[84],pe([0,1,10,2]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,A){return y.scheme===p.Schemas.http||y.scheme===p.Schemas.https?y:(A&&A.authority&&A.isRemote&&y.scheme===p.Schemas.file&&(y=L.URI.from({scheme:p.Schemas.vscodeRemote,authority:A.authority,path:y.path})),L.URI.from({scheme:p.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k}),define(ge[197],pe([0,1,3,6,84]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(P,S,C){this._proxy=P,this._editors=S,this._initData=C,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const r=S.getVisibleTextEditors();for(const I of this._insets.values())r.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,S,C,r,I){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===P){l=u;break}if(!l)throw new Error("not a visible editor");const h=this,c=this._handlePool++,f=new p.Emitter,E=new p.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return k.asWebviewUri(u,h._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(u){this._options=u,h._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,h._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(u){return h._proxy.$postMessage(c,u)}},b=new class{constructor(){this.editor=P,this.line=S,this.height=C,this.webview=w,this.onDidDispose=E.event}dispose(){h._insets.has(c)&&(h._insets.delete(c),h._proxy.$disposeEditorInset(c),E.fire(),E.dispose(),f.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,S+1,C,r||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:P,inset:b,onDidReceiveMessage:f}),b}$onDidDispose(P){const S=this._insets.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){const C=this._insets.get(P);C&&C.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=y}),define(ge[120],pe([0,1,3,16,166]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,S,C,r){const I={command:P};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof r=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(I.seq);if(h){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:P,message:k.localize(0,null,r,P)};h(c)}},r)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,S){return P.type!=="event"||S.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await L.timeout(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const S=P,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}internalSend(P,S){S.type=P,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((S,C)=>P.set(C,S)),await L.timeout(500),P.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(ge[198],pe([0,1,8,2,9,25,10]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function S(i,s,n){return i.replace(P,function(o,v){return s&&v.length>0&&v[0]!=="_"?o:n&&n.hasOwnProperty(v)?n[v]:o})}e.formatPII=S;function C(i){const s={};for(const n of Object.keys(i))n.startsWith("!")||(s[n]=i[n]);return s}e.filterExceptionsFromTelemetry=C;function r(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||r(i.parentSession))}e.isSessionAttach=r;function I(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),p.equalsIgnoreCase(s,"extensionhost")||p.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=l;function h(i,s,n){let o,v=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=m.exec(i);){let D=_.index+1,a=D+_[0].length;if(D<=s&&a>=n){o=_[0],v=D;break}}if(o){let D=/\w+/g,a=null;for(;(a=D.exec(o))&&!(a.index+1+v+a[0].length>=n););a&&(o=o.substring(0,D.lastIndex))}return o?{start:v,end:v+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(i){return!!(i&&i.match(c))}e.isUri=f;function E(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(f(i.path))return L.URI.parse(i.path);if(k.isAbsolute(i.path))return L.URI.file(i.path)}return i.path}function w(i){if(typeof i.path=="object"){const s=L.URI.revive(i.path);if(s)return s.scheme===A.Schemas.file?s.fsPath:s.toString()}return i.path}function b(i,s){const n=s?E:w,o=y.deepClone(i);return d(o,(v,m)=>{v&&m&&(m.path=n(m))}),o}e.convertToDAPaths=b;function u(i,s){const n=s?E:w,o=y.deepClone(i);return d(o,(v,m)=>{!v&&m&&(m.path=n(m))}),o}e.convertToVSCPaths=u;function d(i,s){switch(i.type){case"event":const n=i;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break;case"request":const o=i;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const v=i;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":v.body.sources.forEach(m=>s(!1,m));break;case"scopes":v.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function g(i){return i.filter(s=>{var n;return!((n=s.presentation)===null||n===void 0?void 0:n.hidden)}).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):t(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(ge[199],pe([0,1,28,38,167,121,9,8,25,11,177,120]),function(X,e,p,L,k,y,A,P,S,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",d=>this.handleData(d))}sendMessage(b){if(this.outputStream){const u=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const g=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const t of g){const i=t.split(l.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class h extends l{startSession(){return new Promise((b,u)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",g=>{d?this._onError.fire(g):u(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class c extends h{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=c;class f extends h{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=f;class E extends l{constructor(b,u,d){super();this.adapterExecutable=b,this.debugType=u,this.outputService=d}async startSession(){const b=this.adapterExecutable.command,u=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await p.Promises.exists(b))throw new Error(k.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let g=process.env;if(d.env&&Object.keys(d.env).length>0&&(g=S.mixin(S.deepClone(process.env),d.env)),b==="node")if(Array.isArray(u)&&u.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(s.cwd=d.cwd);const n=L.fork(u[0],u.slice(1),s);if(!n.pid)throw new Error(k.localize(2,null,u[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const i={env:g};d.cwd&&(i.cwd=d.cwd),this.serverProcess=L.spawn(b,u,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,s)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(r.ExtensionsChannelId);n&&n.append(i(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((b,u)=>{const d=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,i){if(g)return u(g)});d.on("exit",b),d.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,u){if(!b)return;const d=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?d.runtime=A.join(u,b.runtime):d.runtime=b.runtime),b.runtimeArgs&&(d.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?d.program=b.program:d.program=A.join(u,b.program)),b.args&&(d.args=b.args);const g=b;return g.win&&(d.win=E.extract(g.win,u)),g.winx86&&(d.winx86=E.extract(g.winx86,u)),g.windows&&(d.windows=E.extract(g.windows,u)),g.osx&&(d.osx=E.extract(g.osx,u)),g.linux&&(d.linux=E.extract(g.linux,u)),d}static platformAdapterExecutable(b,u){let d=Object.create(null);u=u.toLowerCase();for(const o of b)if(o.contributes){const v=o.contributes.debuggers;v&&v.length>0&&v.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,u)).forEach(m=>{const _=E.extract(m,o.extensionLocation.fsPath);d=S.mixin(d,_,o.isBuiltin)})}let g;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=d.winx86||d.win||d.windows:C.isWindows?g=d.win||d.windows:C.isMacintosh?g=d.osx:C.isLinux&&(g=d.linux),g=g||d;let t=g.program||d.program;const i=g.args||d.args;let s=g.runtime||d.runtime;const n=g.runtimeArgs||d.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=E}),define(ge[200],pe([0,1,38,11,29,180]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,h){return new Promise((c,f)=>{let E="";const w=p.spawn(l,h);w.pid&&w.stdout.on("data",b=>{E+=b.toString()}),w.on("error",b=>{f(b)}),w.on("close",b=>{c(E)})})}let P;function S(l,h){if(!P)if(L.isWindows)P=new y.WindowsExternalTerminalService;else if(L.isMacintosh)P=new y.MacExternalTerminalService;else if(L.isLinux)P=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=h.getConfiguration("terminal");return P.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=S;function C(l){return l?L.isWindows?new Promise(async h=>{(await new Promise((f,E)=>{X(["windows-process-tree"],f,E)})).getProcessTree(l,f=>{h(f.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(h=>{const c=h.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=C;var r;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(r||(r={}));function I(l,h,c,f){l=l.trim().toLowerCase();let E;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?E=1:l.indexOf("cmd.exe")>=0?E=0:l.indexOf("bash")>=0?E=2:L.isWindows?E=0:E=2;let w,b=" ";switch(E){case 1:if(w=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),c){const d=k.getDriveLetter(c);d&&(b+=`${d}:; `),b+=`cd ${w(c)}; `}if(f)for(let d in f){const g=f[d];g===null?b+=`Remove-Item env:${d}; `:b+=`\${env:${d}}='${g}'; `}if(h.length>0){const d=w(h.shift());b+=d[0]==="'"?`& ${d} `:`${d} `;for(let g of h)b+=`${w(g)} `}break;case 0:if(w=d=>(d=d.replace(/\"/g,'""'),d.indexOf(" ")>=0||d.indexOf('"')>=0||d.length===0?`"${d}"`:d),c){const d=k.getDriveLetter(c);d&&(b+=`${d}: && `),b+=`cd ${w(c)} && `}if(f){b+='cmd /C "';for(let d in f){let g=f[d];g===null?b+=`set "${d}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${d}=${g}" && `)}}for(let d of h)b+=`${w(d)} `;f&&(b+='"');break;case 2:w=d=>(d=d.replace(/(["'\\\$])/g,"\\$1"),d.indexOf(" ")>=0||d.indexOf(";")>=0||d.length===0?`"${d}"`:d);const u=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(c&&(b+=`cd ${w(c)} ; `),f){b+="/usr/bin/env";for(let d in f){const g=f[d];g===null?b+=` -u ${u(d)}`:b+=` ${u(`${d}=${g}`)}`}b+=" "}for(let d of h)b+=`${w(d)} `;break}return b}e.prepareCommand=I}),define(ge[85],pe([0,1,30,98,10,9,11,112]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var r;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(r=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var E;(function(a){a.scheme=k.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function M(U,z){return U.with({scheme:a.scheme,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==k.Schemas.file?U.scheme:""}`})}a.generate=M;function $(U){if(U.scheme!==a.scheme)return;const z=R.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parse=$;function Y(U){if(U.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const z=R.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=Y;function le(U,z,O){return U.with({scheme:O,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==k.Schemas.file?U.scheme:""}`})}a.generateCellUri=le;function q(U,z){if(U.scheme!==z)return;const O=R.exec(U.fragment);return O?{handle:Number(O[1]),notebook:U.with({scheme:U.fragment.substr(O[0].length)||k.Schemas.file,fragment:null})}:void 0}a.parseCellUri=q})(E=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(a){var R,M;return(M=(R=w.get(a))===null||R===void 0?void 0:R.alwaysSecure)!==null&&M!==void 0?M:!1}e.mimeTypeIsAlwaysSecure=b;function u(a){var R,M;return(M=(R=w.get(a))===null||R===void 0?void 0:R.supportedByCore)!==null&&M!==void 0?M:!1}e.mimeTypeSupportedByCore=u;function d(a){var R,M;return(M=(R=w.get(a))===null||R===void 0?void 0:R.mergeable)!==null&&M!==void 0?M:!1}e.mimeTypeIsMergeable=d;function g(a,R){return A.isWindows&&(a=a.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),p.match(a,R)}function t(a,R,M){let $=0;for(let Y=0;Y<R.length;Y++){if(g(R[Y],a))return $;$++}for(let Y=0;Y<M.length;Y++){if(g(M[Y],a))return $;$++}return $}function i(a,R,M){return a.sort(($,Y)=>t($,R,M)-t(Y,R,M))}e.sortMimeTypes=i;function s(a,R,M,$=(Y,le)=>Y===le){const Y=[];function le(z,O,W){if(O===0&&W.length===0)return;const T=Y[Y.length-1];T&&T.start+T.deleteCount===z?(T.deleteCount+=O,T.toInsert.push(...W)):Y.push({start:z,deleteCount:O,toInsert:W})}let q=0,U=0;for(;;){if(q===a.length){le(q,0,R.slice(U));break}if(U===R.length){le(q,a.length-q,[]);break}const z=a[q],O=R[U];if($(z,O)){q+=1,U+=1;continue}M(O)?(le(q,1,[]),q+=1):(le(q,0,[O]),U+=1)}return Y}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const R=a;return!!((typeof R.include=="string"||p.isRelativePattern(R.include))&&(typeof R.exclude=="string"||p.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=o;function v(a,R,M){if(Array.isArray(a.viewType)&&a.viewType.indexOf(R)>=0||a.viewType===R)return!0;if(a.filenamePattern){let $=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,Y=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(p.match($,y.basename(M.fsPath).toLowerCase()))return!(Y&&p.match(Y,y.basename(M.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class m{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let M=0;M<this.textModel.cells.length;M++)R[M]=this.textModel.cells[M].getHashValue();return R}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var _;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(_=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class D{static create(R){return`${D._prefix}${R}`}static parse(R){if(R.startsWith(D._prefix))return R.substr(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/"}),define(ge[201],pe([0,1,169,4,112]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=L.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[202],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=p;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(ge[122],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var p;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));const L=(S,C)=>{C.expand!==void 0&&(S.expand=C.expand),C.item!==void 0&&(S.item=S.item?Object.assign(S.item,C.item):C.item)};e.applyTestItemUpdate=L;var k;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));const y=(S,C)=>`${S}:${C.toString()}`;e.getTestSubscriptionKey=y;class A{add(C){}update(C){}remove(C,r){}complete(){}}e.IncrementalChangeCollector=A;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const r=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const l=I[1];if(l.parent){if(this.items.has(l.parent)){const h=this.items.get(l.parent);h.children.add(l.item.extId);const c=this.createItem(l,h);this.items.set(l.item.extId,c),r.add(c)}}else{this.roots.add(l.item.extId);const h=this.createItem(l);this.items.set(l.item.extId,h),r.add(h)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=I[1],h=this.items.get(l.extId);if(!h)break;l.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,l),r.update(h);break}case 2:{const l=this.items.get(I[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l.item.extId);const h=[[I[1]]];for(;h.length;)for(const c of h.pop()){const f=this.items.get(c);f&&(h.push(f.children),this.items.delete(c),r.remove(f,f!==l),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}r.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=P}),define(ge[203],pe([0,1,9,37,15,25,11,75,170]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,l,h){this._contributedVariables=new Map,this._context=I,this._labelService=l,h&&(this._envVariablesPromise=h.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(A.isWindows){const l=Object.create(null);return Object.keys(I).forEach(h=>{l[h.toLowerCase()]=I[h]}),l}return I}resolveWithEnvironment(I,l,h){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,h)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,h,c){const f=y.deepClone(l);return A.isWindows&&f.windows?Object.keys(f.windows).forEach(E=>f[E]=f.windows[E]):A.isMacintosh&&f.osx?Object.keys(f.osx).forEach(E=>f[E]=f.osx[E]):A.isLinux&&f.linux&&Object.keys(f.linux).forEach(E=>f[E]=f.linux[E]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,f,h,c)}async resolveAnyAsync(I,l,h){return this.resolveAnyBase(I,l,h)}async resolveAnyMap(I,l,h){const c=new Map;return{newConfig:await this.resolveAnyBase(I,l,h,c),resolvedVariables:c}}resolveWithInteractionReplace(I,l,h,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,h,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,h,c,f){if(k.isString(h))return this.resolveString(I,l,h,c,f);if(k.isArray(h))return h.map(E=>this.recursiveResolve(I,l,E,c,f));if(k.isObject(h)){let E=Object.create(null);return Object.keys(h).forEach(w=>{const b=this.resolveString(I,l,w,c,f);E[b]=this.recursiveResolve(I,l,h[w],c,f)}),E}return h}resolveString(I,l,h,c,f){return h.replace(C.VARIABLE_REGEXP,(w,b)=>{if(b.includes(C.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(I,w,b,l,c);return f&&f.set(b,u),u!==w&&k.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(I,l,u,c,f)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,h,c,f){let E;const w=h.split(":");w.length>1&&(h=w[0],E=w[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(S.localize(0,null,l))},u=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(S.localize(1,null,l,p.basename(g)))},d=()=>{if(E){const g=this._context.getFolderUri(E);if(g)return g;throw new Error(S.localize(2,null,l,E))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(S.localize(3,null,l)):new Error(S.localize(4,null,l))};switch(h){case"env":if(E){if(I){const g=I[A.isWindows?E.toLowerCase():E];if(k.isString(g))return g}return""}throw new Error(S.localize(5,null,l));case"config":if(E){const g=this._context.getConfigurationValue(c,E);if(k.isUndefinedOrNull(g))throw new Error(S.localize(6,null,l,E));if(k.isObject(g))throw new Error(S.localize(7,null,l,E));return g}throw new Error(S.localize(8,null,l));case"command":return this.resolveFromMap(l,E,f,"command");case"input":return this.resolveFromMap(l,E,f,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return P.normalizeDriveLetter(this.fsPath(d()));case"cwd":return c||E?P.normalizeDriveLetter(this.fsPath(d())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(d()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(S.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(S.localize(10,null,l));case"file":return b();case"fileWorkspaceFolder":return u();case"relativeFile":return c||E?p.relative(this.fsPath(d()),b()):b();case"relativeFileDirname":const i=p.dirname(b());if(c||E){const v=p.relative(this.fsPath(d()),i);return v.length===0?".":v}return i;case"fileDirname":return p.dirname(b());case"fileExtname":return p.extname(b());case"fileBasename":return p.basename(b());case"fileBasenameNoExtension":const s=p.basename(b());return s.slice(0,s.length-p.extname(s).length);case"fileDirnameBasename":return p.basename(p.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const o=this._context.getAppRoot();return o||l;case"pathSeparator":return p.sep;default:try{const v=E?`${h}:${E}`:h;return this.resolveFromMap(l,v,f,void 0)}catch(v){return l}}}}resolveFromMap(I,l,h,c){if(l&&h){const f=c===void 0?h[l]:h[c+":"+l];if(typeof f=="string")return f;throw new Error(S.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[204],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=p.createDecorator("editorGroupsService");var L;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(L=e.GroupDirection||(e.GroupDirection={}));var k;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function I(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ge[205],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=p.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[17],pe([0,1,18,95,278,54,25,15,2,41,78,171,114,85,205,7]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(_e){function ye(Q){const{selectionStartLineNumber:xe,selectionStartColumn:we,positionLineNumber:Ye,positionColumn:et}=Q,rt=new f.Position(xe-1,we-1),st=new f.Position(Ye-1,et-1);return new f.Selection(rt,st)}_e.to=ye;function de(Q){const{anchor:xe,active:we}=Q;return{selectionStartLineNumber:xe.line+1,selectionStartColumn:xe.character+1,positionLineNumber:we.line+1,positionColumn:we.character+1}}_e.from=de})(E=e.Selection||(e.Selection={}));var w;(function(_e){function ye(Q){if(!Q)return;const{start:xe,end:we}=Q;return{startLineNumber:xe.line+1,startColumn:xe.character+1,endLineNumber:we.line+1,endColumn:we.character+1}}_e.from=ye;function de(Q){if(!Q)return;const{startLineNumber:xe,startColumn:we,endLineNumber:Ye,endColumn:et}=Q;return new f.Range(xe-1,we-1,Ye-1,et-1)}_e.to=de})(w=e.Range||(e.Range={}));var b;(function(_e){function ye(de){switch(de){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}_e.to=ye})(b=e.TokenType||(e.TokenType={}));var u;(function(_e){function ye(Q){return new f.Position(Q.lineNumber-1,Q.column-1)}_e.to=ye;function de(Q){return{lineNumber:Q.line+1,column:Q.character+1}}_e.from=de})(u=e.Position||(e.Position={}));var d;(function(_e){function ye(Q){switch(Q){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}_e.from=ye;function de(Q){switch(Q){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}_e.to=de})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(_e){function ye(Q){let xe;return Q.code&&(P.isString(Q.code)||P.isNumber(Q.code)?xe=String(Q.code):xe={value:String(Q.code.value),target:Q.code.target}),Object.assign(Object.assign({},w.from(Q.range)),{message:Q.message,source:Q.source,code:xe,severity:i.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(t.from),tags:Array.isArray(Q.tags)?p.coalesce(Q.tags.map(d.from)):void 0})}_e.from=ye;function de(Q){var xe;const we=new f.Diagnostic(w.to(Q),Q.message,i.to(Q.severity));return we.source=Q.source,we.code=P.isString(Q.code)?Q.code:(xe=Q.code)===null||xe===void 0?void 0:xe.value,we.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(t.to),we.tags=Q.tags&&p.coalesce(Q.tags.map(d.to)),we}_e.to=de})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function ye(Q){return Object.assign(Object.assign({},w.from(Q.location.range)),{message:Q.message,resource:Q.location.uri})}_e.from=ye;function de(Q){return new f.DiagnosticRelatedInformation(new f.Location(Q.resource,w.to(Q)),Q.message)}_e.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ye(Q){switch(Q){case f.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ye;function de(Q){switch(Q){case l.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}_e.to=de})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(_e){function ye(Q){return typeof Q=="number"&&Q>=f.ViewColumn.One?Q-1:Q===f.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}_e.from=ye;function de(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=de})(s=e.ViewColumn||(e.ViewColumn={}));function n(_e){return typeof _e.range!="undefined"}function o(_e){return _e.length===0?!0:!!n(_e[0])}e.isDecorationOptionsArr=o;var v;(function(_e){function ye(et){return et.map(_e.from)}_e.fromMany=ye;function de(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Q(et){let rt;if(de(et)){const{language:Et,value:vt}=et;rt={value:"```"+Et+`
`+vt+"\n```\n"}}else f.MarkdownString.isMarkdownString(et)?rt={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?rt={value:et}:rt={value:""};const st=Object.create(null);rt.uris=st;const pt=Et=>{try{let vt=S.URI.parse(Et,!0);vt=vt.with({query:xe(vt.query,st)}),st[Et]=vt}catch(vt){}return""},wt=new k.Renderer;return wt.link=pt,wt.image=Et=>pt(L.parseHrefAndDimensions(Et).href),k(rt.value,{renderer:wt}),rt}_e.from=Q;function xe(et,rt){if(!et)return et;let st;try{st=y.parse(et)}catch(wt){}if(!st)return et;let pt=!1;return st=A.cloneAndChange(st,wt=>{if(S.URI.isUri(wt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Et]=wt,pt=!0,Et}else return}),pt?JSON.stringify(st):et}function we(et){const rt=new f.MarkdownString(et.value,et.supportThemeIcons);return rt.isTrusted=et.isTrusted,rt}_e.to=we;function Ye(et){if(!!et)return typeof et=="string"?et:_e.from(et)}_e.fromStrict=Ye})(v=e.MarkdownString||(e.MarkdownString={}));function m(_e){return o(_e)?_e.map(ye=>({range:w.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?v.fromMany(ye.hoverMessage):ye.hoverMessage?v.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):_e.map(ye=>({range:w.from(ye)}))}e.fromRangeOrRangeWithMessage=m;function _(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?S.URI.file(_e):_e}e.pathOrURIToURI=_;var D;(function(_e){function ye(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?_(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}_e.from=ye})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(_e){function ye(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?_(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?D.from(de.before):void 0,after:de.after?D.from(de.after):void 0}}_e.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(_e){function ye(de){if(typeof de=="undefined")return de;switch(de){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ye})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(_e){function ye(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?R.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?a.from(de.light):void 0,dark:de.dark?a.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?_(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?D.from(de.before):void 0,after:de.after?D.from(de.after):void 0}}_e.from=ye})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(_e){function ye(Q){return{text:Q.newText,eol:Q.newEol&&K.from(Q.newEol),range:w.from(Q.range)}}_e.from=ye;function de(Q){const xe=new f.TextEdit(w.to(Q.range),Q.text);return xe.newEol=typeof Q.eol=="undefined"?void 0:K.to(Q.eol),xe}_e.to=de})($=e.TextEdit||(e.TextEdit={}));var Y;(function(_e){function ye(Q,xe,we){var Ye,et;const rt={edits:[]};if(Q instanceof f.WorkspaceEdit)for(let st of Q._allEntries())if(st._type===1)rt.edits.push({_type:1,oldUri:st.from,newUri:st.to,options:st.options,metadata:st.metadata});else if(st._type===2){const pt=xe==null?void 0:xe.getDocument(st.uri);rt.edits.push({_type:2,resource:st.uri,edit:$.from(st.edit),modelVersionId:pt==null?void 0:pt.version,metadata:st.metadata})}else st._type===3?rt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,edit:st.edit,notebookMetadata:st.notebookMetadata,notebookVersionId:(Ye=we==null?void 0:we.getNotebookDocument(st.uri,!0))===null||Ye===void 0?void 0:Ye.apiNotebook.version}):st._type===5&&rt.edits.push({_type:3,metadata:st.metadata,resource:st.uri,notebookVersionId:(et=we==null?void 0:we.getNotebookDocument(st.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:st.index,count:st.count,cells:st.cells.map(H.from)}});return rt}_e.from=ye;function de(Q){const xe=new f.WorkspaceEdit;for(const we of Q.edits)we.edit?xe.replace(S.URI.revive(we.resource),w.to(we.edit.range),we.edit.text):xe.renameFile(S.URI.revive(we.oldUri),S.URI.revive(we.newUri),we.options);return xe}_e.to=de})(Y=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(_e){const ye=Object.create(null);ye[f.SymbolKind.File]=0,ye[f.SymbolKind.Module]=1,ye[f.SymbolKind.Namespace]=2,ye[f.SymbolKind.Package]=3,ye[f.SymbolKind.Class]=4,ye[f.SymbolKind.Method]=5,ye[f.SymbolKind.Property]=6,ye[f.SymbolKind.Field]=7,ye[f.SymbolKind.Constructor]=8,ye[f.SymbolKind.Enum]=9,ye[f.SymbolKind.Interface]=10,ye[f.SymbolKind.Function]=11,ye[f.SymbolKind.Variable]=12,ye[f.SymbolKind.Constant]=13,ye[f.SymbolKind.String]=14,ye[f.SymbolKind.Number]=15,ye[f.SymbolKind.Boolean]=16,ye[f.SymbolKind.Array]=17,ye[f.SymbolKind.Object]=18,ye[f.SymbolKind.Key]=19,ye[f.SymbolKind.Null]=20,ye[f.SymbolKind.EnumMember]=21,ye[f.SymbolKind.Struct]=22,ye[f.SymbolKind.Event]=23,ye[f.SymbolKind.Operator]=24,ye[f.SymbolKind.TypeParameter]=25;function de(xe){return typeof ye[xe]=="number"?ye[xe]:6}_e.from=de;function Q(xe){for(const we in ye)if(ye[we]===xe)return Number(we);return f.SymbolKind.Property}_e.to=Q})(le=e.SymbolKind||(e.SymbolKind={}));var q;(function(_e){function ye(Q){switch(Q){case f.SymbolTag.Deprecated:return 1}}_e.from=ye;function de(Q){switch(Q){case 1:return f.SymbolTag.Deprecated}}_e.to=de})(q=e.SymbolTag||(e.SymbolTag={}));var U;(function(_e){function ye(Q){return{name:Q.name,kind:le.from(Q.kind),tags:Q.tags&&Q.tags.map(q.from),containerName:Q.containerName,location:F.from(Q.location)}}_e.from=ye;function de(Q){const xe=new f.SymbolInformation(Q.name,le.to(Q.kind),Q.containerName,F.to(Q.location));return xe.tags=Q.tags&&Q.tags.map(q.to),xe}_e.to=de})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(_e){function ye(Q){var xe,we;const Ye={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:w.from(Q.range),selectionRange:w.from(Q.selectionRange),kind:le.from(Q.kind),tags:(we=(xe=Q.tags)===null||xe===void 0?void 0:xe.map(q.from))!==null&&we!==void 0?we:[]};return Q.children&&(Ye.children=Q.children.map(ye)),Ye}_e.from=ye;function de(Q){const xe=new f.DocumentSymbol(Q.name,Q.detail,le.to(Q.kind),w.to(Q.range),w.to(Q.selectionRange));return p.isNonEmptyArray(Q.tags)&&(xe.tags=Q.tags.map(q.to)),Q.children&&(xe.children=Q.children.map(de)),xe}_e.to=de})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var O;(function(_e){function ye(de){const Q=new f.CallHierarchyItem(le.to(de.kind),de.name,de.detail||"",S.URI.revive(de.uri),w.to(de.range),w.to(de.selectionRange));return Q._sessionId=de._sessionId,Q._itemId=de._itemId,Q}_e.to=ye})(O=e.CallHierarchyItem||(e.CallHierarchyItem={}));var W;(function(_e){function ye(de){return new f.CallHierarchyIncomingCall(O.to(de.from),de.fromRanges.map(Q=>w.to(Q)))}_e.to=ye})(W=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var T;(function(_e){function ye(de){return new f.CallHierarchyOutgoingCall(O.to(de.to),de.fromRanges.map(Q=>w.to(Q)))}_e.to=ye})(T=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var F;(function(_e){function ye(Q){return{range:Q.range&&w.from(Q.range),uri:Q.uri}}_e.from=ye;function de(Q){return new f.Location(S.URI.revive(Q.uri),w.to(Q.range))}_e.to=de})(F=e.location||(e.location={}));var N;(function(_e){function ye(Q){const xe=Q,we=Q;return{originSelectionRange:xe.originSelectionRange?w.from(xe.originSelectionRange):void 0,uri:xe.targetUri?xe.targetUri:we.uri,range:w.from(xe.targetRange?xe.targetRange:we.range),targetSelectionRange:xe.targetSelectionRange?w.from(xe.targetSelectionRange):void 0}}_e.from=ye;function de(Q){return{targetUri:S.URI.revive(Q.uri),targetRange:w.to(Q.range),targetSelectionRange:Q.targetSelectionRange?w.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?w.to(Q.originSelectionRange):void 0}}_e.to=de})(N=e.DefinitionLink||(e.DefinitionLink={}));var x;(function(_e){function ye(Q){return{range:w.from(Q.range),contents:v.fromMany(Q.contents)}}_e.from=ye;function de(Q){return new f.Hover(Q.contents.map(v.to),w.to(Q.range))}_e.to=de})(x=e.Hover||(e.Hover={}));var G;(function(_e){function ye(Q){return{range:w.from(Q.range),expression:Q.expression}}_e.from=ye;function de(Q){return new f.EvaluatableExpression(w.to(Q.range),Q.expression)}_e.to=de})(G=e.EvaluatableExpression||(e.EvaluatableExpression={}));var se;(function(_e){function ye(Q){if(Q instanceof f.InlineValueText)return{type:"text",range:w.from(Q.range),text:Q.text};if(Q instanceof f.InlineValueVariableLookup)return{type:"variable",range:w.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ye;function de(Q){switch(Q.type){case"text":return{range:w.to(Q.range),text:Q.text};case"variable":return{range:w.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:w.to(Q.range),expression:Q.expression}}}_e.to=de})(se=e.InlineValue||(e.InlineValue={}));var be;(function(_e){function ye(Q){return{frameId:Q.frameId,stoppedLocation:w.from(Q.stoppedLocation)}}_e.from=ye;function de(Q){return new f.InlineValueContext(Q.frameId,w.to(Q.stoppedLocation))}_e.to=de})(be=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(_e){function ye(Q){return{range:w.from(Q.range),kind:Q.kind}}_e.from=ye;function de(Q){return new f.DocumentHighlight(w.to(Q.range),Q.kind)}_e.to=de})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(_e){function ye(de){switch(de){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}_e.to=ye})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(_e){function ye(de){return{triggerKind:Ce.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}_e.to=ye})(Me=e.CompletionContext||(e.CompletionContext={}));var qe;(function(_e){function ye(Q){switch(Q){case f.CompletionItemTag.Deprecated:return 1}}_e.from=ye;function de(Q){switch(Q){case 1:return f.CompletionItemTag.Deprecated}}_e.to=de})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));var He;(function(_e){const ye=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function de(we){var Ye;return(Ye=ye.get(we))!==null&&Ye!==void 0?Ye:9}_e.from=de;const Q=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function xe(we){var Ye;return(Ye=Q.get(we))!==null&&Ye!==void 0?Ye:f.CompletionItemKind.Property}_e.to=xe})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function(_e){function ye(de,Q){var xe;const we=new f.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(we.label2=de.label),we.insertText=de.insertText,we.kind=He.to(de.kind),we.tags=(xe=de.tags)===null||xe===void 0?void 0:xe.map(qe.to),we.detail=de.detail,we.documentation=L.isMarkdownString(de.documentation)?v.to(de.documentation):de.documentation,we.sortText=de.sortText,we.filterText=de.filterText,we.preselect=de.preselect,we.commitCharacters=de.commitCharacters,C.Range.isIRange(de.range)?we.range=w.to(de.range):typeof de.range=="object"&&(we.range={inserting:w.to(de.range.insert),replacing:w.to(de.range.replace)}),we.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?we.insertText=new f.SnippetString(de.insertText):(we.insertText=de.insertText,we.textEdit=we.range instanceof f.Range?new f.TextEdit(we.range,we.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(we.additionalTextEdits=de.additionalTextEdits.map(Ye=>$.to(Ye))),we.command=Q&&de.command?Q.fromInternal(de.command):void 0,we}_e.to=ye})(Ve=e.CompletionItem||(e.CompletionItem={}));var j;(function(_e){function ye(Q){return{label:Q.label,documentation:Q.documentation?v.fromStrict(Q.documentation):void 0}}_e.from=ye;function de(Q){return{label:Q.label,documentation:L.isMarkdownString(Q.documentation)?v.to(Q.documentation):Q.documentation}}_e.to=de})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(_e){function ye(Q){return{label:Q.label,documentation:Q.documentation?v.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.from):[],activeParameter:Q.activeParameter}}_e.from=ye;function de(Q){return{label:Q.label,documentation:L.isMarkdownString(Q.documentation)?v.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.to):[],activeParameter:Q.activeParameter}}_e.to=de})(Z=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(_e){function ye(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(Z.from):[]}}_e.from=ye;function de(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(Z.to):[]}}_e.to=de})(ne=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(_e){function ye(Q){var xe;return{text:Q.text,position:u.from(Q.position),kind:J.from((xe=Q.kind)!==null&&xe!==void 0?xe:f.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}_e.from=ye;function de(Q){const xe=new f.InlayHint(Q.text,u.to(Q.position),J.to(Q.kind));return xe.whitespaceAfter=Q.whitespaceAfter,xe.whitespaceBefore=Q.whitespaceBefore,xe}_e.to=de})(oe=e.InlayHint||(e.InlayHint={}));var J;(function(_e){function ye(Q){return Q}_e.from=ye;function de(Q){return Q}_e.to=de})(J=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(_e){function ye(Q){return{range:w.from(Q.range),url:Q.target,tooltip:Q.tooltip}}_e.from=ye;function de(Q){let xe;if(Q.url)try{xe=typeof Q.url=="string"?S.URI.parse(Q.url,!0):S.URI.revive(Q.url)}catch(we){}return new f.DocumentLink(w.to(Q.range),xe)}_e.to=de})(ce=e.DocumentLink||(e.DocumentLink={}));var me;(function(_e){function ye(Q){const xe=new f.ColorPresentation(Q.label);return Q.textEdit&&(xe.textEdit=$.to(Q.textEdit)),Q.additionalTextEdits&&(xe.additionalTextEdits=Q.additionalTextEdits.map(we=>$.to(we))),xe}_e.to=ye;function de(Q){return{label:Q.label,textEdit:Q.textEdit?$.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(xe=>$.from(xe)):void 0}}_e.from=de})(me=e.ColorPresentation||(e.ColorPresentation={}));var Le;(function(_e){function ye(Q){return new f.Color(Q[0],Q[1],Q[2],Q[3])}_e.to=ye;function de(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}_e.from=de})(Le=e.Color||(e.Color={}));var We;(function(_e){function ye(Q){return{range:w.from(Q.range)}}_e.from=ye;function de(Q){return new f.SelectionRange(w.to(Q.range))}_e.to=de})(We=e.SelectionRange||(e.SelectionRange={}));var Ee;(function(_e){function ye(de){switch(de){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}_e.to=ye})(Ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(_e){function ye(Q){switch(Q){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ye;function de(Q){switch(Q){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}_e.to=de})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var K;(function(_e){function ye(Q){if(Q===f.EndOfLine.CRLF)return 1;if(Q===f.EndOfLine.LF)return 0}_e.from=ye;function de(Q){if(Q===1)return f.EndOfLine.CRLF;if(Q===0)return f.EndOfLine.LF}_e.to=de})(K=e.EndOfLine||(e.EndOfLine={}));var ie;(function(_e){function ye(de){if(typeof de=="object")return de.viewId;switch(de){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ye})(ie=e.ProgressLocation||(e.ProgressLocation={}));var ve;(function(_e){function ye(de){const Q={start:de.start+1,end:de.end+1};return de.kind&&(Q.kind=Fe.from(de.kind)),Q}_e.from=ye})(ve=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(_e){function ye(de){if(de)switch(de){case f.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}_e.from=ye})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(_e){function ye(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?w.from(de.selection):void 0,override:typeof de.override=="boolean"?I.EditorOverride.DISABLED:void 0}}_e.from=ye})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Qe;(function(_e){function ye(Q){return Q instanceof f.RelativePattern||typeof Q=="string"?Q:de(Q)?new f.RelativePattern(Q.base,Q.pattern):Q}_e.from=ye;function de(Q){const xe=Q;return xe&&typeof xe.base=="string"&&typeof xe.pattern=="string"}})(Qe=e.GlobPattern||(e.GlobPattern={}));var De;(function(_e){function ye(de){if(de){if(Array.isArray(de))return de.map(ye);if(typeof de=="string")return de;{const Q=de;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:Qe.from(Q.pattern),exclusive:Q.exclusive}}}else return}_e.from=ye})(De=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(_e){function ye(Q){return{start:Q.start,end:Q.end}}_e.from=ye;function de(Q){return new f.NotebookRange(Q.start,Q.end)}_e.to=de})(Se=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(_e){function ye(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}_e.to=ye;function de(Q){var xe,we;return{lastRunSuccess:Q.success,runStartTime:(xe=Q.timing)===null||xe===void 0?void 0:xe.startTime,runEndTime:(we=Q.timing)===null||we===void 0?void 0:we.endTime,executionOrder:Q.executionOrder}}_e.from=de})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ae;(function(_e){function ye(Q){switch(Q){case f.NotebookCellKind.Markup:return h.CellKind.Markup;case f.NotebookCellKind.Code:default:return h.CellKind.Code}}_e.from=ye;function de(Q){switch(Q){case h.CellKind.Markup:return f.NotebookCellKind.Markup;case h.CellKind.Code:default:return f.NotebookCellKind.Code}}_e.to=de})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(_e){function ye(Q){var xe;const we={metadata:(xe=Q.metadata)!==null&&xe!==void 0?xe:Object.create(null),cells:[]};for(let Ye of Q.cells)f.NotebookCellData.validate(Ye),we.cells.push(H.from(Ye));return we}_e.from=ye;function de(Q){const xe=new f.NotebookData(Q.cells.map(H.to));return P.isEmptyObject(Q.metadata)||(xe.metadata=Q.metadata),xe}_e.to=de})(fe=e.NotebookData||(e.NotebookData={}));var H;(function(_e){function ye(Q){var xe;return{cellKind:ae.from(Q.kind),language:Q.languageId,source:Q.value,metadata:Q.metadata,internalMetadata:Pe.from((xe=Q.executionSummary)!==null&&xe!==void 0?xe:{}),outputs:Q.outputs?Q.outputs.map(ue.from):[]}}_e.from=ye;function de(Q){return new f.NotebookCellData(ae.to(Q.cellKind),Q.source,Q.language,Q.outputs?Q.outputs.map(ue.to):void 0,Q.metadata,Q.internalMetadata?Pe.to(Q.internalMetadata):void 0)}_e.to=de})(H=e.NotebookCellData||(e.NotebookCellData={}));var ee;(function(_e){function ye(Q){return{mime:Q.mime,valueBytes:Array.from(Q.data)}}_e.from=ye;function de(Q){return new f.NotebookCellOutputItem(new Uint8Array(Q.valueBytes),Q.mime)}_e.to=de})(ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ue;(function(_e){function ye(Q){return{outputId:Q.id,items:Q.items.map(ee.from),metadata:Q.metadata}}_e.from=ye;function de(Q){const xe=Q.items.map(ee.to);return new f.NotebookCellOutput(xe,Q.outputId,Q.metadata)}_e.to=de})(ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(_e){function ye(we){if(we!=null){if(we instanceof f.RelativePattern||typeof we=="string")return we;if(xe(we))return new f.RelativePattern(we.base,we.pattern);if(Q(we))return{include:Qe.from(we.include)||void 0,exclude:Qe.from(we.exclude)||void 0}}}_e.from=ye;function de(we){return typeof we=="string"?we:xe(we)?{base:we.base,pattern:we.pattern}:{include:we.include,exclude:we.exclude}}_e.to=de;function Q(we){const Ye=we,et=Qe.from(Ye.include);if(!(et&&et instanceof f.RelativePattern||typeof et=="string"))return!1;const rt=Qe.from(Ye.exclude);return!!(rt&&rt instanceof f.RelativePattern||typeof rt=="string")}function xe(we){const Ye=we;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Re;(function(_e){function ye(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?D.from(de.top):void 0}}_e.from=ye})(Re=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ue;(function(_e){function ye(de,Q,xe){const we=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(we,xe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}_e.from=ye})(Ue=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ze;(function(_e){function ye(de){var Q,xe,we;return{transientOutputs:(Q=de==null?void 0:de.transientOutputs)!==null&&Q!==void 0?Q:!1,transientCellMetadata:(xe=de==null?void 0:de.transientCellMetadata)!==null&&xe!==void 0?xe:{},transientDocumentMetadata:(we=de==null?void 0:de.transientDocumentMetadata)!==null&&we!==void 0?we:{}}}_e.from=ye})(ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(_e){function ye(Q){return{uri:Q.uri,provides:Q.provides}}_e.from=ye;function de(Q){return new f.NotebookRendererScript(S.URI.revive(Q.uri),Q.provides)}_e.to=de})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(_e){function ye(Q){return{message:v.fromStrict(Q.message)||"",severity:Q.severity,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?F.from(Q.location):void 0}}_e.from=ye;function de(Q){const xe=new f.TestMessage(typeof Q.message=="string"?Q.message:v.to(Q.message));return xe.severity=Q.severity,xe.actualOutput=Q.actualOutput,xe.expectedOutput=Q.expectedOutput,xe}_e.to=de})(Je=e.TestMessage||(e.TestMessage={}));var Xe;(function(_e){function ye(we){var Ye,et;return{extId:we.id,label:we.label,uri:we.uri,range:w.from(we.range)||null,debuggable:(Ye=we.debuggable)!==null&&Ye!==void 0?Ye:!1,description:we.description||null,runnable:(et=we.runnable)!==null&&et!==void 0?et:!0,error:we.error&&v.fromStrict(we.error)||null}}_e.from=ye;function de(we){return{extId:we.id,label:we.label,uri:we.uri,range:w.from(we.range)||null,debuggable:!1,description:we.description||null,error:null,runnable:!0}}_e.fromResultSnapshot=de;function Q(we){return{id:we.extId,label:we.label,uri:S.URI.revive(we.uri),range:w.to(we.range||void 0),addChild:()=>{},dispose:()=>{},status:f.TestItemStatus.Pending,data:void 0,debuggable:we.debuggable,description:we.description||void 0,runnable:we.runnable}}_e.toPlain=Q;function xe(we){const Ye=new f.TestItemImpl(we.extId,we.label,S.URI.revive(we.uri),void 0);return Ye.range=w.to(we.range||void 0),Ye.debuggable=we.debuggable,Ye.description=we.description||void 0,Ye.runnable=we.runnable,Ye}_e.to=xe})(Xe=e.TestItem||(e.TestItem={}));var nt;(function(_e){const ye=(Q,xe)=>Object.assign(Object.assign({},Xe.toPlain(Q.item)),{taskStates:Q.tasks.map(we=>({state:we.state,duration:we.duration,messages:we.messages.map(Je.to)})),children:Q.children.map(we=>xe.get(we)).filter(P.isDefined).map(we=>ye(we,xe))});function de(Q){const xe=[],we=new Map;for(const Ye of Q.items)we.set(Ye.item.extId,Ye),Ye.direct&&xe.push(Ye);return{completedAt:Q.completedAt,results:xe.map(Ye=>ye(Ye,we))}}_e.to=de})(nt=e.TestResults||(e.TestResults={}));var gt;(function(_e){function ye(de){switch(de){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}_e.to=ye})(gt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[206],pe([0,1,2,14,7,17,71]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(C,r,I,l={timeout:1500,errors:3}){this._logService=C,this._documents=r,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(r,I,l)=>{const c={dispose:this._callbacks.push([r,I,C])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(C,r){const I=p.URI.revive(C);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let f of[...this._callbacks]){if(l)break;const E=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(f,{document:E,reason:y.TextDocumentSaveReason.to(r)});c.push(w)}}finally{clearTimeout(h)}return c}_deliverEventAsyncAndBlameBadListeners([C,r,I],l){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,r,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const f=this._badListeners.get(C);this._badListeners.set(C,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,r,I,l){const h=[],c=Date.now(),{document:f,reason:E}=l,{version:w}=f,b=Object.freeze({document:f,reason:E,waitUntil(u){if(Object.isFrozen(h))throw L.illegalState("waitUntil can not be called async");h.push(Promise.resolve(u))}});try{r.apply(I,[b])}catch(u){return Promise.reject(u)}return Object.freeze(h),new Promise((u,d)=>{const g=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(g),u(t)}).catch(t=>{clearTimeout(g),d(t)})}).then(u=>{const d={edits:[]};for(const g of u)if(Array.isArray(g)&&g.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:i,range:s}of g)d.edits.push({_type:2,resource:f.uri,edit:{range:s&&y.Range.from(s),text:t,eol:i&&y.EndOfLine.from(i)}});if(d.edits.length!==0)return w===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ge[207],pe([0,1,3,16,30,2,17,7]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(I,l,h,c,f){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,h&&(this._config+=1),c&&(this._config+=2),f&&(this._config+=4);const E=k.parse(l),w=I(b=>{if(!h)for(let u of b.created){const d=y.URI.revive(u);E(d.fsPath)&&this._onDidCreate.fire(d)}if(!c)for(let u of b.changed){const d=y.URI.revive(u);E(d.fsPath)&&this._onDidChange.fire(d)}if(!f)for(let u of b.deleted){const d=y.URI.revive(u);E(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,l,h){this._logService=l,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new L.AsyncEmitter,this._onWillCreateFile=new L.AsyncEmitter,this._onWillDeleteFile=new L.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,l,h,c){return new S(this._onFileSystemEvent.event,I,l,h,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,l){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(h=>y.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(h=>y.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,l){return(h,c,f)=>{const E=function(b){h.call(c,b)};return E.extension=I,l.event(E,void 0,f)}}async $onWillRunFileOperation(I,l,h,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(f=>({oldUri:y.URI.revive(f.source),newUri:y.URI.revive(f.target)}))},h,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(f=>y.URI.revive(f.target))},h,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(f=>y.URI.revive(f.target))},h,c)}}async _fireWillEvent(I,l,h,c){const f=new Set,E=[];if(await I.fireAsync(l,c,async(b,u)=>{var d;const g=Date.now(),t=await Promise.resolve(b);t instanceof P.WorkspaceEdit&&(E.push(t),f.add((d=u.extension.displayName)!==null&&d!==void 0?d:u.extension.identifier.value)),Date.now()-g>h&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||E.length===0)return;const w={edits:[]};for(let b of E){let{edits:u}=A.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=C}),define(ge[208],pe([0,1,10,25,2,17,7,85]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(l,h,c,f){this.start=l,this.deletedCount=h,this.deletedItems=c,this.items=f}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(c=>c.apiCell)}))}}class C{constructor(l,h,c){var f,E,w;this.notebook=l,this._extHostDocument=h,this._cellData=c,this.handle=c.handle,this.uri=k.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(f=c.internalMetadata)!==null&&f!==void 0?f:{},this._metadata=(E=c.metadata)!==null&&E!==void 0?E:{},this._previousResult=y.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(y.NotebookCellOutput.to)}setOutputItems(l,h,c){const f=c.map(y.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===l);E&&(h||(E.items.length=0),E.items.push(...f))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=y.NotebookCellExecutionSummary.to(l)}}e.ExtHostCell=C;class r{constructor(l,h,c,f,E,w){var b;this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=c,this._emitter=f,this.uri=E,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=(b=w.metadata)!==null&&b!==void 0?b:Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===p.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(f=>f.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const c of l.rawEvents)c.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===P.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,c=l.end|0;return h<0&&(h=0),c>this._cells.length&&(c=this._cells.length),l.with({start:h,end:c})}_getCells(l){l=this._validateRange(l);const h=[];for(let c=l.start;c<l.end;c++)h.push(this._cells[c]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const c=[],f=[],E=[];l.reverse().forEach(w=>{const u=w[2].map(t=>{const i=new C(this,this._textDocumentsAndEditors,t);return h||f.push(C.asModelAddData(this.apiNotebook,t)),i}),d=new S(w[0],w[1],[],u),g=this._cells.splice(w[0],w[1],...u);for(const t of g)E.push(t.uri),d.deletedItems.push(t.apiCell);c.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:E}),h||this._emitter.emitModelChange(L.deepFreeze({document:this.apiNotebook,changes:S.asApiEvents(c)}))}_moveCell(l,h){const c=this._cells.splice(l,1);this._cells.splice(h,0,...c);const f=[new S(l,1,c.map(E=>E.apiCell),[]),new S(h,0,[],c)];this._emitter.emitModelChange(L.deepFreeze({document:this.apiNotebook,changes:S.asApiEvents(f)}))}_setCellOutputs(l,h){const c=this._cells[l];c.setOutputs(h),this._emitter.emitCellOutputsChange(L.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,h,c,f){const E=this._cells[l];E.setOutputItems(h,c,f),this._emitter.emitCellOutputsChange(L.deepFreeze({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(l,h){const c=this._cells[l];c.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(c.uri,h)}_changeCellMetadata(l,h){const c=this._cells[l],f=c.apiCell.metadata;c.setMetadata(h);const E=c.apiCell.metadata;L.equals(f,E)||this._emitter.emitCellMetadataChange(L.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,h){var c;const f=this._cells[l],E=f.internalMetadata;if(f.setInternalMetadata(h),E.runState!==h.runState){const w=(c=h.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(L.deepFreeze({document:this.apiNotebook,cell:f.apiCell,state:w}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(ge[123],pe([0,1,7,17,14]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:C})}replaceCells(S,C,r){this._throwIfFinalized(),!(S===C&&r.length===0)&&this._collectedEdits.push({editType:1,index:S,count:C-S,cells:r.map(L.NotebookCellData.from)})}}class A{constructor(S,C,r,I,l,h){this.id=S,this._proxy=C,this.notebookData=r,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=h}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(C){if(!Array.isArray(C)||!C.every(p.NotebookRange.isNotebookRange))throw k.illegalArgument("selections");S._selections=C,S._trySetSelections(C)},get visibleRanges(){return S._visibleRanges},revealRange(C,r){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(C),r??p.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(C){const r=new y(this.document.version);return C(r),S._applyEdit(r.finalize())},setDecorations(C,r){return S.setDecorations(C,r)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const C=[];let r=-1;for(let I=0;I<S.cellEdits.length;I++){if(r<0){C.push(S.cellEdits[I]),r++;continue}const h=C[r],c=S.cellEdits[I];if(h.editType===1&&c.editType===1&&h.index===c.index){h.cells.push(...S.cellEdits[I].cells),h.count+=S.cellEdits[I].count;continue}C.push(S.cellEdits[I]),r++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,C)}setDecorations(S,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return C.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(C),S.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(ge[209],pe([0,1,17,115,160,21,51]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,h){const c=this._handles++,{title:f,location:E,cancellable:w}=l,b={label:k.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:p.ProgressLocation.from(E),title:f,source:b,cancellable:w},I),this._withProgress(c,h,!!w)}_withProgress(I,l,h){let c;h&&(c=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const f=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let E;try{E=l(new C(this._proxy,I),h&&c?c.token:y.CancellationToken.None)}catch(w){throw f(I),w}return E.then(w=>f(I),w=>f(I)),E}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=P;function S(r,I){return r.message=I.message,typeof I.increment=="number"&&(typeof r.increment=="number"?r.increment+=I.increment:r.increment=I.increment),r}class C extends L.Progress{constructor(I,l){super(h=>this.throttledReport(h));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}je([A.throttle(100,(r,I)=>S(r,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(ge[124],pe([0,1,50,14,69,17,7]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(l,h,c){const f=P._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,f,y.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:f,dispose(){l.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=P,P._Keys=new k.IdGenerator("TextEditorDecorationType");class S{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof A.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,c){const f=this._document.validateRange(l);this._collectedEdits.push({range:f,text:h,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw L.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=S;class C{constructor(l,h,c,f){this._proxy=l,this._id=h,this._accept(c),this._logService=f;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let c=!1;if(typeof l.tabSize!="undefined"){const f=this._validateTabSize(l.tabSize);f==="auto"?(c=!0,h.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,c=!0,h.tabSize=f)}if(typeof l.insertSpaces!="undefined"){const f=this._validateInsertSpaces(l.insertSpaces);f==="auto"?(c=!0,h.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,c=!0,h.insertSpaces=f)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,h.lineNumbers=y.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class r{constructor(l,h,c,f,E,w,b,u){this.id=l,this._proxy=h,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new C(this._proxy,this.id,w,c),this._visibleRanges=b,this._viewColumn=u;const d=this;this.value=Object.freeze({get document(){return f.getValue()},set document(g){throw L.readonly("document")},get selection(){return d._selections&&d._selections[0]},set selection(g){if(!(g instanceof A.Selection))throw L.illegalArgument("selection");d._selections=[g],d._trySetSelection()},get selections(){return d._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.Selection)))throw L.illegalArgument("selections");d._selections=g,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(g){throw L.readonly("visibleRanges")},get options(){return d._options.value},set options(g){d._disposed||d._options.assign(g)},get viewColumn(){return d._viewColumn},set viewColumn(g){throw L.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new S(f.getValue(),t);return g(i),d._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=d._selections.map(n=>y.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:o}=y.Position.from(t);s=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof A.Range)s=[y.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.Range)s.push(y.Range.from(n));else{const{lineNumber:o,column:v}=y.Position.from(n);s.push({startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v})}}return h.$tryInsertSnippet(l,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!d._hasDecorationsForKey.has(g.key)||(i?d._hasDecorationsForKey.delete(g.key):d._hasDecorationsForKey.add(g.key),d._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return h.$trySetDecorations(l,g.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const v=t[n];s[4*n]=v.start.line+1,s[4*n+1]=v.start.character+1,s[4*n+2]=v.end.line+1,s[4*n+3]=v.end.character+1}return h.$trySetDecorationsFast(l,g.key,s)}}))},revealRange(g,t){d._runOnProxy(()=>h.$tryRevealRange(l,y.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){h.$tryShowEditor(l,y.ViewColumn.from(g))},hide(){h.$tryHideEditor(l)}})}dispose(){p.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){p.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){p.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){p.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){p.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const c=h.edits.map(E=>E.range);c.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=c.length-1;E<w;E++){const b=c[E].end;if(c[E+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=h.edits.map(E=>({range:y.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,f,{setEndOfLine:typeof h.setEndOfLine=="number"?y.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=r}),define(ge[210],pe([0,1,163,24,2,3,6,16,7,15,18,17,21]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(E,w){if(C.isString(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let b;return Array.isArray(E.highlights)&&(b=E.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),b=b.length?b:void 0),{label:E.label,highlights:b}}}class c{constructor(w,b,u){this._proxy=w,this.commands=b,this.logService=u,this.treeViews=new Map;function d(g){return g&&g.$treeViewId&&g.$treeItemHandle}b.registerArgumentProcessor({processArgument:g=>d(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>d(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(w,b,u){const d=this.createTreeView(w,{treeDataProvider:b},u);return{dispose:()=>d.dispose()}}createTreeView(w,b,u){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=b.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,canDragAndDrop:d}),t=this.createExtHostTreeView(w,b,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,b){const u=this.treeViews.get(w);return u?u.getChildren(b):Promise.reject(new Error(p.localize(0,null,w)))}$onDrop(w,b,u){const d=this.treeViews.get(w);return d?d.onDrop(b,u):Promise.reject(new Error(p.localize(1,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error(p.localize(2,null,w));return b.hasResolve}$resolve(w,b,u){const d=this.treeViews.get(w);if(!d)throw new Error(p.localize(3,null,w));return d.resolveTreeItem(b,u)}$setExpanded(w,b,u){const d=this.treeViews.get(w);if(!d)throw new Error(p.localize(4,null,w));d.setExpanded(b,u)}$setSelection(w,b){const u=this.treeViews.get(w);if(!u)throw new Error(p.localize(5,null,w));u.setSelection(b)}$setVisible(w,b){const u=this.treeViews.get(w);if(!u)throw new Error(p.localize(6,null,w));u.setVisible(b)}createExtHostTreeView(w,b,u){const d=new f(w,b,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,d),d}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class f extends A.Disposable{constructor(w,b,u,d,g,t){super();if(this.viewId=w,this.proxy=u,this.commands=d,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const o of t.contributes.views[n])o.id===w&&(this._title=o.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(v=>s=v),this.refreshPromise=this.refreshPromise.then(()=>i)),n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=s;return i=null,this.refresh(o).then(()=>v())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!C.isUndefinedOrNull(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(b)).then(d=>d.map(g=>g.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const u=C.isUndefinedOrNull(b.select)?!0:b.select,d=C.isUndefinedOrNull(b.focus)?!1:b.focus,g=C.isUndefinedOrNull(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:u,focus:d,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:d,expand:g})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const u=this.getExtensionElement(w);u&&(b?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){r.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,b){const u=w.map(g=>this.getExtensionElement(g)).filter(g=>!C.isUndefinedOrNull(g)),d=this.getExtensionElement(b);return u&&d?P.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(u,d)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){var u;if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(w);if(d){const g=this.nodes.get(d);if(g){const t=(u=await this.dataProvider.resolveTreeItem(g.extensionItem,d,b))!==null&&u!==void 0?u:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(u=>this.resolveTreeNode(b,u[u.length-1]).then(d=>(u.push(d),u))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):P.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const u=this.nodes.get(w);return u?Promise.resolve(u):P.asPromise(()=>this.dataProvider.getTreeItem(w)).then(d=>this.createHandle(w,d,b,!0)).then(d=>this.getChildren(b?b.item.handle:void 0).then(()=>{const g=this.getExtensionElement(d);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const u=this.getExtensionElement(w);b=u?this.nodes.get(u):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,d=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const g=await Promise.all(r.coalesce(d||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,u):null}));return b.token.isCancellationRequested?[]:r.coalesce(g)}finally{b.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,u=w.map(g=>this.nodes.get(g));for(const g of u)if(g&&!b.has(g.item.handle)){let t=g;for(;t&&t.parent&&u.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(g.item.handle)}const d=[];return b.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&d.push(g)}}),d}refreshHandles(w){const b={};return Promise.all(w.map(u=>this.refreshNode(u).then(d=>{d&&(b[u]=d.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const u=this.nodes.get(b);if(u)return this.clearChildren(b),P.asPromise(()=>this.dataProvider.getTreeItem(b)).then(d=>{if(d){const g=this.createTreeNode(b,d,u.parent);return this.updateNodeCache(b,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,u){const d=this.createTreeNode(w,b,u);if(b.id&&this.elements.has(d.item.handle))throw new Error(p.localize(7,null,b.id));return this.addNodeToCache(w,d),this.addNodeToParentCache(d,u),d}getTooltip(w){return S.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,u){const d=new A.DisposableStore,g=this.createHandle(w,b,u),t=this.getLightIconPath(b);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:h(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(d,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:C.isUndefinedOrNull(b.collapsibleState)?S.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:u,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(w){return w.iconPath instanceof S.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:u,resourceUri:d},g,t){if(b)return`${f.ID_HANDLE_PREFIX}/${b}`;const i=h(u,this.extension),s=g?g.item.handle:f.LABEL_HANDLE_PREFIX;let n=i?i.label:d?L.basename(d):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,v=this.getChildrenNodes(g)||[];let m,_=0;do{if(m=`${s}/${_}:${n}`,t||!this.elements.has(m)||o===m)break;_++}while(_<=v.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof S.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof S.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,u,d){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,b);const g=this.getChildrenNodes(d)||[],t=g.filter(i=>i.item.handle===u.item.handle)[0];t&&g.splice(g.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const u of b.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const u of b.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}f.LABEL_HANDLE_PREFIX="0",f.ID_HANDLE_PREFIX="1"}),define(ge[211],pe([0,1,18,16,21,15,83,17,7,122]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class r{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const b=this.testIdsToInternal.get(w),u=b==null?void 0:b.get(E);if(u)return[b,u]}return p.mapFind(this.testIdsToInternal.values(),b=>{const u=b.get(E);return u&&[b,u]})}createForHierarchy(E=()=>{}){return new c(this.createIdMap(l++),E)}createIdMap(E){const w=new h(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=r;var I;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let l=0;class h{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const b=typeof E=="string"?this.map.get(E):E,u=typeof w=="string"?this.map.get(w):w;if(!b||!u)return 0;if(b===u)return 3;for(let d=this.map.get(u.parent);d;d=this.map.get(d.parent))if(d===b)return 1;for(let d=this.map.get(b.parent);d;d=this.map.get(d.parent))if(d===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class c{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new L.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){C.applyTestItemUpdate(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){C.applyTestItemUpdate(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var b;const u=this.testIdToInternal.object.get(E);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const d=this.refreshChildren(u);return d.isSettled?this.expandChildren(u,w-1):d.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((b=u.initialExpand)===null||b===void 0?void 0:b.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),A.getPrivateApiFor(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const b=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[u,d,g]=w;switch(d){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:b,item:{range:P.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:P.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[d]:g??null}}]);break}break;default:y.assertNever(w[0])}}addItem(E,w,b){if(!(E instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const u=b?b.item.extId:null,d=E.resolveHandler?1:0,g=b?b.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},i={actual:E,parent:u,item:P.TestItem.from(E),expandLevels:g?g-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(E,i),this.pushDiff([0,{parent:u,src:t,expand:d,item:i.item}]);const s=A.getPrivateApiFor(E);s.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const n of s.children.values())this.testItemToInternal.has(n)||this.addItem(n,w,i)}updateExpandability(E){var w;let b;E.actual.resolveHandler?E.actual.status===S.TestItemStatus.Pending?b=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),b=3):b=0,b!==E.expand&&(E.expand=b,this.pushDiff([1,{extId:E.actual.id,expand:b}]),b===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(w<0)return;const b=[...E.actual.children.values()].map(u=>this.expand(u.id,w)).filter(L.isThenable);if(b.length)return Promise.all(b).then(()=>{})}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new L.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new k.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new L.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const b=[E];for(;b.length;){const u=b.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const d of u.actual.children.values())b.push(this.testIdToInternal.object.get(d.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=c}),define(ge[212],pe([0,1,4,176]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=p.refineServiceDecorator(L.IEnvironmentService)}),define(ge[213],pe([0,1,26,3,9]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=y;class A{constructor(r){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let I of r.activationEvents)I==="onUri"&&(I=`onUri:${p.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(r)}}keepOnly(r){const I=new Set;r.forEach(l=>I.add(p.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(p.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,I){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const l=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(h=>h.identifier)),I.length>0){const h=new Set;I.forEach(c=>h.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!h.has(p.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(l)}static _findLoopingExtensions(r){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const b=I.getArcs(E);for(let u=0;u<b.length;u++)if(!w.has(b[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let E of r){const w=p.ExtensionIdentifier.toKey(E.identifier);if(l.set(w,E),E.extensionDependencies)for(let b of E.extensionDependencies){const u=p.ExtensionIdentifier.toKey(b);I.addArc(w,u)}}let h=new Set;I.getNodes().filter(E=>I.getArcs(E).length===0).forEach(E=>h.add(E));let c=I.getNodes().filter(E=>!h.has(E)),f;do{f=!1;for(let E=0;E<c.length;E++){const w=c[E];I.hasOnlyGoodArcs(w,h)&&(c.splice(E,1),E--,h.add(w),f=!0)}}while(f);return c.map(E=>l.get(E))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const I=this._activationMap.get(r);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const I=this._extensionsMap.get(p.ExtensionIdentifier.toKey(r));return I||void 0}}e.ExtensionDescriptionRegistry=A;var P;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(P||(P={}));function S(C,r){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,l=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(I!==l)return I-l;const h=k.posix.basename(C.extensionLocation.path),c=k.posix.basename(r.extensionLocation.path);return h<c?-1:h>c?1:0}}),define(ge[214],pe([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function y(P){const S=p.VSBuffer.alloc(1);switch(P){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=y;function A(P,S){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=A}),define(ge[35],pe([0,1,3,2,4,26,178]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=k.createDecorator("extensionService");class P{constructor(b){this.dependency=b}}e.MissingExtensionDependency=P;var S;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(b,u,d,g){this.codeLoadingTime=b,this.activateCallTime=u,this.activateResolvedTime=d,this.activationReason=g}}e.ActivationTimes=C;class r{constructor(b,u){this.description=b,this.value=u}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||h(w)}e.checkProposedApiEnabled=l;function h(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=h;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function f(w){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=f;class E{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,u){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,u,d,g,t){}_onDidActivateExtensionError(b,u){}_onExtensionRuntimeError(b,u){}_onExtensionHostExit(b){}}e.NullExtensionService=E}),define(ge[215],pe([0,1,26,35,12]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(c,f,E,w){this.startup=c,this.codeLoadingTime=f,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class P{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,f){return c===-1||f===-1?-1:f-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class S{constructor(c,f,E,w,b,u){this.activationFailed=c,this.activationFailedError=f,this.activationTimes=E,this.module=w,this.exports=b,this.subscriptions=u}}e.ActivatedExtension=S;class C extends S{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class r extends S{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class I extends S{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(c,f,E,w,b){this._logService=b,this._registry=c,this._resolvedExtensionsSet=new Set,f.forEach(u=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,E.forEach(u=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const f=p.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(f)}getActivatedExtension(c){const f=p.ExtensionIdentifier.toKey(c),E=this._activatedExtensions.get(f);if(!E)throw new Error("Extension `"+c.value+"` is not known or not activated");return E}activateByEvent(c,f){if(this._alreadyActivatedEvents[c])return y;const E=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:f,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,f){const E=this._registry.getExtensionDescription(c);if(!E)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:E.identifier,reason:f}])}_handleActivateRequest(c,f,E){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(c.id))){f[p.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,d,new L.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(c.id),new I(d));return}const b=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let d=0,g=b.length;d<g;d++){const t=b[d];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const v=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),_=m&&m.displayName||t,D=new Error(`Cannot activate the '${v}' extension because its dependency '${_}' failed to activate`);D.detail=i.activationFailedError,this._host.onExtensionActivationError(w.identifier,D,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new I(D));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){u=!1,f[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,f[p.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const n=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(w.identifier),new I(o));return}u?f[p.ExtensionIdentifier.toKey(w.identifier)]=c:E.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(b=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(b.id))),c.length===0))return Promise.resolve(void 0);const f=Object.create(null),E=[];for(let b=0,u=c.length;b<u;b++)this._handleActivateRequest(c[b],f,E);for(let b=0,u=E.length;b<u;b++){const d=p.ExtensionIdentifier.toKey(E[b].id);f[d]&&delete f[d]}const w=Object.keys(f).map(b=>f[b]);return E.length===0?Promise.all(w.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(w).then(b=>this._activateExtensions(E))}_activateExtension(c,f){const E=p.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const b=this._host.actualActivateExtension(c,f).then(void 0,u=>{const d=new Error;return u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${c.value}' failed: ${u.message}.`:d.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._host.onExtensionActivationError(c,d,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(E,u),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,b),b}};l=je([$e(4,k.ILogService)],l),e.ExtensionsActivator=l}),define(ge[216],pe([0,1,12,35,27,10,113]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends p.LogService{constructor(C){if(C.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(L.ExtensionHostLogFileName,C.logFile.fsPath,!0,C.logLevel))}$setLevel(C){this.setLevel(C)}};P=je([$e(0,k.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(ge[217],pe([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):p.onUnexpectedError(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=L}),define(ge[125],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(S,C){this.isMain=S,this.sid=C,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const L=[];function k(P){const S=new p(!0,P);return L[S.nid]=S,S}e.createMainContextProxyIdentifier=k;function y(P){const S=new p(!1,P);return L[S.nid]=S,S}e.createExtHostContextProxyIdentifier=y;function A(P){return L[P].sid}e.getStringIdentifierForProxy=A}),define(ge[5],pe([0,1,54,2,125]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var r;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(r=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function d(t,i){return Object.defineProperty(t,u.name,{value:i,enumerable:!0}),t}u.mixin=d;function g(t){return t[u.name]}u.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(d){return d._id=h._n++,d}}e.IdObject=h,h._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const d of u.edits)typeof d.resource=="object"?d.resource=L.URI.revive(d.resource):(d.newUri=L.URI.revive(d.newUri),d.oldUri=L.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=p.revive(d.metadata));return u}e.reviveWorkspaceEditDto=w;var b;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:k.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:k.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:k.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:k.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:k.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:k.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:k.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:k.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:k.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(ge[86],pe([0,1,5,3,4]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(P){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,S){return this._proxy.$getPassword(P,S)}store(P,S,C){return this._proxy.$setPassword(P,S,C)}delete(P,S){return this._proxy.$deletePassword(P,S)}}e.ExtHostSecretState=y,e.IExtHostSecretState=k.createDecorator("IExtHostSecretState")}),define(ge[60],pe([0,1,4,12,5,13]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=p.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,C,r){const I=this.getUsageKey(S,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};A=je([$e(0,y.IExtHostRpcService),$e(1,L.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,C){}})}),define(ge[218],pe([0,1,3,5,7,26]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,C,r,I={}){const l=y.ExtensionIdentifier.toKey(S.identifier),h=this._inFlightRequests.get(l)||[],c=[...r].sort().join(" ");let f=h.find(E=>E.scopes===c);if(f)return f.result;{const E=this._getSession(S,l,C,r,I);f={scopes:c,result:E},h.push(f),this._inFlightRequests.set(l,h);try{await E}finally{const w=h.findIndex(b=>b.scopes===c);w>-1&&(h.splice(w),this._inFlightRequests.set(l,h))}return E}}async _getSession(S,C,r,I,l={}){await this._proxy.$ensureProvider(r);const h=S.displayName||S.name;return this._proxy.$getSession(r,I,C,h,l)}async removeSession(S,C){const r=this._authenticationProviders.get(S);return r?r.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,r,I){var l;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:r,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===S)||this._providers.push({id:S,label:C});const h=r.onDidChangeSessions(c=>{var f,E,w;this._proxy.$sendDidChangeSessions(S,{added:(f=c.added)!==null&&f!==void 0?f:[],changed:(E=c.changed)!==null&&E!==void 0?E:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(S,C,(l=I==null?void 0:I.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new k.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(S);const c=this._providers.findIndex(f=>f.id===S);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const r=this._authenticationProviders.get(S);if(r)return Promise.resolve(r.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const r=this._authenticationProviders.get(S);if(r)return Promise.resolve(r.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const r=this._authenticationProviders.get(S);if(r)return Promise.resolve(r.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,C){return S.forEach(r=>{this._providers.some(I=>I.id===r.id)||this._providers.push(r)}),C.forEach(r=>{const I=this._providers.findIndex(l=>l.id===r.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ge[219],pe([0,1,5,13,17]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(P,S){this._extHostDocumentsAndEditors=S,this._proxy=P.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const S=k.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=je([$e(0,L.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(ge[220],pe([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(y){const A=y.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=L}),define(ge[48],pe([0,1,15,7,17,25,5,18,12,54,41,44,2,6,4,13]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,s=>{const n=this._apiCommands.get(s);return(n==null?void 0:n.result)===u.Void?n:void 0},i),this._argumentProcessors=[{processArgument(s){return C.revive(s)}},{processArgument(s){return y.cloneAndChange(s,function(n){if(r.Range.isIRange(n))return k.Range.to(n);if(I.Position.isIPosition(n))return k.Position.to(n);if(r.Range.isIRange(n.range)&&l.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const n=t.args.map((v,m)=>{if(!v.validate(s[m]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${s[m]}`);return v.convert(s[m])}),o=await this.executeCommand(t.internalId,...n);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,n,o){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:n,description:o}),t&&this._proxy.$registerCommand(i),new L.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const n=y.cloneAndChange(i,function(o){if(o instanceof L.Position)return k.Position.from(o);if(o instanceof L.Range)return k.Range.from(o);if(o instanceof L.Location)return k.location.from(o);if(L.NotebookRange.isNotebookRange(o))return k.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,n,s);return C.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw o}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:n,thisArg:o,description:v}=s;if(v)for(let m=0;m<v.args.length;m++)try{p.validateConstraint(i[m],v.args[m].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[m].name}' - ${v.args[m].description}`)}try{return await n.apply(o,i)}catch(m){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...i);_&&(t=_.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((n,o)=>o.processArgument(n),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:n}=s;n&&(t[i]=n)}return Promise.resolve(t)}};E=je([$e(0,f.IExtHostRpcService),$e(1,S.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const n=this._lookupApiCommand(t.command);if(n)s.id=n.internalId,s.arguments=n.args.map((o,v)=>o.convert(t.arguments&&t.arguments[v]));else if(P.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),i.add(h.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const i=A.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,i,s,n){this.name=t,this.description=i,this.validate=s,this.convert=n}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g),b.Position=new b("position","A position in a text document",g=>L.Position.isPosition(g),k.Position.from),b.Range=new b("range","A range in a text document",g=>L.Range.isRange(g),k.Range.from),b.Selection=new b("selection","A selection in a text document",g=>L.Selection.isSelection(g),k.Selection.from),b.Number=new b("number","",g=>typeof g=="number",g=>g),b.String=new b("string","",g=>typeof g=="string",g=>g),b.CallHierarchyItem=new b("item","A call hierarchy item",g=>g instanceof L.CallHierarchyItem,k.CallHierarchyItem.to);class u{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",g=>g);class d{constructor(t,i,s,n,o){this.id=t,this.internalId=i,this.description=s,this.args=n,this.result=o}}e.ApiCommand=d}),define(ge[221],pe([0,1,17,7,78,48,18,108]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",r(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if(A.isFalsyOrEmpty(l))return;class c extends L.SymbolInformation{static to(E){const w=new c(E.name,p.SymbolKind.to(E.kind),E.containerName||"",new L.Location(h[0],p.Range.to(E.range)));return w.detail=E.detail,w.range=w.location.range,w.selectionRange=p.Range.to(E.selectionRange),w.children=E.children?E.children.map(c.to):[],w}}return l.map(c.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",r(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",r(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>L.Position.isPosition(h)),l=>l.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let c;for(const f of h.reverse())c=new L.SelectionRange(p.Range.to(f),c);return c}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let c of l)h.push(...c[1].map(p.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return p.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=P.decodeSemanticTokensDto(l);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=P.decodeSemanticTokensDto(l);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,c)=>{if(!l)return new L.CompletionList([]);const f=l.suggestions.map(E=>p.CompletionItem.to(E,c));return new L.CompletionList(f,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return p.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,c)=>r(f=>new L.CodeLens(p.Range.to(f.range),f.command&&c.fromInternal(f.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.Range.isRange(l),l=>L.Selection.isSelection(l)?p.Selection.from(l):p.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,c)=>r(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const E=new L.CodeAction(f.title,f.kind?new L.CodeActionKind(f.kind):void 0);return f.edit&&(E.edit=p.WorkspaceEdit.to(f.edit)),f.command&&(E.command=c.fromInternal(f.command)),E.isPreferred=f.isPreferred,E}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new L.ColorInformation(p.Range.to(h.range),p.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof L.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:p.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(p.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",r(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>p.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class C{static register(h){S.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function r(l){return h=>{if(Array.isArray(h))return h.map(l)}}function I(l){if(!Array.isArray(l))return;const h=[];for(const c of l)k.isLocationLink(c)?h.push(p.DefinitionLink.to(c)):h.push(p.location.to(c));return h}}),define(ge[222],pe([0,1,16,51,3,6,2,78,26,17,7,5]),function(X,e,p,L,k,y,A,P,S,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(d,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(I.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.commentThreadHandle);return n||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);return n?{thread:n,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.commentUniqueId,v=n.getCommentByUniqueId(o);return v||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.text,v=i.commentUniqueId,m=n.getCommentByUniqueId(v);return m?(m.body=o,m):i}return i}})}createCommentController(d,g,t){const i=l.handlePool++,s=new c(d,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const n=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(d.identifier))||[];return n.push(s),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(d.identifier),n),s}$createCommentThreadTemplate(d,g,t){const i=this._commentControllers.get(d);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(d,g,t){const i=this._commentControllers.get(d);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(d,g){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(d,g,t){const i=this._commentControllers.get(d);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(A.URI.revive(g));return p.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(n=>n?n.map(o=>C.Range.from(o)):void 0)}$toggleReaction(d,g,t,i,s){const n=this._commentControllers.get(d);return!n||!n.reactionHandler?Promise.resolve(void 0):p.asPromise(()=>{const o=n.getCommentThread(g);if(o){const v=o.getCommentByUniqueId(i.uniqueIdInThread);if(n!==void 0&&v&&n.reactionHandler)return n.reactionHandler(v,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class h{constructor(d,g,t,i,s,n,o){this._proxy=d,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=n,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=n}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};d("range")&&(g.range=C.Range.from(this._range)),d("label")&&(g.label=this.label),d("contextValue")&&(g.contextValue=this.contextValue),d("comments")&&(g.comments=this._comments.map(t=>f(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(g.collapseState=b(this._collapseState)),d("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(d){for(let g of this._commentsMap){let t=g[0],i=g[1];if(d===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,je([L.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class c{constructor(d,g,t,i,s){this._extension=d,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,g,t,i){if(typeof d=="string"){const s=new h(this._proxy,this,d,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new h(this._proxy,this,void 0,d,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(d,g){const t=new h(this._proxy,this,void 0,A.URI.revive(d),C.Range.to(g),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,g){let t=this._threads.get(d);t&&(t.range=C.Range.to(g))}$deleteCommentThread(d){let g=this._threads.get(d);g&&g.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function f(u,d,g,t){let i=t.get(g);i||(i=++u.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:C.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(n=>E(n)):void 0}}function E(u){return{label:u.label,iconPath:u.iconPath?C.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function b(u){if(u!==void 0)switch(u){case r.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(ge[126],pe([0,1,2,5,7,4,13,12,18,8,9]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class _n{constructor(h,c){this._logService=c,this._provider=new Map,this._proxy=h.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,c){const f=_n._handlePool++;this._provider.set(f,{provider:h,extensionId:c}),this._proxy.$registerDecorationProvider(f,c.value);const E=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(f,null);return}let b=S.asArray(w);if(b.length<=_n._maxEventSize){this._proxy.$onDidChange(f,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,b.length);const u=b.map(t=>({uri:t,rank:C.count(t.path,"/")})),d=S.groupBy(u,(t,i)=>t.rank-i.rank||C.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of d){let i;for(let s of t){let n=r.dirname(s.uri.path);if(i!==n&&(i=n,g.push(s.uri)>=_n._maxEventSize))break e}}this._proxy.$onDidChange(f,g)});return new k.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(h,c,f){if(!this._provider.has(h))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:b}=this._provider.get(h);return await Promise.all(c.map(async u=>{try{const{uri:d,id:g}=u,t=await Promise.resolve(w.provideFileDecoration(p.URI.revive(d),f));if(!t)return;try{k.FileDecoration.validate(t),E[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(d){this._logService.error(d)}})),E}};I._handlePool=0,I._maxEventSize=250,I=je([$e(0,A.IExtHostRpcService),$e(1,P.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(ge[223],pe([0,1,158,114,2,5,7,17,3,12,23]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,f,E,w,b){this._name=c,this._owner=f,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,f){if(!c){this.clear();return}this._checkDisposed();let E=[];if(k.URI.isUri(c)){if(!f){this.delete(c);return}this._data.set(c,f.slice()),E=[c]}else if(Array.isArray(c)){E=[];let b;c=[...c].sort(I._compareIndexedTuplesByUri);for(const u of c){const[d,g]=u;if((!b||d.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=d,E.push(d),this._data.set(d,[])),g){const t=this._data.get(d);t&&t.push(...g)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!this._proxy)return;const w=[];for(let b of E){let u=[];const d=this._data.get(b);if(d)if(d.length>this._maxDiagnosticsPerFile){u=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of d)if(i.severity===g[t]&&u.push(P.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:L.MarkerSeverity.Info,message:p.localize(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=d.map(g=>P.Diagnostic.from(g));w.push([b,u])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,f){this._checkDisposed();for(let E of this._data.keys())c.apply(f,[E,this.get(E),this])}get(c){this._checkDisposed();const f=this._data.get(c);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,f){return c[0].toString()<f[0].toString()?-1:c[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class Gt{constructor(c,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Gt._debouncer,50),Gt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(c,f){return c?c.concat(f):f}static _mapper(c){const f=new r.ResourceMap;for(const E of c)f.set(E,E);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(c,f){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:b,_logService:u}=this,d=new class{$changeMany(i,s){w.$changeMany(i,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,s.length===0?"CLEARING":s)}$clear(i){w.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){w.dispose()}};let g;if(!f)f="_generated_diagnostic_collection_name_#"+Gt._idPool++,g=f;else if(!E.has(f))g=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do g=f+Gt._idPool++;while(E.has(g))}return new class extends I{constructor(){super(f,g,Gt._maxDiagnosticsPerFile,d,b);E.set(g,this)}dispose(){super.dispose(),E.delete(g)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const f=new Map,E=[];for(const w of this._collections.values())w.forEach((b,u)=>{let d=f.get(b.toString());typeof d=="undefined"&&(d=E.length,f.set(b.toString(),d),E.push([b,[]])),E[d][1]=E[d][1].concat(...u)});return E}}_getDiagnostics(c){let f=[];for(let E of this._collections.values())E.has(c)&&(f=f.concat(E.get(c)));return f}$acceptMarkersChange(c){if(!this._mirrorCollection){const f="_generated_mirror",E=new I(f,f,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,E),this._mirrorCollection=E}for(const[f,E]of c)this._mirrorCollection.set(k.URI.revive(f),E.map(P.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=je([$e(1,C.ILogService)],l),e.ExtHostDiagnostics=l}),define(ge[224],pe([0,1,2,5]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(P=>P?P.map(S=>p.URI.revive(S)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(P=>P?p.URI.revive(P):void 0)}}e.ExtHostDialogs=k}),define(ge[225],pe([0,1,14,2,7,5,10,21,8]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,I);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(f=>{if(f.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(h,f).then(E=>{if(!E&&typeof E!="string")return;const w=this._documentsAndEditors.getDocument(f);if(!w)return;const b=S.splitLines(E);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(f,E)},p.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,l){const h=this._documentContentProviders.get(I);return h?Promise.resolve(h.provideTextDocumentContent(L.URI.revive(l),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(ge[226],pe([0,1,3,6,2,5,119,17,15,25]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(l,h){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const f of c)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const f of c)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const h=this._documentsAndEditors.getDocument(l);if(h)return h}getDocument(l){const h=this.getDocumentData(l);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return h.document}ensureDocumentData(l){const h=this._documentsAndEditors.getDocument(l);if(h)return Promise.resolve(h);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(f=>{this._documentLoader.delete(l.toString());const E=k.URI.revive(f);return S.assertIsDefined(this._documentsAndEditors.getDocument(E))},f=>(this._documentLoader.delete(l.toString()),Promise.reject(f))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(h=>k.URI.revive(h))}$acceptModelModeChanged(l,h){const c=k.URI.revive(l),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(h),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(l){const h=k.URI.revive(l),c=this._documentsAndEditors.getDocument(h);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,h){const c=k.URI.revive(l),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");f._acceptIsDirty(h),this._onDidChangeDocument.fire({document:f.document,contentChanges:[]})}$acceptModelChanged(l,h,c){const f=k.URI.revive(l),E=this._documentsAndEditors.getDocument(f);if(!E)throw new Error("unknown document");E._acceptIsDirty(c),E.onEvents(h),this._onDidChangeDocument.fire(C.deepFreeze({document:E.document,contentChanges:h.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(l,h){A.setWordDefinitionFor(l,h)}}e.ExtHostDocuments=r}),define(ge[39],pe([0,1,50,3,6,2,4,5,119,13,124,17,12,23,10,70,134]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(d,g){this._extHostRpc=d,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const g=[],t=[],i=[];if(d.removedDocuments)for(const s of d.removedDocuments){const n=y.URI.revive(s),o=this._documents.get(n);(o==null?void 0:o.unref())&&(this._documents.delete(n),g.push(o.value))}if(d.addedDocuments)for(const s of d.addedDocuments){const n=y.URI.revive(s.uri);let o=this._documents.get(n);if(o&&n.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${n} already exists!'`);o||(o=new w(new S.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(d.removedEditors)for(const s of d.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&i.push(n)}if(d.addedEditors)for(const s of d.addedEditors){const n=y.URI.revive(s.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(n).value,v=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(m=>I.Range.to(m)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,v)}d.newActiveEditor!==void 0&&(p.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),k.dispose(g),k.dispose(i),d.removedDocuments&&this._onDidRemoveDocuments.fire(g),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var g;return(g=this._documents.get(d))===null||g===void 0?void 0:g.value}allDocuments(){return f.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return d?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};b=je([$e(0,C.IExtHostRpcService),$e(1,l.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[227],pe([0,1,2,5,6,7,17,142,8,22]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const c=this._schemes.indexOf(h);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),c=[];let f,E,w=14,b=14;for(const u of h){let d=f?S.commonPrefixLength(f,u):0;for(d===0?E=1:E=b;d<u.length;d++)d+1===u.length?(w=b,b=9):b+=1,c.push([E,u.toUpperCase().charCodeAt(d),b]),c.push([E,u.toLowerCase().charCodeAt(d),b]),E=b;f=u,b=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new P.StateMachine(c)}}provideDocumentLinks(h){this._initStateMachine();const c=[],f=P.LinkComputer.computeLinks({getLineContent(E){return h.lineAt(E-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const E of f){const w=A.DocumentLink.to(E);w.target&&c.push(w)}return c}}class I{constructor(h,c){this._extHostLanguageFeatures=c,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,c,f,E={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(b,f),this._enableProposedApi.set(b,w??!1);let u=2;E.isCaseSensitive&&(u+=1024),E.isReadonly&&(u+=2048),typeof f.copy=="function"&&(u+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(b,c,u).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${c}`),console.error(g)});const d=f.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:n}=i;if(s.scheme!==c)continue;let o;switch(n){case y.FileChangeType.Changed:o=0;break;case y.FileChangeType.Created:o=1;break;case y.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(b,t)});return k.toDisposable(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(h,c){const{type:f,ctime:E,mtime:w,size:b,permissions:u}=h;return c?{type:f,ctime:E,mtime:w,size:b,permissions:u}:{type:f,ctime:E,mtime:w,size:b}}$stat(h,c){return Promise.resolve(this._getFsProvider(h).stat(p.URI.revive(c))).then(f=>{var E;return I._asIStat(f,(E=this._enableProposedApi.get(h))!==null&&E!==void 0?E:!1)})}$readdir(h,c){return Promise.resolve(this._getFsProvider(h).readDirectory(p.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this._getFsProvider(h).readFile(p.URI.revive(c))).then(f=>C.VSBuffer.wrap(f))}$writeFile(h,c,f,E){return Promise.resolve(this._getFsProvider(h).writeFile(p.URI.revive(c),f.buffer,E))}$delete(h,c,f){return Promise.resolve(this._getFsProvider(h).delete(p.URI.revive(c),f))}$rename(h,c,f,E){return Promise.resolve(this._getFsProvider(h).rename(p.URI.revive(c),p.URI.revive(f),E))}$copy(h,c,f,E){const w=this._getFsProvider(h);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(p.URI.revive(c),p.URI.revive(f),E))}$mkdir(h,c){return Promise.resolve(this._getFsProvider(h).createDirectory(p.URI.revive(c)))}$watch(h,c,f,E){const w=this._getFsProvider(h).watch(p.URI.revive(f),E);this._watches.set(c,w)}$unwatch(h,c){const f=this._watches.get(c);f&&(f.dispose(),this._watches.delete(c))}$open(h,c,f){const E=this._getFsProvider(h);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(p.URI.revive(c),f))}$close(h,c){const f=this._getFsProvider(h);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(c))}$read(h,c,f,E){const w=this._getFsProvider(h);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(E);return Promise.resolve(w.read(c,f,b.buffer,0,E)).then(u=>b.slice(0,u))}$write(h,c,f,E){const w=this._getFsProvider(h);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,f,E.buffer,0,E.byteLength))}_getFsProvider(h){const c=this._fsProvider.get(h);if(!c){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return c}}e.ExtHostFileSystem=I}),define(ge[87],pe([0,1,5,42,7,22,4,13,58]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ut{constructor(I,l){const h=I.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return h.$stat(c).catch(Ut._handleError)},readDirectory(c){return h.$readdir(c).catch(Ut._handleError)},createDirectory(c){return h.$mkdir(c).catch(Ut._handleError)},async readFile(c){return h.$readFile(c).then(f=>f.buffer).catch(Ut._handleError)},writeFile(c,f){return h.$writeFile(c,y.VSBuffer.wrap(f)).catch(Ut._handleError)},delete(c,f){return h.$delete(c,Object.assign({recursive:!1,useTrash:!1},f)).catch(Ut._handleError)},rename(c,f,E){return h.$rename(c,f,Object.assign({overwrite:!1},E)).catch(Ut._handleError)},copy(c,f,E){return h.$copy(c,f,Object.assign({overwrite:!1},E)).catch(Ut._handleError)},isWritableFileSystem(c){const f=l.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};C=je([$e(0,P.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(ge[228],pe([0,1,6,5]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),p.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=k}),define(ge[229],pe([0,1,2,25,17,7,16,5,8,41,18,15,139,6,108,69,82,43,14,3]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentSymbols(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentSymbols(ne,Z)).then(oe=>{if(!r.isFalsyOrEmpty(oe))return oe[0]instanceof y.DocumentSymbol?oe.map(k.DocumentSymbol.from):d._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(j){var Z;j=j.slice(0).sort((J,ce)=>{let me=J.location.range.start.compareTo(ce.location.range.start);return me===0&&(me=ce.location.range.end.compareTo(J.location.range.end)),me});const ne=[],oe=[];for(const J of j){const ce={name:J.name||"!!MISSING: name!!",kind:k.SymbolKind.from(J.kind),tags:((Z=J.tags)===null||Z===void 0?void 0:Z.map(k.SymbolTag.from))||[],detail:"",containerName:J.containerName,range:k.Range.from(J.location.range),selectionRange:k.Range.from(J.location.range),children:[]};for(;;){if(oe.length===0){oe.push(ce),ne.push(ce);break}const me=oe[oe.length-1];if(C.Range.containsRange(me.range,ce.range)&&!C.Range.equalsRange(me.range,ce.range)){me.children&&me.children.push(ce),oe.push(ce);break}oe.pop()}}return ne}}class g{constructor(j,Z,ne){this._documents=j,this._commands=Z,this._provider=ne,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const ne=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ne,Z);if(!oe||Z.isCancellationRequested)return;const J=this._cache.add(oe),ce=new h.DisposableStore;this._disposables.set(J,ce);const me={cacheId:J,lenses:[]};for(let Le=0;Le<oe.length;Le++)me.lenses.push({cacheId:[J,Le],range:k.Range.from(oe[Le].range),command:this._commands.toInternal(oe[Le].command,ce)});return me}async resolveCodeLens(j,Z){var ne;const oe=j.cacheId&&this._cache.get(...j.cacheId);if(!oe)return;let J;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?J=oe:J=await this._provider.resolveCodeLens(oe,Z),J||(J=oe),Z.isCancellationRequested)return;const ce=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!ce)return j.command=this._commands.toInternal((ne=J.command)!==null&&ne!==void 0?ne:g._badCmd,ce),j}releaseCodeLenses(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ve){return Array.isArray(Ve)?Ve.map(k.DefinitionLink.from):Ve?[k.DefinitionLink.from(Ve)]:[]}class i{constructor(j,Z){this._documents=j,this._provider=Z}provideDefinition(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDefinition(oe,J,ne)).then(t)}}class s{constructor(j,Z){this._documents=j,this._provider=Z}provideDeclaration(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDeclaration(oe,J,ne)).then(t)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}provideImplementation(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideImplementation(oe,J,ne)).then(t)}}class o{constructor(j,Z){this._documents=j,this._provider=Z}provideTypeDefinition(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideTypeDefinition(oe,J,ne)).then(t)}}class v{constructor(j,Z){this._documents=j,this._provider=Z}provideHover(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideHover(oe,J,ne)).then(ce=>{if(!(!ce||r.isFalsyOrEmpty(ce.contents)))return ce.range||(ce.range=oe.getWordRangeAtPosition(J)),ce.range||(ce.range=new y.Range(J,J)),k.Hover.from(ce)})}}class m{constructor(j,Z){this._documents=j,this._provider=Z}provideEvaluatableExpression(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideEvaluatableExpression(oe,J,ne)).then(ce=>{if(ce)return k.EvaluatableExpression.from(ce)})}}class _{constructor(j,Z){this._documents=j,this._provider=Z}provideInlineValues(j,Z,ne,oe){const J=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlineValues(J,k.Range.to(Z),k.InlineValueContext.to(ne),oe)).then(ce=>{if(Array.isArray(ce))return ce.map(me=>k.InlineValue.from(me))})}}class D{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentHighlights(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideDocumentHighlights(oe,J,ne)).then(ce=>{if(Array.isArray(ce))return ce.map(k.DocumentHighlight.from)})}}class a{constructor(j,Z){this._documents=j,this._provider=Z}provideLinkedEditingRanges(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(oe,J,ne)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:r.coalesce(ce.ranges.map(k.Range.from)),wordPattern:ce.wordPattern}})}}class R{constructor(j,Z){this._documents=j,this._provider=Z}provideReferences(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=k.Position.to(Z);return A.asPromise(()=>this._provider.provideReferences(J,ce,ne,oe)).then(me=>{if(Array.isArray(me))return me.map(k.location.from)})}}class M{constructor(j,Z,ne,oe,J,ce,me){this._documents=j,this._commands=Z,this._diagnostics=ne,this._provider=oe,this._logService=J,this._extension=ce,this._apiDeprecation=me,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=l.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),me=[];for(const We of this._diagnostics.getDiagnostics(j))if(ce.intersection(We.range)&&me.push(We)>M._maxCodeActionsPerFile)break;const Le={diagnostics:me,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(J,ce,Le,oe)).then(We=>{var Ee;if(!r.isNonEmptyArray(We)||oe.isCancellationRequested)return;const Ke=this._cache.add(We),K=new h.DisposableStore;this._disposables.set(Ke,K);const ie=[];for(let ve=0;ve<We.length;ve++){const Fe=We[ve];!Fe||(M._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ie.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,K)})):(Le.only&&(Fe.kind?Le.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ie.push({cacheId:[Ke,ve],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,K),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(k.Diagnostic.from),edit:Fe.edit&&k.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(Ee=Fe.disabled)===null||Ee===void 0?void 0:Ee.reason})))}return{cacheId:Ke,actions:ie}})}async resolveCodeAction(j,Z){var ne;const[oe,J]=j,ce=this._cache.get(oe,J);if(!ce||M._isCommand(ce)||!this._provider.resolveCodeAction)return;const me=(ne=await this._provider.resolveCodeAction(ce,Z))!==null&&ne!==void 0?ne:ce;return(me==null?void 0:me.edit)?k.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}M._maxCodeActionsPerFile=1e3;class ${constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentFormattingEdits(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(oe,Z,ne)).then(J=>{if(Array.isArray(J))return J.map(k.TextEdit.from)})}}class Y{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeFormattingEdits(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=k.Range.to(Z);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(J,ce,ne,oe)).then(me=>{if(Array.isArray(me))return me.map(k.TextEdit.from)})}}class le{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Z,ne,oe,J){const ce=this._documents.getDocument(j),me=k.Position.to(Z);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ce,me,ne,oe,J)).then(Le=>{if(Array.isArray(Le))return Le.map(k.TextEdit.from)})}}class q{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Z){const ne=P.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(j,Z)).then(oe=>{if(r.isNonEmptyArray(oe))for(const J of oe){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ce=P.IdObject.mixin(k.WorkspaceSymbol.from(J));this._symbolCache.set(ce._id,J),ne.symbols.push(ce)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ne=this._symbolCache.get(j._id);if(ne){const oe=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,Z));return oe&&L.mixin(j,k.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[ne,oe]=Z;ne<=oe;ne++)this._symbolCache.delete(ne);this._resultCache.delete(j)}}}class U{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._logService=ne}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=k.Position.to(Z);return A.asPromise(()=>this._provider.provideRenameEdits(J,ce,ne,oe)).then(me=>{if(!!me)return k.WorkspaceEdit.from(me)},me=>{const Le=U._asMessage(me);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(me)})}resolveRenameLocation(j,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),J=k.Position.to(Z);return A.asPromise(()=>this._provider.prepareRename(oe,J,ne)).then(ce=>{let me,Le;if(y.Range.isRange(ce)?(me=ce,Le=oe.getText(ce)):I.isObject(ce)&&(me=ce.range,Le=ce.placeholder),!!me){if(me.start.line>J.line||me.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(me),text:Le}}},ce=>{const me=U._asMessage(ce);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class z{constructor(j,Z){this.resultId=j,this.tokens=Z}}class O{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Z,ne){const oe=this._documents.getDocument(j),J=Z!==0?this._previousResults.get(Z):null;return A.asPromise(()=>J&&typeof J.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,J.resultId,ne):this._provider.provideDocumentSemanticTokens(oe,ne)).then(ce=>(J&&this._previousResults.delete(Z),ce?(ce=O._fixProvidedSemanticTokens(ce),this._send(O._convertToEdits(J,ce),ce)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return O._isSemanticTokens(j)?O._isCorrectSemanticTokens(j)?j:new y.SemanticTokens(new Uint32Array(j.data),j.resultId):O._isSemanticTokensEdits(j)?O._isCorrectSemanticTokensEdits(j)?j:new y.SemanticTokensEdits(j.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!O._isSemanticTokens(Z)||!j||!j.tokens)return Z;const ne=j.tokens,oe=ne.length,J=Z.data,ce=J.length;let me=0;const Le=Math.min(oe,ce);for(;me<Le&&ne[me]===J[me];)me++;if(me===oe&&me===ce)return new y.SemanticTokensEdits([],Z.resultId);let We=0;const Ee=Le-me;for(;We<Ee&&ne[oe-We-1]===J[ce-We-1];)We++;return new y.SemanticTokensEdits([{start:me,deleteCount:oe-me-We,data:J.subarray(me,ce-We)}],Z.resultId)}_send(j,Z){if(O._isSemanticTokens(j)){const ne=this._nextResultId++;return this._previousResults.set(ne,new z(j.resultId,j.data)),c.encodeSemanticTokensDto({id:ne,type:"full",data:j.data})}if(O._isSemanticTokensEdits(j)){const ne=this._nextResultId++;return O._isSemanticTokens(Z)?this._previousResults.set(ne,new z(Z.resultId,Z.data)):this._previousResults.set(ne,new z(j.resultId)),c.encodeSemanticTokensDto({id:ne,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=O;class W{constructor(j,Z){this._documents=j,this._provider=Z}provideDocumentRangeSemanticTokens(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(oe,k.Range.to(Z),ne)).then(J=>J?this._send(J):null)}_send(j){return c.encodeSemanticTokensDto({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=W;class T{constructor(j,Z,ne,oe,J){this._documents=j,this._commands=Z,this._provider=ne,this._apiDeprecation=oe,this._extension=J,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=k.Position.to(Z),me=J.getWordRangeAtPosition(ce)||new y.Range(ce,ce),Le=me.with({end:ce}),We=new w.StopWatch(!0),Ee=await A.asPromise(()=>this._provider.provideCompletionItems(J,ce,oe,k.CompletionContext.to(ne)));if(!Ee||oe.isCancellationRequested)return;const Ke=Array.isArray(Ee)?new y.CompletionList(Ee):Ee,K=T.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),ie=new h.DisposableStore;this._disposables.set(K,ie);const ve=[],Fe={x:K,b:ve,a:{replace:k.Range.from(me),insert:k.Range.from(Le)},c:Ke.isIncomplete||void 0,d:We.elapsed()};for(let Ne=0;Ne<Ke.items.length;Ne++){const Qe=Ke.items[Ne],De=this._convertCompletionItem(Qe,[K,Ne],Le,me);ve.push(De)}return Fe}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...j);if(!ne)return;const oe=await A.asPromise(()=>this._provider.resolveCompletionItem(ne,Z));if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){var Z;(Z=this._disposables.get(j))===null||Z===void 0||Z.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,ne,oe){var J;const ce=this._disposables.get(Z[0]);if(!ce)throw Error("DisposableStore is missing...");const me={x:Z,a:(J=j.label)!==null&&J!==void 0?J:"",o:j.label2,b:j.kind!==void 0?k.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(k.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(j.command,ce)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=j.textEdit.newText):typeof j.insertText=="string"?me.h=j.insertText:j.insertText instanceof y.SnippetString&&(me.h=j.insertText.value,me.i|=4);let Le;return j.textEdit?Le=j.textEdit.range:j.range&&(Le=j.range),y.Range.isRange(Le)?me.j=k.Range.from(Le):Le&&(!(ne==null?void 0:ne.isEqual(Le.inserting))||!(oe==null?void 0:oe.isEqual(Le.replacing)))&&(me.j={insert:k.Range.from(Le.inserting),replace:k.Range.from(Le.replacing)}),me}}class F{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._commands=ne,this._cache=new E.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=k.Position.to(Z),me=await A.asPromise(()=>this._provider.provideInlineCompletionItems(J,ce,ne,oe));if(!me||oe.isCancellationRequested)return;const Le=I.isArray(me)?{items:me}:me,We=this._cache.add(Le.items);let Ee;return{pid:We,items:Le.items.map((Ke,K)=>{let ie;return Ke.command&&(Ee||(Ee=new h.DisposableStore,this._disposables.set(We,Ee)),ie=this._commands.toInternal(Ke.command,Ee)),{text:Ke.text,range:Ke.range?k.Range.from(Ke.range):void 0,command:ie,idx:K}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const ne=this._cache.get(j,Z);ne&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=N.map.get(j);return Z||(Z=new N,N.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=N,N.map=new WeakMap;class x{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(j,Z,ne,oe){const J=this._documents.getDocument(j),ce=k.Position.to(Z),me=this.reviveContext(ne);return A.asPromise(()=>this._provider.provideSignatureHelp(J,ce,oe,me)).then(Le=>{if(Le){const We=this._cache.add([Le]);return Object.assign(Object.assign({},k.SignatureHelp.from(Le)),{id:We})}})}reviveContext(j){let Z;if(j.activeSignatureHelp){const ne=k.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(Z=oe,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return Object.assign(Object.assign({},j),{activeSignatureHelp:Z})}releaseSignatureHelp(j){this._cache.delete(j)}}class G{constructor(j,Z){this._documents=j,this._provider=Z}provideInlayHints(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlayHints(oe,k.Range.to(Z),ne)).then(J=>J?{hints:J.map(k.InlayHint.from)}:void 0)}}class se{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new E.Cache("DocumentLink")}async provideLinks(j,Z){const ne=this._documents.getDocument(j),oe=await A.asPromise(()=>this._provider.provideDocumentLinks(ne,Z));if(!(!Array.isArray(oe)||oe.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(se._validateLink).map(k.DocumentLink.from)};{const J=this._cache.add(oe),ce={links:[],id:J};for(let me=0;me<oe.length;me++){if(!se._validateLink(oe[me]))continue;const Le=k.DocumentLink.from(oe[me]);Le.cacheId=[J,me],ce.links.push(Le)}return ce}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...j);if(!ne)return;const oe=await A.asPromise(()=>this._provider.resolveDocumentLink(ne,Z));if(!(!oe||!se._validateLink(oe)))return k.DocumentLink.from(oe)}releaseLinks(j){this._cache.delete(j)}}class be{constructor(j,Z){this._documents=j,this._provider=Z}provideColors(j,Z){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentColors(ne,Z)).then(oe=>Array.isArray(oe)?oe.map(ce=>({color:k.Color.from(ce.color),range:k.Range.from(ce.range)})):[])}provideColorPresentations(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Range.to(Z.range),ce=k.Color.to(Z.color);return A.asPromise(()=>this._provider.provideColorPresentations(ce,{document:oe,range:J},ne)).then(me=>{if(!!Array.isArray(me))return me.map(k.ColorPresentation.from)})}}class Ie{constructor(j,Z){this._documents=j,this._provider=Z}provideFoldingRanges(j,Z,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideFoldingRanges(oe,Z,ne)).then(J=>{if(!!Array.isArray(J))return J.map(k.FoldingRange.from)})}}class Ce{constructor(j,Z,ne){this._documents=j,this._provider=Z,this._logService=ne}provideSelectionRanges(j,Z,ne){const oe=this._documents.getDocument(j),J=Z.map(k.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(oe,J,ne)).then(ce=>{if(!r.isNonEmptyArray(ce))return[];if(ce.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Le=0;Le<J.length;Le++){const We=[];me.push(We);let Ee=J[Le],Ke=ce[Le];for(;;){if(!Ke.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(We.push(k.SelectionRange.from(Ke)),!Ke.parent)break;Ee=Ke.range,Ke=Ke.parent}}return me})}}class Me{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,ne){const oe=this._documents.getDocument(j),J=k.Position.to(Z),ce=await this._provider.prepareCallHierarchy(oe,J,ne);if(!ce)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(ce)?ce.map(Le=>this._cacheAndConvertItem(me,Le)):[this._cacheAndConvertItem(me,ce)]}async provideCallsTo(j,Z,ne){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(oe,ne);if(!!J)return J.map(ce=>({from:this._cacheAndConvertItem(j,ce.from),fromRanges:ce.fromRanges.map(me=>k.Range.from(me))}))}async provideCallsFrom(j,Z,ne){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(oe,ne);if(!!J)return J.map(ce=>({to:this._cacheAndConvertItem(j,ce.to),fromRanges:ce.fromRanges.map(me=>k.Range.from(me))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){var ne;const oe=this._cache.get(j),J={_sessionId:j,_itemId:oe.size.toString(36),name:Z.name,detail:Z.detail,kind:k.SymbolKind.from(Z.kind),uri:Z.uri,range:k.Range.from(Z.range),selectionRange:k.Range.from(Z.selectionRange),tags:(ne=Z.tags)===null||ne===void 0?void 0:ne.map(k.SymbolTag.from)};return oe.set(J._itemId,Z),J}_itemFromCache(j,Z){const ne=this._cache.get(j);return ne==null?void 0:ne.get(Z)}}class qe{constructor(j,Z){this.adapter=j,this.extension=Z}}class He{constructor(j,Z,ne,oe,J,ce,me){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=oe,this._diagnostics=J,this._logService=ce,this._apiDeprecation=me}_transformDocumentSelector(j){return r.coalesce(r.asArray(j).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:k.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new y.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return He._handlePool++}_withAdapter(j,Z,ne,oe,J=!1){const ce=this._adapter.get(j);if(!ce)return Promise.resolve(oe);if(ce.adapter instanceof Z){let me;ce.extension&&(me=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Le=ne(ce.adapter,ce.extension),We=ce.extension;return We&&Promise.resolve(Le).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-me}ms`),Ee=>{J&&Ee instanceof b.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(Ee))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const ne=this._nextHandle();return this._adapter.set(ne,new qe(j,Z)),ne}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,ne,oe){const J=this._addNewAdapter(new d(this._documents,ne),j),ce=oe&&oe.label||He._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Z),ce),this._createDisposable(J)}$provideDocumentSymbols(j,Z,ne){return this._withAdapter(j,d,oe=>oe.provideDocumentSymbols(p.URI.revive(Z),ne),void 0)}registerCodeLensProvider(j,Z,ne){const oe=this._nextHandle(),J=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new qe(new g(this._documents,this._commands.converter,ne),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(Z),J);let ce=this._createDisposable(oe);if(J!==void 0){const me=ne.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(J));ce=y.Disposable.from(ce,me)}return ce}$provideCodeLenses(j,Z,ne){return this._withAdapter(j,g,oe=>oe.provideCodeLenses(p.URI.revive(Z),ne),void 0)}$resolveCodeLens(j,Z,ne){return this._withAdapter(j,g,oe=>oe.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,g,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,ne){const oe=this._addNewAdapter(new i(this._documents,ne),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDefinition(j,Z,ne,oe){return this._withAdapter(j,i,J=>J.provideDefinition(p.URI.revive(Z),ne,oe),[])}registerDeclarationProvider(j,Z,ne){const oe=this._addNewAdapter(new s(this._documents,ne),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDeclaration(j,Z,ne,oe){return this._withAdapter(j,s,J=>J.provideDeclaration(p.URI.revive(Z),ne,oe),[])}registerImplementationProvider(j,Z,ne){const oe=this._addNewAdapter(new n(this._documents,ne),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideImplementation(j,Z,ne,oe){return this._withAdapter(j,n,J=>J.provideImplementation(p.URI.revive(Z),ne,oe),[])}registerTypeDefinitionProvider(j,Z,ne){const oe=this._addNewAdapter(new o(this._documents,ne),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideTypeDefinition(j,Z,ne,oe){return this._withAdapter(j,o,J=>J.provideTypeDefinition(p.URI.revive(Z),ne,oe),[])}registerHoverProvider(j,Z,ne,oe){const J=this._addNewAdapter(new v(this._documents,ne),j);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideHover(j,Z,ne,oe){return this._withAdapter(j,v,J=>J.provideHover(p.URI.revive(Z),ne,oe),void 0)}registerEvaluatableExpressionProvider(j,Z,ne,oe){const J=this._addNewAdapter(new m(this._documents,ne),j);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Z)),this._createDisposable(J)}$provideEvaluatableExpression(j,Z,ne,oe){return this._withAdapter(j,m,J=>J.provideEvaluatableExpression(p.URI.revive(Z),ne,oe),void 0)}registerInlineValuesProvider(j,Z,ne,oe){const J=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new _(this._documents,ne),j);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(Z),J);let me=this._createDisposable(ce);if(J!==void 0){const Le=ne.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(J));me=y.Disposable.from(me,Le)}return me}$provideInlineValues(j,Z,ne,oe,J){return this._withAdapter(j,_,ce=>ce.provideInlineValues(p.URI.revive(Z),ne,oe,J),void 0)}registerDocumentHighlightProvider(j,Z,ne){const oe=this._addNewAdapter(new D(this._documents,ne),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentHighlights(j,Z,ne,oe){return this._withAdapter(j,D,J=>J.provideDocumentHighlights(p.URI.revive(Z),ne,oe),void 0)}registerLinkedEditingRangeProvider(j,Z,ne){const oe=this._addNewAdapter(new a(this._documents,ne),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,Z,ne,oe){return this._withAdapter(j,a,async J=>{const ce=await J.provideLinkedEditingRanges(p.URI.revive(Z),ne,oe);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?He._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,ne){const oe=this._addNewAdapter(new R(this._documents,ne),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideReferences(j,Z,ne,oe,J){return this._withAdapter(j,R,ce=>ce.provideReferences(p.URI.revive(Z),ne,oe,J),void 0)}registerCodeActionProvider(j,Z,ne,oe){var J,ce;const me=new h.DisposableStore,Le=this._addNewAdapter(new M(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Le,this._transformDocumentSelector(Z),{providedKinds:(J=oe==null?void 0:oe.providedCodeActionKinds)===null||J===void 0?void 0:J.map(We=>We.value),documentation:(ce=oe==null?void 0:oe.documentation)===null||ce===void 0?void 0:ce.map(We=>({kind:We.kind.value,command:this._commands.converter.toInternal(We.command,me)}))},He._extLabel(j),Boolean(ne.resolveCodeAction)),me.add(this._createDisposable(Le)),me}$provideCodeActions(j,Z,ne,oe,J){return this._withAdapter(j,M,ce=>ce.provideCodeActions(p.URI.revive(Z),ne,oe,J),void 0)}$resolveCodeAction(j,Z,ne){return this._withAdapter(j,M,oe=>oe.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,M,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,ne){const oe=this._addNewAdapter(new $(this._documents,ne),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,Z,ne,oe){return this._withAdapter(j,$,J=>J.provideDocumentFormattingEdits(p.URI.revive(Z),ne,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,ne){const oe=this._addNewAdapter(new Y(this._documents,ne),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,Z,ne,oe,J){return this._withAdapter(j,Y,ce=>ce.provideDocumentRangeFormattingEdits(p.URI.revive(Z),ne,oe,J),void 0)}registerOnTypeFormattingEditProvider(j,Z,ne,oe){const J=this._addNewAdapter(new le(this._documents,ne),j);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Z),oe,j.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(j,Z,ne,oe,J,ce){return this._withAdapter(j,le,me=>me.provideOnTypeFormattingEdits(p.URI.revive(Z),ne,oe,J,ce),void 0)}registerWorkspaceSymbolProvider(j,Z){const ne=this._addNewAdapter(new q(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(j,Z,ne){return this._withAdapter(j,q,oe=>oe.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,ne){return this._withAdapter(j,q,oe=>oe.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,q,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,ne){const oe=this._addNewAdapter(new U(this._documents,ne,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(Z),U.supportsResolving(ne)),this._createDisposable(oe)}$provideRenameEdits(j,Z,ne,oe,J){return this._withAdapter(j,U,ce=>ce.provideRenameEdits(p.URI.revive(Z),ne,oe,J),void 0)}$resolveRenameLocation(j,Z,ne,oe){return this._withAdapter(j,U,J=>J.resolveRenameLocation(p.URI.revive(Z),ne,oe),void 0)}registerDocumentSemanticTokensProvider(j,Z,ne,oe){const J=this._nextHandle(),ce=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new qe(new O(this._documents,ne),j)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Z),oe,ce);let me=this._createDisposable(J);if(ce){const Le=ne.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ce));me=y.Disposable.from(me,Le)}return me}$provideDocumentSemanticTokens(j,Z,ne,oe){return this._withAdapter(j,O,J=>J.provideDocumentSemanticTokens(p.URI.revive(Z),ne,oe),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,O,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,ne,oe){const J=this._addNewAdapter(new W(this._documents,ne),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Z),oe),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(j,Z,ne,oe){return this._withAdapter(j,W,J=>J.provideDocumentRangeSemanticTokens(p.URI.revive(Z),ne,oe),null,!0)}registerCompletionItemProvider(j,Z,ne,oe){const J=this._addNewAdapter(new T(this._documents,this._commands.converter,ne,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Z),oe,T.supportsResolving(ne),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(J)}$provideCompletionItems(j,Z,ne,oe,J){return this._withAdapter(j,T,ce=>ce.provideCompletionItems(p.URI.revive(Z),ne,oe,J),void 0)}$resolveCompletionItem(j,Z,ne){return this._withAdapter(j,T,oe=>oe.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,T,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,ne){const oe=this._addNewAdapter(new F(this._documents,ne,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideInlineCompletions(j,Z,ne,oe,J){return this._withAdapter(j,F,ce=>ce.provideInlineCompletions(p.URI.revive(Z),ne,oe,J),void 0)}$handleInlineCompletionDidShow(j,Z,ne){this._withAdapter(j,F,async oe=>{oe.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,F,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,ne,oe){const J=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ce=this._addNewAdapter(new x(this._documents,ne),j);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(Z),J),this._createDisposable(ce)}$provideSignatureHelp(j,Z,ne,oe,J){return this._withAdapter(j,x,ce=>ce.provideSignatureHelp(p.URI.revive(Z),ne,oe,J),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,x,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,ne){const oe=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new G(this._documents,ne),j);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Z),oe);let ce=this._createDisposable(J);if(oe!==void 0){const me=ne.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(oe));ce=y.Disposable.from(ce,me)}return ce}$provideInlayHints(j,Z,ne,oe){return this._withAdapter(j,G,J=>J.provideInlayHints(p.URI.revive(Z),ne,oe),void 0)}registerDocumentLinkProvider(j,Z,ne){const oe=this._addNewAdapter(new se(this._documents,ne),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,Z,ne){return this._withAdapter(j,se,oe=>oe.provideLinks(p.URI.revive(Z),ne),void 0)}$resolveDocumentLink(j,Z,ne){return this._withAdapter(j,se,oe=>oe.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,se,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(j,Z,ne){const oe=this._addNewAdapter(new be(this._documents,ne),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentColors(j,Z,ne){return this._withAdapter(j,be,oe=>oe.provideColors(p.URI.revive(Z),ne),[])}$provideColorPresentations(j,Z,ne,oe){return this._withAdapter(j,be,J=>J.provideColorPresentations(p.URI.revive(Z),ne,oe),void 0)}registerFoldingRangeProvider(j,Z,ne){const oe=this._nextHandle(),J=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new qe(new Ie(this._documents,ne),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(Z),J);let ce=this._createDisposable(oe);if(J!==void 0){const me=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ce=y.Disposable.from(ce,me)}return ce}$provideFoldingRanges(j,Z,ne,oe){return this._withAdapter(j,Ie,J=>J.provideFoldingRanges(p.URI.revive(Z),ne,oe),void 0)}registerSelectionRangeProvider(j,Z,ne){const oe=this._addNewAdapter(new Ce(this._documents,ne,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideSelectionRanges(j,Z,ne,oe){return this._withAdapter(j,Ce,J=>J.provideSelectionRanges(p.URI.revive(Z),ne,oe),[])}registerCallHierarchyProvider(j,Z,ne){const oe=this._addNewAdapter(new Me(this._documents,ne),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$prepareCallHierarchy(j,Z,ne,oe){return this._withAdapter(j,Me,J=>Promise.resolve(J.prepareSession(p.URI.revive(Z),ne,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,ne,oe){return this._withAdapter(j,Me,J=>J.provideCallsTo(Z,ne,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,ne,oe){return this._withAdapter(j,Me,J=>J.provideCallsFrom(Z,ne,oe),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,Me,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:S.regExpFlags(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:He._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:He._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?He._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?He._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:He._serializeRegExp(j.beforeText),afterText:j.afterText?He._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?He._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(He._serializeOnEnterRule)}setLanguageConfiguration(j,Z,ne){let{wordPattern:oe}=ne;if(oe&&S.regExpLeadsToEndlessLoop(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(Z,oe):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const J=this._nextHandle(),ce={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?He._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?He._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?He._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Z,ce),this._createDisposable(J)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=He,He._handlePool=0}),define(ge[230],pe([0,1,5,17,7]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(P,S){this._proxy=P.getProxy(p.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,S){await this._proxy.$changeLanguage(P,S);const C=this._documents.getDocumentData(P);if(!C)throw new Error(`document '${P.toString}' NOT found`);return C.document}async tokenAtPosition(P,S){var C;const r=P.version,I=L.Position.from(S),l=await this._proxy.$tokensAtPosition(P.uri,I),h={type:k.StandardTokenType.Other,range:(C=P.getWordRangeAtPosition(S))!==null&&C!==void 0?C:new k.Range(S.line,S.character,S.line,S.character)};if(!l)return h;const c={range:L.Range.to(l.range),type:L.TokenType.to(l.type)};return!c.range.contains(S)||r!==P.version?h:c}}e.ExtHostLanguages=y}),define(ge[231],pe([0,1,5,12,35]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(P){return P&&P.title}let A=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(p.MainContext.MainThreadMessageService)}showMessage(S,C,r,I,l){const h={extension:S};let c;typeof I=="string"||y(I)?c=[I,...l]:(h.modal=I==null?void 0:I.modal,h.useCustom=I==null?void 0:I.useCustom,h.detail=I==null?void 0:I.detail,c=l),h.useCustom&&k.checkProposedApiEnabled(S);const f=[];for(let E=0;E<c.length;E++){const w=c[E];if(typeof w=="string")f.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:u}=w;f.push({title:b,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,r,h,f).then(E=>{if(typeof E=="number")return c[E]})}};A=je([$e(1,L.ILogService)],A),e.ExtHostMessageService=A}),define(ge[232],pe([0,1,22,3,73,6,23,8,15,2,82,5,17,7,208,123]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class E{constructor(b,u,d,g,t){this._textDocumentsAndEditors=d,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new r.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const n=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,o=i.cell.handle,v=this._documents.get(n),m=v==null?void 0:v.getCell(o);if(m)return m.apiCell}return i}})}get activeNotebookEditor(){var b;return(b=this._activeNotebookEditor)===null||b===void 0?void 0:b.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const u=this._editors.get(b);if(!u)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(b){for(const[u,d]of this._editors)if(d.apiEditor===b)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,u){const d=this._documents.get(b);if(!d&&!u)throw new Error(`NO notebook document for '${b}'`);return d}_getProviderData(b){const u=this._notebookContentProviders.get(b);if(!u)throw new Error(`NO provider for '${b}'`);return u}registerNotebookContentProvider(b,u,d,g,t){if(P.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:b,provider:d});let i;return d.onDidChangeNotebookContentOptions&&(i=d.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(d.options);this._notebookProxy.$updateNotebookProviderOptions(u,s)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},u,l.NotebookDocumentContentOptions.from(g),E._convertNotebookRegistrationData(b,t)),new h.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(b,u){if(!u)return;const d=u.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(u.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:u.displayName,filenamePattern:d,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,u,d){const g=E._notebookStatusBarItemProviderHandlePool++,t=typeof d.onDidChangeCellStatusBarItems=="function"?E._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,d),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,u);let i;return t!==void 0&&(i=d.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(b){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&l.NotebookData.from(b.content)});return C.URI.revive(u)}async openNotebookDocument(b){const u=this._documents.get(b);if(u)return u.apiNotebook;const d=await this._notebookDocumentsProxy.$tryOpenNotebook(b),g=this._documents.get(C.URI.revive(d));return S.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(b,u){var d;C.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof u=="object"?g={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(l.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,g),i=t&&((d=this._editors.get(t))===null||d===void 0?void 0:d.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,u,d,g){const t=this._notebookStatusBarItemProviders.get(b),i=C.URI.revive(u),s=this._documents.get(i);if(!s||!t)return;const n=s.getCellFromIndex(d);if(!n)return;const o=await t.provideCellStatusBarItems(n.apiCell,g);if(!o)return;const v=new y.DisposableStore,m=this._statusBarCache.add([v]),D=(Array.isArray(o)?o:[o]).map(a=>l.NotebookStatusBarItem.from(a,this._commandsConverter,v));return{cacheId:m,items:D}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,u,d,g,t){if(P.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,d),this._notebookProxy.$registerNotebookSerializer(i,{id:b.identifier,location:b.extensionLocation},u,l.NotebookDocumentContentOptions.from(g),E._convertNotebookRegistrationData(b,t)),y.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(b,u,d){const g=this._notebookSerializer.get(b);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(u.buffer,d);return l.NotebookData.from(t)}async $notebookToData(b,u,d){const g=this._notebookSerializer.get(b);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(l.NotebookData.to(u),d);return p.VSBuffer.wrap(t)}async $openNotebook(b,u,d,g,t){var i;const{provider:s}=this._getProviderData(b),n=await s.openNotebook(C.URI.revive(u),{backupId:d,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=n.metadata)!==null&&i!==void 0?i:Object.create(null),cells:n.cells.map(l.NotebookCellData.from)}}async $saveNotebook(b,u,d){const g=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(b);return await t.saveNotebook(g.apiNotebook,d),!0}async $saveNotebookAs(b,u,d,g){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:i}=this._getProviderData(b);return await i.saveNotebookAs(C.URI.revive(d),t.apiNotebook,g),!0}async $backupNotebook(b,u,d){var g;const t=this.getNotebookDocument(C.URI.revive(u)),i=this._getProviderData(b),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),n=String(k.hash([t.uri.toString(),this._backupIdPool++])),o=C.URI.joinPath(s,n),v=await i.provider.backupNotebook(t.apiNotebook,{destination:o},d);return t.updateBackup(v),v.id}_createExtHostEditor(b,u,d){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const g=new f.ExtHostNotebookEditor(u,this._notebookEditorsProxy,b,d.visibleRanges.map(l.NotebookRange.to),d.selections.map(l.NotebookRange.to),typeof d.viewColumn=="number"?l.ViewColumn.to(d.viewColumn):void 0);this._editors.set(u,g)}$acceptDocumentAndEditorsDelta(b){var u,d,g;if(b.removedDocuments)for(const i of b.removedDocuments){const s=C.URI.revive(i),n=this._documents.get(s);n&&(n.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(b.addedDocuments){const i=[];for(const s of b.addedDocuments){const n=C.URI.revive(s.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const o=this,v=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){o._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){o._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){o._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){o._onDidChangeCellExecutionState.fire(m)}},n,s);i.push(...s.cells.map(m=>c.ExtHostCell.asModelAddData(v.apiNotebook,m))),(u=this._documents.get(n))===null||u===void 0||u.dispose(),this._documents.set(n,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(b.addedEditors)for(const i of b.addedEditors){if(this._editors.has(i.id))return;const s=C.URI.revive(i.documentUri),n=this._documents.get(s);n&&this._createExtHostEditor(n,i.id,i)}const t=[];if(b.removedEditors)for(const i of b.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(b.visibleEditors){this._visibleNotebookEditors=b.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const n=i.has(s.id);s._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.newActiveEditor===null?this._activeNotebookEditor=void 0:b.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.newActiveEditor)),b.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=E,E._notebookStatusBarItemProviderHandlePool=0}),define(ge[233],pe([0,1,3,69,12,5,13,17]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(I,l){const h=S._Keys.nextId();I.$registerNotebookEditorDecorationType(h,P.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){I.$removeNotebookEditorDecorationType(h)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,l,h){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new S(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const h=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(P.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(P.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(P.ViewColumn.to(I[l]))}};C=je([$e(0,k.ILogService),$e(1,A.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(ge[234],pe([0,1,3,6,5,26,2,17,84,23,16,85,21,18,12,7,35]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,i,s,n){this._initData=i,this._extHostNotebook=s,this._logService=n,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,n,o,v){for(let T of this._kernelData.values())if(T.controller.id===i&&y.ExtensionIdentifier.equals(t.identifier,T.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const m=this._handlePool++,_=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${i}`);const D=()=>console.warn(`NO execute handler from notebook controller '${Y.id}' of extension: '${t.identifier}'`);let a=!1;const R=new L.DisposableStore,M=new p.Emitter,$=new p.Emitter,Y={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let le=o??D,q;this._proxy.$addKernel(m,Y).catch(T=>{console.log(T),a=!0});let U=0;const z=()=>{if(a)return;const T=++U;Promise.resolve().then(()=>{T===U&&this._proxy.$updateKernel(m,Y)})},O=new C.ResourceMap,W={get id(){return i},get notebookType(){return Y.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return Y.label},set label(T){var F;Y.label=(F=T??t.displayName)!==null&&F!==void 0?F:t.name,z()},get detail(){var T;return(T=Y.detail)!==null&&T!==void 0?T:""},set detail(T){Y.detail=T,z()},get description(){var T;return(T=Y.description)!==null&&T!==void 0?T:""},set description(T){Y.description=T,z()},get supportedLanguages(){return Y.supportedLanguages},set supportedLanguages(T){Y.supportedLanguages=T,z()},get supportsExecutionOrder(){var T;return(T=Y.supportsExecutionOrder)!==null&&T!==void 0?T:!1},set supportsExecutionOrder(T){Y.supportsExecutionOrder=T,z()},get rendererScripts(){return Y.preloads?Y.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return le},set executeHandler(T){le=T??D},get interruptHandler(){return q},set interruptHandler(T){q=T,Y.supportsInterrupt=Boolean(T),z()},createNotebookCellExecution(T){if(a)throw new Error("notebook controller is DISPOSED");if(!O.has(T.notebook.uri))throw _._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(O.keys()).map(F=>F.toString())),new Error(`notebook controller is NOT associated to notebook: ${T.notebook.uri.toString()}`);return _._createNotebookCellExecution(T)},dispose:()=>{a||(this._logService.trace(`NotebookController[${m}], DISPOSED`),a=!0,this._kernelData.delete(m),R.dispose(),M.dispose(),$.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(T,F){_._proxy.$updateNotebookPriority(m,T.uri,F)},onDidReceiveMessage:$.event,postMessage(T,F){return E.checkProposedApiEnabled(t),_._proxy.$postMessage(m,F&&_._extHostNotebook.getIdByEditor(F),T)},asWebviewUri(T){return E.checkProposedApiEnabled(t),S.asWebviewUri(T,_._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:W,onDidReceiveMessage:$,onDidChangeSelection:M,associatedNotebooks:O}),W}$acceptNotebookAssociation(t,i,s){const n=this._kernelData.get(t);if(n){const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));s?n.associatedNotebooks.set(o.uri,!0):n.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,o.uri.toString(),s),n.onDidChangeSelection.fire({selected:s,notebook:o.apiNotebook})}}async $executeCells(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i)),v=[];for(let m of s){const _=o.getCell(m);_&&v.push(_.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,o.uri.toString(),v.length),await n.controller.executeHandler.call(n.controller,v,o.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,i,s){var n;const o=this._kernelData.get(t);if(!o)return;const v=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,v.apiNotebook);else for(let m of s){const _=v.getCell(m);_&&((n=this._activeExecutions.get(_.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getEditorById(i);n.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const n=new u(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,n);const o=n.onDidChangeState(()=>{n.state===b.Resolved&&(n.dispose(),o.dispose(),this._activeExecutions.delete(s.uri))});return n.asApiObject()}};w=je([$e(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var b;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(b||(b={}));class u extends L.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=b.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new d(10,n=>this.applyEdits(n)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===b.Init)throw new Error("Must call start before modifying cell output");if(this._state===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=f.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?P.NotebookCellOutput.from(i):P.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const n=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:n,append:s,outputs:o})}async updateOutputItems(t,i,s){return t=f.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(P.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===b.Resolved||t._state===b.Started)throw new Error("Cannot call start again");t._state=b.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,n){if(t._state===b.Resolved)throw new Error("Cannot call resolve twice");t._state=b.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:n??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!0)},replaceOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!1)},appendOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!0)},replaceOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!1)}})}}class d{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=r.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(ge[235],pe([0,1,3,5,123]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(P,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,C){var r;const I=this._extHostNotebook.getEditorById(P);(r=this._rendererMessageEmitters.get(S))===null||r===void 0||r.fire({editor:I.apiEditor,message:C})}createRendererMessaging(P){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(P).event(...C),postMessage:(C,r)=>{const I=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,P,r)}}}getOrCreateEmitterFor(P){let S=this._rendererMessageEmitters.get(P);return S||(S=new p.Emitter({onLastListenerRemove:()=>{S==null||S.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,S),S)}}e.ExtHostNotebookRenderers=y}),define(ge[61],pe([0,1,5,3,6,22,4,13]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends k.Disposable{constructor(c,f,E,w){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,f,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?y.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(f=>this._proxy.$clear(f,c))}show(c,f){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof c=="boolean"?c:f)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class C extends S{constructor(c,f){super(c,!1,void 0,f)}append(c){super.append(c),this._id.then(f=>this._proxy.$append(f,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class r extends S{constructor(c,f,E){super(c,!0,f,E)}append(c){throw new Error("Not supported")}}class I{constructor(c,f){this.name=c,this._channel=f}append(c){this._channel.then(f=>f.append(c))}appendLine(c){this._channel.then(f=>f.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,f){this._channel.then(E=>E.show(c,f))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(c){this._proxy=c.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new C(c,this._proxy)}createOutputChannelFromLogFile(c,f){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new r(c,f,this._proxy)}};l=je([$e(0,P.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(ge[236],pe([0,1,16,21,3,6,5,2,7,14,18,53]),function(X,e,p,L,k,y,A,P,S,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(h,c,f){const E=h.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(n,o){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=o}showQuickPick(n,o,v,m=L.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(n),D=++this._instances,a=E.$show(D,{title:v==null?void 0:v.title,placeHolder:v==null?void 0:v.placeHolder,matchOnDescription:v==null?void 0:v.matchOnDescription,matchOnDetail:v==null?void 0:v.matchOnDetail,ignoreFocusLost:v==null?void 0:v.ignoreFocusOut,canPickMany:v==null?void 0:v.canPickMany},m),R={},M=a.then(()=>R);return Promise.race([M,_]).then($=>{if($!==R)return _.then(Y=>{const le=[];for(let q=0;q<Y.length;q++){const U=Y[q];let z,O,W,T,F;typeof U=="string"?z=U:(z=U.label,O=U.description,W=U.detail,T=U.picked,F=U.alwaysShow),le.push({label:z,description:O,handle:q,detail:W,picked:T,alwaysShow:F})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{v.onDidSelectItem(Y[q])}),E.$setItems(D,le),a.then(q=>{if(typeof q=="number")return Y[q];if(Array.isArray(q))return q.map(U=>Y[U])})})}).then(void 0,$=>{if(!C.isPromiseCanceledError($))return E.$setError(D,$),Promise.reject($)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=L.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,E.$input(n,typeof this._validateInput=="function",o).then(void 0,v=>{if(!C.isPromiseCanceledError(v))return Promise.reject(v)})}$validateInput(n){return this._validateInput?p.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=L.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!v)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(_=>_.uri.toString()===v.uri.toString())}createQuickPick(n,o){const v=new t(n,o,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(n){const o=new i(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const v=this._sessions.get(n);v&&v._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const v=this._sessions.get(n);v&&v._fireDidTriggerButton(o)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}class b{constructor(n,o){this._extensionId=n,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,v)=>{const m=o===S.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(m,o)}),this.update({buttons:n.map((o,v)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===S.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const v=n[o];this._pendingUpdate[o]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function u(s){if(s instanceof S.ThemeIcon)return{id:s.id};const n=g(s),o=d(s);return{dark:typeof n=="string"?P.URI.file(n):n,light:typeof o=="string"?P.URI.file(o):o}}function d(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends b{constructor(n,o,v){super(n,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,v)=>{this._handlesToItems.set(v,o),this._itemsToHandles.set(o,v)}),this.update({items:n.map((o,v)=>({label:o.label,description:o.description,handle:v,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class i extends b{constructor(n,o){super(n,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new w(c,f)}e.createExtHostQuickOpen=l}),define(ge[237],pe([0,1,2,3,51,6,16,5,18,96,12,26,35]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(n){if(n)return typeof n.iconPath=="string"?p.URI.file(n.iconPath):n.iconPath}function c(n,o){if(!n.iconPath&&!o.iconPath)return 0;if(n.iconPath){if(!o.iconPath)return 1}else return-1;const v=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return C.comparePaths(v,m)}function f(n,o){let v=0;if(n.strikeThrough!==o.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==o.faded)return n.faded?1:-1;if(n.tooltip!==o.tooltip)return(n.tooltip||"").localeCompare(o.tooltip||"");if(v=c(n,o),v!==0)return v;if(n.light&&o.light)v=c(n.light,o.light);else{if(n.light)return 1;if(o.light)return-1}if(v!==0)return v;if(n.dark&&o.dark)v=c(n.dark,o.dark);else{if(n.dark)return 1;if(o.dark)return-1}return v}function E(n,o){if(n.command!==o.command)return n.command<o.command?-1:1;if(n.title!==o.title)return n.title<o.title?-1:1;if(n.tooltip!==o.tooltip){if(n.tooltip!==void 0&&o.tooltip!==void 0)return n.tooltip<o.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(n.arguments===o.arguments)return 0;if(n.arguments)if(o.arguments){if(n.arguments.length!==o.arguments.length)return n.arguments.length-o.arguments.length}else return 1;else return-1;for(let v=0;v<n.arguments.length;v++){const m=n.arguments[v],_=o.arguments[v];if(m!==_)return m<_?-1:1}return 0}function w(n,o){let v=C.comparePaths(n.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(v!==0)return v;if(n.command&&o.command)v=E(n.command,o.command);else{if(n.command)return 1;if(o.command)return-1}if(v!==0)return v;if(n.decorations&&o.decorations)v=f(n.decorations,o.decorations);else{if(n.decorations)return 1;if(o.decorations)return-1}return v}function b(n,o){for(let v=0;v<n.length;v++)if(n[v]!==o[v])return!1;return!0}function u(n,o){return n.command===o.command&&n.title===o.title&&n.tooltip===o.tooltip&&(n.arguments&&o.arguments?b(n.arguments,o.arguments):n.arguments===o.arguments)}function d(n,o){return S.equals(n,o,u)}class g{constructor(o,v,m){this._extension=o,this._proxy=v,this._sourceControlHandle=m,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(l.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,v){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,v)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=g;class t{constructor(o,v,m,_,D){this._proxy=o,this._commands=v,this._sourceControlHandle=m,this._id=_,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,v){const m=this._resourceStatesCommandsMap.get(o);return m?A.asPromise(()=>this._commands.executeCommand(m.command,...m.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const v=[...this._resourceStates].sort(w),_=S.sortedDiff(this._resourceSnapshot,v,w).map(R=>{const M=R.toInsert.map($=>{const Y=this._resourceHandlePool++;this._resourceStatesMap.set(Y,$);const le=$.resourceUri,q=h($.decorations),U=$.decorations&&h($.decorations.light)||q,z=$.decorations&&h($.decorations.dark)||q,O=[];let W;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const se=new y.DisposableStore;W=this._commands.converter.toInternal($.command,se),this._resourceStatesDisposablesMap.set(Y,se)}else this._resourceStatesCommandsMap.set(Y,$.command);U&&O.push(U),z&&z.toString()!==(U==null?void 0:U.toString())&&O.push(z);const T=$.decorations&&$.decorations.tooltip||"",F=$.decorations&&!!$.decorations.strikeThrough,N=$.decorations&&!!$.decorations.faded,x=$.contextValue||"";return{rawResource:[Y,le,O,T,F,N,x,W],handle:Y}});return{start:R.start,deleteCount:R.deleteCount,toInsert:M}}),D=_.map(({start:R,deleteCount:M,toInsert:$})=>[R,M,$.map(Y=>Y.rawResource)]),a=_.reverse();for(const{start:R,deleteCount:M,toInsert:$}of a){const Y=$.map(q=>q.handle),le=this._handlesSnapshot.splice(R,M,...Y);for(const q of le)this._resourceStatesMap.delete(q),this._resourceStatesCommandsMap.delete(q),(o=this._resourceStatesDisposablesMap.get(q))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(q)}return this._resourceSnapshot=v,D}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(o,v,m,_,D,a){this._proxy=v,this._commands=m,this._id=_,this._label=D,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,D,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=o;const v=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&d(this._statusBarCommands,o))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=o;const v=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(o,v){const m=new t(this._proxy,this._commands,this.handle,o,v),_=L.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,_),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],v=[];for(const[m,_]of this.createdResourceGroups){_.dispose();const D=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});L.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),D.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const a=m._takeResourceStateSnapshot();a.length>0&&v.push([m.handle,a]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(v=>{const m=v._takeResourceStateSnapshot();m.length!==0&&o.push([v.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([k.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),je([k.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(o,v,m){this._commands=v,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const D=this._sourceControls.get(_.sourceControlHandle);if(!D)return _;const a=D.getResourceGroup(_.groupHandle);return a?a.getResourceState(_.handle):_}else if(_&&_.$mid===4){const D=this._sourceControls.get(_.sourceControlHandle);return D?D.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const D=this._sourceControls.get(_.handle);return D||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,v,m,_){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,v,m,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const D=Un._handlePool++,a=new i(o,this._proxy,this._commands,v,m,_);this._sourceControls.set(D,a);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),R),a}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const v=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),m=v&&v[v.length-1];return m&&m.inputBox}$provideOriginalResource(o,v,m){const _=p.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,_.toString());const D=this._sourceControls.get(o);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>D.quickDiffProvider.provideOriginalResource(_,m)).then(a=>a||null)}$onInputBoxValueChange(o,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(o,v,m,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,v,m);const D=this._sourceControls.get(o);if(!D)return Promise.resolve(void 0);const a=D.getResourceGroup(v);return a?a.$executeResourceCommand(m,_):Promise.resolve(void 0)}$validateInput(o,v,m){this.logService.trace("ExtHostSCM#$validateInput",o);const _=this._sourceControls.get(o);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>_.inputBox.validateInput(v,m)).then(D=>D?Promise.resolve([D.message,D.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var v,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((v=this._sourceControls.get(o))===null||v===void 0||v.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=je([$e(2,r.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[238],pe([0,1,7,5,161,6,17]),function(X,e,p,L,k,y,A){"use strict";var P,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(h,c,f,E,w=p.StatusBarAlignment.Left,b){P.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,P,h,"f"),it(this,S,c,"f"),this._entryId=C.ID_GEN++,this._extension=f,this._id=E,this._alignment=w,this._priority=b}get id(){var h;return(h=this._id)!==null&&h!==void 0?h:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set tooltip2(h){this._tooltip2=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!C.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,S,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,S,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,P,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let f;this._name?f=this._name:f=k.localize(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip2!==void 0?A.MarkdownString.fromStrict(this._tooltip2):this.tooltip;Be(this,P,"f").$setEntry(this._entryId,c,f,this._text,w,(h=this._command)===null||h===void 0?void 0:h.internal,E,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,P=new WeakMap,S=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class r{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=k.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const c={message:h};return this._messages.unshift(c),this._update(),new p.Disposable(()=>{const f=this._messages.indexOf(c);f>=0&&(this._messages.splice(f,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(h,c){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new r(this)}createStatusBarEntry(h,c,f,E){return new C(this._proxy,this._commands,h,c,f,E)}setStatusBarMessage(h,c){const f=this._statusMessage.setMessage(h);let E;return typeof c=="number"?E=setTimeout(()=>f.dispose(),c):typeof c!="undefined"&&c.then(()=>f.dispose(),()=>f.dispose()),new p.Disposable(()=>{f.dispose(),clearTimeout(E)})}}e.ExtHostStatusBar=I}),define(ge[88],pe([0,1,5,3,4]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(P){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this._proxy.$registerExtensionStorageKeysToSync(P,S)}getValue(P,S,C){return this._proxy.$getValue(P,S).then(r=>r||C)}setValue(P,S,C){return this._proxy.$setValue(P,S,C)}$acceptValue(P,S,C){this._onDidChangeStorage.fire({shared:P,key:S,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=k.createDecorator("IExtHostStorage")}),define(ge[89],pe([0,1,4,27,12,87,2]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=p.createDecorator("IExtensionStoragePaths");let P=class{constructor(C,r,I){var l;this._logService=r,this._extHostFileSystem=I,this._workspace=(l=C.workspace)!==null&&l!==void 0?l:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,I=A.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=A.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(C){if(this._value)return A.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return A.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};P=je([$e(0,L.IExtHostInitDataService),$e(1,k.ILogService),$e(2,y.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ge[33],pe([0,1,3,5,4,2,13,6,7,162,14,202,21,32,189,15]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=k.createDecorator("IExtHostTerminalService");class E{constructor(s,n,o,v){this._proxy=s,this._id=n,this._creationOptions=o,this._name=v,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(_=>this._pidPromiseComplete=_);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(_,D=!0){m._checkDisposed(),m._proxy.$sendText(m._id,_,D)},show(_){m._checkDisposed(),m._proxy.$show(m._id,_)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:f.withNullAsUndefined(s.shellPath),shellArgs:f.withNullAsUndefined(s.shellArgs),cwd:f.withNullAsUndefined(s.cwd),env:f.withNullAsUndefined(s.env),icon:f.withNullAsUndefined(t(s.iconPath)),initialText:f.withNullAsUndefined(s.message),strictEnv:f.withNullAsUndefined(s.strictEnv),hideFromUser:f.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:f.withNullAsUndefined(n==null?void 0:n.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:f.withNullAsUndefined(n==null?void 0:n.useShellEnvironment),isSplitTerminal:f.withNullAsUndefined(n==null?void 0:n.isSplitTerminal)})}async createExtensionTerminal(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:n,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,n){return s===this._cols&&n===this._rows||s===0||n===0?!1:(this._cols=s,this._rows=n,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=E;class w{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,n){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:n})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let b=1,u=class extends P.Disposable{constructor(s,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=n.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[o,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(s,n){const o=new E(this._proxy,h.generateUuid(),s,s.name),v=new w(s.pty);return o.createExtensionTerminal(n==null?void 0:n.isSplitTerminal,t(s.iconPath)).then(m=>{const _=this._setupExtHostProcessListeners(m,v);this._terminalProcessDisposables[m]=_}),this._terminals.push(o),o.value}attachPtyToTerminal(s,n){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const v=new w(n),m=this._setupExtHostProcessListeners(s,v);this._terminalProcessDisposables[s]=m}async $acceptActiveTerminalChanged(s){const n=this._activeTerminal;if(s===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(s);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,n){const o=this._getTerminalById(s);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(s,n,o){const v=this._getTerminalById(s);v&&v.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(s,n,o){var v;(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}async $acceptTerminalTitleChange(s,n){const o=this._getTerminalById(s);o&&(o.name=n)}async $acceptTerminalClosed(s,n){const o=this._getTerminalObjectIndexById(this._terminals,s);if(o!==null){const v=this._terminals.splice(o,1)[0];v.setExitCode(n),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(s,n,o,v){if(n){const D=this._getTerminalObjectIndexById(this._terminals,n);if(D!==null){this._terminals[D]._id=s,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const m={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:y.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},_=new E(this._proxy,s,m,o);this._terminals.push(_),this._onDidOpenTerminal.fire(_.value),_.isOpen=!0}async $acceptTerminalProcessId(s,n){const o=this._getTerminalById(s);o&&o._setProcessId(n)}async $startExtensionTerminal(s,n){const o=this._getTerminalById(s);if(!o)return{message:C.localize(0,null,s)};o.isOpen||await new Promise(m=>{const _=this.onDidOpenTerminal(async D=>{D===o.value&&(_.dispose(),m())})});const v=this._terminalProcesses.get(s);v?v.startSendingEvents(n):this._extensionTerminalAwaitingStart[s]={initialDimensions:n}}_setupExtHostProcessListeners(s,n){const o=new P.DisposableStore;o.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(s,m.pid,m.cwd))),o.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(s,m))),this._bufferer.startBuffering(s,n.onProcessData),o.add(n.onProcessExit(m=>this._onProcessExit(s,m))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(s,m))),this._terminalProcesses.set(s,n);const v=this._extensionTerminalAwaitingStart[s];return v&&n instanceof w&&(n.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),o}$acceptProcessAckDataEvent(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.input(n)}$acceptProcessResize(s,n,o){var v;try{(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(s,o))}$acceptProcessRequestCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(s,o))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,n,o){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,o),this._proxy.$registerProfileProvider(n,s.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(s,n){var o;const v=new l.CancellationTokenSource().token,m=await((o=this._profileProviders.get(s))===null||o===void 0?void 0:o.provideTerminalProfile(v));if(!v.isCancellationRequested){if(!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,{isSplitTerminal:n});return}this.createTerminalFromOptions(m.options,{isSplitTerminal:n})}}async $provideLinks(s,n){const o=this._getTerminalById(s);if(!o)return[];this._terminalLinkCache.delete(s);const v=this._terminalLinkCancellationSource.get(s);v&&v.dispose(!0);const m=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,m);const _=[],D={terminal:o.value,line:n},a=[];for(const $ of this._linkProviders)a.push(new Promise(async Y=>{m.token.onCancellationRequested(()=>Y({provider:$,links:[]}));const le=await $.provideTerminalLinks(D,m.token)||[];m.token.isCancellationRequested||Y({provider:$,links:le})}));const R=await Promise.all(a);if(m.token.isCancellationRequested)return[];const M=new Map;for(const $ of R)$&&$.links.length>0&&_.push(...$.links.map(Y=>{const le={id:b++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return M.set(le.id,{provider:$.provider,link:Y}),le}));return this._terminalLinkCache.set(s,M),_}$activateLink(s,n){var o;const v=(o=this._terminalLinkCache.get(s))===null||o===void 0?void 0:o.get(n);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(s,n){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const o=this._terminalProcessDisposables[s];o&&(o.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,n)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,n){const o=this._getTerminalObjectIndexById(s,n);return o!==null?s[o]:null}_getTerminalObjectIndexById(s,n){let o=null;return s.some((v,m)=>v._id===n?(o=m,!0):!1),o}getEnvironmentVariableCollection(s){let n=this._environmentVariableCollections.get(s.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(s.identifier.value,n)),n}_syncEnvironmentVariableCollection(s,n){const o=I.serializeEnvironmentVariableCollection(n.map);this._proxy.$setEnvironmentVariableCollection(s,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(s){s.forEach(n=>{const o=n[0],v=new d(n[1]);this._setEnvironmentVariableCollection(o,v)})}$acceptDefaultProfile(s,n){this._defaultProfile=s,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(s,n){this._environmentVariableCollections.set(s,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,n)})}};u=je([$e(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class d{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,n){this._setIfDiffers(s,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(s,n){this._setIfDiffers(s,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(s,n){this._setIfDiffers(s,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,n){const o=this.map.get(s);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(s,n),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,n){this.map.forEach((o,v)=>s.call(n,v,o,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let g=class extends u{constructor(s){super(!1,s)}createTerminal(s,n,o){throw new r.NotSupportedError}createTerminalFromOptions(s,n){throw new r.NotSupportedError}};g=je([$e(0,A.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}}),define(ge[239],pe([0,1,3,18,5,124,17,7]),function(X,e,p,L,k,y,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(r,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const I=this._extHostDocumentsAndEditors.allEditors();return r?I:I.map(l=>l.value)}async showTextDocument(r,I,l){let h;typeof I=="number"?h={position:A.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?h={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:h={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(r.uri,h),f=c&&this._extHostDocumentsAndEditors.getEditor(c);if(f)return f.value;throw c?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r,I){return new y.TextEditorDecorationType(this._proxy,r,I).value}$acceptEditorPropertiesChanged(r,I){const l=this._extHostDocumentsAndEditors.getEditor(r);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const h=I.selections.selections.map(A.Selection.to);l._acceptSelections(h)}if(I.visibleRanges){const h=L.coalesce(I.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(h)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const h=P.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:h})}if(I.visibleRanges){const h=L.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(r){for(const I in r){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const h=A.ViewColumn.to(r[I]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=S});var Sn=this&&this.__rest||function(X,e){var p={};for(var L in X)Object.prototype.hasOwnProperty.call(X,L)&&e.indexOf(L)<0&&(p[L]=X[L]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,L=Object.getOwnPropertySymbols(X);k<L.length;k++)e.indexOf(L[k])<0&&Object.prototype.propertyIsEnumerable.call(X,L[k])&&(p[L[k]]=X[L[k]]);return p};define(ge[240],pe([0,1,2,4,5,6,7]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=L.createDecorator("IExtHostTimeline");class P{constructor(r,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{var h,c;if(l&&l.$mid===11){const f=l.uri===void 0?void 0:p.URI.revive(l.uri);return(c=(h=this._itemsBySourceAndUriMap.get(l.source))===null||h===void 0?void 0:h.get(S(f)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(r,I,l,h,c){const f=this._providers.get(r);return f==null?void 0:f.provideTimeline(p.URI.revive(I),l,h,c)}registerTimelineProvider(r,I,l,h){const c=new y.DisposableStore,f=this.convertTimelineItem(I.id,h,c).bind(this);let E;I.onDidChange&&(E=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:r,onDidChange:void 0,async provideTimeline(b,u,d,g){var t;(g==null?void 0:g.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const i=await I.provideTimeline(b,u,d);if(i==null)return;const s=f(b,g);return Object.assign(Object.assign({},i),{source:I.id,items:i.items.map(s)})},dispose(){var b;for(const u of w.values())(b=u.get(I.id))===null||b===void 0||b.clear();E==null||E.dispose(),c.dispose()}}))}convertTimelineItem(r,I,l){return(h,c)=>{let f;if(c==null?void 0:c.cacheResults){let E=this._itemsBySourceAndUriMap.get(r);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(r,E));const w=S(h);f=E.get(w),f===void 0&&(f=new Map,E.set(w,f))}return E=>{var w,b;const{iconPath:u}=E,d=Sn(E,["iconPath"]),g=`${r}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;f==null||f.set(g,E);let t,i,s;return E.iconPath&&(u instanceof A.ThemeIcon?s={id:u.id}:p.URI.isUri(u)?(t=u,i=u):{light:t,dark:i}=u),Object.assign(Object.assign({},d),{id:(b=d.id)!==null&&b!==void 0?b:void 0,handle:g,source:r,command:E.command?I.toInternal(E.command,l):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),y.toDisposable(()=>{var l;for(const h of this._itemsBySourceAndUriMap.values())(l=h.get(r.id))===null||l===void 0||l.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=P;function S(C){return C==null?void 0:C.toString()}}),define(ge[241],pe([0,1,6,10,2,5]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(S){this._openers=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,r,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const l=I.schemes.find(h=>!A.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,r),this._proxy.$registerUriOpener(C,I.schemes,S,I.label),p.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,r){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const l=k.URI.revive(C);return I.canOpenExternalUri(l,r)}async $openUri(S,C,r){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(k.URI.revive(C.resolvedUri),{sourceUri:k.URI.revive(C.sourceUri)},r)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(ge[242],pe([0,1,5,2,6,14,26]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(C,r){if(this.handles.has(A.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=P.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(C)),this.handlers.set(I,r),this._proxy.$registerUriHandler(I,C),k.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,r){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(r))}catch(l){y.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(C){return L.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=P,P.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[62],pe([0,1,3,2,172,196,84,5]),function(X,e,p,L,k,y,A,P){"use strict";var S,C,r,I,l,h,c,f,E,w,b,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(m,_,D,a,R,M,$){S.set(this,void 0),C.set(this,void 0),r.set(this,void 0),I.set(this,void 0),l.set(this,void 0),h.set(this,void 0),c.set(this,""),f.set(this,void 0),E.set(this,!1),w.set(this,!1),b.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new p.Emitter),this._onDidDispose=Be(this,u,"f").event,it(this,S,m,"f"),it(this,C,_,"f"),it(this,f,D,"f"),it(this,I,a,"f"),it(this,l,R,"f"),it(this,h,M,"f"),it(this,b,g(M),"f"),it(this,r,$,"f")}dispose(){it(this,E,!0,"f"),Be(this,u,"f").fire(),Be(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return it(this,w,!0,"f"),A.asWebviewUri(m,Be(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(m){this.assertNotDisposed(),Be(this,c,"f")!==m&&(it(this,c,m,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(it(this,w,!0,"f"),Be(this,r,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,C,"f").$setHtml(Be(this,S,"f"),m))}get options(){return this.assertNotDisposed(),Be(this,f,"f")}set options(m){this.assertNotDisposed(),Be(this,C,"f").$setOptions(Be(this,S,"f"),s(Be(this,h,"f"),Be(this,l,"f"),m)),it(this,f,m,"f")}async postMessage(m){if(Be(this,E,"f"))return!1;const _=y.serializeWebviewMessage(m,{serializeBuffersForPostMessage:Be(this,b,"f")});return Be(this,C,"f").$postMessage(Be(this,S,"f"),_.message,..._.buffers)}assertNotDisposed(){if(Be(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,S=new WeakMap,C=new WeakMap,r=new WeakMap,I=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,b=new WeakMap,u=new WeakMap;function g(v){try{const m=k.normalizeVersion(k.parseVersion(v.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(m,_,D,a,R){this.initData=_,this.workspace=D,this._logService=a,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=m.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(m,_,...D){const a=this.getWebview(m);if(a){const{message:R}=y.deserializeWebviewMessage(_,D);a._onMessageEmitter.fire(R)}}$onMissingCsp(m,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,_,D){const a=new d(m,this._webviewProxy,n(_),this.initData,this.workspace,D,this._deprecationService);return this._webviews.set(m,a),a._onDidDispose(()=>{this._webviews.delete(m)}),a}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function i(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=i;function s(v,m,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||o(v,m)}}e.serializeWebviewOptions=s;function n(v){var m;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(m=v.localResourceRoots)===null||m===void 0?void 0:m.map(_=>L.URI.from(_))}}e.reviveOptions=n;function o(v,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(_=>_.uri),v.extensionLocation]}}),define(ge[243],pe([0,1,21,73,6,10,24,2,17,62,82,5,7]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const n=this.key(t,i.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const o=new h(i,s);return this._documents.set(n,o),o}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var f;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(f||(f={}));class E{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,n){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:n}),new l.Disposable(()=>this._providers.delete(i))}}class w{constructor(t,i,s,n,o){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,n){const o=new k.DisposableStore;return b(s)?(o.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),i,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(v=>{const m=this.getCustomDocumentEntry(i,v.document.uri);if(u(v)){const _=m.addEdit(v);this._proxy.$onDidEdit(v.document.uri,i,_,v.label)}else this._proxy.$onContentChange(v.document.uri,i)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),i,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(o,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,n,o){var v;const m=this._editorProviders.get(i);if(!m)throw new Error(`No provider found for '${i}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${i}'`);const _=P.URI.revive(t),D=await m.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:n==null?void 0:n.buffer},o);let a;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(a=(v=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(i,D,a),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const n=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(i,n);this._documents.delete(i,o),o.dispose()}async $resolveWebviewEditor(t,i,s,n,o,v){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const _=S.ViewColumn.to(o),D=this._extHostWebview.createNewWebview(i,n.webviewOptions,m.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,n.title,_,n.panelOptions,D),R=P.URI.revive(t);switch(m.type){case 1:{const{document:M}=this.getCustomDocumentEntry(s,R);return m.provider.resolveCustomEditor(M,a,v)}case 0:{const M=this._extHostDocuments.getDocument(R);return m.provider.resolveCustomTextEditor(M,a,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const v=P.URI.revive(i),m=this._extHostDocuments.getDocument(v);await n.provider.moveCustomTextEditor(m,o,p.CancellationToken.None)}async $undo(t,i,s,n){return this.getCustomDocumentEntry(i,t).undo(s,n)}async $redo(t,i,s,n){return this.getCustomDocumentEntry(i,t).redo(s,n)}async $revert(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,i,s,n){const o=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(o.document,P.URI.revive(s),n)}async $backup(t,i,s){const n=this.getCustomDocumentEntry(i,t),v=await this.getCustomEditorProvider(i).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(v),v.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,P.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(g){return typeof g.resolveCustomTextEditor=="function"}function u(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function d(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return L.hash(t)+""}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[244],pe([0,1,3,6,2,32,17,62,5,7]),function(X,e,p,L,k,y,A,P,S,C){"use strict";var r,I,l,h,c,f,E,w,b,u,d,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends L.Disposable{constructor(v,m,_,D,a,R,M){super();r.set(this,void 0),I.set(this,void 0),l.set(this,void 0),h.set(this,void 0),c.set(this,void 0),f.set(this,void 0),E.set(this,void 0),w.set(this,void 0),b.set(this,!0),u.set(this,!0),d.set(this,!1),g.set(this,this._register(new p.Emitter)),this.onDidDispose=Be(this,g,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,r,v,"f"),it(this,I,m,"f"),it(this,l,_,"f"),it(this,c,R,"f"),it(this,w,a,"f"),it(this,f,D,"f"),it(this,h,M,"f")}dispose(){Be(this,d,"f")||(it(this,d,!0,"f"),Be(this,g,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,r,"f")),Be(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,h,"f")}get viewType(){return this.assertNotDisposed(),Be(this,l,"f")}get title(){return this.assertNotDisposed(),Be(this,f,"f")}set title(v){this.assertNotDisposed(),Be(this,f,"f")!==v&&(it(this,f,v,"f"),Be(this,I,"f").$setTitle(Be(this,r,"f"),v))}get iconPath(){return this.assertNotDisposed(),Be(this,E,"f")}set iconPath(v){this.assertNotDisposed(),Be(this,E,"f")!==v&&(it(this,E,v,"f"),Be(this,I,"f").$setIconPath(Be(this,r,"f"),k.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,u,"f")}get visible(){return this.assertNotDisposed(),Be(this,b,"f")}_updateViewState(v){Be(this,d,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(it(this,u,v.active,"f"),it(this,b,v.visible,"f"),it(this,w,v.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(v,m){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,r,"f"),{viewColumn:v?A.ViewColumn.from(v):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Be(this,d,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,I=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,b=new WeakMap,u=new WeakMap,d=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(v,m,_){this.webviews=m,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(v,m,_,D,a={}){const R=typeof D=="object"?D.viewColumn:D,M={viewColumn:A.ViewColumn.from(R),preserveFocus:typeof D=="object"&&!!D.preserveFocus},$=P.shouldSerializeBuffersForPostMessage(v),Y=s.newHandle();this._proxy.$createWebviewPanel(P.toExtensionData(v),Y,m,{title:_,panelOptions:n(a),webviewOptions:P.serializeWebviewOptions(v,this.workspace,a),serializeBuffersForPostMessage:$},M);const le=this.webviews.createNewWebview(Y,a,v);return this.createNewWebviewPanel(Y,m,_,R,a,le)}$onDidChangeWebviewPanelViewStates(v){const m=Object.keys(v);m.sort((_,D)=>{const a=v[_],R=v[D];return a.active?1:R.active?-1:+a.visible-+R.visible});for(const _ of m){const D=this.getWebviewPanel(_);if(!D)continue;const a=v[_];D._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(v){const m=this.getWebviewPanel(v);m==null||m.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,m,_){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:_,extension:v}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:P.shouldSerializeBuffersForPostMessage(v)}),new C.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(v,m,_,D){const a=this._serializers.get(m);if(!a)throw new Error(`No serializer found for '${m}'`);const{serializer:R,extension:M}=a,$=this.webviews.createNewWebview(v,_.webviewOptions,M),Y=this.createNewWebviewPanel(v,m,_.title,D,_.panelOptions,$);await R.deserializeWebviewPanel(Y,_.state)}createNewWebviewPanel(v,m,_,D,a,R){const M=new i(v,this._proxy,m,_,D,a,R);return this._webviewPanels.set(v,M),M}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=s;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[245],pe([0,1,3,6,62,5,7]),function(X,e,p,L,k,y,A){"use strict";var P,S,C,r,I,l,h,c,f,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends L.Disposable{constructor(d,g,t,i,s,n){super();P.set(this,void 0),S.set(this,void 0),C.set(this,void 0),r.set(this,void 0),I.set(this,!1),l.set(this,void 0),h.set(this,void 0),c.set(this,void 0),f.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Be(this,f,"f").event,E.set(this,this._register(new p.Emitter)),this.onDidDispose=Be(this,E,"f").event,it(this,C,t,"f"),it(this,h,i,"f"),it(this,P,d,"f"),it(this,S,g,"f"),it(this,r,s,"f"),it(this,l,n,"f")}dispose(){Be(this,I,"f")||(it(this,I,!0,"f"),Be(this,E,"f").fire(),Be(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(d){this.assertNotDisposed(),Be(this,h,"f")!==d&&(it(this,h,d,"f"),Be(this,S,"f").$setWebviewViewTitle(Be(this,P,"f"),d))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(d){this.assertNotDisposed(),Be(this,c,"f")!==d&&(it(this,c,d,"f"),Be(this,S,"f").$setWebviewViewDescription(Be(this,P,"f"),d))}get visible(){return Be(this,l,"f")}get webview(){return Be(this,r,"f")}get viewType(){return Be(this,C,"f")}_setVisible(d){d===Be(this,l,"f")||Be(this,I,"f")||(it(this,l,d,"f"),Be(this,f,"f").fire())}show(d){this.assertNotDisposed(),Be(this,S,"f").$show(Be(this,P,"f"),!!d)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,S=new WeakMap,C=new WeakMap,r=new WeakMap,I=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,f=new WeakMap,E=new WeakMap;class b{constructor(d,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider(k.toExtensionData(d),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(d,g,t,i,s){const n=this._viewProviders.get(g);if(!n)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:v}=n,m=this._extHostWebview.createNewWebview(d,{},v),_=new w(d,this._proxy,g,t,m,!0);this._webviewViews.set(d,_),await o.resolveWebviewView(_,{state:i},s)}async $onDidChangeWebviewViewVisibility(d,g){this.getWebviewView(d)._setVisible(g)}async $disposeWebviewView(d){const g=this.getWebviewView(d);this._webviewViews.delete(d),g.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const g=this._webviewViews.get(d);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(ge[127],pe([0,1,3,5,2,10,8,4,13]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class xn{constructor(I){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let h;if(typeof I=="string"){h=I;try{I=k.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return A.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,h,l)}async asExternalUri(I,l){if(A.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(I,l);return k.URI.from(h)}};C.InitialState={focused:!0},C=je([$e(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=P.createDecorator("IExtHostWindow")}),define(ge[246],pe([0,1,9,101,32,48,6,5,2,13]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends A.Disposable{constructor(l,h){super();const c=l.getProxy(P.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async f=>{const E=S.URI.file(p.join(L.tmpdir(),k.generateUuid()));return await c.$download(f,E),E})}};r=je([$e(0,C.IExtHostRpcService),$e(1,y.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(ge[247],pe([0,1,2,9,146,28,61,27,13,6,12,113,42]),function(X,e,p,L,k,y,A,P,S,C,r,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class h{constructor(w,b,u){this.name=w,this.file=b,this.appender=u}static async create(w,b){const u=await I.createRotatingLogger(w,b,30*l.ByteSize.MB,1);return u.clearFormatters(),new h(w,b,u)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,b,u){super(w,!1,p.URI.file(b.file),u);this._appender=b}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,b){this._appender.flush(),super.show(w,b)}clear(){this._appender.flush(),super.clear()}}let f=class extends A.ExtHostOutputService{constructor(w,b,u){super(w);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new C.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const b=this._channels.get(w);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const b=this._doCreateOutChannel(w);return b.then(u=>u._id.then(d=>this._channels.set(d,u))),new A.LazyOutputChannel(w,b)}async _doCreateOutChannel(w){try{const b=L.join(this._logsLocation.fsPath,`output_logging_${k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(b)||await y.Promises.mkdir(b,{recursive:!0});const d=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,g=p.URI.file(L.join(b,`${d}.log`)),t=await h.create(d,g.fsPath);return new c(w,t,this._proxy)}catch(b){return this.logService.error(b),new A.ExtHostPushOutputChannel(w,this._proxy)}}};f=je([$e(0,S.IExtHostRpcService),$e(1,r.ILogService),$e(2,P.IExtHostInitDataService)],f),e.ExtHostOutputService2=f}),define(ge[248],pe([0,1,32,13,33]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends k.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,S,C){return this.createTerminalFromOptions({name:P,shellPath:S,shellArgs:C})}createTerminalFromOptions(P,S){const C=new k.ExtHostTerminal(this._proxy,p.generateUuid(),P,P.name);return this._terminals.push(C),C.create(P,S),C.value}};y=je([$e(0,L.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(ge[249],pe([0,1,5,13,6,27,2,38,24,28,7,11,47,3,187,72,12]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(m,_,D){this.remoteAddress=m,this.localAddress=_,this._dispose=D,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(v){const m=v.trim().split(`
`),_=[];return m.forEach(a=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(a);R&&R.length>=3&&_.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),_.reduce((a,R)=>(a[R.socket]=R,a),{})}e.getSockets=b;function u(...v){const m=[].concat(...v.map(g));return[...new Map(m.filter(_=>_.st==="0A").map(_=>{const D=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:d(D[0]),port:parseInt(D[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=u;function d(v){let m="";if(v.length===8)for(let _=v.length-2;_>=0;_-=2)m+=parseInt(v.substr(_,2),16),_!==0&&(m+=".");else for(let _=v.length-4;_>=0;_-=4)m+=parseInt(v.substr(_,4),16).toString(16),_!==0&&(m+=":");return m}e.parseIpAddress=d;function g(v){const m=v.trim().split(`
`),_=m.shift().trim().split(/\s+/).filter(a=>a!=="rx_queue"&&a!=="tm->when");return m.map(a=>a.trim().split(/\s+/).reduce((R,M,$)=>(R[_[$]||$]=M,R),{}))}e.loadConnectionTable=g;function t(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/vs/server/main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function i(v){const m=v.trim().split(`
`),_=[];return m.forEach(D=>{const a=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);a&&a.length>=4&&_.push({pid:parseInt(a[1],10),ppid:parseInt(a[2]),cmd:a[3]})}),_}e.getRootProcesses=i;async function s(v,m,_){const D=_.reduce((R,M)=>(R[M.pid]=M,R),{}),a=[];return v.forEach(({socket:R,ip:M,port:$})=>{var Y;const le=m[R]?m[R].pid:void 0,q=le?(Y=D[le])===null||Y===void 0?void 0:Y.cmd:void 0;le&&q&&!t(q)&&a.push({host:M,port:$,detail:q,pid:le})}),a}e.findPorts=s;function n(v,m,_){const D=new Map,a=i(m);for(const R of v){const M=_.get(R.port);if(M){D.set(R.port,M);continue}const $=a.find(Y=>Y.cmd.includes(`${R.port}`));if($){let Y=$,le;do le=a.find(q=>q.ppid===Y.pid),le&&(Y=le);while(le);D.set(R.port,{host:R.ip,port:R.port,pid:Y.pid,detail:Y.cmd,ppid:Y.ppid})}else D.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=n;let o=class extends k.Disposable{constructor(m,_,D){super();this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),I.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(_,m.displayName);if(D){const a=new w(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,_){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:m,provider:_}),this._proxy.$registerPortsAttributesProvider(m,D),new r.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(m,_,D,a,R){const M=[];for(const Y of m){const le=this._portAttributesProviders.get(Y);if(!le)return[];M.push(...await Promise.all(_.map(async q=>le.provider.providePortAttributes(q,D,a,R))))}const $=M.filter(Y=>!!Y);return $.length>0?$.map(Y=>({autoForwardAction:Y.autoForwardAction,port:Y.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let _=new f.MovingAverage,D;for(;this._candidateFindingEnabled;){const a=new Date().getTime(),R=(await this.findCandidatePorts()).filter($=>c.isLocalhost($.host)||c.isAllInterfaces($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map($=>$.port).join(", ")}`);const M=new Date().getTime()-a;_.update(M),(!D||JSON.stringify(D)!==JSON.stringify(R))&&(D=R,await this._proxy.$onFoundNewCandidates(D)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(_.value)))}}async setTunnelExtensionFunctions(m){var _;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((_=m.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,k.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,_){if(this._extensionTunnels.has(m.host)){const D=this._extensionTunnels.get(m.host);D.has(m.port)&&(_&&D.get(m.port).disposeListener.dispose(),await D.get(m.port).tunnel.dispose(),D.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(m,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const a=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:a,disposeListener:R}),l.TunnelDto.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(D){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const _=await Promise.all(m.map(a=>{var R;return this._showCandidatePort(a.host,a.port,(R=a.detail)!==null&&R!==void 0?R:"")})),D=m.filter((a,R)=>_[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(a=>a.port).join(", ")} to ${D.map(a=>a.port).join(", ")}`),D}async findCandidatePorts(){let m="",_="";try{m=await C.Promises.readFile("/proc/net/tcp","utf8"),_=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch(z){}const D=u(m,_),a=await new Promise(z=>{P.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,W,T)=>{z(W)})}),R=b(a),M=await C.Promises.readdir("/proc"),$=[];for(let z of M)try{const O=Number(z),W=S.joinPath(A.URI.file("/proc"),z);if((await C.Promises.stat(W.fsPath)).isDirectory()&&!isNaN(O)){const F=await C.Promises.readlink(S.joinPath(W,"cwd").fsPath),N=await C.Promises.readFile(S.joinPath(W,"cmdline").fsPath,"utf8");$.push({pid:O,cwd:F,cmd:N})}}catch(O){}const Y=[],le=D.filter(z=>{const O=R[z.socket];return O||Y.push(z),O}),q=s(le,R,$);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Y.length}`),Y.length>0){const z=await new Promise(O=>{P.exec("ps -F -A -l | grep root",(W,T,F)=>{O(T)})});this._foundRootPorts=n(Y,z,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return q.then(z=>U?z.concat(U):z)}};o=je([$e(0,L.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,E.ILogService)],o),e.ExtHostTunnelService=o}),define(ge[250],pe([0,1,16,21,14,3,6,99,217,125,22]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(n,o){try{return JSON.stringify(n,o)}catch(v){return"null"}}function h(n,o){return JSON.stringify(n,o)}function c(n){return n?(o,v)=>v&&v.$mid===1?n.transformOutgoing(v):v:null}var f;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(o,v=null,m=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=v,this._uriTransformer=m,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,D=C.ProxyIdentifier.count;_<D;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?P.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:v,sid:m}=o;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,m)),this._proxies[v]}_createProxy(o,v){let m={get:(_,D)=>(typeof D=="string"&&!_[D]&&D.charCodeAt(0)===36&&(_[D]=(...a)=>this._remoteCall(o,D,a)),D===u?v:_[D])};return new Proxy(Object.create(null),m)}set(o,v){return this._locals[o.nid]=v,v}assertRegistered(o){for(let v=0,m=o.length;v<m;v++){const _=o[v];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const v=o.byteLength,m=g.read(o,0),_=m.readUInt8(),D=m.readUInt32();switch(_){case 1:case 2:{let{rpcId:a,method:R,args:M}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(M=P.transformIncomingURIs(M,this._uriTransformer)),this._receiveRequest(v,D,a,R,M,_===2);break}case 3:case 4:{let{rpcId:a,method:R,args:M}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(M=P.transformIncomingURIs(M,this._uriTransformer)),this._receiveRequest(v,D,a,R,M,_===4);break}case 5:{this._logger&&this._logger.logIncoming(v,D,0,"ack"),this._onDidReceiveAcknowledge(D);break}case 6:{this._receiveCancel(v,D);break}case 7:{this._receiveReply(v,D,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(m);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(v,D,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(m);this._receiveReply(v,D,a);break}case 10:{let a=t.deserializeReplyErrError(m);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(v,D,a);break}case 11:{this._receiveReplyErr(v,D,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,v,m,_,D,a){this._logger&&this._logger.logIncoming(o,v,1,`receiveRequest ${C.getStringIdentifierForProxy(m)}.${_}(`,D);const R=String(v);let M,$;if(a){const le=new L.CancellationTokenSource;D.push(le.token),M=this._invokeHandler(m,_,D),$=()=>le.cancel()}else M=this._invokeHandler(m,_,D),$=w;this._cancelInvokedHandlers[R]=$;const Y=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(Y.byteLength,v,1,"ack"),this._protocol.send(Y),M.then(le=>{delete this._cancelInvokedHandlers[R];const q=t.serializeReplyOK(v,le,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,v,1,"reply:",le),this._protocol.send(q)},le=>{delete this._cancelInvokedHandlers[R];const q=t.serializeReplyErr(v,le);this._logger&&this._logger.logOutgoing(q.byteLength,v,1,"replyErr:",le),this._protocol.send(q)})}_receiveCancel(o,v){this._logger&&this._logger.logIncoming(o,v,1,"receiveCancel");const m=String(v);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReply:",m);const _=String(v);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const D=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],D.resolveOk(m)}_receiveReplyErr(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReplyErr:",m);const _=String(v);if(!this._pendingRPCReplies.hasOwnProperty(_))return;const D=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let a;m&&(m.$isError?(a=new Error,a.name=m.name,a.message=m.message,a.stack=m.stack):a=m),D.resolveErr(a)}_invokeHandler(o,v,m){try{return Promise.resolve(this._doInvokeHandler(o,v,m))}catch(_){return Promise.reject(_)}}_doInvokeHandler(o,v,m){const _=this._locals[o];if(!_)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(o));let D=_[v];if(typeof D!="function")throw new Error("Unknown method "+v+" on actor "+C.getStringIdentifierForProxy(o));return D.apply(_,m)}_remoteCall(o,v,m){if(this._isDisposed)return Promise.reject(k.canceled());let _=null;if(m.length>0&&L.CancellationToken.isCancellationToken(m[m.length-1])&&(_=m.pop()),_&&_.isCancellationRequested)return Promise.reject(k.canceled());const D=t.serializeRequestArguments(m,this._uriReplacer),a=++this._lastMessageId,R=String(a),M=new S.LazyPromise;_&&_.onCancellationRequested(()=>{const Y=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(Y.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[R]=M,this._onWillSendRequest(a);const $=t.serializeRequest(a,o,v,D,!!_);return this._logger&&this._logger.logOutgoing($.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(o)}.${v}(`,m),this._protocol.send($),M}}e.RPCProtocol=d,I=b,d.UNRESPONSIVE_TIME=3*1e3;class g{constructor(o,v){this._buff=o,this._offset=v}static alloc(o,v,m){let _=new g(r.VSBuffer.alloc(m+1+4),0);return _.writeUInt8(o),_.writeUInt32(v),_}static read(o,v){return new g(o,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,v}static sizeMixedArray(o,v){let m=0;m+=1;for(let _=0,D=o.length;_<D;_++){const a=o[_],R=v[_];switch(m+=1,R){case 1:m+=this.sizeLongString(a);break;case 2:m+=this.sizeVSBuffer(a);break;case 3:break}}return m}writeMixedArray(o,v){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,_=o.length;m<_;m++){const D=o[m];switch(v[m]){case 1:this.writeUInt8(1),this.writeLongString(D);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:v[m]=this.readLongString();break;case 2:v[m]=this.readVSBuffer();break;case 3:v[m]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(o){for(let v=0,m=o.length;v<m;v++)if(o[v]instanceof r.VSBuffer||typeof o[v]=="undefined")return!0;return!1}static serializeRequestArguments(o,v){if(this._arrayContainsBufferOrUndefined(o)){let m=[],_=[];for(let D=0,a=o.length;D<a;D++){const R=o[D];R instanceof r.VSBuffer?(m[D]=R,_[D]=2):typeof R=="undefined"?(m[D]=r.VSBuffer.alloc(0),_[D]=3):(m[D]=r.VSBuffer.fromString(h(R,v)),_[D]=1)}return{type:"mixed",args:m,argsType:_}}return{type:"simple",args:h(o,v)}}static serializeRequest(o,v,m,_,D){return _.type==="mixed"?this._requestMixedArgs(o,v,m,_.args,_.argsType,D):this._requestJSONArgs(o,v,m,_.args,D)}static _requestJSONArgs(o,v,m,_,D){const a=r.VSBuffer.fromString(m),R=r.VSBuffer.fromString(_);let M=0;M+=g.sizeUInt8(),M+=g.sizeShortString(a),M+=g.sizeLongString(R);let $=g.alloc(D?2:1,o,M);return $.writeUInt8(v),$.writeShortString(a),$.writeLongString(R),$.buffer}static deserializeRequestJSONArgs(o){const v=o.readUInt8(),m=o.readShortString(),_=o.readLongString();return{rpcId:v,method:m,args:JSON.parse(_)}}static _requestMixedArgs(o,v,m,_,D,a){const R=r.VSBuffer.fromString(m);let M=0;M+=g.sizeUInt8(),M+=g.sizeShortString(R),M+=g.sizeMixedArray(_,D);let $=g.alloc(a?4:3,o,M);return $.writeUInt8(v),$.writeShortString(R),$.writeMixedArray(_,D),$.buffer}static deserializeRequestMixedArgs(o){const v=o.readUInt8(),m=o.readShortString(),_=o.readMixedArray(),D=new Array(_.length);for(let a=0,R=_.length;a<R;a++){const M=_[a];typeof M=="string"?D[a]=JSON.parse(M):D[a]=M}return{rpcId:v,method:m,args:D}}static serializeAcknowledged(o){return g.alloc(5,o,0).buffer}static serializeCancel(o){return g.alloc(6,o,0).buffer}static serializeReplyOK(o,v,m){return typeof v=="undefined"?this._serializeReplyOKEmpty(o):v instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(o,v):this._serializeReplyOKJSON(o,l(v,m))}static _serializeReplyOKEmpty(o){return g.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,v){let m=0;m+=g.sizeVSBuffer(v);let _=g.alloc(8,o,m);return _.writeVSBuffer(v),_.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,v){const m=r.VSBuffer.fromString(v);let _=0;_+=g.sizeLongString(m);let D=g.alloc(9,o,_);return D.writeLongString(m),D.buffer}static deserializeReplyOKJSON(o){const v=o.readLongString();return JSON.parse(v)}static serializeReplyErr(o,v){return v?this._serializeReplyErrEror(o,v):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,v){const m=r.VSBuffer.fromString(l(k.transformErrorForSerialization(v),null));let _=0;_+=g.sizeLongString(m);let D=g.alloc(10,o,_);return D.writeLongString(m),D.buffer}static deserializeReplyErrError(o){const v=o.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(o){return g.alloc(11,o,0).buffer}}var i;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(s||(s={}))}),define(ge[251],pe([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=p.createDecorator("remoteAgentService")}),define(ge[252],pe([0,1,10,9,11,2,4,81,45,212,251]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let I=class Bn{constructor(h,c,f,E){this.localUserHome=h,this.remoteAgentService=c,this.environmentService=f,this.contextService=E,this.resolveOS=(async()=>{const w=await this.remoteAgentService.getEnvironment();return(w==null?void 0:w.os)||k.OS})(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(w==null?void 0:w.userHome)||h})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,c){if(h.remoteAuthority)return p.Schemas.vscodeRemote;const f=P.getVirtualWorkspaceScheme(c.getWorkspace());if(f)return f;const E=c.getWorkspace().folders[0];if(E)return E.uri.scheme;const w=c.getWorkspace().configuration;return w?w.scheme:p.Schemas.file}async userHome(h){return(h==null?void 0:h.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?L.win32:L.posix)}async fileURI(h){let c="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const E=h.indexOf("/",2);E===-1?(c=h.substring(2),h="/"):(c=h.substring(2,E),h=h.substring(E)||"/")}return y.URI.from({scheme:p.Schemas.file,authority:c,path:h,query:"",fragment:""})}};I=je([$e(1,r.IRemoteAgentService),$e(2,C.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ge[63],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new p(0,0)}with(A){return new p(0,0)}}e.Position=p;class L{constructor(A,P,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(A,P),this.end=new p(S,C)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.Range=L;var k;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,18,30,25,29,8,4,9,14,63]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",h=(I.length+l.length+5)*2;e.ISearchService=P.createDecorator("searchService");var c;(function(O){O[O.file=0]="file",O[O.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(O){O[O.File=1]="File",O[O.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function E(O){return!!O.preview}e.resultIsMatch=E;function w(O){return!!O.resource}e.isFileMatch=w;function b(O){return!!O.message}e.isProgressMessage=b;var u;(function(O){O[O.Normal=0]="Normal",O[O.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(W){this.resource=W,this.results=[]}}e.FileMatch=d;class g{constructor(W,T,F){this.ranges=T;const N=Array.isArray(T)?T:[T];if(F&&F.matchLines===1&&t(N)){W=A.getNLines(W,F.matchLines);let x="",G=0,se=0;const be=Math.floor(F.charsPerLine/5),Ie=[];for(const Ce of N){const Me=Math.max(Ce.startColumn-be,0),qe=Ce.startColumn+F.charsPerLine;if(Me>se+be+h){const He=I+(Me-se)+l;x+=He+W.slice(Me,qe),G+=Me-(se+He.length)}else x+=W.slice(se,qe);Ie.push(new s(0,Ce.startColumn-G,Ce.endColumn-G)),se=qe}this.preview={text:x,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const x=Array.isArray(T)?T[0].startLineNumber:T.startLineNumber;this.preview={text:W,matches:p.mapArrayOrNot(T,G=>new i(G.startLineNumber-x,G.startColumn,G.endLineNumber-x,G.endColumn))}}}}e.TextSearchMatch=g;function t(O){const W=O[0].startLineNumber;for(const T of O)if(T.startLineNumber!==W||T.endLineNumber!==W)return!1;return!0}class i{constructor(W,T,F,N){this.startLineNumber=W,this.startColumn=T,this.endLineNumber=F,this.endColumn=N}}e.SearchRange=i;class s extends i{constructor(W,T,F){super(W,T,W,F)}}e.OneLineRange=s;var n;(function(O){O.Default="default",O.FileNames="fileNames",O.Type="type",O.Modified="modified",O.CountDescending="countDescending",O.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(O,W=!0){const T=O&&O.files&&O.files.exclude,F=W&&O&&O.search&&O.search.exclude;if(!T&&!F)return;if(!T||!F)return T||F;let N=Object.create(null);return N=k.mixin(N,k.deepClone(T)),N=k.mixin(N,k.deepClone(F),!0),N}e.getExcludes=o;function v(O,W){return O.excludePattern&&L.match(O.excludePattern,W)?!1:O.includePattern||O.usingSearchPaths?O.includePattern&&L.match(O.includePattern,W)?!0:O.usingSearchPaths?!!O.folderQueries&&O.folderQueries.some(T=>{const F=T.folder.fsPath;if(y.isEqualOrParent(W,F)){const N=S.relative(F,W);return!T.includePattern||!!L.match(T.includePattern,N)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var m;(function(O){O[O.unknownEncoding=1]="unknownEncoding",O[O.regexParseError=2]="regexParseError",O[O.globParseError=3]="globParseError",O[O.invalidLiteral=4]="invalidLiteral",O[O.rgProcessError=5]="rgProcessError",O[O.other=6]="other",O[O.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(W,T){super(W);this.code=T}}e.SearchError=_;function D(O){const W=O.message;if(C.isPromiseCanceledError(O))return new _(W,m.canceled);try{const T=JSON.parse(W);return new _(T.message,T.code)}catch(T){return new _(W,m.other)}}e.deserializeSearchError=D;function a(O){const W={message:O.message,code:O.code};return new Error(JSON.stringify(W))}e.serializeSearchError=a;function R(O){return O.type==="error"?!0:O.type==="success"}e.isSerializedSearchComplete=R;function M(O){return O.type==="success"}e.isSerializedSearchSuccess=M;function $(O){return!!O.path}e.isSerializedFileMatch=$;function Y(O,W){const T=O.searchPath?O.searchPath:O.relativePath;return A.fuzzyContains(T,W)}e.isFilePatternMatch=Y;class le{constructor(W){this.path=W,this.results=[]}addMatch(W){this.results.push(W)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function q(O,W){const T=Object.assign(Object.assign({},O||{}),W||{});return Object.keys(T).filter(F=>{const N=T[F];return typeof N=="boolean"&&N})}e.resolvePatternsForProvider=q;class U{constructor(W,T){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},W.excludePattern||{}),T.excludePattern||{}),this._parsedExcludeExpression=L.parse(this._excludeExpression);let F=W.includePattern;T.includePattern&&(F?F=Object.assign(Object.assign({},F),T.includePattern):F=T.includePattern),F&&(this._parsedIncludeExpression=L.parse(F))}includedInQuerySync(W,T,F){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,T,F)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(W,T,F))}includedInQuery(W,T,F){return Promise.resolve(this._parsedExcludeExpression(W,T,F)).then(x=>!!x).then(x=>x?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(W,T,F)).then(G=>!!G):Promise.resolve(!0)).then(x=>x)}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=U;function z(O){for(const W in O)if(typeof O[W]!="boolean")return!0;return!1}}),define(ge[34],pe([0,1,18,16,21,3,23,10,72,24,8,15,2,164,4,12,182,45,58,27,13,7,31,5]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u,d,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,M,$){return new C.ExtUri(Y=>m(Y,$)).isEqual(R,M)}function n(R,M,$){return s(R.uri,M.uri,$)?0:r.compare(R.uri.toString(),M.uri.toString())}function o(R,M,$){return R.index!==M.index?R.index<M.index?-1:1:s(R.uri,M.uri,$)?r.compare(R.name,M.name):r.compare(R.uri.toString(),M.uri.toString())}function v(R,M,$,Y){const le=R.slice(0).sort((U,z)=>$(U,z,Y)),q=M.slice(0).sort((U,z)=>$(U,z,Y));return p.delta(le,q,(U,z)=>$(U,z,Y))}function m(R,M){const $=M.getCapabilities(R.scheme);return!($&&$&1024)}class _ extends w.Workspace{constructor(M,$,Y,le,q,U){super(M,Y.map(z=>new w.WorkspaceFolder(z)),le,U);this._name=$,this._isUntitled=q,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(U),Y.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(M,$,Y,le){if(!M)return{workspace:null,added:[],removed:[]};const{id:q,name:U,folders:z,configuration:O,isUntitled:W}=M,T=[],F=$;$?z.forEach((se,be)=>{const Ie=l.URI.revive(se.uri),Ce=_._findFolder(Y||$,Ie,le);Ce?(Ce.name=se.name,Ce.index=se.index,T.push(Ce)):T.push({uri:Ie,name:se.name,index:be})}):T.push(...z.map(({uri:se,name:be,index:Ie})=>({uri:l.URI.revive(se),name:be,index:Ie}))),T.sort((se,be)=>se.index<be.index?-1:1);const N=new _(q,U,T,O?l.URI.revive(O):null,!!W,se=>m(se,le)),{added:x,removed:G}=v(F?F.workspaceFolders:[],N.workspaceFolders,n,le);return{workspace:N,added:x,removed:G}}static _findFolder(M,$,Y){for(let le=0;le<M.folders.length;le++){const q=M.workspaceFolders[le];if(s(q.uri,$,Y))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,$){return $&&this._structure.get(M)&&(M=C.dirname(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let D=class{constructor(M,$,Y,le){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=le,this._extHostFileSystemInfo=Y,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=M.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(i.MainContext.MainThreadMessageService);const q=$.workspace;this._confirmedWorkspace=q?new _(q.id,q.name,[],q.configuration?l.URI.revive(q.configuration):null,!!q.isUntitled,U=>m(U,Y)):void 0}$initializeWorkspace(M,$){this._trusted=$,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:P.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,$,Y,...le){const q=[];if(Array.isArray(le)&&le.forEach(T=>{l.URI.isUri(T.uri)&&!q.some(F=>s(F.uri,T.uri,this._extHostFileSystemInfo))&&q.push({uri:T.uri,name:T.name||C.basenameOrAuthority(T.uri)})}),this._unconfirmedWorkspace||[$,Y].some(T=>typeof T!="number"||T<0)||Y===0&&q.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+Y>U.length)return!1;const z=U.slice(0);z.splice($,Y,...q.map(T=>({uri:T.uri,name:T.name||C.basenameOrAuthority(T.uri),index:void 0})));for(let T=0;T<z.length;T++){const F=z[T];if(z.some((N,x)=>x!==T&&s(F.uri,N.uri,this._extHostFileSystemInfo)))return!1}z.forEach((T,F)=>T.index=F);const{added:O,removed:W}=v(U,z,o,this._extHostFileSystemInfo);if(O.length===0&&W.length===0)return!1;if(this._proxy){const T=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(T,$,Y,q).then(void 0,F=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,h.localize(0,null,T,F.toString()),{extension:M},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(M,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,$)}async getWorkspaceFolder2(M,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,$)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,$){let Y,le="";if(typeof M=="string"?(Y=l.URI.file(M),le=M):typeof M!="undefined"&&(Y=M,le=M.fsPath),!Y)return le;const q=this.getWorkspaceFolder(Y,!0);if(!q)return le;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let U=C.relativePath(q.uri,Y);return $&&q.name&&(U=`${q.name}/${U}`),U}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:$,added:Y,removed:le}=_.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:Y,removed:le}))}findFiles(M,$,Y,le,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${le.value}, entryPoint: findFiles`);let U;if($===null?U=!1:$&&(typeof $=="string"?U=$:U=$.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:O}=a(M);return this._proxy.$startFileSearch(I.withUndefinedAsNull(z),I.withUndefinedAsNull(O),I.withUndefinedAsNull(U),I.withUndefinedAsNull(Y),q).then(W=>Array.isArray(W)?W.map(T=>l.URI.revive(T)):[])}async findTextInFiles(M,$,Y,le,q=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${le.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),z=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:O,folder:W}=a($.include),T=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,F={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:z,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:O,excludePattern:T},N=!1;if(this._activeSearchCallbacks[U]=x=>{if(N)return;const G=l.URI.revive(x.resource);x.results.forEach(se=>{t.resultIsMatch(se)?Y({uri:G,preview:{text:se.preview.text,matches:p.mapArrayOrNot(se.preview.matches,be=>new g.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:p.mapArrayOrNot(se.ranges,be=>new g.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):Y({uri:G,text:se.text,lineNumber:se.lineNumber})})},q.isCancellationRequested)return{};try{const x=await this._proxy.$startTextSearch(M,I.withUndefinedAsNull(W),F,U,q);return delete this._activeSearchCallbacks[U],x||{}}catch(x){throw delete this._activeSearchCallbacks[U],x}}$handleTextSearchResult(M,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=je([$e(0,d.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,f.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(R){let M,$;return R&&(typeof R=="string"?M=R:(M=R.pattern,$=R.baseFolder||l.URI.file(R.base))),{includePattern:M,folder:$}}}),define(ge[36],pe([0,1,25,3,34,5,7,186,80,15,16,4,13,12,2]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(i,s){if(s){const n=s.split(".");let o=i;for(let v=0;o&&v<n.length;v++)o=o[n[v]];return o}}function E(i){return i instanceof c.URI}function w(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function d(i){if(E(i))return{resource:i};if(w(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(u(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,n,o){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,n))}};g=je([$e(0,l.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,h.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,n,o,v){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=v,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(s,n,o){const v=d(n)||{},m=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,v,o==null?void 0:o.identifier);function _(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(a){return typeof f(m,a)!="undefined"},get:(a,R)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,v,o==null?void 0:o.identifier);let M=f(m,a);if(typeof M=="undefined")M=R;else{let $;const Y=(le,q)=>{let U;const z=()=>{$=$||p.deepClone(m),U=U||f($,q)};return C.isObject(le)?new Proxy(le,{get:(O,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return z(),()=>U;if($)return U=U||f($,q),U[W];const T=O[W];return typeof W=="string"?Y(T,`${q}.${W}`):T},set:(O,W,T)=>(z(),U&&(U[W]=T),!0),deleteProperty:(O,W)=>(z(),U&&delete U[W],!0),defineProperty:(O,W,T)=>(z(),U&&Object.defineProperty(U,W,T),!0)}):le};M=Y(M,a)}return M},update:(a,R,M,$)=>{a=s?`${s}.${a}`:a;const Y=_(M);return R!==void 0?this._proxy.$updateConfigurationOption(Y,a,R,v,$):this._proxy.$removeConfigurationOption(Y,a,v,$)},inspect:a=>{var R,M,$,Y,le,q,U,z;a=s?`${s}.${a}`:a;const O=p.deepClone(this._configuration.inspect(a,v,this._extHostWorkspace.workspace));if(O)return{key:a,defaultValue:(R=O.default)===null||R===void 0?void 0:R.value,globalValue:(M=O.user)===null||M===void 0?void 0:M.value,workspaceValue:($=O.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(Y=O.workspaceFolder)===null||Y===void 0?void 0:Y.value,defaultLanguageValue:(le=O.default)===null||le===void 0?void 0:le.override,globalLanguageValue:(q=O.user)===null||q===void 0?void 0:q.override,workspaceLanguageValue:(U=O.workspace)===null||U===void 0?void 0:U.override,workspaceFolderLanguageValue:(z=O.workspaceFolder)===null||z===void 0?void 0:z.override,languageIds:O.overrideIdentifiers}}};return typeof m=="object"&&p.mixin(D,m,!1),Object.freeze(D)}_toReadonlyValue(s){const n=o=>C.isObject(o)?new Proxy(o,{get:(v,m)=>n(v[m]),set:(v,m,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(v,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(v,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(s)}_validateConfigurationAccess(s,n,o){const v=S.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=o?`[${o.value}] `:"";if(v===4){typeof(n==null?void 0:n.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){(n==null?void 0:n.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const o=new P.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,m)=>o.affectsConfiguration(v,d(m))})}_toMap(s){return s.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[64],pe([0,1,2,16,3,5,7,34,39,36,21,33,13,27,4,10,11,12,60,201,14]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(le){function q(z){if(z!=null)return z}le.from=q;function U(z){if(z!=null)return z}le.to=U})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(le){function q(z){if(z!=null)return z}le.from=q;function U(z){if(z!=null)return z}le.to=U})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(le){function q(z){if(z!=null)return z}le.from=q;function U(z){if(z!=null)return z}le.to=U})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(le){function q(O){if(O){const W=O;return W&&!!W.process}else return!1}le.is=q;function U(O){if(O==null)return;const W={process:O.process,args:O.args};return O.options&&(W.options=s.from(O.options)),W}le.from=U;function z(O){if(O!=null)return new A.ProcessExecution(O.process,O.args,O.options)}le.to=z})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(le){function q(z){if(z!=null)return z}le.from=q;function U(z){if(z!=null)return z}le.to=U})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(le){function q(O){if(O){const W=O;return W&&(!!W.commandLine||!!W.command)}else return!1}le.is=q;function U(O){if(O==null)return;const W={};return O.commandLine!==void 0?W.commandLine=O.commandLine:(W.command=O.command,W.args=O.args),O.options&&(W.options=o.from(O.options)),W}le.from=U;function z(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.ShellExecution(O.commandLine,O.options):new A.ShellExecution(O.command,O.args?O.args:[],O.options)}le.to=z})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(le){function q(O){if(O){let W=O;return W&&W.customExecution==="customExecution"}else return!1}le.is=q;function U(O){return{customExecution:"customExecution"}}le.from=U;function z(O,W){return W.get(O)}le.to=z})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(le){function q(U,z){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===A.TaskScope.Workspace&&z&&z.workspaceFile?O=z.workspaceFile:O=u.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:O}}le.from=q})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var D;(function(le){function q(O,W){if(O==null)return[];const T=[];for(let F of O){const N=U(F,W);N&&T.push(N)}return T}le.fromMany=q;function U(O,W){if(O==null)return;let T;O.execution instanceof A.ProcessExecution?T=n.from(O.execution):O.execution instanceof A.ShellExecution?T=v.from(O.execution):O.execution&&O.execution instanceof A.CustomExecution&&(T=m.from(O.execution));const F=t.from(O.definition);let N;if(O.scope?typeof O.scope=="number"?N=O.scope:N=O.scope.uri:N=A.TaskScope.Workspace,!F||!N)return;const x=O.group?O.group.id:void 0;return{_id:O._id,definition:F,name:O.name,source:{extensionId:W.identifier.value,label:O.source,scope:N},execution:T,isBackground:O.isBackground,group:x,presentationOptions:i.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}le.from=U;async function z(O,W,T){if(O==null)return;let F;n.is(O.execution)?F=n.to(O.execution):v.is(O.execution)?F=v.to(O.execution):m.is(O.execution)&&(F=m.to(O._id,T));const N=t.to(O.definition);let x;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?x=O.source.scope:x=await W.resolveWorkspaceFolder(p.URI.revive(O.source.scope)):x=A.TaskScope.Workspace),!N||!x)return;const G=new A.Task(N,x,O.name,O.source.label,F,O.problemMatchers);return O.isBackground!==void 0&&(G.isBackground=O.isBackground),O.group!==void 0&&(G.group=A.TaskGroup.from(O.group)),O.presentationOptions&&(G.presentationOptions=i.to(O.presentationOptions)),O._id&&(G._id=O._id),O.detail&&(G.detail=O.detail),G}le.to=z})(D=e.TaskDTO||(e.TaskDTO={}));var a;(function(le){function q(z){return z}le.from=q;function U(z){if(!!z)return Object.assign(Object.create(null),z)}le.to=U})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(q,U,z){this._id=U,this._task=z,g.set(this,void 0),it(this,g,q,"f")}get task(){return this._task}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}g=new WeakMap;var M;(function(le){function q(U){return{id:U._id,task:void 0}}le.from=q})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(q,U,z,O,W,T,F,N){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=q.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=O,this._configurationService=W,this._terminalService=T,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=F,this._deprecationService=N,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,z){if(!z)return new A.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:U,provider:z,extension:q}),this._proxy.$registerTaskProvider(O,U),new A.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(q,U){this._proxy.$registerTaskSystem(q,U)}fetchTasks(q){return this._proxy.$fetchTasks(a.from(q)).then(async U=>{const z=[];for(let O of U){const W=await D.to(O,this._workspaceProvider,this._providedCustomExecutions2);W&&z.push(W)}return z})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,U,z){const O=this._providedCustomExecutions2.get(q.id);if(O){if(this._activeCustomExecutions2.get(q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(q.id,O),this._terminalService.attachPtyToTerminal(U,await O.callback(z))}this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const U=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:U})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const U=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const U=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const z=this._handlers.get(q);if(!z)return Promise.reject(new Error("no handler found"));const O=[],W=L.asPromise(()=>z.provider.provideTasks(r.CancellationToken.None)).then(T=>this.provideTasksInternal(U,O,z,T));return new Promise(T=>{W.then(F=>{Promise.all(O).then(()=>{T(F)})})})}async $resolveTask(q,U){const z=this._handlers.get(q);if(!z)return Promise.reject(new Error("no handler found"));if(U.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${z.type}].`);const O=await D.to(U,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const W=await z.provider.resolveTask(O,r.CancellationToken.None);if(!W)return;this.checkDeprecation(W,z);const T=D.from(W,z.extension);if(!T)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(T.execution)&&await this.addCustomExecution(T,W,!0),await this.resolveTaskInternal(T)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,U,z){const O=await this._proxy.$createTaskId(q);!z&&!this._providedCustomExecutions2.has(O)&&this._notProvidedCustomExecutions.add(O),this._providedCustomExecutions2.set(O,U.execution)}async getTaskExecution(q,U){if(typeof q=="string"){const W=this._taskExecutionPromises.get(q);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let z=this._taskExecutionPromises.get(q.id);if(z)return z;const O=new Promise(async(W,T)=>{const F=U||await D.to(q.task,this._workspaceProvider,this._providedCustomExecutions2);F?W(new R(this,q.id,F)):T("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(q.id,O),O.then(W=>(this._taskExecutions.set(q.id,W),W),W=>Promise.reject(W))}checkDeprecation(q,U){q._deprecated&&this._deprecationService.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let z=this._notProvidedCustomExecutions.values(),O=z.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=z.next()}};$=je([$e(0,l.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let Y=class extends ${constructor(q,U,z,O,W,T,F,N){super(q,U,z,O,W,T,F,N);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const z=D.from(U,q);if(z===void 0)throw new Error("Task is not valid");if(m.is(z.execution))await this.addCustomExecution(z,U,!1);else throw new d.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),U);return this._proxy.$executeTask(z).catch(W=>{throw new Error(W)}),O}provideTasksInternal(q,U,z,O){const W=[];if(O)for(let T of O){this.checkDeprecation(T,z),(!T.definition||!q[T.definition.type])&&this._logService.warn(`The task [${T.source}, ${T.name}] uses an undefined task type. The task will be ignored in the future.`);const F=D.from(T,z.extension);F&&m.is(F.execution)?(W.push(F),U.push(this.addCustomExecution(F,T,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:z.extension}}async resolveTaskInternal(q){if(m.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,z){}};Y=je([$e(0,l.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService)],Y),e.WorkerExtHostTask=Y,e.IExtHostTask=c.createDecorator("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)},Sn=this&&this.__rest||function(X,e){var p={};for(var L in X)Object.prototype.hasOwnProperty.call(X,L)&&e.indexOf(L)<0&&(p[L]=X[L]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,L=Object.getOwnPropertySymbols(X);k<L.length;k++)e.indexOf(L[k])<0&&Object.prototype.propertyIsEnumerable.call(X,L[k])&&(p[L[k]]=X[L[k]]);return p};define(ge[253],pe([0,1,18,16,22,21,3,68,70,6,25,15,2,32,5,39,13,83,17,7,34,211,122]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u,d,g,t){"use strict";var i,s,n,o,v;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;const m=(W,T)=>`${W}:${T.toString()}`;let _=class{constructor(T,F,N){this.documents=F,this.workspace=N,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.ownedTests=new g.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(c.MainContext.MainThreadTesting),this.runTracker=new a(this.proxy),this.workspaceObservers=new z(this.proxy),this.textDocumentObservers=new O(this.proxy,F)}registerTestController(T,F){const N=h.generateUuid();this.controllers.set(N,{instance:F,extensionId:T}),this.proxy.$registerTestController(N);const x=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const se of x)(G=this.testControllers.get(se))===null||G===void 0||G.subscribeFn(N,F)},0),C.toDisposable(()=>{this.controllers.delete(N),this.proxy.$unregisterTestController(N)})}createTextDocumentTestObserver(T){return this.textDocumentObservers.checkout(T.uri)}createWorkspaceTestObserver(T){return this.workspaceObservers.checkout(T.uri)}async runTests(T,F=y.CancellationToken.None){const N=x=>x.map(this.getInternalTestForReference,this).filter(I.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:T.exclude?N(T.exclude).map(x=>x.testId):void 0,tests:N(T.tests),debug:T.debug},F)}createTestRun(T,F,N=!0){return this.runTracker.createTestRun(T,F,N)}$publishTestResults(T){this.results=Object.freeze(T.map(F=>r.deepFreeze(b.TestResults.to(F))).concat(this.results).sort((F,N)=>N.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(T,F){const N=l.URI.revive(F),x=m(T,N);if(this.testControllers.has(x))return;const G=new y.CancellationTokenSource;let se;if(T===1){let qe=this.documents.getDocument(N);if(!qe){const He=new C.DisposableStore;qe=await new Promise(Ve=>{He.add(L.disposableTimeout(()=>Ve(void 0),5e3)),He.add(this.documents.onDidAddDocuments(j=>{const Z=j.find(ne=>ne.document.uri.toString()===N.toString());Z&&Ve(Z)}))}).finally(()=>He.dispose())}if(qe){const He=await this.workspace.getWorkspaceFolder2(N,!1);se=Ve=>Ve.createDocumentTestRoot?Ve.createDocumentTestRoot(qe.document,G.token):e.createDefaultDocumentTestRoot(Ve,qe.document,He,G.token)}}else{const qe=await this.workspace.getWorkspaceFolder2(N,!1);qe&&(se=He=>He.createWorkspaceTestRoot(qe,G.token))}if(!se)return;const be=async(qe,He)=>{try{const Ve=await se(He);Ve&&Ce.addRoot(Ve,qe)}catch(Ve){console.error(Ve)}},Ie=new C.DisposableStore,Ce=Ie.add(this.ownedTests.createForHierarchy(qe=>this.proxy.$publishDiff(T,F,qe)));Ie.add(C.toDisposable(()=>G.dispose(!0)));const Me=[];for(const[qe,He]of this.controllers)Me.push(be(qe,He.instance));Promise.all(Me).then(()=>Ce.pushDiff([3,-1])),this.testControllers.set(x,{store:Ie,collection:Ce,subscribeFn:be})}async $expandTest(T,F){const N=p.mapFind(this.testControllers.values(),x=>x.collection.treeId===T.src.tree?x:void 0);await(N==null?void 0:N.collection.expand(T.testId,F<0?Infinity:F)),this.flushCollectionDiffs()}$unsubscribeFromTests(T,F){var N;const x=l.URI.revive(F),G=m(T,x);(N=this.testControllers.get(G))===null||N===void 0||N.store.dispose(),this.testControllers.delete(G)}$acceptDiff(T,F,N){T===1?this.textDocumentObservers.acceptDiff(l.URI.revive(F),N):this.workspaceObservers.acceptDiff(l.URI.revive(F),N)}async $runTestsForProvider(T,F){const N=this.controllers.get(T.tests[0].src.controller);if(!N)return;const x=T.tests.map(({testId:Ie,src:Ce})=>this.ownedTests.getTestById(Ie,Ce==null?void 0:Ce.tree)).filter(I.isDefined).map(([Ie,Ce])=>Ce),G=T.excludeExtIds.map(Ie=>this.ownedTests.getTestById(Ie)).filter(I.isDefined).filter(([Ie,Ce])=>x.some(Me=>Ie.comparePositions(Me,Ce)===1));if(!x.length)return;const se={tests:x.map(Ie=>Y.unwrap(Ie.actual)),exclude:G.map(([,Ie])=>Y.unwrap(Ie.actual)),debug:T.debug},be=this.runTracker.prepareForMainThreadTestRun(se,R.fromInternal(T),F);try{await N.instance.runTests(se,F)}finally{be.isRunning&&!F.isCancellationRequested&&await A.Event.toPromise(be.onEnd),this.runTracker.cancelRunById(T.runId)}}$cancelExtensionTestRun(T){T===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(T)}$lookupTest(T){const F=this.ownedTests.getTestById(T.testId);if(!F)return Promise.resolve(void 0);const N=F[1],{actual:x,discoverCts:G,expandLevels:se}=N,be=Sn(N,["actual","discoverCts","expandLevels"]);return Promise.resolve(be)}flushCollectionDiffs(){for(const{collection:T}of this.testControllers.values())T.flushDiff()}getInternalTestForReference(T){var F,N;return(N=(F=this.workspaceObservers.getMirroredTestDataByReference(T))!==null&&F!==void 0?F:p.mapFind(this.testControllers.values(),x=>x.collection.getTestByReference(T)))!==null&&N!==void 0?N:this.textDocumentObservers.getMirroredTestDataByReference(T)}};_=je([$e(0,E.IExtHostRpcService),$e(1,f.IExtHostDocumentsAndEditors),$e(2,d.IExtHostWorkspace)],_),e.ExtHostTesting=_;class D extends C.Disposable{constructor(T,F,N){super();this.dto=T,this.proxy=F,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const x of this.task)x.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(T){const F=new M(T,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(F),this.isRunning||this.dispose()});return this.task.add(F),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class a{constructor(T){this.proxy=T,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(T,F,N){return this.getTracker(T,F,N)}cancelRunById(T){for(const F of this.tracked.values())if(F.id===T){F.dispose();return}}cancelAllRuns(){for(const T of this.tracked.values())T.dispose()}createTestRun(T,F,N){var x,G;const se=this.tracked.get(T);if(se)return se.createRun(F);const be=R.fromPublic(T);this.proxy.$startedExtensionTestRun({debug:T.debug,exclude:(G=(x=T.exclude)===null||x===void 0?void 0:x.map(Ce=>Ce.id))!==null&&G!==void 0?G:[],id:be.id,tests:T.tests.map(Ce=>Ce.id),persist:N});const Ie=this.getTracker(T,be);return Ie.onEnd(()=>this.proxy.$finishedExtensionTestRun(be.id)),Ie.createRun(F)}getTracker(T,F,N){const x=new D(F,this.proxy,N);return this.tracked.set(T,x),x.onEnd(()=>this.tracked.delete(T)),x}}e.TestRunCoordinator=a;class R{constructor(T,F,N){this.id=T,this.include=F,this.exclude=N}static fromPublic(T){var F,N;return new R(h.generateUuid(),new Set(T.tests.map(x=>x.id)),new Set((N=(F=T.exclude)===null||F===void 0?void 0:F.map(x=>x.id))!==null&&N!==void 0?N:S.Iterable.empty()))}static fromInternal(T){return new R(T.runId,new Set(T.tests.map(F=>F.testId)),new Set(T.excludeExtIds))}isIncluded(T){for(let F=T;F;F=F.parent){if(this.include.has(F.id))return!0;if(this.exclude.has(F.id))return!1}return!0}}e.TestRunDto=R;class M{constructor(T,F,N,x,G,se){this.name=T,this.token=F,i.set(this,void 0),s.set(this,void 0),n.set(this,void 0),o.set(this,void 0),v.set(this,!1),this.taskId=h.generateUuid(),it(this,o,se,"f"),it(this,i,G,"f"),it(this,s,N,"f"),it(this,n,x,"f"),G.$startedTestRunTask(N.id,{id:this.taskId,name:T,running:!0})}setState(T,F,N){!Be(this,v,"f")&&Be(this,s,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,i,"f").$updateTestStateInRun(Be(this,s,"f").id,this.taskId,T.id,F,N))}appendMessage(T,F){!Be(this,v,"f")&&Be(this,s,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,i,"f").$appendTestMessageInRun(Be(this,s,"f").id,this.taskId,T.id,b.TestMessage.from(F)))}appendOutput(T){Be(this,v,"f")||Be(this,i,"f").$appendOutputToRun(Be(this,s,"f").id,this.taskId,k.VSBuffer.fromString(T))}end(){Be(this,v,"f")||(it(this,v,!0,"f"),Be(this,i,"f").$finishedTestRunTask(Be(this,s,"f").id,this.taskId),Be(this,o,"f").call(this))}ensureTestIsKnown(T){const F=Be(this,n,"f");if(F.has(T.id))return;const N=[];for(;N.unshift(b.TestItem.from(T)),!(F.has(T.id)||(F.add(T.id),!T.parent));)T=T.parent;Be(this,i,"f").$addTestsToRun(Be(this,s,"f").id,N)}}i=new WeakMap,s=new WeakMap,n=new WeakMap,o=new WeakMap,v=new WeakMap;const $=async(W,T,F,N)=>{if(!F)return;const x=await W.createWorkspaceTestRoot(F,N);if(!x)return;N.onCancellationRequested(()=>{Y.removeFilter(T)});const G=Y.getWrapperForTestItem(x,T);return G.refreshMatch(),G};e.createDefaultDocumentTestRoot=$;class Y extends u.TestItemImpl{constructor(T,F,N){super(T.id,T.label,T.uri,void 0);if(this.actual=T,this.filterDocument=F,this.actualParent=N,!(T instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${T.id} did not`);this.debuggable=T.debuggable,this.runnable=T.runnable,this.description=T.description,this.error=T.error,this.status=T.status,this.range=T.range,this.resolveHandler=T.resolveHandler;const x=w.getPrivateApiFor(this);w.getPrivateApiFor(T).bus.event(se=>{switch(se[0]){case 3:this[se[1]]=se[2];break;case 0:const be=Y.getWrapperForTestItem(se[1],this.filterDocument,this);w.getPrivateApiFor(be).parent=T,be.refreshMatch();break;default:x.bus.fire(se)}})}static removeFilter(T){this.wrapperMap.delete(T)}static getWrapperForTestItem(T,F,N){let x=this.wrapperMap.get(F);if(x==null?void 0:x.has(T))return x.get(T);x||(x=new WeakMap,this.wrapperMap.set(F,x));const G=new Y(T,F,N);return x.set(T,G),G}static unwrap(T){return T instanceof Y?T.actual:T}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var T,F;const N=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const se=Y.getWrapperForTestItem(G,this.filterDocument,this);se.hasNodeMatchingFilter?this.children.has(se.id)||this.addChild(se):se.dispose()}const x=this.children.size>0||((T=this.actual.uri)===null||T===void 0?void 0:T.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=x,x!==N&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&w.getPrivateApiFor(this.actualParent).children.delete(this.id),w.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=Y,Y.wrapperMap=new WeakMap;class le extends t.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,b.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:F,removed:N}=this;return{get added(){return[...T].map(x=>x.revived)},get updated(){return[...F].map(x=>x.revived)},get removed(){return[...N].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class q extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(T){let F=[];for(const N of T){const x=this.items.get(N);x&&F.push(x.revived)}return F}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,F){return Object.assign(Object.assign({},T),{revived:b.TestItem.toPlain(T.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new le(this.changeEmitter)}}e.MirroredTestCollection=q;class U{constructor(){this.resources=new Map}checkout(T){var F,N;const x=T.toString(),G=(F=this.resources.get(x))!==null&&F!==void 0?F:this.createObserverData(T);return(N=G.pendingDeletion)===null||N===void 0||N.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:P.once(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(T))})}}getMirroredTestDataByReference(T){for(const{tests:F}of this.resources.values()){const N=F.getMirroredTestDataByReference(T);if(N)return N}}eventuallyDispose(T){return L.disposableTimeout(()=>this.unlisten(T),10*1e3)}createObserverData(T){const F=new q,N=this.listen(T,G=>F.apply(G)),x={observers:0,tests:F,listener:N};return this.resources.set(T.toString(),x),x}unlisten(T){var F;const N=T.toString(),x=this.resources.get(N);x&&(x.observers=-1,(F=x.pendingDeletion)===null||F===void 0||F.dispose(),x.listener.dispose(),this.resources.delete(N))}}class z extends U{constructor(T){super();this.proxy=T,this.diffListeners=new Map}acceptDiff(T,F){var N;(N=this.diffListeners.get(T.toString()))===null||N===void 0||N(F)}listen(T,F){this.proxy.$subscribeToDiffs(0,T);const N=T.toString();return this.diffListeners.set(N,F),C.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(0,T),this.diffListeners.delete(N)})}}class O extends U{constructor(T,F){super();this.proxy=T,this.documents=F,this.diffListeners=new Map}acceptDiff(T,F){var N;(N=this.diffListeners.get(T.toString()))===null||N===void 0||N(F)}listen(T,F){if(!this.documents.getDocument(T))return C.toDisposable(()=>{});const x=T.toString();return this.diffListeners.set(x,F),this.proxy.$subscribeToDiffs(1,T),C.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(1,T),this.diffListeners.delete(x)})}}}),define(ge[254],pe([0,1,18,67,30,75,23,10,9,24,8,15,2,140,168,116,45,204,252,31]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(_,D,a,R){this.configurationService=_,this.workspaceContextService=D,this.editorGroupsService=a,this.pathService=R}text(_,D,a={}){_=this.getContentPattern(_,a);const R=this.configurationService.getValue(),M=D&&D.some(Y=>!this.configurationService.getValue({resource:Y}).search.useRipgrep),$=this.commonQuery(D==null?void 0:D.map(E.toWorkspaceFolder),a);return Object.assign(Object.assign({},$),{type:2,contentPattern:_,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:R.search.usePCRE2||M||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(_,D){const a=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},_),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(_,D)&&(R.isCaseSensitive=!0),this.isMultiline(_)&&(R.isMultiline=!0),R}file(_,D={}){const a=this.commonQuery(_,D);return Object.assign(Object.assign({},a),{type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey})}handleIncludeExclude(_,D){return _?(_=Array.isArray(_)?_.map(n):n(_),D?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],D={}){const a=this.handleIncludeExclude(D.includePattern,D.expandPatterns),R=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),M=_.length>1,$=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,D,R)):_.map(q=>this.getFolderQueryForRoot(q,D,R,M))).filter(q=>!!q),Y={_reason:D._reason,folderQueries:$,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:R.pattern,includePattern:a.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const U=p.coalesce(p.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(W=>W.resource)))).filter(O=>u.pathIncludedInQuery(Y,O.fsPath)),z=this.commonQueryFromFileList(U);return Object.assign(Object.assign({},Y),z)}const le=D.extraFileResources&&D.extraFileResources.filter(q=>u.pathIncludedInQuery(Y,q.fsPath));return Y.extraFileResources=le&&le.length?le:void 0,Y}commonQueryFromFileList(_){const D=[],a=new A.ResourceMap,R={};let M=!1;return _.forEach($=>{var Y,le;if($.scheme===P.Schemas.walkThrough)return;if(C.isAbsolutePath($)){const U=(le=(Y=this.workspaceContextService.getWorkspaceFolder($))===null||Y===void 0?void 0:Y.uri)!==null&&le!==void 0?le:$.with({path:S.dirname($.fsPath)});let z=a.get(U);z||(M=!0,z={folder:U,includePattern:{}},D.push(z),a.set(U,z));const O=S.relative(U.fsPath,$.fsPath);I.assertIsDefined(z.includePattern)[O.replace(/\\/g,"/")]=!0}else $.fsPath&&(M=!0,R[$.fsPath]=!0)}),{folderQueries:D,includePattern:R,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(_,D){if(D.isSmartCase){if(_.isRegExp){if(r.containsUppercaseCharacter(_.pattern,!0))return!0}else if(r.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&h.isMultilineRegexSource(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const D=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),R=(Array.isArray(_)?_:i(_)).map(z=>{const O=this.pathService.resolvedUserHome;return O?y.untildify(z,O.scheme===P.Schemas.file?O.fsPath:O.path):z}),M=L.groupBy(R,z=>D(z)?"searchPaths":"exprSegments"),$=(M.exprSegments||[]).map(z=>r.rtrim(z,"/")).map(z=>r.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),s(z))),Y={},le=this.expandSearchPathPatterns(M.searchPaths||[]);le&&le.length&&(Y.searchPaths=le);const q=p.flatten($),U=t(...q);return U&&(Y.pattern=U),Y}getExcludesForFolder(_,D){return D.disregardExcludeSettings?void 0:u.getExcludes(_,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const D=p.flatten(_.map(R=>{let{pathPortion:M,globPortion:$}=g(R);$&&($=o($));const Y=this.expandOneSearchPath(M);return p.flatten(Y.map(le=>this.resolveOneSearchPathPattern(le,$)))})),a=new Map;return D.forEach(R=>{const M=R.searchPath.toString(),$=a.get(M);$?R.pattern&&($.pattern=$.pattern||{},$.pattern[R.pattern]=!0):a.set(M,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(_){if(S.isAbsolute(_)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==P.Schemas.file?[{searchPath:D[0].uri.with({path:_})}]:[{searchPath:l.URI.file(S.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=n(_),_.startsWith("../")||_===".."){const R=S.posix.resolve(D.path,_);return[{searchPath:D.with({path:R})}]}const a=o(_);return[{searchPath:D,pattern:a}]}else{if(_==="./"||_===".\\")return[];{const D=_.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(M=>{const $=D.match(new RegExp(`^${r.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return $?{match:$,folder:M}:null}).filter(I.isDefined);if(R.length)return R.map(M=>{const $=M.match[1];return{searchPath:M.folder.uri,pattern:$&&o($)}});{const M=_.match(/\.[\/\\](.+)[\/\\]?/),$=M?M[1]:_,Y=c.localize(0,null,$);throw new Error(Y)}}}}resolveOneSearchPathPattern(_,D){const a=_.pattern&&D?`${_.pattern}/${D}`:_.pattern||D,R=[{searchPath:_.searchPath,pattern:a}];return a&&!a.endsWith("**")&&R.push({searchPath:_.searchPath,pattern:a+"/**"}),R}getFolderQueryForSearchPath(_,D,a){const R=this.getFolderQueryForRoot(E.toWorkspaceFolder(_.searchPath),D,a,!1);return R?Object.assign(Object.assign({},R),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,D,a,R){let M;const $=l.URI.isUri(_)?_:_.uri;if(a.searchPaths){const z=a.searchPaths.filter(O=>C.isEqual(O.searchPath,$))[0];if(z&&!z.pattern)return null;z&&(M=z.pattern)}const Y=this.configurationService.getValue({resource:$}),le=this.getExcludesForFolder(Y,D),q=Object.assign(Object.assign({},le||{}),M||{}),U=l.URI.isUri(_)?C.basename(_):_.name;return{folder:$,folderName:R?U:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:Y.files&&Y.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!Y.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!Y.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!Y.search.followSymlinks}}};d=je([$e(0,f.IConfigurationService),$e(1,E.IWorkspaceContextService),$e(2,w.IEditorGroupsService),$e(3,b.IPathService)],d),e.QueryBuilder=d;function g(m){const _=m.match(/[\*\{\}\(\)\[\]\?]/);if(_){const D=_.index,a=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(a){let R=m.substr(0,a.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:m.substr((a.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((_,D)=>(_[D]=!0,_),Object.create(null)):void 0}function i(m){return k.splitGlobAware(m,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function o(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(m,_){m=p.distinct(m,R=>R.toString());const D=[],a=_.getWorkspace();return m&&m.forEach(R=>{let M;if(_.getWorkbenchState()===2)M=C.relativePath(a.folders[0].uri,R),M&&M!=="."&&(M="./"+M);else{const $=_.getWorkspaceFolder(R);if($){const Y=$.name;if(a.folders.filter(q=>q.name===Y).length===1){const q=C.relativePath($.uri,R);q===""?M=`./${$.name}`:M=`./${$.name}/${q}`}else M=R.fsPath}}M&&D.push(M)}),D}e.resolveResourcesForSearchIncludes=v}),define(ge[255],pe([0,1,24,2,21,14,4,254,31,45]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function I(f,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],u=[];for(const n of w)if(/^workspaceContains:/.test(n)){const o=n.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||f.forceUsingSearch?u.push(o):b.push(o)}if(b.length===0&&u.length===0)return Promise.resolve(void 0);let d;const g=new Promise((n,o)=>{d=n}),t=n=>d({activationEvent:n}),i=Promise.all(b.map(n=>l(f,n,t))).then(()=>{}),s=h(f,E.identifier,u,t);return Promise.all([i,s]).then(()=>{d(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function l(f,E,w){for(const b of f.folders)if(await f.exists(p.joinPath(L.URI.revive(b),E))){w(`workspaceContains:${E}`);return}}async function h(f,E,w,b){if(w.length===0)return Promise.resolve(void 0);const u=new k.CancellationTokenSource,d=f.checkExists(f.folders,w,u.token),g=setTimeout(async()=>{u.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await d}catch(i){y.isPromiseCanceledError(i)||y.onUnexpectedError(i)}u.dispose(),clearTimeout(g),t&&b(`workspaceContains:${w.join(",")}`)}function c(f,E,w,b){const u=f.get(A.IInstantiationService),d=f.get(S.ISearchService),t=u.createInstance(P.QueryBuilder).file(E.map(i=>C.toWorkspaceFolder(L.URI.revive(i))),{_reason:"checkExists",includePattern:w,exists:!0});return d.fileSearch(t,b).then(i=>!!i.limitHit,i=>y.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var it=this&&this.__classPrivateFieldSet||function(X,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(X,p):k?k.value=p:e.set(X,p),p},Be=this&&this.__classPrivateFieldGet||function(X,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(X):L?L.value:e.get(X)};define(ge[40],pe([0,1,159,9,65,24,16,6,23,2,12,5,36,215,88,34,35,213,14,26,22,191,7,117,4,27,89,13,79,47,33,3,255,86,193]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u,d,g,t,i,s,n,o,v,m,_,D,a,R,M,$){"use strict";var Y,le,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let U=class $n extends P.Disposable{constructor(T,F,N,x,G,se,be,Ie,Ce,Me){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=F,this._extHostContext=N,this._initData=be,this._extHostWorkspace=x,this._extHostConfiguration=G,this._logService=se,this._extHostTunnelService=Ce,this._extHostTerminalService=Me,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Ie,this._instaService=T.createChild(new m.ServiceCollection([c.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(He=>qe.add(u.ExtensionIdentifier.toKey(He))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,Ve,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(Ve),j)},actualActivateExtension:async(He,Ve)=>{if(qe.has(u.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,Ve),new h.HostExtension;const j=this._registry.getExtensionDescription(He);return this._activateExtension(j,Ve)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(T){b.onUnexpectedError(T)}}async deactivateAll(){let T=[];try{T=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(F){}await Promise.all(T)}isActivated(T){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(T):!1}_activateByEvent(T,F){return this._activator.activateByEvent(T,F)}_activateById(T,F){return this._activator.activateById(T,F)}activateByIdWithErrors(T,F){return this._activateById(T,F).then(()=>{const N=this._activator.getActivatedExtension(T);if(N.activationFailed)return Promise.reject(N.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(T=>this._registry)}getExtensionExports(T){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(T).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const T=S.TernarySearchTree.forPaths(),F=this._registry.getAllExtensionDescriptions().map(N=>{if(!!this._getEntryPoint(N))return this._hostUtils.realpath(N.extensionLocation.fsPath).then(x=>T.set(C.URI.file(x).fsPath,N))});this._extensionPathIndex=Promise.all(F).then(()=>T)}return this._extensionPathIndex}_deactivate(T){let F=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(T))return F;const N=this._activator.getActivatedExtension(T);if(!N)return F;try{typeof N.module.deactivate=="function"&&(F=Promise.resolve(N.module.deactivate()).then(void 0,x=>(this._logService.error(x),Promise.resolve(void 0))))}catch(x){this._logService.error(x)}try{P.dispose(N.subscriptions)}catch(x){this._logService.error(x)}return F}async _activateExtension(T,F){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(T.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(T.identifier),this._doActivateExtension(T,F).then(N=>{const x=N.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(T.identifier,x.codeLoadingTime,x.activateCallTime,x.activateResolvedTime,F),this._logExtensionActivationTimes(T,F,"success",x),N},N=>{throw this._logExtensionActivationTimes(T,F,"failure"),N})}_logExtensionActivationTimes(T,F,N,x){const G=z(T,F);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},G),x||{}),{outcome:N}))}_doActivateExtension(T,F){const N=z(T,F);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",N);const x=this._getEntryPoint(T);if(!x)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${T.identifier.value} ${JSON.stringify(F)}`),this._logService.flush();const G=new h.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this._loadCommonJSModule(T.identifier,y.joinPath(T.extensionLocation,x),G),this._loadExtensionContext(T)]).then(se=>(k.mark(`code/extHost/willActivateExtension/${T.identifier.value}`),$n._callActivate(this._logService,T.identifier,se[0],se[1],G))).then(se=>(k.mark(`code/extHost/didActivateExtension/${T.identifier.value}`),se))}_loadExtensionContext(T){const F=new g.ExtensionGlobalMemento(T,this._storage),N=new g.ExtensionMemento(T.identifier.value,!1,this._storage),x=new $.ExtensionSecrets(T,this._secretState),G=T.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${T.identifier.value}`),Promise.all([F.whenReady,N.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Ie;return Object.freeze({globalState:F,workspaceState:N,secrets:x,subscriptions:[],get extensionUri(){return T.extensionLocation},get extensionPath(){return T.extensionLocation.fsPath},asAbsolutePath(Ce){return L.join(T.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(T))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(T).fsPath},get logPath(){return L.join(be._initData.logsLocation.fsPath,T.identifier.value)},get logUri(){return C.URI.joinPath(be._initData.logsLocation,T.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(T)},get globalStorageUri(){return be._storagePath.globalValue(T)},get extensionMode(){return G},get extension(){return Ie===void 0&&(Ie=new O(be,T.identifier,T,se)),Ie},get extensionRuntime(){return E.checkProposedApiEnabled(T),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(T)}})})}static _callActivate(T,F,N,x,G){return N=N||{activate:void 0,deactivate:void 0},this._callActivateOptional(T,F,N,x,G).then(se=>new h.ActivatedExtension(!1,null,G.build(),N,se,x.subscriptions))}static _callActivateOptional(T,F,N,x,G){if(typeof N.activate=="function")try{G.activateCallStart(),T.trace(`ExtensionService#_callActivateOptional ${F.value}`);const se=typeof global=="object"?global:self,be=N.activate.apply(se,[x]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(be).then(Ie=>(G.activateResolveStop(),Ie))}catch(se){return Promise.reject(se)}else return Promise.resolve(N)}_activateOneStartupFinished(T,F){this._activateById(T.identifier,{startup:!1,extensionId:T.identifier,activationEvent:F}).then(void 0,N=>{this._logService.error(N)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const T of this._registry.getAllExtensionDescriptions())if(T.activationEvents)for(const F of T.activationEvents)F==="onStartupFinished"&&this._activateOneStartupFinished(T,F)}_handleEagerExtensions(){const T=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const F=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],N=this._handleWorkspaceContainsEagerExtensions(F),x=Promise.all([T,N]).then(()=>{});return Promise.race([x,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),x}_handleWorkspaceContainsEagerExtensions(T){return T.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(F=>this._handleWorkspaceContainsEagerExtension(T,F))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(T,F){if(this.isActivated(F.identifier))return;const N=!this._initData.remote.isRemote&&!!this._initData.remote.authority,x={folders:T.map(se=>se.uri),forceUsingSearch:N,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,be,Ie)=>this._mainThreadWorkspaceProxy.$checkExists(se,be,Ie)},G=await R.checkActivateWorkspaceContainsExtension(x,F);if(!!G)return this._activateById(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:G.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(T){throw console.error(T),T}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:T,extensionTestsLocationURI:F}=this._initData.environment;if(!T||!F)throw new Error(p.localize(0,null));const N=await this._loadCommonJSModule(null,F,new h.ExtensionActivationTimesBuilder(!1));if(!N||typeof N.run!="function")throw new Error(p.localize(1,null,F.toString()));return new Promise((x,G)=>{const se=(Ce,Me)=>{Ce?G(Ce):x(typeof Me=="number"&&Me>0?1:0)},be=y.originalFSPath(F),Ie=N.run(be,se);Ie&&Ie.then&&Ie.then(()=>{x(0)}).catch(Ce=>{G(Ce.toString())})})}async $extensionTestsExit(T){this._logService.info(`extension host terminating: test runner requested exit with code ${T}`),this._logService.info(`exiting with code ${T}`),this._logService.flush(),this._hostUtils.exit(T)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(T,F){return this._resolvers[T]=F,P.toDisposable(()=>{delete this._resolvers[T]})}async _activateAndGetResolver(T){const F=T.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const N=T.substr(0,F);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${N}`,!1),{authorityPrefix:N,resolver:this._resolvers[N]}}async $resolveAuthority(T,F){const{authorityPrefix:N,resolver:x}=await this._activateAndGetResolver(T);if(!x)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${N}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(x)),k.mark(`code/extHost/willResolveAuthority/${N}`);const G=await x.resolve(T,{resolveAttempt:F});k.mark(`code/extHost/didResolveAuthorityOK/${N}`);const se={authority:T,host:G.host,port:G.port,connectionToken:G.connectionToken},be={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted};return{type:"ok",value:{authority:se,options:be,tunnelInformation:{environmentTunnels:G.environmentTunnels}}}}catch(G){if(k.mark(`code/extHost/didResolveAuthorityError/${N}`),G instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G}}async $getCanonicalURI(T,F){const{authorityPrefix:N,resolver:x}=await this._activateAndGetResolver(T);if(!x)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${N}`);const G=C.URI.revive(F);if(typeof x.getCanonicalURI=="undefined")return G;const se=await A.asPromise(()=>x.getCanonicalURI(G));return se||G}$startExtensionHost(T){return this._registry.keepOnly(T),this._startExtensionHost()}$activateByEvent(T,F){return F===1?this._activateByEvent(T,!1):this._readyToRunExtensions.wait().then(N=>this._activateByEvent(T,!1))}async $activate(T,F){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(T)?(await this._activateById(T,F),!0):!1}async $deltaExtensions(T,F){T.forEach(x=>x.extensionLocation=C.URI.revive(x.extensionLocation));const N=await this.getExtensionPathIndex();return await Promise.all(F.map(async x=>{const G=this._registry.getExtensionDescription(x);if(!G)return;const se=await this._hostUtils.realpath(G.extensionLocation.fsPath);N.delete(C.URI.file(se).fsPath)})),await Promise.all(T.map(async x=>{const G=await this._hostUtils.realpath(x.extensionLocation.fsPath);N.set(C.URI.file(G).fsPath,x)})),this._registry.deltaExtensions(T,F),Promise.resolve(void 0)}async $test_latency(T){return T}async $test_up(T){return T.byteLength}async $test_down(T){let F=d.VSBuffer.alloc(T),N=Math.random()%256;for(let x=0;x<T;x++)F.writeUInt8(N,x);return F}async $updateRemoteConnectionData(T){this._remoteConnectionData=T,this._onDidChangeRemoteConnectionData.fire()}};U=je([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,v.IExtHostRpcService),$e(3,f.IExtHostWorkspace),$e(4,l.IExtHostConfiguration),$e(5,r.ILogService),$e(6,n.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,_.IExtHostTunnelService),$e(9,D.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function z(W,T){return{id:W.identifier.value,name:W.name,extensionVersion:W.version,publisherDisplayName:W.publisher,activationEvents:W.activationEvents?W.activationEvents.join(","):null,isBuiltin:W.isBuiltin,reason:T.activationEvent,reasonId:T.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class O{constructor(T,F,N,x){Y.set(this,void 0),le.set(this,void 0),q.set(this,void 0),it(this,Y,T,"f"),it(this,le,F,"f"),it(this,q,N.identifier,"f"),this.id=N.identifier.value,this.extensionUri=N.extensionLocation,this.extensionPath=L.normalize(y.originalFSPath(N.extensionLocation)),this.packageJSON=N,this.extensionKind=x}get isActive(){return Be(this,Y,"f").isActivated(Be(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,Y,"f").getExtensionExports(Be(this,q,"f"))}activate(){return Be(this,Y,"f").activateByIdWithErrors(Be(this,q,"f"),{startup:!1,extensionId:Be(this,le,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=O,Y=new WeakMap,le=new WeakMap,q=new WeakMap}),define(ge[49],pe([0,1,9,2,3,16,5,7,120,34,40,39,203,36,198,13,4,15,37,46]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=E.createDecorator("IExtHostDebugService");let d=class{constructor(m,_,D,a,R,M){this._workspaceService=_,this._extensionService=D,this._editorsService=a,this._configurationService=R,this._editorTabs=M,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=m.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(Y=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,_){const D=m;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let a=`debug:${encodeURIComponent(D.path||"")}`,R="?";return _&&(a+=`${R}session=${encodeURIComponent(_.id)}`,R="&"),a+=`${R}ref=${D.sourceReference}`,L.URI.parse(a)}else{if(D.path)return L.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const _=[];for(const D of m.getAllExtensionDescriptions())if(D.contributes){const a=D.contributes.debuggers;if(a&&a.length>0)for(const R of a)c.isDebuggerMainContribution(R)&&_.push(R.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(_=>m.push(_)),m}addBreakpoints(m){this.startBreakpoints();const _=m.filter(R=>{const M=R.id;return this._breakpoints.has(M)?!1:(this._breakpoints.set(M,R),!0)});this.fireBreakpointChanges(_,[],[]);const D=[],a=new Map;for(const R of _)if(R instanceof P.SourceBreakpoint){let M=a.get(R.location.uri.toString());M||(M={type:"sourceMulti",uri:R.location.uri,lines:[]},a.set(R.location.uri.toString(),M),D.push(M)),M.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof P.FunctionBreakpoint&&D.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(m){this.startBreakpoints();const _=m.filter(M=>this._breakpoints.delete(M.id));this.fireBreakpointChanges([],_,[]);const D=_.filter(M=>M instanceof P.SourceBreakpoint).map(M=>M.id),a=_.filter(M=>M instanceof P.FunctionBreakpoint).map(M=>M.id),R=_.filter(M=>M instanceof P.DataBreakpoint).map(M=>M.id);return this._debugServiceProxy.$unregisterBreakpoints(D,a,R)}startDebugging(m,_,D){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,_,{parentSessionID:D.parentSession?D.parentSession.id:void 0,repl:D.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,_,D){if(!_)return new P.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:a,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,D,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(m,_,D){if(!D)return new P.Disposable(()=>{});if(!this.definesDebugType(m,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:a,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,a),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(m,_){if(!_)return new P.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:D,factory:_}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==_)})}async $runInTerminal(m,_){return Promise.resolve(void 0)}async $substituteVariables(m,_){if(!this._variableResolver){const[R,M]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,M)}let D;const a=await this.getFolder(m);return a&&(D={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,_)}createDebugAdapter(m,_){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,_){const D=this,a=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const M=this.convertToDto(R),$=this.createDebugAdapter(M,a);if(!$)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const Y=$;return this._debugAdapters.set(m,Y),this.getDebugAdapterTrackers(a).then(le=>(le&&this._debugAdaptersTrackers.set(m,le),Y.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const U=q,z={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(U.arguments.value);z.body={signature:O},Y.sendResponse(z)}else throw new Error("no signer")}catch(O){z.success=!1,z.message=O.message,Y.sendResponse(z)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(q),q=c.convertToVSCPaths(q,!0),D._debugServiceProxy.$acceptDAMessage(m,q)}),Y.onError(q=>{le&&le.onError&&le.onError(q),this._debugServiceProxy.$acceptDAError(m,q.name,q.message,q.stack)}),Y.onExit(q=>{le&&le.onExit&&le.onExit(w.withNullAsUndefined(q),void 0),this._debugServiceProxy.$acceptDAExit(m,w.withNullAsUndefined(q),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),Y.startSession()))})}$sendDAMessage(m,_){_=c.convertToDAPaths(_,!1);const D=this._debugAdaptersTrackers.get(m);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(_);const a=this._debugAdapters.get(m);a&&a.sendMessage(_)}$stopDASession(m){const _=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),_&&_.onWillStopSession&&_.onWillStopSession();const D=this._debugAdapters.get(m);return this._debugAdapters.delete(m),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const _=[],D=[],a=[];if(m.added)for(const R of m.added){const M=R.id;if(M&&!this._breakpoints.has(M)){let $;if(R.type==="function")$=new P.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")$=new P.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const Y=L.URI.revive(R.uri);$=new P.SourceBreakpoint(new P.Location(Y,new P.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}$._id=M,this._breakpoints.set(M,$),_.push($)}}if(m.removed)for(const R of m.removed){const M=this._breakpoints.get(R);M&&(this._breakpoints.delete(R),D.push(M))}if(m.changed){for(const R of m.changed)if(R.id){const M=this._breakpoints.get(R.id);if(M){if(M instanceof P.FunctionBreakpoint&&R.type==="function"){const $=M;$.enabled=R.enabled,$.condition=R.condition,$.hitCondition=R.hitCondition,$.logMessage=R.logMessage,$.functionName=R.functionName}else if(M instanceof P.SourceBreakpoint&&R.type==="source"){const $=M;$.enabled=R.enabled,$.condition=R.condition,$.hitCondition=R.hitCondition,$.logMessage=R.logMessage,$.location=new P.Location(L.URI.revive(R.uri),new P.Position(R.line,R.character))}a.push(M)}}}this.fireBreakpointChanges(_,D,a)}$provideDebugConfigurations(m,_,D){return y.asPromise(async()=>{const a=this.getConfigProviderByHandle(m);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(_);return a.provideDebugConfigurations(R,D)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(m,_,D,a){return y.asPromise(async()=>{const R=this.getConfigProviderByHandle(m);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.getFolder(_);return R.resolveDebugConfiguration(M,D,a)})}$resolveDebugConfigurationWithSubstitutedVariables(m,_,D,a){return y.asPromise(async()=>{const R=this.getConfigProviderByHandle(m);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.getFolder(_);return R.resolveDebugConfigurationWithSubstitutedVariables(M,D,a)})}async $provideDebugAdapter(m,_){const D=this.getAdapterDescriptorFactoryByHandle(m);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(_);return this.getAdapterDescriptor(D,a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(m){const _=await this.getSession(m);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(m){const _=await this.getSession(m);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,_){const D=await this.getSession(m);D&&D._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(m,_){const a={session:await this.getSession(m),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(m){if(m instanceof P.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof P.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const _=this._adapterFactories.filter(D=>D.type===m);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(m){const _=this._adapterFactories.filter(D=>D.handle===m);if(_.length>0)return _[0].factory}getConfigProviderByHandle(m){const _=this._configProviders.filter(D=>D.handle===m);if(_.length>0)return _[0].provider}definesDebugType(m,_){if(m.contributes){const D=m.contributes.debuggers;if(D&&D.length>0){for(const a of D)if(a.label&&a.type&&a.type===_)return!0}}return!1}getDebugAdapterTrackers(m){const D=m.configuration.type,a=this._trackerFactories.filter(R=>R.type===D||R.type==="*").map(R=>y.asPromise(()=>R.factory.createDebugAdapterTracker(m)).then(M=>M,M=>null));return Promise.race([Promise.all(a).then(R=>{const M=R.filter($=>!!$);if(M.length>0)return new s(M)}),new Promise((R,M)=>{const $=setTimeout(()=>{clearTimeout($),M(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(m,_){const D=_.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new P.DebugAdapterServer(D));if(m){const R=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>m.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,R))).then(M=>{if(M)return M})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,a))}daExecutableFromPackage(m,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,_,D){(m.length>0||_.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:_,changed:D}))}async getSession(m){if(m)if(typeof m=="string"){const _=this._debugSessions.get(m);if(_)return _}else{let _=this._debugSessions.get(m.id);if(!_){const D=await this.getFolder(m.folderUri),a=m.parent?this._debugSessions.get(m.parent):void 0;_=new g(this._debugServiceProxy,m.id,m.type,m.name,D,m.configuration,a),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(m){if(m){const _=L.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};d=je([$e(0,f.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,r.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,u.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class g{constructor(m,_,D,a,R,M,$){this._debugServiceProxy=m,this._id=_,this._type=D,this._name=a,this._workspaceFolder=R,this._configuration=M,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,_)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=g;class t{constructor(m){this.value=Object.freeze({append(_){m.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class i extends l.AbstractVariableResolverService{constructor(m,_,D,a,R){function M(){if(_){const $=_.activeEditor();if($)return $.document.uri;const Y=a.tabs.filter(le=>le.isActive);if(Y.length>0)return Y[0].resource}}super({getFolderUri:$=>{const Y=m.filter(le=>le.name===$);if(Y&&Y.length>0)return Y[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:($,Y)=>D.getConfiguration(void 0,$).get(Y),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=M();if($)return p.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const $=M();if($){const Y=R.getWorkspaceFolder($);if(Y)return p.normalize(Y.uri.fsPath)}}},getSelectedText:()=>{if(_){const $=_.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(_){const $=_.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=i;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(_=>_.onError?_.onError(m):void 0)}onExit(m,_){this.trackers.forEach(D=>D.onExit?D.onExit(m,_):void 0)}}class n extends S.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends d{constructor(m,_,D,a,R,M){super(m,_,D,a,R,M)}createVariableResolver(m,_,D){return new i(m,_,D,this._editorTabs)}};o=je([$e(0,f.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,r.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(ge[256],pe([0,1,65,2,5,36,35,26,13,27,4,40,37,12]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,d,g,t,i,s,n){this._apiFactory=u,this._extensionRegistry=d,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,d,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,d,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let d of u.nodeModuleName)this._factories.set(d,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(d=>u.alternativeModuleName(d))}};c=je([$e(2,r.IInstantiationService),$e(3,y.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,C.IExtHostInitDataService),$e(6,h.ILogService)],c),e.RequireInterceptor=c;class f{constructor(u,d,g,t,i){this._apiFactory=u,this._extensionPaths=d,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,d){const g=this._extensionPaths.findSubstr(d.fsPath);if(g){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(u,d){this.nodeModuleName="keytar";const{environment:g}=d,t=u.getProxy(k.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;l.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,n)=>t.$setPassword(i,s,n),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(u,d){return this._impl}alternativeModuleName(u){const d=u.length;if(d<=7||!this.alternativeNames)return;const g=d-7;if((u.charAt(g)==="/"||u.charAt(g)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};E=je([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],E);let w=class{constructor(u,d,g){this._extensionPaths=u,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(k.MainContext.MainThreadTelemetry);const t=g.getProxy(k.MainContext.MainThreadWindow);this._impl=(i,s)=>{const n=L.URI.parse(i);return s?this.callOriginal(i,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,i,{}):this.callOriginal(i,s)}}load(u,d,g){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(u),this._impl}callOriginal(u,d){return this.sendNoForwardTelemetry(),this._original(u,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=je([$e(2,S.IExtHostRpcService)],w)}),define(ge[257],pe([0,1,165,11,7,199,34,40,39,36,33,13,49,188,16,200,46]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends l.ExtHostDebugServiceBase{constructor(d,g,t,i,s,n,o){super(d,g,t,i,s,o);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(d,g){switch(d.type){case"server":return new y.SocketDebugAdapter(d);case"pipeServer":return new y.NamedPipeDebugAdapter(d);case"executable":return new y.ExecutableDebugAdapter(d,g.type)}return super.createDebugAdapter(d,g)}daExecutableFromPackage(d,g){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),d.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new h.SignService}async $runInTerminal(d,g){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const t=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=d.title||p.localize(0,null),o=JSON.stringify({shell:i,shellArgs:s});let v=await this._integratedTerminalInstances.checkout(o,n),m,_=!1;if(v)m=d.cwd;else{const M={shellPath:i,shellArgs:s,cwd:d.cwd,name:n};_=!0,v=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(v,o)}v.show(!0);const D=await v.processId;_?await new Promise(M=>setTimeout(M,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?v.sendText("cls"):i.indexOf("bash")>=0?v.sendText("clear"):L.isWindows?v.sendText("cls"):v.sendText("clear"));const a=f.prepareCommand(i,d.args,m,d.env);v.sendText(a);const R=this.onDidTerminateDebugSession(M=>{M.id===g&&(this._integratedTerminalInstances.free(v),R.dispose())});return D}else if(d.kind==="external")return f.runInExternalTerminal(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,g)}createVariableResolver(d,g,t){return new l.ExtHostVariableResolverService(d,g,t,this._editorTabs,this._workspaceService)}};w=je([$e(0,I.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,r.IExtHostTerminalService),$e(6,E.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class b{constructor(){this._terminalInstances=new Map}async checkout(d,g){const i=[...this._terminalInstances.entries()].map(([s,n])=>c.createCancelablePromise(async o=>{if(s.name!==g||n.lastUsedAt!==-1&&await f.hasChildProcesses(await s.processId))return null;const v=Date.now();return n.lastUsedAt+b.minUseDelay>v||o.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=v,s)}));return await c.firstParallel(i,s=>!!s)}insert(d,g){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:g})}free(d){const g=this._terminalInstances.get(d);g&&(g.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}b.minUseDelay=1e3}),define(ge[258],pe([0,1,9,2,110,34,49,39,36,33,13,27,64,10,12,60,46]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends l.ExtHostTaskBase{constructor(u,d,g,t,i,s,n,o,v){super(u,d,g,t,i,s,n,o);this.workspaceService=g,this.editorTabs=v,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,d){const g=d;if(!d.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const t=l.TaskHandleDTO.from(g,this.workspaceService),i=await this._proxy.$getTaskExecution(t);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(i,d);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=l.TaskDTO.from(d,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,d,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),d);return this._proxy.$executeTask(t).catch(()=>{}),i}}provideTasksInternal(u,d,g,t){const i=[];if(t)for(let s of t){this.checkDeprecation(s,g),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const n=l.TaskDTO.from(s,g.extension);n&&(i.push(n),l.CustomExecutionDTO.is(n.execution)&&d.push(this.addCustomExecution(n,s,!0)))}return{tasks:i,extension:g.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(u,this._editorService,d,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,d){const g=L.URI.revive(u),t={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(g),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!i)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(s),o={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}};for(let v of d.variables)t.variables[v]=await n.resolveAsync(o,v);if(d.process!==void 0){let v;if(d.process.path!==void 0){v=d.process.path.split(p.delimiter);for(let m=0;m<v.length;m++)v[m]=await n.resolveAsync(o,v[m])}t.process=await k.win32.findExecutable(await n.resolveAsync(o,d.process.name),d.process.cwd!==void 0?await n.resolveAsync(o,d.process.cwd):void 0,v)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,d,g){return k.win32.findExecutable(u,d,g)}};w=je([$e(0,r.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,P.IExtHostDocumentsAndEditors),$e(4,S.IExtHostConfiguration),$e(5,C.IExtHostTerminalService),$e(6,c.ILogService),$e(7,f.IExtHostApiDeprecationService),$e(8,E.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(ge[259],pe([0,1,16,14,65,6,2,5,250,12,77,79,27,181,13,59,40,33]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(d,g,t,i){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(d,null,i),g=b._transform(g,this._rpcProtocol);const s=new I.ServiceCollection(...r.getSingletonServiceDescriptors());s.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(f.IURITransformerService,new f.URITransformerService(i)),s.set(E.IHostUtils,t);const n=new h.InstantiationService(s,!0),o=n.invokeFunction(D=>D.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=n.invokeFunction(D=>D.get(C.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=n.invokeFunction(D=>D.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(D=>{Error.prepareStackTrace=(a,R)=>{let M="",$,Y;for(const le of R)M+=`
	at ${le.toString()}`,Y=le.getFileName(),!$&&Y&&($=D.findSubstr(Y));return v.set(a,$),`${a.name||"Error"}: ${a.message||""}${M}`}});const m=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),_=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(D=>{const a=L.transformErrorForSerialization(D),R=v.get(D);R?m.$onExtensionRuntimeError(R.identifier,a):_.$onUnexpectedError(a)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([p.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,g){d.extensions.forEach(i=>i.extensionLocation=A.URI.revive(g.transformIncomingURIs(i.extensionLocation))),d.environment.appRoot=A.URI.revive(g.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(i=>A.URI.revive(g.transformIncomingURIs(i)))),d.environment.extensionTestsLocationURI=A.URI.revive(g.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=A.URI.revive(g.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=A.URI.revive(g.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=A.URI.revive(g.transformIncomingURIs(d.logsLocation)),d.logFile=A.URI.revive(g.transformIncomingURIs(d.logFile)),d.workspace=g.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=b}),define(ge[260],pe([0,1,9,21,56,30,24,43,31]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(l,h,c){this.config=l,this.provider=h,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&y.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&y.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((c,f)=>{const E=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),u=p.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,u)||this.matchFile(E,{base:w,basename:u})}),Promise.all(h.map(w=>this.searchInFolder(w,E))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{f(new Error(k.toErrorMessage(w)))})})}async searchInFolder(l,h){const c=new L.CancellationTokenSource,f=this.getSearchOptionsForFolder(l),E=this.initDirectoryTree(),w=new S.QueryGlobTester(this.config,l),b=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=P.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,c.token),g=u.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(i=>{const s=p.posix.relative(l.folder.path,i.path);if(b){const n=p.basename(i.path);this.matchFile(h,{base:l.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(E,l.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,h),{providerTime:g,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const h=S.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=S.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,c,f){if(c===this.filePattern){const w=p.basename(this.filePattern);this.matchFile(f,{base:h,relativePath:this.filePattern,basename:w})}function E(w){const b=p.basename(w),u=p.dirname(w);let d=l[u];d||(d=l[u]=[],E(u)),d.push({base:h,relativePath:w,basename:b})}E(c)}matchDirectoryTree({rootEntries:l,pathToEntries:h},c,f){const E=this,w=this.filePattern;function b(u){const d=y.hasSiblingFn(()=>u.map(g=>g.basename));for(let g=0,t=u.length;g<t;g++){const i=u[g],{relativePath:s,basename:n}=i;if(!c.includedInQuerySync(s,n,w!==n?d:void 0))continue;const o=h[s];if(o)b(o);else{if(s===w)continue;E.matchFile(f,i)}if(E.isLimitHit)break}}b(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class r{constructor(){this.sessions=new Map}fileSearch(l,h,c,f){const E=this.getSessionTokenSource(l.cacheKey),w=new C(l,h,E&&E.token);let b=0;const u=d=>{b+=d.length,c(d.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(w,r.BATCH_SIZE,u,f).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:d.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new L.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,c,f){f.onCancellationRequested(()=>{l.cancel()});const E=b=>{b&&(w.push(b),h>0&&w.length>=h&&(c(w),w=[]))};let w=[];return l.search(E).then(b=>(w.length&&c(w),b),b=>(w.length&&c(w),Promise.reject(b)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(ge[128],pe([0,1,9,18,21,56,24,30,2,31,10,15]),function(X,e,p,L,k,y,A,P,S,C,r,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,d,g){this.query=u,this.provider=d,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,d){const g=this.query.folderQueries||[],t=new k.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new c(u);let n=!1;const o=(v,m)=>{if(!n&&!this.isLimitHit){const _=this.resultSize(v);E(v)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const D=this.resultSize(v);this.resultCount+=D,(D>0||!E(v))&&this.collector.add(v,m)}};Promise.all(g.map((v,m)=>this.searchInFolder(v,_=>o(_,m),t.token))).then(v=>{t.dispose(),this.collector.flush();const m=v.some(_=>!!_&&!!_.limitHit);i({limitHit:this.isLimitHit||m,messages:L.flatten(v.map(_=>(_==null?void 0:_.message)?I.isArray(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const m=y.toErrorMessage(v);s(new Error(m))})})}resultSize(u){return E(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,d){const g=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:g.slice(0,d),preview:{matches:t.slice(0,d),text:u.preview.text},uri:u.uri}}async searchInFolder(u,d,g){const t=new C.QueryGlobTester(this.query,u),i=[],s={report:v=>{if(!this.validateProviderResult(v))return;const m=u.folder.scheme===r.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(v.uri))):void 0,_=A.relativePath(u.folder,v.uri);_&&i.push(t.includedInQuery(_,p.basename(_),m).then(D=>{D&&d(v)}))}},n=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(h(this.query.contentPattern),n,s,g);return await Promise.all(i),o}validateProviderResult(u){if(E(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const d=C.resolvePatternsForProvider(this.query.includePattern,u.includePattern),g=C.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:S.URI.from(u.folder),excludes:g,includes:d,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,d=>this.sendItems(d))}add(u,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!A.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(f(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function f(b){return E(b)?{preview:{matches:L.mapArrayOrNot(b.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:b.preview.text},ranges:L.mapArrayOrNot(b.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function E(b){return!!b.preview}e.extensionResultIsMatch=E;class w{constructor(u,d){this.maxBatchSize=u,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,d){!u||this.addItemToBatch(u,d)}addItems(u,d){!u||this.addItemsToBatch(u,d)}addItemToBatch(u,d){this.batch.push(u),this.batchSize+=d,this.onUpdate()}addItemsToBatch(u,d){this.batch=this.batch.concat(u),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[66],pe([0,1,6,5,4,260,13,59,12,2,128]),function(X,e,p,L,k,y,A,P,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=k.createDecorator("IExtHostSearch");let I=class{constructor(f,E,w){this.extHostRpc=f,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,E){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(f)),p.toDisposable(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(f,E){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(f)),p.toDisposable(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(f,E,w,b){const u=l(w),d=this._fileSearchProvider.get(f);if(d)return this._fileSearchManager.fileSearch(u,d,g=>{this._proxy.$handleFileMatch(f,E,g.map(t=>t.resource))},b);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,E,w,b){const u=this._textSearchProvider.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const d=l(w);return this.createTextSearchManager(d,u).search(t=>this._proxy.$handleTextMatch(f,E,t),b)}createTextSearchManager(f,E){return new r.TextSearchManager(f,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=je([$e(0,A.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,S.ILogService)],I),e.ExtHostSearch=I;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(h),extraFileResources:c.extraFileResources&&c.extraFileResources.map(f=>C.URI.revive(f))})}e.reviveQuery=l;function h(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(ge[261],pe([0,1,21,14,3,53,2,150,106,141,76,42,5,221,220,48,222,36,223,224,225,206,226,39,40,227,207,229,230,231,61,209,236,237,238,88,33,239,210,17,7,242,62,127,34,35,67,197,228,81,126,64,49,66,12,59,13,27,232,195,47,60,218,240,194,89,87,245,243,244,219,58,253,241,86,46,118,234,63,235,10,183,233,192]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u,d,g,t,i,s,n,o,v,m,_,D,a,R,M,$,Y,le,q,U,z,O,W,T,F,N,x,G,se,be,Ie,Ce,Me,qe,He,Ve,j,Z,ne,oe,J,ce,me,Le,We,Ee,Ke,K,ie,ve,Fe,Ne,Qe,De,Se,Pe,ae,fe,H,ee,ue,Ae,Re,Ue,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Je){const Xe=Je.get(ne.IExtHostInitDataService),nt=Je.get(Qe.IExtHostFileSystemInfo),gt=Je.get(K.IExtHostConsumerFileSystem),_e=Je.get(s.IExtHostExtensionService),ye=Je.get(N.IExtHostWorkspace),de=Je.get(fe.IExtHostTelemetry),Q=Je.get(w.IExtHostConfiguration),xe=Je.get(j.IURITransformerService),we=Je.get(Z.IExtHostRpcService),Ye=Je.get(Y.IExtHostStorage),et=Je.get(Ke.IExtensionStoragePaths),rt=Je.get(Ve.ILogService),st=Je.get(ce.IExtHostTunnelService),pt=Je.get(me.IExtHostApiDeprecationService),wt=Je.get(F.IExtHostWindow),Et=Je.get(Pe.IExtHostSecretState),vt=Je.get(ae.IExtHostEditorTabs);we.set(l.ExtHostContext.ExtHostFileSystemInfo,nt),we.set(l.ExtHostContext.ExtHostLogService,rt),we.set(l.ExtHostContext.ExtHostWorkspace,ye),we.set(l.ExtHostContext.ExtHostConfiguration,Q),we.set(l.ExtHostContext.ExtHostExtensionService,_e),we.set(l.ExtHostContext.ExtHostStorage,Ye),we.set(l.ExtHostContext.ExtHostTunnelService,st),we.set(l.ExtHostContext.ExtHostWindow,wt),we.set(l.ExtHostContext.ExtHostSecretState,Et),we.set(l.ExtHostContext.ExtHostTelemetry,de),we.set(l.ExtHostContext.ExtHostEditorTabs,vt);const xt=we.set(l.ExtHostContext.ExtHostDecorations,Je.get(Ce.IExtHostDecorations)),_t=we.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Je.get(i.IExtHostDocumentsAndEditors)),ht=we.set(l.ExtHostContext.ExtHostCommands,Je.get(f.IExtHostCommands)),ct=we.set(l.ExtHostContext.ExtHostTerminalService,Je.get(le.IExtHostTerminalService)),dt=we.set(l.ExtHostContext.ExtHostDebugService,Je.get(qe.IExtHostDebugService)),Ht=we.set(l.ExtHostContext.ExtHostSearch,Je.get(He.IExtHostSearch)),kt=we.set(l.ExtHostContext.ExtHostTask,Je.get(Me.IExtHostTask)),At=we.set(l.ExtHostContext.ExtHostOutputService,Je.get(D.IExtHostOutputService)),Kt=we.set(l.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(we)),St=we.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(we,_t)),en=we.set(l.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(we,_t,rt)),tn=we.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(rt,St,we.getProxy(l.MainContext.MainThreadBulkEdits))),mt=we.set(l.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(we,ht,_t,St,et)),Qt=we.set(l.ExtHostContext.ExtHostNotebookDocuments,new ze.ExtHostNotebookDocuments(rt,mt)),zt=we.set(l.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(rt,we,mt)),nn=we.set(l.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(we,Xe,mt,rt)),yn=we.set(l.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(we,mt)),Dt=we.set(l.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(we,_t)),Xt=we.set(l.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(we.getProxy(l.MainContext.MainThreadTreeViews),ht,rt)),rn=we.set(l.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(we.getProxy(l.MainContext.MainThreadEditorInsets),Dt,Xe)),Bt=we.set(l.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(we,rt)),ut=we.set(l.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(we,xe,St,ht,Bt,rt,pt)),sn=we.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(we,ut)),Tt=we.set(l.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(we,rt,_t)),Vt=we.set(l.ExtHostContext.ExtHostQuickOpen,R.createExtHostQuickOpen(we,ye,ht)),fn=we.set(l.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(we,ht,rt)),Dn=we.set(l.ExtHostContext.ExtHostComments,new E.ExtHostComments(we,ht,St)),mn=we.set(l.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(we.getProxy(l.MainContext.MainThreadProgress))),Cn=we.set(l.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(we)),Yt=we.set(l.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(we)),Ft=we.set(l.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(we)),kn=we.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(we,ht)),on=we.set(l.ExtHostContext.ExtHostWebviews,new T.ExtHostWebviews(we,{remote:Xe.remote},ye,rt,pt)),an=we.set(l.ExtHostContext.ExtHostWebviewPanels,new Fe.ExtHostWebviewPanels(we,on,ye)),Pn=we.set(l.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(we,St,et,on,an)),Jt=we.set(l.ExtHostContext.ExtHostWebviewViews,new ie.ExtHostWebviewViews(we,on)),Ot=we.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(we,_t,ye)),In=we.set(l.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(we)),ln=G.values(l.ExtHostContext);we.assertRegistered(ln);const An=new Ne.ExtHostBulkEdits(we,_t),jt=new c.ExtHostClipboard(we),Rt=new _.ExtHostMessageService(we,rt),gn=new u.ExtHostDialogs(we),It=new $.ExtHostStatusBar(we,ht.converter),$t=new m.ExtHostLanguages(we,St);return h.ExtHostApiCommands.register(ht),function(Oe,cn,pn){const ft=function(){let te=!Oe.isUnderDevelopment;function he(Te){te||(rt.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(ot){if(Array.isArray(ot))ot.forEach(Te);else if(typeof ot=="string")he(ot);else{const bt=ot;typeof bt.scheme=="undefined"&&he(ot),!Oe.enableProposedApi&&typeof bt.exclusive=="boolean"&&x.throwProposedApiError(Oe)}return ot}}(),Tn={getSession(te,he,Te){return Ft.getSession(Oe,te,he,Te)},get onDidChangeSessions(){return Ft.onDidChangeSessions},registerAuthenticationProvider(te,he,Te,ot){return Ft.registerAuthenticationProvider(te,he,Te,ot)},get onDidChangeAuthenticationProviders(){return x.checkProposedApiEnabled(Oe),Ft.onDidChangeAuthenticationProviders},get providers(){return x.checkProposedApiEnabled(Oe),Ft.providers},logout(te,he){return x.checkProposedApiEnabled(Oe),Ft.removeSession(te,he)}},Rn={registerCommand(te,he,Te){return ht.registerCommand(!0,te,he,Te)},registerTextEditorCommand(te,he,Te){return ht.registerCommand(!0,te,(...ot)=>{const bt=Dt.getActiveTextEditor();if(!bt){rt.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(Ct=>{he.apply(Te,[bt,Ct,...ot])}).then(Ct=>{Ct||rt.warn("Edits from command "+te+" were not applied.")},Ct=>{rt.warn("An error occurred while running command "+te,Ct)})})},registerDiffInformationCommand:(te,he,Te)=>(x.checkProposedApiEnabled(Oe),ht.registerCommand(!0,te,async(...ot)=>{const bt=_t.activeEditor(!0);if(!bt){rt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);he.apply(Te,[Ct,...ot])})),executeCommand(te,...he){return ht.executeCommand(te,...he)},getCommands(te=!1){return ht.getCommands(te)}},vn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){var te,he;return(he=(te=Xe.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return jt.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return de.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return de.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return wt.openUri(te,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Xe.environment.appUriScheme)return Kt.createAppUri(te);const he=Re.matchesScheme(te,Ae.Schemas.http)||Re.matchesScheme(te,Ae.Schemas.https);he||x.checkProposedApiEnabled(Oe);try{return await wt.asExternalUri(te,{allowTunneling:!!Xe.remote.authority})}catch(Te){if(he)return te;throw Te}},get remoteName(){return Ie.getRemoteName(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(vn);const Zt=Xe.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,un={registerTestController(te){return x.checkProposedApiEnabled(Oe),Ot.registerTestController(Oe.identifier.value,te)},createDocumentTestObserver(te){return x.checkProposedApiEnabled(Oe),Ot.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return x.checkProposedApiEnabled(Oe),Ot.createWorkspaceTestObserver(te)},runTests(te){return x.checkProposedApiEnabled(Oe),Ot.runTests(te)},createTestItem(te,he){return new O.TestItemImpl(te.id,te.label,te.uri,he)},createTestRun(te,he,Te){return x.checkProposedApiEnabled(Oe),Ot.createTestRun(te,he,Te)},get onDidChangeTestResults(){return x.checkProposedApiEnabled(Oe),Ot.onResultsChanged},get testResults(){return x.checkProposedApiEnabled(Oe),Ot.results}};un.createTestRunTask=un.createTestRun;const Ln={getExtension(te){const he=cn.getExtensionDescription(te);if(he)return new s.Extension(_e,Oe.identifier,he,Zt)},get all(){return cn.getAllExtensionDescriptions().map(te=>new s.Extension(_e,Oe.identifier,te,Zt))},get onDidChange(){return cn.onDidChange}},Fn={createDiagnosticCollection(te){return Bt.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:te=>Bt.getDiagnostics(te),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(te,he){return $t.changeLanguage(te.uri,he)},match(te,he){return r.score(z.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Te){return ut.registerCodeActionProvider(Oe,ft(te),he,Te)},registerCodeLensProvider(te,he){return ut.registerCodeLensProvider(Oe,ft(te),he)},registerDefinitionProvider(te,he){return ut.registerDefinitionProvider(Oe,ft(te),he)},registerDeclarationProvider(te,he){return ut.registerDeclarationProvider(Oe,ft(te),he)},registerImplementationProvider(te,he){return ut.registerImplementationProvider(Oe,ft(te),he)},registerTypeDefinitionProvider(te,he){return ut.registerTypeDefinitionProvider(Oe,ft(te),he)},registerHoverProvider(te,he){return ut.registerHoverProvider(Oe,ft(te),he,Oe.identifier)},registerEvaluatableExpressionProvider(te,he){return ut.registerEvaluatableExpressionProvider(Oe,ft(te),he,Oe.identifier)},registerInlineValuesProvider(te,he){return ut.registerInlineValuesProvider(Oe,ft(te),he,Oe.identifier)},registerDocumentHighlightProvider(te,he){return ut.registerDocumentHighlightProvider(Oe,ft(te),he)},registerLinkedEditingRangeProvider(te,he){return ut.registerLinkedEditingRangeProvider(Oe,ft(te),he)},registerReferenceProvider(te,he){return ut.registerReferenceProvider(Oe,ft(te),he)},registerRenameProvider(te,he){return ut.registerRenameProvider(Oe,ft(te),he)},registerDocumentSymbolProvider(te,he,Te){return ut.registerDocumentSymbolProvider(Oe,ft(te),he,Te)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,he){return ut.registerDocumentFormattingEditProvider(Oe,ft(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return ut.registerDocumentRangeFormattingEditProvider(Oe,ft(te),he)},registerOnTypeFormattingEditProvider(te,he,Te,...ot){return ut.registerOnTypeFormattingEditProvider(Oe,ft(te),he,[Te].concat(ot))},registerDocumentSemanticTokensProvider(te,he,Te){return ut.registerDocumentSemanticTokensProvider(Oe,ft(te),he,Te)},registerDocumentRangeSemanticTokensProvider(te,he,Te){return ut.registerDocumentRangeSemanticTokensProvider(Oe,ft(te),he,Te)},registerSignatureHelpProvider(te,he,Te,...ot){return typeof Te=="object"?ut.registerSignatureHelpProvider(Oe,ft(te),he,Te):ut.registerSignatureHelpProvider(Oe,ft(te),he,typeof Te=="undefined"?[]:[Te,...ot])},registerCompletionItemProvider(te,he,...Te){return ut.registerCompletionItemProvider(Oe,ft(te),he,Te)},registerInlineCompletionItemProvider(te,he){return x.checkProposedApiEnabled(Oe),ut.registerInlineCompletionsProvider(Oe,ft(te),he)},registerDocumentLinkProvider(te,he){return ut.registerDocumentLinkProvider(Oe,ft(te),he)},registerColorProvider(te,he){return ut.registerColorProvider(Oe,ft(te),he)},registerFoldingRangeProvider(te,he){return ut.registerFoldingRangeProvider(Oe,ft(te),he)},registerSelectionRangeProvider(te,he){return ut.registerSelectionRangeProvider(Oe,te,he)},registerCallHierarchyProvider(te,he){return ut.registerCallHierarchyProvider(Oe,te,he)},setLanguageConfiguration:(te,he)=>ut.setLanguageConfiguration(Oe,te,he),getTokenInformationAtPosition(te,he){return x.checkProposedApiEnabled(Oe),$t.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return x.checkProposedApiEnabled(Oe),ut.registerInlayHintsProvider(Oe,te,he)}},Mn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(te,he,Te){const ot=await(A.URI.isUri(te)?Promise.resolve(wn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(ot,he,Te)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,he,Te){return Dt.onDidChangeActiveTextEditor(te,he,Te)},onDidChangeVisibleTextEditors(te,he,Te){return Dt.onDidChangeVisibleTextEditors(te,he,Te)},onDidChangeTextEditorSelection(te,he,Te){return Dt.onDidChangeTextEditorSelection(te,he,Te)},onDidChangeTextEditorOptions(te,he,Te){return Dt.onDidChangeTextEditorOptions(te,he,Te)},onDidChangeTextEditorVisibleRanges(te,he,Te){return Dt.onDidChangeTextEditorVisibleRanges(te,he,Te)},onDidChangeTextEditorViewColumn(te,he,Te){return Dt.onDidChangeTextEditorViewColumn(te,he,Te)},onDidCloseTerminal(te,he,Te){return ct.onDidCloseTerminal(te,he,Te)},onDidOpenTerminal(te,he,Te){return ct.onDidOpenTerminal(te,he,Te)},onDidChangeActiveTerminal(te,he,Te){return ct.onDidChangeActiveTerminal(te,he,Te)},onDidChangeTerminalDimensions(te,he,Te){return x.checkProposedApiEnabled(Oe),ct.onDidChangeTerminalDimensions(te,he,Te)},onDidWriteTerminalData(te,he,Te){return x.checkProposedApiEnabled(Oe),ct.onDidWriteTerminalData(te,he,Te)},get state(){return wt.state},onDidChangeWindowState(te,he,Te){return wt.onDidChangeWindowState(te,he,Te)},showInformationMessage(te,...he){return Rt.showMessage(Oe,y.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Rt.showMessage(Oe,y.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Rt.showMessage(Oe,y.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Te){return Vt.showQuickPick(te,!!Oe.enableProposedApi,he,Te)},showWorkspaceFolderPick(te){return Vt.showWorkspaceFolderPick(te)},showInputBox(te,he){return Vt.showInput(te,he)},showOpenDialog(te){return gn.showOpenDialog(te)},showSaveDialog(te){return gn.showSaveDialog(te)},createStatusBarItem(te,he,Te){let ot,bt,Ct;return typeof te=="string"?(ot=te,bt=he,Ct=Te):(bt=te,Ct=he),It.createStatusBarEntry(Oe,ot,bt,Ct)},setStatusBarMessage(te,he){return It.setStatusBarMessage(te,he)},withScmProgress(te){return pt.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),mn.withProgress(Oe,{location:O.ProgressLocation.SourceControl},(he,Te)=>te({report(ot){}}))},withProgress(te,he){return mn.withProgress(Oe,te,he)},createOutputChannel(te){return At.createOutputChannel(te)},createWebviewPanel(te,he,Te,ot){return an.createWebviewPanel(Oe,te,he,Te,ot)},createWebviewTextEditorInset(te,he,Te,ot){return x.checkProposedApiEnabled(Oe),rn.createWebviewEditorInset(te,he,Te,ot,Oe)},createTerminal(te,he,Te){return typeof te=="object"?"pty"in te?ct.createExtensionTerminal(te):ct.createTerminalFromOptions(te):ct.createTerminal(te,he,Te)},registerTerminalLinkProvider(te){return ct.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return ct.registerProfileProvider(Oe,te,he)},registerTreeDataProvider(te,he){return Xt.registerTreeDataProvider(te,he,Oe)},createTreeView(te,he){return Xt.createTreeView(te,he,Oe)},registerWebviewPanelSerializer:(te,he)=>an.registerWebviewPanelSerializer(Oe,te,he),registerCustomEditorProvider:(te,he,Te={})=>Pn.registerCustomEditorProvider(Oe,te,he,Te),registerFileDecorationProvider(te){return xt.registerFileDecorationProvider(te,Oe.identifier)},registerUriHandler(te){return Kt.registerUriHandler(Oe.identifier,te)},createQuickPick(){return Vt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Oe.identifier)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(te,he,Te){return Yt.onDidChangeActiveColorTheme(te,he,Te)},registerWebviewViewProvider(te,he,Te){return Jt.registerWebviewViewProvider(Oe,te,he,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return x.checkProposedApiEnabled(Oe),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Te){return x.checkProposedApiEnabled(Oe),mt.onDidChangeActiveNotebookEditor(te,he,Te)},get visibleNotebookEditors(){return x.checkProposedApiEnabled(Oe),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return x.checkProposedApiEnabled(Oe),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Te){return x.checkProposedApiEnabled(Oe),zt.onDidChangeNotebookEditorSelection(te,he,Te)},onDidChangeNotebookEditorVisibleRanges(te,he,Te){return x.checkProposedApiEnabled(Oe),zt.onDidChangeNotebookEditorVisibleRanges(te,he,Te)},showNotebookDocument(te,he){return x.checkProposedApiEnabled(Oe),mt.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Te){return x.checkProposedApiEnabled(Oe),In.registerExternalUriOpener(Oe.identifier,te,he,Te)},get openEditors(){return x.checkProposedApiEnabled(Oe),vt.tabs},get onDidChangeOpenEditors(){return x.checkProposedApiEnabled(Oe),vt.onDidChangeTabs},getInlineCompletionItemController(te){return x.checkProposedApiEnabled(Oe),v.InlineCompletionController.get(te)}},wn={get rootPath(){return pt.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ye.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return ye.getWorkspaceFolder(te)},get workspaceFolders(){return ye.getWorkspaceFolders()},get name(){return ye.name},set name(te){throw L.readonly()},get workspaceFile(){return ye.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,he,...Te)=>ye.updateWorkspaceFolders(Oe,te,he||0,...Te),onDidChangeWorkspaceFolders:function(te,he,Te){return ye.onDidChangeWorkspace(te,he,Te)},asRelativePath:(te,he)=>ye.getRelativePath(te,he),findFiles:(te,he,Te,ot)=>ye.findFiles(z.GlobPattern.from(te),z.GlobPattern.from(he),Te,Oe.identifier,ot),findTextInFiles:(te,he,Te,ot)=>{let bt,Ct;return typeof he=="object"?(bt=he,Ct=Te):(bt={},Ct=he,ot=Te),ye.findTextInFiles(te,bt||{},Ct,Oe.identifier,ot)},saveAll:te=>ye.saveAll(te),applyEdit(te){return An.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Te,ot)=>Tt.createFileSystemWatcher(z.GlobPattern.from(te),he,Te,ot),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let he;const Te=te;if(typeof te=="string")he=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))he=Promise.resolve(te);else if(!Te||typeof Te=="object")he=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ot=>St.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(te,he,Te)=>St.onDidAddDocument(te,he,Te),onDidCloseTextDocument:(te,he,Te)=>St.onDidRemoveDocument(te,he,Te),onDidChangeTextDocument:(te,he,Te)=>St.onDidChangeDocument(te,he,Te),onDidSaveTextDocument:(te,he,Te)=>St.onDidSaveDocument(te,he,Te),onWillSaveTextDocument:(te,he,Te)=>tn.getOnWillSaveTextDocumentEvent(Oe)(te,he,Te),get notebookDocuments(){return mt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Te;if(A.URI.isUri(te))Te=te,await mt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await mt.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Te,ot){return mt.registerNotebookSerializer(Oe,te,he,Te,Oe.enableProposedApi?ot:void 0)},registerNotebookContentProvider:(te,he,Te,ot)=>(x.checkProposedApiEnabled(Oe),mt.registerNotebookContentProvider(Oe,te,he,Te,Oe.enableProposedApi?ot:void 0)),onDidChangeConfiguration:(te,he,Te)=>pn.onDidChangeConfiguration(te,he,Te),getConfiguration(te,he){return he=arguments.length===1?void 0:he,pn.getConfiguration(te,he,Oe)},registerTextDocumentContentProvider(te,he){return en.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(pt.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Oe,te,he)),registerFileSystemProvider(te,he,Te){return sn.registerFileSystemProvider(Oe.identifier,te,he,Te,Oe.enableProposedApi)},get fs(){return gt.value},registerFileSearchProvider:(te,he)=>(x.checkProposedApiEnabled(Oe),Ht.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>(x.checkProposedApiEnabled(Oe),Ht.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>(x.checkProposedApiEnabled(Oe),_e.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>(x.checkProposedApiEnabled(Oe),Cn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Te)=>Tt.onDidCreateFile(te,he,Te),onDidDeleteFiles:(te,he,Te)=>Tt.onDidDeleteFile(te,he,Te),onDidRenameFiles:(te,he,Te)=>Tt.onDidRenameFile(te,he,Te),onWillCreateFiles:(te,he,Te)=>Tt.getOnWillCreateFileEvent(Oe)(te,he,Te),onWillDeleteFiles:(te,he,Te)=>Tt.getOnWillDeleteFileEvent(Oe)(te,he,Te),onWillRenameFiles:(te,he,Te)=>Tt.getOnWillRenameFileEvent(Oe)(te,he,Te),openTunnel:te=>(x.checkProposedApiEnabled(Oe),st.openTunnel(Oe,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return x.checkProposedApiEnabled(Oe),st.getTunnels()},onDidChangeTunnels:(te,he,Te)=>(x.checkProposedApiEnabled(Oe),st.onDidChangeTunnels(te,he,Te)),registerPortAttributesProvider:(te,he)=>(x.checkProposedApiEnabled(Oe),st.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>(x.checkProposedApiEnabled(Oe),kn.registerTimelineProvider(te,he,Oe.identifier,ht.converter)),get isTrusted(){return ye.trusted},requestWorkspaceTrust:te=>(x.checkProposedApiEnabled(Oe),ye.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Te)=>ye.onDidGrantWorkspaceTrust(te,he,Te)},On={get inputBox(){return pt.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),fn.getLastInputBox(Oe)},createSourceControl(te,he,Te){return fn.createSourceControl(Oe,te,he,Te)}},bn={createCommentController(te,he){return Dn.createCommentController(Oe,te,he)}},En={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(te,he,Te){return dt.onDidStartDebugSession(te,he,Te)},onDidTerminateDebugSession(te,he,Te){return dt.onDidTerminateDebugSession(te,he,Te)},onDidChangeActiveDebugSession(te,he,Te){return dt.onDidChangeActiveDebugSession(te,he,Te)},onDidReceiveDebugSessionCustomEvent(te,he,Te){return dt.onDidReceiveDebugSessionCustomEvent(te,he,Te)},onDidChangeBreakpoints(te,he,Te){return dt.onDidChangeBreakpoints(te,he,Te)},registerDebugConfigurationProvider(te,he,Te){return dt.registerDebugConfigurationProvider(te,he,Te||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return dt.registerDebugAdapterDescriptorFactory(Oe,te,he)},registerDebugAdapterTrackerFactory(te,he){return dt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?dt.startDebugging(te,he,{parentSession:Te}):dt.startDebugging(te,he,Te||{})},stopDebugging(te){return dt.stopDebugging(te)},addBreakpoints(te){return dt.addBreakpoints(te)},removeBreakpoints(te){return dt.removeBreakpoints(te)},asDebugSourceUri(te,he){return dt.asDebugSourceUri(te,he)}},Wt={registerTaskProvider:(te,he)=>kt.registerTaskProvider(Oe,te,he),fetchTasks:te=>kt.fetchTasks(te),executeTask:te=>kt.executeTask(Oe,te),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(te,he,Te)=>kt.onDidStartTask(te,he,Te),onDidEndTask:(te,he,Te)=>kt.onDidEndTask(te,he,Te),onDidStartTaskProcess:(te,he,Te)=>kt.onDidStartTaskProcess(te,he,Te),onDidEndTaskProcess:(te,he,Te)=>kt.onDidEndTaskProcess(te,he,Te)},qt={createNotebookController(te,he,Te,ot,bt){return nn.createNotebookController(Oe,te,he,Te,ot,Oe.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>mt.registerNotebookCellStatusBarItemProvider(Oe,te,he),get onDidSaveNotebookDocument(){return x.checkProposedApiEnabled(Oe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return x.checkProposedApiEnabled(Oe),zt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return x.checkProposedApiEnabled(Oe),yn.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,he,Te){return x.checkProposedApiEnabled(Oe),Qt.onDidChangeNotebookDocumentMetadata(te,he,Te)},onDidChangeNotebookCells(te,he,Te){return x.checkProposedApiEnabled(Oe),mt.onDidChangeNotebookCells(te,he,Te)},onDidChangeNotebookCellExecutionState(te,he,Te){return x.checkProposedApiEnabled(Oe),mt.onDidChangeNotebookCellExecutionState(te,he,Te)},onDidChangeCellOutputs(te,he,Te){return x.checkProposedApiEnabled(Oe),mt.onDidChangeCellOutputs(te,he,Te)},onDidChangeCellMetadata(te,he,Te){return x.checkProposedApiEnabled(Oe),mt.onDidChangeCellMetadata(te,he,Te)},createConcatTextDocument(te,he){return x.checkProposedApiEnabled(Oe),new Ee.ExtHostNotebookConcatDocument(mt,St,te,he)}};return{version:Xe.version,authentication:Tn,commands:Rn,comments:bn,debug:En,env:vn,extensions:Ln,languages:Fn,notebooks:qt,scm:On,tasks:Wt,test:un,window:Mn,workspace:wn,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionList:O.InlineSuggestions,Hover:O.Hover,IndentAction:C.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestItemStatus:O.TestItemStatus,TestResultState:O.TestResultState,TestMessage:O.TestMessage,TextSearchCompleteMessageType:ee.TextSearchCompleteMessageType,TestMessageSeverity:O.TestMessageSeverity,WorkspaceTrustState:O.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ze}),define(ge[262],pe([0,1,77,61,34,126,36,48,39,33,64,49,66,89,88,47,60,127,87,58,86,118,46]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b,u,d,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),p.registerSingleton(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),p.registerSingleton(P.IExtHostCommands,P.ExtHostCommands),p.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),p.registerSingleton(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),p.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),p.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),p.registerSingleton(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),p.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),p.registerSingleton(L.IExtHostOutputService,L.ExtHostOutputService),p.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),p.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),p.registerSingleton(r.IExtHostTask,r.WorkerExtHostTask),p.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),p.registerSingleton(f.IExtHostTunnelService,f.ExtHostTunnelService),p.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),p.registerSingleton(k.IExtHostWorkspace,k.ExtHostWorkspace),p.registerSingleton(d.IExtHostSecretState,d.ExtHostSecretState),p.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),p.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[90],pe([0,1,18,12,31,63]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function P(I,l,h,c){const f=p.mapArrayOrNot(h,S),E=new k.TextSearchMatch(l,f,c),w=E.preview.matches;return{ranges:p.mapArrayOrNot(f,C),uri:I,preview:{text:E.preview.text,matches:p.mapArrayOrNot(w,C)}}}e.createTextSearchResult=P;function S(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function C(I){return new y.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let r=class{constructor(l,h){this.prefix=l,this.logService=h}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};r=je([$e(1,L.ILogService)],r),e.OutputChannel=r}),define(ge[263],pe([0,1,92,22]),function(X,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,P=512*8,S=512*128;class C{constructor(i){this.iconvLiteDecoder=i}static async create(i){let s;if(i!==e.UTF8)s=(await new Promise((o,v)=>{X(["iconv-lite-umd"],o,v)})).getDecoder(h(i));else{const n=new TextDecoder;s={write(o){return n.decode(o,{stream:!0})},end(){return n.decode()}}}return new C(s)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function r(t,i){var s;const n=((s=i.minBytesRequiredForDetection)!==null&&s!==void 0?s:i.guessEncoding)?P:A;return new Promise((o,v)=>{const m=p.newWriteableStream(M=>M.join("")),_=[];let D=0,a;const R=async()=>{try{const M=await g({buffer:L.VSBuffer.concat(_),bytesRead:D},i.guessEncoding);M.encoding=await i.overwriteEncoding(M.encoding),a=await C.create(M.encoding);const $=a.write(L.VSBuffer.concat(_).buffer);m.write($),_.length=0,D=0,o({stream:m,detected:M})}catch(M){v(M)}};p.listenStream(t,{onData:async M=>{a?m.write(a.write(M.buffer)):(_.push(M),D+=M.byteLength,D>=n&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:M=>m.error(M),onEnd:async()=>{a||await R(),m.end(a==null?void 0:a.end())}})})}e.toDecodeStream=r;async function I(t,i,s){const o=(await new Promise((_,D)=>{X(["iconv-lite-umd"],_,D)})).getEncoder(h(i),s);let v=!1,m=!1;return{read(){if(m)return null;const _=t.read();if(typeof _!="string"){if(m=!0,!v&&(s==null?void 0:s.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=o.end();return D&&D.length>0?(v=!0,L.VSBuffer.wrap(D)):null}return v=!0,L.VSBuffer.wrap(o.write(_))}}}e.toEncodeReadable=I;async function l(t){return(await new Promise((s,n)=>{X(["iconv-lite-umd"],s,n)})).encodingExists(h(t))}e.encodingExists=l;function h(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=h;function c(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const f=["ascii","utf-16","utf-32"];async function E(t){const i=await new Promise((m,_)=>{X(["jschardet"],m,_)}),s=t.slice(0,S),n=u(s.buffer),o=i.detect(n);if(!o||!o.encoding)return null;const v=o.encoding.toLowerCase();return 0<=f.indexOf(v)?null:b(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[i]||i}function u(t){let i="";for(let s=0;s<t.length;s++)i+=String.fromCharCode(t[s]);return i}function d(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=d;function g({buffer:t,bytesRead:i},s){let n=c(t,i),o=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let v=!0,m=!0,_=!1;for(let D=0;D<i&&D<y;D++){const a=D%2==1,R=t.readUInt8(D)===0;if(R&&(_=!0),v&&(a&&!R||!a&&R)&&(v=!1),m&&(a&&R||!a&&!R)&&(m=!1),R&&!v&&!m)break}_&&(v?n=e.UTF16le:m?n=e.UTF16be:o=!0)}return s&&!o&&!n&&t?E(t.slice(0,i)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:o,encoding:n}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[129],pe([0,1,263,28,128]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends k.TextSearchManager{constructor(P,S,C=L){super(P,S,{readdir:r=>C.Promises.readdir(r.fsPath),toCanonicalName:r=>p.toCanonicalName(r)})}}e.NativeTextSearchManager=y}),define(ge[264],pe([0,1,265,279,280,2,281]),function(X,e,p,L,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(I,l,h,c,f,E){const w=E.environment.useHostProxy,b=typeof w=="boolean"?w:!E.remote.isRemote,u=A.createProxyResolver({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,t,...i)=>{switch(g){case A.LogLevel.Trace:c.trace(t,...i);break;case A.LogLevel.Debug:c.debug(t,...i);break;case A.LogLevel.Info:c.info(t,...i);break;case A.LogLevel.Warning:c.warn(t,...i);break;case A.LogLevel.Error:c.error(t,...i);break;case A.LogLevel.Critical:c.critical(t,...i);break;case A.LogLevel.Off:break;default:s(g,t,i);break}function s(n,o,...v){c.error("Unknown log level",n),c.error(o,...v)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:g=>{f.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),d=S(l,u);return r(h,d)}e.connectProxyResolver=P;function S(I,l){const h={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(f=>{h.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(f=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,A.createHttpPatch(p,l,{config:"off"},c,!0)),on:Object.assign({},p,A.createHttpPatch(p,l,{config:"on"},c,!0)),override:Object.assign({},p,A.createHttpPatch(p,l,{config:"override"},c,!0)),onRequest:Object.assign({},p,A.createHttpPatch(p,l,h,c,!0)),default:Object.assign(p,A.createHttpPatch(p,l,h,c,!1))},https:{off:Object.assign({},L,A.createHttpPatch(L,l,{config:"off"},c,!0)),on:Object.assign({},L,A.createHttpPatch(L,l,{config:"on"},c,!0)),override:Object.assign({},L,A.createHttpPatch(L,l,{config:"override"},c,!0)),onRequest:Object.assign({},L,A.createHttpPatch(L,l,h,c,!0)),default:Object.assign(L,A.createHttpPatch(L,l,h,c,!1))},tls:Object.assign(k,A.createTlsPatch(k))}}const C=new Map;function r(I,l){return I.getExtensionPathIndex().then(h=>{const c=X.__$__nodeRequire("module"),f=c._load;c._load=function(w,b,u){if(w==="tls")return l.tls;if(w!=="http"&&w!=="https")return f.apply(this,arguments);const d=l[w],g=h.findSubstr(y.URI.file(b.filename).fsPath);let t=C.get(g);if(t||C.set(g,t={}),!t[w]){let i=d.default;g&&g.enableProposedApi&&(i=d[g.proxySupport]||d.onRequest),t[w]=Object.assign({},i)}return t[w]}})}}),define(ge[266],pe([0,1,38,9,74,29,11,8,90,267]),function(X,e,p,L,k,y,A,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(u,d,g,t){const i=l(u,d,g,t),s=d.folder.fsPath;return{cmd:p.spawn(r,i.args,{cwd:s}),rgDiskPath:r,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.spawnRipgrepCmd=I;function l(u,d,g,t){const i=["--files","--hidden","--case-sensitive"];c([d],g,!1).forEach(n=>{const o=S.anchorGlob(n);if(i.push("-g",o),A.isMacintosh){const v=k.normalizeNFD(o);v!==o&&i.push("-g",v)}});const s=h([d],t,void 0,!1);return s.globArgs.forEach(n=>{const o=`!${S.anchorGlob(n)}`;if(i.push("-g",o),A.isMacintosh){const v=k.normalizeNFD(o);v!==o&&i.push("-g",v)}}),d.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),d.ignoreSymlinks||i.push("--follow"),u.exists&&i.push("--quiet"),i.push("--no-config"),d.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function h(u,d,g,t=!0){const i=[];let s={};return u.forEach(n=>{const o=Object.assign({},n.excludePattern||{},d||{}),v=f(o,t?n.folder.fsPath:void 0,g);i.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:i,siblingClauses:s}}e.foldersToRgExcludeGlobs=h;function c(u,d,g=!0){const t=[];return u.forEach(i=>{const s=Object.assign({},d||{},i.includePattern||{}),n=f(s,g?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function f(u,d,g){const t=[],i={};return Object.keys(u).forEach(s=>{if(g&&g.has(s)||!s)return;const n=u[s];s=w(d?E(d,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(b(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function E(u,d){return L.isAbsolute(d)?d:L.join(u,d)}e.getAbsoluteGlob=E;function w(u){return u=P.rtrim(u,"\\"),P.rtrim(u,"/")}function b(u){return y.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=b}),define(ge[268],pe([0,1,38,55,9,100,18,56,30,74,29,11,43,8,15,28,31,266,97]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class d{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=b.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(o=>{const v=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;n.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==m).forEach(_=>{r.isEqualOrParent(_,m)&&(v[k.relative(m,_)]=!0)}),this.folderExcludePatterns.set(m,new t(v,m))})}cancel(){this.isCanceled=!0}walk(n,o,v,m,_){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);o.forEach(D=>{const a=k.basename(D.fsPath);this.globalExcludePattern&&this.globalExcludePattern(D.fsPath,a)||this.matchFile(v,{relativePath:D.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(D,a)=>{this.call(this.cmdTraversal,this,D,v,m,R=>{if(R){const M=P.toErrorMessage(R);console.error(M),this.errors.push(M),a(R,void 0)}else a(null,void 0)})},(D,a)=>{this.fileWalkSW.stop();const R=D?A.coalesce(D)[0]:null;_(R,this.isLimitHit)})}parallel(n,o,v){const m=new Array(n.length),_=new Array(n.length);let D=!1,a=0;if(n.length===0)return v(null,[]);n.forEach((R,M)=>{o(R,($,Y)=>{if($?(D=!0,m[M]=null,_[M]=$):(m[M]=Y,_[M]=null),++a===n.length)return v(D?_:null,m)})})}call(n,o,...v){try{n.apply(o,v)}catch(m){v[v.length-1](m)}}cmdTraversal(n,o,v,m){const _=n.folder.fsPath,D=I.isMacintosh;let a;const R=()=>a&&a.kill();u.add(R);let M=O=>{u.delete(R),M=()=>{},m(O)},$="";const Y=this.initDirectoryTree();let le;const q=w.spawnRipgrepCmd(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);a=q.cmd,le=!Object.keys(q.siblingClauses).length;const U=q.rgArgs.args.map(O=>O.match(/^-/)?O:`'${O}'`).join(" ");let z=`${q.rgDiskPath} ${U}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),v({message:z}),this.cmdResultCount=0,this.collectStdout(a,"utf8",v,(O,W,T)=>{if(O){M(O);return}if(this.isLimitHit){M();return}const N=($+(D?C.normalizeNFC(W||""):W)).split(`
`);if(T){const x=N.length;N[x-1]=N[x-1].trim(),N[x-1]||N.pop()}else $=N.pop()||"";if(N.length&&N[0].indexOf(`
`)!==-1){M(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=N.length,le){for(const x of N)if(this.matchFile(o,{base:_,relativePath:x,searchPath:this.getSearchPath(n,x)}),this.isLimitHit){R();break}(T||this.isLimitHit)&&M();return}this.addDirectoryEntries(n,Y,_,N,o),T&&(this.matchDirectoryTree(Y,_,o),M())})}spawnFindCmd(n){const o=this.folderExcludePatterns.get(n.folder.fsPath),v=o.getBasenameTerms(),m=o.getPathTerms(),_=["-L","."];if(v.length||m.length){_.push("-not","(","(");for(const D of v)_.push("-name",D),_.push("-o");for(const D of m)_.push("-path",D),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),p.spawn("find",_,{cwd:n.folder.fsPath})}readStdout(n,o,v){let m="";this.collectStdout(n,o,()=>{},(_,D,a)=>{if(_){v(_);return}m+=D,a&&v(null,m)})}collectStdout(n,o,v,m){let _=(R,M,$)=>{(R||$)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),m(R,M,$)},D=!1;n.stdout?(this.forwardData(n.stdout,o,_),n.stdout.once("data",()=>D=!0)):v({message:"stdout is null"});let a;n.stderr?a=this.collectData(n.stderr):v({message:"stderr is null"}),n.on("error",R=>{_(R)}),n.on("close",R=>{let M;!D&&(M=this.decodeData(a,o))&&i(M)?_(new Error(`command failed with error code ${R}: ${this.decodeData(a,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(n,o,v){const m=new y.StringDecoder(o);return n.on("data",_=>{v(null,m.write(_))}),m}collectData(n){const o=[];return n.on("data",v=>{o.push(v)}),o}decodeData(n,o){const v=new y.StringDecoder(o);return n.map(m=>v.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:o},v,m,_){m.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:v,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const D=a=>{const R=k.basename(a),M=k.dirname(a);let $=o[M];$||($=o[M]=[],D(M)),$.push({base:v,relativePath:a,basename:R,searchPath:this.getSearchPath(n,a)})};m.forEach(D)}matchDirectoryTree({rootEntries:n,pathToEntries:o},v,m){const _=this,D=this.folderExcludePatterns.get(v),a=this.filePattern;function R(M){_.directoriesWalked++;const $=S.hasSiblingFn(()=>M.map(Y=>Y.basename));for(let Y=0,le=M.length;Y<le;Y++){const q=M[Y],{relativePath:U,basename:z}=q;if(D.test(U,z,a!==z?$:void 0))continue;const O=o[U];if(O)R(O);else{if(_.filesWalked++,U===a)continue;_.matchFile(m,q)}if(_.isLimitHit)break}}R(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,o,v,m,_){const D=n.folder,a=S.hasSiblingFn(()=>v);this.parallel(v,(R,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const $=o?[o,R].join(k.sep):R;if(this.folderExcludePatterns.get(n.folder.fsPath).test($,R,this.config.filePattern!==R?a:void 0))return M(null);const Y=[D.fsPath,$].join(k.sep);L.lstat(Y,(le,q)=>{if(le||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(Y,q,(U,z)=>U||this.isCanceled||this.isLimitHit?M(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(Y,q,(O,W)=>O||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?M(null):(this.walkedPaths[W]=!0,f.Promises.readdir(Y).then(T=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(n,$,T,m,F=>M(F||null))},T=>{M(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&c.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(m,{base:D.fsPath,relativePath:$,searchPath:this.getSearchPath(n,$)}),M(null,void 0)))})},R=>{const M=R&&A.coalesce(R);return _(M&&M.length>0?M[0]:void 0)})}matchFile(n,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,k.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(o))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return E.isFilePatternMatch(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,o,v){return o.isSymbolicLink()?L.stat(n,v):v(null,o)}realPathIfNeeded(n,o,v){return o.isSymbolicLink()?L.realpath(n,(m,_)=>m?v(m):v(null,_)):v(null,n)}getSearchPath(n,o){return n.folderName?k.join(n.folderName,o):o}}e.FileWalker=d;class g{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new d(n)}search(n,o,v){this.walker.walk(this.folderQueries,this.extraFiles,n,o,(m,_)=>{v(m,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(n,o){this.expression=n,this.root=o,this.init(n)}init(n){let o,v;Object.keys(n).filter(m=>n[m]).forEach(m=>{k.isAbsolute(m)?(o=o||S.getEmptyExpression(),o[m]=n[m]):(v=v||S.getEmptyExpression(),v[m]=n[m])}),this.absoluteParsedExpr=o&&S.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=v&&S.parse(v,{trimForExclusions:!0})}test(n,o,v){return this.relativeParsedExpr&&this.relativeParsedExpr(n,o,v)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),o,v)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function i(s){const n=s.trim().split(`
`),o=n[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return h.uppercaseFirstLetter(n[n.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=i}),define(ge[130],pe([0,1,38,282,100,18,67,30,9,8,2,31,63,283,267,90]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(D){this.outputChannel=D}provideTextSearchResults(D,a,R,M){return this.outputChannel.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify(Object.assign(Object.assign({},a),{folder:a.folder.toString()}))}`),new Promise(($,Y)=>{M.onCancellationRequested(()=>F());const le=i(D,a),q=a.folder.fsPath,U=le.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${E} ${U}
 - cwd: ${q}`);let z=p.spawn(E,le,{cwd:q});z.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),Y(I.serializeSearchError(new I.SearchError(be&&be.message,I.SearchErrorCode.rgProcessError)))});let O=!1;const W=new d(a.maxResults,q,a.previewOptions);W.on("result",be=>{O=!0,x="",R.report(be)});let T=!1;const F=()=>{T=!0,z&&z.kill(),W&&W.cancel()};let N=!1;W.on("hitLimit",()=>{N=!0,F()});let x="";z.stdout.on("data",be=>{W.handleData(be),O||(x+=be)});let G=!1;z.stdout.once("data",()=>G=!0);let se="";z.stderr.on("data",be=>{const Ie=be.toString();this.outputChannel.appendLine(Ie),se+=Ie}),z.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(O?"Got result from parser":"No result from parser"),x&&this.outputChannel.appendLine(`Got data without result: ${x}`),this.outputChannel.appendLine(""),T)$({limitHit:N});else{W.flush(),z=null;let be;se&&!G&&(be=b(se))?Y(I.serializeSearchError(new I.SearchError(be.message,be.code))):$({limitHit:N})}})})}}e.RipgrepTextSearchEngine=w;function b(_){const D=_.split(`
`),a=D[0].trim();if(D.some(M=>M.startsWith("regex parse error")))return new I.SearchError(u(D),I.SearchErrorCode.regexParseError);const R=a.match(/grep config error: unknown encoding: (.*)/);if(R)return new I.SearchError(`Unknown encoding: ${R[1]}`,I.SearchErrorCode.unknownEncoding);if(a.startsWith("error parsing glob"))return new I.SearchError(a.charAt(0).toUpperCase()+a.substr(1),I.SearchErrorCode.globParseError);if(a.startsWith("the literal"))return new I.SearchError(a.charAt(0).toUpperCase()+a.substr(1),I.SearchErrorCode.invalidLiteral);if(a.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(a,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function u(_){const D=["Regex parse error"],a=_.filter(R=>R.startsWith("PCRE2:"));if(a.length>=1){const R=a[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const M=R.split(":")[1];D.push(":"+M)}}return D.join("")}e.buildRegexParseError=u;class d extends L.EventEmitter{constructor(D,a,R){super();this.maxResults=D,this.rootFolder=a,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(D,a){return super.on(D,a),this}handleData(D){if(this.isDone)return;const a=typeof D=="string"?D:this.stringDecoder.write(D);this.handleDecodedData(a)}handleDecodedData(D){let a=D.indexOf(`
`);const R=this.remainder+D;if(a>=0)a+=this.remainder.length;else{this.remainder=R;return}let M=0;for(;a>=0;)this.handleLine(R.substring(M,a).trim()),M=a+1,a=R.indexOf(`
`,M);this.remainder=R.substring(M)}handleLine(D){if(this.isDone||!D)return;let a;try{a=JSON.parse(D)}catch(R){throw new Error(`malformed line from rg: ${D}`)}if(a.type==="match"){const R=g(a.data.path),M=r.URI.file(S.join(this.rootFolder,R)),$=this.createTextSearchMatch(a.data,M);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(a.type==="context"){const R=g(a.data.path),M=r.URI.file(S.join(this.rootFolder,R));this.createTextSearchContext(a.data,M).forEach(Y=>this.onResult(Y))}}createTextSearchMatch(D,a){const R=D.line_number-1;let M=!1,$=g(D.lines);R===0&&C.startsWithUTF8BOM($)&&(M=!0,$=C.stripUTF8BOM($));const Y=Buffer.from($);let le=0,q=0,U=R;D.submatches.length===0&&D.submatches.push($.length?{start:0,end:1,match:{text:$[0]}}:{start:0,end:0,match:{text:""}});const z=y.coalesce(D.submatches.map((O,W)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let T=g(O.match);R===0&&W===0&&M&&(T=C.stripUTF8BOM(T),O.start=O.start<=3?0:O.start-3,O.end=O.end<=3?0:O.end-3);const F=Y.slice(le,O.start).toString().length,N=q+F,x=t(T),G=U,se=x.numLines+G,be=x.numLines>0?x.lastLineLength:x.lastLineLength+N;return le=O.end,q=be,U=se,new l.Range(G,N,se,be)}));return f.createTextSearchResult(a,$,z,this.previewOptions)}createTextSearchContext(D,a){const R=g(D.lines),M=D.line_number;return R.replace(/\r?\n$/,"").split(`
`).map(($,Y)=>({text:$,uri:a,lineNumber:M+Y}))}onResult(D){this.emit("result",D)}}e.RipgrepParser=d;function g(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const D=/\n/g;let a=0,R=-1,M;for(;M=D.exec(_);)a++,R=M.index;const $=R>=0?_.length-R-1:_.length;return{numLines:a,lastLineLength:$}}function i(_,D){const a=["--hidden"];a.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:M}=A.groupBy(D.includes,Y=>Y.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const Y=new Set;M.forEach(le=>{Y.add(le)}),a.push("-g","!*"),Y.forEach(le=>{s(le).map(f.anchorGlob).forEach(q=>{a.push("-g",q)})})}R&&R.length&&R.forEach(Y=>{a.push("-g",Y)}),D.excludes.map(f.anchorGlob).forEach(Y=>a.push("-g",`!${Y}`)),D.maxFileSize&&a.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?a.push("--no-ignore-parent"):a.push("--no-ignore"),D.followSymlinks&&a.push("--follow"),D.encoding&&D.encoding!=="utf8"&&a.push("--encoding",D.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=C.escapeRegExpCharacters(_.pattern),_.isRegExp=!0),D.usePCRE2&&a.push("--pcre2"),a.push("--crlf"),_.isRegExp&&(_.pattern=n(_.pattern),a.push("--auto-hybrid-regex"));let $;if(_.isWordMatch){const le=C.createRegExp(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");a.push("--regexp",le)}else if(_.isRegExp){let Y=v(_.pattern);Y=m(Y),a.push("--regexp",Y)}else $=_.pattern,a.push("--fixed-strings");return a.push("--no-config"),D.useGlobalIgnoreFiles||a.push("--no-ignore-global"),a.push("--json"),_.isMultiline&&a.push("--multiline"),D.beforeContext&&a.push("--before-context",D.beforeContext+""),D.afterContext&&a.push("--after-context",D.afterContext+""),a.push("--"),$&&a.push($),a.push("."),a}function s(_){const D=P.splitGlobAware(_,"/");return D.map((a,R)=>D.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function n(_){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(D);)_=_.replace(D,"$1\\x{$2}");const a=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(a);)_=_.replace(a,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=n;const o=_=>_.type==="Assertion"&&_.kind==="lookbehind";function v(_){let D;try{D=new h.RegExpParser().parsePattern(_)}catch(le){return _}let a="",R=0;const M=(le,q,U)=>{a+=_.slice(R,le)+U,R=q},$=[];return new h.RegExpVisitor({onCharacterEnter(le){if(le.raw!=="\\n")return;const q=$[0];if(!q)M(le.start,le.end,"\\r?\\n");else if(!$.some(o))if(q.type==="CharacterClass")if(q.negate){const U=_.slice(q.start+2,le.start)+_.slice(le.end,q.end-1);M(q.start,q.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=_.slice(q.start+1,le.start)+_.slice(le.end,q.end-1);M(q.start,q.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else q.type==="Quantifier"&&M(le.start,le.end,"(?:\\r?\\n)")},onQuantifierEnter(le){$.unshift(le)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(le){$.unshift(le)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(le){$.unshift(le)},onCharacterClassLeave(){$.shift()},onAssertionEnter(le){o(le)&&$.push(le)},onAssertionLeave(le){$[0]===le&&$.shift()}}).visit(D),a+=_.slice(R),a}e.fixRegexNewline=v;function m(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(ge[269],pe([0,1,21,130,115,10]),function(X,e,p,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,r,I,l){const h=new L.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===y.Schemas.userData){const c=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:y.Schemas.file})}),f=new k.Progress(E=>I.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:r.folder.scheme})})));return this.withToken(l,E=>h.provideTextSearchResults(C,c,f,E))}else return this.withToken(l,c=>h.provideTextSearchResults(C,r,I,c))}async withToken(C,r){const I=P(C);this.inProgress.add(I);const l=await r(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=A;function P(S){const C=new p.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(ge[270],pe([0,1,28,130,129]),function(X,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(S){this.query=S}search(S,C,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(h){r({message:h})}},l=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),p);return new Promise((h,c)=>l.search(f=>{C(f.map(A))},S).then(f=>h({limitHit:f.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=y;function A(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,C)=>{if(C.ranges){const r=C;return S+(Array.isArray(r.ranges)?r.ranges.length:1)}else return S+1},0)}}}),define(ge[271],pe([0,1,55,284,18,16,14,3,97,9,43,2,42,31,268,270]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(p);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const s=u(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=y.createCancelablePromise(o=>this.doFileSearchWithEngine(c.Engine,s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}textSearch(t){let i;const s=u(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=y.createCancelablePromise(o=>this.ripgrepTextSearch(s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}ripgrepTextSearch(t,i,s){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new f.TextSearchEngineAdapter(t).search(s,i,i)}doFileSearch(t,i,s){return this.doFileSearchWithEngine(c.Engine,t,i,s)}doFileSearchWithEngine(t,i,s,n,o=E.BATCH_SIZE){let v=0;const m=D=>{Array.isArray(D)?(v+=D.length,s(D.map(a=>this.rawMatchToSearchItem(a)))):D.relativePath?(v++,s(this.rawMatchToSearchItem(D))):s(D)};if(i.sortByScore){let D=this.trySortedSearchFromCache(i,m,n);if(!D){const a=i.maxResults?Object.assign({},i,{maxResults:null}):i,R=new t(a);D=this.doSortedSearch(R,i,s,m,n)}return new Promise((a,R)=>{D.then(([M,$])=>{const Y=$.map(le=>this.rawMatchToSearchItem(le));this.sendProgress(Y,s,o),a(M)},R)})}const _=new t(i);return this.doSearch(_,m,o,n).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:"searchProcess",fromCache:!1,resultCount:v,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?C.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,s,n,o){const v=new P.Emitter;let m=y.createCancelablePromise(D=>{let a=[];const R=M=>{Array.isArray(M)?a=M:(n(M),v.fire(M))};return this.doSearch(t,R,-1,D).then(M=>[M,a])}),_;if(i.cacheKey){_=this.getOrCreateCache(i.cacheKey);const D={promise:m,event:v.event,resolved:!1};_.resultsToSearchCache[i.filePattern||""]=D,m.then(()=>{D.resolved=!0},a=>{delete _.resultsToSearchCache[i.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([D,a])=>{const R=_?_.scorerCache:Object.create(null),M=(typeof i.maxResults!="number"||i.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(i,a,R,o).then($=>{const Y=M?M.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:Y,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:$.length},messages:D.messages,limitHit:D.limitHit||typeof i.maxResults=="number"&&a.length>i.maxResults},$]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new w)}trySortedSearchFromCache(t,i,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const o=this.getResultsFromCache(n,t.filePattern||"",i,s);if(o)return o.then(([v,m,_])=>{const D=r.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,s).then(a=>{const R=D.elapsed(),M={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:m.length,sortingTime:R};return[{type:"success",limitHit:v.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:M},a]})})}sortResults(t,i,s,n){const o=S.prepareQuery(t.filePattern||""),v=(_,D)=>S.compareItemsByFuzzyScore(_,D,o,!0,b,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(i,v,m,1e4,n)}sendProgress(t,i,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)i(t.slice(n,n+s));else i(t)}getResultsFromCache(t,i,s,n){const o=r.StopWatch.create(!1),v=i.indexOf(C.sep)>=0;let m;for(const R in t.resultsToSearchCache)if(i.startsWith(R)){if(v&&R.indexOf(C.sep)<0&&R!=="")continue;const M=t.resultsToSearchCache[R];m={promise:this.preventCancellation(M.promise),event:M.event,resolved:M.resolved};break}if(!m)return null;const _=o.elapsed(),D=r.StopWatch.create(!1),a=m.event(s);return n&&n.onCancellationRequested(()=>{a.dispose()}),m.promise.then(([R,M])=>{if(n&&n.isCancellationRequested)throw A.canceled();const $=[],Y=S.prepareQuery(i).normalizedLowercase;for(const le of M)!h.isFilePatternMatch(le,Y)||$.push(le);return[R,$,{cacheWasResolved:m.resolved,cacheLookupTime:_,cacheFilterTime:D.elapsed(),cacheEntryCount:M.length}]})}doSearch(t,i,s,n){return new Promise((o,v)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(s?(m.push(_),s>0&&m.length>=s&&(i(m),m=[])):i(_))},_=>{i(_)},(_,D)=>{m.length&&i(m),_?v(_):o(D)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,s){return t.then(i,s)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return C.basename(g.relativePath)}getItemDescription(g){return C.dirname(g.relativePath)}getItemPath(g){return g.relativePath}};function u(g){return Object.assign(Object.assign({},g),{folderQueries:g.folderQueries&&g.folderQueries.map(d),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>I.URI.revive(t))})}function d(g){return Object.assign(Object.assign({},g),{folder:I.URI.revive(g.folder)})}}),define(ge[272],pe([0,1,6,2,28,12,31,271,269,90,13,59,27,66,10,129]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends h.ExtHostSearch{constructor(b,u,d,g){super(b,d,g);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new S.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new S.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(c.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(b,u){const d=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(b)),p.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(b,u,d,g){const t=h.reviveQuery(d);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,u,t,g):super.$provideFileSearchResults(b,u,d,g)}doInternalFileSearch(b,u,d,g){const t=i=>{if(A.isSerializedFileMatch(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(b,u,i.map(s=>L.URI.file(s.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,t,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,u){return new f.NativeTextSearchManager(b,u)}};E=je([$e(0,r.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,I.IURITransformerService),$e(3,y.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[131],pe([0,1,285,121,286,3,103,9,101,32,6,22,104,14,11]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(m){this.socket=m,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;h.onUnexpectedError(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const _=D=>m(I.VSBuffer.wrap(D));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(m){const _=D=>{m({type:0,hadError:D,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,_=>{if(_){if(_.code==="EPIPE")return;h.onUnexpectedError(_)}})}catch(_){if(_.code==="EPIPE")return;h.onUnexpectedError(_)}}end(){this.socket.end()}drain(){return new Promise((m,_)=>{if(this.socket.bufferSize===0){m();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),m()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=f;var E;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(w||(w={}));class b extends r.Disposable{constructor(m,_,D,a){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=a,_?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),h.onUnexpectedError(R),this._onClose.fire({type:0,hadError:!0,error:R})}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),h.onUnexpectedError(R),this._onClose.fire({type:0,hadError:!0,error:R})}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(I.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,_){let D=2;m.byteLength<126?D+=0:m.byteLength<2**16?D+=2:D+=8;const a=I.VSBuffer.alloc(D);if(_?a.writeUInt8(194,0):a.writeUInt8(130,0),m.byteLength<126)a.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){a.writeUInt8(126,1);let R=1;a.writeUInt8(m.byteLength>>>8&255,++R),a.writeUInt8(m.byteLength>>>0&255,++R)}else{a.writeUInt8(127,1);let R=1;a.writeUInt8(0,++R),a.writeUInt8(0,++R),a.writeUInt8(0,++R),a.writeUInt8(0,++R),a.writeUInt8(m.byteLength>>>24&255,++R),a.writeUInt8(m.byteLength>>>16&255,++R),a.writeUInt8(m.byteLength>>>8&255,++R),a.writeUInt8(m.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=a.byteLength+m.byteLength,this.socket.write(I.VSBuffer.concat([a,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),a=(_.readUInt8(0)&128)>>>7,R=_.readUInt8(1),M=(R&128)>>>7,$=R&127;this._state.state=2,this._state.readLen=2+(M?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=a,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),D=_.readUInt8(1),a=(D&128)>>>7;let R=D&127,M=1;R===126?R=_.readUInt8(++M)*2**8+_.readUInt8(++M):R===127&&(R=_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*0+_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M));let $=0;a&&($=_.readUInt8(++M)*2**24+_.readUInt8(++M)*2**16+_.readUInt8(++M)*2**8+_.readUInt8(++M)),this._state.state=3,this._state.readLen=R,this._state.mask=$}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);u(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(I.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function u(v,m){if(m===0)return;let _=v.byteLength>>>2;for(let Y=0;Y<_;Y++){const le=v.readUInt32BE(Y*4);v.writeUInt32BE(le^m,Y*4)}let D=_*4,a=v.byteLength-D;const R=m>>>24&255,M=m>>>16&255,$=m>>>8&255;a>=1&&v.writeUInt8(v.readUInt8(D)^R,D),a>=2&&v.writeUInt8(v.readUInt8(D+1)^M,D+1),a>=3&&v.writeUInt8(v.readUInt8(D+2)^$,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function g(){const v=C.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let m;return e.XDG_RUNTIME_DIR?m=P.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):m=P.join(S.tmpdir(),`vscode-ipc-${v}.sock`),i(m),m}e.createRandomIPCHandle=g;function t(v,m,_){const D=p.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${_}-${m}-sock`;let a;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a=P.join(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${_}-${m}.sock`):a=P.join(v,`${_}-${m}.sock`),i(a),a}e.createStaticIPCHandle=t;function i(v){const m=d[c.platform];typeof m=="number"&&v.length>=m&&console.warn(`WARNING: IPC handle "${v}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends A.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const _=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(_,D=>({protocol:new l.Protocol(new f(D)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(v){return new Promise((m,_)=>{const D=L.createServer();D.on("error",_),D.listen(v,()=>{D.removeListener("error",_),m(new s(D))})})}e.serve=n;function o(v,m){return new Promise((_,D)=>{const a=L.createConnection(v,()=>{a.removeListener("error",D),_(l.Client.fromSocket(new f(a),m))});a.once("error",D)})}e.connect=o}),define(ge[273],pe([0,1,131,265,55,48,2,190,12]),function(X,e,p,L,k,y,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(l,h,c){this._commands=l,this.logService=h,this._ipcHandlePath=c,this._server=L.createServer((f,E)=>this.onRequest(f,E)),this.setup().catch(f=>(h.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,h){const c=[];l.setEncoding("utf8"),l.on("data",f=>c.push(f)),l.on("end",()=>{const f=JSON.parse(c.join(""));switch(f.type){case"open":this.open(f,h);break;case"openExternal":this.openExternal(f,h);break;case"status":this.getStatus(f,h);break;case"extensionManagement":this.manageExtensions(f,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${f.type}`,E=>{E&&this.logService.error(E)}),h.end();break}})}open(l,h){let{fileURIs:c,folderURIs:f,forceNewWindow:E,diffMode:w,addMode:b,forceReuseWindow:u,gotoLineMode:d,waitMarkerFilePath:g}=l;const t=[];if(Array.isArray(f))for(const i of f)try{t.push({folderUri:A.URI.parse(i)})}catch(s){}if(Array.isArray(c))for(const i of c)try{P.hasWorkspaceFileExtension(i)?t.push({workspaceUri:A.URI.parse(i)}):t.push({fileUri:A.URI.parse(i)})}catch(s){}if(t.length){const i=g?A.URI.file(g):void 0,n={forceNewWindow:E,diffMode:w,addMode:b,gotoLineMode:d,forceReuseWindow:u,preferNewWindow:!u&&!i&&!b,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}h.writeHead(200),h.end()}async openExternal(l,h){for(const c of l.uris){const f=A.URI.parse(c),E=f.scheme==="file"?f:c;await this._commands.executeCommand("_remoteCLI.openExternal",E)}h.writeHead(200),h.end()}async manageExtensions(l,h){try{const c=w=>w==null?void 0:w.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),f={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",f);h.writeHead(200),h.write(E)}catch(c){h.writeHead(500),h.write(String(c),f=>{f&&this.logService.error(f)})}h.end()}async getStatus(l,h){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");h.writeHead(200),h.write(c),h.end()}catch(c){h.writeHead(500),h.write(String(c),f=>{f&&this.logService.error(f)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let r=class extends C{constructor(l,h){super(l,h,p.createRandomIPCHandle())}};r=je([$e(0,y.IExtHostCommands),$e(1,S.ILogService)],r),e.CLIServer=r}),define(ge[274],pe([0,1,65,261,256,5,264,40,246,2,10,7,273,102]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends k.RequireInterceptor{_installInterceptor(){const w=this,b=X.__$__nodeRequire("module"),u=b._load;b._load=function(g,t,i){for(let s of w._alternatives){let n=s(g);if(n){g=n;break}}return w._factories.has(g)?w._factories.get(g).load(g,C.URI.file(h.realpathSync(t.filename)),s=>u.apply(this,[s,t,i])):u.apply(this,arguments)}}}class f extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),p.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const d=process.send,g=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?d.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,u){if(b.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let d=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&p.mark(`code/extHost/willLoadExtensionCode/${w.value}`),d=X.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{w&&p.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const u=w[b];u===null?delete process.env[b]:process.env[b]=u}}}e.ExtHostExtensionService=f}),define(ge[275],pe([0,1,77,247,248,258,257,272,274,216,249,49,40,61,66,64,33,47,12]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f,E,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(l.IExtHostExtensionService,S.ExtHostExtensionService),p.registerSingleton(b.ILogService,C.ExtHostLogService),p.registerSingleton(I.IExtHostDebugService,A.ExtHostDebugService),p.registerSingleton(h.IExtHostOutputService,L.ExtHostOutputService2),p.registerSingleton(c.IExtHostSearch,P.NativeExtHostSearch),p.registerSingleton(f.IExtHostTask,y.ExtHostTask),p.registerSingleton(E.IExtHostTerminalService,k.ExtHostTerminalService),p.registerSingleton(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(ge[276],pe([0,1,121,287,65,14,104,131,184,214,259,22,99,28,102,16,262,275]),function(X,e,p,L,k,y,A,P,S,C,r,I,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const E=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=X.__$__nodeRequire("module"),n=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function b(s){process.exit=function(n){if(s)w(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let u=function(s){w()};function d(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let o=null,v=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,_=3e5,D=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),m),a=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),_);process.on("message",(M,$)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){const Y=I.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let le;if(M.skipWebSocketFrames)le=new P.NodeSocket($);else{const q=I.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));le=new P.WebSocketNodeSocket(new P.NodeSocket($),M.permessageDeflate,q,!1)}o?(D.cancel(),a.cancel(),o.beginAcceptReconnection(le,Y),o.endAcceptReconnection()):(clearTimeout(v),o=new A.PersistentProtocol(le,Y),o.onDidDispose(()=>u("renderer disconnected")),s(o),o.onSocketClose(()=>{D.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(a.isScheduled())return;D.isScheduled()&&a.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const v=p.createConnection(s,()=>{v.removeListener("error",o),n(new A.PersistentProtocol(new P.NodeSocket(v)))});v.once("error",o),v.on("close",()=>{u("renderer closed the socket")})})}}async function g(){const s=await d();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{C.isMessageOfType(n,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}drain(){return s.drain()}}}function t(s){return new Promise(n=>{const o=s.onMessage(v=>{o.dispose();const m=JSON.parse(v.toString()),_=m.commit,D=S.default.commit;_&&D&&_!==D&&w(55);const a=[];process.on("unhandledRejection",($,Y)=>{a.push(Y),setTimeout(()=>{const le=a.indexOf(Y);le>=0&&Y.catch(q=>{a.splice(le,1),y.isPromiseCanceledError(q)||(console.warn(`rejected promise not handled within 1 second: ${q}`),q&&q.stack&&console.warn(`stack trace: ${q.stack}`),y.onUnexpectedError($))})},1e3)}),process.on("rejectionHandled",$=>{const Y=a.indexOf($);Y>=0&&a.splice(Y,1)}),process.on("uncaughtException",function($){y.onUnexpectedError($)});let R=0;setInterval(function(){try{process.kill(m.parentPid,0),R=0}catch($){$&&$.code==="EPERM"?(R++,R>=3&&u(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):u(`parent process ${m.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let M;try{M=X.__$__nodeRequire("native-watchdog"),M.start(m.parentPid)}catch($){y.onUnexpectedError($)}s.send(C.createMessageOfType(0)),n({protocol:s,initData:m})});s.send(C.createMessageOfType(1))})}async function i(){k.mark("code/extHost/willConnectToRenderer");const s=await g();k.mark("code/extHost/didConnectToRenderer");const n=await t(s);k.mark("code/extHost/didWaitForInitData");const{initData:o}=n;b(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const v=new class{exit(a){w(a)}exists(a){return h.Promises.exists(a)}realpath(a){return c.realpath(a)}};let m=null;if(o.remote.authority&&E.uriTransformerPath)try{const a=X.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);m=new l.URITransformer(a)}catch(D){console.error(D)}const _=new r.ExtensionHostMain(n.protocol,o,v,m);u=D=>_.terminate(D)}e.startExtensionHostProcess=i}),define(ge[288],pe([0,1,276]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.startExtensionHostProcess().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b79d23d3568db6c926c5ac428457c31f4dfc1c00/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
